
:- import dcg/2 from dcg.
:- import append/3 from basics.
:- import str_sub/3, string_substitute/4, str_cat/3,
	  term_to_codes/2, codes_to_term/2 from string.

:- auto_table.


:- debug_ctl(hide, [name/3,
		    name_list/3,
%		    setL/3,
		    scan_file/1,
		    write_mls_rules/1,
		    write_mls_rule/3
		   ]).

'C'(X,Y,Z) :- word(Y,X,Z).



model_init_sid_contexts(InFile) :-
	parse_filename(InFile, _DirName, FileName, _Ext),
%	str_cat(FileName, '.P', OutFile), 
	str_cat(FileName, '.P', OutFileName), 
	str_cat('model/', OutFileName, OutFile), 
	nl, write('Modeling initial sid contexts after '),
	write(InFile), writeln(' ...'),
	cputime(B),
	tell(OutFile),
	scan_file(InFile),
	sid_contexts(0,_F),
	nl,
	told,
	cputime(E),
	T is E-B,
	write('Done in '), write(T), write(' sec. ... Output file: '),
	write(OutFile), writeln('.'), nl.



%
% definition rules
%
sid_contexts --> sid_context
  	       | sid_contexts, sid_context.



sid_context --> [sid],name(SID),name(User),[':'],name(Role),[':'],name(Type),
		{write(init_sid_context(SID, (User,Role,Type))),writeln('.')}.