sensitivity(unclassified,u).
sensitivity(confidential,c).
sensitivity(secret,s).
sensitivity(top_secret,ts).
dominance([u,c,s,ts]).
category(nocon,[]).
category(noforn,[]).
category(nato,[]).
category(usuk,[]).
level(u,[]).
level(c,[]).
level(s,[nocon,noforn]).
level(ts,[nocon,noforn,nato,usuk]).
perm_map(common,file,read,read).
perm_map(common,file,write,write).
perm_map(common,file,create,write).
perm_map(common,file,getattr,read).
perm_map(common,file,setattr,write).
perm_map(common,file,relabelfrom,read).
perm_map(common,file,relabelfrom,write).
perm_map(common,file,relabelto,write).
perm_map(common,file,append,write).
perm_map(common,file,unlink,write).
perm_map(common,file,link,write).
perm_map(common,file,rename,write).
perm_map(common,file,execute,read).
perm_map(common,file,swapon,read).
perm_map(common,file,swapon,write).
perm_map(common,file,quotaon,read).
perm_map(common,file,quotaon,write).
perm_map(common,file,mounton,read).
perm_map(common,file,mounton,write).
perm_map(common,socket,read,read).
perm_map(common,socket,write,write).
perm_map(common,socket,create,write).
perm_map(common,socket,getattr,read).
perm_map(common,socket,setattr,write).
perm_map(common,socket,relabelfrom,read).
perm_map(common,socket,relabelfrom,write).
perm_map(common,socket,relabelto,write).
perm_map(common,socket,append,write).
perm_map(common,socket,bind,write).
perm_map(common,socket,connect,write).
perm_map(common,socket,listen,read).
perm_map(common,socket,accept,read).
perm_map(common,socket,getopt,read).
perm_map(common,socket,setopt,write).
perm_map(common,socket,shutdown,write).
perm_map(common,socket,recvfrom,read).
perm_map(common,socket,sendto,write).
perm_map(common,socket,recv_msg,read).
perm_map(common,socket,send_msg,write).
perm_map(common,ipc,create,write).
perm_map(common,ipc,destroy,write).
perm_map(common,ipc,getattr,read).
perm_map(common,ipc,setattr,write).
perm_map(common,ipc,read,read).
perm_map(common,ipc,write,write).
perm_map(common,ipc,unix_read,read).
perm_map(common,ipc,unix_write,write).
perm_map(class,filesystem,mount,write).
perm_map(class,filesystem,remount,write).
perm_map(class,filesystem,unmount,write).
perm_map(class,filesystem,getattr,read).
perm_map(class,filesystem,relabelfrom,read).
perm_map(class,filesystem,relabelfrom,write).
perm_map(class,filesystem,relabelto,write).
perm_map(class,filesystem,transition,write).
perm_map(class,filesystem,quotamod,write).
perm_map(class,filesystem,quotaget,read).
perm_map(class,dir,add_name,write).
perm_map(class,dir,remove_name,write).
perm_map(class,dir,reparent,write).
perm_map(class,dir,search,read).
perm_map(class,dir,rmdir,read).
perm_map(class,dir,rmdir,write).
perm_map(class,file,execute_no_trans,read).
perm_map(class,file,entrypoint,read).
perm_map(class,fd,use,read).
perm_map(class,fd,use,write).
perm_map(class,tcp_socket,connectto,write).
perm_map(class,tcp_socket,newconn,write).
perm_map(class,tcp_socket,acceptfrom,read).
perm_map(class,node,tcp_recv,read).
perm_map(class,node,tcp_send,write).
perm_map(class,node,udp_recv,read).
perm_map(class,node,udp_send,write).
perm_map(class,node,rawip_recv,read).
perm_map(class,node,rawip_send,write).
perm_map(class,netif,tcp_recv,read).
perm_map(class,netif,tcp_send,write).
perm_map(class,netif,udp_recv,read).
perm_map(class,netif,udp_send,write).
perm_map(class,netif,rawip_recv,read).
perm_map(class,netif,rawip_send,write).
perm_map(class,unix_stream_socket,connectto,write).
perm_map(class,unix_stream_socket,newconn,write).
perm_map(class,unix_stream_socket,acceptfrom,read).
perm_map(class,process,transition,write).
perm_map(class,process,sigchld,write).
perm_map(class,process,sigkill,write).
perm_map(class,process,sigstop,write).
perm_map(class,process,signal,write).
perm_map(class,process,ptrace,read).
perm_map(class,process,ptrace,write).
perm_map(class,process,getsched,read).
perm_map(class,process,setsched,write).
perm_map(class,process,getsession,read).
perm_map(class,process,getpgid,read).
perm_map(class,process,setpgid,write).
perm_map(class,process,getcap,read).
perm_map(class,process,setcap,write).
perm_map(class,process,share,read).
perm_map(class,process,share,write).
perm_map(class,msgq,enqueue,write).
perm_map(class,msg,send,write).
perm_map(class,msg,receive,read).
perm_map(class,shm,lock,write).

security_class(security).
security_class(process).
security_class(system).
security_class(capability).
security_class(filesystem).
security_class(file).
security_class(dir).
security_class(fd).
security_class(lnk_file).
security_class(chr_file).
security_class(blk_file).
security_class(sock_file).
security_class(fifo_file).
security_class(socket).
security_class(tcp_socket).
security_class(udp_socket).
security_class(rawip_socket).
security_class(node).
security_class(netif).
security_class(netlink_socket).
security_class(packet_socket).
security_class(key_socket).
security_class(unix_stream_socket).
security_class(unix_dgram_socket).
security_class(sem).
security_class(msg).
security_class(msgq).
security_class(shm).
security_class(ipc).
security_class(passwd).
initial_sid(kernel).
initial_sid(security).
initial_sid(unlabeled).
initial_sid(fs).
initial_sid(file).
initial_sid(file_labels).
initial_sid(init).
initial_sid(any_socket).
initial_sid(port).
initial_sid(netif).
initial_sid(netmsg).
initial_sid(node).
initial_sid(igmp_packet).
initial_sid(icmp_socket).
initial_sid(tcp_socket).
initial_sid(sysctl_modprobe).
initial_sid(sysctl).
initial_sid(sysctl_fs).
initial_sid(sysctl_kernel).
initial_sid(sysctl_net).
initial_sid(sysctl_net_unix).
initial_sid(sysctl_vm).
initial_sid(sysctl_dev).
initial_sid(kmod).
initial_sid(policy).
initial_sid(scmp_packet).
access(common,file,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,unlink,link,rename,execute,swapon,quotaon,mounton]).
access(common,socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind]).
access(common,ipc,[create,destroy,getattr,setattr,read,write,associate,unix_read,unix_write]).
access(class,filesystem,[mount,remount,unmount,getattr,relabelfrom,relabelto,transition,associate,quotamod,quotaget]).
inherits(dir,file).
access(class,dir,[add_name,remove_name,reparent,search,rmdir]).
inherits(file,file).
access(class,file,[execute_no_trans,entrypoint]).
inherits(lnk_file,file).
inherits(chr_file,file).
inherits(blk_file,file).
inherits(sock_file,file).
inherits(fifo_file,file).
access(class,fd,[use]).
inherits(socket,socket).
inherits(tcp_socket,socket).
access(class,tcp_socket,[connectto,newconn,acceptfrom]).
inherits(udp_socket,socket).
inherits(rawip_socket,socket).
access(class,node,[tcp_recv,tcp_send,udp_recv,udp_send,rawip_recv,rawip_send,enforce_dest]).
access(class,netif,[tcp_recv,tcp_send,udp_recv,udp_send,rawip_recv,rawip_send]).
inherits(netlink_socket,socket).
inherits(packet_socket,socket).
inherits(key_socket,socket).
inherits(unix_stream_socket,socket).
access(class,unix_stream_socket,[connectto,newconn,acceptfrom]).
inherits(unix_dgram_socket,socket).
access(class,process,[fork,transition,sigchld,sigkill,sigstop,signull,signal,ptrace,getsched,setsched,getsession,getpgid,setpgid,getcap,setcap,share,getattr,setexec,setfscreate,noatsecure]).
inherits(ipc,ipc).
inherits(sem,ipc).
inherits(msgq,ipc).
access(class,msgq,[enqueue]).
access(class,msg,[send,receive]).
inherits(shm,ipc).
access(class,shm,[lock]).
access(class,security,[compute_av,compute_create,compute_member,check_context,load_policy,compute_relabel,compute_user,setenforce]).
access(class,system,[ipc_info,syslog_read,syslog_mod,syslog_console]).
access(class,capability,[chown,dac_override,dac_read_search,fowner,fsetid,kill,setgid,setuid,setpcap,linux_immutable,net_bind_service,net_broadcast,net_admin,net_raw,ipc_lock,ipc_owner,sys_module,sys_rawio,sys_chroot,sys_ptrace,sys_pacct,sys_admin,sys_boot,sys_nice,sys_resource,sys_time,sys_tty_config,mknod,lease]).
access(class,passwd,[passwd,chfn,chsh]).
attr(mlstrustedreader).
attr(mlstrustedwriter).
attr(mlstrustedobject).
attr(domain).
attr(privuser).
attr(privrole).
attr(privowner).
attr(privlog).
attr(privmem).
attr(privfd).
attr(privhome).
attr(auth).
attr(admin).
attr(userdomain).
attr(userpty_type).
attr(user_crond_domain).
attr(unpriv_userdomain).
attr(user_home_dir_type).
attr(gphdomain).
attr(file_type).
attr(sysadmfile).
attr(fs_type).
attr(root_dir_type).
attr(exec_type).
attr(tmpfile).
attr(user_tmpfile).
attr(xserver_tmpfile).
attr(tmpfsfile).
attr(home_type).
attr(home_dir_type).
attr(ttyfile).
attr(ptyfile).
attr(pidfile).
attr(socket_type).
attr(port_type).
attr(netif_type).
attr(netmsg_type).
attr(node_type).
attr(logfile).
attr(lockfile).
attr(login_contexts).
attr(user_mail_domain).
attr(privmail).
attr(user_home_type).
attr(mta_user_agent).
attr(mta_delivery_agent).
attr(web_client_domain).
attr(mail_server_domain).
type_decl(device_t,[],[file_type]).
type_decl(null_device_t,[],[file_type,mlstrustedobject]).
type_decl(zero_device_t,[],[file_type,mlstrustedobject]).
type_decl(console_device_t,[],[file_type]).
type_decl(memory_device_t,[],[file_type]).
type_decl(random_device_t,[],[file_type]).
type_decl(devtty_t,[],[file_type,mlstrustedobject]).
type_decl(tty_device_t,[],[file_type]).
type_decl(fixed_disk_device_t,[],[file_type]).
type_decl(removable_device_t,[],[file_type]).
type_decl(clock_device_t,[],[file_type]).
type_decl(tun_tap_device_t,[],[file_type]).
type_decl(misc_device_t,[],[file_type]).
type_decl(psaux_t,[],[file_type]).
type_decl(mouse_device_t,[],[file_type]).
type_decl(agp_device_t,[],[file_type]).
type_decl(dri_device_t,[],[file_type]).
type_decl(sound_device_t,[],[file_type]).
type_decl(ppp_device_t,[],[file_type]).
type_decl(framebuf_device_t,[],[file_type]).
type_decl(devfs_control_t,[],[file_type]).
type_decl(mtrr_device_t,[],[file_type]).
type_decl(apm_bios_t,[],[file_type]).
type_decl(v4l_device_t,[],[file_type]).
type_decl(ptmx_t,[],[file_type,sysadmfile]).
type_decl(devpts_t,[],[fs_type,root_dir_type]).
type_decl(unlabeled_t,[],[fs_type,file_type,root_dir_type,sysadmfile]).
type_decl(fs_t,[],[fs_type]).
type_decl(file_t,[],[file_type,root_dir_type,sysadmfile]).
type_decl(root_t,[],[file_type,sysadmfile]).
type_decl(home_root_t,[],[file_type,sysadmfile]).
type_decl(lost_found_t,[],[file_type,sysadmfile]).
type_decl(boot_t,[],[file_type,root_dir_type,sysadmfile]).
type_decl(system_map_t,[],[file_type,sysadmfile]).
type_decl(boot_runtime_t,[],[file_type,sysadmfile]).
type_decl(tmp_t,[],[file_type,sysadmfile,tmpfile]).
type_decl(etc_t,[],[file_type,sysadmfile]).
type_decl(shadow_t,[],[file_type]).
access_vector(allow,auth,shadow_t,file,getattr).
access_vector(allow,auth,shadow_t,file,read).
type_decl(ld_so_cache_t,[],[file_type,sysadmfile]).
type_decl(etc_runtime_t,[],[file_type,sysadmfile]).
type_decl(etc_aliases_t,[],[file_type,sysadmfile]).
type_decl(etc_mail_t,[],[file_type,sysadmfile]).
type_decl(resolv_conf_t,[],[file_type,sysadmfile]).
type_decl(lib_t,[],[file_type,sysadmfile]).
type_decl(shlib_t,[],[file_type,sysadmfile]).
type_decl(ld_so_t,[],[file_type,sysadmfile]).
type_decl(bin_t,[],[file_type,sysadmfile]).
type_decl(ls_exec_t,[],[file_type,exec_type,sysadmfile]).
type_decl(shell_exec_t,[],[file_type,exec_type,sysadmfile]).
type_decl(sbin_t,[],[file_type,sysadmfile]).
type_decl(usr_t,[],[file_type,root_dir_type,sysadmfile]).
type_decl(src_t,[],[file_type,sysadmfile]).
type_decl(var_t,[],[file_type,root_dir_type,sysadmfile]).
type_decl(var_run_t,[],[file_type,sysadmfile]).
type_decl(var_log_t,[],[file_type,sysadmfile,logfile]).
type_decl(faillog_t,[],[file_type,sysadmfile,logfile]).
type_decl(var_lock_t,[],[file_type,sysadmfile,lockfile]).
type_decl(var_lib_t,[],[file_type,sysadmfile]).
type_decl(tetex_data_t,[],[file_type,sysadmfile,tmpfile]).
type_decl(var_spool_t,[],[file_type,sysadmfile]).
type_decl(var_yp_t,[],[file_type,sysadmfile]).
type_decl(var_log_sa_t,[],[file_type,sysadmfile,logfile]).
type_decl(var_log_ksyms_t,[],[file_type,sysadmfile,logfile]).
type_decl(lastlog_t,[],[file_type,sysadmfile,logfile]).
type_decl(var_lib_nfs_t,[],[file_type,sysadmfile]).
type_decl(wtmp_t,[],[file_type,sysadmfile,logfile]).
type_decl(catman_t,[],[file_type,sysadmfile,tmpfile]).
type_decl(at_spool_t,[],[file_type,sysadmfile]).
type_decl(cron_spool_t,[],[file_type,sysadmfile]).
type_decl(print_spool_t,[],[file_type,sysadmfile]).
type_decl(mail_spool_t,[],[file_type,sysadmfile]).
type_decl(mqueue_spool_t,[],[file_type,sysadmfile]).
type_decl(man_t,[],[file_type,sysadmfile]).
type_decl(readable_t,[],[file_type,sysadmfile]).
type_decl(test_file_t,[],[file_type,sysadmfile]).
type_decl(poly_t,[],[file_type,sysadmfile]).
type_decl(swapfile_t,[],[file_type,sysadmfile]).
type_decl(locale_t,[],[file_type]).
access_vector(allow,file_type,fs_t,filesystem,associate).
access_vector(allow,devpts_t,devpts_t,filesystem,associate).
type_decl(tmpfs_t,[],[file_type,sysadmfile,fs_type,root_dir_type]).
access_vector(allow,tmpfs_t,tmpfs_t,filesystem,associate).
access_vector(allow,tmp_t,tmpfs_t,filesystem,associate).
type_decl(usbdevfs_t,[],[fs_type,root_dir_type,sysadmfile]).
access_vector(allow,usbdevfs_t,usbdevfs_t,filesystem,associate).
type_decl(usbdevfs_device_t,[],[file_type,sysadmfile]).
access_vector(allow,usbdevfs_device_t,usbdevfs_t,filesystem,associate).
type_decl(sysfs_t,driverfs_t,[fs_type,root_dir_type,sysadmfile]).
access_vector(allow,sysfs_t,sysfs_t,filesystem,associate).
type_decl(iso9660_t,[],[fs_type,root_dir_type,sysadmfile]).
access_vector(allow,iso9660_t,iso9660_t,filesystem,associate).
type_decl(dosfs_t,[],[fs_type,root_dir_type,sysadmfile]).
access_vector(allow,dosfs_t,dosfs_t,filesystem,associate).
type_decl(any_socket_t,[],[socket_type]).
role_decl(system_r,any_socket_t).
type_decl(igmp_packet_t,[],[]).
role_decl(system_r,igmp_packet_t).
type_decl(icmp_socket_t,[],[socket_type]).
role_decl(system_r,icmp_socket_t).
type_decl(tcp_socket_t,[],[socket_type]).
role_decl(system_r,tcp_socket_t).
type_decl(scmp_packet_t,[],[]).
role_decl(system_r,scmp_packet_t).
type_decl(port_t,[],[port_type]).
type_decl(netif_t,[],[netif_type]).
type_decl(netif_eth0_t,[],[netif_type]).
type_decl(netif_eth1_t,[],[netif_type]).
type_decl(netif_eth2_t,[],[netif_type]).
type_decl(netif_lo_t,[],[netif_type]).
type_decl(netif_ippp0_t,[],[netif_type]).
type_decl(netif_ipsec0_t,[],[netif_type]).
type_decl(netif_ipsec1_t,[],[netif_type]).
type_decl(netif_ipsec2_t,[],[netif_type]).
type_decl(netmsg_t,[],[netmsg_type]).
type_decl(netmsg_eth0_t,[],[netmsg_type]).
type_decl(netmsg_eth1_t,[],[netmsg_type]).
type_decl(netmsg_eth2_t,[],[netmsg_type]).
type_decl(netmsg_lo_t,[],[netmsg_type]).
type_decl(netmsg_ippp0_t,[],[netmsg_type]).
type_decl(netmsg_ipsec0_t,[],[netmsg_type]).
type_decl(netmsg_ipsec1_t,[],[netmsg_type]).
type_decl(netmsg_ipsec2_t,[],[netmsg_type]).
type_decl(node_t,[],[node_type]).
type_decl(node_lo_t,[],[node_type]).
type_decl(node_internal_t,[],[node_type]).
access_vector(allow,igmp_packet_t,netif_type,netif,rawip_send).
access_vector(allow,igmp_packet_t,netif_type,netif,rawip_recv).
access_vector(allow,igmp_packet_t,node_type,node,rawip_send).
access_vector(allow,igmp_packet_t,node_type,node,rawip_recv).
access_vector(allow,icmp_socket_t,netif_type,netif,rawip_send).
access_vector(allow,icmp_socket_t,netif_type,netif,rawip_recv).
access_vector(allow,icmp_socket_t,node_type,node,rawip_send).
access_vector(allow,icmp_socket_t,node_type,node,rawip_recv).
access_vector(allow,icmp_socket_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,tcp_socket_t,netif_type,netif,tcp_send).
access_vector(allow,tcp_socket_t,netif_type,netif,tcp_recv).
access_vector(allow,tcp_socket_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,tcp_socket_t,node_type,node,tcp_send).
access_vector(allow,tcp_socket_t,node_type,node,tcp_recv).
access_vector(allow,netmsg_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_t,node_t,node,udp_recv).
access_vector(allow,netmsg_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_eth0_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_eth0_t,node_t,node,udp_recv).
access_vector(allow,netmsg_eth0_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_eth0_t,netif_eth0_t,netif,tcp_recv).
access_vector(allow,netmsg_eth0_t,netif_eth0_t,netif,udp_recv).
access_vector(allow,netmsg_eth0_t,netif_eth0_t,netif,rawip_recv).
access_vector(allow,netmsg_eth1_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_eth1_t,node_t,node,udp_recv).
access_vector(allow,netmsg_eth1_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_eth1_t,netif_eth1_t,netif,tcp_recv).
access_vector(allow,netmsg_eth1_t,netif_eth1_t,netif,udp_recv).
access_vector(allow,netmsg_eth1_t,netif_eth1_t,netif,rawip_recv).
access_vector(allow,netmsg_eth2_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_eth2_t,node_t,node,udp_recv).
access_vector(allow,netmsg_eth2_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_eth2_t,netif_eth2_t,netif,tcp_recv).
access_vector(allow,netmsg_eth2_t,netif_eth2_t,netif,udp_recv).
access_vector(allow,netmsg_eth2_t,netif_eth2_t,netif,rawip_recv).
access_vector(allow,netmsg_lo_t,node_lo_t,node,tcp_recv).
access_vector(allow,netmsg_lo_t,node_lo_t,node,udp_recv).
access_vector(allow,netmsg_lo_t,node_lo_t,node,rawip_recv).
access_vector(allow,netmsg_lo_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_lo_t,node_t,node,udp_recv).
access_vector(allow,netmsg_lo_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_lo_t,netif_lo_t,netif,tcp_recv).
access_vector(allow,netmsg_lo_t,netif_lo_t,netif,udp_recv).
access_vector(allow,netmsg_lo_t,netif_lo_t,netif,rawip_recv).
access_vector(allow,netmsg_ippp0_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_ippp0_t,node_t,node,udp_recv).
access_vector(allow,netmsg_ippp0_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_ippp0_t,netif_ippp0_t,netif,tcp_recv).
access_vector(allow,netmsg_ippp0_t,netif_ippp0_t,netif,udp_recv).
access_vector(allow,netmsg_ippp0_t,netif_ippp0_t,netif,rawip_recv).
access_vector(allow,netmsg_ipsec0_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_ipsec0_t,node_t,node,udp_recv).
access_vector(allow,netmsg_ipsec0_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_ipsec0_t,netif_ipsec0_t,node,tcp_recv).
access_vector(allow,netmsg_ipsec0_t,netif_ipsec0_t,node,udp_recv).
access_vector(allow,netmsg_ipsec0_t,netif_ipsec0_t,node,rawip_recv).
access_vector(allow,netmsg_ipsec1_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_ipsec1_t,node_t,node,udp_recv).
access_vector(allow,netmsg_ipsec1_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_ipsec1_t,netif_ipsec1_t,netif,tcp_recv).
access_vector(allow,netmsg_ipsec1_t,netif_ipsec1_t,netif,udp_recv).
access_vector(allow,netmsg_ipsec1_t,netif_ipsec1_t,netif,rawip_recv).
access_vector(allow,netmsg_ipsec2_t,node_t,node,tcp_recv).
access_vector(allow,netmsg_ipsec2_t,node_t,node,udp_recv).
access_vector(allow,netmsg_ipsec2_t,node_t,node,rawip_recv).
access_vector(allow,netmsg_ipsec2_t,netif_ipsec2_t,netif,tcp_recv).
access_vector(allow,netmsg_ipsec2_t,netif_ipsec2_t,netif,udp_recv).
access_vector(allow,netmsg_ipsec2_t,netif_ipsec2_t,netif,rawip_recv).
type_decl(nfs_t,[],[fs_type,root_dir_type]).
access_vector(allow,nfs_t,nfs_t,filesystem,associate).
type_decl(proc_t,[],[fs_type,root_dir_type]).
type_decl(proc_kmsg_t,[],[]).
type_decl(proc_kcore_t,[],[]).
type_decl(sysctl_t,[],[]).
type_decl(sysctl_fs_t,[],[]).
type_decl(sysctl_kernel_t,[],[]).
type_decl(sysctl_modprobe_t,[],[]).
type_decl(sysctl_net_t,[],[]).
type_decl(sysctl_net_unix_t,[],[]).
type_decl(sysctl_vm_t,[],[]).
type_decl(sysctl_dev_t,[],[]).
type_decl(security_t,[],[fs_type]).
type_decl(policy_config_t,[],[file_type]).
type_decl(policy_src_t,[],[file_type]).
type_decl(default_context_t,[],[file_type,sysadmfile,login_contexts]).
type_decl(file_labels_t,[],[file_type,sysadmfile]).
type_decl(no_access_t,[],[file_type,sysadmfile]).
type_decl(sysadm_t,[],[domain,privlog,privowner,admin,userdomain,web_client_domain,privhome]).
access_vector(allow,privhome,home_root_t,dir,search).
role_decl(system_r,sysadm_t).
role_decl(sysadm_r,sysadm_t).
access_vector(allow,sysadm_t,proc_t,dir,read).
access_vector(allow,sysadm_t,proc_t,dir,getattr).
access_vector(allow,sysadm_t,proc_t,dir,lock).
access_vector(allow,sysadm_t,proc_t,dir,search).
access_vector(allow,sysadm_t,proc_t,dir,ioctl).
access_vector(allow,sysadm_t,proc_t,file,read).
access_vector(allow,sysadm_t,proc_t,file,getattr).
access_vector(allow,sysadm_t,proc_t,file,lock).
access_vector(allow,sysadm_t,proc_t,file,ioctl).
access_vector(allow,sysadm_t,proc_t,lnk_file,read).
access_vector(allow,sysadm_t,proc_t,lnk_file,getattr).
access_vector(allow,sysadm_t,proc_t,lnk_file,lock).
access_vector(allow,sysadm_t,proc_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,proc_t,sock_file,read).
access_vector(allow,sysadm_t,proc_t,sock_file,getattr).
access_vector(allow,sysadm_t,proc_t,sock_file,lock).
access_vector(allow,sysadm_t,proc_t,sock_file,ioctl).
access_vector(allow,sysadm_t,proc_t,fifo_file,read).
access_vector(allow,sysadm_t,proc_t,fifo_file,getattr).
access_vector(allow,sysadm_t,proc_t,fifo_file,lock).
access_vector(allow,sysadm_t,proc_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,proc_kmsg_t,file,getattr).
access_vector(allow,sysadm_t,proc_kcore_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,read).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,lock).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_t,file,read).
access_vector(allow,sysadm_t,sysctl_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_t,file,lock).
access_vector(allow,sysadm_t,sysctl_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_t,dir,read).
access_vector(allow,sysadm_t,sysctl_t,dir,getattr).
access_vector(allow,sysadm_t,sysctl_t,dir,lock).
access_vector(allow,sysadm_t,sysctl_t,dir,search).
access_vector(allow,sysadm_t,sysctl_t,dir,ioctl).
access_vector(allow,sysadm_t,sysctl_fs_t,file,read).
access_vector(allow,sysadm_t,sysctl_fs_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_fs_t,file,lock).
access_vector(allow,sysadm_t,sysctl_fs_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_fs_t,dir,read).
access_vector(allow,sysadm_t,sysctl_fs_t,dir,getattr).
access_vector(allow,sysadm_t,sysctl_fs_t,dir,lock).
access_vector(allow,sysadm_t,sysctl_fs_t,dir,search).
access_vector(allow,sysadm_t,sysctl_fs_t,dir,ioctl).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,read).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,lock).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_kernel_t,dir,read).
access_vector(allow,sysadm_t,sysctl_kernel_t,dir,getattr).
access_vector(allow,sysadm_t,sysctl_kernel_t,dir,lock).
access_vector(allow,sysadm_t,sysctl_kernel_t,dir,search).
access_vector(allow,sysadm_t,sysctl_kernel_t,dir,ioctl).
access_vector(allow,sysadm_t,sysctl_net_t,file,read).
access_vector(allow,sysadm_t,sysctl_net_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_net_t,file,lock).
access_vector(allow,sysadm_t,sysctl_net_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_net_t,dir,read).
access_vector(allow,sysadm_t,sysctl_net_t,dir,getattr).
access_vector(allow,sysadm_t,sysctl_net_t,dir,lock).
access_vector(allow,sysadm_t,sysctl_net_t,dir,search).
access_vector(allow,sysadm_t,sysctl_net_t,dir,ioctl).
access_vector(allow,sysadm_t,sysctl_vm_t,file,read).
access_vector(allow,sysadm_t,sysctl_vm_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_vm_t,file,lock).
access_vector(allow,sysadm_t,sysctl_vm_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_vm_t,dir,read).
access_vector(allow,sysadm_t,sysctl_vm_t,dir,getattr).
access_vector(allow,sysadm_t,sysctl_vm_t,dir,lock).
access_vector(allow,sysadm_t,sysctl_vm_t,dir,search).
access_vector(allow,sysadm_t,sysctl_vm_t,dir,ioctl).
access_vector(allow,sysadm_t,sysctl_dev_t,file,read).
access_vector(allow,sysadm_t,sysctl_dev_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_dev_t,file,lock).
access_vector(allow,sysadm_t,sysctl_dev_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_dev_t,dir,read).
access_vector(allow,sysadm_t,sysctl_dev_t,dir,getattr).
access_vector(allow,sysadm_t,sysctl_dev_t,dir,lock).
access_vector(allow,sysadm_t,sysctl_dev_t,dir,search).
access_vector(allow,sysadm_t,sysctl_dev_t,dir,ioctl).
access_vector(allow,sysadm_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,sysadm_t,self,dir,read).
access_vector(allow,sysadm_t,self,dir,getattr).
access_vector(allow,sysadm_t,self,dir,lock).
access_vector(allow,sysadm_t,self,dir,search).
access_vector(allow,sysadm_t,self,dir,ioctl).
access_vector(allow,sysadm_t,self,file,read).
access_vector(allow,sysadm_t,self,file,getattr).
access_vector(allow,sysadm_t,self,file,lock).
access_vector(allow,sysadm_t,self,file,ioctl).
access_vector(allow,sysadm_t,self,lnk_file,read).
access_vector(allow,sysadm_t,self,lnk_file,getattr).
access_vector(allow,sysadm_t,self,lnk_file,lock).
access_vector(allow,sysadm_t,self,lnk_file,ioctl).
access_vector(allow,sysadm_t,self,sock_file,read).
access_vector(allow,sysadm_t,self,sock_file,getattr).
access_vector(allow,sysadm_t,self,sock_file,lock).
access_vector(allow,sysadm_t,self,sock_file,ioctl).
access_vector(allow,sysadm_t,self,fifo_file,read).
access_vector(allow,sysadm_t,self,fifo_file,getattr).
access_vector(allow,sysadm_t,self,fifo_file,lock).
access_vector(allow,sysadm_t,self,fifo_file,ioctl).
access_vector(allow,sysadm_t,self,fd,_).
access_vector(allow,sysadm_t,self,fifo_file,ioctl).
access_vector(allow,sysadm_t,self,fifo_file,read).
access_vector(allow,sysadm_t,self,fifo_file,getattr).
access_vector(allow,sysadm_t,self,fifo_file,lock).
access_vector(allow,sysadm_t,self,fifo_file,write).
access_vector(allow,sysadm_t,self,fifo_file,append).
access_vector(allow,sysadm_t,self,unix_dgram_socket,create).
access_vector(allow,sysadm_t,self,unix_dgram_socket,ioctl).
access_vector(allow,sysadm_t,self,unix_dgram_socket,read).
access_vector(allow,sysadm_t,self,unix_dgram_socket,getattr).
access_vector(allow,sysadm_t,self,unix_dgram_socket,write).
access_vector(allow,sysadm_t,self,unix_dgram_socket,setattr).
access_vector(allow,sysadm_t,self,unix_dgram_socket,append).
access_vector(allow,sysadm_t,self,unix_dgram_socket,bind).
access_vector(allow,sysadm_t,self,unix_dgram_socket,connect).
access_vector(allow,sysadm_t,self,unix_dgram_socket,getopt).
access_vector(allow,sysadm_t,self,unix_dgram_socket,setopt).
access_vector(allow,sysadm_t,self,unix_dgram_socket,shutdown).
access_vector(allow,sysadm_t,self,unix_stream_socket,create).
access_vector(allow,sysadm_t,self,unix_stream_socket,ioctl).
access_vector(allow,sysadm_t,self,unix_stream_socket,read).
access_vector(allow,sysadm_t,self,unix_stream_socket,getattr).
access_vector(allow,sysadm_t,self,unix_stream_socket,write).
access_vector(allow,sysadm_t,self,unix_stream_socket,setattr).
access_vector(allow,sysadm_t,self,unix_stream_socket,append).
access_vector(allow,sysadm_t,self,unix_stream_socket,bind).
access_vector(allow,sysadm_t,self,unix_stream_socket,connect).
access_vector(allow,sysadm_t,self,unix_stream_socket,getopt).
access_vector(allow,sysadm_t,self,unix_stream_socket,setopt).
access_vector(allow,sysadm_t,self,unix_stream_socket,shutdown).
access_vector(allow,sysadm_t,self,unix_stream_socket,listen).
access_vector(allow,sysadm_t,self,unix_stream_socket,accept).
access_vector(allow,sysadm_t,self,unix_dgram_socket,sendto).
access_vector(allow,sysadm_t,self,unix_stream_socket,connectto).
access_vector(allow,sysadm_t,self,sem,associate).
access_vector(allow,sysadm_t,self,sem,getattr).
access_vector(allow,sysadm_t,self,sem,setattr).
access_vector(allow,sysadm_t,self,sem,create).
access_vector(allow,sysadm_t,self,sem,destroy).
access_vector(allow,sysadm_t,self,sem,read).
access_vector(allow,sysadm_t,self,sem,write).
access_vector(allow,sysadm_t,self,sem,unix_read).
access_vector(allow,sysadm_t,self,sem,unix_write).
access_vector(allow,sysadm_t,self,msg,send).
access_vector(allow,sysadm_t,self,msg,receive).
access_vector(allow,sysadm_t,self,msgq,associate).
access_vector(allow,sysadm_t,self,msgq,getattr).
access_vector(allow,sysadm_t,self,msgq,setattr).
access_vector(allow,sysadm_t,self,msgq,create).
access_vector(allow,sysadm_t,self,msgq,destroy).
access_vector(allow,sysadm_t,self,msgq,read).
access_vector(allow,sysadm_t,self,msgq,write).
access_vector(allow,sysadm_t,self,msgq,enqueue).
access_vector(allow,sysadm_t,self,msgq,unix_read).
access_vector(allow,sysadm_t,self,msgq,unix_write).
access_vector(allow,sysadm_t,self,shm,associate).
access_vector(allow,sysadm_t,self,shm,getattr).
access_vector(allow,sysadm_t,self,shm,setattr).
access_vector(allow,sysadm_t,self,shm,create).
access_vector(allow,sysadm_t,self,shm,destroy).
access_vector(allow,sysadm_t,self,shm,read).
access_vector(allow,sysadm_t,self,shm,write).
access_vector(allow,sysadm_t,self,shm,lock).
access_vector(allow,sysadm_t,self,shm,unix_read).
access_vector(allow,sysadm_t,self,shm,unix_write).
access_vector(allow,sysadm_t,self,capability,setgid).
access_vector(allow,sysadm_t,self,capability,chown).
access_vector(allow,sysadm_t,self,capability,fowner).
access_vector(dontaudit,sysadm_t,self,capability,sys_nice).
access_vector(dontaudit,sysadm_t,self,capability,fsetid).
type_decl(sysadm_home_dir_t,[],[file_type,sysadmfile,home_dir_type,home_type]).
type_decl(sysadm_home_t,[],[file_type,sysadmfile,home_type]).
type_decl(sysadm_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,sysadm_t,tmp_t,dir,read).
access_vector(allow,sysadm_t,tmp_t,dir,getattr).
access_vector(allow,sysadm_t,tmp_t,dir,lock).
access_vector(allow,sysadm_t,tmp_t,dir,search).
access_vector(allow,sysadm_t,tmp_t,dir,ioctl).
access_vector(allow,sysadm_t,tmp_t,dir,add_name).
access_vector(allow,sysadm_t,tmp_t,dir,remove_name).
access_vector(allow,sysadm_t,tmp_t,dir,write).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,create).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,read).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,getattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,lock).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,write).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,setattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,append).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,link).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,unlink).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,rename).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,create).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,read).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,getattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,lock).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,write).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,setattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,append).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,link).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,unlink).
access_vector(allow,sysadm_t,sysadm_tmp_t,lnk_file,rename).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,create).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,read).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,getattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,lock).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,write).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,setattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,append).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,link).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,unlink).
access_vector(allow,sysadm_t,sysadm_tmp_t,sock_file,rename).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,create).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,read).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,getattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,lock).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,write).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,setattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,append).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,link).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,unlink).
access_vector(allow,sysadm_t,sysadm_tmp_t,fifo_file,rename).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,create).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,read).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,getattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,lock).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,setattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,link).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,unlink).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,rename).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,search).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,add_name).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,remove_name).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,reparent).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,write).
access_vector(allow,sysadm_t,sysadm_tmp_t,dir,rmdir).
type_trans(sysadm_t,tmp_t,dir,sysadm_tmp_t).
type_trans(sysadm_t,tmp_t,[file,lnk_file,sock_file,fifo_file],sysadm_tmp_t).
access_vector(allow,sysadm_t,sysadm_home_dir_t,dir,read).
access_vector(allow,sysadm_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,sysadm_t,sysadm_home_dir_t,dir,lock).
access_vector(allow,sysadm_t,sysadm_home_dir_t,dir,search).
access_vector(allow,sysadm_t,sysadm_home_dir_t,dir,ioctl).
access_vector(allow,sysadm_t,sysadm_home_dir_t,dir,add_name).
access_vector(allow,sysadm_t,sysadm_home_dir_t,dir,remove_name).
access_vector(allow,sysadm_t,sysadm_home_dir_t,dir,write).
access_vector(allow,sysadm_t,sysadm_home_t,file,create).
access_vector(allow,sysadm_t,sysadm_home_t,file,ioctl).
access_vector(allow,sysadm_t,sysadm_home_t,file,read).
access_vector(allow,sysadm_t,sysadm_home_t,file,getattr).
access_vector(allow,sysadm_t,sysadm_home_t,file,lock).
access_vector(allow,sysadm_t,sysadm_home_t,file,write).
access_vector(allow,sysadm_t,sysadm_home_t,file,setattr).
access_vector(allow,sysadm_t,sysadm_home_t,file,append).
access_vector(allow,sysadm_t,sysadm_home_t,file,link).
access_vector(allow,sysadm_t,sysadm_home_t,file,unlink).
access_vector(allow,sysadm_t,sysadm_home_t,file,rename).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,create).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,read).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,getattr).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,lock).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,write).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,setattr).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,append).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,link).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,unlink).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,rename).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,create).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,ioctl).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,read).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,getattr).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,lock).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,write).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,setattr).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,append).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,link).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,unlink).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,rename).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,create).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,read).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,getattr).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,lock).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,write).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,setattr).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,append).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,link).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,unlink).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,rename).
access_vector(allow,sysadm_t,sysadm_home_t,dir,create).
access_vector(allow,sysadm_t,sysadm_home_t,dir,read).
access_vector(allow,sysadm_t,sysadm_home_t,dir,getattr).
access_vector(allow,sysadm_t,sysadm_home_t,dir,lock).
access_vector(allow,sysadm_t,sysadm_home_t,dir,setattr).
access_vector(allow,sysadm_t,sysadm_home_t,dir,link).
access_vector(allow,sysadm_t,sysadm_home_t,dir,unlink).
access_vector(allow,sysadm_t,sysadm_home_t,dir,rename).
access_vector(allow,sysadm_t,sysadm_home_t,dir,search).
access_vector(allow,sysadm_t,sysadm_home_t,dir,add_name).
access_vector(allow,sysadm_t,sysadm_home_t,dir,remove_name).
access_vector(allow,sysadm_t,sysadm_home_t,dir,reparent).
access_vector(allow,sysadm_t,sysadm_home_t,dir,write).
access_vector(allow,sysadm_t,sysadm_home_t,dir,rmdir).
type_trans(sysadm_t,sysadm_home_dir_t,dir,sysadm_home_t).
type_trans(sysadm_t,sysadm_home_dir_t,[file,lnk_file,sock_file,fifo_file],sysadm_home_t).
access_vector(allow,sysadm_t,sysadm_home_t,dir,relabelfrom).
access_vector(allow,sysadm_t,sysadm_home_t,dir,relabelto).
access_vector(allow,sysadm_t,sysadm_home_t,file,relabelfrom).
access_vector(allow,sysadm_t,sysadm_home_t,file,relabelto).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,relabelfrom).
access_vector(allow,sysadm_t,sysadm_home_t,lnk_file,relabelto).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,relabelfrom).
access_vector(allow,sysadm_t,sysadm_home_t,sock_file,relabelto).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,relabelfrom).
access_vector(allow,sysadm_t,sysadm_home_t,fifo_file,relabelto).
access_vector(allow,sysadm_t,sysadm_home_t,chr_file,relabelfrom).
access_vector(allow,sysadm_t,sysadm_home_t,chr_file,relabelto).
access_vector(allow,sysadm_t,sysadm_home_t,blk_file,relabelfrom).
access_vector(allow,sysadm_t,sysadm_home_t,blk_file,relabelto).
access_vector(allow,sysadm_t,sysadm_tmp_t,unix_stream_socket,name_bind).
type_decl(sysadm_tty_device_t,[],[file_type,sysadmfile,ttyfile]).
access_vector(allow,sysadm_t,privfd,fd,use).
access_vector(allow,sysadm_t,sysadm_tty_device_t,chr_file,setattr).
access_vector(allow,sysadm_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,sysadm_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,sysadm_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,sysadm_t,sysadm_tty_device_t,chr_file,append).
type_change(sysadm_t,tty_device_t,chr_file,sysadm_tty_device_t).
type_change(sysadm_t,ttyfile,chr_file,sysadm_tty_device_t).
access_vector(allow,sysadm_t,var_lib_t,dir,read).
access_vector(allow,sysadm_t,var_lib_t,dir,getattr).
access_vector(allow,sysadm_t,var_lib_t,dir,lock).
access_vector(allow,sysadm_t,var_lib_t,dir,search).
access_vector(allow,sysadm_t,var_lib_t,dir,ioctl).
access_vector(allow,sysadm_t,etc_dpkg_t,dir,read).
access_vector(allow,sysadm_t,etc_dpkg_t,dir,getattr).
access_vector(allow,sysadm_t,etc_dpkg_t,dir,lock).
access_vector(allow,sysadm_t,etc_dpkg_t,dir,search).
access_vector(allow,sysadm_t,etc_dpkg_t,dir,ioctl).
access_vector(allow,sysadm_t,etc_dpkg_t,file,read).
access_vector(allow,sysadm_t,etc_dpkg_t,file,getattr).
access_vector(allow,sysadm_t,etc_dpkg_t,file,lock).
access_vector(allow,sysadm_t,etc_dpkg_t,file,ioctl).
access_vector(allow,sysadm_t,etc_dpkg_t,lnk_file,read).
access_vector(allow,sysadm_t,etc_dpkg_t,lnk_file,getattr).
access_vector(allow,sysadm_t,etc_dpkg_t,lnk_file,lock).
access_vector(allow,sysadm_t,etc_dpkg_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,locale_t,dir,read).
access_vector(allow,sysadm_t,locale_t,dir,getattr).
access_vector(allow,sysadm_t,locale_t,dir,lock).
access_vector(allow,sysadm_t,locale_t,dir,search).
access_vector(allow,sysadm_t,locale_t,dir,ioctl).
access_vector(allow,sysadm_t,locale_t,file,read).
access_vector(allow,sysadm_t,locale_t,file,getattr).
access_vector(allow,sysadm_t,locale_t,file,lock).
access_vector(allow,sysadm_t,locale_t,file,ioctl).
access_vector(allow,sysadm_t,locale_t,lnk_file,read).
access_vector(allow,sysadm_t,locale_t,lnk_file,getattr).
access_vector(allow,sysadm_t,locale_t,lnk_file,lock).
access_vector(allow,sysadm_t,locale_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,tetex_data_t,dir,read).
access_vector(allow,sysadm_t,tetex_data_t,dir,getattr).
access_vector(allow,sysadm_t,tetex_data_t,dir,lock).
access_vector(allow,sysadm_t,tetex_data_t,dir,search).
access_vector(allow,sysadm_t,tetex_data_t,dir,ioctl).
access_vector(allow,sysadm_t,tetex_data_t,file,read).
access_vector(allow,sysadm_t,tetex_data_t,file,getattr).
access_vector(allow,sysadm_t,tetex_data_t,file,lock).
access_vector(allow,sysadm_t,tetex_data_t,file,ioctl).
access_vector(allow,sysadm_t,tetex_data_t,lnk_file,read).
access_vector(allow,sysadm_t,tetex_data_t,lnk_file,getattr).
access_vector(allow,sysadm_t,tetex_data_t,lnk_file,lock).
access_vector(allow,sysadm_t,tetex_data_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,tetex_data_t,file,read).
access_vector(allow,sysadm_t,tetex_data_t,file,getattr).
access_vector(allow,sysadm_t,tetex_data_t,file,lock).
access_vector(allow,sysadm_t,tetex_data_t,file,execute).
access_vector(allow,sysadm_t,tetex_data_t,file,ioctl).
access_vector(allow,sysadm_t,tetex_data_t,file,execute_no_trans).
access_vector(allow,sysadm_t,ptmx_t,chr_file,ioctl).
access_vector(allow,sysadm_t,ptmx_t,chr_file,read).
access_vector(allow,sysadm_t,ptmx_t,chr_file,getattr).
access_vector(allow,sysadm_t,ptmx_t,chr_file,lock).
access_vector(allow,sysadm_t,ptmx_t,chr_file,write).
access_vector(allow,sysadm_t,ptmx_t,chr_file,append).
access_vector(allow,sysadm_t,devpts_t,filesystem,getattr).
access_vector(allow,sysadm_t,devpts_t,dir,getattr).
access_vector(allow,sysadm_t,devpts_t,dir,read).
access_vector(allow,sysadm_t,devpts_t,dir,search).
type_decl(sysadm_devpts_t,[],[file_type,sysadmfile,ptyfile]).
access_vector(allow,sysadm_devpts_t,devpts_t,filesystem,associate).
type_trans(sysadm_t,devpts_t,chr_file,sysadm_devpts_t).
access_vector(allow,sysadm_t,sysadm_devpts_t,chr_file,setattr).
access_vector(allow,sysadm_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,sysadm_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,sysadm_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,sysadm_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,sysadm_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,sysadm_t,sysadm_devpts_t,chr_file,append).
type_change(sysadm_t,sshd_devpts_t,chr_file,sysadm_devpts_t).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,connectto).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,recvfrom).
access_vector(allow,sshd_t,sysadm_t,tcp_socket,acceptfrom).
access_vector(allow,sshd_t,sysadm_t,tcp_socket,recvfrom).
access_vector(allow,sshd_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(allow,sysadm_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(allow,sysadm_t,sysadm_ssh_t,tcp_socket,connectto).
access_vector(allow,sysadm_t,sysadm_ssh_t,tcp_socket,recvfrom).
access_vector(allow,sysadm_ssh_t,sysadm_t,tcp_socket,acceptfrom).
access_vector(allow,sysadm_ssh_t,sysadm_t,tcp_socket,recvfrom).
access_vector(allow,sysadm_ssh_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(allow,sysadm_t,sshd_t,fd,use).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,ioctl).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,read).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,getattr).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,write).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,setattr).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,append).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,bind).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,connect).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,getopt).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,setopt).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,shutdown).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,listen).
access_vector(allow,sysadm_t,sshd_t,tcp_socket,accept).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,ioctl).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,read).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,getattr).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,write).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,setattr).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,append).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,bind).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,connect).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,getopt).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,setopt).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,shutdown).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,listen).
access_vector(allow,sysadm_t,sshd_t,unix_stream_socket,accept).
access_vector(allow,sysadm_t,boot_t,dir,getattr).
access_vector(allow,sysadm_t,boot_t,dir,search).
access_vector(dontaudit,sysadm_t,boot_t,dir,read).
access_vector(dontaudit,sysadm_t,boot_t,lnk_file,getattr).
access_vector(dontaudit,sysadm_t,boot_t,file,getattr).
access_vector(dontaudit,sysadm_t,boot_t,file,read).
access_vector(allow,sysadm_t,system_map_t,file,getattr).
access_vector(allow,sysadm_t,system_map_t,file,read).
type_decl(sysadm_tmpfs_t,[],[file_type,sysadmfile,tmpfsfile]).
access_vector(allow,sysadm_t,tmpfs_t,dir,read).
access_vector(allow,sysadm_t,tmpfs_t,dir,getattr).
access_vector(allow,sysadm_t,tmpfs_t,dir,lock).
access_vector(allow,sysadm_t,tmpfs_t,dir,search).
access_vector(allow,sysadm_t,tmpfs_t,dir,ioctl).
access_vector(allow,sysadm_t,tmpfs_t,dir,add_name).
access_vector(allow,sysadm_t,tmpfs_t,dir,remove_name).
access_vector(allow,sysadm_t,tmpfs_t,dir,write).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,create).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,read).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,getattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,lock).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,write).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,setattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,append).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,link).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,unlink).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,file,rename).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,create).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,read).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,getattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,lock).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,write).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,setattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,append).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,link).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,unlink).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,lnk_file,rename).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,create).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,read).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,getattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,lock).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,write).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,setattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,append).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,link).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,unlink).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,sock_file,rename).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,create).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,read).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,getattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,lock).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,write).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,setattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,append).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,link).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,unlink).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,fifo_file,rename).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,create).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,read).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,getattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,lock).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,setattr).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,link).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,unlink).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,rename).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,search).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,add_name).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,remove_name).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,reparent).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,write).
access_vector(allow,sysadm_t,sysadm_tmpfs_t,dir,rmdir).
type_trans(sysadm_t,tmpfs_t,dir,sysadm_tmpfs_t).
type_trans(sysadm_t,tmpfs_t,[file,lnk_file,sock_file,fifo_file],sysadm_tmpfs_t).
access_vector(allow,sysadm_tmpfs_t,tmpfs_t,filesystem,associate).
access_vector(allow,sysadm_t,catman_t,dir,read).
access_vector(allow,sysadm_t,catman_t,dir,getattr).
access_vector(allow,sysadm_t,catman_t,dir,lock).
access_vector(allow,sysadm_t,catman_t,dir,search).
access_vector(allow,sysadm_t,catman_t,dir,ioctl).
access_vector(allow,sysadm_t,catman_t,dir,add_name).
access_vector(allow,sysadm_t,catman_t,dir,remove_name).
access_vector(allow,sysadm_t,catman_t,dir,write).
access_vector(allow,sysadm_t,catman_t,file,create).
access_vector(allow,sysadm_t,catman_t,file,ioctl).
access_vector(allow,sysadm_t,catman_t,file,read).
access_vector(allow,sysadm_t,catman_t,file,getattr).
access_vector(allow,sysadm_t,catman_t,file,lock).
access_vector(allow,sysadm_t,catman_t,file,write).
access_vector(allow,sysadm_t,catman_t,file,setattr).
access_vector(allow,sysadm_t,catman_t,file,append).
access_vector(allow,sysadm_t,catman_t,file,link).
access_vector(allow,sysadm_t,catman_t,file,unlink).
access_vector(allow,sysadm_t,catman_t,file,rename).
access_vector(allow,sysadm_t,catman_t,lnk_file,create).
access_vector(allow,sysadm_t,catman_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,catman_t,lnk_file,read).
access_vector(allow,sysadm_t,catman_t,lnk_file,getattr).
access_vector(allow,sysadm_t,catman_t,lnk_file,lock).
access_vector(allow,sysadm_t,catman_t,lnk_file,write).
access_vector(allow,sysadm_t,catman_t,lnk_file,setattr).
access_vector(allow,sysadm_t,catman_t,lnk_file,append).
access_vector(allow,sysadm_t,catman_t,lnk_file,link).
access_vector(allow,sysadm_t,catman_t,lnk_file,unlink).
access_vector(allow,sysadm_t,catman_t,lnk_file,rename).
access_vector(allow,sysadm_t,catman_t,sock_file,create).
access_vector(allow,sysadm_t,catman_t,sock_file,ioctl).
access_vector(allow,sysadm_t,catman_t,sock_file,read).
access_vector(allow,sysadm_t,catman_t,sock_file,getattr).
access_vector(allow,sysadm_t,catman_t,sock_file,lock).
access_vector(allow,sysadm_t,catman_t,sock_file,write).
access_vector(allow,sysadm_t,catman_t,sock_file,setattr).
access_vector(allow,sysadm_t,catman_t,sock_file,append).
access_vector(allow,sysadm_t,catman_t,sock_file,link).
access_vector(allow,sysadm_t,catman_t,sock_file,unlink).
access_vector(allow,sysadm_t,catman_t,sock_file,rename).
access_vector(allow,sysadm_t,catman_t,fifo_file,create).
access_vector(allow,sysadm_t,catman_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,catman_t,fifo_file,read).
access_vector(allow,sysadm_t,catman_t,fifo_file,getattr).
access_vector(allow,sysadm_t,catman_t,fifo_file,lock).
access_vector(allow,sysadm_t,catman_t,fifo_file,write).
access_vector(allow,sysadm_t,catman_t,fifo_file,setattr).
access_vector(allow,sysadm_t,catman_t,fifo_file,append).
access_vector(allow,sysadm_t,catman_t,fifo_file,link).
access_vector(allow,sysadm_t,catman_t,fifo_file,unlink).
access_vector(allow,sysadm_t,catman_t,fifo_file,rename).
access_vector(allow,sysadm_t,mail_spool_t,dir,read).
access_vector(allow,sysadm_t,mail_spool_t,dir,getattr).
access_vector(allow,sysadm_t,mail_spool_t,dir,lock).
access_vector(allow,sysadm_t,mail_spool_t,dir,search).
access_vector(allow,sysadm_t,mail_spool_t,dir,ioctl).
access_vector(allow,sysadm_t,mail_spool_t,file,ioctl).
access_vector(allow,sysadm_t,mail_spool_t,file,read).
access_vector(allow,sysadm_t,mail_spool_t,file,getattr).
access_vector(allow,sysadm_t,mail_spool_t,file,lock).
access_vector(allow,sysadm_t,mail_spool_t,file,write).
access_vector(allow,sysadm_t,mail_spool_t,file,append).
access_vector(allow,sysadm_t,mail_spool_t,lnk_file,read).
access_vector(allow,sysadm_t,fs_type,filesystem,quotaget).
access_vector(allow,sysadm_t,bin_t,dir,read).
access_vector(allow,sysadm_t,bin_t,dir,getattr).
access_vector(allow,sysadm_t,bin_t,dir,lock).
access_vector(allow,sysadm_t,bin_t,dir,search).
access_vector(allow,sysadm_t,bin_t,dir,ioctl).
access_vector(allow,sysadm_t,sbin_t,dir,read).
access_vector(allow,sysadm_t,sbin_t,dir,getattr).
access_vector(allow,sysadm_t,sbin_t,dir,lock).
access_vector(allow,sysadm_t,sbin_t,dir,search).
access_vector(allow,sysadm_t,sbin_t,dir,ioctl).
access_vector(allow,sysadm_t,lib_t,dir,read).
access_vector(allow,sysadm_t,lib_t,dir,getattr).
access_vector(allow,sysadm_t,lib_t,dir,lock).
access_vector(allow,sysadm_t,lib_t,dir,search).
access_vector(allow,sysadm_t,lib_t,dir,ioctl).
access_vector(allow,sysadm_t,etc_t,dir,read).
access_vector(allow,sysadm_t,etc_t,dir,getattr).
access_vector(allow,sysadm_t,etc_t,dir,lock).
access_vector(allow,sysadm_t,etc_t,dir,search).
access_vector(allow,sysadm_t,etc_t,dir,ioctl).
access_vector(allow,sysadm_t,bin_t,lnk_file,getattr).
access_vector(allow,sysadm_t,bin_t,lnk_file,read).
access_vector(allow,sysadm_t,sbin_t,lnk_file,getattr).
access_vector(allow,sysadm_t,sbin_t,lnk_file,read).
access_vector(allow,sysadm_t,etc_t,lnk_file,getattr).
access_vector(allow,sysadm_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_t,root_t,dir,read).
access_vector(allow,sysadm_t,root_t,dir,getattr).
access_vector(allow,sysadm_t,root_t,dir,lock).
access_vector(allow,sysadm_t,root_t,dir,search).
access_vector(allow,sysadm_t,root_t,dir,ioctl).
access_vector(allow,sysadm_t,usr_t,dir,read).
access_vector(allow,sysadm_t,usr_t,dir,getattr).
access_vector(allow,sysadm_t,usr_t,dir,lock).
access_vector(allow,sysadm_t,usr_t,dir,search).
access_vector(allow,sysadm_t,usr_t,dir,ioctl).
access_vector(allow,sysadm_t,lib_t,lnk_file,read).
access_vector(allow,sysadm_t,lib_t,lnk_file,getattr).
access_vector(allow,sysadm_t,lib_t,lnk_file,lock).
access_vector(allow,sysadm_t,lib_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,ld_so_t,file,read).
access_vector(allow,sysadm_t,ld_so_t,file,getattr).
access_vector(allow,sysadm_t,ld_so_t,file,lock).
access_vector(allow,sysadm_t,ld_so_t,file,execute).
access_vector(allow,sysadm_t,ld_so_t,file,ioctl).
access_vector(allow,sysadm_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_t,ld_so_t,lnk_file,read).
access_vector(allow,sysadm_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sysadm_t,ld_so_t,lnk_file,lock).
access_vector(allow,sysadm_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,shlib_t,file,read).
access_vector(allow,sysadm_t,shlib_t,file,getattr).
access_vector(allow,sysadm_t,shlib_t,file,lock).
access_vector(allow,sysadm_t,shlib_t,file,execute).
access_vector(allow,sysadm_t,shlib_t,file,ioctl).
access_vector(allow,sysadm_t,shlib_t,lnk_file,read).
access_vector(allow,sysadm_t,shlib_t,lnk_file,getattr).
access_vector(allow,sysadm_t,shlib_t,lnk_file,lock).
access_vector(allow,sysadm_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,ld_so_cache_t,file,read).
access_vector(allow,sysadm_t,ld_so_cache_t,file,getattr).
access_vector(allow,sysadm_t,ld_so_cache_t,file,lock).
access_vector(allow,sysadm_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sysadm_t,device_t,dir,search).
access_vector(allow,sysadm_t,null_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,null_device_t,chr_file,read).
access_vector(allow,sysadm_t,null_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,null_device_t,chr_file,lock).
access_vector(allow,sysadm_t,null_device_t,chr_file,write).
access_vector(allow,sysadm_t,null_device_t,chr_file,append).
access_vector(allow,sysadm_t,etc_t,file,read).
access_vector(allow,sysadm_t,etc_t,file,getattr).
access_vector(allow,sysadm_t,etc_t,file,lock).
access_vector(allow,sysadm_t,etc_t,file,execute).
access_vector(allow,sysadm_t,etc_t,file,ioctl).
access_vector(allow,sysadm_t,etc_t,file,execute_no_trans).
access_vector(allow,sysadm_t,lib_t,file,read).
access_vector(allow,sysadm_t,lib_t,file,getattr).
access_vector(allow,sysadm_t,lib_t,file,lock).
access_vector(allow,sysadm_t,lib_t,file,execute).
access_vector(allow,sysadm_t,lib_t,file,ioctl).
access_vector(allow,sysadm_t,lib_t,file,execute_no_trans).
access_vector(allow,sysadm_t,bin_t,file,read).
access_vector(allow,sysadm_t,bin_t,file,getattr).
access_vector(allow,sysadm_t,bin_t,file,lock).
access_vector(allow,sysadm_t,bin_t,file,execute).
access_vector(allow,sysadm_t,bin_t,file,ioctl).
access_vector(allow,sysadm_t,bin_t,file,execute_no_trans).
access_vector(allow,sysadm_t,sbin_t,file,read).
access_vector(allow,sysadm_t,sbin_t,file,getattr).
access_vector(allow,sysadm_t,sbin_t,file,lock).
access_vector(allow,sysadm_t,sbin_t,file,execute).
access_vector(allow,sysadm_t,sbin_t,file,ioctl).
access_vector(allow,sysadm_t,sbin_t,file,execute_no_trans).
access_vector(allow,sysadm_t,exec_type,file,read).
access_vector(allow,sysadm_t,exec_type,file,getattr).
access_vector(allow,sysadm_t,exec_type,file,lock).
access_vector(allow,sysadm_t,exec_type,file,execute).
access_vector(allow,sysadm_t,exec_type,file,ioctl).
access_vector(allow,sysadm_t,exec_type,file,execute_no_trans).
access_vector(allow,sysadm_t,sysadm_home_t,file,read).
access_vector(allow,sysadm_t,sysadm_home_t,file,getattr).
access_vector(allow,sysadm_t,sysadm_home_t,file,lock).
access_vector(allow,sysadm_t,sysadm_home_t,file,execute).
access_vector(allow,sysadm_t,sysadm_home_t,file,ioctl).
access_vector(allow,sysadm_t,sysadm_home_t,file,execute_no_trans).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,read).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,getattr).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,lock).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,execute).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,ioctl).
access_vector(allow,sysadm_t,sysadm_tmp_t,file,execute_no_trans).
type_decl(sysadm_su_t,[],[domain,privlog,auth]).
access_vector(allow,sysadm_t,sysadm_su_t,process,transition).
access_vector(dontaudit,sysadm_t,sysadm_su_t,process,noatsecure).
access_vector(allow,sysadm_t,su_exec_t,file,read).
access_vector(allow,sysadm_t,su_exec_t,file,getattr).
access_vector(allow,sysadm_t,su_exec_t,file,execute).
access_vector(allow,sysadm_su_t,sysadm_t,process,sigchld).
access_vector(allow,sysadm_su_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,sysadm_su_t,fd,use).
access_vector(allow,sysadm_su_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,sysadm_su_t,sysadm_t,fifo_file,read).
access_vector(allow,sysadm_su_t,sysadm_t,fifo_file,getattr).
access_vector(allow,sysadm_su_t,sysadm_t,fifo_file,lock).
access_vector(allow,sysadm_su_t,sysadm_t,fifo_file,write).
access_vector(allow,sysadm_su_t,sysadm_t,fifo_file,append).
access_vector(allow,sysadm_su_t,su_exec_t,file,read).
access_vector(allow,sysadm_su_t,su_exec_t,file,getattr).
access_vector(allow,sysadm_su_t,su_exec_t,file,lock).
access_vector(allow,sysadm_su_t,su_exec_t,file,execute).
access_vector(allow,sysadm_su_t,su_exec_t,file,ioctl).
access_vector(allow,sysadm_su_t,su_exec_t,file,entrypoint).
type_trans(sysadm_t,su_exec_t,process,sysadm_su_t).
access_vector(allow,sysadm_su_t,root_t,dir,read).
access_vector(allow,sysadm_su_t,root_t,dir,getattr).
access_vector(allow,sysadm_su_t,root_t,dir,lock).
access_vector(allow,sysadm_su_t,root_t,dir,search).
access_vector(allow,sysadm_su_t,root_t,dir,ioctl).
access_vector(allow,sysadm_su_t,usr_t,dir,read).
access_vector(allow,sysadm_su_t,usr_t,dir,getattr).
access_vector(allow,sysadm_su_t,usr_t,dir,lock).
access_vector(allow,sysadm_su_t,usr_t,dir,search).
access_vector(allow,sysadm_su_t,usr_t,dir,ioctl).
access_vector(allow,sysadm_su_t,lib_t,dir,read).
access_vector(allow,sysadm_su_t,lib_t,dir,getattr).
access_vector(allow,sysadm_su_t,lib_t,dir,lock).
access_vector(allow,sysadm_su_t,lib_t,dir,search).
access_vector(allow,sysadm_su_t,lib_t,dir,ioctl).
access_vector(allow,sysadm_su_t,etc_t,dir,read).
access_vector(allow,sysadm_su_t,etc_t,dir,getattr).
access_vector(allow,sysadm_su_t,etc_t,dir,lock).
access_vector(allow,sysadm_su_t,etc_t,dir,search).
access_vector(allow,sysadm_su_t,etc_t,dir,ioctl).
access_vector(allow,sysadm_su_t,lib_t,lnk_file,read).
access_vector(allow,sysadm_su_t,lib_t,lnk_file,getattr).
access_vector(allow,sysadm_su_t,lib_t,lnk_file,lock).
access_vector(allow,sysadm_su_t,lib_t,lnk_file,ioctl).
access_vector(allow,sysadm_su_t,ld_so_t,file,read).
access_vector(allow,sysadm_su_t,ld_so_t,file,getattr).
access_vector(allow,sysadm_su_t,ld_so_t,file,lock).
access_vector(allow,sysadm_su_t,ld_so_t,file,execute).
access_vector(allow,sysadm_su_t,ld_so_t,file,ioctl).
access_vector(allow,sysadm_su_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_su_t,ld_so_t,lnk_file,read).
access_vector(allow,sysadm_su_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sysadm_su_t,ld_so_t,lnk_file,lock).
access_vector(allow,sysadm_su_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sysadm_su_t,shlib_t,file,read).
access_vector(allow,sysadm_su_t,shlib_t,file,getattr).
access_vector(allow,sysadm_su_t,shlib_t,file,lock).
access_vector(allow,sysadm_su_t,shlib_t,file,execute).
access_vector(allow,sysadm_su_t,shlib_t,file,ioctl).
access_vector(allow,sysadm_su_t,shlib_t,lnk_file,read).
access_vector(allow,sysadm_su_t,shlib_t,lnk_file,getattr).
access_vector(allow,sysadm_su_t,shlib_t,lnk_file,lock).
access_vector(allow,sysadm_su_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sysadm_su_t,ld_so_cache_t,file,read).
access_vector(allow,sysadm_su_t,ld_so_cache_t,file,getattr).
access_vector(allow,sysadm_su_t,ld_so_cache_t,file,lock).
access_vector(allow,sysadm_su_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sysadm_su_t,device_t,dir,search).
access_vector(allow,sysadm_su_t,null_device_t,chr_file,ioctl).
access_vector(allow,sysadm_su_t,null_device_t,chr_file,read).
access_vector(allow,sysadm_su_t,null_device_t,chr_file,getattr).
access_vector(allow,sysadm_su_t,null_device_t,chr_file,lock).
access_vector(allow,sysadm_su_t,null_device_t,chr_file,write).
access_vector(allow,sysadm_su_t,null_device_t,chr_file,append).
access_vector(allow,sysadm_su_t,etc_t,file,getattr).
access_vector(allow,sysadm_su_t,etc_t,file,read).
access_vector(allow,sysadm_su_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_su_t,locale_t,dir,read).
access_vector(allow,sysadm_su_t,locale_t,dir,getattr).
access_vector(allow,sysadm_su_t,locale_t,dir,lock).
access_vector(allow,sysadm_su_t,locale_t,dir,search).
access_vector(allow,sysadm_su_t,locale_t,dir,ioctl).
access_vector(allow,sysadm_su_t,locale_t,file,read).
access_vector(allow,sysadm_su_t,locale_t,file,getattr).
access_vector(allow,sysadm_su_t,locale_t,file,lock).
access_vector(allow,sysadm_su_t,locale_t,file,ioctl).
access_vector(allow,sysadm_su_t,locale_t,lnk_file,read).
access_vector(allow,sysadm_su_t,locale_t,lnk_file,getattr).
access_vector(allow,sysadm_su_t,locale_t,lnk_file,lock).
access_vector(allow,sysadm_su_t,locale_t,lnk_file,ioctl).
access_vector(allow,sysadm_su_t,self,unix_dgram_socket,connect).
access_vector(allow,sysadm_su_t,self,unix_dgram_socket,create).
access_vector(allow,sysadm_su_t,self,unix_dgram_socket,write).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,create).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,ioctl).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,read).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,getattr).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,write).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,setattr).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,append).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,bind).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,connect).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,getopt).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,setopt).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,shutdown).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,listen).
access_vector(allow,sysadm_su_t,self,unix_stream_socket,accept).
access_vector(allow,sysadm_su_t,proc_t,dir,search).
access_vector(allow,sysadm_su_t,proc_t,lnk_file,read).
access_vector(allow,sysadm_su_t,self,dir,read).
access_vector(allow,sysadm_su_t,self,dir,getattr).
access_vector(allow,sysadm_su_t,self,dir,lock).
access_vector(allow,sysadm_su_t,self,dir,search).
access_vector(allow,sysadm_su_t,self,dir,ioctl).
access_vector(allow,sysadm_su_t,self,file,read).
access_vector(allow,sysadm_su_t,self,file,getattr).
access_vector(allow,sysadm_su_t,self,file,lock).
access_vector(allow,sysadm_su_t,self,file,ioctl).
access_vector(allow,sysadm_su_t,self,lnk_file,read).
access_vector(allow,sysadm_su_t,self,lnk_file,getattr).
access_vector(allow,sysadm_su_t,self,lnk_file,lock).
access_vector(allow,sysadm_su_t,self,lnk_file,ioctl).
access_vector(allow,sysadm_su_t,self,process,setsched).
access_vector(allow,sysadm_su_t,device_t,dir,search).
access_vector(allow,sysadm_su_t,self,process,fork).
access_vector(allow,sysadm_su_t,self,process,sigchld).
access_vector(allow,sysadm_su_t,self,capability,setuid).
access_vector(allow,sysadm_su_t,self,capability,setgid).
access_vector(allow,sysadm_su_t,self,capability,net_bind_service).
access_vector(allow,sysadm_su_t,self,capability,chown).
access_vector(allow,sysadm_su_t,self,capability,dac_override).
access_vector(allow,sysadm_su_t,self,capability,sys_nice).
access_vector(allow,sysadm_su_t,self,capability,sys_resource).
access_vector(allow,sysadm_su_t,sysadm_t,process,transition).
access_vector(dontaudit,sysadm_su_t,sysadm_t,process,noatsecure).
access_vector(allow,sysadm_su_t,shell_exec_t,file,read).
access_vector(allow,sysadm_su_t,shell_exec_t,file,getattr).
access_vector(allow,sysadm_su_t,shell_exec_t,file,execute).
access_vector(allow,sysadm_t,sysadm_su_t,process,sigchld).
access_vector(allow,sysadm_t,sysadm_su_t,fd,use).
access_vector(allow,sysadm_su_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,sysadm_su_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,sysadm_su_t,fifo_file,read).
access_vector(allow,sysadm_t,sysadm_su_t,fifo_file,getattr).
access_vector(allow,sysadm_t,sysadm_su_t,fifo_file,lock).
access_vector(allow,sysadm_t,sysadm_su_t,fifo_file,write).
access_vector(allow,sysadm_t,sysadm_su_t,fifo_file,append).
access_vector(allow,sysadm_t,shell_exec_t,file,read).
access_vector(allow,sysadm_t,shell_exec_t,file,getattr).
access_vector(allow,sysadm_t,shell_exec_t,file,lock).
access_vector(allow,sysadm_t,shell_exec_t,file,execute).
access_vector(allow,sysadm_t,shell_exec_t,file,ioctl).
access_vector(allow,sysadm_t,shell_exec_t,file,entrypoint).
type_trans(sysadm_su_t,shell_exec_t,process,sysadm_t).
access_vector(allow,sysadm_su_t,bin_t,dir,search).
access_vector(allow,sysadm_su_t,bin_t,lnk_file,read).
access_vector(allow,sysadm_su_t,privfd,fd,use).
access_vector(allow,sysadm_su_t,var_t,dir,search).
access_vector(allow,sysadm_su_t,var_run_t,dir,search).
access_vector(allow,sysadm_su_t,initrc_var_run_t,file,ioctl).
access_vector(allow,sysadm_su_t,initrc_var_run_t,file,read).
access_vector(allow,sysadm_su_t,initrc_var_run_t,file,getattr).
access_vector(allow,sysadm_su_t,initrc_var_run_t,file,lock).
access_vector(allow,sysadm_su_t,initrc_var_run_t,file,write).
access_vector(allow,sysadm_su_t,initrc_var_run_t,file,append).
access_vector(allow,sysadm_su_t,chkpwd_exec_t,file,read).
access_vector(allow,sysadm_su_t,chkpwd_exec_t,file,getattr).
access_vector(allow,sysadm_su_t,chkpwd_exec_t,file,lock).
access_vector(allow,sysadm_su_t,chkpwd_exec_t,file,execute).
access_vector(allow,sysadm_su_t,chkpwd_exec_t,file,ioctl).
access_vector(allow,sysadm_su_t,chkpwd_exec_t,file,execute_no_trans).
role_decl(sysadm_r,sysadm_su_t).
access_vector(allow,sysadm_su_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,sysadm_su_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,sysadm_su_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,sysadm_su_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,sysadm_su_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,sysadm_su_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,sysadm_su_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,sysadm_su_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,sysadm_su_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,sysadm_su_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,sysadm_su_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,sysadm_su_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,sysadm_su_t,home_root_t,dir,search).
access_vector(allow,sysadm_su_t,sysadm_home_dir_t,dir,search).
access_vector(allow,sysadm_su_t,sshd_tmp_t,dir,read).
access_vector(allow,sysadm_su_t,sshd_tmp_t,dir,getattr).
access_vector(allow,sysadm_su_t,sshd_tmp_t,dir,lock).
access_vector(allow,sysadm_su_t,sshd_tmp_t,dir,search).
access_vector(allow,sysadm_su_t,sshd_tmp_t,dir,ioctl).
access_vector(allow,sysadm_su_t,sshd_tmp_t,dir,add_name).
access_vector(allow,sysadm_su_t,sshd_tmp_t,dir,remove_name).
access_vector(allow,sysadm_su_t,sshd_tmp_t,dir,write).
access_vector(allow,sysadm_su_t,sshd_tmp_t,file,ioctl).
access_vector(allow,sysadm_su_t,sshd_tmp_t,file,read).
access_vector(allow,sysadm_su_t,sshd_tmp_t,file,getattr).
access_vector(allow,sysadm_su_t,sshd_tmp_t,file,lock).
access_vector(allow,sysadm_su_t,sshd_tmp_t,file,write).
access_vector(allow,sysadm_su_t,sshd_tmp_t,file,append).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,create).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,ioctl).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,read).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,getattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,lock).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,write).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,setattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,append).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,link).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,unlink).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,file,rename).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,create).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,ioctl).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,read).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,getattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,lock).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,write).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,setattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,append).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,link).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,unlink).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,lnk_file,rename).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,create).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,ioctl).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,read).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,getattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,lock).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,write).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,setattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,append).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,link).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,unlink).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,sock_file,rename).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,create).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,ioctl).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,read).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,getattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,lock).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,write).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,setattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,append).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,link).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,unlink).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,fifo_file,rename).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,create).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,read).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,getattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,lock).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,setattr).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,link).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,unlink).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,rename).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,search).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,add_name).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,remove_name).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,reparent).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,write).
access_vector(allow,sysadm_su_t,sysadm_tmp_t,dir,rmdir).
type_trans(sysadm_su_t,sshd_tmp_t,dir,sysadm_tmp_t).
type_trans(sysadm_su_t,sshd_tmp_t,[file,lnk_file,sock_file,fifo_file],sysadm_tmp_t).
access_vector(dontaudit,sysadm_su_t,file_type,dir,search).
type_decl(sysadm_chkpwd_t,[],[domain,privlog,auth]).
access_vector(allow,sysadm_t,sysadm_chkpwd_t,process,transition).
access_vector(dontaudit,sysadm_t,sysadm_chkpwd_t,process,noatsecure).
access_vector(allow,sysadm_t,chkpwd_exec_t,file,read).
access_vector(allow,sysadm_t,chkpwd_exec_t,file,getattr).
access_vector(allow,sysadm_t,chkpwd_exec_t,file,execute).
access_vector(allow,sysadm_chkpwd_t,sysadm_t,process,sigchld).
access_vector(allow,sysadm_chkpwd_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,sysadm_chkpwd_t,fd,use).
access_vector(allow,sysadm_chkpwd_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,sysadm_chkpwd_t,sysadm_t,fifo_file,read).
access_vector(allow,sysadm_chkpwd_t,sysadm_t,fifo_file,getattr).
access_vector(allow,sysadm_chkpwd_t,sysadm_t,fifo_file,lock).
access_vector(allow,sysadm_chkpwd_t,sysadm_t,fifo_file,write).
access_vector(allow,sysadm_chkpwd_t,sysadm_t,fifo_file,append).
access_vector(allow,sysadm_chkpwd_t,chkpwd_exec_t,file,read).
access_vector(allow,sysadm_chkpwd_t,chkpwd_exec_t,file,getattr).
access_vector(allow,sysadm_chkpwd_t,chkpwd_exec_t,file,lock).
access_vector(allow,sysadm_chkpwd_t,chkpwd_exec_t,file,execute).
access_vector(allow,sysadm_chkpwd_t,chkpwd_exec_t,file,ioctl).
access_vector(allow,sysadm_chkpwd_t,chkpwd_exec_t,file,entrypoint).
type_trans(sysadm_t,chkpwd_exec_t,process,sysadm_chkpwd_t).
role_decl(sysadm_r,sysadm_chkpwd_t).
access_vector(allow,sysadm_chkpwd_t,root_t,dir,read).
access_vector(allow,sysadm_chkpwd_t,root_t,dir,getattr).
access_vector(allow,sysadm_chkpwd_t,root_t,dir,lock).
access_vector(allow,sysadm_chkpwd_t,root_t,dir,search).
access_vector(allow,sysadm_chkpwd_t,root_t,dir,ioctl).
access_vector(allow,sysadm_chkpwd_t,usr_t,dir,read).
access_vector(allow,sysadm_chkpwd_t,usr_t,dir,getattr).
access_vector(allow,sysadm_chkpwd_t,usr_t,dir,lock).
access_vector(allow,sysadm_chkpwd_t,usr_t,dir,search).
access_vector(allow,sysadm_chkpwd_t,usr_t,dir,ioctl).
access_vector(allow,sysadm_chkpwd_t,lib_t,dir,read).
access_vector(allow,sysadm_chkpwd_t,lib_t,dir,getattr).
access_vector(allow,sysadm_chkpwd_t,lib_t,dir,lock).
access_vector(allow,sysadm_chkpwd_t,lib_t,dir,search).
access_vector(allow,sysadm_chkpwd_t,lib_t,dir,ioctl).
access_vector(allow,sysadm_chkpwd_t,etc_t,dir,read).
access_vector(allow,sysadm_chkpwd_t,etc_t,dir,getattr).
access_vector(allow,sysadm_chkpwd_t,etc_t,dir,lock).
access_vector(allow,sysadm_chkpwd_t,etc_t,dir,search).
access_vector(allow,sysadm_chkpwd_t,etc_t,dir,ioctl).
access_vector(allow,sysadm_chkpwd_t,lib_t,lnk_file,read).
access_vector(allow,sysadm_chkpwd_t,lib_t,lnk_file,getattr).
access_vector(allow,sysadm_chkpwd_t,lib_t,lnk_file,lock).
access_vector(allow,sysadm_chkpwd_t,lib_t,lnk_file,ioctl).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,file,read).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,file,getattr).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,file,lock).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,file,execute).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,file,ioctl).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,lnk_file,read).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,lnk_file,lock).
access_vector(allow,sysadm_chkpwd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sysadm_chkpwd_t,shlib_t,file,read).
access_vector(allow,sysadm_chkpwd_t,shlib_t,file,getattr).
access_vector(allow,sysadm_chkpwd_t,shlib_t,file,lock).
access_vector(allow,sysadm_chkpwd_t,shlib_t,file,execute).
access_vector(allow,sysadm_chkpwd_t,shlib_t,file,ioctl).
access_vector(allow,sysadm_chkpwd_t,shlib_t,lnk_file,read).
access_vector(allow,sysadm_chkpwd_t,shlib_t,lnk_file,getattr).
access_vector(allow,sysadm_chkpwd_t,shlib_t,lnk_file,lock).
access_vector(allow,sysadm_chkpwd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sysadm_chkpwd_t,ld_so_cache_t,file,read).
access_vector(allow,sysadm_chkpwd_t,ld_so_cache_t,file,getattr).
access_vector(allow,sysadm_chkpwd_t,ld_so_cache_t,file,lock).
access_vector(allow,sysadm_chkpwd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sysadm_chkpwd_t,device_t,dir,search).
access_vector(allow,sysadm_chkpwd_t,null_device_t,chr_file,ioctl).
access_vector(allow,sysadm_chkpwd_t,null_device_t,chr_file,read).
access_vector(allow,sysadm_chkpwd_t,null_device_t,chr_file,getattr).
access_vector(allow,sysadm_chkpwd_t,null_device_t,chr_file,lock).
access_vector(allow,sysadm_chkpwd_t,null_device_t,chr_file,write).
access_vector(allow,sysadm_chkpwd_t,null_device_t,chr_file,append).
access_vector(allow,sysadm_chkpwd_t,etc_t,file,getattr).
access_vector(allow,sysadm_chkpwd_t,etc_t,file,read).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,create).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,read).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,getattr).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,write).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,setattr).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,append).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,bind).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,connect).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,getopt).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,setopt).
access_vector(allow,sysadm_chkpwd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,create).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,ioctl).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,read).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,getattr).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,write).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,setattr).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,append).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,bind).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,connect).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,getopt).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,setopt).
access_vector(allow,sysadm_chkpwd_t,self,unix_stream_socket,shutdown).
access_vector(allow,sysadm_chkpwd_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_chkpwd_t,locale_t,dir,read).
access_vector(allow,sysadm_chkpwd_t,locale_t,dir,getattr).
access_vector(allow,sysadm_chkpwd_t,locale_t,dir,lock).
access_vector(allow,sysadm_chkpwd_t,locale_t,dir,search).
access_vector(allow,sysadm_chkpwd_t,locale_t,dir,ioctl).
access_vector(allow,sysadm_chkpwd_t,locale_t,file,read).
access_vector(allow,sysadm_chkpwd_t,locale_t,file,getattr).
access_vector(allow,sysadm_chkpwd_t,locale_t,file,lock).
access_vector(allow,sysadm_chkpwd_t,locale_t,file,ioctl).
access_vector(allow,sysadm_chkpwd_t,locale_t,lnk_file,read).
access_vector(allow,sysadm_chkpwd_t,locale_t,lnk_file,getattr).
access_vector(allow,sysadm_chkpwd_t,locale_t,lnk_file,lock).
access_vector(allow,sysadm_chkpwd_t,locale_t,lnk_file,ioctl).
access_vector(allow,sysadm_chkpwd_t,self,capability,setuid).
access_vector(allow,sysadm_chkpwd_t,newrole_t,fd,use).
access_vector(allow,sysadm_chkpwd_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,sysadm_chkpwd_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,sysadm_chkpwd_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,sysadm_chkpwd_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,sysadm_chkpwd_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,sysadm_chkpwd_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,sysadm_chkpwd_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,sysadm_chkpwd_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,sysadm_chkpwd_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,sysadm_chkpwd_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,sysadm_chkpwd_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,sysadm_chkpwd_t,sysadm_devpts_t,chr_file,append).
type_decl(sysadm_crontab_t,[],[domain,privlog]).
access_vector(allow,sysadm_t,sysadm_crontab_t,process,transition).
access_vector(dontaudit,sysadm_t,sysadm_crontab_t,process,noatsecure).
access_vector(allow,sysadm_t,crontab_exec_t,file,read).
access_vector(allow,sysadm_t,crontab_exec_t,file,getattr).
access_vector(allow,sysadm_t,crontab_exec_t,file,execute).
access_vector(allow,sysadm_crontab_t,sysadm_t,process,sigchld).
access_vector(allow,sysadm_crontab_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,sysadm_crontab_t,fd,use).
access_vector(allow,sysadm_crontab_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_t,fifo_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_t,fifo_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_t,fifo_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_t,fifo_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_t,fifo_file,append).
access_vector(allow,sysadm_crontab_t,crontab_exec_t,file,read).
access_vector(allow,sysadm_crontab_t,crontab_exec_t,file,getattr).
access_vector(allow,sysadm_crontab_t,crontab_exec_t,file,lock).
access_vector(allow,sysadm_crontab_t,crontab_exec_t,file,execute).
access_vector(allow,sysadm_crontab_t,crontab_exec_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,crontab_exec_t,file,entrypoint).
type_trans(sysadm_t,crontab_exec_t,process,sysadm_crontab_t).
role_decl(sysadm_r,sysadm_crontab_t).
access_vector(allow,sysadm_crontab_t,root_t,dir,read).
access_vector(allow,sysadm_crontab_t,root_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,root_t,dir,lock).
access_vector(allow,sysadm_crontab_t,root_t,dir,search).
access_vector(allow,sysadm_crontab_t,root_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,usr_t,dir,read).
access_vector(allow,sysadm_crontab_t,usr_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,usr_t,dir,lock).
access_vector(allow,sysadm_crontab_t,usr_t,dir,search).
access_vector(allow,sysadm_crontab_t,usr_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,lib_t,dir,read).
access_vector(allow,sysadm_crontab_t,lib_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,lib_t,dir,lock).
access_vector(allow,sysadm_crontab_t,lib_t,dir,search).
access_vector(allow,sysadm_crontab_t,lib_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,etc_t,dir,read).
access_vector(allow,sysadm_crontab_t,etc_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,etc_t,dir,lock).
access_vector(allow,sysadm_crontab_t,etc_t,dir,search).
access_vector(allow,sysadm_crontab_t,etc_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,lib_t,lnk_file,read).
access_vector(allow,sysadm_crontab_t,lib_t,lnk_file,getattr).
access_vector(allow,sysadm_crontab_t,lib_t,lnk_file,lock).
access_vector(allow,sysadm_crontab_t,lib_t,lnk_file,ioctl).
access_vector(allow,sysadm_crontab_t,ld_so_t,file,read).
access_vector(allow,sysadm_crontab_t,ld_so_t,file,getattr).
access_vector(allow,sysadm_crontab_t,ld_so_t,file,lock).
access_vector(allow,sysadm_crontab_t,ld_so_t,file,execute).
access_vector(allow,sysadm_crontab_t,ld_so_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_crontab_t,ld_so_t,lnk_file,read).
access_vector(allow,sysadm_crontab_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sysadm_crontab_t,ld_so_t,lnk_file,lock).
access_vector(allow,sysadm_crontab_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sysadm_crontab_t,shlib_t,file,read).
access_vector(allow,sysadm_crontab_t,shlib_t,file,getattr).
access_vector(allow,sysadm_crontab_t,shlib_t,file,lock).
access_vector(allow,sysadm_crontab_t,shlib_t,file,execute).
access_vector(allow,sysadm_crontab_t,shlib_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,shlib_t,lnk_file,read).
access_vector(allow,sysadm_crontab_t,shlib_t,lnk_file,getattr).
access_vector(allow,sysadm_crontab_t,shlib_t,lnk_file,lock).
access_vector(allow,sysadm_crontab_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sysadm_crontab_t,ld_so_cache_t,file,read).
access_vector(allow,sysadm_crontab_t,ld_so_cache_t,file,getattr).
access_vector(allow,sysadm_crontab_t,ld_so_cache_t,file,lock).
access_vector(allow,sysadm_crontab_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,device_t,dir,search).
access_vector(allow,sysadm_crontab_t,null_device_t,chr_file,ioctl).
access_vector(allow,sysadm_crontab_t,null_device_t,chr_file,read).
access_vector(allow,sysadm_crontab_t,null_device_t,chr_file,getattr).
access_vector(allow,sysadm_crontab_t,null_device_t,chr_file,lock).
access_vector(allow,sysadm_crontab_t,null_device_t,chr_file,write).
access_vector(allow,sysadm_crontab_t,null_device_t,chr_file,append).
access_vector(allow,sysadm_crontab_t,etc_t,file,getattr).
access_vector(allow,sysadm_crontab_t,etc_t,file,read).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,create).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,ioctl).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,read).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,getattr).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,write).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,setattr).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,append).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,bind).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,connect).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,getopt).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,setopt).
access_vector(allow,sysadm_crontab_t,self,unix_stream_socket,shutdown).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,create).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,ioctl).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,read).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,getattr).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,write).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,setattr).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,append).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,bind).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,connect).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,getopt).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,setopt).
access_vector(allow,sysadm_crontab_t,self,unix_dgram_socket,shutdown).
access_vector(allow,sysadm_crontab_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_crontab_t,locale_t,dir,read).
access_vector(allow,sysadm_crontab_t,locale_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,locale_t,dir,lock).
access_vector(allow,sysadm_crontab_t,locale_t,dir,search).
access_vector(allow,sysadm_crontab_t,locale_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,locale_t,file,read).
access_vector(allow,sysadm_crontab_t,locale_t,file,getattr).
access_vector(allow,sysadm_crontab_t,locale_t,file,lock).
access_vector(allow,sysadm_crontab_t,locale_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,locale_t,lnk_file,read).
access_vector(allow,sysadm_crontab_t,locale_t,lnk_file,getattr).
access_vector(allow,sysadm_crontab_t,locale_t,lnk_file,lock).
access_vector(allow,sysadm_crontab_t,locale_t,lnk_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_crontab_t,capability,setuid).
access_vector(allow,sysadm_crontab_t,sysadm_crontab_t,capability,setgid).
access_vector(allow,sysadm_crontab_t,sysadm_crontab_t,capability,chown).
access_vector(allow,sysadm_crontab_t,tmp_t,dir,read).
access_vector(allow,sysadm_crontab_t,tmp_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,tmp_t,dir,lock).
access_vector(allow,sysadm_crontab_t,tmp_t,dir,search).
access_vector(allow,sysadm_crontab_t,tmp_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,tmp_t,dir,add_name).
access_vector(allow,sysadm_crontab_t,tmp_t,dir,remove_name).
access_vector(allow,sysadm_crontab_t,tmp_t,dir,write).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,create).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,read).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,write).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,append).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,link).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,file,rename).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,create).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,append).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,link).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,lnk_file,rename).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,create).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,append).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,link).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,sock_file,rename).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,create).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,append).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,link).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,fifo_file,rename).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,create).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,read).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,lock).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,link).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,rename).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,search).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,add_name).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,remove_name).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,reparent).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,write).
access_vector(allow,sysadm_crontab_t,sysadm_tmp_t,dir,rmdir).
type_trans(sysadm_crontab_t,tmp_t,dir,sysadm_tmp_t).
type_trans(sysadm_crontab_t,tmp_t,[file,lnk_file,sock_file,fifo_file],sysadm_tmp_t).
type_decl(sysadm_cron_spool_t,[],[file_type,sysadmfile]).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,read).
access_vector(allow,sysadm_crontab_t,var_t,dir,search).
access_vector(allow,sysadm_crontab_t,var_spool_t,dir,search).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,read).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,lock).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,search).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,add_name).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,remove_name).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,write).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,create).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,read).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,write).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,append).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,link).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,file,rename).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,create).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,append).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,link).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,lnk_file,rename).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,create).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,append).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,link).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,sock_file,rename).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,create).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,append).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,link).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,fifo_file,rename).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,create).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,read).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,lock).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,setattr).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,link).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,unlink).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,rename).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,search).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,add_name).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,remove_name).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,reparent).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,write).
access_vector(allow,sysadm_crontab_t,sysadm_cron_spool_t,dir,rmdir).
type_trans(sysadm_crontab_t,cron_spool_t,dir,sysadm_cron_spool_t).
type_trans(sysadm_crontab_t,cron_spool_t,[file,lnk_file,sock_file,fifo_file],sysadm_cron_spool_t).
access_vector(allow,sysadm_crontab_t,self,process,fork).
access_vector(allow,sysadm_crontab_t,self,process,sigchld).
access_vector(allow,sysadm_crontab_t,self,process,sigkill).
access_vector(allow,sysadm_crontab_t,self,process,sigstop).
access_vector(allow,sysadm_crontab_t,self,process,signull).
access_vector(allow,sysadm_crontab_t,self,process,signal).
access_vector(allow,sysadm_crontab_t,cron_spool_t,dir,setattr).
access_vector(allow,crond_t,sysadm_cron_spool_t,file,read).
access_vector(allow,crond_t,sysadm_cron_spool_t,file,getattr).
access_vector(allow,crond_t,sysadm_cron_spool_t,file,lock).
access_vector(allow,crond_t,sysadm_cron_spool_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,bin_t,dir,search).
access_vector(allow,sysadm_crontab_t,sbin_t,dir,search).
access_vector(allow,sysadm_crontab_t,bin_t,lnk_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_t,process,transition).
access_vector(dontaudit,sysadm_crontab_t,sysadm_t,process,noatsecure).
access_vector(allow,sysadm_crontab_t,bin_t,file,read).
access_vector(allow,sysadm_crontab_t,bin_t,file,getattr).
access_vector(allow,sysadm_crontab_t,bin_t,file,execute).
access_vector(allow,sysadm_crontab_t,sbin_t,file,read).
access_vector(allow,sysadm_crontab_t,sbin_t,file,getattr).
access_vector(allow,sysadm_crontab_t,sbin_t,file,execute).
access_vector(allow,sysadm_crontab_t,shell_exec_t,file,read).
access_vector(allow,sysadm_crontab_t,shell_exec_t,file,getattr).
access_vector(allow,sysadm_crontab_t,shell_exec_t,file,execute).
access_vector(allow,sysadm_t,sysadm_crontab_t,process,sigchld).
access_vector(allow,sysadm_t,sysadm_crontab_t,fd,use).
access_vector(allow,sysadm_crontab_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,sysadm_crontab_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,sysadm_crontab_t,fifo_file,read).
access_vector(allow,sysadm_t,sysadm_crontab_t,fifo_file,getattr).
access_vector(allow,sysadm_t,sysadm_crontab_t,fifo_file,lock).
access_vector(allow,sysadm_t,sysadm_crontab_t,fifo_file,write).
access_vector(allow,sysadm_t,sysadm_crontab_t,fifo_file,append).
access_vector(allow,sysadm_t,bin_t,file,read).
access_vector(allow,sysadm_t,bin_t,file,getattr).
access_vector(allow,sysadm_t,bin_t,file,lock).
access_vector(allow,sysadm_t,bin_t,file,execute).
access_vector(allow,sysadm_t,bin_t,file,ioctl).
access_vector(allow,sysadm_t,sbin_t,file,read).
access_vector(allow,sysadm_t,sbin_t,file,getattr).
access_vector(allow,sysadm_t,sbin_t,file,lock).
access_vector(allow,sysadm_t,sbin_t,file,execute).
access_vector(allow,sysadm_t,sbin_t,file,ioctl).
access_vector(allow,sysadm_t,bin_t,file,entrypoint).
access_vector(allow,sysadm_t,sbin_t,file,entrypoint).
access_vector(allow,sysadm_t,shell_exec_t,file,entrypoint).
type_trans(sysadm_crontab_t,[bin_t,sbin_t,shell_exec_t],process,sysadm_t).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,dir,read).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,dir,lock).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,dir,search).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_home_dir_t,dir,read).
access_vector(allow,sysadm_crontab_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_home_dir_t,dir,lock).
access_vector(allow,sysadm_crontab_t,sysadm_home_dir_t,dir,search).
access_vector(allow,sysadm_crontab_t,sysadm_home_dir_t,dir,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,file,read).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_home_t,file,ioctl).
access_vector(dontaudit,sysadm_crontab_t,sysadm_home_dir_t,dir,write).
access_vector(allow,sysadm_crontab_t,cron_log_t,file,read).
access_vector(allow,sysadm_crontab_t,cron_log_t,file,getattr).
access_vector(allow,sysadm_crontab_t,cron_log_t,file,lock).
access_vector(allow,sysadm_crontab_t,cron_log_t,file,ioctl).
access_vector(allow,sysadm_crontab_t,cron_log_t,file,append).
access_vector(allow,sysadm_crontab_t,device_t,dir,search).
access_vector(allow,sysadm_crontab_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,sysadm_crontab_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,sysadm_crontab_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,sysadm_crontab_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,sysadm_crontab_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,sysadm_crontab_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,sysadm_crontab_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,sysadm_crontab_t,privfd,fd,use).
type_decl(sysadm_ssh_t,[],[domain,privlog]).
access_vector(allow,sysadm_t,sysadm_ssh_t,process,transition).
access_vector(dontaudit,sysadm_t,sysadm_ssh_t,process,noatsecure).
access_vector(allow,sysadm_t,ssh_exec_t,file,read).
access_vector(allow,sysadm_t,ssh_exec_t,file,getattr).
access_vector(allow,sysadm_t,ssh_exec_t,file,execute).
access_vector(allow,sysadm_ssh_t,sysadm_t,process,sigchld).
access_vector(allow,sysadm_ssh_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,sysadm_ssh_t,fd,use).
access_vector(allow,sysadm_ssh_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,sysadm_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,sysadm_t,fifo_file,write).
access_vector(allow,sysadm_ssh_t,sysadm_t,fifo_file,append).
access_vector(allow,sysadm_ssh_t,ssh_exec_t,file,read).
access_vector(allow,sysadm_ssh_t,ssh_exec_t,file,getattr).
access_vector(allow,sysadm_ssh_t,ssh_exec_t,file,lock).
access_vector(allow,sysadm_ssh_t,ssh_exec_t,file,execute).
access_vector(allow,sysadm_ssh_t,ssh_exec_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,ssh_exec_t,file,entrypoint).
type_trans(sysadm_t,ssh_exec_t,process,sysadm_ssh_t).
role_decl(sysadm_r,sysadm_ssh_t).
access_vector(allow,sysadm_ssh_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,sysadm_ssh_t,self,dir,read).
access_vector(allow,sysadm_ssh_t,self,dir,getattr).
access_vector(allow,sysadm_ssh_t,self,dir,lock).
access_vector(allow,sysadm_ssh_t,self,dir,search).
access_vector(allow,sysadm_ssh_t,self,dir,ioctl).
access_vector(allow,sysadm_ssh_t,self,file,read).
access_vector(allow,sysadm_ssh_t,self,file,getattr).
access_vector(allow,sysadm_ssh_t,self,file,lock).
access_vector(allow,sysadm_ssh_t,self,file,ioctl).
access_vector(allow,sysadm_ssh_t,self,lnk_file,read).
access_vector(allow,sysadm_ssh_t,self,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,self,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,self,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,self,sock_file,read).
access_vector(allow,sysadm_ssh_t,self,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,self,sock_file,lock).
access_vector(allow,sysadm_ssh_t,self,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,self,fifo_file,read).
access_vector(allow,sysadm_ssh_t,self,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,self,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,self,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,self,fd,_).
access_vector(allow,sysadm_ssh_t,self,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,self,fifo_file,read).
access_vector(allow,sysadm_ssh_t,self,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,self,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,self,fifo_file,write).
access_vector(allow,sysadm_ssh_t,self,fifo_file,append).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,create).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,ioctl).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,read).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,getattr).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,write).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,setattr).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,append).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,bind).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,connect).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,getopt).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,setopt).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,shutdown).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,create).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,ioctl).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,read).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,getattr).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,write).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,setattr).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,append).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,bind).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,connect).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,getopt).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,setopt).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,shutdown).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,listen).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,accept).
access_vector(allow,sysadm_ssh_t,self,unix_dgram_socket,sendto).
access_vector(allow,sysadm_ssh_t,self,unix_stream_socket,connectto).
access_vector(allow,sysadm_ssh_t,self,sem,associate).
access_vector(allow,sysadm_ssh_t,self,sem,getattr).
access_vector(allow,sysadm_ssh_t,self,sem,setattr).
access_vector(allow,sysadm_ssh_t,self,sem,create).
access_vector(allow,sysadm_ssh_t,self,sem,destroy).
access_vector(allow,sysadm_ssh_t,self,sem,read).
access_vector(allow,sysadm_ssh_t,self,sem,write).
access_vector(allow,sysadm_ssh_t,self,sem,unix_read).
access_vector(allow,sysadm_ssh_t,self,sem,unix_write).
access_vector(allow,sysadm_ssh_t,self,msg,send).
access_vector(allow,sysadm_ssh_t,self,msg,receive).
access_vector(allow,sysadm_ssh_t,self,msgq,associate).
access_vector(allow,sysadm_ssh_t,self,msgq,getattr).
access_vector(allow,sysadm_ssh_t,self,msgq,setattr).
access_vector(allow,sysadm_ssh_t,self,msgq,create).
access_vector(allow,sysadm_ssh_t,self,msgq,destroy).
access_vector(allow,sysadm_ssh_t,self,msgq,read).
access_vector(allow,sysadm_ssh_t,self,msgq,write).
access_vector(allow,sysadm_ssh_t,self,msgq,enqueue).
access_vector(allow,sysadm_ssh_t,self,msgq,unix_read).
access_vector(allow,sysadm_ssh_t,self,msgq,unix_write).
access_vector(allow,sysadm_ssh_t,self,shm,associate).
access_vector(allow,sysadm_ssh_t,self,shm,getattr).
access_vector(allow,sysadm_ssh_t,self,shm,setattr).
access_vector(allow,sysadm_ssh_t,self,shm,create).
access_vector(allow,sysadm_ssh_t,self,shm,destroy).
access_vector(allow,sysadm_ssh_t,self,shm,read).
access_vector(allow,sysadm_ssh_t,self,shm,write).
access_vector(allow,sysadm_ssh_t,self,shm,lock).
access_vector(allow,sysadm_ssh_t,self,shm,unix_read).
access_vector(allow,sysadm_ssh_t,self,shm,unix_write).
access_vector(allow,sysadm_ssh_t,privfd,fd,use).
access_vector(allow,sysadm_ssh_t,root_t,dir,read).
access_vector(allow,sysadm_ssh_t,root_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,root_t,dir,lock).
access_vector(allow,sysadm_ssh_t,root_t,dir,search).
access_vector(allow,sysadm_ssh_t,root_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,usr_t,dir,read).
access_vector(allow,sysadm_ssh_t,usr_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,usr_t,dir,lock).
access_vector(allow,sysadm_ssh_t,usr_t,dir,search).
access_vector(allow,sysadm_ssh_t,usr_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,lib_t,dir,read).
access_vector(allow,sysadm_ssh_t,lib_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,lib_t,dir,lock).
access_vector(allow,sysadm_ssh_t,lib_t,dir,search).
access_vector(allow,sysadm_ssh_t,lib_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,etc_t,dir,read).
access_vector(allow,sysadm_ssh_t,etc_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,etc_t,dir,lock).
access_vector(allow,sysadm_ssh_t,etc_t,dir,search).
access_vector(allow,sysadm_ssh_t,etc_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,lib_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,lib_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,lib_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,lib_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,read).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,getattr).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,lock).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,execute).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_ssh_t,ld_so_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,ld_so_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,shlib_t,file,read).
access_vector(allow,sysadm_ssh_t,shlib_t,file,getattr).
access_vector(allow,sysadm_ssh_t,shlib_t,file,lock).
access_vector(allow,sysadm_ssh_t,shlib_t,file,execute).
access_vector(allow,sysadm_ssh_t,shlib_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,shlib_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,shlib_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,shlib_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,ld_so_cache_t,file,read).
access_vector(allow,sysadm_ssh_t,ld_so_cache_t,file,getattr).
access_vector(allow,sysadm_ssh_t,ld_so_cache_t,file,lock).
access_vector(allow,sysadm_ssh_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,device_t,dir,search).
access_vector(allow,sysadm_ssh_t,null_device_t,chr_file,ioctl).
access_vector(allow,sysadm_ssh_t,null_device_t,chr_file,read).
access_vector(allow,sysadm_ssh_t,null_device_t,chr_file,getattr).
access_vector(allow,sysadm_ssh_t,null_device_t,chr_file,lock).
access_vector(allow,sysadm_ssh_t,null_device_t,chr_file,write).
access_vector(allow,sysadm_ssh_t,null_device_t,chr_file,append).
access_vector(allow,sysadm_ssh_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,locale_t,dir,read).
access_vector(allow,sysadm_ssh_t,locale_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,locale_t,dir,lock).
access_vector(allow,sysadm_ssh_t,locale_t,dir,search).
access_vector(allow,sysadm_ssh_t,locale_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,locale_t,file,read).
access_vector(allow,sysadm_ssh_t,locale_t,file,getattr).
access_vector(allow,sysadm_ssh_t,locale_t,file,lock).
access_vector(allow,sysadm_ssh_t,locale_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,locale_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,locale_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,locale_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,locale_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,fs_type,filesystem,getattr).
access_vector(allow,sysadm_ssh_t,root_t,file,read).
access_vector(allow,sysadm_ssh_t,root_t,file,getattr).
access_vector(allow,sysadm_ssh_t,root_t,file,lock).
access_vector(allow,sysadm_ssh_t,root_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,root_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,root_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,root_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,root_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,root_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,root_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,root_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,root_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,root_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,root_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,root_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,root_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,home_root_t,dir,read).
access_vector(allow,sysadm_ssh_t,home_root_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,home_root_t,dir,lock).
access_vector(allow,sysadm_ssh_t,home_root_t,dir,search).
access_vector(allow,sysadm_ssh_t,home_root_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,usr_t,file,read).
access_vector(allow,sysadm_ssh_t,usr_t,file,getattr).
access_vector(allow,sysadm_ssh_t,usr_t,file,lock).
access_vector(allow,sysadm_ssh_t,usr_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,usr_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,usr_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,usr_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,usr_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,usr_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,usr_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,usr_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,usr_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,usr_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,usr_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,usr_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,usr_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,bin_t,dir,read).
access_vector(allow,sysadm_ssh_t,bin_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,bin_t,dir,lock).
access_vector(allow,sysadm_ssh_t,bin_t,dir,search).
access_vector(allow,sysadm_ssh_t,bin_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,bin_t,file,read).
access_vector(allow,sysadm_ssh_t,bin_t,file,getattr).
access_vector(allow,sysadm_ssh_t,bin_t,file,lock).
access_vector(allow,sysadm_ssh_t,bin_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,bin_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,bin_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,bin_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,bin_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,bin_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,bin_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,bin_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,bin_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,bin_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,bin_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,bin_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,bin_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,sbin_t,dir,read).
access_vector(allow,sysadm_ssh_t,sbin_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,sbin_t,dir,lock).
access_vector(allow,sysadm_ssh_t,sbin_t,dir,search).
access_vector(allow,sysadm_ssh_t,sbin_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,sbin_t,file,read).
access_vector(allow,sysadm_ssh_t,sbin_t,file,getattr).
access_vector(allow,sysadm_ssh_t,sbin_t,file,lock).
access_vector(allow,sysadm_ssh_t,sbin_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,sbin_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,sbin_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,sbin_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,sbin_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,sbin_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,sbin_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,sbin_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,sbin_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,sbin_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,sbin_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,sbin_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,sbin_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,devpts_t,dir,read).
access_vector(allow,sysadm_ssh_t,devpts_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,devpts_t,dir,lock).
access_vector(allow,sysadm_ssh_t,devpts_t,dir,search).
access_vector(allow,sysadm_ssh_t,devpts_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,var_t,dir,read).
access_vector(allow,sysadm_ssh_t,var_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,var_t,dir,lock).
access_vector(allow,sysadm_ssh_t,var_t,dir,search).
access_vector(allow,sysadm_ssh_t,var_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,var_t,file,read).
access_vector(allow,sysadm_ssh_t,var_t,file,getattr).
access_vector(allow,sysadm_ssh_t,var_t,file,lock).
access_vector(allow,sysadm_ssh_t,var_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,var_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,var_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,var_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,var_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,var_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,var_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,var_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,var_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,var_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,var_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,var_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,var_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,var_run_t,dir,read).
access_vector(allow,sysadm_ssh_t,var_run_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,var_run_t,dir,lock).
access_vector(allow,sysadm_ssh_t,var_run_t,dir,search).
access_vector(allow,sysadm_ssh_t,var_run_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,var_run_t,file,read).
access_vector(allow,sysadm_ssh_t,var_run_t,file,getattr).
access_vector(allow,sysadm_ssh_t,var_run_t,file,lock).
access_vector(allow,sysadm_ssh_t,var_run_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,var_run_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,var_run_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,var_run_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,var_run_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,var_log_t,dir,read).
access_vector(allow,sysadm_ssh_t,var_log_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,var_log_t,dir,lock).
access_vector(allow,sysadm_ssh_t,var_log_t,dir,search).
access_vector(allow,sysadm_ssh_t,var_log_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,var_log_t,file,read).
access_vector(allow,sysadm_ssh_t,var_log_t,file,getattr).
access_vector(allow,sysadm_ssh_t,var_log_t,file,lock).
access_vector(allow,sysadm_ssh_t,var_log_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,var_log_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,var_log_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,var_log_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,var_log_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,etc_t,file,read).
access_vector(allow,sysadm_ssh_t,etc_t,file,getattr).
access_vector(allow,sysadm_ssh_t,etc_t,file,lock).
access_vector(allow,sysadm_ssh_t,etc_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,etc_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,etc_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,etc_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,etc_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,etc_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,etc_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,etc_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,etc_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,etc_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,etc_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,etc_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,etc_runtime_t,file,read).
access_vector(allow,sysadm_ssh_t,etc_runtime_t,file,getattr).
access_vector(allow,sysadm_ssh_t,etc_runtime_t,file,lock).
access_vector(allow,sysadm_ssh_t,etc_runtime_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,etc_runtime_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,resolv_conf_t,file,read).
access_vector(allow,sysadm_ssh_t,resolv_conf_t,file,getattr).
access_vector(allow,sysadm_ssh_t,resolv_conf_t,file,lock).
access_vector(allow,sysadm_ssh_t,resolv_conf_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,resolv_conf_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,resolv_conf_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,resolv_conf_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,resolv_conf_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,read).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,getattr).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,lock).
access_vector(allow,sysadm_ssh_t,shlib_t,file,read).
access_vector(allow,sysadm_ssh_t,shlib_t,file,getattr).
access_vector(allow,sysadm_ssh_t,shlib_t,file,lock).
access_vector(allow,sysadm_ssh_t,exec_type,file,read).
access_vector(allow,sysadm_ssh_t,exec_type,file,getattr).
access_vector(allow,sysadm_ssh_t,exec_type,file,lock).
access_vector(allow,sysadm_ssh_t,exec_type,file,ioctl).
access_vector(allow,sysadm_ssh_t,exec_type,lnk_file,read).
access_vector(allow,sysadm_ssh_t,exec_type,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,exec_type,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,exec_type,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,device_t,dir,read).
access_vector(allow,sysadm_ssh_t,device_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,device_t,dir,lock).
access_vector(allow,sysadm_ssh_t,device_t,dir,search).
access_vector(allow,sysadm_ssh_t,device_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,device_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,device_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,device_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,device_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,random_device_t,chr_file,read).
access_vector(allow,sysadm_ssh_t,random_device_t,chr_file,getattr).
access_vector(allow,sysadm_ssh_t,random_device_t,chr_file,lock).
access_vector(allow,sysadm_ssh_t,random_device_t,chr_file,ioctl).
access_vector(allow,sysadm_ssh_t,devtty_t,chr_file,ioctl).
access_vector(allow,sysadm_ssh_t,devtty_t,chr_file,read).
access_vector(allow,sysadm_ssh_t,devtty_t,chr_file,getattr).
access_vector(allow,sysadm_ssh_t,devtty_t,chr_file,lock).
access_vector(allow,sysadm_ssh_t,devtty_t,chr_file,write).
access_vector(allow,sysadm_ssh_t,devtty_t,chr_file,append).
access_vector(allow,sysadm_ssh_t,zero_device_t,chr_file,ioctl).
access_vector(allow,sysadm_ssh_t,zero_device_t,chr_file,read).
access_vector(allow,sysadm_ssh_t,zero_device_t,chr_file,getattr).
access_vector(allow,sysadm_ssh_t,zero_device_t,chr_file,lock).
access_vector(allow,sysadm_ssh_t,zero_device_t,chr_file,write).
access_vector(allow,sysadm_ssh_t,zero_device_t,chr_file,append).
access_vector(allow,sysadm_ssh_t,self,udp_socket,create).
access_vector(allow,sysadm_ssh_t,self,udp_socket,ioctl).
access_vector(allow,sysadm_ssh_t,self,udp_socket,read).
access_vector(allow,sysadm_ssh_t,self,udp_socket,getattr).
access_vector(allow,sysadm_ssh_t,self,udp_socket,write).
access_vector(allow,sysadm_ssh_t,self,udp_socket,setattr).
access_vector(allow,sysadm_ssh_t,self,udp_socket,append).
access_vector(allow,sysadm_ssh_t,self,udp_socket,bind).
access_vector(allow,sysadm_ssh_t,self,udp_socket,connect).
access_vector(allow,sysadm_ssh_t,self,udp_socket,getopt).
access_vector(allow,sysadm_ssh_t,self,udp_socket,setopt).
access_vector(allow,sysadm_ssh_t,self,udp_socket,shutdown).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,create).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,ioctl).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,read).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,getattr).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,write).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,setattr).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,append).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,bind).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,connect).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,getopt).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,setopt).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,shutdown).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,listen).
access_vector(allow,sysadm_ssh_t,self,tcp_socket,accept).
access_vector(allow,sysadm_ssh_t,any_socket_t,udp_socket,sendto).
access_vector(allow,sysadm_ssh_t,netif_type,netif,tcp_send).
access_vector(allow,sysadm_ssh_t,netif_type,netif,udp_send).
access_vector(allow,sysadm_ssh_t,netif_type,netif,rawip_send).
access_vector(allow,sysadm_ssh_t,netif_type,netif,tcp_recv).
access_vector(allow,sysadm_ssh_t,netif_type,netif,udp_recv).
access_vector(allow,sysadm_ssh_t,netif_type,netif,rawip_recv).
access_vector(allow,sysadm_ssh_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,sysadm_ssh_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,sysadm_ssh_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,sysadm_ssh_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,sysadm_ssh_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,sysadm_ssh_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,sysadm_ssh_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,sysadm_ssh_t,node_type,node,tcp_send).
access_vector(allow,sysadm_ssh_t,node_type,node,udp_send).
access_vector(allow,sysadm_ssh_t,node_type,node,rawip_send).
access_vector(allow,sysadm_ssh_t,node_type,node,tcp_recv).
access_vector(allow,sysadm_ssh_t,node_type,node,udp_recv).
access_vector(allow,sysadm_ssh_t,node_type,node,rawip_recv).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,ioctl).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,read).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,getattr).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,write).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,setattr).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,append).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,bind).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,connect).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,getopt).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,setopt).
access_vector(allow,sysadm_ssh_t,mount_t,udp_socket,shutdown).
access_vector(allow,sysadm_ssh_t,port_t,udp_socket,name_bind).
access_vector(allow,sysadm_ssh_t,port_t,tcp_socket,name_bind).
access_vector(allow,sysadm_ssh_t,sysadm_ssh_t,tcp_socket,connectto).
access_vector(allow,sysadm_ssh_t,sysadm_ssh_t,tcp_socket,recvfrom).
access_vector(allow,sysadm_ssh_t,sysadm_ssh_t,tcp_socket,acceptfrom).
access_vector(allow,sysadm_ssh_t,self,capability,setuid).
access_vector(allow,sysadm_ssh_t,self,capability,setgid).
access_vector(allow,sysadm_ssh_t,self,capability,dac_override).
access_vector(allow,sysadm_ssh_t,self,capability,dac_read_search).
access_vector(allow,sysadm_ssh_t,bin_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,bin_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,sbin_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,sbin_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,etc_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_ssh_t,device_t,dir,search).
access_vector(allow,sysadm_ssh_t,etc_t,file,read).
access_vector(allow,sysadm_ssh_t,etc_t,file,getattr).
access_vector(allow,sysadm_ssh_t,etc_t,file,lock).
access_vector(allow,sysadm_ssh_t,etc_t,file,execute).
access_vector(allow,sysadm_ssh_t,etc_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,etc_t,file,execute_no_trans).
access_vector(allow,sysadm_ssh_t,lib_t,file,read).
access_vector(allow,sysadm_ssh_t,lib_t,file,getattr).
access_vector(allow,sysadm_ssh_t,lib_t,file,lock).
access_vector(allow,sysadm_ssh_t,lib_t,file,execute).
access_vector(allow,sysadm_ssh_t,lib_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,lib_t,file,execute_no_trans).
access_vector(allow,sysadm_ssh_t,bin_t,file,read).
access_vector(allow,sysadm_ssh_t,bin_t,file,getattr).
access_vector(allow,sysadm_ssh_t,bin_t,file,lock).
access_vector(allow,sysadm_ssh_t,bin_t,file,execute).
access_vector(allow,sysadm_ssh_t,bin_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,bin_t,file,execute_no_trans).
access_vector(allow,sysadm_ssh_t,sbin_t,file,read).
access_vector(allow,sysadm_ssh_t,sbin_t,file,getattr).
access_vector(allow,sysadm_ssh_t,sbin_t,file,lock).
access_vector(allow,sysadm_ssh_t,sbin_t,file,execute).
access_vector(allow,sysadm_ssh_t,sbin_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,sbin_t,file,execute_no_trans).
access_vector(allow,sysadm_ssh_t,exec_type,file,read).
access_vector(allow,sysadm_ssh_t,exec_type,file,getattr).
access_vector(allow,sysadm_ssh_t,exec_type,file,lock).
access_vector(allow,sysadm_ssh_t,exec_type,file,execute).
access_vector(allow,sysadm_ssh_t,exec_type,file,ioctl).
access_vector(allow,sysadm_ssh_t,exec_type,file,execute_no_trans).
access_vector(allow,sysadm_ssh_t,sshd_key_t,file,read).
access_vector(allow,sysadm_ssh_t,sshd_key_t,file,getattr).
access_vector(allow,sysadm_ssh_t,sshd_key_t,file,lock).
access_vector(allow,sysadm_ssh_t,sshd_key_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,tmp_t,dir,read).
access_vector(allow,sysadm_ssh_t,tmp_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,tmp_t,dir,lock).
access_vector(allow,sysadm_ssh_t,tmp_t,dir,search).
access_vector(allow,sysadm_ssh_t,tmp_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,tmp_t,dir,add_name).
access_vector(allow,sysadm_ssh_t,tmp_t,dir,remove_name).
access_vector(allow,sysadm_ssh_t,tmp_t,dir,write).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,create).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,read).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,getattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,lock).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,write).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,setattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,append).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,link).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,unlink).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,file,rename).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,create).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,write).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,setattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,append).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,link).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,unlink).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,lnk_file,rename).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,create).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,write).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,setattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,append).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,link).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,unlink).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,sock_file,rename).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,create).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,write).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,setattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,append).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,link).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,unlink).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,fifo_file,rename).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,create).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,read).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,lock).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,setattr).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,link).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,unlink).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,rename).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,search).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,add_name).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,remove_name).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,reparent).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,write).
access_vector(allow,sysadm_ssh_t,sshd_tmp_t,dir,rmdir).
type_trans(sysadm_ssh_t,tmp_t,dir,sshd_tmp_t).
type_trans(sysadm_ssh_t,tmp_t,[file,lnk_file,sock_file,fifo_file],sshd_tmp_t).
access_vector(allow,sysadm_ssh_t,sysadm_tmp_t,dir,read).
access_vector(allow,sysadm_ssh_t,sysadm_tmp_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_tmp_t,dir,lock).
access_vector(allow,sysadm_ssh_t,sysadm_tmp_t,dir,search).
access_vector(allow,sysadm_ssh_t,sysadm_tmp_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,read).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,write).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,setattr).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,append).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,bind).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,connect).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,getopt).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,setopt).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,shutdown).
type_decl(sysadm_home_ssh_t,[],[file_type,sysadmfile]).
access_vector(allow,sysadm_ssh_t,sysadm_home_dir_t,dir,read).
access_vector(allow,sysadm_ssh_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_dir_t,dir,lock).
access_vector(allow,sysadm_ssh_t,sysadm_home_dir_t,dir,search).
access_vector(allow,sysadm_ssh_t,sysadm_home_dir_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_home_dir_t,dir,add_name).
access_vector(allow,sysadm_ssh_t,sysadm_home_dir_t,dir,remove_name).
access_vector(allow,sysadm_ssh_t,sysadm_home_dir_t,dir,write).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,create).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,read).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,lock).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,write).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,setattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,append).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,link).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,unlink).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,file,rename).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,create).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,write).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,setattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,append).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,link).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,unlink).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,rename).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,create).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,write).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,setattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,append).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,link).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,unlink).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,sock_file,rename).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,create).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,write).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,setattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,append).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,link).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,unlink).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,fifo_file,rename).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,create).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,read).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,lock).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,setattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,link).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,unlink).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,rename).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,search).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,add_name).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,remove_name).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,reparent).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,write).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,dir,rmdir).
type_trans([sysadm_ssh_t,sysadm_ssh_t],sysadm_home_dir_t,dir,sysadm_home_ssh_t).
type_trans([sysadm_ssh_t,sysadm_ssh_t],sysadm_home_dir_t,[file,lnk_file,sock_file,fifo_file],sysadm_home_ssh_t).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_home_ssh_t,lnk_file,read).
access_vector(dontaudit,sysadm_ssh_t,sysadm_home_t,dir,search).
access_vector(allow,sshd_t,sysadm_home_ssh_t,dir,read).
access_vector(allow,sshd_t,sysadm_home_ssh_t,dir,getattr).
access_vector(allow,sshd_t,sysadm_home_ssh_t,dir,lock).
access_vector(allow,sshd_t,sysadm_home_ssh_t,dir,search).
access_vector(allow,sshd_t,sysadm_home_ssh_t,dir,ioctl).
access_vector(allow,sshd_t,sysadm_home_ssh_t,file,read).
access_vector(allow,sshd_t,sysadm_home_ssh_t,file,getattr).
access_vector(allow,sshd_t,sysadm_home_ssh_t,file,lock).
access_vector(allow,sshd_t,sysadm_home_ssh_t,file,ioctl).
access_vector(allow,sshd_t,sysadm_home_ssh_t,lnk_file,read).
access_vector(allow,sshd_t,sysadm_home_ssh_t,lnk_file,getattr).
access_vector(allow,sshd_t,sysadm_home_ssh_t,lnk_file,lock).
access_vector(allow,sshd_t,sysadm_home_ssh_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,dir,read).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,dir,getattr).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,dir,lock).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,dir,search).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,dir,ioctl).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,dir,add_name).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,dir,remove_name).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,dir,write).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,create).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,ioctl).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,read).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,getattr).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,lock).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,write).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,setattr).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,append).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,link).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,unlink).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,file,rename).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,create).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,read).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,lock).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,write).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,setattr).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,append).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,link).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,unlink).
access_vector(allow,sysadm_t,sysadm_home_ssh_t,lnk_file,rename).
access_vector(dontaudit,sysadm_ssh_t,proc_t,dir,search).
access_vector(allow,sysadm_ssh_t,sshd_t,tcp_socket,connectto).
access_vector(allow,sysadm_ssh_t,sshd_t,tcp_socket,recvfrom).
access_vector(allow,sshd_t,sysadm_ssh_t,tcp_socket,acceptfrom).
access_vector(allow,sshd_t,sysadm_ssh_t,tcp_socket,recvfrom).
access_vector(allow,sysadm_ssh_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,sysadm_ssh_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,sysadm_ssh_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,sysadm_ssh_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,sysadm_ssh_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,sysadm_ssh_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,sysadm_ssh_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,sysadm_ssh_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,sysadm_ssh_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,sysadm_t,sysadm_ssh_t,process,signal).
access_vector(allow,sysadm_t,sysadm_ssh_t,dir,search).
access_vector(allow,sysadm_t,sysadm_ssh_t,dir,getattr).
access_vector(allow,sysadm_t,sysadm_ssh_t,dir,read).
access_vector(allow,sysadm_t,sysadm_ssh_t,file,read).
access_vector(allow,sysadm_t,sysadm_ssh_t,file,getattr).
access_vector(allow,sysadm_t,sysadm_ssh_t,lnk_file,read).
access_vector(allow,sysadm_t,sysadm_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,sysadm_tmp_t,sock_file,write).
access_vector(allow,sysadm_ssh_t,sysadm_t,unix_stream_socket,connectto).
access_vector(allow,sysadm_ssh_t,sshd_t,unix_stream_socket,connectto).
type_decl(sysadm_crond_t,[],[domain,user_crond_domain]).
access_vector(allow,crond_t,sysadm_crond_t,process,transition).
access_vector(dontaudit,crond_t,sysadm_crond_t,process,noatsecure).
access_vector(allow,crond_t,shell_exec_t,file,read).
access_vector(allow,crond_t,shell_exec_t,file,getattr).
access_vector(allow,crond_t,shell_exec_t,file,execute).
access_vector(allow,sysadm_crond_t,crond_t,process,sigchld).
access_vector(allow,sysadm_crond_t,crond_t,fd,use).
access_vector(allow,crond_t,sysadm_crond_t,fd,use).
access_vector(allow,sysadm_crond_t,crond_t,fifo_file,ioctl).
access_vector(allow,sysadm_crond_t,crond_t,fifo_file,read).
access_vector(allow,sysadm_crond_t,crond_t,fifo_file,getattr).
access_vector(allow,sysadm_crond_t,crond_t,fifo_file,lock).
access_vector(allow,sysadm_crond_t,crond_t,fifo_file,write).
access_vector(allow,sysadm_crond_t,crond_t,fifo_file,append).
access_vector(allow,sysadm_crond_t,shell_exec_t,file,read).
access_vector(allow,sysadm_crond_t,shell_exec_t,file,getattr).
access_vector(allow,sysadm_crond_t,shell_exec_t,file,lock).
access_vector(allow,sysadm_crond_t,shell_exec_t,file,execute).
access_vector(allow,sysadm_crond_t,shell_exec_t,file,ioctl).
access_vector(allow,sysadm_crond_t,shell_exec_t,file,entrypoint).
role_decl(sysadm_r,sysadm_crond_t).
access_vector(allow,sysadm_crond_t,self,udp_socket,create).
access_vector(allow,sysadm_crond_t,self,udp_socket,ioctl).
access_vector(allow,sysadm_crond_t,self,udp_socket,read).
access_vector(allow,sysadm_crond_t,self,udp_socket,getattr).
access_vector(allow,sysadm_crond_t,self,udp_socket,write).
access_vector(allow,sysadm_crond_t,self,udp_socket,setattr).
access_vector(allow,sysadm_crond_t,self,udp_socket,append).
access_vector(allow,sysadm_crond_t,self,udp_socket,bind).
access_vector(allow,sysadm_crond_t,self,udp_socket,connect).
access_vector(allow,sysadm_crond_t,self,udp_socket,getopt).
access_vector(allow,sysadm_crond_t,self,udp_socket,setopt).
access_vector(allow,sysadm_crond_t,self,udp_socket,shutdown).
access_vector(allow,sysadm_crond_t,self,tcp_socket,create).
access_vector(allow,sysadm_crond_t,self,tcp_socket,ioctl).
access_vector(allow,sysadm_crond_t,self,tcp_socket,read).
access_vector(allow,sysadm_crond_t,self,tcp_socket,getattr).
access_vector(allow,sysadm_crond_t,self,tcp_socket,write).
access_vector(allow,sysadm_crond_t,self,tcp_socket,setattr).
access_vector(allow,sysadm_crond_t,self,tcp_socket,append).
access_vector(allow,sysadm_crond_t,self,tcp_socket,bind).
access_vector(allow,sysadm_crond_t,self,tcp_socket,connect).
access_vector(allow,sysadm_crond_t,self,tcp_socket,getopt).
access_vector(allow,sysadm_crond_t,self,tcp_socket,setopt).
access_vector(allow,sysadm_crond_t,self,tcp_socket,shutdown).
access_vector(allow,sysadm_crond_t,self,tcp_socket,listen).
access_vector(allow,sysadm_crond_t,self,tcp_socket,accept).
access_vector(allow,sysadm_crond_t,any_socket_t,udp_socket,sendto).
access_vector(allow,sysadm_crond_t,netif_type,netif,tcp_send).
access_vector(allow,sysadm_crond_t,netif_type,netif,udp_send).
access_vector(allow,sysadm_crond_t,netif_type,netif,rawip_send).
access_vector(allow,sysadm_crond_t,netif_type,netif,tcp_recv).
access_vector(allow,sysadm_crond_t,netif_type,netif,udp_recv).
access_vector(allow,sysadm_crond_t,netif_type,netif,rawip_recv).
access_vector(allow,sysadm_crond_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,sysadm_crond_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,sysadm_crond_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,sysadm_crond_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,sysadm_crond_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,sysadm_crond_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,sysadm_crond_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,sysadm_crond_t,node_type,node,tcp_send).
access_vector(allow,sysadm_crond_t,node_type,node,udp_send).
access_vector(allow,sysadm_crond_t,node_type,node,rawip_send).
access_vector(allow,sysadm_crond_t,node_type,node,tcp_recv).
access_vector(allow,sysadm_crond_t,node_type,node,udp_recv).
access_vector(allow,sysadm_crond_t,node_type,node,rawip_recv).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,ioctl).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,read).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,getattr).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,write).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,setattr).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,append).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,bind).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,connect).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,getopt).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,setopt).
access_vector(allow,sysadm_crond_t,mount_t,udp_socket,shutdown).
access_vector(allow,sysadm_crond_t,port_t,udp_socket,name_bind).
access_vector(allow,sysadm_crond_t,port_t,tcp_socket,name_bind).
access_vector(allow,sysadm_crond_t,resolv_conf_t,file,getattr).
access_vector(allow,sysadm_crond_t,resolv_conf_t,file,read).
access_vector(allow,sysadm_crond_t,root_t,dir,read).
access_vector(allow,sysadm_crond_t,root_t,dir,getattr).
access_vector(allow,sysadm_crond_t,root_t,dir,lock).
access_vector(allow,sysadm_crond_t,root_t,dir,search).
access_vector(allow,sysadm_crond_t,root_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,usr_t,dir,read).
access_vector(allow,sysadm_crond_t,usr_t,dir,getattr).
access_vector(allow,sysadm_crond_t,usr_t,dir,lock).
access_vector(allow,sysadm_crond_t,usr_t,dir,search).
access_vector(allow,sysadm_crond_t,usr_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,lib_t,dir,read).
access_vector(allow,sysadm_crond_t,lib_t,dir,getattr).
access_vector(allow,sysadm_crond_t,lib_t,dir,lock).
access_vector(allow,sysadm_crond_t,lib_t,dir,search).
access_vector(allow,sysadm_crond_t,lib_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,etc_t,dir,read).
access_vector(allow,sysadm_crond_t,etc_t,dir,getattr).
access_vector(allow,sysadm_crond_t,etc_t,dir,lock).
access_vector(allow,sysadm_crond_t,etc_t,dir,search).
access_vector(allow,sysadm_crond_t,etc_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,lib_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,lib_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,lib_t,lnk_file,lock).
access_vector(allow,sysadm_crond_t,lib_t,lnk_file,ioctl).
access_vector(allow,sysadm_crond_t,ld_so_t,file,read).
access_vector(allow,sysadm_crond_t,ld_so_t,file,getattr).
access_vector(allow,sysadm_crond_t,ld_so_t,file,lock).
access_vector(allow,sysadm_crond_t,ld_so_t,file,execute).
access_vector(allow,sysadm_crond_t,ld_so_t,file,ioctl).
access_vector(allow,sysadm_crond_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_crond_t,ld_so_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,ld_so_t,lnk_file,lock).
access_vector(allow,sysadm_crond_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sysadm_crond_t,shlib_t,file,read).
access_vector(allow,sysadm_crond_t,shlib_t,file,getattr).
access_vector(allow,sysadm_crond_t,shlib_t,file,lock).
access_vector(allow,sysadm_crond_t,shlib_t,file,execute).
access_vector(allow,sysadm_crond_t,shlib_t,file,ioctl).
access_vector(allow,sysadm_crond_t,shlib_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,shlib_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,shlib_t,lnk_file,lock).
access_vector(allow,sysadm_crond_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sysadm_crond_t,ld_so_cache_t,file,read).
access_vector(allow,sysadm_crond_t,ld_so_cache_t,file,getattr).
access_vector(allow,sysadm_crond_t,ld_so_cache_t,file,lock).
access_vector(allow,sysadm_crond_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sysadm_crond_t,device_t,dir,search).
access_vector(allow,sysadm_crond_t,null_device_t,chr_file,ioctl).
access_vector(allow,sysadm_crond_t,null_device_t,chr_file,read).
access_vector(allow,sysadm_crond_t,null_device_t,chr_file,getattr).
access_vector(allow,sysadm_crond_t,null_device_t,chr_file,lock).
access_vector(allow,sysadm_crond_t,null_device_t,chr_file,write).
access_vector(allow,sysadm_crond_t,null_device_t,chr_file,append).
access_vector(allow,sysadm_crond_t,self,dir,read).
access_vector(allow,sysadm_crond_t,self,dir,getattr).
access_vector(allow,sysadm_crond_t,self,dir,lock).
access_vector(allow,sysadm_crond_t,self,dir,search).
access_vector(allow,sysadm_crond_t,self,dir,ioctl).
access_vector(allow,sysadm_crond_t,self,file,read).
access_vector(allow,sysadm_crond_t,self,file,getattr).
access_vector(allow,sysadm_crond_t,self,file,lock).
access_vector(allow,sysadm_crond_t,self,file,ioctl).
access_vector(allow,sysadm_crond_t,self,lnk_file,read).
access_vector(allow,sysadm_crond_t,self,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,self,lnk_file,lock).
access_vector(allow,sysadm_crond_t,self,lnk_file,ioctl).
access_vector(allow,sysadm_crond_t,self,fifo_file,ioctl).
access_vector(allow,sysadm_crond_t,self,fifo_file,read).
access_vector(allow,sysadm_crond_t,self,fifo_file,getattr).
access_vector(allow,sysadm_crond_t,self,fifo_file,lock).
access_vector(allow,sysadm_crond_t,self,fifo_file,write).
access_vector(allow,sysadm_crond_t,self,fifo_file,append).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,create).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,ioctl).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,read).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,getattr).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,write).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,setattr).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,append).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,bind).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,connect).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,getopt).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,setopt).
access_vector(allow,sysadm_crond_t,self,unix_stream_socket,shutdown).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,create).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,ioctl).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,read).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,getattr).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,write).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,setattr).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,append).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,bind).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,connect).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,getopt).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,setopt).
access_vector(allow,sysadm_crond_t,self,unix_dgram_socket,shutdown).
access_vector(allow,sysadm_crond_t,etc_runtime_t,file,getattr).
access_vector(allow,sysadm_crond_t,etc_runtime_t,file,read).
access_vector(allow,sysadm_crond_t,self,process,fork).
access_vector(allow,sysadm_crond_t,self,process,sigchld).
access_vector(allow,sysadm_crond_t,self,process,sigkill).
access_vector(allow,sysadm_crond_t,self,process,sigstop).
access_vector(allow,sysadm_crond_t,self,process,signull).
access_vector(allow,sysadm_crond_t,self,process,signal).
access_vector(allow,sysadm_crond_t,proc_t,dir,getattr).
access_vector(allow,sysadm_crond_t,proc_t,dir,search).
access_vector(allow,sysadm_crond_t,proc_t,dir,read).
access_vector(allow,sysadm_crond_t,proc_t,file,getattr).
access_vector(allow,sysadm_crond_t,proc_t,file,read).
access_vector(allow,sysadm_crond_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,locale_t,dir,read).
access_vector(allow,sysadm_crond_t,locale_t,dir,getattr).
access_vector(allow,sysadm_crond_t,locale_t,dir,lock).
access_vector(allow,sysadm_crond_t,locale_t,dir,search).
access_vector(allow,sysadm_crond_t,locale_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,locale_t,file,read).
access_vector(allow,sysadm_crond_t,locale_t,file,getattr).
access_vector(allow,sysadm_crond_t,locale_t,file,lock).
access_vector(allow,sysadm_crond_t,locale_t,file,ioctl).
access_vector(allow,sysadm_crond_t,locale_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,locale_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,locale_t,lnk_file,lock).
access_vector(allow,sysadm_crond_t,locale_t,lnk_file,ioctl).
access_vector(allow,sysadm_crond_t,sysctl_kernel_t,dir,search).
access_vector(allow,sysadm_crond_t,sysctl_kernel_t,file,getattr).
access_vector(allow,sysadm_crond_t,sysctl_kernel_t,file,read).
access_vector(allow,sysadm_crond_t,var_spool_t,dir,search).
access_vector(allow,sysadm_crond_t,fs_t,filesystem,getattr).
access_vector(allow,sysadm_crond_t,devtty_t,chr_file,read).
access_vector(allow,sysadm_crond_t,devtty_t,chr_file,write).
access_vector(allow,sysadm_crond_t,sysadm_crond_t,capability,dac_override).
access_vector(allow,sysadm_crond_t,initrc_t,fd,use).
access_vector(allow,sysadm_crond_t,sysadm_cron_spool_t,file,entrypoint).
access_vector(allow,sysadm_crond_t,home_root_t,dir,search).
access_vector(allow,sysadm_crond_t,sysadm_home_dir_t,dir,read).
access_vector(allow,sysadm_crond_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,sysadm_crond_t,sysadm_home_dir_t,dir,lock).
access_vector(allow,sysadm_crond_t,sysadm_home_dir_t,dir,search).
access_vector(allow,sysadm_crond_t,sysadm_home_dir_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_home_dir_t,dir,add_name).
access_vector(allow,sysadm_crond_t,sysadm_home_dir_t,dir,remove_name).
access_vector(allow,sysadm_crond_t,sysadm_home_dir_t,dir,write).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,create).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,read).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,lock).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,write).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,setattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,append).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,link).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,unlink).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,rename).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,create).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,lock).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,write).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,setattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,append).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,link).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,unlink).
access_vector(allow,sysadm_crond_t,sysadm_home_t,lnk_file,rename).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,create).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,read).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,lock).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,write).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,setattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,append).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,link).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,unlink).
access_vector(allow,sysadm_crond_t,sysadm_home_t,sock_file,rename).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,create).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,read).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,lock).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,write).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,setattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,append).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,link).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,unlink).
access_vector(allow,sysadm_crond_t,sysadm_home_t,fifo_file,rename).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,create).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,read).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,getattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,lock).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,setattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,link).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,unlink).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,rename).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,search).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,add_name).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,remove_name).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,reparent).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,write).
access_vector(allow,sysadm_crond_t,sysadm_home_t,dir,rmdir).
type_trans(sysadm_crond_t,sysadm_home_dir_t,dir,sysadm_home_t).
type_trans(sysadm_crond_t,sysadm_home_dir_t,[file,lnk_file,sock_file,fifo_file],sysadm_home_t).
access_vector(allow,sysadm_crond_t,tmp_t,dir,read).
access_vector(allow,sysadm_crond_t,tmp_t,dir,getattr).
access_vector(allow,sysadm_crond_t,tmp_t,dir,lock).
access_vector(allow,sysadm_crond_t,tmp_t,dir,search).
access_vector(allow,sysadm_crond_t,tmp_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,tmp_t,dir,add_name).
access_vector(allow,sysadm_crond_t,tmp_t,dir,remove_name).
access_vector(allow,sysadm_crond_t,tmp_t,dir,write).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,create).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,read).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,lock).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,write).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,setattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,append).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,link).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,unlink).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,file,rename).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,create).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,lock).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,write).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,setattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,append).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,link).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,unlink).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,lnk_file,rename).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,create).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,read).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,lock).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,write).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,setattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,append).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,link).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,unlink).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,sock_file,rename).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,create).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,read).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,lock).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,write).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,setattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,append).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,link).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,unlink).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,fifo_file,rename).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,create).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,read).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,getattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,lock).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,setattr).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,link).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,unlink).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,rename).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,search).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,add_name).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,remove_name).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,reparent).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,write).
access_vector(allow,sysadm_crond_t,sysadm_tmp_t,dir,rmdir).
type_trans(sysadm_crond_t,tmp_t,dir,sysadm_tmp_t).
type_trans(sysadm_crond_t,tmp_t,[file,lnk_file,sock_file,fifo_file],sysadm_tmp_t).
access_vector(allow,sysadm_crond_t,bin_t,dir,read).
access_vector(allow,sysadm_crond_t,bin_t,dir,getattr).
access_vector(allow,sysadm_crond_t,bin_t,dir,lock).
access_vector(allow,sysadm_crond_t,bin_t,dir,search).
access_vector(allow,sysadm_crond_t,bin_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,sbin_t,dir,read).
access_vector(allow,sysadm_crond_t,sbin_t,dir,getattr).
access_vector(allow,sysadm_crond_t,sbin_t,dir,lock).
access_vector(allow,sysadm_crond_t,sbin_t,dir,search).
access_vector(allow,sysadm_crond_t,sbin_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,bin_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,bin_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,sbin_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,sbin_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,etc_t,lnk_file,getattr).
access_vector(allow,sysadm_crond_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_crond_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_crond_t,device_t,dir,search).
access_vector(allow,sysadm_crond_t,etc_t,file,read).
access_vector(allow,sysadm_crond_t,etc_t,file,getattr).
access_vector(allow,sysadm_crond_t,etc_t,file,lock).
access_vector(allow,sysadm_crond_t,etc_t,file,execute).
access_vector(allow,sysadm_crond_t,etc_t,file,ioctl).
access_vector(allow,sysadm_crond_t,etc_t,file,execute_no_trans).
access_vector(allow,sysadm_crond_t,lib_t,file,read).
access_vector(allow,sysadm_crond_t,lib_t,file,getattr).
access_vector(allow,sysadm_crond_t,lib_t,file,lock).
access_vector(allow,sysadm_crond_t,lib_t,file,execute).
access_vector(allow,sysadm_crond_t,lib_t,file,ioctl).
access_vector(allow,sysadm_crond_t,lib_t,file,execute_no_trans).
access_vector(allow,sysadm_crond_t,bin_t,file,read).
access_vector(allow,sysadm_crond_t,bin_t,file,getattr).
access_vector(allow,sysadm_crond_t,bin_t,file,lock).
access_vector(allow,sysadm_crond_t,bin_t,file,execute).
access_vector(allow,sysadm_crond_t,bin_t,file,ioctl).
access_vector(allow,sysadm_crond_t,bin_t,file,execute_no_trans).
access_vector(allow,sysadm_crond_t,sbin_t,file,read).
access_vector(allow,sysadm_crond_t,sbin_t,file,getattr).
access_vector(allow,sysadm_crond_t,sbin_t,file,lock).
access_vector(allow,sysadm_crond_t,sbin_t,file,execute).
access_vector(allow,sysadm_crond_t,sbin_t,file,ioctl).
access_vector(allow,sysadm_crond_t,sbin_t,file,execute_no_trans).
access_vector(allow,sysadm_crond_t,exec_type,file,read).
access_vector(allow,sysadm_crond_t,exec_type,file,getattr).
access_vector(allow,sysadm_crond_t,exec_type,file,lock).
access_vector(allow,sysadm_crond_t,exec_type,file,execute).
access_vector(allow,sysadm_crond_t,exec_type,file,ioctl).
access_vector(allow,sysadm_crond_t,exec_type,file,execute_no_trans).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,read).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,getattr).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,lock).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,execute).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,ioctl).
access_vector(allow,sysadm_crond_t,sysadm_home_t,file,execute_no_trans).
access_vector(dontaudit,sysadm_crond_t,boot_t,dir,search).
access_vector(dontaudit,sysadm_crond_t,domain,dir,getattr).
access_vector(allow,sysadm_t,mouse_device_t,chr_file,read).
access_vector(allow,sysadm_t,mouse_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,mouse_device_t,chr_file,lock).
access_vector(allow,sysadm_t,mouse_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,misc_device_t,file,ioctl).
access_vector(allow,sysadm_t,misc_device_t,file,read).
access_vector(allow,sysadm_t,misc_device_t,file,getattr).
access_vector(allow,sysadm_t,misc_device_t,file,lock).
access_vector(allow,sysadm_t,misc_device_t,file,write).
access_vector(allow,sysadm_t,misc_device_t,file,append).
access_vector(allow,sysadm_t,misc_device_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,misc_device_t,lnk_file,read).
access_vector(allow,sysadm_t,misc_device_t,lnk_file,getattr).
access_vector(allow,sysadm_t,misc_device_t,lnk_file,lock).
access_vector(allow,sysadm_t,misc_device_t,lnk_file,write).
access_vector(allow,sysadm_t,misc_device_t,lnk_file,append).
access_vector(allow,sysadm_t,misc_device_t,sock_file,ioctl).
access_vector(allow,sysadm_t,misc_device_t,sock_file,read).
access_vector(allow,sysadm_t,misc_device_t,sock_file,getattr).
access_vector(allow,sysadm_t,misc_device_t,sock_file,lock).
access_vector(allow,sysadm_t,misc_device_t,sock_file,write).
access_vector(allow,sysadm_t,misc_device_t,sock_file,append).
access_vector(allow,sysadm_t,misc_device_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,misc_device_t,fifo_file,read).
access_vector(allow,sysadm_t,misc_device_t,fifo_file,getattr).
access_vector(allow,sysadm_t,misc_device_t,fifo_file,lock).
access_vector(allow,sysadm_t,misc_device_t,fifo_file,write).
access_vector(allow,sysadm_t,misc_device_t,fifo_file,append).
access_vector(allow,sysadm_t,misc_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,misc_device_t,chr_file,read).
access_vector(allow,sysadm_t,misc_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,misc_device_t,chr_file,lock).
access_vector(allow,sysadm_t,misc_device_t,chr_file,write).
access_vector(allow,sysadm_t,misc_device_t,chr_file,append).
access_vector(allow,sysadm_t,misc_device_t,blk_file,ioctl).
access_vector(allow,sysadm_t,misc_device_t,blk_file,read).
access_vector(allow,sysadm_t,misc_device_t,blk_file,getattr).
access_vector(allow,sysadm_t,misc_device_t,blk_file,lock).
access_vector(allow,sysadm_t,misc_device_t,blk_file,write).
access_vector(allow,sysadm_t,misc_device_t,blk_file,append).
access_vector(allow,sysadm_t,self,udp_socket,create).
access_vector(allow,sysadm_t,self,udp_socket,ioctl).
access_vector(allow,sysadm_t,self,udp_socket,read).
access_vector(allow,sysadm_t,self,udp_socket,getattr).
access_vector(allow,sysadm_t,self,udp_socket,write).
access_vector(allow,sysadm_t,self,udp_socket,setattr).
access_vector(allow,sysadm_t,self,udp_socket,append).
access_vector(allow,sysadm_t,self,udp_socket,bind).
access_vector(allow,sysadm_t,self,udp_socket,connect).
access_vector(allow,sysadm_t,self,udp_socket,getopt).
access_vector(allow,sysadm_t,self,udp_socket,setopt).
access_vector(allow,sysadm_t,self,udp_socket,shutdown).
access_vector(allow,sysadm_t,self,tcp_socket,create).
access_vector(allow,sysadm_t,self,tcp_socket,ioctl).
access_vector(allow,sysadm_t,self,tcp_socket,read).
access_vector(allow,sysadm_t,self,tcp_socket,getattr).
access_vector(allow,sysadm_t,self,tcp_socket,write).
access_vector(allow,sysadm_t,self,tcp_socket,setattr).
access_vector(allow,sysadm_t,self,tcp_socket,append).
access_vector(allow,sysadm_t,self,tcp_socket,bind).
access_vector(allow,sysadm_t,self,tcp_socket,connect).
access_vector(allow,sysadm_t,self,tcp_socket,getopt).
access_vector(allow,sysadm_t,self,tcp_socket,setopt).
access_vector(allow,sysadm_t,self,tcp_socket,shutdown).
access_vector(allow,sysadm_t,self,tcp_socket,listen).
access_vector(allow,sysadm_t,self,tcp_socket,accept).
access_vector(allow,sysadm_t,any_socket_t,udp_socket,sendto).
access_vector(allow,sysadm_t,netif_type,netif,tcp_send).
access_vector(allow,sysadm_t,netif_type,netif,udp_send).
access_vector(allow,sysadm_t,netif_type,netif,rawip_send).
access_vector(allow,sysadm_t,netif_type,netif,tcp_recv).
access_vector(allow,sysadm_t,netif_type,netif,udp_recv).
access_vector(allow,sysadm_t,netif_type,netif,rawip_recv).
access_vector(allow,sysadm_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,sysadm_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,sysadm_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,sysadm_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,sysadm_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,sysadm_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,sysadm_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,sysadm_t,node_type,node,tcp_send).
access_vector(allow,sysadm_t,node_type,node,udp_send).
access_vector(allow,sysadm_t,node_type,node,rawip_send).
access_vector(allow,sysadm_t,node_type,node,tcp_recv).
access_vector(allow,sysadm_t,node_type,node,udp_recv).
access_vector(allow,sysadm_t,node_type,node,rawip_recv).
access_vector(allow,sysadm_t,mount_t,udp_socket,ioctl).
access_vector(allow,sysadm_t,mount_t,udp_socket,read).
access_vector(allow,sysadm_t,mount_t,udp_socket,getattr).
access_vector(allow,sysadm_t,mount_t,udp_socket,write).
access_vector(allow,sysadm_t,mount_t,udp_socket,setattr).
access_vector(allow,sysadm_t,mount_t,udp_socket,append).
access_vector(allow,sysadm_t,mount_t,udp_socket,bind).
access_vector(allow,sysadm_t,mount_t,udp_socket,connect).
access_vector(allow,sysadm_t,mount_t,udp_socket,getopt).
access_vector(allow,sysadm_t,mount_t,udp_socket,setopt).
access_vector(allow,sysadm_t,mount_t,udp_socket,shutdown).
access_vector(allow,sysadm_t,port_t,udp_socket,name_bind).
access_vector(allow,sysadm_t,port_t,tcp_socket,name_bind).
access_vector(allow,sysadm_t,resolv_conf_t,file,getattr).
access_vector(allow,sysadm_t,resolv_conf_t,file,read).
access_vector(dontaudit,sysadm_t,resolv_conf_t,file,ioctl).
access_vector(allow,sysadm_t,node_lo_t,node,enforce_dest).
access_vector(allow,sysadm_t,sysadm_t,udp_socket,sendto).
access_vector(allow,sysadm_t,sysadm_t,udp_socket,recvfrom).
access_vector(allow,sysadm_t,sysadm_t,tcp_socket,connectto).
access_vector(allow,sysadm_t,sysadm_t,tcp_socket,recvfrom).
access_vector(allow,sysadm_t,sysadm_t,tcp_socket,acceptfrom).
access_vector(dontaudit,sysadm_t,kernel_t,system,syslog_read).
access_vector(allow,sysadm_t,kernel_t,system,ipc_info).
access_vector(dontaudit,sysadm_t,domain,dir,read).
access_vector(dontaudit,sysadm_t,domain,dir,getattr).
access_vector(dontaudit,sysadm_t,domain,dir,lock).
access_vector(dontaudit,sysadm_t,domain,dir,search).
access_vector(dontaudit,sysadm_t,domain,dir,ioctl).
access_vector(dontaudit,sysadm_t,domain,file,read).
access_vector(dontaudit,sysadm_t,domain,file,getattr).
access_vector(dontaudit,sysadm_t,domain,file,lock).
access_vector(dontaudit,sysadm_t,domain,file,ioctl).
access_vector(dontaudit,sysadm_t,domain,lnk_file,read).
access_vector(dontaudit,sysadm_t,domain,lnk_file,getattr).
access_vector(dontaudit,sysadm_t,domain,lnk_file,lock).
access_vector(dontaudit,sysadm_t,domain,lnk_file,ioctl).
access_vector(dontaudit,sysadm_t,domain,sock_file,read).
access_vector(dontaudit,sysadm_t,domain,sock_file,getattr).
access_vector(dontaudit,sysadm_t,domain,sock_file,lock).
access_vector(dontaudit,sysadm_t,domain,sock_file,ioctl).
access_vector(dontaudit,sysadm_t,domain,fifo_file,read).
access_vector(dontaudit,sysadm_t,domain,fifo_file,getattr).
access_vector(dontaudit,sysadm_t,domain,fifo_file,lock).
access_vector(dontaudit,sysadm_t,domain,fifo_file,ioctl).
access_vector(dontaudit,sysadm_t,initrc_var_run_t,file,getattr).
access_vector(dontaudit,sysadm_t,initrc_var_run_t,file,read).
access_vector(dontaudit,sysadm_t,initrc_var_run_t,file,write).
access_vector(dontaudit,sysadm_t,tmpfile,dir,getattr).
access_vector(dontaudit,sysadm_t,tmpfile,file,getattr).
access_vector(dontaudit,sysadm_t,tmpfile,lnk_file,getattr).
access_vector(dontaudit,sysadm_t,tmpfile,sock_file,getattr).
access_vector(dontaudit,sysadm_t,tmpfile,fifo_file,getattr).
access_vector(dontaudit,sysadm_t,tmpfile,chr_file,getattr).
access_vector(dontaudit,sysadm_t,tmpfile,blk_file,getattr).
access_vector(dontaudit,sysadm_t,removable_device_t,blk_file,getattr).
access_vector(dontaudit,sysadm_t,fixed_disk_device_t,blk_file,getattr).
access_vector(allow,sysadm_t,sound_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,sound_device_t,chr_file,read).
access_vector(allow,sysadm_t,sound_device_t,chr_file,write).
access_vector(allow,sysadm_t,sound_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,fs_type,filesystem,getattr).
access_vector(allow,sysadm_t,devtty_t,chr_file,ioctl).
access_vector(allow,sysadm_t,devtty_t,chr_file,read).
access_vector(allow,sysadm_t,devtty_t,chr_file,getattr).
access_vector(allow,sysadm_t,devtty_t,chr_file,lock).
access_vector(allow,sysadm_t,devtty_t,chr_file,write).
access_vector(allow,sysadm_t,devtty_t,chr_file,append).
access_vector(allow,sysadm_t,zero_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,zero_device_t,chr_file,read).
access_vector(allow,sysadm_t,zero_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,zero_device_t,chr_file,lock).
access_vector(allow,sysadm_t,zero_device_t,chr_file,write).
access_vector(allow,sysadm_t,zero_device_t,chr_file,append).
access_vector(allow,sysadm_t,zero_device_t,chr_file,execute).
access_vector(allow,sysadm_t,random_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,random_device_t,chr_file,read).
access_vector(allow,sysadm_t,devpts_t,dir,read).
access_vector(allow,sysadm_t,devpts_t,dir,getattr).
access_vector(allow,sysadm_t,devpts_t,dir,lock).
access_vector(allow,sysadm_t,devpts_t,dir,search).
access_vector(allow,sysadm_t,devpts_t,dir,ioctl).
access_vector(allow,sysadm_crond_t,var_log_t,file,read).
access_vector(allow,sysadm_crond_t,var_log_t,file,getattr).
access_vector(allow,sysadm_crond_t,var_log_t,file,lock).
access_vector(allow,sysadm_crond_t,var_log_t,file,ioctl).
access_vector(allow,sysadm_t,kernel_t,system,syslog_read).
access_vector(allow,sysadm_t,self,capability,except(sys_module)).
access_vector(allow,sysadm_t,security_t,dir,read).
access_vector(allow,sysadm_t,security_t,dir,search).
access_vector(allow,sysadm_t,security_t,dir,getattr).
access_vector(allow,sysadm_t,security_t,file,getattr).
access_vector(allow,sysadm_t,security_t,file,read).
access_vector(allow,sysadm_t,security_t,file,write).
access_vector(allow,sysadm_t,security_t,security,check_context).
access_vector(allow,sysadm_t,security_t,security,compute_av).
access_vector(allow,sysadm_t,security_t,security,compute_create).
access_vector(allow,sysadm_t,security_t,security,compute_relabel).
access_vector(allow,sysadm_t,security_t,security,compute_user).
access_vector(allow,sysadm_t,kernel_t,system,_).
access_vector(allow,sysadm_t,self,passwd,passwd).
access_vector(allow,sysadm_t,self,passwd,chfn).
access_vector(allow,sysadm_t,self,passwd,chsh).
access_vector(allow,sysadm_t,sysctl_t,file,setattr).
access_vector(allow,sysadm_t,sysctl_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_t,file,read).
access_vector(allow,sysadm_t,sysctl_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_t,file,lock).
access_vector(allow,sysadm_t,sysctl_t,file,write).
access_vector(allow,sysadm_t,sysctl_t,file,append).
access_vector(allow,sysadm_t,sysctl_fs_t,file,setattr).
access_vector(allow,sysadm_t,sysctl_fs_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_fs_t,file,read).
access_vector(allow,sysadm_t,sysctl_fs_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_fs_t,file,lock).
access_vector(allow,sysadm_t,sysctl_fs_t,file,write).
access_vector(allow,sysadm_t,sysctl_fs_t,file,append).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,setattr).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,read).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,lock).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,write).
access_vector(allow,sysadm_t,sysctl_kernel_t,file,append).
access_vector(allow,sysadm_t,sysctl_net_t,file,setattr).
access_vector(allow,sysadm_t,sysctl_net_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_net_t,file,read).
access_vector(allow,sysadm_t,sysctl_net_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_net_t,file,lock).
access_vector(allow,sysadm_t,sysctl_net_t,file,write).
access_vector(allow,sysadm_t,sysctl_net_t,file,append).
access_vector(allow,sysadm_t,sysctl_net_unix_t,dir,read).
access_vector(allow,sysadm_t,sysctl_net_unix_t,dir,getattr).
access_vector(allow,sysadm_t,sysctl_net_unix_t,dir,lock).
access_vector(allow,sysadm_t,sysctl_net_unix_t,dir,search).
access_vector(allow,sysadm_t,sysctl_net_unix_t,dir,ioctl).
access_vector(allow,sysadm_t,sysctl_net_unix_t,file,setattr).
access_vector(allow,sysadm_t,sysctl_net_unix_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_net_unix_t,file,read).
access_vector(allow,sysadm_t,sysctl_net_unix_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_net_unix_t,file,lock).
access_vector(allow,sysadm_t,sysctl_net_unix_t,file,write).
access_vector(allow,sysadm_t,sysctl_net_unix_t,file,append).
access_vector(allow,sysadm_t,sysctl_vm_t,file,setattr).
access_vector(allow,sysadm_t,sysctl_vm_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_vm_t,file,read).
access_vector(allow,sysadm_t,sysctl_vm_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_vm_t,file,lock).
access_vector(allow,sysadm_t,sysctl_vm_t,file,write).
access_vector(allow,sysadm_t,sysctl_vm_t,file,append).
access_vector(allow,sysadm_t,sysctl_dev_t,file,setattr).
access_vector(allow,sysadm_t,sysctl_dev_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_dev_t,file,read).
access_vector(allow,sysadm_t,sysctl_dev_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_dev_t,file,lock).
access_vector(allow,sysadm_t,sysctl_dev_t,file,write).
access_vector(allow,sysadm_t,sysctl_dev_t,file,append).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,setattr).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,ioctl).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,read).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,getattr).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,lock).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,write).
access_vector(allow,sysadm_t,sysctl_modprobe_t,file,append).
access_vector(allow,sysadm_t,sysadmfile,file,create).
access_vector(allow,sysadm_t,sysadmfile,file,ioctl).
access_vector(allow,sysadm_t,sysadmfile,file,read).
access_vector(allow,sysadm_t,sysadmfile,file,getattr).
access_vector(allow,sysadm_t,sysadmfile,file,lock).
access_vector(allow,sysadm_t,sysadmfile,file,write).
access_vector(allow,sysadm_t,sysadmfile,file,setattr).
access_vector(allow,sysadm_t,sysadmfile,file,append).
access_vector(allow,sysadm_t,sysadmfile,file,link).
access_vector(allow,sysadm_t,sysadmfile,file,unlink).
access_vector(allow,sysadm_t,sysadmfile,file,rename).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,create).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,ioctl).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,read).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,getattr).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,lock).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,write).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,setattr).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,append).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,link).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,unlink).
access_vector(allow,sysadm_t,sysadmfile,lnk_file,rename).
access_vector(allow,sysadm_t,sysadmfile,sock_file,create).
access_vector(allow,sysadm_t,sysadmfile,sock_file,ioctl).
access_vector(allow,sysadm_t,sysadmfile,sock_file,read).
access_vector(allow,sysadm_t,sysadmfile,sock_file,getattr).
access_vector(allow,sysadm_t,sysadmfile,sock_file,lock).
access_vector(allow,sysadm_t,sysadmfile,sock_file,write).
access_vector(allow,sysadm_t,sysadmfile,sock_file,setattr).
access_vector(allow,sysadm_t,sysadmfile,sock_file,append).
access_vector(allow,sysadm_t,sysadmfile,sock_file,link).
access_vector(allow,sysadm_t,sysadmfile,sock_file,unlink).
access_vector(allow,sysadm_t,sysadmfile,sock_file,rename).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,create).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,ioctl).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,read).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,getattr).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,lock).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,write).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,setattr).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,append).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,link).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,unlink).
access_vector(allow,sysadm_t,sysadmfile,fifo_file,rename).
access_vector(allow,sysadm_t,sysadmfile,dir,create).
access_vector(allow,sysadm_t,sysadmfile,dir,read).
access_vector(allow,sysadm_t,sysadmfile,dir,getattr).
access_vector(allow,sysadm_t,sysadmfile,dir,lock).
access_vector(allow,sysadm_t,sysadmfile,dir,setattr).
access_vector(allow,sysadm_t,sysadmfile,dir,link).
access_vector(allow,sysadm_t,sysadmfile,dir,unlink).
access_vector(allow,sysadm_t,sysadmfile,dir,rename).
access_vector(allow,sysadm_t,sysadmfile,dir,search).
access_vector(allow,sysadm_t,sysadmfile,dir,add_name).
access_vector(allow,sysadm_t,sysadmfile,dir,remove_name).
access_vector(allow,sysadm_t,sysadmfile,dir,reparent).
access_vector(allow,sysadm_t,sysadmfile,dir,write).
access_vector(allow,sysadm_t,sysadmfile,dir,rmdir).
access_vector(allow,sysadm_t,self,process,setfscreate).
access_vector(allow,sysadm_t,proc_t,dir,search).
access_vector(allow,sysadm_t,proc_t,lnk_file,read).
access_vector(allow,sysadm_t,self,dir,search).
access_vector(allow,sysadm_t,self,file,read).
access_vector(allow,sysadm_t,self,file,write).
access_vector(allow,sysadm_t,removable_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,removable_device_t,chr_file,read).
access_vector(allow,sysadm_t,removable_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,removable_device_t,chr_file,lock).
access_vector(allow,sysadm_t,removable_device_t,chr_file,write).
access_vector(allow,sysadm_t,removable_device_t,chr_file,append).
access_vector(allow,sysadm_t,removable_device_t,blk_file,ioctl).
access_vector(allow,sysadm_t,removable_device_t,blk_file,read).
access_vector(allow,sysadm_t,removable_device_t,blk_file,getattr).
access_vector(allow,sysadm_t,removable_device_t,blk_file,lock).
access_vector(allow,sysadm_t,removable_device_t,blk_file,write).
access_vector(allow,sysadm_t,removable_device_t,blk_file,append).
access_vector(allow,sysadm_t,initctl_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,initctl_t,fifo_file,read).
access_vector(allow,sysadm_t,initctl_t,fifo_file,getattr).
access_vector(allow,sysadm_t,initctl_t,fifo_file,lock).
access_vector(allow,sysadm_t,initctl_t,fifo_file,write).
access_vector(allow,sysadm_t,initctl_t,fifo_file,append).
access_vector(allow,sysadm_t,domain,dir,read).
access_vector(allow,sysadm_t,domain,dir,getattr).
access_vector(allow,sysadm_t,domain,dir,lock).
access_vector(allow,sysadm_t,domain,dir,search).
access_vector(allow,sysadm_t,domain,dir,ioctl).
access_vector(allow,sysadm_t,domain,file,read).
access_vector(allow,sysadm_t,domain,file,getattr).
access_vector(allow,sysadm_t,domain,file,lock).
access_vector(allow,sysadm_t,domain,file,ioctl).
access_vector(allow,sysadm_t,domain,lnk_file,read).
access_vector(allow,sysadm_t,domain,lnk_file,getattr).
access_vector(allow,sysadm_t,domain,lnk_file,lock).
access_vector(allow,sysadm_t,domain,lnk_file,ioctl).
access_vector(allow,sysadm_t,domain,sock_file,read).
access_vector(allow,sysadm_t,domain,sock_file,getattr).
access_vector(allow,sysadm_t,domain,sock_file,lock).
access_vector(allow,sysadm_t,domain,sock_file,ioctl).
access_vector(allow,sysadm_t,domain,fifo_file,read).
access_vector(allow,sysadm_t,domain,fifo_file,getattr).
access_vector(allow,sysadm_t,domain,fifo_file,lock).
access_vector(allow,sysadm_t,domain,fifo_file,ioctl).
access_vector(allow,sysadm_t,domain,process,getattr).
access_vector(allow,sysadm_t,domain,process,sigchld).
access_vector(allow,sysadm_t,domain,process,sigkill).
access_vector(allow,sysadm_t,domain,process,sigstop).
access_vector(allow,sysadm_t,domain,process,signull).
access_vector(allow,sysadm_t,domain,process,signal).
access_vector(allow,sysadm_t,unlabeled_t,process,sigchld).
access_vector(allow,sysadm_t,unlabeled_t,process,sigkill).
access_vector(allow,sysadm_t,unlabeled_t,process,sigstop).
access_vector(allow,sysadm_t,unlabeled_t,process,signull).
access_vector(allow,sysadm_t,unlabeled_t,process,signal).
access_vector(allow,sysadm_t,tty_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,tty_device_t,chr_file,read).
access_vector(allow,sysadm_t,tty_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,tty_device_t,chr_file,lock).
access_vector(allow,sysadm_t,tty_device_t,chr_file,write).
access_vector(allow,sysadm_t,tty_device_t,chr_file,append).
access_vector(allow,sysadm_t,ttyfile,chr_file,ioctl).
access_vector(allow,sysadm_t,ttyfile,chr_file,read).
access_vector(allow,sysadm_t,ttyfile,chr_file,getattr).
access_vector(allow,sysadm_t,ttyfile,chr_file,lock).
access_vector(allow,sysadm_t,ttyfile,chr_file,write).
access_vector(allow,sysadm_t,ttyfile,chr_file,append).
access_vector(allow,sysadm_t,ptyfile,chr_file,ioctl).
access_vector(allow,sysadm_t,ptyfile,chr_file,read).
access_vector(allow,sysadm_t,ptyfile,chr_file,getattr).
access_vector(allow,sysadm_t,ptyfile,chr_file,lock).
access_vector(allow,sysadm_t,ptyfile,chr_file,write).
access_vector(allow,sysadm_t,ptyfile,chr_file,append).
access_vector(allow,sysadm_t,tun_tap_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,tun_tap_device_t,chr_file,read).
access_vector(allow,sysadm_t,tun_tap_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,tun_tap_device_t,chr_file,lock).
access_vector(allow,sysadm_t,tun_tap_device_t,chr_file,write).
access_vector(allow,sysadm_t,tun_tap_device_t,chr_file,append).
access_vector(allow,sysadm_t,init_exec_t,file,read).
access_vector(allow,sysadm_t,init_exec_t,file,getattr).
access_vector(allow,sysadm_t,init_exec_t,file,lock).
access_vector(allow,sysadm_t,init_exec_t,file,execute).
access_vector(allow,sysadm_t,init_exec_t,file,ioctl).
access_vector(allow,sysadm_t,init_exec_t,file,execute_no_trans).
access_vector(allow,sysadm_t,user_home_type,file,read).
access_vector(allow,sysadm_t,user_home_type,file,getattr).
access_vector(allow,sysadm_t,user_home_type,file,lock).
access_vector(allow,sysadm_t,user_home_type,file,execute).
access_vector(allow,sysadm_t,user_home_type,file,ioctl).
access_vector(allow,sysadm_t,user_home_type,file,execute_no_trans).
access_vector(allow,sysadm_t,src_t,file,read).
access_vector(allow,sysadm_t,src_t,file,getattr).
access_vector(allow,sysadm_t,src_t,file,lock).
access_vector(allow,sysadm_t,src_t,file,execute).
access_vector(allow,sysadm_t,src_t,file,ioctl).
access_vector(allow,sysadm_t,src_t,file,execute_no_trans).
access_vector(allow,sysadm_t,policy_src_t,file,create).
access_vector(allow,sysadm_t,policy_src_t,file,ioctl).
access_vector(allow,sysadm_t,policy_src_t,file,read).
access_vector(allow,sysadm_t,policy_src_t,file,getattr).
access_vector(allow,sysadm_t,policy_src_t,file,lock).
access_vector(allow,sysadm_t,policy_src_t,file,write).
access_vector(allow,sysadm_t,policy_src_t,file,setattr).
access_vector(allow,sysadm_t,policy_src_t,file,append).
access_vector(allow,sysadm_t,policy_src_t,file,link).
access_vector(allow,sysadm_t,policy_src_t,file,unlink).
access_vector(allow,sysadm_t,policy_src_t,file,rename).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,create).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,ioctl).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,read).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,getattr).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,lock).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,write).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,setattr).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,append).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,link).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,unlink).
access_vector(allow,sysadm_t,policy_src_t,lnk_file,rename).
access_vector(allow,sysadm_t,policy_src_t,sock_file,create).
access_vector(allow,sysadm_t,policy_src_t,sock_file,ioctl).
access_vector(allow,sysadm_t,policy_src_t,sock_file,read).
access_vector(allow,sysadm_t,policy_src_t,sock_file,getattr).
access_vector(allow,sysadm_t,policy_src_t,sock_file,lock).
access_vector(allow,sysadm_t,policy_src_t,sock_file,write).
access_vector(allow,sysadm_t,policy_src_t,sock_file,setattr).
access_vector(allow,sysadm_t,policy_src_t,sock_file,append).
access_vector(allow,sysadm_t,policy_src_t,sock_file,link).
access_vector(allow,sysadm_t,policy_src_t,sock_file,unlink).
access_vector(allow,sysadm_t,policy_src_t,sock_file,rename).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,create).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,read).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,getattr).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,lock).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,write).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,setattr).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,append).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,link).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,unlink).
access_vector(allow,sysadm_t,policy_src_t,fifo_file,rename).
access_vector(allow,sysadm_t,policy_src_t,dir,create).
access_vector(allow,sysadm_t,policy_src_t,dir,read).
access_vector(allow,sysadm_t,policy_src_t,dir,getattr).
access_vector(allow,sysadm_t,policy_src_t,dir,lock).
access_vector(allow,sysadm_t,policy_src_t,dir,setattr).
access_vector(allow,sysadm_t,policy_src_t,dir,link).
access_vector(allow,sysadm_t,policy_src_t,dir,unlink).
access_vector(allow,sysadm_t,policy_src_t,dir,rename).
access_vector(allow,sysadm_t,policy_src_t,dir,search).
access_vector(allow,sysadm_t,policy_src_t,dir,add_name).
access_vector(allow,sysadm_t,policy_src_t,dir,remove_name).
access_vector(allow,sysadm_t,policy_src_t,dir,reparent).
access_vector(allow,sysadm_t,policy_src_t,dir,write).
access_vector(allow,sysadm_t,policy_src_t,dir,rmdir).
access_vector(allow,sysadm_t,policy_config_t,file,unlink).
access_vector(allow,sysadm_t,file_type,dir,getattr).
access_vector(allow,sysadm_t,file_type,dir,read).
access_vector(allow,sysadm_t,file_type,dir,search).
access_vector(allow,sysadm_t,file_type,dir,relabelfrom).
access_vector(allow,sysadm_t,file_type,dir,relabelto).
access_vector(allow,sysadm_t,file_type,file,getattr).
access_vector(allow,sysadm_t,file_type,file,relabelfrom).
access_vector(allow,sysadm_t,file_type,file,relabelto).
access_vector(allow,sysadm_t,file_type,lnk_file,getattr).
access_vector(allow,sysadm_t,file_type,lnk_file,relabelfrom).
access_vector(allow,sysadm_t,file_type,lnk_file,relabelto).
access_vector(allow,sysadm_t,file_type,sock_file,getattr).
access_vector(allow,sysadm_t,file_type,sock_file,relabelfrom).
access_vector(allow,sysadm_t,file_type,sock_file,relabelto).
access_vector(allow,sysadm_t,file_type,fifo_file,getattr).
access_vector(allow,sysadm_t,file_type,fifo_file,relabelfrom).
access_vector(allow,sysadm_t,file_type,fifo_file,relabelto).
access_vector(allow,sysadm_t,file_type,chr_file,getattr).
access_vector(allow,sysadm_t,file_type,chr_file,relabelfrom).
access_vector(allow,sysadm_t,file_type,chr_file,relabelto).
access_vector(allow,sysadm_t,file_type,blk_file,getattr).
access_vector(allow,sysadm_t,file_type,blk_file,relabelfrom).
access_vector(allow,sysadm_t,file_type,blk_file,relabelto).
access_vector(allow,sysadm_t,user_tmpfile,dir,read).
access_vector(allow,sysadm_t,user_tmpfile,dir,getattr).
access_vector(allow,sysadm_t,user_tmpfile,dir,lock).
access_vector(allow,sysadm_t,user_tmpfile,dir,search).
access_vector(allow,sysadm_t,user_tmpfile,dir,ioctl).
access_vector(allow,sysadm_t,user_tmpfile,dir,add_name).
access_vector(allow,sysadm_t,user_tmpfile,dir,remove_name).
access_vector(allow,sysadm_t,user_tmpfile,dir,write).
type_trans(sysadm_t,user_tmpfile,sock_file,sysadm_tmp_t).
access_vector(allow,sysadm_crontab_t,user_cron_spool_t,file,unlink).
access_vector(allow,sysadm_t,fs_type,filesystem,quotamod).
access_vector(allow,sysadm_t,console_device_t,chr_file,ioctl).
access_vector(allow,sysadm_t,console_device_t,chr_file,read).
access_vector(allow,sysadm_t,console_device_t,chr_file,getattr).
access_vector(allow,sysadm_t,console_device_t,chr_file,lock).
access_vector(allow,sysadm_t,console_device_t,chr_file,write).
access_vector(allow,sysadm_t,console_device_t,chr_file,append).
access_vector(allow,sysadm_t,domain,tcp_socket,getattr).
access_vector(allow,sysadm_t,domain,udp_socket,getattr).
access_vector(allow,sysadm_t,domain,rawip_socket,getattr).
access_vector(allow,sysadm_t,domain,netlink_socket,getattr).
access_vector(allow,sysadm_t,domain,packet_socket,getattr).
access_vector(allow,sysadm_t,domain,unix_stream_socket,getattr).
access_vector(allow,sysadm_t,domain,unix_dgram_socket,getattr).
access_vector(allow,admin,security_t,dir,read).
access_vector(allow,admin,security_t,dir,search).
access_vector(allow,admin,security_t,dir,getattr).
access_vector(allow,admin,security_t,file,getattr).
access_vector(allow,admin,security_t,file,read).
access_vector(allow,admin,security_t,file,write).
access_vector(allow,admin,security_t,security,setenforce).
access_vector(auditallow,admin,security_t,security,setenforce).
type_decl(user_t,[],[domain,userdomain,unpriv_userdomain,web_client_domain]).
role_decl(user_r,user_t).
role_allow(system_r,user_r).
access_vector(allow,user_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,user_t,self,dir,read).
access_vector(allow,user_t,self,dir,getattr).
access_vector(allow,user_t,self,dir,lock).
access_vector(allow,user_t,self,dir,search).
access_vector(allow,user_t,self,dir,ioctl).
access_vector(allow,user_t,self,file,read).
access_vector(allow,user_t,self,file,getattr).
access_vector(allow,user_t,self,file,lock).
access_vector(allow,user_t,self,file,ioctl).
access_vector(allow,user_t,self,lnk_file,read).
access_vector(allow,user_t,self,lnk_file,getattr).
access_vector(allow,user_t,self,lnk_file,lock).
access_vector(allow,user_t,self,lnk_file,ioctl).
access_vector(allow,user_t,self,sock_file,read).
access_vector(allow,user_t,self,sock_file,getattr).
access_vector(allow,user_t,self,sock_file,lock).
access_vector(allow,user_t,self,sock_file,ioctl).
access_vector(allow,user_t,self,fifo_file,read).
access_vector(allow,user_t,self,fifo_file,getattr).
access_vector(allow,user_t,self,fifo_file,lock).
access_vector(allow,user_t,self,fifo_file,ioctl).
access_vector(allow,user_t,self,fd,_).
access_vector(allow,user_t,self,fifo_file,ioctl).
access_vector(allow,user_t,self,fifo_file,read).
access_vector(allow,user_t,self,fifo_file,getattr).
access_vector(allow,user_t,self,fifo_file,lock).
access_vector(allow,user_t,self,fifo_file,write).
access_vector(allow,user_t,self,fifo_file,append).
access_vector(allow,user_t,self,unix_dgram_socket,create).
access_vector(allow,user_t,self,unix_dgram_socket,ioctl).
access_vector(allow,user_t,self,unix_dgram_socket,read).
access_vector(allow,user_t,self,unix_dgram_socket,getattr).
access_vector(allow,user_t,self,unix_dgram_socket,write).
access_vector(allow,user_t,self,unix_dgram_socket,setattr).
access_vector(allow,user_t,self,unix_dgram_socket,append).
access_vector(allow,user_t,self,unix_dgram_socket,bind).
access_vector(allow,user_t,self,unix_dgram_socket,connect).
access_vector(allow,user_t,self,unix_dgram_socket,getopt).
access_vector(allow,user_t,self,unix_dgram_socket,setopt).
access_vector(allow,user_t,self,unix_dgram_socket,shutdown).
access_vector(allow,user_t,self,unix_stream_socket,create).
access_vector(allow,user_t,self,unix_stream_socket,ioctl).
access_vector(allow,user_t,self,unix_stream_socket,read).
access_vector(allow,user_t,self,unix_stream_socket,getattr).
access_vector(allow,user_t,self,unix_stream_socket,write).
access_vector(allow,user_t,self,unix_stream_socket,setattr).
access_vector(allow,user_t,self,unix_stream_socket,append).
access_vector(allow,user_t,self,unix_stream_socket,bind).
access_vector(allow,user_t,self,unix_stream_socket,connect).
access_vector(allow,user_t,self,unix_stream_socket,getopt).
access_vector(allow,user_t,self,unix_stream_socket,setopt).
access_vector(allow,user_t,self,unix_stream_socket,shutdown).
access_vector(allow,user_t,self,unix_stream_socket,listen).
access_vector(allow,user_t,self,unix_stream_socket,accept).
access_vector(allow,user_t,self,unix_dgram_socket,sendto).
access_vector(allow,user_t,self,unix_stream_socket,connectto).
access_vector(allow,user_t,self,sem,associate).
access_vector(allow,user_t,self,sem,getattr).
access_vector(allow,user_t,self,sem,setattr).
access_vector(allow,user_t,self,sem,create).
access_vector(allow,user_t,self,sem,destroy).
access_vector(allow,user_t,self,sem,read).
access_vector(allow,user_t,self,sem,write).
access_vector(allow,user_t,self,sem,unix_read).
access_vector(allow,user_t,self,sem,unix_write).
access_vector(allow,user_t,self,msg,send).
access_vector(allow,user_t,self,msg,receive).
access_vector(allow,user_t,self,msgq,associate).
access_vector(allow,user_t,self,msgq,getattr).
access_vector(allow,user_t,self,msgq,setattr).
access_vector(allow,user_t,self,msgq,create).
access_vector(allow,user_t,self,msgq,destroy).
access_vector(allow,user_t,self,msgq,read).
access_vector(allow,user_t,self,msgq,write).
access_vector(allow,user_t,self,msgq,enqueue).
access_vector(allow,user_t,self,msgq,unix_read).
access_vector(allow,user_t,self,msgq,unix_write).
access_vector(allow,user_t,self,shm,associate).
access_vector(allow,user_t,self,shm,getattr).
access_vector(allow,user_t,self,shm,setattr).
access_vector(allow,user_t,self,shm,create).
access_vector(allow,user_t,self,shm,destroy).
access_vector(allow,user_t,self,shm,read).
access_vector(allow,user_t,self,shm,write).
access_vector(allow,user_t,self,shm,lock).
access_vector(allow,user_t,self,shm,unix_read).
access_vector(allow,user_t,self,shm,unix_write).
access_vector(allow,user_t,proc_t,dir,read).
access_vector(allow,user_t,proc_t,dir,getattr).
access_vector(allow,user_t,proc_t,dir,lock).
access_vector(allow,user_t,proc_t,dir,search).
access_vector(allow,user_t,proc_t,dir,ioctl).
access_vector(allow,user_t,proc_t,file,read).
access_vector(allow,user_t,proc_t,file,getattr).
access_vector(allow,user_t,proc_t,file,lock).
access_vector(allow,user_t,proc_t,file,ioctl).
access_vector(allow,user_t,proc_t,lnk_file,read).
access_vector(allow,user_t,proc_t,lnk_file,getattr).
access_vector(allow,user_t,proc_t,lnk_file,lock).
access_vector(allow,user_t,proc_t,lnk_file,ioctl).
access_vector(allow,user_t,root_t,dir,read).
access_vector(allow,user_t,root_t,dir,getattr).
access_vector(allow,user_t,root_t,dir,lock).
access_vector(allow,user_t,root_t,dir,search).
access_vector(allow,user_t,root_t,dir,ioctl).
access_vector(allow,user_t,root_t,file,read).
access_vector(allow,user_t,root_t,file,getattr).
access_vector(allow,user_t,root_t,file,lock).
access_vector(allow,user_t,root_t,file,ioctl).
access_vector(allow,user_t,root_t,lnk_file,read).
access_vector(allow,user_t,root_t,lnk_file,getattr).
access_vector(allow,user_t,root_t,lnk_file,lock).
access_vector(allow,user_t,root_t,lnk_file,ioctl).
access_vector(allow,user_t,root_t,sock_file,read).
access_vector(allow,user_t,root_t,sock_file,getattr).
access_vector(allow,user_t,root_t,sock_file,lock).
access_vector(allow,user_t,root_t,sock_file,ioctl).
access_vector(allow,user_t,root_t,fifo_file,read).
access_vector(allow,user_t,root_t,fifo_file,getattr).
access_vector(allow,user_t,root_t,fifo_file,lock).
access_vector(allow,user_t,root_t,fifo_file,ioctl).
access_vector(allow,user_t,home_root_t,dir,read).
access_vector(allow,user_t,home_root_t,dir,getattr).
access_vector(allow,user_t,home_root_t,dir,lock).
access_vector(allow,user_t,home_root_t,dir,search).
access_vector(allow,user_t,home_root_t,dir,ioctl).
access_vector(allow,user_t,usr_t,dir,read).
access_vector(allow,user_t,usr_t,dir,getattr).
access_vector(allow,user_t,usr_t,dir,lock).
access_vector(allow,user_t,usr_t,dir,search).
access_vector(allow,user_t,usr_t,dir,ioctl).
access_vector(allow,user_t,usr_t,file,read).
access_vector(allow,user_t,usr_t,file,getattr).
access_vector(allow,user_t,usr_t,file,lock).
access_vector(allow,user_t,usr_t,file,ioctl).
access_vector(allow,user_t,usr_t,lnk_file,read).
access_vector(allow,user_t,usr_t,lnk_file,getattr).
access_vector(allow,user_t,usr_t,lnk_file,lock).
access_vector(allow,user_t,usr_t,lnk_file,ioctl).
access_vector(allow,user_t,usr_t,sock_file,read).
access_vector(allow,user_t,usr_t,sock_file,getattr).
access_vector(allow,user_t,usr_t,sock_file,lock).
access_vector(allow,user_t,usr_t,sock_file,ioctl).
access_vector(allow,user_t,usr_t,fifo_file,read).
access_vector(allow,user_t,usr_t,fifo_file,getattr).
access_vector(allow,user_t,usr_t,fifo_file,lock).
access_vector(allow,user_t,usr_t,fifo_file,ioctl).
access_vector(allow,user_t,bin_t,dir,read).
access_vector(allow,user_t,bin_t,dir,getattr).
access_vector(allow,user_t,bin_t,dir,lock).
access_vector(allow,user_t,bin_t,dir,search).
access_vector(allow,user_t,bin_t,dir,ioctl).
access_vector(allow,user_t,bin_t,file,read).
access_vector(allow,user_t,bin_t,file,getattr).
access_vector(allow,user_t,bin_t,file,lock).
access_vector(allow,user_t,bin_t,file,ioctl).
access_vector(allow,user_t,bin_t,lnk_file,read).
access_vector(allow,user_t,bin_t,lnk_file,getattr).
access_vector(allow,user_t,bin_t,lnk_file,lock).
access_vector(allow,user_t,bin_t,lnk_file,ioctl).
access_vector(allow,user_t,bin_t,sock_file,read).
access_vector(allow,user_t,bin_t,sock_file,getattr).
access_vector(allow,user_t,bin_t,sock_file,lock).
access_vector(allow,user_t,bin_t,sock_file,ioctl).
access_vector(allow,user_t,bin_t,fifo_file,read).
access_vector(allow,user_t,bin_t,fifo_file,getattr).
access_vector(allow,user_t,bin_t,fifo_file,lock).
access_vector(allow,user_t,bin_t,fifo_file,ioctl).
access_vector(allow,user_t,sbin_t,dir,read).
access_vector(allow,user_t,sbin_t,dir,getattr).
access_vector(allow,user_t,sbin_t,dir,lock).
access_vector(allow,user_t,sbin_t,dir,search).
access_vector(allow,user_t,sbin_t,dir,ioctl).
access_vector(allow,user_t,sbin_t,file,read).
access_vector(allow,user_t,sbin_t,file,getattr).
access_vector(allow,user_t,sbin_t,file,lock).
access_vector(allow,user_t,sbin_t,file,ioctl).
access_vector(allow,user_t,sbin_t,lnk_file,read).
access_vector(allow,user_t,sbin_t,lnk_file,getattr).
access_vector(allow,user_t,sbin_t,lnk_file,lock).
access_vector(allow,user_t,sbin_t,lnk_file,ioctl).
access_vector(allow,user_t,sbin_t,sock_file,read).
access_vector(allow,user_t,sbin_t,sock_file,getattr).
access_vector(allow,user_t,sbin_t,sock_file,lock).
access_vector(allow,user_t,sbin_t,sock_file,ioctl).
access_vector(allow,user_t,sbin_t,fifo_file,read).
access_vector(allow,user_t,sbin_t,fifo_file,getattr).
access_vector(allow,user_t,sbin_t,fifo_file,lock).
access_vector(allow,user_t,sbin_t,fifo_file,ioctl).
access_vector(allow,user_t,readable_t,dir,read).
access_vector(allow,user_t,readable_t,dir,getattr).
access_vector(allow,user_t,readable_t,dir,lock).
access_vector(allow,user_t,readable_t,dir,search).
access_vector(allow,user_t,readable_t,dir,ioctl).
access_vector(allow,user_t,readable_t,file,read).
access_vector(allow,user_t,readable_t,file,getattr).
access_vector(allow,user_t,readable_t,file,lock).
access_vector(allow,user_t,readable_t,file,ioctl).
access_vector(allow,user_t,readable_t,lnk_file,read).
access_vector(allow,user_t,readable_t,lnk_file,getattr).
access_vector(allow,user_t,readable_t,lnk_file,lock).
access_vector(allow,user_t,readable_t,lnk_file,ioctl).
access_vector(allow,user_t,readable_t,sock_file,read).
access_vector(allow,user_t,readable_t,sock_file,getattr).
access_vector(allow,user_t,readable_t,sock_file,lock).
access_vector(allow,user_t,readable_t,sock_file,ioctl).
access_vector(allow,user_t,readable_t,fifo_file,read).
access_vector(allow,user_t,readable_t,fifo_file,getattr).
access_vector(allow,user_t,readable_t,fifo_file,lock).
access_vector(allow,user_t,readable_t,fifo_file,ioctl).
access_vector(allow,user_t,file_labels_t,dir,getattr).
access_vector(allow,user_t,lost_found_t,dir,getattr).
access_vector(allow,user_t,tmp_t,dir,read).
access_vector(allow,user_t,tmp_t,dir,getattr).
access_vector(allow,user_t,tmp_t,dir,lock).
access_vector(allow,user_t,tmp_t,dir,search).
access_vector(allow,user_t,tmp_t,dir,ioctl).
access_vector(allow,user_t,tmp_t,file,read).
access_vector(allow,user_t,tmp_t,file,getattr).
access_vector(allow,user_t,tmp_t,file,lock).
access_vector(allow,user_t,tmp_t,file,ioctl).
access_vector(allow,user_t,tmp_t,lnk_file,read).
access_vector(allow,user_t,tmp_t,lnk_file,getattr).
access_vector(allow,user_t,tmp_t,lnk_file,lock).
access_vector(allow,user_t,tmp_t,lnk_file,ioctl).
access_vector(allow,user_t,var_t,dir,read).
access_vector(allow,user_t,var_t,dir,getattr).
access_vector(allow,user_t,var_t,dir,lock).
access_vector(allow,user_t,var_t,dir,search).
access_vector(allow,user_t,var_t,dir,ioctl).
access_vector(allow,user_t,var_t,file,read).
access_vector(allow,user_t,var_t,file,getattr).
access_vector(allow,user_t,var_t,file,lock).
access_vector(allow,user_t,var_t,file,ioctl).
access_vector(allow,user_t,var_t,lnk_file,read).
access_vector(allow,user_t,var_t,lnk_file,getattr).
access_vector(allow,user_t,var_t,lnk_file,lock).
access_vector(allow,user_t,var_t,lnk_file,ioctl).
access_vector(allow,user_t,var_t,sock_file,read).
access_vector(allow,user_t,var_t,sock_file,getattr).
access_vector(allow,user_t,var_t,sock_file,lock).
access_vector(allow,user_t,var_t,sock_file,ioctl).
access_vector(allow,user_t,var_t,fifo_file,read).
access_vector(allow,user_t,var_t,fifo_file,getattr).
access_vector(allow,user_t,var_t,fifo_file,lock).
access_vector(allow,user_t,var_t,fifo_file,ioctl).
access_vector(allow,user_t,var_spool_t,dir,read).
access_vector(allow,user_t,var_spool_t,dir,getattr).
access_vector(allow,user_t,var_spool_t,dir,lock).
access_vector(allow,user_t,var_spool_t,dir,search).
access_vector(allow,user_t,var_spool_t,dir,ioctl).
access_vector(allow,user_t,var_spool_t,file,read).
access_vector(allow,user_t,var_spool_t,file,getattr).
access_vector(allow,user_t,var_spool_t,file,lock).
access_vector(allow,user_t,var_spool_t,file,ioctl).
access_vector(allow,user_t,var_spool_t,lnk_file,read).
access_vector(allow,user_t,var_spool_t,lnk_file,getattr).
access_vector(allow,user_t,var_spool_t,lnk_file,lock).
access_vector(allow,user_t,var_spool_t,lnk_file,ioctl).
access_vector(allow,user_t,var_spool_t,sock_file,read).
access_vector(allow,user_t,var_spool_t,sock_file,getattr).
access_vector(allow,user_t,var_spool_t,sock_file,lock).
access_vector(allow,user_t,var_spool_t,sock_file,ioctl).
access_vector(allow,user_t,var_spool_t,fifo_file,read).
access_vector(allow,user_t,var_spool_t,fifo_file,getattr).
access_vector(allow,user_t,var_spool_t,fifo_file,lock).
access_vector(allow,user_t,var_spool_t,fifo_file,ioctl).
access_vector(allow,user_t,var_run_t,dir,read).
access_vector(allow,user_t,var_run_t,dir,getattr).
access_vector(allow,user_t,var_run_t,dir,lock).
access_vector(allow,user_t,var_run_t,dir,search).
access_vector(allow,user_t,var_run_t,dir,ioctl).
access_vector(allow,user_t,var_run_t,file,read).
access_vector(allow,user_t,var_run_t,file,getattr).
access_vector(allow,user_t,var_run_t,file,lock).
access_vector(allow,user_t,var_run_t,file,ioctl).
access_vector(allow,user_t,var_run_t,lnk_file,read).
access_vector(allow,user_t,var_run_t,lnk_file,getattr).
access_vector(allow,user_t,var_run_t,lnk_file,lock).
access_vector(allow,user_t,var_run_t,lnk_file,ioctl).
access_vector(allow,user_t,sysctl_kernel_t,dir,search).
access_vector(allow,user_t,sysctl_kernel_t,file,getattr).
access_vector(allow,user_t,sysctl_kernel_t,file,read).
access_vector(allow,user_t,etc_t,dir,read).
access_vector(allow,user_t,etc_t,dir,getattr).
access_vector(allow,user_t,etc_t,dir,lock).
access_vector(allow,user_t,etc_t,dir,search).
access_vector(allow,user_t,etc_t,dir,ioctl).
access_vector(allow,user_t,etc_t,file,read).
access_vector(allow,user_t,etc_t,file,getattr).
access_vector(allow,user_t,etc_t,file,lock).
access_vector(allow,user_t,etc_t,file,ioctl).
access_vector(allow,user_t,etc_t,lnk_file,read).
access_vector(allow,user_t,etc_t,lnk_file,getattr).
access_vector(allow,user_t,etc_t,lnk_file,lock).
access_vector(allow,user_t,etc_t,lnk_file,ioctl).
access_vector(allow,user_t,etc_t,sock_file,read).
access_vector(allow,user_t,etc_t,sock_file,getattr).
access_vector(allow,user_t,etc_t,sock_file,lock).
access_vector(allow,user_t,etc_t,sock_file,ioctl).
access_vector(allow,user_t,etc_t,fifo_file,read).
access_vector(allow,user_t,etc_t,fifo_file,getattr).
access_vector(allow,user_t,etc_t,fifo_file,lock).
access_vector(allow,user_t,etc_t,fifo_file,ioctl).
access_vector(allow,user_t,etc_runtime_t,file,read).
access_vector(allow,user_t,etc_runtime_t,file,getattr).
access_vector(allow,user_t,etc_runtime_t,file,lock).
access_vector(allow,user_t,etc_runtime_t,file,ioctl).
access_vector(allow,user_t,etc_runtime_t,lnk_file,read).
access_vector(allow,user_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,user_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,user_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,user_t,modules_conf_t,file,getattr).
access_vector(allow,user_t,modules_conf_t,file,read).
access_vector(allow,user_t,man_t,dir,read).
access_vector(allow,user_t,man_t,dir,getattr).
access_vector(allow,user_t,man_t,dir,lock).
access_vector(allow,user_t,man_t,dir,search).
access_vector(allow,user_t,man_t,dir,ioctl).
access_vector(allow,user_t,man_t,file,read).
access_vector(allow,user_t,man_t,file,getattr).
access_vector(allow,user_t,man_t,file,lock).
access_vector(allow,user_t,man_t,file,ioctl).
access_vector(allow,user_t,man_t,lnk_file,read).
access_vector(allow,user_t,man_t,lnk_file,getattr).
access_vector(allow,user_t,man_t,lnk_file,lock).
access_vector(allow,user_t,man_t,lnk_file,ioctl).
access_vector(allow,user_t,man_t,sock_file,read).
access_vector(allow,user_t,man_t,sock_file,getattr).
access_vector(allow,user_t,man_t,sock_file,lock).
access_vector(allow,user_t,man_t,sock_file,ioctl).
access_vector(allow,user_t,man_t,fifo_file,read).
access_vector(allow,user_t,man_t,fifo_file,getattr).
access_vector(allow,user_t,man_t,fifo_file,lock).
access_vector(allow,user_t,man_t,fifo_file,ioctl).
access_vector(allow,user_t,device_t,dir,read).
access_vector(allow,user_t,device_t,dir,getattr).
access_vector(allow,user_t,device_t,dir,lock).
access_vector(allow,user_t,device_t,dir,search).
access_vector(allow,user_t,device_t,dir,ioctl).
access_vector(allow,user_t,device_t,lnk_file,read).
access_vector(allow,user_t,device_t,lnk_file,getattr).
access_vector(allow,user_t,device_t,lnk_file,lock).
access_vector(allow,user_t,device_t,lnk_file,ioctl).
access_vector(dontaudit,user_t,ld_so_cache_t,file,write).
access_vector(allow,user_t,lib_t,dir,read).
access_vector(allow,user_t,lib_t,dir,getattr).
access_vector(allow,user_t,lib_t,dir,lock).
access_vector(allow,user_t,lib_t,dir,search).
access_vector(allow,user_t,lib_t,dir,ioctl).
access_vector(allow,user_t,lib_t,lnk_file,read).
access_vector(allow,user_t,lib_t,lnk_file,getattr).
access_vector(allow,user_t,lib_t,lnk_file,lock).
access_vector(allow,user_t,lib_t,lnk_file,ioctl).
access_vector(allow,user_t,ld_so_t,file,read).
access_vector(allow,user_t,ld_so_t,file,getattr).
access_vector(allow,user_t,ld_so_t,file,lock).
access_vector(allow,user_t,ld_so_t,file,execute).
access_vector(allow,user_t,ld_so_t,file,ioctl).
access_vector(allow,user_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_t,ld_so_t,lnk_file,read).
access_vector(allow,user_t,ld_so_t,lnk_file,getattr).
access_vector(allow,user_t,ld_so_t,lnk_file,lock).
access_vector(allow,user_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,user_t,shlib_t,file,read).
access_vector(allow,user_t,shlib_t,file,getattr).
access_vector(allow,user_t,shlib_t,file,lock).
access_vector(allow,user_t,shlib_t,file,execute).
access_vector(allow,user_t,shlib_t,file,ioctl).
access_vector(allow,user_t,shlib_t,lnk_file,read).
access_vector(allow,user_t,shlib_t,lnk_file,getattr).
access_vector(allow,user_t,shlib_t,lnk_file,lock).
access_vector(allow,user_t,shlib_t,lnk_file,ioctl).
access_vector(allow,user_t,ld_so_cache_t,file,read).
access_vector(allow,user_t,ld_so_cache_t,file,getattr).
access_vector(allow,user_t,ld_so_cache_t,file,lock).
access_vector(allow,user_t,ld_so_cache_t,file,ioctl).
access_vector(allow,user_t,device_t,dir,search).
access_vector(allow,user_t,null_device_t,chr_file,ioctl).
access_vector(allow,user_t,null_device_t,chr_file,read).
access_vector(allow,user_t,null_device_t,chr_file,getattr).
access_vector(allow,user_t,null_device_t,chr_file,lock).
access_vector(allow,user_t,null_device_t,chr_file,write).
access_vector(allow,user_t,null_device_t,chr_file,append).
access_vector(allow,user_t,self,capability,setgid).
access_vector(allow,user_t,self,capability,chown).
access_vector(allow,user_t,self,capability,fowner).
access_vector(dontaudit,user_t,self,capability,sys_nice).
access_vector(dontaudit,user_t,self,capability,fsetid).
type_decl(user_home_dir_t,[],[file_type,sysadmfile,home_dir_type,user_home_dir_type,home_type,user_home_type]).
type_decl(user_home_t,[],[file_type,sysadmfile,home_type,user_home_type]).
access_vector(allow,privhome,user_home_dir_t,dir,read).
access_vector(allow,privhome,user_home_dir_t,dir,getattr).
access_vector(allow,privhome,user_home_dir_t,dir,lock).
access_vector(allow,privhome,user_home_dir_t,dir,search).
access_vector(allow,privhome,user_home_dir_t,dir,ioctl).
access_vector(allow,privhome,user_home_dir_t,dir,add_name).
access_vector(allow,privhome,user_home_dir_t,dir,remove_name).
access_vector(allow,privhome,user_home_dir_t,dir,write).
access_vector(allow,privhome,user_home_t,file,create).
access_vector(allow,privhome,user_home_t,file,ioctl).
access_vector(allow,privhome,user_home_t,file,read).
access_vector(allow,privhome,user_home_t,file,getattr).
access_vector(allow,privhome,user_home_t,file,lock).
access_vector(allow,privhome,user_home_t,file,write).
access_vector(allow,privhome,user_home_t,file,setattr).
access_vector(allow,privhome,user_home_t,file,append).
access_vector(allow,privhome,user_home_t,file,link).
access_vector(allow,privhome,user_home_t,file,unlink).
access_vector(allow,privhome,user_home_t,file,rename).
access_vector(allow,privhome,user_home_t,lnk_file,create).
access_vector(allow,privhome,user_home_t,lnk_file,ioctl).
access_vector(allow,privhome,user_home_t,lnk_file,read).
access_vector(allow,privhome,user_home_t,lnk_file,getattr).
access_vector(allow,privhome,user_home_t,lnk_file,lock).
access_vector(allow,privhome,user_home_t,lnk_file,write).
access_vector(allow,privhome,user_home_t,lnk_file,setattr).
access_vector(allow,privhome,user_home_t,lnk_file,append).
access_vector(allow,privhome,user_home_t,lnk_file,link).
access_vector(allow,privhome,user_home_t,lnk_file,unlink).
access_vector(allow,privhome,user_home_t,lnk_file,rename).
access_vector(allow,privhome,user_home_t,sock_file,create).
access_vector(allow,privhome,user_home_t,sock_file,ioctl).
access_vector(allow,privhome,user_home_t,sock_file,read).
access_vector(allow,privhome,user_home_t,sock_file,getattr).
access_vector(allow,privhome,user_home_t,sock_file,lock).
access_vector(allow,privhome,user_home_t,sock_file,write).
access_vector(allow,privhome,user_home_t,sock_file,setattr).
access_vector(allow,privhome,user_home_t,sock_file,append).
access_vector(allow,privhome,user_home_t,sock_file,link).
access_vector(allow,privhome,user_home_t,sock_file,unlink).
access_vector(allow,privhome,user_home_t,sock_file,rename).
access_vector(allow,privhome,user_home_t,fifo_file,create).
access_vector(allow,privhome,user_home_t,fifo_file,ioctl).
access_vector(allow,privhome,user_home_t,fifo_file,read).
access_vector(allow,privhome,user_home_t,fifo_file,getattr).
access_vector(allow,privhome,user_home_t,fifo_file,lock).
access_vector(allow,privhome,user_home_t,fifo_file,write).
access_vector(allow,privhome,user_home_t,fifo_file,setattr).
access_vector(allow,privhome,user_home_t,fifo_file,append).
access_vector(allow,privhome,user_home_t,fifo_file,link).
access_vector(allow,privhome,user_home_t,fifo_file,unlink).
access_vector(allow,privhome,user_home_t,fifo_file,rename).
access_vector(allow,privhome,user_home_t,dir,create).
access_vector(allow,privhome,user_home_t,dir,read).
access_vector(allow,privhome,user_home_t,dir,getattr).
access_vector(allow,privhome,user_home_t,dir,lock).
access_vector(allow,privhome,user_home_t,dir,setattr).
access_vector(allow,privhome,user_home_t,dir,link).
access_vector(allow,privhome,user_home_t,dir,unlink).
access_vector(allow,privhome,user_home_t,dir,rename).
access_vector(allow,privhome,user_home_t,dir,search).
access_vector(allow,privhome,user_home_t,dir,add_name).
access_vector(allow,privhome,user_home_t,dir,remove_name).
access_vector(allow,privhome,user_home_t,dir,reparent).
access_vector(allow,privhome,user_home_t,dir,write).
access_vector(allow,privhome,user_home_t,dir,rmdir).
type_trans(privhome,user_home_dir_t,dir,user_home_t).
type_trans(privhome,user_home_dir_t,[file,lnk_file,sock_file,fifo_file],user_home_t).
type_decl(user_tmp_t,[],[file_type,sysadmfile,tmpfile,user_tmpfile]).
access_vector(allow,user_t,tmp_t,dir,read).
access_vector(allow,user_t,tmp_t,dir,getattr).
access_vector(allow,user_t,tmp_t,dir,lock).
access_vector(allow,user_t,tmp_t,dir,search).
access_vector(allow,user_t,tmp_t,dir,ioctl).
access_vector(allow,user_t,tmp_t,dir,add_name).
access_vector(allow,user_t,tmp_t,dir,remove_name).
access_vector(allow,user_t,tmp_t,dir,write).
access_vector(allow,user_t,user_tmp_t,file,create).
access_vector(allow,user_t,user_tmp_t,file,ioctl).
access_vector(allow,user_t,user_tmp_t,file,read).
access_vector(allow,user_t,user_tmp_t,file,getattr).
access_vector(allow,user_t,user_tmp_t,file,lock).
access_vector(allow,user_t,user_tmp_t,file,write).
access_vector(allow,user_t,user_tmp_t,file,setattr).
access_vector(allow,user_t,user_tmp_t,file,append).
access_vector(allow,user_t,user_tmp_t,file,link).
access_vector(allow,user_t,user_tmp_t,file,unlink).
access_vector(allow,user_t,user_tmp_t,file,rename).
access_vector(allow,user_t,user_tmp_t,lnk_file,create).
access_vector(allow,user_t,user_tmp_t,lnk_file,ioctl).
access_vector(allow,user_t,user_tmp_t,lnk_file,read).
access_vector(allow,user_t,user_tmp_t,lnk_file,getattr).
access_vector(allow,user_t,user_tmp_t,lnk_file,lock).
access_vector(allow,user_t,user_tmp_t,lnk_file,write).
access_vector(allow,user_t,user_tmp_t,lnk_file,setattr).
access_vector(allow,user_t,user_tmp_t,lnk_file,append).
access_vector(allow,user_t,user_tmp_t,lnk_file,link).
access_vector(allow,user_t,user_tmp_t,lnk_file,unlink).
access_vector(allow,user_t,user_tmp_t,lnk_file,rename).
access_vector(allow,user_t,user_tmp_t,sock_file,create).
access_vector(allow,user_t,user_tmp_t,sock_file,ioctl).
access_vector(allow,user_t,user_tmp_t,sock_file,read).
access_vector(allow,user_t,user_tmp_t,sock_file,getattr).
access_vector(allow,user_t,user_tmp_t,sock_file,lock).
access_vector(allow,user_t,user_tmp_t,sock_file,write).
access_vector(allow,user_t,user_tmp_t,sock_file,setattr).
access_vector(allow,user_t,user_tmp_t,sock_file,append).
access_vector(allow,user_t,user_tmp_t,sock_file,link).
access_vector(allow,user_t,user_tmp_t,sock_file,unlink).
access_vector(allow,user_t,user_tmp_t,sock_file,rename).
access_vector(allow,user_t,user_tmp_t,fifo_file,create).
access_vector(allow,user_t,user_tmp_t,fifo_file,ioctl).
access_vector(allow,user_t,user_tmp_t,fifo_file,read).
access_vector(allow,user_t,user_tmp_t,fifo_file,getattr).
access_vector(allow,user_t,user_tmp_t,fifo_file,lock).
access_vector(allow,user_t,user_tmp_t,fifo_file,write).
access_vector(allow,user_t,user_tmp_t,fifo_file,setattr).
access_vector(allow,user_t,user_tmp_t,fifo_file,append).
access_vector(allow,user_t,user_tmp_t,fifo_file,link).
access_vector(allow,user_t,user_tmp_t,fifo_file,unlink).
access_vector(allow,user_t,user_tmp_t,fifo_file,rename).
access_vector(allow,user_t,user_tmp_t,dir,create).
access_vector(allow,user_t,user_tmp_t,dir,read).
access_vector(allow,user_t,user_tmp_t,dir,getattr).
access_vector(allow,user_t,user_tmp_t,dir,lock).
access_vector(allow,user_t,user_tmp_t,dir,setattr).
access_vector(allow,user_t,user_tmp_t,dir,link).
access_vector(allow,user_t,user_tmp_t,dir,unlink).
access_vector(allow,user_t,user_tmp_t,dir,rename).
access_vector(allow,user_t,user_tmp_t,dir,search).
access_vector(allow,user_t,user_tmp_t,dir,add_name).
access_vector(allow,user_t,user_tmp_t,dir,remove_name).
access_vector(allow,user_t,user_tmp_t,dir,reparent).
access_vector(allow,user_t,user_tmp_t,dir,write).
access_vector(allow,user_t,user_tmp_t,dir,rmdir).
type_trans(user_t,tmp_t,dir,user_tmp_t).
type_trans(user_t,tmp_t,[file,lnk_file,sock_file,fifo_file],user_tmp_t).
access_vector(allow,user_t,user_home_dir_t,dir,read).
access_vector(allow,user_t,user_home_dir_t,dir,getattr).
access_vector(allow,user_t,user_home_dir_t,dir,lock).
access_vector(allow,user_t,user_home_dir_t,dir,search).
access_vector(allow,user_t,user_home_dir_t,dir,ioctl).
access_vector(allow,user_t,user_home_dir_t,dir,add_name).
access_vector(allow,user_t,user_home_dir_t,dir,remove_name).
access_vector(allow,user_t,user_home_dir_t,dir,write).
access_vector(allow,user_t,user_home_t,file,create).
access_vector(allow,user_t,user_home_t,file,ioctl).
access_vector(allow,user_t,user_home_t,file,read).
access_vector(allow,user_t,user_home_t,file,getattr).
access_vector(allow,user_t,user_home_t,file,lock).
access_vector(allow,user_t,user_home_t,file,write).
access_vector(allow,user_t,user_home_t,file,setattr).
access_vector(allow,user_t,user_home_t,file,append).
access_vector(allow,user_t,user_home_t,file,link).
access_vector(allow,user_t,user_home_t,file,unlink).
access_vector(allow,user_t,user_home_t,file,rename).
access_vector(allow,user_t,user_home_t,lnk_file,create).
access_vector(allow,user_t,user_home_t,lnk_file,ioctl).
access_vector(allow,user_t,user_home_t,lnk_file,read).
access_vector(allow,user_t,user_home_t,lnk_file,getattr).
access_vector(allow,user_t,user_home_t,lnk_file,lock).
access_vector(allow,user_t,user_home_t,lnk_file,write).
access_vector(allow,user_t,user_home_t,lnk_file,setattr).
access_vector(allow,user_t,user_home_t,lnk_file,append).
access_vector(allow,user_t,user_home_t,lnk_file,link).
access_vector(allow,user_t,user_home_t,lnk_file,unlink).
access_vector(allow,user_t,user_home_t,lnk_file,rename).
access_vector(allow,user_t,user_home_t,sock_file,create).
access_vector(allow,user_t,user_home_t,sock_file,ioctl).
access_vector(allow,user_t,user_home_t,sock_file,read).
access_vector(allow,user_t,user_home_t,sock_file,getattr).
access_vector(allow,user_t,user_home_t,sock_file,lock).
access_vector(allow,user_t,user_home_t,sock_file,write).
access_vector(allow,user_t,user_home_t,sock_file,setattr).
access_vector(allow,user_t,user_home_t,sock_file,append).
access_vector(allow,user_t,user_home_t,sock_file,link).
access_vector(allow,user_t,user_home_t,sock_file,unlink).
access_vector(allow,user_t,user_home_t,sock_file,rename).
access_vector(allow,user_t,user_home_t,fifo_file,create).
access_vector(allow,user_t,user_home_t,fifo_file,ioctl).
access_vector(allow,user_t,user_home_t,fifo_file,read).
access_vector(allow,user_t,user_home_t,fifo_file,getattr).
access_vector(allow,user_t,user_home_t,fifo_file,lock).
access_vector(allow,user_t,user_home_t,fifo_file,write).
access_vector(allow,user_t,user_home_t,fifo_file,setattr).
access_vector(allow,user_t,user_home_t,fifo_file,append).
access_vector(allow,user_t,user_home_t,fifo_file,link).
access_vector(allow,user_t,user_home_t,fifo_file,unlink).
access_vector(allow,user_t,user_home_t,fifo_file,rename).
access_vector(allow,user_t,user_home_t,dir,create).
access_vector(allow,user_t,user_home_t,dir,read).
access_vector(allow,user_t,user_home_t,dir,getattr).
access_vector(allow,user_t,user_home_t,dir,lock).
access_vector(allow,user_t,user_home_t,dir,setattr).
access_vector(allow,user_t,user_home_t,dir,link).
access_vector(allow,user_t,user_home_t,dir,unlink).
access_vector(allow,user_t,user_home_t,dir,rename).
access_vector(allow,user_t,user_home_t,dir,search).
access_vector(allow,user_t,user_home_t,dir,add_name).
access_vector(allow,user_t,user_home_t,dir,remove_name).
access_vector(allow,user_t,user_home_t,dir,reparent).
access_vector(allow,user_t,user_home_t,dir,write).
access_vector(allow,user_t,user_home_t,dir,rmdir).
type_trans(user_t,user_home_dir_t,dir,user_home_t).
type_trans(user_t,user_home_dir_t,[file,lnk_file,sock_file,fifo_file],user_home_t).
access_vector(allow,user_t,user_home_t,dir,relabelfrom).
access_vector(allow,user_t,user_home_t,dir,relabelto).
access_vector(allow,user_t,user_home_t,file,relabelfrom).
access_vector(allow,user_t,user_home_t,file,relabelto).
access_vector(allow,user_t,user_home_t,lnk_file,relabelfrom).
access_vector(allow,user_t,user_home_t,lnk_file,relabelto).
access_vector(allow,user_t,user_home_t,sock_file,relabelfrom).
access_vector(allow,user_t,user_home_t,sock_file,relabelto).
access_vector(allow,user_t,user_home_t,fifo_file,relabelfrom).
access_vector(allow,user_t,user_home_t,fifo_file,relabelto).
access_vector(allow,user_t,user_home_t,chr_file,relabelfrom).
access_vector(allow,user_t,user_home_t,chr_file,relabelto).
access_vector(allow,user_t,user_home_t,blk_file,relabelfrom).
access_vector(allow,user_t,user_home_t,blk_file,relabelto).
access_vector(allow,user_t,user_tmp_t,unix_stream_socket,name_bind).
type_decl(user_tty_device_t,[],[file_type,sysadmfile,ttyfile]).
access_vector(allow,user_t,privfd,fd,use).
access_vector(allow,user_t,user_tty_device_t,chr_file,setattr).
access_vector(allow,user_t,user_tty_device_t,chr_file,ioctl).
access_vector(allow,user_t,user_tty_device_t,chr_file,read).
access_vector(allow,user_t,user_tty_device_t,chr_file,getattr).
access_vector(allow,user_t,user_tty_device_t,chr_file,lock).
access_vector(allow,user_t,user_tty_device_t,chr_file,write).
access_vector(allow,user_t,user_tty_device_t,chr_file,append).
type_change(user_t,tty_device_t,chr_file,user_tty_device_t).
type_change(user_t,ttyfile,chr_file,user_tty_device_t).
access_vector(allow,user_t,var_lib_t,dir,read).
access_vector(allow,user_t,var_lib_t,dir,getattr).
access_vector(allow,user_t,var_lib_t,dir,lock).
access_vector(allow,user_t,var_lib_t,dir,search).
access_vector(allow,user_t,var_lib_t,dir,ioctl).
access_vector(allow,user_t,etc_dpkg_t,dir,read).
access_vector(allow,user_t,etc_dpkg_t,dir,getattr).
access_vector(allow,user_t,etc_dpkg_t,dir,lock).
access_vector(allow,user_t,etc_dpkg_t,dir,search).
access_vector(allow,user_t,etc_dpkg_t,dir,ioctl).
access_vector(allow,user_t,etc_dpkg_t,file,read).
access_vector(allow,user_t,etc_dpkg_t,file,getattr).
access_vector(allow,user_t,etc_dpkg_t,file,lock).
access_vector(allow,user_t,etc_dpkg_t,file,ioctl).
access_vector(allow,user_t,etc_dpkg_t,lnk_file,read).
access_vector(allow,user_t,etc_dpkg_t,lnk_file,getattr).
access_vector(allow,user_t,etc_dpkg_t,lnk_file,lock).
access_vector(allow,user_t,etc_dpkg_t,lnk_file,ioctl).
access_vector(allow,user_t,locale_t,dir,read).
access_vector(allow,user_t,locale_t,dir,getattr).
access_vector(allow,user_t,locale_t,dir,lock).
access_vector(allow,user_t,locale_t,dir,search).
access_vector(allow,user_t,locale_t,dir,ioctl).
access_vector(allow,user_t,locale_t,file,read).
access_vector(allow,user_t,locale_t,file,getattr).
access_vector(allow,user_t,locale_t,file,lock).
access_vector(allow,user_t,locale_t,file,ioctl).
access_vector(allow,user_t,locale_t,lnk_file,read).
access_vector(allow,user_t,locale_t,lnk_file,getattr).
access_vector(allow,user_t,locale_t,lnk_file,lock).
access_vector(allow,user_t,locale_t,lnk_file,ioctl).
access_vector(allow,user_t,tetex_data_t,dir,read).
access_vector(allow,user_t,tetex_data_t,dir,getattr).
access_vector(allow,user_t,tetex_data_t,dir,lock).
access_vector(allow,user_t,tetex_data_t,dir,search).
access_vector(allow,user_t,tetex_data_t,dir,ioctl).
access_vector(allow,user_t,tetex_data_t,file,read).
access_vector(allow,user_t,tetex_data_t,file,getattr).
access_vector(allow,user_t,tetex_data_t,file,lock).
access_vector(allow,user_t,tetex_data_t,file,ioctl).
access_vector(allow,user_t,tetex_data_t,lnk_file,read).
access_vector(allow,user_t,tetex_data_t,lnk_file,getattr).
access_vector(allow,user_t,tetex_data_t,lnk_file,lock).
access_vector(allow,user_t,tetex_data_t,lnk_file,ioctl).
access_vector(allow,user_t,tetex_data_t,file,read).
access_vector(allow,user_t,tetex_data_t,file,getattr).
access_vector(allow,user_t,tetex_data_t,file,lock).
access_vector(allow,user_t,tetex_data_t,file,execute).
access_vector(allow,user_t,tetex_data_t,file,ioctl).
access_vector(allow,user_t,tetex_data_t,file,execute_no_trans).
access_vector(allow,user_t,ptmx_t,chr_file,ioctl).
access_vector(allow,user_t,ptmx_t,chr_file,read).
access_vector(allow,user_t,ptmx_t,chr_file,getattr).
access_vector(allow,user_t,ptmx_t,chr_file,lock).
access_vector(allow,user_t,ptmx_t,chr_file,write).
access_vector(allow,user_t,ptmx_t,chr_file,append).
access_vector(allow,user_t,devpts_t,filesystem,getattr).
access_vector(allow,user_t,devpts_t,dir,getattr).
access_vector(allow,user_t,devpts_t,dir,read).
access_vector(allow,user_t,devpts_t,dir,search).
type_decl(user_devpts_t,[],[file_type,sysadmfile,ptyfile,userpty_type]).
access_vector(allow,user_devpts_t,devpts_t,filesystem,associate).
type_trans(user_t,devpts_t,chr_file,user_devpts_t).
access_vector(allow,user_t,user_devpts_t,chr_file,setattr).
access_vector(allow,user_t,user_devpts_t,chr_file,ioctl).
access_vector(allow,user_t,user_devpts_t,chr_file,read).
access_vector(allow,user_t,user_devpts_t,chr_file,getattr).
access_vector(allow,user_t,user_devpts_t,chr_file,lock).
access_vector(allow,user_t,user_devpts_t,chr_file,write).
access_vector(allow,user_t,user_devpts_t,chr_file,append).
type_change(user_t,sshd_devpts_t,chr_file,user_devpts_t).
access_vector(allow,user_t,sshd_t,tcp_socket,connectto).
access_vector(allow,user_t,sshd_t,tcp_socket,recvfrom).
access_vector(allow,sshd_t,user_t,tcp_socket,acceptfrom).
access_vector(allow,sshd_t,user_t,tcp_socket,recvfrom).
access_vector(allow,user_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(allow,user_t,user_ssh_t,tcp_socket,connectto).
access_vector(allow,user_t,user_ssh_t,tcp_socket,recvfrom).
access_vector(allow,user_ssh_t,user_t,tcp_socket,acceptfrom).
access_vector(allow,user_ssh_t,user_t,tcp_socket,recvfrom).
access_vector(allow,user_ssh_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(allow,user_t,sshd_t,fd,use).
access_vector(allow,user_t,sshd_t,tcp_socket,ioctl).
access_vector(allow,user_t,sshd_t,tcp_socket,read).
access_vector(allow,user_t,sshd_t,tcp_socket,getattr).
access_vector(allow,user_t,sshd_t,tcp_socket,write).
access_vector(allow,user_t,sshd_t,tcp_socket,setattr).
access_vector(allow,user_t,sshd_t,tcp_socket,append).
access_vector(allow,user_t,sshd_t,tcp_socket,bind).
access_vector(allow,user_t,sshd_t,tcp_socket,connect).
access_vector(allow,user_t,sshd_t,tcp_socket,getopt).
access_vector(allow,user_t,sshd_t,tcp_socket,setopt).
access_vector(allow,user_t,sshd_t,tcp_socket,shutdown).
access_vector(allow,user_t,sshd_t,tcp_socket,listen).
access_vector(allow,user_t,sshd_t,tcp_socket,accept).
access_vector(allow,user_t,sshd_t,unix_stream_socket,ioctl).
access_vector(allow,user_t,sshd_t,unix_stream_socket,read).
access_vector(allow,user_t,sshd_t,unix_stream_socket,getattr).
access_vector(allow,user_t,sshd_t,unix_stream_socket,write).
access_vector(allow,user_t,sshd_t,unix_stream_socket,setattr).
access_vector(allow,user_t,sshd_t,unix_stream_socket,append).
access_vector(allow,user_t,sshd_t,unix_stream_socket,bind).
access_vector(allow,user_t,sshd_t,unix_stream_socket,connect).
access_vector(allow,user_t,sshd_t,unix_stream_socket,getopt).
access_vector(allow,user_t,sshd_t,unix_stream_socket,setopt).
access_vector(allow,user_t,sshd_t,unix_stream_socket,shutdown).
access_vector(allow,user_t,sshd_t,unix_stream_socket,listen).
access_vector(allow,user_t,sshd_t,unix_stream_socket,accept).
access_vector(allow,user_t,boot_t,dir,getattr).
access_vector(allow,user_t,boot_t,dir,search).
access_vector(dontaudit,user_t,boot_t,dir,read).
access_vector(dontaudit,user_t,boot_t,lnk_file,getattr).
access_vector(dontaudit,user_t,boot_t,file,getattr).
access_vector(dontaudit,user_t,boot_t,file,read).
access_vector(allow,user_t,system_map_t,file,getattr).
access_vector(allow,user_t,system_map_t,file,read).
type_decl(user_tmpfs_t,[],[file_type,sysadmfile,tmpfsfile]).
access_vector(allow,user_t,tmpfs_t,dir,read).
access_vector(allow,user_t,tmpfs_t,dir,getattr).
access_vector(allow,user_t,tmpfs_t,dir,lock).
access_vector(allow,user_t,tmpfs_t,dir,search).
access_vector(allow,user_t,tmpfs_t,dir,ioctl).
access_vector(allow,user_t,tmpfs_t,dir,add_name).
access_vector(allow,user_t,tmpfs_t,dir,remove_name).
access_vector(allow,user_t,tmpfs_t,dir,write).
access_vector(allow,user_t,user_tmpfs_t,file,create).
access_vector(allow,user_t,user_tmpfs_t,file,ioctl).
access_vector(allow,user_t,user_tmpfs_t,file,read).
access_vector(allow,user_t,user_tmpfs_t,file,getattr).
access_vector(allow,user_t,user_tmpfs_t,file,lock).
access_vector(allow,user_t,user_tmpfs_t,file,write).
access_vector(allow,user_t,user_tmpfs_t,file,setattr).
access_vector(allow,user_t,user_tmpfs_t,file,append).
access_vector(allow,user_t,user_tmpfs_t,file,link).
access_vector(allow,user_t,user_tmpfs_t,file,unlink).
access_vector(allow,user_t,user_tmpfs_t,file,rename).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,create).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,ioctl).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,read).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,getattr).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,lock).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,write).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,setattr).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,append).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,link).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,unlink).
access_vector(allow,user_t,user_tmpfs_t,lnk_file,rename).
access_vector(allow,user_t,user_tmpfs_t,sock_file,create).
access_vector(allow,user_t,user_tmpfs_t,sock_file,ioctl).
access_vector(allow,user_t,user_tmpfs_t,sock_file,read).
access_vector(allow,user_t,user_tmpfs_t,sock_file,getattr).
access_vector(allow,user_t,user_tmpfs_t,sock_file,lock).
access_vector(allow,user_t,user_tmpfs_t,sock_file,write).
access_vector(allow,user_t,user_tmpfs_t,sock_file,setattr).
access_vector(allow,user_t,user_tmpfs_t,sock_file,append).
access_vector(allow,user_t,user_tmpfs_t,sock_file,link).
access_vector(allow,user_t,user_tmpfs_t,sock_file,unlink).
access_vector(allow,user_t,user_tmpfs_t,sock_file,rename).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,create).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,ioctl).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,read).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,getattr).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,lock).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,write).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,setattr).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,append).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,link).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,unlink).
access_vector(allow,user_t,user_tmpfs_t,fifo_file,rename).
access_vector(allow,user_t,user_tmpfs_t,dir,create).
access_vector(allow,user_t,user_tmpfs_t,dir,read).
access_vector(allow,user_t,user_tmpfs_t,dir,getattr).
access_vector(allow,user_t,user_tmpfs_t,dir,lock).
access_vector(allow,user_t,user_tmpfs_t,dir,setattr).
access_vector(allow,user_t,user_tmpfs_t,dir,link).
access_vector(allow,user_t,user_tmpfs_t,dir,unlink).
access_vector(allow,user_t,user_tmpfs_t,dir,rename).
access_vector(allow,user_t,user_tmpfs_t,dir,search).
access_vector(allow,user_t,user_tmpfs_t,dir,add_name).
access_vector(allow,user_t,user_tmpfs_t,dir,remove_name).
access_vector(allow,user_t,user_tmpfs_t,dir,reparent).
access_vector(allow,user_t,user_tmpfs_t,dir,write).
access_vector(allow,user_t,user_tmpfs_t,dir,rmdir).
type_trans(user_t,tmpfs_t,dir,user_tmpfs_t).
type_trans(user_t,tmpfs_t,[file,lnk_file,sock_file,fifo_file],user_tmpfs_t).
access_vector(allow,user_tmpfs_t,tmpfs_t,filesystem,associate).
access_vector(allow,user_t,catman_t,dir,read).
access_vector(allow,user_t,catman_t,dir,getattr).
access_vector(allow,user_t,catman_t,dir,lock).
access_vector(allow,user_t,catman_t,dir,search).
access_vector(allow,user_t,catman_t,dir,ioctl).
access_vector(allow,user_t,catman_t,dir,add_name).
access_vector(allow,user_t,catman_t,dir,remove_name).
access_vector(allow,user_t,catman_t,dir,write).
access_vector(allow,user_t,catman_t,file,create).
access_vector(allow,user_t,catman_t,file,ioctl).
access_vector(allow,user_t,catman_t,file,read).
access_vector(allow,user_t,catman_t,file,getattr).
access_vector(allow,user_t,catman_t,file,lock).
access_vector(allow,user_t,catman_t,file,write).
access_vector(allow,user_t,catman_t,file,setattr).
access_vector(allow,user_t,catman_t,file,append).
access_vector(allow,user_t,catman_t,file,link).
access_vector(allow,user_t,catman_t,file,unlink).
access_vector(allow,user_t,catman_t,file,rename).
access_vector(allow,user_t,catman_t,lnk_file,create).
access_vector(allow,user_t,catman_t,lnk_file,ioctl).
access_vector(allow,user_t,catman_t,lnk_file,read).
access_vector(allow,user_t,catman_t,lnk_file,getattr).
access_vector(allow,user_t,catman_t,lnk_file,lock).
access_vector(allow,user_t,catman_t,lnk_file,write).
access_vector(allow,user_t,catman_t,lnk_file,setattr).
access_vector(allow,user_t,catman_t,lnk_file,append).
access_vector(allow,user_t,catman_t,lnk_file,link).
access_vector(allow,user_t,catman_t,lnk_file,unlink).
access_vector(allow,user_t,catman_t,lnk_file,rename).
access_vector(allow,user_t,catman_t,sock_file,create).
access_vector(allow,user_t,catman_t,sock_file,ioctl).
access_vector(allow,user_t,catman_t,sock_file,read).
access_vector(allow,user_t,catman_t,sock_file,getattr).
access_vector(allow,user_t,catman_t,sock_file,lock).
access_vector(allow,user_t,catman_t,sock_file,write).
access_vector(allow,user_t,catman_t,sock_file,setattr).
access_vector(allow,user_t,catman_t,sock_file,append).
access_vector(allow,user_t,catman_t,sock_file,link).
access_vector(allow,user_t,catman_t,sock_file,unlink).
access_vector(allow,user_t,catman_t,sock_file,rename).
access_vector(allow,user_t,catman_t,fifo_file,create).
access_vector(allow,user_t,catman_t,fifo_file,ioctl).
access_vector(allow,user_t,catman_t,fifo_file,read).
access_vector(allow,user_t,catman_t,fifo_file,getattr).
access_vector(allow,user_t,catman_t,fifo_file,lock).
access_vector(allow,user_t,catman_t,fifo_file,write).
access_vector(allow,user_t,catman_t,fifo_file,setattr).
access_vector(allow,user_t,catman_t,fifo_file,append).
access_vector(allow,user_t,catman_t,fifo_file,link).
access_vector(allow,user_t,catman_t,fifo_file,unlink).
access_vector(allow,user_t,catman_t,fifo_file,rename).
access_vector(allow,user_t,mail_spool_t,dir,read).
access_vector(allow,user_t,mail_spool_t,dir,getattr).
access_vector(allow,user_t,mail_spool_t,dir,lock).
access_vector(allow,user_t,mail_spool_t,dir,search).
access_vector(allow,user_t,mail_spool_t,dir,ioctl).
access_vector(allow,user_t,mail_spool_t,file,ioctl).
access_vector(allow,user_t,mail_spool_t,file,read).
access_vector(allow,user_t,mail_spool_t,file,getattr).
access_vector(allow,user_t,mail_spool_t,file,lock).
access_vector(allow,user_t,mail_spool_t,file,write).
access_vector(allow,user_t,mail_spool_t,file,append).
access_vector(allow,user_t,mail_spool_t,lnk_file,read).
access_vector(allow,user_t,fs_type,filesystem,quotaget).
access_vector(allow,user_t,bin_t,lnk_file,getattr).
access_vector(allow,user_t,bin_t,lnk_file,read).
access_vector(allow,user_t,sbin_t,lnk_file,getattr).
access_vector(allow,user_t,sbin_t,lnk_file,read).
access_vector(allow,user_t,etc_t,lnk_file,getattr).
access_vector(allow,user_t,etc_t,lnk_file,read).
access_vector(allow,user_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_t,device_t,dir,search).
access_vector(allow,user_t,etc_t,file,read).
access_vector(allow,user_t,etc_t,file,getattr).
access_vector(allow,user_t,etc_t,file,lock).
access_vector(allow,user_t,etc_t,file,execute).
access_vector(allow,user_t,etc_t,file,ioctl).
access_vector(allow,user_t,etc_t,file,execute_no_trans).
access_vector(allow,user_t,lib_t,file,read).
access_vector(allow,user_t,lib_t,file,getattr).
access_vector(allow,user_t,lib_t,file,lock).
access_vector(allow,user_t,lib_t,file,execute).
access_vector(allow,user_t,lib_t,file,ioctl).
access_vector(allow,user_t,lib_t,file,execute_no_trans).
access_vector(allow,user_t,bin_t,file,read).
access_vector(allow,user_t,bin_t,file,getattr).
access_vector(allow,user_t,bin_t,file,lock).
access_vector(allow,user_t,bin_t,file,execute).
access_vector(allow,user_t,bin_t,file,ioctl).
access_vector(allow,user_t,bin_t,file,execute_no_trans).
access_vector(allow,user_t,sbin_t,file,read).
access_vector(allow,user_t,sbin_t,file,getattr).
access_vector(allow,user_t,sbin_t,file,lock).
access_vector(allow,user_t,sbin_t,file,execute).
access_vector(allow,user_t,sbin_t,file,ioctl).
access_vector(allow,user_t,sbin_t,file,execute_no_trans).
access_vector(allow,user_t,exec_type,file,read).
access_vector(allow,user_t,exec_type,file,getattr).
access_vector(allow,user_t,exec_type,file,lock).
access_vector(allow,user_t,exec_type,file,execute).
access_vector(allow,user_t,exec_type,file,ioctl).
access_vector(allow,user_t,exec_type,file,execute_no_trans).
access_vector(allow,user_t,user_home_t,file,read).
access_vector(allow,user_t,user_home_t,file,getattr).
access_vector(allow,user_t,user_home_t,file,lock).
access_vector(allow,user_t,user_home_t,file,execute).
access_vector(allow,user_t,user_home_t,file,ioctl).
access_vector(allow,user_t,user_home_t,file,execute_no_trans).
access_vector(allow,user_t,user_tmp_t,file,read).
access_vector(allow,user_t,user_tmp_t,file,getattr).
access_vector(allow,user_t,user_tmp_t,file,lock).
access_vector(allow,user_t,user_tmp_t,file,execute).
access_vector(allow,user_t,user_tmp_t,file,ioctl).
access_vector(allow,user_t,user_tmp_t,file,execute_no_trans).
type_decl(user_su_t,[],[domain,privlog,auth]).
access_vector(allow,user_t,user_su_t,process,transition).
access_vector(dontaudit,user_t,user_su_t,process,noatsecure).
access_vector(allow,user_t,su_exec_t,file,read).
access_vector(allow,user_t,su_exec_t,file,getattr).
access_vector(allow,user_t,su_exec_t,file,execute).
access_vector(allow,user_su_t,user_t,process,sigchld).
access_vector(allow,user_su_t,user_t,fd,use).
access_vector(allow,user_t,user_su_t,fd,use).
access_vector(allow,user_su_t,user_t,fifo_file,ioctl).
access_vector(allow,user_su_t,user_t,fifo_file,read).
access_vector(allow,user_su_t,user_t,fifo_file,getattr).
access_vector(allow,user_su_t,user_t,fifo_file,lock).
access_vector(allow,user_su_t,user_t,fifo_file,write).
access_vector(allow,user_su_t,user_t,fifo_file,append).
access_vector(allow,user_su_t,su_exec_t,file,read).
access_vector(allow,user_su_t,su_exec_t,file,getattr).
access_vector(allow,user_su_t,su_exec_t,file,lock).
access_vector(allow,user_su_t,su_exec_t,file,execute).
access_vector(allow,user_su_t,su_exec_t,file,ioctl).
access_vector(allow,user_su_t,su_exec_t,file,entrypoint).
type_trans(user_t,su_exec_t,process,user_su_t).
access_vector(allow,user_su_t,root_t,dir,read).
access_vector(allow,user_su_t,root_t,dir,getattr).
access_vector(allow,user_su_t,root_t,dir,lock).
access_vector(allow,user_su_t,root_t,dir,search).
access_vector(allow,user_su_t,root_t,dir,ioctl).
access_vector(allow,user_su_t,usr_t,dir,read).
access_vector(allow,user_su_t,usr_t,dir,getattr).
access_vector(allow,user_su_t,usr_t,dir,lock).
access_vector(allow,user_su_t,usr_t,dir,search).
access_vector(allow,user_su_t,usr_t,dir,ioctl).
access_vector(allow,user_su_t,lib_t,dir,read).
access_vector(allow,user_su_t,lib_t,dir,getattr).
access_vector(allow,user_su_t,lib_t,dir,lock).
access_vector(allow,user_su_t,lib_t,dir,search).
access_vector(allow,user_su_t,lib_t,dir,ioctl).
access_vector(allow,user_su_t,etc_t,dir,read).
access_vector(allow,user_su_t,etc_t,dir,getattr).
access_vector(allow,user_su_t,etc_t,dir,lock).
access_vector(allow,user_su_t,etc_t,dir,search).
access_vector(allow,user_su_t,etc_t,dir,ioctl).
access_vector(allow,user_su_t,lib_t,lnk_file,read).
access_vector(allow,user_su_t,lib_t,lnk_file,getattr).
access_vector(allow,user_su_t,lib_t,lnk_file,lock).
access_vector(allow,user_su_t,lib_t,lnk_file,ioctl).
access_vector(allow,user_su_t,ld_so_t,file,read).
access_vector(allow,user_su_t,ld_so_t,file,getattr).
access_vector(allow,user_su_t,ld_so_t,file,lock).
access_vector(allow,user_su_t,ld_so_t,file,execute).
access_vector(allow,user_su_t,ld_so_t,file,ioctl).
access_vector(allow,user_su_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_su_t,ld_so_t,lnk_file,read).
access_vector(allow,user_su_t,ld_so_t,lnk_file,getattr).
access_vector(allow,user_su_t,ld_so_t,lnk_file,lock).
access_vector(allow,user_su_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,user_su_t,shlib_t,file,read).
access_vector(allow,user_su_t,shlib_t,file,getattr).
access_vector(allow,user_su_t,shlib_t,file,lock).
access_vector(allow,user_su_t,shlib_t,file,execute).
access_vector(allow,user_su_t,shlib_t,file,ioctl).
access_vector(allow,user_su_t,shlib_t,lnk_file,read).
access_vector(allow,user_su_t,shlib_t,lnk_file,getattr).
access_vector(allow,user_su_t,shlib_t,lnk_file,lock).
access_vector(allow,user_su_t,shlib_t,lnk_file,ioctl).
access_vector(allow,user_su_t,ld_so_cache_t,file,read).
access_vector(allow,user_su_t,ld_so_cache_t,file,getattr).
access_vector(allow,user_su_t,ld_so_cache_t,file,lock).
access_vector(allow,user_su_t,ld_so_cache_t,file,ioctl).
access_vector(allow,user_su_t,device_t,dir,search).
access_vector(allow,user_su_t,null_device_t,chr_file,ioctl).
access_vector(allow,user_su_t,null_device_t,chr_file,read).
access_vector(allow,user_su_t,null_device_t,chr_file,getattr).
access_vector(allow,user_su_t,null_device_t,chr_file,lock).
access_vector(allow,user_su_t,null_device_t,chr_file,write).
access_vector(allow,user_su_t,null_device_t,chr_file,append).
access_vector(allow,user_su_t,etc_t,file,getattr).
access_vector(allow,user_su_t,etc_t,file,read).
access_vector(allow,user_su_t,etc_t,lnk_file,read).
access_vector(allow,user_su_t,locale_t,dir,read).
access_vector(allow,user_su_t,locale_t,dir,getattr).
access_vector(allow,user_su_t,locale_t,dir,lock).
access_vector(allow,user_su_t,locale_t,dir,search).
access_vector(allow,user_su_t,locale_t,dir,ioctl).
access_vector(allow,user_su_t,locale_t,file,read).
access_vector(allow,user_su_t,locale_t,file,getattr).
access_vector(allow,user_su_t,locale_t,file,lock).
access_vector(allow,user_su_t,locale_t,file,ioctl).
access_vector(allow,user_su_t,locale_t,lnk_file,read).
access_vector(allow,user_su_t,locale_t,lnk_file,getattr).
access_vector(allow,user_su_t,locale_t,lnk_file,lock).
access_vector(allow,user_su_t,locale_t,lnk_file,ioctl).
access_vector(allow,user_su_t,self,unix_dgram_socket,connect).
access_vector(allow,user_su_t,self,unix_dgram_socket,create).
access_vector(allow,user_su_t,self,unix_dgram_socket,write).
access_vector(allow,user_su_t,self,unix_stream_socket,create).
access_vector(allow,user_su_t,self,unix_stream_socket,ioctl).
access_vector(allow,user_su_t,self,unix_stream_socket,read).
access_vector(allow,user_su_t,self,unix_stream_socket,getattr).
access_vector(allow,user_su_t,self,unix_stream_socket,write).
access_vector(allow,user_su_t,self,unix_stream_socket,setattr).
access_vector(allow,user_su_t,self,unix_stream_socket,append).
access_vector(allow,user_su_t,self,unix_stream_socket,bind).
access_vector(allow,user_su_t,self,unix_stream_socket,connect).
access_vector(allow,user_su_t,self,unix_stream_socket,getopt).
access_vector(allow,user_su_t,self,unix_stream_socket,setopt).
access_vector(allow,user_su_t,self,unix_stream_socket,shutdown).
access_vector(allow,user_su_t,self,unix_stream_socket,listen).
access_vector(allow,user_su_t,self,unix_stream_socket,accept).
access_vector(allow,user_su_t,proc_t,dir,search).
access_vector(allow,user_su_t,proc_t,lnk_file,read).
access_vector(allow,user_su_t,self,dir,read).
access_vector(allow,user_su_t,self,dir,getattr).
access_vector(allow,user_su_t,self,dir,lock).
access_vector(allow,user_su_t,self,dir,search).
access_vector(allow,user_su_t,self,dir,ioctl).
access_vector(allow,user_su_t,self,file,read).
access_vector(allow,user_su_t,self,file,getattr).
access_vector(allow,user_su_t,self,file,lock).
access_vector(allow,user_su_t,self,file,ioctl).
access_vector(allow,user_su_t,self,lnk_file,read).
access_vector(allow,user_su_t,self,lnk_file,getattr).
access_vector(allow,user_su_t,self,lnk_file,lock).
access_vector(allow,user_su_t,self,lnk_file,ioctl).
access_vector(allow,user_su_t,self,process,setsched).
access_vector(allow,user_su_t,device_t,dir,search).
access_vector(allow,user_su_t,self,process,fork).
access_vector(allow,user_su_t,self,process,sigchld).
access_vector(allow,user_su_t,self,capability,setuid).
access_vector(allow,user_su_t,self,capability,setgid).
access_vector(allow,user_su_t,self,capability,net_bind_service).
access_vector(allow,user_su_t,self,capability,chown).
access_vector(allow,user_su_t,self,capability,dac_override).
access_vector(allow,user_su_t,self,capability,sys_nice).
access_vector(allow,user_su_t,self,capability,sys_resource).
access_vector(allow,user_su_t,user_t,process,transition).
access_vector(dontaudit,user_su_t,user_t,process,noatsecure).
access_vector(allow,user_su_t,shell_exec_t,file,read).
access_vector(allow,user_su_t,shell_exec_t,file,getattr).
access_vector(allow,user_su_t,shell_exec_t,file,execute).
access_vector(allow,user_t,user_su_t,process,sigchld).
access_vector(allow,user_t,user_su_t,fd,use).
access_vector(allow,user_su_t,user_t,fd,use).
access_vector(allow,user_t,user_su_t,fifo_file,ioctl).
access_vector(allow,user_t,user_su_t,fifo_file,read).
access_vector(allow,user_t,user_su_t,fifo_file,getattr).
access_vector(allow,user_t,user_su_t,fifo_file,lock).
access_vector(allow,user_t,user_su_t,fifo_file,write).
access_vector(allow,user_t,user_su_t,fifo_file,append).
access_vector(allow,user_t,shell_exec_t,file,read).
access_vector(allow,user_t,shell_exec_t,file,getattr).
access_vector(allow,user_t,shell_exec_t,file,lock).
access_vector(allow,user_t,shell_exec_t,file,execute).
access_vector(allow,user_t,shell_exec_t,file,ioctl).
access_vector(allow,user_t,shell_exec_t,file,entrypoint).
type_trans(user_su_t,shell_exec_t,process,user_t).
access_vector(allow,user_su_t,bin_t,dir,search).
access_vector(allow,user_su_t,bin_t,lnk_file,read).
access_vector(allow,user_su_t,privfd,fd,use).
access_vector(allow,user_su_t,var_t,dir,search).
access_vector(allow,user_su_t,var_run_t,dir,search).
access_vector(allow,user_su_t,initrc_var_run_t,file,ioctl).
access_vector(allow,user_su_t,initrc_var_run_t,file,read).
access_vector(allow,user_su_t,initrc_var_run_t,file,getattr).
access_vector(allow,user_su_t,initrc_var_run_t,file,lock).
access_vector(allow,user_su_t,initrc_var_run_t,file,write).
access_vector(allow,user_su_t,initrc_var_run_t,file,append).
access_vector(allow,user_su_t,chkpwd_exec_t,file,read).
access_vector(allow,user_su_t,chkpwd_exec_t,file,getattr).
access_vector(allow,user_su_t,chkpwd_exec_t,file,lock).
access_vector(allow,user_su_t,chkpwd_exec_t,file,execute).
access_vector(allow,user_su_t,chkpwd_exec_t,file,ioctl).
access_vector(allow,user_su_t,chkpwd_exec_t,file,execute_no_trans).
role_decl(user_r,user_su_t).
access_vector(allow,user_su_t,user_tty_device_t,chr_file,ioctl).
access_vector(allow,user_su_t,user_tty_device_t,chr_file,read).
access_vector(allow,user_su_t,user_tty_device_t,chr_file,getattr).
access_vector(allow,user_su_t,user_tty_device_t,chr_file,lock).
access_vector(allow,user_su_t,user_tty_device_t,chr_file,write).
access_vector(allow,user_su_t,user_tty_device_t,chr_file,append).
access_vector(allow,user_su_t,user_devpts_t,chr_file,ioctl).
access_vector(allow,user_su_t,user_devpts_t,chr_file,read).
access_vector(allow,user_su_t,user_devpts_t,chr_file,getattr).
access_vector(allow,user_su_t,user_devpts_t,chr_file,lock).
access_vector(allow,user_su_t,user_devpts_t,chr_file,write).
access_vector(allow,user_su_t,user_devpts_t,chr_file,append).
access_vector(allow,user_su_t,home_root_t,dir,search).
access_vector(allow,user_su_t,user_home_dir_t,dir,search).
access_vector(allow,user_su_t,sshd_tmp_t,dir,read).
access_vector(allow,user_su_t,sshd_tmp_t,dir,getattr).
access_vector(allow,user_su_t,sshd_tmp_t,dir,lock).
access_vector(allow,user_su_t,sshd_tmp_t,dir,search).
access_vector(allow,user_su_t,sshd_tmp_t,dir,ioctl).
access_vector(allow,user_su_t,sshd_tmp_t,dir,add_name).
access_vector(allow,user_su_t,sshd_tmp_t,dir,remove_name).
access_vector(allow,user_su_t,sshd_tmp_t,dir,write).
access_vector(allow,user_su_t,sshd_tmp_t,file,ioctl).
access_vector(allow,user_su_t,sshd_tmp_t,file,read).
access_vector(allow,user_su_t,sshd_tmp_t,file,getattr).
access_vector(allow,user_su_t,sshd_tmp_t,file,lock).
access_vector(allow,user_su_t,sshd_tmp_t,file,write).
access_vector(allow,user_su_t,sshd_tmp_t,file,append).
access_vector(allow,user_su_t,user_tmp_t,file,create).
access_vector(allow,user_su_t,user_tmp_t,file,ioctl).
access_vector(allow,user_su_t,user_tmp_t,file,read).
access_vector(allow,user_su_t,user_tmp_t,file,getattr).
access_vector(allow,user_su_t,user_tmp_t,file,lock).
access_vector(allow,user_su_t,user_tmp_t,file,write).
access_vector(allow,user_su_t,user_tmp_t,file,setattr).
access_vector(allow,user_su_t,user_tmp_t,file,append).
access_vector(allow,user_su_t,user_tmp_t,file,link).
access_vector(allow,user_su_t,user_tmp_t,file,unlink).
access_vector(allow,user_su_t,user_tmp_t,file,rename).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,create).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,ioctl).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,read).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,getattr).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,lock).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,write).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,setattr).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,append).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,link).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,unlink).
access_vector(allow,user_su_t,user_tmp_t,lnk_file,rename).
access_vector(allow,user_su_t,user_tmp_t,sock_file,create).
access_vector(allow,user_su_t,user_tmp_t,sock_file,ioctl).
access_vector(allow,user_su_t,user_tmp_t,sock_file,read).
access_vector(allow,user_su_t,user_tmp_t,sock_file,getattr).
access_vector(allow,user_su_t,user_tmp_t,sock_file,lock).
access_vector(allow,user_su_t,user_tmp_t,sock_file,write).
access_vector(allow,user_su_t,user_tmp_t,sock_file,setattr).
access_vector(allow,user_su_t,user_tmp_t,sock_file,append).
access_vector(allow,user_su_t,user_tmp_t,sock_file,link).
access_vector(allow,user_su_t,user_tmp_t,sock_file,unlink).
access_vector(allow,user_su_t,user_tmp_t,sock_file,rename).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,create).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,ioctl).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,read).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,getattr).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,lock).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,write).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,setattr).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,append).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,link).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,unlink).
access_vector(allow,user_su_t,user_tmp_t,fifo_file,rename).
access_vector(allow,user_su_t,user_tmp_t,dir,create).
access_vector(allow,user_su_t,user_tmp_t,dir,read).
access_vector(allow,user_su_t,user_tmp_t,dir,getattr).
access_vector(allow,user_su_t,user_tmp_t,dir,lock).
access_vector(allow,user_su_t,user_tmp_t,dir,setattr).
access_vector(allow,user_su_t,user_tmp_t,dir,link).
access_vector(allow,user_su_t,user_tmp_t,dir,unlink).
access_vector(allow,user_su_t,user_tmp_t,dir,rename).
access_vector(allow,user_su_t,user_tmp_t,dir,search).
access_vector(allow,user_su_t,user_tmp_t,dir,add_name).
access_vector(allow,user_su_t,user_tmp_t,dir,remove_name).
access_vector(allow,user_su_t,user_tmp_t,dir,reparent).
access_vector(allow,user_su_t,user_tmp_t,dir,write).
access_vector(allow,user_su_t,user_tmp_t,dir,rmdir).
type_trans(user_su_t,sshd_tmp_t,dir,user_tmp_t).
type_trans(user_su_t,sshd_tmp_t,[file,lnk_file,sock_file,fifo_file],user_tmp_t).
access_vector(dontaudit,user_su_t,file_type,dir,search).
type_decl(user_chkpwd_t,[],[domain,privlog,auth]).
access_vector(allow,user_t,user_chkpwd_t,process,transition).
access_vector(dontaudit,user_t,user_chkpwd_t,process,noatsecure).
access_vector(allow,user_t,chkpwd_exec_t,file,read).
access_vector(allow,user_t,chkpwd_exec_t,file,getattr).
access_vector(allow,user_t,chkpwd_exec_t,file,execute).
access_vector(allow,user_chkpwd_t,user_t,process,sigchld).
access_vector(allow,user_chkpwd_t,user_t,fd,use).
access_vector(allow,user_t,user_chkpwd_t,fd,use).
access_vector(allow,user_chkpwd_t,user_t,fifo_file,ioctl).
access_vector(allow,user_chkpwd_t,user_t,fifo_file,read).
access_vector(allow,user_chkpwd_t,user_t,fifo_file,getattr).
access_vector(allow,user_chkpwd_t,user_t,fifo_file,lock).
access_vector(allow,user_chkpwd_t,user_t,fifo_file,write).
access_vector(allow,user_chkpwd_t,user_t,fifo_file,append).
access_vector(allow,user_chkpwd_t,chkpwd_exec_t,file,read).
access_vector(allow,user_chkpwd_t,chkpwd_exec_t,file,getattr).
access_vector(allow,user_chkpwd_t,chkpwd_exec_t,file,lock).
access_vector(allow,user_chkpwd_t,chkpwd_exec_t,file,execute).
access_vector(allow,user_chkpwd_t,chkpwd_exec_t,file,ioctl).
access_vector(allow,user_chkpwd_t,chkpwd_exec_t,file,entrypoint).
type_trans(user_t,chkpwd_exec_t,process,user_chkpwd_t).
role_decl(user_r,user_chkpwd_t).
access_vector(allow,user_chkpwd_t,root_t,dir,read).
access_vector(allow,user_chkpwd_t,root_t,dir,getattr).
access_vector(allow,user_chkpwd_t,root_t,dir,lock).
access_vector(allow,user_chkpwd_t,root_t,dir,search).
access_vector(allow,user_chkpwd_t,root_t,dir,ioctl).
access_vector(allow,user_chkpwd_t,usr_t,dir,read).
access_vector(allow,user_chkpwd_t,usr_t,dir,getattr).
access_vector(allow,user_chkpwd_t,usr_t,dir,lock).
access_vector(allow,user_chkpwd_t,usr_t,dir,search).
access_vector(allow,user_chkpwd_t,usr_t,dir,ioctl).
access_vector(allow,user_chkpwd_t,lib_t,dir,read).
access_vector(allow,user_chkpwd_t,lib_t,dir,getattr).
access_vector(allow,user_chkpwd_t,lib_t,dir,lock).
access_vector(allow,user_chkpwd_t,lib_t,dir,search).
access_vector(allow,user_chkpwd_t,lib_t,dir,ioctl).
access_vector(allow,user_chkpwd_t,etc_t,dir,read).
access_vector(allow,user_chkpwd_t,etc_t,dir,getattr).
access_vector(allow,user_chkpwd_t,etc_t,dir,lock).
access_vector(allow,user_chkpwd_t,etc_t,dir,search).
access_vector(allow,user_chkpwd_t,etc_t,dir,ioctl).
access_vector(allow,user_chkpwd_t,lib_t,lnk_file,read).
access_vector(allow,user_chkpwd_t,lib_t,lnk_file,getattr).
access_vector(allow,user_chkpwd_t,lib_t,lnk_file,lock).
access_vector(allow,user_chkpwd_t,lib_t,lnk_file,ioctl).
access_vector(allow,user_chkpwd_t,ld_so_t,file,read).
access_vector(allow,user_chkpwd_t,ld_so_t,file,getattr).
access_vector(allow,user_chkpwd_t,ld_so_t,file,lock).
access_vector(allow,user_chkpwd_t,ld_so_t,file,execute).
access_vector(allow,user_chkpwd_t,ld_so_t,file,ioctl).
access_vector(allow,user_chkpwd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_chkpwd_t,ld_so_t,lnk_file,read).
access_vector(allow,user_chkpwd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,user_chkpwd_t,ld_so_t,lnk_file,lock).
access_vector(allow,user_chkpwd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,user_chkpwd_t,shlib_t,file,read).
access_vector(allow,user_chkpwd_t,shlib_t,file,getattr).
access_vector(allow,user_chkpwd_t,shlib_t,file,lock).
access_vector(allow,user_chkpwd_t,shlib_t,file,execute).
access_vector(allow,user_chkpwd_t,shlib_t,file,ioctl).
access_vector(allow,user_chkpwd_t,shlib_t,lnk_file,read).
access_vector(allow,user_chkpwd_t,shlib_t,lnk_file,getattr).
access_vector(allow,user_chkpwd_t,shlib_t,lnk_file,lock).
access_vector(allow,user_chkpwd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,user_chkpwd_t,ld_so_cache_t,file,read).
access_vector(allow,user_chkpwd_t,ld_so_cache_t,file,getattr).
access_vector(allow,user_chkpwd_t,ld_so_cache_t,file,lock).
access_vector(allow,user_chkpwd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,user_chkpwd_t,device_t,dir,search).
access_vector(allow,user_chkpwd_t,null_device_t,chr_file,ioctl).
access_vector(allow,user_chkpwd_t,null_device_t,chr_file,read).
access_vector(allow,user_chkpwd_t,null_device_t,chr_file,getattr).
access_vector(allow,user_chkpwd_t,null_device_t,chr_file,lock).
access_vector(allow,user_chkpwd_t,null_device_t,chr_file,write).
access_vector(allow,user_chkpwd_t,null_device_t,chr_file,append).
access_vector(allow,user_chkpwd_t,etc_t,file,getattr).
access_vector(allow,user_chkpwd_t,etc_t,file,read).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,create).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,read).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,getattr).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,write).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,setattr).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,append).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,bind).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,connect).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,getopt).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,setopt).
access_vector(allow,user_chkpwd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,create).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,ioctl).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,read).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,getattr).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,write).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,setattr).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,append).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,bind).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,connect).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,getopt).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,setopt).
access_vector(allow,user_chkpwd_t,self,unix_stream_socket,shutdown).
access_vector(allow,user_chkpwd_t,etc_t,lnk_file,read).
access_vector(allow,user_chkpwd_t,locale_t,dir,read).
access_vector(allow,user_chkpwd_t,locale_t,dir,getattr).
access_vector(allow,user_chkpwd_t,locale_t,dir,lock).
access_vector(allow,user_chkpwd_t,locale_t,dir,search).
access_vector(allow,user_chkpwd_t,locale_t,dir,ioctl).
access_vector(allow,user_chkpwd_t,locale_t,file,read).
access_vector(allow,user_chkpwd_t,locale_t,file,getattr).
access_vector(allow,user_chkpwd_t,locale_t,file,lock).
access_vector(allow,user_chkpwd_t,locale_t,file,ioctl).
access_vector(allow,user_chkpwd_t,locale_t,lnk_file,read).
access_vector(allow,user_chkpwd_t,locale_t,lnk_file,getattr).
access_vector(allow,user_chkpwd_t,locale_t,lnk_file,lock).
access_vector(allow,user_chkpwd_t,locale_t,lnk_file,ioctl).
access_vector(allow,user_chkpwd_t,self,capability,setuid).
access_vector(allow,user_chkpwd_t,newrole_t,fd,use).
access_vector(allow,user_chkpwd_t,user_tty_device_t,chr_file,ioctl).
access_vector(allow,user_chkpwd_t,user_tty_device_t,chr_file,read).
access_vector(allow,user_chkpwd_t,user_tty_device_t,chr_file,getattr).
access_vector(allow,user_chkpwd_t,user_tty_device_t,chr_file,lock).
access_vector(allow,user_chkpwd_t,user_tty_device_t,chr_file,write).
access_vector(allow,user_chkpwd_t,user_tty_device_t,chr_file,append).
access_vector(allow,user_chkpwd_t,user_devpts_t,chr_file,ioctl).
access_vector(allow,user_chkpwd_t,user_devpts_t,chr_file,read).
access_vector(allow,user_chkpwd_t,user_devpts_t,chr_file,getattr).
access_vector(allow,user_chkpwd_t,user_devpts_t,chr_file,lock).
access_vector(allow,user_chkpwd_t,user_devpts_t,chr_file,write).
access_vector(allow,user_chkpwd_t,user_devpts_t,chr_file,append).
type_decl(user_crontab_t,[],[domain,privlog]).
access_vector(allow,user_t,user_crontab_t,process,transition).
access_vector(dontaudit,user_t,user_crontab_t,process,noatsecure).
access_vector(allow,user_t,crontab_exec_t,file,read).
access_vector(allow,user_t,crontab_exec_t,file,getattr).
access_vector(allow,user_t,crontab_exec_t,file,execute).
access_vector(allow,user_crontab_t,user_t,process,sigchld).
access_vector(allow,user_crontab_t,user_t,fd,use).
access_vector(allow,user_t,user_crontab_t,fd,use).
access_vector(allow,user_crontab_t,user_t,fifo_file,ioctl).
access_vector(allow,user_crontab_t,user_t,fifo_file,read).
access_vector(allow,user_crontab_t,user_t,fifo_file,getattr).
access_vector(allow,user_crontab_t,user_t,fifo_file,lock).
access_vector(allow,user_crontab_t,user_t,fifo_file,write).
access_vector(allow,user_crontab_t,user_t,fifo_file,append).
access_vector(allow,user_crontab_t,crontab_exec_t,file,read).
access_vector(allow,user_crontab_t,crontab_exec_t,file,getattr).
access_vector(allow,user_crontab_t,crontab_exec_t,file,lock).
access_vector(allow,user_crontab_t,crontab_exec_t,file,execute).
access_vector(allow,user_crontab_t,crontab_exec_t,file,ioctl).
access_vector(allow,user_crontab_t,crontab_exec_t,file,entrypoint).
type_trans(user_t,crontab_exec_t,process,user_crontab_t).
role_decl(user_r,user_crontab_t).
access_vector(allow,user_crontab_t,root_t,dir,read).
access_vector(allow,user_crontab_t,root_t,dir,getattr).
access_vector(allow,user_crontab_t,root_t,dir,lock).
access_vector(allow,user_crontab_t,root_t,dir,search).
access_vector(allow,user_crontab_t,root_t,dir,ioctl).
access_vector(allow,user_crontab_t,usr_t,dir,read).
access_vector(allow,user_crontab_t,usr_t,dir,getattr).
access_vector(allow,user_crontab_t,usr_t,dir,lock).
access_vector(allow,user_crontab_t,usr_t,dir,search).
access_vector(allow,user_crontab_t,usr_t,dir,ioctl).
access_vector(allow,user_crontab_t,lib_t,dir,read).
access_vector(allow,user_crontab_t,lib_t,dir,getattr).
access_vector(allow,user_crontab_t,lib_t,dir,lock).
access_vector(allow,user_crontab_t,lib_t,dir,search).
access_vector(allow,user_crontab_t,lib_t,dir,ioctl).
access_vector(allow,user_crontab_t,etc_t,dir,read).
access_vector(allow,user_crontab_t,etc_t,dir,getattr).
access_vector(allow,user_crontab_t,etc_t,dir,lock).
access_vector(allow,user_crontab_t,etc_t,dir,search).
access_vector(allow,user_crontab_t,etc_t,dir,ioctl).
access_vector(allow,user_crontab_t,lib_t,lnk_file,read).
access_vector(allow,user_crontab_t,lib_t,lnk_file,getattr).
access_vector(allow,user_crontab_t,lib_t,lnk_file,lock).
access_vector(allow,user_crontab_t,lib_t,lnk_file,ioctl).
access_vector(allow,user_crontab_t,ld_so_t,file,read).
access_vector(allow,user_crontab_t,ld_so_t,file,getattr).
access_vector(allow,user_crontab_t,ld_so_t,file,lock).
access_vector(allow,user_crontab_t,ld_so_t,file,execute).
access_vector(allow,user_crontab_t,ld_so_t,file,ioctl).
access_vector(allow,user_crontab_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_crontab_t,ld_so_t,lnk_file,read).
access_vector(allow,user_crontab_t,ld_so_t,lnk_file,getattr).
access_vector(allow,user_crontab_t,ld_so_t,lnk_file,lock).
access_vector(allow,user_crontab_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,user_crontab_t,shlib_t,file,read).
access_vector(allow,user_crontab_t,shlib_t,file,getattr).
access_vector(allow,user_crontab_t,shlib_t,file,lock).
access_vector(allow,user_crontab_t,shlib_t,file,execute).
access_vector(allow,user_crontab_t,shlib_t,file,ioctl).
access_vector(allow,user_crontab_t,shlib_t,lnk_file,read).
access_vector(allow,user_crontab_t,shlib_t,lnk_file,getattr).
access_vector(allow,user_crontab_t,shlib_t,lnk_file,lock).
access_vector(allow,user_crontab_t,shlib_t,lnk_file,ioctl).
access_vector(allow,user_crontab_t,ld_so_cache_t,file,read).
access_vector(allow,user_crontab_t,ld_so_cache_t,file,getattr).
access_vector(allow,user_crontab_t,ld_so_cache_t,file,lock).
access_vector(allow,user_crontab_t,ld_so_cache_t,file,ioctl).
access_vector(allow,user_crontab_t,device_t,dir,search).
access_vector(allow,user_crontab_t,null_device_t,chr_file,ioctl).
access_vector(allow,user_crontab_t,null_device_t,chr_file,read).
access_vector(allow,user_crontab_t,null_device_t,chr_file,getattr).
access_vector(allow,user_crontab_t,null_device_t,chr_file,lock).
access_vector(allow,user_crontab_t,null_device_t,chr_file,write).
access_vector(allow,user_crontab_t,null_device_t,chr_file,append).
access_vector(allow,user_crontab_t,etc_t,file,getattr).
access_vector(allow,user_crontab_t,etc_t,file,read).
access_vector(allow,user_crontab_t,self,unix_stream_socket,create).
access_vector(allow,user_crontab_t,self,unix_stream_socket,ioctl).
access_vector(allow,user_crontab_t,self,unix_stream_socket,read).
access_vector(allow,user_crontab_t,self,unix_stream_socket,getattr).
access_vector(allow,user_crontab_t,self,unix_stream_socket,write).
access_vector(allow,user_crontab_t,self,unix_stream_socket,setattr).
access_vector(allow,user_crontab_t,self,unix_stream_socket,append).
access_vector(allow,user_crontab_t,self,unix_stream_socket,bind).
access_vector(allow,user_crontab_t,self,unix_stream_socket,connect).
access_vector(allow,user_crontab_t,self,unix_stream_socket,getopt).
access_vector(allow,user_crontab_t,self,unix_stream_socket,setopt).
access_vector(allow,user_crontab_t,self,unix_stream_socket,shutdown).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,create).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,ioctl).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,read).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,getattr).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,write).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,setattr).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,append).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,bind).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,connect).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,getopt).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,setopt).
access_vector(allow,user_crontab_t,self,unix_dgram_socket,shutdown).
access_vector(allow,user_crontab_t,etc_t,lnk_file,read).
access_vector(allow,user_crontab_t,locale_t,dir,read).
access_vector(allow,user_crontab_t,locale_t,dir,getattr).
access_vector(allow,user_crontab_t,locale_t,dir,lock).
access_vector(allow,user_crontab_t,locale_t,dir,search).
access_vector(allow,user_crontab_t,locale_t,dir,ioctl).
access_vector(allow,user_crontab_t,locale_t,file,read).
access_vector(allow,user_crontab_t,locale_t,file,getattr).
access_vector(allow,user_crontab_t,locale_t,file,lock).
access_vector(allow,user_crontab_t,locale_t,file,ioctl).
access_vector(allow,user_crontab_t,locale_t,lnk_file,read).
access_vector(allow,user_crontab_t,locale_t,lnk_file,getattr).
access_vector(allow,user_crontab_t,locale_t,lnk_file,lock).
access_vector(allow,user_crontab_t,locale_t,lnk_file,ioctl).
access_vector(allow,user_crontab_t,user_crontab_t,capability,setuid).
access_vector(allow,user_crontab_t,user_crontab_t,capability,setgid).
access_vector(allow,user_crontab_t,user_crontab_t,capability,chown).
access_vector(allow,user_crontab_t,tmp_t,dir,read).
access_vector(allow,user_crontab_t,tmp_t,dir,getattr).
access_vector(allow,user_crontab_t,tmp_t,dir,lock).
access_vector(allow,user_crontab_t,tmp_t,dir,search).
access_vector(allow,user_crontab_t,tmp_t,dir,ioctl).
access_vector(allow,user_crontab_t,tmp_t,dir,add_name).
access_vector(allow,user_crontab_t,tmp_t,dir,remove_name).
access_vector(allow,user_crontab_t,tmp_t,dir,write).
access_vector(allow,user_crontab_t,user_tmp_t,file,create).
access_vector(allow,user_crontab_t,user_tmp_t,file,ioctl).
access_vector(allow,user_crontab_t,user_tmp_t,file,read).
access_vector(allow,user_crontab_t,user_tmp_t,file,getattr).
access_vector(allow,user_crontab_t,user_tmp_t,file,lock).
access_vector(allow,user_crontab_t,user_tmp_t,file,write).
access_vector(allow,user_crontab_t,user_tmp_t,file,setattr).
access_vector(allow,user_crontab_t,user_tmp_t,file,append).
access_vector(allow,user_crontab_t,user_tmp_t,file,link).
access_vector(allow,user_crontab_t,user_tmp_t,file,unlink).
access_vector(allow,user_crontab_t,user_tmp_t,file,rename).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,create).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,ioctl).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,read).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,getattr).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,lock).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,write).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,setattr).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,append).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,link).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,unlink).
access_vector(allow,user_crontab_t,user_tmp_t,lnk_file,rename).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,create).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,ioctl).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,read).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,getattr).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,lock).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,write).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,setattr).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,append).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,link).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,unlink).
access_vector(allow,user_crontab_t,user_tmp_t,sock_file,rename).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,create).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,ioctl).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,read).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,getattr).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,lock).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,write).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,setattr).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,append).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,link).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,unlink).
access_vector(allow,user_crontab_t,user_tmp_t,fifo_file,rename).
access_vector(allow,user_crontab_t,user_tmp_t,dir,create).
access_vector(allow,user_crontab_t,user_tmp_t,dir,read).
access_vector(allow,user_crontab_t,user_tmp_t,dir,getattr).
access_vector(allow,user_crontab_t,user_tmp_t,dir,lock).
access_vector(allow,user_crontab_t,user_tmp_t,dir,setattr).
access_vector(allow,user_crontab_t,user_tmp_t,dir,link).
access_vector(allow,user_crontab_t,user_tmp_t,dir,unlink).
access_vector(allow,user_crontab_t,user_tmp_t,dir,rename).
access_vector(allow,user_crontab_t,user_tmp_t,dir,search).
access_vector(allow,user_crontab_t,user_tmp_t,dir,add_name).
access_vector(allow,user_crontab_t,user_tmp_t,dir,remove_name).
access_vector(allow,user_crontab_t,user_tmp_t,dir,reparent).
access_vector(allow,user_crontab_t,user_tmp_t,dir,write).
access_vector(allow,user_crontab_t,user_tmp_t,dir,rmdir).
type_trans(user_crontab_t,tmp_t,dir,user_tmp_t).
type_trans(user_crontab_t,tmp_t,[file,lnk_file,sock_file,fifo_file],user_tmp_t).
type_decl(user_cron_spool_t,[],[file_type,sysadmfile]).
access_vector(allow,sysadm_crontab_t,user_cron_spool_t,file,getattr).
access_vector(allow,sysadm_crontab_t,user_cron_spool_t,file,read).
access_vector(allow,user_crontab_t,var_t,dir,search).
access_vector(allow,user_crontab_t,var_spool_t,dir,search).
access_vector(allow,user_crontab_t,cron_spool_t,dir,read).
access_vector(allow,user_crontab_t,cron_spool_t,dir,getattr).
access_vector(allow,user_crontab_t,cron_spool_t,dir,lock).
access_vector(allow,user_crontab_t,cron_spool_t,dir,search).
access_vector(allow,user_crontab_t,cron_spool_t,dir,ioctl).
access_vector(allow,user_crontab_t,cron_spool_t,dir,add_name).
access_vector(allow,user_crontab_t,cron_spool_t,dir,remove_name).
access_vector(allow,user_crontab_t,cron_spool_t,dir,write).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,create).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,ioctl).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,read).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,getattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,lock).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,write).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,setattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,append).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,link).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,unlink).
access_vector(allow,user_crontab_t,user_cron_spool_t,file,rename).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,create).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,ioctl).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,read).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,getattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,lock).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,write).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,setattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,append).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,link).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,unlink).
access_vector(allow,user_crontab_t,user_cron_spool_t,lnk_file,rename).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,create).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,ioctl).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,read).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,getattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,lock).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,write).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,setattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,append).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,link).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,unlink).
access_vector(allow,user_crontab_t,user_cron_spool_t,sock_file,rename).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,create).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,ioctl).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,read).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,getattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,lock).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,write).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,setattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,append).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,link).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,unlink).
access_vector(allow,user_crontab_t,user_cron_spool_t,fifo_file,rename).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,create).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,read).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,getattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,lock).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,setattr).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,link).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,unlink).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,rename).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,search).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,add_name).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,remove_name).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,reparent).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,write).
access_vector(allow,user_crontab_t,user_cron_spool_t,dir,rmdir).
type_trans(user_crontab_t,cron_spool_t,dir,user_cron_spool_t).
type_trans(user_crontab_t,cron_spool_t,[file,lnk_file,sock_file,fifo_file],user_cron_spool_t).
access_vector(allow,user_crontab_t,self,process,fork).
access_vector(allow,user_crontab_t,self,process,sigchld).
access_vector(allow,user_crontab_t,self,process,sigkill).
access_vector(allow,user_crontab_t,self,process,sigstop).
access_vector(allow,user_crontab_t,self,process,signull).
access_vector(allow,user_crontab_t,self,process,signal).
access_vector(allow,user_crontab_t,cron_spool_t,dir,setattr).
access_vector(allow,crond_t,user_cron_spool_t,file,read).
access_vector(allow,crond_t,user_cron_spool_t,file,getattr).
access_vector(allow,crond_t,user_cron_spool_t,file,lock).
access_vector(allow,crond_t,user_cron_spool_t,file,ioctl).
access_vector(allow,user_crontab_t,bin_t,dir,search).
access_vector(allow,user_crontab_t,sbin_t,dir,search).
access_vector(allow,user_crontab_t,bin_t,lnk_file,read).
access_vector(allow,user_crontab_t,user_t,process,transition).
access_vector(dontaudit,user_crontab_t,user_t,process,noatsecure).
access_vector(allow,user_crontab_t,bin_t,file,read).
access_vector(allow,user_crontab_t,bin_t,file,getattr).
access_vector(allow,user_crontab_t,bin_t,file,execute).
access_vector(allow,user_crontab_t,sbin_t,file,read).
access_vector(allow,user_crontab_t,sbin_t,file,getattr).
access_vector(allow,user_crontab_t,sbin_t,file,execute).
access_vector(allow,user_crontab_t,shell_exec_t,file,read).
access_vector(allow,user_crontab_t,shell_exec_t,file,getattr).
access_vector(allow,user_crontab_t,shell_exec_t,file,execute).
access_vector(allow,user_t,user_crontab_t,process,sigchld).
access_vector(allow,user_t,user_crontab_t,fd,use).
access_vector(allow,user_crontab_t,user_t,fd,use).
access_vector(allow,user_t,user_crontab_t,fifo_file,ioctl).
access_vector(allow,user_t,user_crontab_t,fifo_file,read).
access_vector(allow,user_t,user_crontab_t,fifo_file,getattr).
access_vector(allow,user_t,user_crontab_t,fifo_file,lock).
access_vector(allow,user_t,user_crontab_t,fifo_file,write).
access_vector(allow,user_t,user_crontab_t,fifo_file,append).
access_vector(allow,user_t,bin_t,file,read).
access_vector(allow,user_t,bin_t,file,getattr).
access_vector(allow,user_t,bin_t,file,lock).
access_vector(allow,user_t,bin_t,file,execute).
access_vector(allow,user_t,sbin_t,file,read).
access_vector(allow,user_t,sbin_t,file,getattr).
access_vector(allow,user_t,sbin_t,file,lock).
access_vector(allow,user_t,sbin_t,file,execute).
access_vector(allow,user_t,bin_t,file,entrypoint).
access_vector(allow,user_t,sbin_t,file,entrypoint).
access_vector(allow,user_t,shell_exec_t,file,entrypoint).
type_trans(user_crontab_t,[bin_t,sbin_t,shell_exec_t],process,user_t).
access_vector(allow,user_crontab_t,user_home_t,dir,read).
access_vector(allow,user_crontab_t,user_home_t,dir,getattr).
access_vector(allow,user_crontab_t,user_home_t,dir,lock).
access_vector(allow,user_crontab_t,user_home_t,dir,search).
access_vector(allow,user_crontab_t,user_home_t,dir,ioctl).
access_vector(allow,user_crontab_t,user_home_dir_t,dir,read).
access_vector(allow,user_crontab_t,user_home_dir_t,dir,getattr).
access_vector(allow,user_crontab_t,user_home_dir_t,dir,lock).
access_vector(allow,user_crontab_t,user_home_dir_t,dir,search).
access_vector(allow,user_crontab_t,user_home_dir_t,dir,ioctl).
access_vector(allow,user_crontab_t,user_home_t,file,read).
access_vector(allow,user_crontab_t,user_home_t,file,getattr).
access_vector(allow,user_crontab_t,user_home_t,file,lock).
access_vector(allow,user_crontab_t,user_home_t,file,ioctl).
access_vector(dontaudit,user_crontab_t,user_home_dir_t,dir,write).
access_vector(allow,user_crontab_t,cron_log_t,file,read).
access_vector(allow,user_crontab_t,cron_log_t,file,getattr).
access_vector(allow,user_crontab_t,cron_log_t,file,lock).
access_vector(allow,user_crontab_t,cron_log_t,file,ioctl).
access_vector(allow,user_crontab_t,cron_log_t,file,append).
access_vector(allow,user_crontab_t,device_t,dir,search).
access_vector(allow,user_crontab_t,user_tty_device_t,chr_file,ioctl).
access_vector(allow,user_crontab_t,user_tty_device_t,chr_file,read).
access_vector(allow,user_crontab_t,user_tty_device_t,chr_file,getattr).
access_vector(allow,user_crontab_t,user_tty_device_t,chr_file,lock).
access_vector(allow,user_crontab_t,user_tty_device_t,chr_file,write).
access_vector(allow,user_crontab_t,user_tty_device_t,chr_file,append).
access_vector(allow,user_crontab_t,user_devpts_t,chr_file,ioctl).
access_vector(allow,user_crontab_t,user_devpts_t,chr_file,read).
access_vector(allow,user_crontab_t,user_devpts_t,chr_file,getattr).
access_vector(allow,user_crontab_t,user_devpts_t,chr_file,lock).
access_vector(allow,user_crontab_t,user_devpts_t,chr_file,write).
access_vector(allow,user_crontab_t,user_devpts_t,chr_file,append).
access_vector(allow,user_crontab_t,privfd,fd,use).
type_decl(user_ssh_t,[],[domain,privlog]).
access_vector(allow,user_t,user_ssh_t,process,transition).
access_vector(dontaudit,user_t,user_ssh_t,process,noatsecure).
access_vector(allow,user_t,ssh_exec_t,file,read).
access_vector(allow,user_t,ssh_exec_t,file,getattr).
access_vector(allow,user_t,ssh_exec_t,file,execute).
access_vector(allow,user_ssh_t,user_t,process,sigchld).
access_vector(allow,user_ssh_t,user_t,fd,use).
access_vector(allow,user_t,user_ssh_t,fd,use).
access_vector(allow,user_ssh_t,user_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,user_t,fifo_file,read).
access_vector(allow,user_ssh_t,user_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,user_t,fifo_file,lock).
access_vector(allow,user_ssh_t,user_t,fifo_file,write).
access_vector(allow,user_ssh_t,user_t,fifo_file,append).
access_vector(allow,user_ssh_t,ssh_exec_t,file,read).
access_vector(allow,user_ssh_t,ssh_exec_t,file,getattr).
access_vector(allow,user_ssh_t,ssh_exec_t,file,lock).
access_vector(allow,user_ssh_t,ssh_exec_t,file,execute).
access_vector(allow,user_ssh_t,ssh_exec_t,file,ioctl).
access_vector(allow,user_ssh_t,ssh_exec_t,file,entrypoint).
type_trans(user_t,ssh_exec_t,process,user_ssh_t).
role_decl(user_r,user_ssh_t).
access_vector(allow,user_ssh_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,user_ssh_t,self,dir,read).
access_vector(allow,user_ssh_t,self,dir,getattr).
access_vector(allow,user_ssh_t,self,dir,lock).
access_vector(allow,user_ssh_t,self,dir,search).
access_vector(allow,user_ssh_t,self,dir,ioctl).
access_vector(allow,user_ssh_t,self,file,read).
access_vector(allow,user_ssh_t,self,file,getattr).
access_vector(allow,user_ssh_t,self,file,lock).
access_vector(allow,user_ssh_t,self,file,ioctl).
access_vector(allow,user_ssh_t,self,lnk_file,read).
access_vector(allow,user_ssh_t,self,lnk_file,getattr).
access_vector(allow,user_ssh_t,self,lnk_file,lock).
access_vector(allow,user_ssh_t,self,lnk_file,ioctl).
access_vector(allow,user_ssh_t,self,sock_file,read).
access_vector(allow,user_ssh_t,self,sock_file,getattr).
access_vector(allow,user_ssh_t,self,sock_file,lock).
access_vector(allow,user_ssh_t,self,sock_file,ioctl).
access_vector(allow,user_ssh_t,self,fifo_file,read).
access_vector(allow,user_ssh_t,self,fifo_file,getattr).
access_vector(allow,user_ssh_t,self,fifo_file,lock).
access_vector(allow,user_ssh_t,self,fifo_file,ioctl).
access_vector(allow,user_ssh_t,self,fd,_).
access_vector(allow,user_ssh_t,self,fifo_file,ioctl).
access_vector(allow,user_ssh_t,self,fifo_file,read).
access_vector(allow,user_ssh_t,self,fifo_file,getattr).
access_vector(allow,user_ssh_t,self,fifo_file,lock).
access_vector(allow,user_ssh_t,self,fifo_file,write).
access_vector(allow,user_ssh_t,self,fifo_file,append).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,create).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,ioctl).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,read).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,getattr).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,write).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,setattr).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,append).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,bind).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,connect).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,getopt).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,setopt).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,shutdown).
access_vector(allow,user_ssh_t,self,unix_stream_socket,create).
access_vector(allow,user_ssh_t,self,unix_stream_socket,ioctl).
access_vector(allow,user_ssh_t,self,unix_stream_socket,read).
access_vector(allow,user_ssh_t,self,unix_stream_socket,getattr).
access_vector(allow,user_ssh_t,self,unix_stream_socket,write).
access_vector(allow,user_ssh_t,self,unix_stream_socket,setattr).
access_vector(allow,user_ssh_t,self,unix_stream_socket,append).
access_vector(allow,user_ssh_t,self,unix_stream_socket,bind).
access_vector(allow,user_ssh_t,self,unix_stream_socket,connect).
access_vector(allow,user_ssh_t,self,unix_stream_socket,getopt).
access_vector(allow,user_ssh_t,self,unix_stream_socket,setopt).
access_vector(allow,user_ssh_t,self,unix_stream_socket,shutdown).
access_vector(allow,user_ssh_t,self,unix_stream_socket,listen).
access_vector(allow,user_ssh_t,self,unix_stream_socket,accept).
access_vector(allow,user_ssh_t,self,unix_dgram_socket,sendto).
access_vector(allow,user_ssh_t,self,unix_stream_socket,connectto).
access_vector(allow,user_ssh_t,self,sem,associate).
access_vector(allow,user_ssh_t,self,sem,getattr).
access_vector(allow,user_ssh_t,self,sem,setattr).
access_vector(allow,user_ssh_t,self,sem,create).
access_vector(allow,user_ssh_t,self,sem,destroy).
access_vector(allow,user_ssh_t,self,sem,read).
access_vector(allow,user_ssh_t,self,sem,write).
access_vector(allow,user_ssh_t,self,sem,unix_read).
access_vector(allow,user_ssh_t,self,sem,unix_write).
access_vector(allow,user_ssh_t,self,msg,send).
access_vector(allow,user_ssh_t,self,msg,receive).
access_vector(allow,user_ssh_t,self,msgq,associate).
access_vector(allow,user_ssh_t,self,msgq,getattr).
access_vector(allow,user_ssh_t,self,msgq,setattr).
access_vector(allow,user_ssh_t,self,msgq,create).
access_vector(allow,user_ssh_t,self,msgq,destroy).
access_vector(allow,user_ssh_t,self,msgq,read).
access_vector(allow,user_ssh_t,self,msgq,write).
access_vector(allow,user_ssh_t,self,msgq,enqueue).
access_vector(allow,user_ssh_t,self,msgq,unix_read).
access_vector(allow,user_ssh_t,self,msgq,unix_write).
access_vector(allow,user_ssh_t,self,shm,associate).
access_vector(allow,user_ssh_t,self,shm,getattr).
access_vector(allow,user_ssh_t,self,shm,setattr).
access_vector(allow,user_ssh_t,self,shm,create).
access_vector(allow,user_ssh_t,self,shm,destroy).
access_vector(allow,user_ssh_t,self,shm,read).
access_vector(allow,user_ssh_t,self,shm,write).
access_vector(allow,user_ssh_t,self,shm,lock).
access_vector(allow,user_ssh_t,self,shm,unix_read).
access_vector(allow,user_ssh_t,self,shm,unix_write).
access_vector(allow,user_ssh_t,privfd,fd,use).
access_vector(allow,user_ssh_t,root_t,dir,read).
access_vector(allow,user_ssh_t,root_t,dir,getattr).
access_vector(allow,user_ssh_t,root_t,dir,lock).
access_vector(allow,user_ssh_t,root_t,dir,search).
access_vector(allow,user_ssh_t,root_t,dir,ioctl).
access_vector(allow,user_ssh_t,usr_t,dir,read).
access_vector(allow,user_ssh_t,usr_t,dir,getattr).
access_vector(allow,user_ssh_t,usr_t,dir,lock).
access_vector(allow,user_ssh_t,usr_t,dir,search).
access_vector(allow,user_ssh_t,usr_t,dir,ioctl).
access_vector(allow,user_ssh_t,lib_t,dir,read).
access_vector(allow,user_ssh_t,lib_t,dir,getattr).
access_vector(allow,user_ssh_t,lib_t,dir,lock).
access_vector(allow,user_ssh_t,lib_t,dir,search).
access_vector(allow,user_ssh_t,lib_t,dir,ioctl).
access_vector(allow,user_ssh_t,etc_t,dir,read).
access_vector(allow,user_ssh_t,etc_t,dir,getattr).
access_vector(allow,user_ssh_t,etc_t,dir,lock).
access_vector(allow,user_ssh_t,etc_t,dir,search).
access_vector(allow,user_ssh_t,etc_t,dir,ioctl).
access_vector(allow,user_ssh_t,lib_t,lnk_file,read).
access_vector(allow,user_ssh_t,lib_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,lib_t,lnk_file,lock).
access_vector(allow,user_ssh_t,lib_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,ld_so_t,file,read).
access_vector(allow,user_ssh_t,ld_so_t,file,getattr).
access_vector(allow,user_ssh_t,ld_so_t,file,lock).
access_vector(allow,user_ssh_t,ld_so_t,file,execute).
access_vector(allow,user_ssh_t,ld_so_t,file,ioctl).
access_vector(allow,user_ssh_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_ssh_t,ld_so_t,lnk_file,read).
access_vector(allow,user_ssh_t,ld_so_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,ld_so_t,lnk_file,lock).
access_vector(allow,user_ssh_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,shlib_t,file,read).
access_vector(allow,user_ssh_t,shlib_t,file,getattr).
access_vector(allow,user_ssh_t,shlib_t,file,lock).
access_vector(allow,user_ssh_t,shlib_t,file,execute).
access_vector(allow,user_ssh_t,shlib_t,file,ioctl).
access_vector(allow,user_ssh_t,shlib_t,lnk_file,read).
access_vector(allow,user_ssh_t,shlib_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,shlib_t,lnk_file,lock).
access_vector(allow,user_ssh_t,shlib_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,ld_so_cache_t,file,read).
access_vector(allow,user_ssh_t,ld_so_cache_t,file,getattr).
access_vector(allow,user_ssh_t,ld_so_cache_t,file,lock).
access_vector(allow,user_ssh_t,ld_so_cache_t,file,ioctl).
access_vector(allow,user_ssh_t,device_t,dir,search).
access_vector(allow,user_ssh_t,null_device_t,chr_file,ioctl).
access_vector(allow,user_ssh_t,null_device_t,chr_file,read).
access_vector(allow,user_ssh_t,null_device_t,chr_file,getattr).
access_vector(allow,user_ssh_t,null_device_t,chr_file,lock).
access_vector(allow,user_ssh_t,null_device_t,chr_file,write).
access_vector(allow,user_ssh_t,null_device_t,chr_file,append).
access_vector(allow,user_ssh_t,etc_t,lnk_file,read).
access_vector(allow,user_ssh_t,locale_t,dir,read).
access_vector(allow,user_ssh_t,locale_t,dir,getattr).
access_vector(allow,user_ssh_t,locale_t,dir,lock).
access_vector(allow,user_ssh_t,locale_t,dir,search).
access_vector(allow,user_ssh_t,locale_t,dir,ioctl).
access_vector(allow,user_ssh_t,locale_t,file,read).
access_vector(allow,user_ssh_t,locale_t,file,getattr).
access_vector(allow,user_ssh_t,locale_t,file,lock).
access_vector(allow,user_ssh_t,locale_t,file,ioctl).
access_vector(allow,user_ssh_t,locale_t,lnk_file,read).
access_vector(allow,user_ssh_t,locale_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,locale_t,lnk_file,lock).
access_vector(allow,user_ssh_t,locale_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,fs_type,filesystem,getattr).
access_vector(allow,user_ssh_t,root_t,file,read).
access_vector(allow,user_ssh_t,root_t,file,getattr).
access_vector(allow,user_ssh_t,root_t,file,lock).
access_vector(allow,user_ssh_t,root_t,file,ioctl).
access_vector(allow,user_ssh_t,root_t,lnk_file,read).
access_vector(allow,user_ssh_t,root_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,root_t,lnk_file,lock).
access_vector(allow,user_ssh_t,root_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,root_t,sock_file,read).
access_vector(allow,user_ssh_t,root_t,sock_file,getattr).
access_vector(allow,user_ssh_t,root_t,sock_file,lock).
access_vector(allow,user_ssh_t,root_t,sock_file,ioctl).
access_vector(allow,user_ssh_t,root_t,fifo_file,read).
access_vector(allow,user_ssh_t,root_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,root_t,fifo_file,lock).
access_vector(allow,user_ssh_t,root_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,home_root_t,dir,read).
access_vector(allow,user_ssh_t,home_root_t,dir,getattr).
access_vector(allow,user_ssh_t,home_root_t,dir,lock).
access_vector(allow,user_ssh_t,home_root_t,dir,search).
access_vector(allow,user_ssh_t,home_root_t,dir,ioctl).
access_vector(allow,user_ssh_t,usr_t,file,read).
access_vector(allow,user_ssh_t,usr_t,file,getattr).
access_vector(allow,user_ssh_t,usr_t,file,lock).
access_vector(allow,user_ssh_t,usr_t,file,ioctl).
access_vector(allow,user_ssh_t,usr_t,lnk_file,read).
access_vector(allow,user_ssh_t,usr_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,usr_t,lnk_file,lock).
access_vector(allow,user_ssh_t,usr_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,usr_t,sock_file,read).
access_vector(allow,user_ssh_t,usr_t,sock_file,getattr).
access_vector(allow,user_ssh_t,usr_t,sock_file,lock).
access_vector(allow,user_ssh_t,usr_t,sock_file,ioctl).
access_vector(allow,user_ssh_t,usr_t,fifo_file,read).
access_vector(allow,user_ssh_t,usr_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,usr_t,fifo_file,lock).
access_vector(allow,user_ssh_t,usr_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,bin_t,dir,read).
access_vector(allow,user_ssh_t,bin_t,dir,getattr).
access_vector(allow,user_ssh_t,bin_t,dir,lock).
access_vector(allow,user_ssh_t,bin_t,dir,search).
access_vector(allow,user_ssh_t,bin_t,dir,ioctl).
access_vector(allow,user_ssh_t,bin_t,file,read).
access_vector(allow,user_ssh_t,bin_t,file,getattr).
access_vector(allow,user_ssh_t,bin_t,file,lock).
access_vector(allow,user_ssh_t,bin_t,file,ioctl).
access_vector(allow,user_ssh_t,bin_t,lnk_file,read).
access_vector(allow,user_ssh_t,bin_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,bin_t,lnk_file,lock).
access_vector(allow,user_ssh_t,bin_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,bin_t,sock_file,read).
access_vector(allow,user_ssh_t,bin_t,sock_file,getattr).
access_vector(allow,user_ssh_t,bin_t,sock_file,lock).
access_vector(allow,user_ssh_t,bin_t,sock_file,ioctl).
access_vector(allow,user_ssh_t,bin_t,fifo_file,read).
access_vector(allow,user_ssh_t,bin_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,bin_t,fifo_file,lock).
access_vector(allow,user_ssh_t,bin_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,sbin_t,dir,read).
access_vector(allow,user_ssh_t,sbin_t,dir,getattr).
access_vector(allow,user_ssh_t,sbin_t,dir,lock).
access_vector(allow,user_ssh_t,sbin_t,dir,search).
access_vector(allow,user_ssh_t,sbin_t,dir,ioctl).
access_vector(allow,user_ssh_t,sbin_t,file,read).
access_vector(allow,user_ssh_t,sbin_t,file,getattr).
access_vector(allow,user_ssh_t,sbin_t,file,lock).
access_vector(allow,user_ssh_t,sbin_t,file,ioctl).
access_vector(allow,user_ssh_t,sbin_t,lnk_file,read).
access_vector(allow,user_ssh_t,sbin_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,sbin_t,lnk_file,lock).
access_vector(allow,user_ssh_t,sbin_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,sbin_t,sock_file,read).
access_vector(allow,user_ssh_t,sbin_t,sock_file,getattr).
access_vector(allow,user_ssh_t,sbin_t,sock_file,lock).
access_vector(allow,user_ssh_t,sbin_t,sock_file,ioctl).
access_vector(allow,user_ssh_t,sbin_t,fifo_file,read).
access_vector(allow,user_ssh_t,sbin_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,sbin_t,fifo_file,lock).
access_vector(allow,user_ssh_t,sbin_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,devpts_t,dir,read).
access_vector(allow,user_ssh_t,devpts_t,dir,getattr).
access_vector(allow,user_ssh_t,devpts_t,dir,lock).
access_vector(allow,user_ssh_t,devpts_t,dir,search).
access_vector(allow,user_ssh_t,devpts_t,dir,ioctl).
access_vector(allow,user_ssh_t,var_t,dir,read).
access_vector(allow,user_ssh_t,var_t,dir,getattr).
access_vector(allow,user_ssh_t,var_t,dir,lock).
access_vector(allow,user_ssh_t,var_t,dir,search).
access_vector(allow,user_ssh_t,var_t,dir,ioctl).
access_vector(allow,user_ssh_t,var_t,file,read).
access_vector(allow,user_ssh_t,var_t,file,getattr).
access_vector(allow,user_ssh_t,var_t,file,lock).
access_vector(allow,user_ssh_t,var_t,file,ioctl).
access_vector(allow,user_ssh_t,var_t,lnk_file,read).
access_vector(allow,user_ssh_t,var_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,var_t,lnk_file,lock).
access_vector(allow,user_ssh_t,var_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,var_t,sock_file,read).
access_vector(allow,user_ssh_t,var_t,sock_file,getattr).
access_vector(allow,user_ssh_t,var_t,sock_file,lock).
access_vector(allow,user_ssh_t,var_t,sock_file,ioctl).
access_vector(allow,user_ssh_t,var_t,fifo_file,read).
access_vector(allow,user_ssh_t,var_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,var_t,fifo_file,lock).
access_vector(allow,user_ssh_t,var_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,var_run_t,dir,read).
access_vector(allow,user_ssh_t,var_run_t,dir,getattr).
access_vector(allow,user_ssh_t,var_run_t,dir,lock).
access_vector(allow,user_ssh_t,var_run_t,dir,search).
access_vector(allow,user_ssh_t,var_run_t,dir,ioctl).
access_vector(allow,user_ssh_t,var_run_t,file,read).
access_vector(allow,user_ssh_t,var_run_t,file,getattr).
access_vector(allow,user_ssh_t,var_run_t,file,lock).
access_vector(allow,user_ssh_t,var_run_t,file,ioctl).
access_vector(allow,user_ssh_t,var_run_t,lnk_file,read).
access_vector(allow,user_ssh_t,var_run_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,var_run_t,lnk_file,lock).
access_vector(allow,user_ssh_t,var_run_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,var_log_t,dir,read).
access_vector(allow,user_ssh_t,var_log_t,dir,getattr).
access_vector(allow,user_ssh_t,var_log_t,dir,lock).
access_vector(allow,user_ssh_t,var_log_t,dir,search).
access_vector(allow,user_ssh_t,var_log_t,dir,ioctl).
access_vector(allow,user_ssh_t,var_log_t,file,read).
access_vector(allow,user_ssh_t,var_log_t,file,getattr).
access_vector(allow,user_ssh_t,var_log_t,file,lock).
access_vector(allow,user_ssh_t,var_log_t,file,ioctl).
access_vector(allow,user_ssh_t,var_log_t,lnk_file,read).
access_vector(allow,user_ssh_t,var_log_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,var_log_t,lnk_file,lock).
access_vector(allow,user_ssh_t,var_log_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,etc_t,file,read).
access_vector(allow,user_ssh_t,etc_t,file,getattr).
access_vector(allow,user_ssh_t,etc_t,file,lock).
access_vector(allow,user_ssh_t,etc_t,file,ioctl).
access_vector(allow,user_ssh_t,etc_t,lnk_file,read).
access_vector(allow,user_ssh_t,etc_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,etc_t,lnk_file,lock).
access_vector(allow,user_ssh_t,etc_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,etc_t,sock_file,read).
access_vector(allow,user_ssh_t,etc_t,sock_file,getattr).
access_vector(allow,user_ssh_t,etc_t,sock_file,lock).
access_vector(allow,user_ssh_t,etc_t,sock_file,ioctl).
access_vector(allow,user_ssh_t,etc_t,fifo_file,read).
access_vector(allow,user_ssh_t,etc_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,etc_t,fifo_file,lock).
access_vector(allow,user_ssh_t,etc_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,etc_runtime_t,file,read).
access_vector(allow,user_ssh_t,etc_runtime_t,file,getattr).
access_vector(allow,user_ssh_t,etc_runtime_t,file,lock).
access_vector(allow,user_ssh_t,etc_runtime_t,file,ioctl).
access_vector(allow,user_ssh_t,etc_runtime_t,lnk_file,read).
access_vector(allow,user_ssh_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,user_ssh_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,resolv_conf_t,file,read).
access_vector(allow,user_ssh_t,resolv_conf_t,file,getattr).
access_vector(allow,user_ssh_t,resolv_conf_t,file,lock).
access_vector(allow,user_ssh_t,resolv_conf_t,file,ioctl).
access_vector(allow,user_ssh_t,resolv_conf_t,lnk_file,read).
access_vector(allow,user_ssh_t,resolv_conf_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,resolv_conf_t,lnk_file,lock).
access_vector(allow,user_ssh_t,resolv_conf_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,ld_so_t,file,read).
access_vector(allow,user_ssh_t,ld_so_t,file,getattr).
access_vector(allow,user_ssh_t,ld_so_t,file,lock).
access_vector(allow,user_ssh_t,shlib_t,file,read).
access_vector(allow,user_ssh_t,shlib_t,file,getattr).
access_vector(allow,user_ssh_t,shlib_t,file,lock).
access_vector(allow,user_ssh_t,exec_type,file,read).
access_vector(allow,user_ssh_t,exec_type,file,getattr).
access_vector(allow,user_ssh_t,exec_type,file,lock).
access_vector(allow,user_ssh_t,exec_type,file,ioctl).
access_vector(allow,user_ssh_t,exec_type,lnk_file,read).
access_vector(allow,user_ssh_t,exec_type,lnk_file,getattr).
access_vector(allow,user_ssh_t,exec_type,lnk_file,lock).
access_vector(allow,user_ssh_t,exec_type,lnk_file,ioctl).
access_vector(allow,user_ssh_t,device_t,dir,read).
access_vector(allow,user_ssh_t,device_t,dir,getattr).
access_vector(allow,user_ssh_t,device_t,dir,lock).
access_vector(allow,user_ssh_t,device_t,dir,search).
access_vector(allow,user_ssh_t,device_t,dir,ioctl).
access_vector(allow,user_ssh_t,device_t,lnk_file,read).
access_vector(allow,user_ssh_t,device_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,device_t,lnk_file,lock).
access_vector(allow,user_ssh_t,device_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,random_device_t,chr_file,read).
access_vector(allow,user_ssh_t,random_device_t,chr_file,getattr).
access_vector(allow,user_ssh_t,random_device_t,chr_file,lock).
access_vector(allow,user_ssh_t,random_device_t,chr_file,ioctl).
access_vector(allow,user_ssh_t,devtty_t,chr_file,ioctl).
access_vector(allow,user_ssh_t,devtty_t,chr_file,read).
access_vector(allow,user_ssh_t,devtty_t,chr_file,getattr).
access_vector(allow,user_ssh_t,devtty_t,chr_file,lock).
access_vector(allow,user_ssh_t,devtty_t,chr_file,write).
access_vector(allow,user_ssh_t,devtty_t,chr_file,append).
access_vector(allow,user_ssh_t,zero_device_t,chr_file,ioctl).
access_vector(allow,user_ssh_t,zero_device_t,chr_file,read).
access_vector(allow,user_ssh_t,zero_device_t,chr_file,getattr).
access_vector(allow,user_ssh_t,zero_device_t,chr_file,lock).
access_vector(allow,user_ssh_t,zero_device_t,chr_file,write).
access_vector(allow,user_ssh_t,zero_device_t,chr_file,append).
access_vector(allow,user_ssh_t,self,udp_socket,create).
access_vector(allow,user_ssh_t,self,udp_socket,ioctl).
access_vector(allow,user_ssh_t,self,udp_socket,read).
access_vector(allow,user_ssh_t,self,udp_socket,getattr).
access_vector(allow,user_ssh_t,self,udp_socket,write).
access_vector(allow,user_ssh_t,self,udp_socket,setattr).
access_vector(allow,user_ssh_t,self,udp_socket,append).
access_vector(allow,user_ssh_t,self,udp_socket,bind).
access_vector(allow,user_ssh_t,self,udp_socket,connect).
access_vector(allow,user_ssh_t,self,udp_socket,getopt).
access_vector(allow,user_ssh_t,self,udp_socket,setopt).
access_vector(allow,user_ssh_t,self,udp_socket,shutdown).
access_vector(allow,user_ssh_t,self,tcp_socket,create).
access_vector(allow,user_ssh_t,self,tcp_socket,ioctl).
access_vector(allow,user_ssh_t,self,tcp_socket,read).
access_vector(allow,user_ssh_t,self,tcp_socket,getattr).
access_vector(allow,user_ssh_t,self,tcp_socket,write).
access_vector(allow,user_ssh_t,self,tcp_socket,setattr).
access_vector(allow,user_ssh_t,self,tcp_socket,append).
access_vector(allow,user_ssh_t,self,tcp_socket,bind).
access_vector(allow,user_ssh_t,self,tcp_socket,connect).
access_vector(allow,user_ssh_t,self,tcp_socket,getopt).
access_vector(allow,user_ssh_t,self,tcp_socket,setopt).
access_vector(allow,user_ssh_t,self,tcp_socket,shutdown).
access_vector(allow,user_ssh_t,self,tcp_socket,listen).
access_vector(allow,user_ssh_t,self,tcp_socket,accept).
access_vector(allow,user_ssh_t,any_socket_t,udp_socket,sendto).
access_vector(allow,user_ssh_t,netif_type,netif,tcp_send).
access_vector(allow,user_ssh_t,netif_type,netif,udp_send).
access_vector(allow,user_ssh_t,netif_type,netif,rawip_send).
access_vector(allow,user_ssh_t,netif_type,netif,tcp_recv).
access_vector(allow,user_ssh_t,netif_type,netif,udp_recv).
access_vector(allow,user_ssh_t,netif_type,netif,rawip_recv).
access_vector(allow,user_ssh_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,user_ssh_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,user_ssh_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,user_ssh_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,user_ssh_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,user_ssh_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,user_ssh_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,user_ssh_t,node_type,node,tcp_send).
access_vector(allow,user_ssh_t,node_type,node,udp_send).
access_vector(allow,user_ssh_t,node_type,node,rawip_send).
access_vector(allow,user_ssh_t,node_type,node,tcp_recv).
access_vector(allow,user_ssh_t,node_type,node,udp_recv).
access_vector(allow,user_ssh_t,node_type,node,rawip_recv).
access_vector(allow,user_ssh_t,mount_t,udp_socket,ioctl).
access_vector(allow,user_ssh_t,mount_t,udp_socket,read).
access_vector(allow,user_ssh_t,mount_t,udp_socket,getattr).
access_vector(allow,user_ssh_t,mount_t,udp_socket,write).
access_vector(allow,user_ssh_t,mount_t,udp_socket,setattr).
access_vector(allow,user_ssh_t,mount_t,udp_socket,append).
access_vector(allow,user_ssh_t,mount_t,udp_socket,bind).
access_vector(allow,user_ssh_t,mount_t,udp_socket,connect).
access_vector(allow,user_ssh_t,mount_t,udp_socket,getopt).
access_vector(allow,user_ssh_t,mount_t,udp_socket,setopt).
access_vector(allow,user_ssh_t,mount_t,udp_socket,shutdown).
access_vector(allow,user_ssh_t,port_t,udp_socket,name_bind).
access_vector(allow,user_ssh_t,port_t,tcp_socket,name_bind).
access_vector(allow,user_ssh_t,user_ssh_t,tcp_socket,connectto).
access_vector(allow,user_ssh_t,user_ssh_t,tcp_socket,recvfrom).
access_vector(allow,user_ssh_t,user_ssh_t,tcp_socket,acceptfrom).
access_vector(allow,user_ssh_t,self,capability,setuid).
access_vector(allow,user_ssh_t,self,capability,setgid).
access_vector(allow,user_ssh_t,self,capability,dac_override).
access_vector(allow,user_ssh_t,self,capability,dac_read_search).
access_vector(allow,user_ssh_t,bin_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,bin_t,lnk_file,read).
access_vector(allow,user_ssh_t,sbin_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,sbin_t,lnk_file,read).
access_vector(allow,user_ssh_t,etc_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,etc_t,lnk_file,read).
access_vector(allow,user_ssh_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_ssh_t,device_t,dir,search).
access_vector(allow,user_ssh_t,etc_t,file,read).
access_vector(allow,user_ssh_t,etc_t,file,getattr).
access_vector(allow,user_ssh_t,etc_t,file,lock).
access_vector(allow,user_ssh_t,etc_t,file,execute).
access_vector(allow,user_ssh_t,etc_t,file,ioctl).
access_vector(allow,user_ssh_t,etc_t,file,execute_no_trans).
access_vector(allow,user_ssh_t,lib_t,file,read).
access_vector(allow,user_ssh_t,lib_t,file,getattr).
access_vector(allow,user_ssh_t,lib_t,file,lock).
access_vector(allow,user_ssh_t,lib_t,file,execute).
access_vector(allow,user_ssh_t,lib_t,file,ioctl).
access_vector(allow,user_ssh_t,lib_t,file,execute_no_trans).
access_vector(allow,user_ssh_t,bin_t,file,read).
access_vector(allow,user_ssh_t,bin_t,file,getattr).
access_vector(allow,user_ssh_t,bin_t,file,lock).
access_vector(allow,user_ssh_t,bin_t,file,execute).
access_vector(allow,user_ssh_t,bin_t,file,ioctl).
access_vector(allow,user_ssh_t,bin_t,file,execute_no_trans).
access_vector(allow,user_ssh_t,sbin_t,file,read).
access_vector(allow,user_ssh_t,sbin_t,file,getattr).
access_vector(allow,user_ssh_t,sbin_t,file,lock).
access_vector(allow,user_ssh_t,sbin_t,file,execute).
access_vector(allow,user_ssh_t,sbin_t,file,ioctl).
access_vector(allow,user_ssh_t,sbin_t,file,execute_no_trans).
access_vector(allow,user_ssh_t,exec_type,file,read).
access_vector(allow,user_ssh_t,exec_type,file,getattr).
access_vector(allow,user_ssh_t,exec_type,file,lock).
access_vector(allow,user_ssh_t,exec_type,file,execute).
access_vector(allow,user_ssh_t,exec_type,file,ioctl).
access_vector(allow,user_ssh_t,exec_type,file,execute_no_trans).
access_vector(allow,user_ssh_t,sshd_key_t,file,read).
access_vector(allow,user_ssh_t,sshd_key_t,file,getattr).
access_vector(allow,user_ssh_t,sshd_key_t,file,lock).
access_vector(allow,user_ssh_t,sshd_key_t,file,ioctl).
access_vector(allow,user_ssh_t,tmp_t,dir,read).
access_vector(allow,user_ssh_t,tmp_t,dir,getattr).
access_vector(allow,user_ssh_t,tmp_t,dir,lock).
access_vector(allow,user_ssh_t,tmp_t,dir,search).
access_vector(allow,user_ssh_t,tmp_t,dir,ioctl).
access_vector(allow,user_ssh_t,tmp_t,dir,add_name).
access_vector(allow,user_ssh_t,tmp_t,dir,remove_name).
access_vector(allow,user_ssh_t,tmp_t,dir,write).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,create).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,ioctl).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,read).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,getattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,lock).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,write).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,setattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,append).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,link).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,unlink).
access_vector(allow,user_ssh_t,sshd_tmp_t,file,rename).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,create).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,read).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,lock).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,write).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,setattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,append).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,link).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,unlink).
access_vector(allow,user_ssh_t,sshd_tmp_t,lnk_file,rename).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,create).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,ioctl).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,read).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,getattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,lock).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,write).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,setattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,append).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,link).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,unlink).
access_vector(allow,user_ssh_t,sshd_tmp_t,sock_file,rename).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,create).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,read).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,lock).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,write).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,setattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,append).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,link).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,unlink).
access_vector(allow,user_ssh_t,sshd_tmp_t,fifo_file,rename).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,create).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,read).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,getattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,lock).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,setattr).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,link).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,unlink).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,rename).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,search).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,add_name).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,remove_name).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,reparent).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,write).
access_vector(allow,user_ssh_t,sshd_tmp_t,dir,rmdir).
type_trans(user_ssh_t,tmp_t,dir,sshd_tmp_t).
type_trans(user_ssh_t,tmp_t,[file,lnk_file,sock_file,fifo_file],sshd_tmp_t).
access_vector(allow,user_ssh_t,user_tmp_t,dir,read).
access_vector(allow,user_ssh_t,user_tmp_t,dir,getattr).
access_vector(allow,user_ssh_t,user_tmp_t,dir,lock).
access_vector(allow,user_ssh_t,user_tmp_t,dir,search).
access_vector(allow,user_ssh_t,user_tmp_t,dir,ioctl).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,ioctl).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,read).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,getattr).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,write).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,setattr).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,append).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,bind).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,connect).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,getopt).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,setopt).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,shutdown).
type_decl(user_home_ssh_t,[],[file_type,sysadmfile]).
access_vector(allow,sysadm_ssh_t,user_home_dir_t,dir,read).
access_vector(allow,sysadm_ssh_t,user_home_dir_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,user_home_dir_t,dir,lock).
access_vector(allow,sysadm_ssh_t,user_home_dir_t,dir,search).
access_vector(allow,sysadm_ssh_t,user_home_dir_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,user_home_dir_t,dir,add_name).
access_vector(allow,sysadm_ssh_t,user_home_dir_t,dir,remove_name).
access_vector(allow,sysadm_ssh_t,user_home_dir_t,dir,write).
access_vector(allow,user_ssh_t,user_home_dir_t,dir,read).
access_vector(allow,user_ssh_t,user_home_dir_t,dir,getattr).
access_vector(allow,user_ssh_t,user_home_dir_t,dir,lock).
access_vector(allow,user_ssh_t,user_home_dir_t,dir,search).
access_vector(allow,user_ssh_t,user_home_dir_t,dir,ioctl).
access_vector(allow,user_ssh_t,user_home_dir_t,dir,add_name).
access_vector(allow,user_ssh_t,user_home_dir_t,dir,remove_name).
access_vector(allow,user_ssh_t,user_home_dir_t,dir,write).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,create).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,read).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,lock).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,write).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,setattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,append).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,link).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,unlink).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,rename).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,create).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,write).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,setattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,append).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,link).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,unlink).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,rename).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,create).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,write).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,setattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,append).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,link).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,unlink).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,sock_file,rename).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,create).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,write).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,setattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,append).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,link).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,unlink).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,fifo_file,rename).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,create).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,ioctl).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,read).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,getattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,lock).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,write).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,setattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,append).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,link).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,unlink).
access_vector(allow,user_ssh_t,user_home_ssh_t,file,rename).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,create).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,ioctl).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,read).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,lock).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,write).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,setattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,append).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,link).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,unlink).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,rename).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,create).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,ioctl).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,read).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,getattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,lock).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,write).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,setattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,append).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,link).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,unlink).
access_vector(allow,user_ssh_t,user_home_ssh_t,sock_file,rename).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,create).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,ioctl).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,read).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,getattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,lock).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,write).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,setattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,append).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,link).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,unlink).
access_vector(allow,user_ssh_t,user_home_ssh_t,fifo_file,rename).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,create).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,read).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,lock).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,setattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,link).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,unlink).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,rename).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,search).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,add_name).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,remove_name).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,reparent).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,write).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,rmdir).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,create).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,read).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,getattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,lock).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,setattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,link).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,unlink).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,rename).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,search).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,add_name).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,remove_name).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,reparent).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,write).
access_vector(allow,user_ssh_t,user_home_ssh_t,dir,rmdir).
type_trans([sysadm_ssh_t,user_ssh_t],user_home_dir_t,dir,user_home_ssh_t).
type_trans([sysadm_ssh_t,user_ssh_t],user_home_dir_t,[file,lnk_file,sock_file,fifo_file],user_home_ssh_t).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,read).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,user_home_ssh_t,lnk_file,read).
access_vector(dontaudit,user_ssh_t,user_home_t,dir,search).
access_vector(allow,sshd_t,user_home_ssh_t,dir,read).
access_vector(allow,sshd_t,user_home_ssh_t,dir,getattr).
access_vector(allow,sshd_t,user_home_ssh_t,dir,lock).
access_vector(allow,sshd_t,user_home_ssh_t,dir,search).
access_vector(allow,sshd_t,user_home_ssh_t,dir,ioctl).
access_vector(allow,sshd_t,user_home_ssh_t,file,read).
access_vector(allow,sshd_t,user_home_ssh_t,file,getattr).
access_vector(allow,sshd_t,user_home_ssh_t,file,lock).
access_vector(allow,sshd_t,user_home_ssh_t,file,ioctl).
access_vector(allow,sshd_t,user_home_ssh_t,lnk_file,read).
access_vector(allow,sshd_t,user_home_ssh_t,lnk_file,getattr).
access_vector(allow,sshd_t,user_home_ssh_t,lnk_file,lock).
access_vector(allow,sshd_t,user_home_ssh_t,lnk_file,ioctl).
access_vector(allow,user_t,user_home_ssh_t,dir,read).
access_vector(allow,user_t,user_home_ssh_t,dir,getattr).
access_vector(allow,user_t,user_home_ssh_t,dir,lock).
access_vector(allow,user_t,user_home_ssh_t,dir,search).
access_vector(allow,user_t,user_home_ssh_t,dir,ioctl).
access_vector(allow,user_t,user_home_ssh_t,dir,add_name).
access_vector(allow,user_t,user_home_ssh_t,dir,remove_name).
access_vector(allow,user_t,user_home_ssh_t,dir,write).
access_vector(allow,user_t,user_home_ssh_t,file,create).
access_vector(allow,user_t,user_home_ssh_t,file,ioctl).
access_vector(allow,user_t,user_home_ssh_t,file,read).
access_vector(allow,user_t,user_home_ssh_t,file,getattr).
access_vector(allow,user_t,user_home_ssh_t,file,lock).
access_vector(allow,user_t,user_home_ssh_t,file,write).
access_vector(allow,user_t,user_home_ssh_t,file,setattr).
access_vector(allow,user_t,user_home_ssh_t,file,append).
access_vector(allow,user_t,user_home_ssh_t,file,link).
access_vector(allow,user_t,user_home_ssh_t,file,unlink).
access_vector(allow,user_t,user_home_ssh_t,file,rename).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,create).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,ioctl).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,read).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,getattr).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,lock).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,write).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,setattr).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,append).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,link).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,unlink).
access_vector(allow,user_t,user_home_ssh_t,lnk_file,rename).
access_vector(dontaudit,user_ssh_t,proc_t,dir,search).
access_vector(allow,user_ssh_t,sshd_t,tcp_socket,connectto).
access_vector(allow,user_ssh_t,sshd_t,tcp_socket,recvfrom).
access_vector(allow,sshd_t,user_ssh_t,tcp_socket,acceptfrom).
access_vector(allow,sshd_t,user_ssh_t,tcp_socket,recvfrom).
access_vector(allow,user_ssh_t,user_tty_device_t,chr_file,ioctl).
access_vector(allow,user_ssh_t,user_tty_device_t,chr_file,read).
access_vector(allow,user_ssh_t,user_tty_device_t,chr_file,getattr).
access_vector(allow,user_ssh_t,user_tty_device_t,chr_file,lock).
access_vector(allow,user_ssh_t,user_tty_device_t,chr_file,write).
access_vector(allow,user_ssh_t,user_tty_device_t,chr_file,append).
access_vector(allow,user_ssh_t,user_devpts_t,chr_file,ioctl).
access_vector(allow,user_ssh_t,user_devpts_t,chr_file,read).
access_vector(allow,user_ssh_t,user_devpts_t,chr_file,getattr).
access_vector(allow,user_ssh_t,user_devpts_t,chr_file,lock).
access_vector(allow,user_ssh_t,user_devpts_t,chr_file,write).
access_vector(allow,user_ssh_t,user_devpts_t,chr_file,append).
access_vector(allow,user_t,user_ssh_t,process,signal).
access_vector(allow,user_t,user_ssh_t,dir,search).
access_vector(allow,user_t,user_ssh_t,dir,getattr).
access_vector(allow,user_t,user_ssh_t,dir,read).
access_vector(allow,user_t,user_ssh_t,file,read).
access_vector(allow,user_t,user_ssh_t,file,getattr).
access_vector(allow,user_t,user_ssh_t,lnk_file,read).
access_vector(allow,user_t,user_ssh_t,lnk_file,getattr).
access_vector(allow,user_ssh_t,user_tmp_t,sock_file,write).
access_vector(allow,user_ssh_t,user_t,unix_stream_socket,connectto).
access_vector(allow,user_ssh_t,sshd_t,unix_stream_socket,connectto).
type_decl(user_crond_t,[],[domain,user_crond_domain]).
access_vector(allow,crond_t,user_crond_t,process,transition).
access_vector(dontaudit,crond_t,user_crond_t,process,noatsecure).
access_vector(allow,user_crond_t,crond_t,process,sigchld).
access_vector(allow,user_crond_t,crond_t,fd,use).
access_vector(allow,crond_t,user_crond_t,fd,use).
access_vector(allow,user_crond_t,crond_t,fifo_file,ioctl).
access_vector(allow,user_crond_t,crond_t,fifo_file,read).
access_vector(allow,user_crond_t,crond_t,fifo_file,getattr).
access_vector(allow,user_crond_t,crond_t,fifo_file,lock).
access_vector(allow,user_crond_t,crond_t,fifo_file,write).
access_vector(allow,user_crond_t,crond_t,fifo_file,append).
access_vector(allow,user_crond_t,shell_exec_t,file,read).
access_vector(allow,user_crond_t,shell_exec_t,file,getattr).
access_vector(allow,user_crond_t,shell_exec_t,file,lock).
access_vector(allow,user_crond_t,shell_exec_t,file,execute).
access_vector(allow,user_crond_t,shell_exec_t,file,ioctl).
access_vector(allow,user_crond_t,shell_exec_t,file,entrypoint).
role_decl(user_r,user_crond_t).
access_vector(allow,user_crond_t,self,udp_socket,create).
access_vector(allow,user_crond_t,self,udp_socket,ioctl).
access_vector(allow,user_crond_t,self,udp_socket,read).
access_vector(allow,user_crond_t,self,udp_socket,getattr).
access_vector(allow,user_crond_t,self,udp_socket,write).
access_vector(allow,user_crond_t,self,udp_socket,setattr).
access_vector(allow,user_crond_t,self,udp_socket,append).
access_vector(allow,user_crond_t,self,udp_socket,bind).
access_vector(allow,user_crond_t,self,udp_socket,connect).
access_vector(allow,user_crond_t,self,udp_socket,getopt).
access_vector(allow,user_crond_t,self,udp_socket,setopt).
access_vector(allow,user_crond_t,self,udp_socket,shutdown).
access_vector(allow,user_crond_t,self,tcp_socket,create).
access_vector(allow,user_crond_t,self,tcp_socket,ioctl).
access_vector(allow,user_crond_t,self,tcp_socket,read).
access_vector(allow,user_crond_t,self,tcp_socket,getattr).
access_vector(allow,user_crond_t,self,tcp_socket,write).
access_vector(allow,user_crond_t,self,tcp_socket,setattr).
access_vector(allow,user_crond_t,self,tcp_socket,append).
access_vector(allow,user_crond_t,self,tcp_socket,bind).
access_vector(allow,user_crond_t,self,tcp_socket,connect).
access_vector(allow,user_crond_t,self,tcp_socket,getopt).
access_vector(allow,user_crond_t,self,tcp_socket,setopt).
access_vector(allow,user_crond_t,self,tcp_socket,shutdown).
access_vector(allow,user_crond_t,self,tcp_socket,listen).
access_vector(allow,user_crond_t,self,tcp_socket,accept).
access_vector(allow,user_crond_t,any_socket_t,udp_socket,sendto).
access_vector(allow,user_crond_t,netif_type,netif,tcp_send).
access_vector(allow,user_crond_t,netif_type,netif,udp_send).
access_vector(allow,user_crond_t,netif_type,netif,rawip_send).
access_vector(allow,user_crond_t,netif_type,netif,tcp_recv).
access_vector(allow,user_crond_t,netif_type,netif,udp_recv).
access_vector(allow,user_crond_t,netif_type,netif,rawip_recv).
access_vector(allow,user_crond_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,user_crond_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,user_crond_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,user_crond_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,user_crond_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,user_crond_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,user_crond_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,user_crond_t,node_type,node,tcp_send).
access_vector(allow,user_crond_t,node_type,node,udp_send).
access_vector(allow,user_crond_t,node_type,node,rawip_send).
access_vector(allow,user_crond_t,node_type,node,tcp_recv).
access_vector(allow,user_crond_t,node_type,node,udp_recv).
access_vector(allow,user_crond_t,node_type,node,rawip_recv).
access_vector(allow,user_crond_t,mount_t,udp_socket,ioctl).
access_vector(allow,user_crond_t,mount_t,udp_socket,read).
access_vector(allow,user_crond_t,mount_t,udp_socket,getattr).
access_vector(allow,user_crond_t,mount_t,udp_socket,write).
access_vector(allow,user_crond_t,mount_t,udp_socket,setattr).
access_vector(allow,user_crond_t,mount_t,udp_socket,append).
access_vector(allow,user_crond_t,mount_t,udp_socket,bind).
access_vector(allow,user_crond_t,mount_t,udp_socket,connect).
access_vector(allow,user_crond_t,mount_t,udp_socket,getopt).
access_vector(allow,user_crond_t,mount_t,udp_socket,setopt).
access_vector(allow,user_crond_t,mount_t,udp_socket,shutdown).
access_vector(allow,user_crond_t,port_t,udp_socket,name_bind).
access_vector(allow,user_crond_t,port_t,tcp_socket,name_bind).
access_vector(allow,user_crond_t,resolv_conf_t,file,getattr).
access_vector(allow,user_crond_t,resolv_conf_t,file,read).
access_vector(allow,user_crond_t,root_t,dir,read).
access_vector(allow,user_crond_t,root_t,dir,getattr).
access_vector(allow,user_crond_t,root_t,dir,lock).
access_vector(allow,user_crond_t,root_t,dir,search).
access_vector(allow,user_crond_t,root_t,dir,ioctl).
access_vector(allow,user_crond_t,usr_t,dir,read).
access_vector(allow,user_crond_t,usr_t,dir,getattr).
access_vector(allow,user_crond_t,usr_t,dir,lock).
access_vector(allow,user_crond_t,usr_t,dir,search).
access_vector(allow,user_crond_t,usr_t,dir,ioctl).
access_vector(allow,user_crond_t,lib_t,dir,read).
access_vector(allow,user_crond_t,lib_t,dir,getattr).
access_vector(allow,user_crond_t,lib_t,dir,lock).
access_vector(allow,user_crond_t,lib_t,dir,search).
access_vector(allow,user_crond_t,lib_t,dir,ioctl).
access_vector(allow,user_crond_t,etc_t,dir,read).
access_vector(allow,user_crond_t,etc_t,dir,getattr).
access_vector(allow,user_crond_t,etc_t,dir,lock).
access_vector(allow,user_crond_t,etc_t,dir,search).
access_vector(allow,user_crond_t,etc_t,dir,ioctl).
access_vector(allow,user_crond_t,lib_t,lnk_file,read).
access_vector(allow,user_crond_t,lib_t,lnk_file,getattr).
access_vector(allow,user_crond_t,lib_t,lnk_file,lock).
access_vector(allow,user_crond_t,lib_t,lnk_file,ioctl).
access_vector(allow,user_crond_t,ld_so_t,file,read).
access_vector(allow,user_crond_t,ld_so_t,file,getattr).
access_vector(allow,user_crond_t,ld_so_t,file,lock).
access_vector(allow,user_crond_t,ld_so_t,file,execute).
access_vector(allow,user_crond_t,ld_so_t,file,ioctl).
access_vector(allow,user_crond_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_crond_t,ld_so_t,lnk_file,read).
access_vector(allow,user_crond_t,ld_so_t,lnk_file,getattr).
access_vector(allow,user_crond_t,ld_so_t,lnk_file,lock).
access_vector(allow,user_crond_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,user_crond_t,shlib_t,file,read).
access_vector(allow,user_crond_t,shlib_t,file,getattr).
access_vector(allow,user_crond_t,shlib_t,file,lock).
access_vector(allow,user_crond_t,shlib_t,file,execute).
access_vector(allow,user_crond_t,shlib_t,file,ioctl).
access_vector(allow,user_crond_t,shlib_t,lnk_file,read).
access_vector(allow,user_crond_t,shlib_t,lnk_file,getattr).
access_vector(allow,user_crond_t,shlib_t,lnk_file,lock).
access_vector(allow,user_crond_t,shlib_t,lnk_file,ioctl).
access_vector(allow,user_crond_t,ld_so_cache_t,file,read).
access_vector(allow,user_crond_t,ld_so_cache_t,file,getattr).
access_vector(allow,user_crond_t,ld_so_cache_t,file,lock).
access_vector(allow,user_crond_t,ld_so_cache_t,file,ioctl).
access_vector(allow,user_crond_t,device_t,dir,search).
access_vector(allow,user_crond_t,null_device_t,chr_file,ioctl).
access_vector(allow,user_crond_t,null_device_t,chr_file,read).
access_vector(allow,user_crond_t,null_device_t,chr_file,getattr).
access_vector(allow,user_crond_t,null_device_t,chr_file,lock).
access_vector(allow,user_crond_t,null_device_t,chr_file,write).
access_vector(allow,user_crond_t,null_device_t,chr_file,append).
access_vector(allow,user_crond_t,self,dir,read).
access_vector(allow,user_crond_t,self,dir,getattr).
access_vector(allow,user_crond_t,self,dir,lock).
access_vector(allow,user_crond_t,self,dir,search).
access_vector(allow,user_crond_t,self,dir,ioctl).
access_vector(allow,user_crond_t,self,file,read).
access_vector(allow,user_crond_t,self,file,getattr).
access_vector(allow,user_crond_t,self,file,lock).
access_vector(allow,user_crond_t,self,file,ioctl).
access_vector(allow,user_crond_t,self,lnk_file,read).
access_vector(allow,user_crond_t,self,lnk_file,getattr).
access_vector(allow,user_crond_t,self,lnk_file,lock).
access_vector(allow,user_crond_t,self,lnk_file,ioctl).
access_vector(allow,user_crond_t,self,fifo_file,ioctl).
access_vector(allow,user_crond_t,self,fifo_file,read).
access_vector(allow,user_crond_t,self,fifo_file,getattr).
access_vector(allow,user_crond_t,self,fifo_file,lock).
access_vector(allow,user_crond_t,self,fifo_file,write).
access_vector(allow,user_crond_t,self,fifo_file,append).
access_vector(allow,user_crond_t,self,unix_stream_socket,create).
access_vector(allow,user_crond_t,self,unix_stream_socket,ioctl).
access_vector(allow,user_crond_t,self,unix_stream_socket,read).
access_vector(allow,user_crond_t,self,unix_stream_socket,getattr).
access_vector(allow,user_crond_t,self,unix_stream_socket,write).
access_vector(allow,user_crond_t,self,unix_stream_socket,setattr).
access_vector(allow,user_crond_t,self,unix_stream_socket,append).
access_vector(allow,user_crond_t,self,unix_stream_socket,bind).
access_vector(allow,user_crond_t,self,unix_stream_socket,connect).
access_vector(allow,user_crond_t,self,unix_stream_socket,getopt).
access_vector(allow,user_crond_t,self,unix_stream_socket,setopt).
access_vector(allow,user_crond_t,self,unix_stream_socket,shutdown).
access_vector(allow,user_crond_t,self,unix_dgram_socket,create).
access_vector(allow,user_crond_t,self,unix_dgram_socket,ioctl).
access_vector(allow,user_crond_t,self,unix_dgram_socket,read).
access_vector(allow,user_crond_t,self,unix_dgram_socket,getattr).
access_vector(allow,user_crond_t,self,unix_dgram_socket,write).
access_vector(allow,user_crond_t,self,unix_dgram_socket,setattr).
access_vector(allow,user_crond_t,self,unix_dgram_socket,append).
access_vector(allow,user_crond_t,self,unix_dgram_socket,bind).
access_vector(allow,user_crond_t,self,unix_dgram_socket,connect).
access_vector(allow,user_crond_t,self,unix_dgram_socket,getopt).
access_vector(allow,user_crond_t,self,unix_dgram_socket,setopt).
access_vector(allow,user_crond_t,self,unix_dgram_socket,shutdown).
access_vector(allow,user_crond_t,etc_runtime_t,file,getattr).
access_vector(allow,user_crond_t,etc_runtime_t,file,read).
access_vector(allow,user_crond_t,self,process,fork).
access_vector(allow,user_crond_t,self,process,sigchld).
access_vector(allow,user_crond_t,self,process,sigkill).
access_vector(allow,user_crond_t,self,process,sigstop).
access_vector(allow,user_crond_t,self,process,signull).
access_vector(allow,user_crond_t,self,process,signal).
access_vector(allow,user_crond_t,proc_t,dir,getattr).
access_vector(allow,user_crond_t,proc_t,dir,search).
access_vector(allow,user_crond_t,proc_t,dir,read).
access_vector(allow,user_crond_t,proc_t,file,getattr).
access_vector(allow,user_crond_t,proc_t,file,read).
access_vector(allow,user_crond_t,etc_t,lnk_file,read).
access_vector(allow,user_crond_t,locale_t,dir,read).
access_vector(allow,user_crond_t,locale_t,dir,getattr).
access_vector(allow,user_crond_t,locale_t,dir,lock).
access_vector(allow,user_crond_t,locale_t,dir,search).
access_vector(allow,user_crond_t,locale_t,dir,ioctl).
access_vector(allow,user_crond_t,locale_t,file,read).
access_vector(allow,user_crond_t,locale_t,file,getattr).
access_vector(allow,user_crond_t,locale_t,file,lock).
access_vector(allow,user_crond_t,locale_t,file,ioctl).
access_vector(allow,user_crond_t,locale_t,lnk_file,read).
access_vector(allow,user_crond_t,locale_t,lnk_file,getattr).
access_vector(allow,user_crond_t,locale_t,lnk_file,lock).
access_vector(allow,user_crond_t,locale_t,lnk_file,ioctl).
access_vector(allow,user_crond_t,sysctl_kernel_t,dir,search).
access_vector(allow,user_crond_t,sysctl_kernel_t,file,getattr).
access_vector(allow,user_crond_t,sysctl_kernel_t,file,read).
access_vector(allow,user_crond_t,var_spool_t,dir,search).
access_vector(allow,user_crond_t,fs_t,filesystem,getattr).
access_vector(allow,user_crond_t,devtty_t,chr_file,read).
access_vector(allow,user_crond_t,devtty_t,chr_file,write).
access_vector(allow,user_crond_t,user_crond_t,capability,dac_override).
access_vector(allow,user_crond_t,initrc_t,fd,use).
access_vector(allow,user_crond_t,user_cron_spool_t,file,entrypoint).
access_vector(allow,user_crond_t,home_root_t,dir,search).
access_vector(allow,user_crond_t,user_home_dir_t,dir,read).
access_vector(allow,user_crond_t,user_home_dir_t,dir,getattr).
access_vector(allow,user_crond_t,user_home_dir_t,dir,lock).
access_vector(allow,user_crond_t,user_home_dir_t,dir,search).
access_vector(allow,user_crond_t,user_home_dir_t,dir,ioctl).
access_vector(allow,user_crond_t,user_home_dir_t,dir,add_name).
access_vector(allow,user_crond_t,user_home_dir_t,dir,remove_name).
access_vector(allow,user_crond_t,user_home_dir_t,dir,write).
access_vector(allow,user_crond_t,user_home_t,file,create).
access_vector(allow,user_crond_t,user_home_t,file,ioctl).
access_vector(allow,user_crond_t,user_home_t,file,read).
access_vector(allow,user_crond_t,user_home_t,file,getattr).
access_vector(allow,user_crond_t,user_home_t,file,lock).
access_vector(allow,user_crond_t,user_home_t,file,write).
access_vector(allow,user_crond_t,user_home_t,file,setattr).
access_vector(allow,user_crond_t,user_home_t,file,append).
access_vector(allow,user_crond_t,user_home_t,file,link).
access_vector(allow,user_crond_t,user_home_t,file,unlink).
access_vector(allow,user_crond_t,user_home_t,file,rename).
access_vector(allow,user_crond_t,user_home_t,lnk_file,create).
access_vector(allow,user_crond_t,user_home_t,lnk_file,ioctl).
access_vector(allow,user_crond_t,user_home_t,lnk_file,read).
access_vector(allow,user_crond_t,user_home_t,lnk_file,getattr).
access_vector(allow,user_crond_t,user_home_t,lnk_file,lock).
access_vector(allow,user_crond_t,user_home_t,lnk_file,write).
access_vector(allow,user_crond_t,user_home_t,lnk_file,setattr).
access_vector(allow,user_crond_t,user_home_t,lnk_file,append).
access_vector(allow,user_crond_t,user_home_t,lnk_file,link).
access_vector(allow,user_crond_t,user_home_t,lnk_file,unlink).
access_vector(allow,user_crond_t,user_home_t,lnk_file,rename).
access_vector(allow,user_crond_t,user_home_t,sock_file,create).
access_vector(allow,user_crond_t,user_home_t,sock_file,ioctl).
access_vector(allow,user_crond_t,user_home_t,sock_file,read).
access_vector(allow,user_crond_t,user_home_t,sock_file,getattr).
access_vector(allow,user_crond_t,user_home_t,sock_file,lock).
access_vector(allow,user_crond_t,user_home_t,sock_file,write).
access_vector(allow,user_crond_t,user_home_t,sock_file,setattr).
access_vector(allow,user_crond_t,user_home_t,sock_file,append).
access_vector(allow,user_crond_t,user_home_t,sock_file,link).
access_vector(allow,user_crond_t,user_home_t,sock_file,unlink).
access_vector(allow,user_crond_t,user_home_t,sock_file,rename).
access_vector(allow,user_crond_t,user_home_t,fifo_file,create).
access_vector(allow,user_crond_t,user_home_t,fifo_file,ioctl).
access_vector(allow,user_crond_t,user_home_t,fifo_file,read).
access_vector(allow,user_crond_t,user_home_t,fifo_file,getattr).
access_vector(allow,user_crond_t,user_home_t,fifo_file,lock).
access_vector(allow,user_crond_t,user_home_t,fifo_file,write).
access_vector(allow,user_crond_t,user_home_t,fifo_file,setattr).
access_vector(allow,user_crond_t,user_home_t,fifo_file,append).
access_vector(allow,user_crond_t,user_home_t,fifo_file,link).
access_vector(allow,user_crond_t,user_home_t,fifo_file,unlink).
access_vector(allow,user_crond_t,user_home_t,fifo_file,rename).
access_vector(allow,user_crond_t,user_home_t,dir,create).
access_vector(allow,user_crond_t,user_home_t,dir,read).
access_vector(allow,user_crond_t,user_home_t,dir,getattr).
access_vector(allow,user_crond_t,user_home_t,dir,lock).
access_vector(allow,user_crond_t,user_home_t,dir,setattr).
access_vector(allow,user_crond_t,user_home_t,dir,link).
access_vector(allow,user_crond_t,user_home_t,dir,unlink).
access_vector(allow,user_crond_t,user_home_t,dir,rename).
access_vector(allow,user_crond_t,user_home_t,dir,search).
access_vector(allow,user_crond_t,user_home_t,dir,add_name).
access_vector(allow,user_crond_t,user_home_t,dir,remove_name).
access_vector(allow,user_crond_t,user_home_t,dir,reparent).
access_vector(allow,user_crond_t,user_home_t,dir,write).
access_vector(allow,user_crond_t,user_home_t,dir,rmdir).
type_trans(user_crond_t,user_home_dir_t,dir,user_home_t).
type_trans(user_crond_t,user_home_dir_t,[file,lnk_file,sock_file,fifo_file],user_home_t).
access_vector(allow,user_crond_t,tmp_t,dir,read).
access_vector(allow,user_crond_t,tmp_t,dir,getattr).
access_vector(allow,user_crond_t,tmp_t,dir,lock).
access_vector(allow,user_crond_t,tmp_t,dir,search).
access_vector(allow,user_crond_t,tmp_t,dir,ioctl).
access_vector(allow,user_crond_t,tmp_t,dir,add_name).
access_vector(allow,user_crond_t,tmp_t,dir,remove_name).
access_vector(allow,user_crond_t,tmp_t,dir,write).
access_vector(allow,user_crond_t,user_tmp_t,file,create).
access_vector(allow,user_crond_t,user_tmp_t,file,ioctl).
access_vector(allow,user_crond_t,user_tmp_t,file,read).
access_vector(allow,user_crond_t,user_tmp_t,file,getattr).
access_vector(allow,user_crond_t,user_tmp_t,file,lock).
access_vector(allow,user_crond_t,user_tmp_t,file,write).
access_vector(allow,user_crond_t,user_tmp_t,file,setattr).
access_vector(allow,user_crond_t,user_tmp_t,file,append).
access_vector(allow,user_crond_t,user_tmp_t,file,link).
access_vector(allow,user_crond_t,user_tmp_t,file,unlink).
access_vector(allow,user_crond_t,user_tmp_t,file,rename).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,create).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,ioctl).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,read).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,getattr).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,lock).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,write).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,setattr).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,append).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,link).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,unlink).
access_vector(allow,user_crond_t,user_tmp_t,lnk_file,rename).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,create).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,ioctl).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,read).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,getattr).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,lock).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,write).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,setattr).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,append).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,link).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,unlink).
access_vector(allow,user_crond_t,user_tmp_t,sock_file,rename).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,create).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,ioctl).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,read).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,getattr).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,lock).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,write).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,setattr).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,append).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,link).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,unlink).
access_vector(allow,user_crond_t,user_tmp_t,fifo_file,rename).
access_vector(allow,user_crond_t,user_tmp_t,dir,create).
access_vector(allow,user_crond_t,user_tmp_t,dir,read).
access_vector(allow,user_crond_t,user_tmp_t,dir,getattr).
access_vector(allow,user_crond_t,user_tmp_t,dir,lock).
access_vector(allow,user_crond_t,user_tmp_t,dir,setattr).
access_vector(allow,user_crond_t,user_tmp_t,dir,link).
access_vector(allow,user_crond_t,user_tmp_t,dir,unlink).
access_vector(allow,user_crond_t,user_tmp_t,dir,rename).
access_vector(allow,user_crond_t,user_tmp_t,dir,search).
access_vector(allow,user_crond_t,user_tmp_t,dir,add_name).
access_vector(allow,user_crond_t,user_tmp_t,dir,remove_name).
access_vector(allow,user_crond_t,user_tmp_t,dir,reparent).
access_vector(allow,user_crond_t,user_tmp_t,dir,write).
access_vector(allow,user_crond_t,user_tmp_t,dir,rmdir).
type_trans(user_crond_t,tmp_t,dir,user_tmp_t).
type_trans(user_crond_t,tmp_t,[file,lnk_file,sock_file,fifo_file],user_tmp_t).
access_vector(allow,user_crond_t,bin_t,dir,read).
access_vector(allow,user_crond_t,bin_t,dir,getattr).
access_vector(allow,user_crond_t,bin_t,dir,lock).
access_vector(allow,user_crond_t,bin_t,dir,search).
access_vector(allow,user_crond_t,bin_t,dir,ioctl).
access_vector(allow,user_crond_t,sbin_t,dir,read).
access_vector(allow,user_crond_t,sbin_t,dir,getattr).
access_vector(allow,user_crond_t,sbin_t,dir,lock).
access_vector(allow,user_crond_t,sbin_t,dir,search).
access_vector(allow,user_crond_t,sbin_t,dir,ioctl).
access_vector(allow,user_crond_t,bin_t,lnk_file,getattr).
access_vector(allow,user_crond_t,bin_t,lnk_file,read).
access_vector(allow,user_crond_t,sbin_t,lnk_file,getattr).
access_vector(allow,user_crond_t,sbin_t,lnk_file,read).
access_vector(allow,user_crond_t,etc_t,lnk_file,getattr).
access_vector(allow,user_crond_t,etc_t,lnk_file,read).
access_vector(allow,user_crond_t,ld_so_t,file,execute_no_trans).
access_vector(allow,user_crond_t,device_t,dir,search).
access_vector(allow,user_crond_t,etc_t,file,read).
access_vector(allow,user_crond_t,etc_t,file,getattr).
access_vector(allow,user_crond_t,etc_t,file,lock).
access_vector(allow,user_crond_t,etc_t,file,execute).
access_vector(allow,user_crond_t,etc_t,file,ioctl).
access_vector(allow,user_crond_t,etc_t,file,execute_no_trans).
access_vector(allow,user_crond_t,lib_t,file,read).
access_vector(allow,user_crond_t,lib_t,file,getattr).
access_vector(allow,user_crond_t,lib_t,file,lock).
access_vector(allow,user_crond_t,lib_t,file,execute).
access_vector(allow,user_crond_t,lib_t,file,ioctl).
access_vector(allow,user_crond_t,lib_t,file,execute_no_trans).
access_vector(allow,user_crond_t,bin_t,file,read).
access_vector(allow,user_crond_t,bin_t,file,getattr).
access_vector(allow,user_crond_t,bin_t,file,lock).
access_vector(allow,user_crond_t,bin_t,file,execute).
access_vector(allow,user_crond_t,bin_t,file,ioctl).
access_vector(allow,user_crond_t,bin_t,file,execute_no_trans).
access_vector(allow,user_crond_t,sbin_t,file,read).
access_vector(allow,user_crond_t,sbin_t,file,getattr).
access_vector(allow,user_crond_t,sbin_t,file,lock).
access_vector(allow,user_crond_t,sbin_t,file,execute).
access_vector(allow,user_crond_t,sbin_t,file,ioctl).
access_vector(allow,user_crond_t,sbin_t,file,execute_no_trans).
access_vector(allow,user_crond_t,exec_type,file,read).
access_vector(allow,user_crond_t,exec_type,file,getattr).
access_vector(allow,user_crond_t,exec_type,file,lock).
access_vector(allow,user_crond_t,exec_type,file,execute).
access_vector(allow,user_crond_t,exec_type,file,ioctl).
access_vector(allow,user_crond_t,exec_type,file,execute_no_trans).
access_vector(allow,user_crond_t,user_home_t,file,read).
access_vector(allow,user_crond_t,user_home_t,file,getattr).
access_vector(allow,user_crond_t,user_home_t,file,lock).
access_vector(allow,user_crond_t,user_home_t,file,execute).
access_vector(allow,user_crond_t,user_home_t,file,ioctl).
access_vector(allow,user_crond_t,user_home_t,file,execute_no_trans).
access_vector(dontaudit,user_crond_t,boot_t,dir,search).
access_vector(dontaudit,user_crond_t,domain,dir,getattr).
access_vector(allow,user_t,mouse_device_t,chr_file,read).
access_vector(allow,user_t,mouse_device_t,chr_file,getattr).
access_vector(allow,user_t,mouse_device_t,chr_file,lock).
access_vector(allow,user_t,mouse_device_t,chr_file,ioctl).
access_vector(allow,user_t,misc_device_t,file,ioctl).
access_vector(allow,user_t,misc_device_t,file,read).
access_vector(allow,user_t,misc_device_t,file,getattr).
access_vector(allow,user_t,misc_device_t,file,lock).
access_vector(allow,user_t,misc_device_t,file,write).
access_vector(allow,user_t,misc_device_t,file,append).
access_vector(allow,user_t,misc_device_t,lnk_file,ioctl).
access_vector(allow,user_t,misc_device_t,lnk_file,read).
access_vector(allow,user_t,misc_device_t,lnk_file,getattr).
access_vector(allow,user_t,misc_device_t,lnk_file,lock).
access_vector(allow,user_t,misc_device_t,lnk_file,write).
access_vector(allow,user_t,misc_device_t,lnk_file,append).
access_vector(allow,user_t,misc_device_t,sock_file,ioctl).
access_vector(allow,user_t,misc_device_t,sock_file,read).
access_vector(allow,user_t,misc_device_t,sock_file,getattr).
access_vector(allow,user_t,misc_device_t,sock_file,lock).
access_vector(allow,user_t,misc_device_t,sock_file,write).
access_vector(allow,user_t,misc_device_t,sock_file,append).
access_vector(allow,user_t,misc_device_t,fifo_file,ioctl).
access_vector(allow,user_t,misc_device_t,fifo_file,read).
access_vector(allow,user_t,misc_device_t,fifo_file,getattr).
access_vector(allow,user_t,misc_device_t,fifo_file,lock).
access_vector(allow,user_t,misc_device_t,fifo_file,write).
access_vector(allow,user_t,misc_device_t,fifo_file,append).
access_vector(allow,user_t,misc_device_t,chr_file,ioctl).
access_vector(allow,user_t,misc_device_t,chr_file,read).
access_vector(allow,user_t,misc_device_t,chr_file,getattr).
access_vector(allow,user_t,misc_device_t,chr_file,lock).
access_vector(allow,user_t,misc_device_t,chr_file,write).
access_vector(allow,user_t,misc_device_t,chr_file,append).
access_vector(allow,user_t,misc_device_t,blk_file,ioctl).
access_vector(allow,user_t,misc_device_t,blk_file,read).
access_vector(allow,user_t,misc_device_t,blk_file,getattr).
access_vector(allow,user_t,misc_device_t,blk_file,lock).
access_vector(allow,user_t,misc_device_t,blk_file,write).
access_vector(allow,user_t,misc_device_t,blk_file,append).
access_vector(allow,user_t,self,udp_socket,create).
access_vector(allow,user_t,self,udp_socket,ioctl).
access_vector(allow,user_t,self,udp_socket,read).
access_vector(allow,user_t,self,udp_socket,getattr).
access_vector(allow,user_t,self,udp_socket,write).
access_vector(allow,user_t,self,udp_socket,setattr).
access_vector(allow,user_t,self,udp_socket,append).
access_vector(allow,user_t,self,udp_socket,bind).
access_vector(allow,user_t,self,udp_socket,connect).
access_vector(allow,user_t,self,udp_socket,getopt).
access_vector(allow,user_t,self,udp_socket,setopt).
access_vector(allow,user_t,self,udp_socket,shutdown).
access_vector(allow,user_t,self,tcp_socket,create).
access_vector(allow,user_t,self,tcp_socket,ioctl).
access_vector(allow,user_t,self,tcp_socket,read).
access_vector(allow,user_t,self,tcp_socket,getattr).
access_vector(allow,user_t,self,tcp_socket,write).
access_vector(allow,user_t,self,tcp_socket,setattr).
access_vector(allow,user_t,self,tcp_socket,append).
access_vector(allow,user_t,self,tcp_socket,bind).
access_vector(allow,user_t,self,tcp_socket,connect).
access_vector(allow,user_t,self,tcp_socket,getopt).
access_vector(allow,user_t,self,tcp_socket,setopt).
access_vector(allow,user_t,self,tcp_socket,shutdown).
access_vector(allow,user_t,self,tcp_socket,listen).
access_vector(allow,user_t,self,tcp_socket,accept).
access_vector(allow,user_t,any_socket_t,udp_socket,sendto).
access_vector(allow,user_t,netif_type,netif,tcp_send).
access_vector(allow,user_t,netif_type,netif,udp_send).
access_vector(allow,user_t,netif_type,netif,rawip_send).
access_vector(allow,user_t,netif_type,netif,tcp_recv).
access_vector(allow,user_t,netif_type,netif,udp_recv).
access_vector(allow,user_t,netif_type,netif,rawip_recv).
access_vector(allow,user_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,user_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,user_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,user_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,user_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,user_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,user_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,user_t,node_type,node,tcp_send).
access_vector(allow,user_t,node_type,node,udp_send).
access_vector(allow,user_t,node_type,node,rawip_send).
access_vector(allow,user_t,node_type,node,tcp_recv).
access_vector(allow,user_t,node_type,node,udp_recv).
access_vector(allow,user_t,node_type,node,rawip_recv).
access_vector(allow,user_t,mount_t,udp_socket,ioctl).
access_vector(allow,user_t,mount_t,udp_socket,read).
access_vector(allow,user_t,mount_t,udp_socket,getattr).
access_vector(allow,user_t,mount_t,udp_socket,write).
access_vector(allow,user_t,mount_t,udp_socket,setattr).
access_vector(allow,user_t,mount_t,udp_socket,append).
access_vector(allow,user_t,mount_t,udp_socket,bind).
access_vector(allow,user_t,mount_t,udp_socket,connect).
access_vector(allow,user_t,mount_t,udp_socket,getopt).
access_vector(allow,user_t,mount_t,udp_socket,setopt).
access_vector(allow,user_t,mount_t,udp_socket,shutdown).
access_vector(allow,user_t,port_t,udp_socket,name_bind).
access_vector(allow,user_t,port_t,tcp_socket,name_bind).
access_vector(allow,user_t,resolv_conf_t,file,getattr).
access_vector(allow,user_t,resolv_conf_t,file,read).
access_vector(dontaudit,user_t,resolv_conf_t,file,ioctl).
access_vector(allow,user_t,node_lo_t,node,enforce_dest).
access_vector(allow,user_t,user_t,udp_socket,sendto).
access_vector(allow,user_t,user_t,udp_socket,recvfrom).
access_vector(allow,user_t,user_t,tcp_socket,connectto).
access_vector(allow,user_t,user_t,tcp_socket,recvfrom).
access_vector(allow,user_t,user_t,tcp_socket,acceptfrom).
access_vector(dontaudit,user_t,kernel_t,system,syslog_read).
access_vector(allow,user_t,kernel_t,system,ipc_info).
access_vector(dontaudit,user_t,domain,dir,read).
access_vector(dontaudit,user_t,domain,dir,getattr).
access_vector(dontaudit,user_t,domain,dir,lock).
access_vector(dontaudit,user_t,domain,dir,search).
access_vector(dontaudit,user_t,domain,dir,ioctl).
access_vector(dontaudit,user_t,domain,file,read).
access_vector(dontaudit,user_t,domain,file,getattr).
access_vector(dontaudit,user_t,domain,file,lock).
access_vector(dontaudit,user_t,domain,file,ioctl).
access_vector(dontaudit,user_t,domain,lnk_file,read).
access_vector(dontaudit,user_t,domain,lnk_file,getattr).
access_vector(dontaudit,user_t,domain,lnk_file,lock).
access_vector(dontaudit,user_t,domain,lnk_file,ioctl).
access_vector(dontaudit,user_t,domain,sock_file,read).
access_vector(dontaudit,user_t,domain,sock_file,getattr).
access_vector(dontaudit,user_t,domain,sock_file,lock).
access_vector(dontaudit,user_t,domain,sock_file,ioctl).
access_vector(dontaudit,user_t,domain,fifo_file,read).
access_vector(dontaudit,user_t,domain,fifo_file,getattr).
access_vector(dontaudit,user_t,domain,fifo_file,lock).
access_vector(dontaudit,user_t,domain,fifo_file,ioctl).
access_vector(dontaudit,user_t,initrc_var_run_t,file,getattr).
access_vector(dontaudit,user_t,initrc_var_run_t,file,read).
access_vector(dontaudit,user_t,initrc_var_run_t,file,write).
access_vector(dontaudit,user_t,tmpfile,dir,getattr).
access_vector(dontaudit,user_t,tmpfile,file,getattr).
access_vector(dontaudit,user_t,tmpfile,lnk_file,getattr).
access_vector(dontaudit,user_t,tmpfile,sock_file,getattr).
access_vector(dontaudit,user_t,tmpfile,fifo_file,getattr).
access_vector(dontaudit,user_t,tmpfile,chr_file,getattr).
access_vector(dontaudit,user_t,tmpfile,blk_file,getattr).
access_vector(dontaudit,user_t,removable_device_t,blk_file,getattr).
access_vector(dontaudit,user_t,fixed_disk_device_t,blk_file,getattr).
access_vector(allow,user_t,sound_device_t,chr_file,getattr).
access_vector(allow,user_t,sound_device_t,chr_file,read).
access_vector(allow,user_t,sound_device_t,chr_file,write).
access_vector(allow,user_t,sound_device_t,chr_file,ioctl).
access_vector(allow,user_t,fs_type,filesystem,getattr).
access_vector(allow,user_t,devtty_t,chr_file,ioctl).
access_vector(allow,user_t,devtty_t,chr_file,read).
access_vector(allow,user_t,devtty_t,chr_file,getattr).
access_vector(allow,user_t,devtty_t,chr_file,lock).
access_vector(allow,user_t,devtty_t,chr_file,write).
access_vector(allow,user_t,devtty_t,chr_file,append).
access_vector(allow,user_t,zero_device_t,chr_file,ioctl).
access_vector(allow,user_t,zero_device_t,chr_file,read).
access_vector(allow,user_t,zero_device_t,chr_file,getattr).
access_vector(allow,user_t,zero_device_t,chr_file,lock).
access_vector(allow,user_t,zero_device_t,chr_file,write).
access_vector(allow,user_t,zero_device_t,chr_file,append).
access_vector(allow,user_t,zero_device_t,chr_file,execute).
access_vector(allow,user_t,random_device_t,chr_file,getattr).
access_vector(allow,user_t,random_device_t,chr_file,read).
access_vector(allow,user_t,devpts_t,dir,read).
access_vector(allow,user_t,devpts_t,dir,getattr).
access_vector(allow,user_t,devpts_t,dir,lock).
access_vector(allow,user_t,devpts_t,dir,search).
access_vector(allow,user_t,devpts_t,dir,ioctl).
access_vector(dontaudit,user_su_t,sysadm_home_t,dir,read).
access_vector(dontaudit,user_su_t,sysadm_home_t,dir,getattr).
access_vector(dontaudit,user_su_t,sysadm_home_t,dir,search).
access_vector(dontaudit,user_su_t,sysadm_home_t,dir,write).
access_vector(dontaudit,user_su_t,sysadm_home_t,dir,add_name).
access_vector(dontaudit,user_su_t,sysadm_home_t,dir,remove_name).
access_vector(dontaudit,user_su_t,sysadm_home_t,file,read).
access_vector(dontaudit,user_su_t,sysadm_home_t,file,getattr).
access_vector(dontaudit,user_su_t,sysadm_home_t,file,create).
access_vector(dontaudit,user_su_t,sysadm_home_t,file,write).
access_vector(dontaudit,user_su_t,sysadm_home_t,file,link).
access_vector(dontaudit,user_su_t,sysadm_home_t,file,unlink).
access_vector(dontaudit,user_t,sysadm_home_t,dir,read).
access_vector(dontaudit,user_t,sysadm_home_t,dir,search).
access_vector(dontaudit,user_t,sysadm_home_t,dir,getattr).
access_vector(dontaudit,user_t,sysadm_home_t,file,read).
access_vector(dontaudit,user_t,sysadm_home_t,file,getattr).
access_vector(dontaudit,user_t,sysadm_home_t,file,append).
access_vector(dontaudit,user_t,devlog_t,sock_file,read).
access_vector(dontaudit,user_t,devlog_t,sock_file,write).
access_vector(dontaudit,user_t,syslogd_t,unix_dgram_socket,sendto).
access_vector(dontaudit,user_t,file_t,dir,getattr).
access_vector(dontaudit,user_t,file_t,file,getattr).
access_vector(dontaudit,user_t,file_t,lnk_file,getattr).
type_decl(staff_t,[],[domain,userdomain,unpriv_userdomain,web_client_domain]).
role_decl(staff_r,staff_t).
role_allow(system_r,staff_r).
access_vector(allow,staff_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,staff_t,self,dir,read).
access_vector(allow,staff_t,self,dir,getattr).
access_vector(allow,staff_t,self,dir,lock).
access_vector(allow,staff_t,self,dir,search).
access_vector(allow,staff_t,self,dir,ioctl).
access_vector(allow,staff_t,self,file,read).
access_vector(allow,staff_t,self,file,getattr).
access_vector(allow,staff_t,self,file,lock).
access_vector(allow,staff_t,self,file,ioctl).
access_vector(allow,staff_t,self,lnk_file,read).
access_vector(allow,staff_t,self,lnk_file,getattr).
access_vector(allow,staff_t,self,lnk_file,lock).
access_vector(allow,staff_t,self,lnk_file,ioctl).
access_vector(allow,staff_t,self,sock_file,read).
access_vector(allow,staff_t,self,sock_file,getattr).
access_vector(allow,staff_t,self,sock_file,lock).
access_vector(allow,staff_t,self,sock_file,ioctl).
access_vector(allow,staff_t,self,fifo_file,read).
access_vector(allow,staff_t,self,fifo_file,getattr).
access_vector(allow,staff_t,self,fifo_file,lock).
access_vector(allow,staff_t,self,fifo_file,ioctl).
access_vector(allow,staff_t,self,fd,_).
access_vector(allow,staff_t,self,fifo_file,ioctl).
access_vector(allow,staff_t,self,fifo_file,read).
access_vector(allow,staff_t,self,fifo_file,getattr).
access_vector(allow,staff_t,self,fifo_file,lock).
access_vector(allow,staff_t,self,fifo_file,write).
access_vector(allow,staff_t,self,fifo_file,append).
access_vector(allow,staff_t,self,unix_dgram_socket,create).
access_vector(allow,staff_t,self,unix_dgram_socket,ioctl).
access_vector(allow,staff_t,self,unix_dgram_socket,read).
access_vector(allow,staff_t,self,unix_dgram_socket,getattr).
access_vector(allow,staff_t,self,unix_dgram_socket,write).
access_vector(allow,staff_t,self,unix_dgram_socket,setattr).
access_vector(allow,staff_t,self,unix_dgram_socket,append).
access_vector(allow,staff_t,self,unix_dgram_socket,bind).
access_vector(allow,staff_t,self,unix_dgram_socket,connect).
access_vector(allow,staff_t,self,unix_dgram_socket,getopt).
access_vector(allow,staff_t,self,unix_dgram_socket,setopt).
access_vector(allow,staff_t,self,unix_dgram_socket,shutdown).
access_vector(allow,staff_t,self,unix_stream_socket,create).
access_vector(allow,staff_t,self,unix_stream_socket,ioctl).
access_vector(allow,staff_t,self,unix_stream_socket,read).
access_vector(allow,staff_t,self,unix_stream_socket,getattr).
access_vector(allow,staff_t,self,unix_stream_socket,write).
access_vector(allow,staff_t,self,unix_stream_socket,setattr).
access_vector(allow,staff_t,self,unix_stream_socket,append).
access_vector(allow,staff_t,self,unix_stream_socket,bind).
access_vector(allow,staff_t,self,unix_stream_socket,connect).
access_vector(allow,staff_t,self,unix_stream_socket,getopt).
access_vector(allow,staff_t,self,unix_stream_socket,setopt).
access_vector(allow,staff_t,self,unix_stream_socket,shutdown).
access_vector(allow,staff_t,self,unix_stream_socket,listen).
access_vector(allow,staff_t,self,unix_stream_socket,accept).
access_vector(allow,staff_t,self,unix_dgram_socket,sendto).
access_vector(allow,staff_t,self,unix_stream_socket,connectto).
access_vector(allow,staff_t,self,sem,associate).
access_vector(allow,staff_t,self,sem,getattr).
access_vector(allow,staff_t,self,sem,setattr).
access_vector(allow,staff_t,self,sem,create).
access_vector(allow,staff_t,self,sem,destroy).
access_vector(allow,staff_t,self,sem,read).
access_vector(allow,staff_t,self,sem,write).
access_vector(allow,staff_t,self,sem,unix_read).
access_vector(allow,staff_t,self,sem,unix_write).
access_vector(allow,staff_t,self,msg,send).
access_vector(allow,staff_t,self,msg,receive).
access_vector(allow,staff_t,self,msgq,associate).
access_vector(allow,staff_t,self,msgq,getattr).
access_vector(allow,staff_t,self,msgq,setattr).
access_vector(allow,staff_t,self,msgq,create).
access_vector(allow,staff_t,self,msgq,destroy).
access_vector(allow,staff_t,self,msgq,read).
access_vector(allow,staff_t,self,msgq,write).
access_vector(allow,staff_t,self,msgq,enqueue).
access_vector(allow,staff_t,self,msgq,unix_read).
access_vector(allow,staff_t,self,msgq,unix_write).
access_vector(allow,staff_t,self,shm,associate).
access_vector(allow,staff_t,self,shm,getattr).
access_vector(allow,staff_t,self,shm,setattr).
access_vector(allow,staff_t,self,shm,create).
access_vector(allow,staff_t,self,shm,destroy).
access_vector(allow,staff_t,self,shm,read).
access_vector(allow,staff_t,self,shm,write).
access_vector(allow,staff_t,self,shm,lock).
access_vector(allow,staff_t,self,shm,unix_read).
access_vector(allow,staff_t,self,shm,unix_write).
access_vector(allow,staff_t,proc_t,dir,read).
access_vector(allow,staff_t,proc_t,dir,getattr).
access_vector(allow,staff_t,proc_t,dir,lock).
access_vector(allow,staff_t,proc_t,dir,search).
access_vector(allow,staff_t,proc_t,dir,ioctl).
access_vector(allow,staff_t,proc_t,file,read).
access_vector(allow,staff_t,proc_t,file,getattr).
access_vector(allow,staff_t,proc_t,file,lock).
access_vector(allow,staff_t,proc_t,file,ioctl).
access_vector(allow,staff_t,proc_t,lnk_file,read).
access_vector(allow,staff_t,proc_t,lnk_file,getattr).
access_vector(allow,staff_t,proc_t,lnk_file,lock).
access_vector(allow,staff_t,proc_t,lnk_file,ioctl).
access_vector(allow,staff_t,root_t,dir,read).
access_vector(allow,staff_t,root_t,dir,getattr).
access_vector(allow,staff_t,root_t,dir,lock).
access_vector(allow,staff_t,root_t,dir,search).
access_vector(allow,staff_t,root_t,dir,ioctl).
access_vector(allow,staff_t,root_t,file,read).
access_vector(allow,staff_t,root_t,file,getattr).
access_vector(allow,staff_t,root_t,file,lock).
access_vector(allow,staff_t,root_t,file,ioctl).
access_vector(allow,staff_t,root_t,lnk_file,read).
access_vector(allow,staff_t,root_t,lnk_file,getattr).
access_vector(allow,staff_t,root_t,lnk_file,lock).
access_vector(allow,staff_t,root_t,lnk_file,ioctl).
access_vector(allow,staff_t,root_t,sock_file,read).
access_vector(allow,staff_t,root_t,sock_file,getattr).
access_vector(allow,staff_t,root_t,sock_file,lock).
access_vector(allow,staff_t,root_t,sock_file,ioctl).
access_vector(allow,staff_t,root_t,fifo_file,read).
access_vector(allow,staff_t,root_t,fifo_file,getattr).
access_vector(allow,staff_t,root_t,fifo_file,lock).
access_vector(allow,staff_t,root_t,fifo_file,ioctl).
access_vector(allow,staff_t,home_root_t,dir,read).
access_vector(allow,staff_t,home_root_t,dir,getattr).
access_vector(allow,staff_t,home_root_t,dir,lock).
access_vector(allow,staff_t,home_root_t,dir,search).
access_vector(allow,staff_t,home_root_t,dir,ioctl).
access_vector(allow,staff_t,usr_t,dir,read).
access_vector(allow,staff_t,usr_t,dir,getattr).
access_vector(allow,staff_t,usr_t,dir,lock).
access_vector(allow,staff_t,usr_t,dir,search).
access_vector(allow,staff_t,usr_t,dir,ioctl).
access_vector(allow,staff_t,usr_t,file,read).
access_vector(allow,staff_t,usr_t,file,getattr).
access_vector(allow,staff_t,usr_t,file,lock).
access_vector(allow,staff_t,usr_t,file,ioctl).
access_vector(allow,staff_t,usr_t,lnk_file,read).
access_vector(allow,staff_t,usr_t,lnk_file,getattr).
access_vector(allow,staff_t,usr_t,lnk_file,lock).
access_vector(allow,staff_t,usr_t,lnk_file,ioctl).
access_vector(allow,staff_t,usr_t,sock_file,read).
access_vector(allow,staff_t,usr_t,sock_file,getattr).
access_vector(allow,staff_t,usr_t,sock_file,lock).
access_vector(allow,staff_t,usr_t,sock_file,ioctl).
access_vector(allow,staff_t,usr_t,fifo_file,read).
access_vector(allow,staff_t,usr_t,fifo_file,getattr).
access_vector(allow,staff_t,usr_t,fifo_file,lock).
access_vector(allow,staff_t,usr_t,fifo_file,ioctl).
access_vector(allow,staff_t,bin_t,dir,read).
access_vector(allow,staff_t,bin_t,dir,getattr).
access_vector(allow,staff_t,bin_t,dir,lock).
access_vector(allow,staff_t,bin_t,dir,search).
access_vector(allow,staff_t,bin_t,dir,ioctl).
access_vector(allow,staff_t,bin_t,file,read).
access_vector(allow,staff_t,bin_t,file,getattr).
access_vector(allow,staff_t,bin_t,file,lock).
access_vector(allow,staff_t,bin_t,file,ioctl).
access_vector(allow,staff_t,bin_t,lnk_file,read).
access_vector(allow,staff_t,bin_t,lnk_file,getattr).
access_vector(allow,staff_t,bin_t,lnk_file,lock).
access_vector(allow,staff_t,bin_t,lnk_file,ioctl).
access_vector(allow,staff_t,bin_t,sock_file,read).
access_vector(allow,staff_t,bin_t,sock_file,getattr).
access_vector(allow,staff_t,bin_t,sock_file,lock).
access_vector(allow,staff_t,bin_t,sock_file,ioctl).
access_vector(allow,staff_t,bin_t,fifo_file,read).
access_vector(allow,staff_t,bin_t,fifo_file,getattr).
access_vector(allow,staff_t,bin_t,fifo_file,lock).
access_vector(allow,staff_t,bin_t,fifo_file,ioctl).
access_vector(allow,staff_t,sbin_t,dir,read).
access_vector(allow,staff_t,sbin_t,dir,getattr).
access_vector(allow,staff_t,sbin_t,dir,lock).
access_vector(allow,staff_t,sbin_t,dir,search).
access_vector(allow,staff_t,sbin_t,dir,ioctl).
access_vector(allow,staff_t,sbin_t,file,read).
access_vector(allow,staff_t,sbin_t,file,getattr).
access_vector(allow,staff_t,sbin_t,file,lock).
access_vector(allow,staff_t,sbin_t,file,ioctl).
access_vector(allow,staff_t,sbin_t,lnk_file,read).
access_vector(allow,staff_t,sbin_t,lnk_file,getattr).
access_vector(allow,staff_t,sbin_t,lnk_file,lock).
access_vector(allow,staff_t,sbin_t,lnk_file,ioctl).
access_vector(allow,staff_t,sbin_t,sock_file,read).
access_vector(allow,staff_t,sbin_t,sock_file,getattr).
access_vector(allow,staff_t,sbin_t,sock_file,lock).
access_vector(allow,staff_t,sbin_t,sock_file,ioctl).
access_vector(allow,staff_t,sbin_t,fifo_file,read).
access_vector(allow,staff_t,sbin_t,fifo_file,getattr).
access_vector(allow,staff_t,sbin_t,fifo_file,lock).
access_vector(allow,staff_t,sbin_t,fifo_file,ioctl).
access_vector(allow,staff_t,readable_t,dir,read).
access_vector(allow,staff_t,readable_t,dir,getattr).
access_vector(allow,staff_t,readable_t,dir,lock).
access_vector(allow,staff_t,readable_t,dir,search).
access_vector(allow,staff_t,readable_t,dir,ioctl).
access_vector(allow,staff_t,readable_t,file,read).
access_vector(allow,staff_t,readable_t,file,getattr).
access_vector(allow,staff_t,readable_t,file,lock).
access_vector(allow,staff_t,readable_t,file,ioctl).
access_vector(allow,staff_t,readable_t,lnk_file,read).
access_vector(allow,staff_t,readable_t,lnk_file,getattr).
access_vector(allow,staff_t,readable_t,lnk_file,lock).
access_vector(allow,staff_t,readable_t,lnk_file,ioctl).
access_vector(allow,staff_t,readable_t,sock_file,read).
access_vector(allow,staff_t,readable_t,sock_file,getattr).
access_vector(allow,staff_t,readable_t,sock_file,lock).
access_vector(allow,staff_t,readable_t,sock_file,ioctl).
access_vector(allow,staff_t,readable_t,fifo_file,read).
access_vector(allow,staff_t,readable_t,fifo_file,getattr).
access_vector(allow,staff_t,readable_t,fifo_file,lock).
access_vector(allow,staff_t,readable_t,fifo_file,ioctl).
access_vector(allow,staff_t,file_labels_t,dir,getattr).
access_vector(allow,staff_t,lost_found_t,dir,getattr).
access_vector(allow,staff_t,tmp_t,dir,read).
access_vector(allow,staff_t,tmp_t,dir,getattr).
access_vector(allow,staff_t,tmp_t,dir,lock).
access_vector(allow,staff_t,tmp_t,dir,search).
access_vector(allow,staff_t,tmp_t,dir,ioctl).
access_vector(allow,staff_t,tmp_t,file,read).
access_vector(allow,staff_t,tmp_t,file,getattr).
access_vector(allow,staff_t,tmp_t,file,lock).
access_vector(allow,staff_t,tmp_t,file,ioctl).
access_vector(allow,staff_t,tmp_t,lnk_file,read).
access_vector(allow,staff_t,tmp_t,lnk_file,getattr).
access_vector(allow,staff_t,tmp_t,lnk_file,lock).
access_vector(allow,staff_t,tmp_t,lnk_file,ioctl).
access_vector(allow,staff_t,var_t,dir,read).
access_vector(allow,staff_t,var_t,dir,getattr).
access_vector(allow,staff_t,var_t,dir,lock).
access_vector(allow,staff_t,var_t,dir,search).
access_vector(allow,staff_t,var_t,dir,ioctl).
access_vector(allow,staff_t,var_t,file,read).
access_vector(allow,staff_t,var_t,file,getattr).
access_vector(allow,staff_t,var_t,file,lock).
access_vector(allow,staff_t,var_t,file,ioctl).
access_vector(allow,staff_t,var_t,lnk_file,read).
access_vector(allow,staff_t,var_t,lnk_file,getattr).
access_vector(allow,staff_t,var_t,lnk_file,lock).
access_vector(allow,staff_t,var_t,lnk_file,ioctl).
access_vector(allow,staff_t,var_t,sock_file,read).
access_vector(allow,staff_t,var_t,sock_file,getattr).
access_vector(allow,staff_t,var_t,sock_file,lock).
access_vector(allow,staff_t,var_t,sock_file,ioctl).
access_vector(allow,staff_t,var_t,fifo_file,read).
access_vector(allow,staff_t,var_t,fifo_file,getattr).
access_vector(allow,staff_t,var_t,fifo_file,lock).
access_vector(allow,staff_t,var_t,fifo_file,ioctl).
access_vector(allow,staff_t,var_spool_t,dir,read).
access_vector(allow,staff_t,var_spool_t,dir,getattr).
access_vector(allow,staff_t,var_spool_t,dir,lock).
access_vector(allow,staff_t,var_spool_t,dir,search).
access_vector(allow,staff_t,var_spool_t,dir,ioctl).
access_vector(allow,staff_t,var_spool_t,file,read).
access_vector(allow,staff_t,var_spool_t,file,getattr).
access_vector(allow,staff_t,var_spool_t,file,lock).
access_vector(allow,staff_t,var_spool_t,file,ioctl).
access_vector(allow,staff_t,var_spool_t,lnk_file,read).
access_vector(allow,staff_t,var_spool_t,lnk_file,getattr).
access_vector(allow,staff_t,var_spool_t,lnk_file,lock).
access_vector(allow,staff_t,var_spool_t,lnk_file,ioctl).
access_vector(allow,staff_t,var_spool_t,sock_file,read).
access_vector(allow,staff_t,var_spool_t,sock_file,getattr).
access_vector(allow,staff_t,var_spool_t,sock_file,lock).
access_vector(allow,staff_t,var_spool_t,sock_file,ioctl).
access_vector(allow,staff_t,var_spool_t,fifo_file,read).
access_vector(allow,staff_t,var_spool_t,fifo_file,getattr).
access_vector(allow,staff_t,var_spool_t,fifo_file,lock).
access_vector(allow,staff_t,var_spool_t,fifo_file,ioctl).
access_vector(allow,staff_t,var_run_t,dir,read).
access_vector(allow,staff_t,var_run_t,dir,getattr).
access_vector(allow,staff_t,var_run_t,dir,lock).
access_vector(allow,staff_t,var_run_t,dir,search).
access_vector(allow,staff_t,var_run_t,dir,ioctl).
access_vector(allow,staff_t,var_run_t,file,read).
access_vector(allow,staff_t,var_run_t,file,getattr).
access_vector(allow,staff_t,var_run_t,file,lock).
access_vector(allow,staff_t,var_run_t,file,ioctl).
access_vector(allow,staff_t,var_run_t,lnk_file,read).
access_vector(allow,staff_t,var_run_t,lnk_file,getattr).
access_vector(allow,staff_t,var_run_t,lnk_file,lock).
access_vector(allow,staff_t,var_run_t,lnk_file,ioctl).
access_vector(allow,staff_t,sysctl_kernel_t,dir,search).
access_vector(allow,staff_t,sysctl_kernel_t,file,getattr).
access_vector(allow,staff_t,sysctl_kernel_t,file,read).
access_vector(allow,staff_t,etc_t,dir,read).
access_vector(allow,staff_t,etc_t,dir,getattr).
access_vector(allow,staff_t,etc_t,dir,lock).
access_vector(allow,staff_t,etc_t,dir,search).
access_vector(allow,staff_t,etc_t,dir,ioctl).
access_vector(allow,staff_t,etc_t,file,read).
access_vector(allow,staff_t,etc_t,file,getattr).
access_vector(allow,staff_t,etc_t,file,lock).
access_vector(allow,staff_t,etc_t,file,ioctl).
access_vector(allow,staff_t,etc_t,lnk_file,read).
access_vector(allow,staff_t,etc_t,lnk_file,getattr).
access_vector(allow,staff_t,etc_t,lnk_file,lock).
access_vector(allow,staff_t,etc_t,lnk_file,ioctl).
access_vector(allow,staff_t,etc_t,sock_file,read).
access_vector(allow,staff_t,etc_t,sock_file,getattr).
access_vector(allow,staff_t,etc_t,sock_file,lock).
access_vector(allow,staff_t,etc_t,sock_file,ioctl).
access_vector(allow,staff_t,etc_t,fifo_file,read).
access_vector(allow,staff_t,etc_t,fifo_file,getattr).
access_vector(allow,staff_t,etc_t,fifo_file,lock).
access_vector(allow,staff_t,etc_t,fifo_file,ioctl).
access_vector(allow,staff_t,etc_runtime_t,file,read).
access_vector(allow,staff_t,etc_runtime_t,file,getattr).
access_vector(allow,staff_t,etc_runtime_t,file,lock).
access_vector(allow,staff_t,etc_runtime_t,file,ioctl).
access_vector(allow,staff_t,etc_runtime_t,lnk_file,read).
access_vector(allow,staff_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,staff_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,staff_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,staff_t,modules_conf_t,file,getattr).
access_vector(allow,staff_t,modules_conf_t,file,read).
access_vector(allow,staff_t,man_t,dir,read).
access_vector(allow,staff_t,man_t,dir,getattr).
access_vector(allow,staff_t,man_t,dir,lock).
access_vector(allow,staff_t,man_t,dir,search).
access_vector(allow,staff_t,man_t,dir,ioctl).
access_vector(allow,staff_t,man_t,file,read).
access_vector(allow,staff_t,man_t,file,getattr).
access_vector(allow,staff_t,man_t,file,lock).
access_vector(allow,staff_t,man_t,file,ioctl).
access_vector(allow,staff_t,man_t,lnk_file,read).
access_vector(allow,staff_t,man_t,lnk_file,getattr).
access_vector(allow,staff_t,man_t,lnk_file,lock).
access_vector(allow,staff_t,man_t,lnk_file,ioctl).
access_vector(allow,staff_t,man_t,sock_file,read).
access_vector(allow,staff_t,man_t,sock_file,getattr).
access_vector(allow,staff_t,man_t,sock_file,lock).
access_vector(allow,staff_t,man_t,sock_file,ioctl).
access_vector(allow,staff_t,man_t,fifo_file,read).
access_vector(allow,staff_t,man_t,fifo_file,getattr).
access_vector(allow,staff_t,man_t,fifo_file,lock).
access_vector(allow,staff_t,man_t,fifo_file,ioctl).
access_vector(allow,staff_t,device_t,dir,read).
access_vector(allow,staff_t,device_t,dir,getattr).
access_vector(allow,staff_t,device_t,dir,lock).
access_vector(allow,staff_t,device_t,dir,search).
access_vector(allow,staff_t,device_t,dir,ioctl).
access_vector(allow,staff_t,device_t,lnk_file,read).
access_vector(allow,staff_t,device_t,lnk_file,getattr).
access_vector(allow,staff_t,device_t,lnk_file,lock).
access_vector(allow,staff_t,device_t,lnk_file,ioctl).
access_vector(dontaudit,staff_t,ld_so_cache_t,file,write).
access_vector(allow,staff_t,lib_t,dir,read).
access_vector(allow,staff_t,lib_t,dir,getattr).
access_vector(allow,staff_t,lib_t,dir,lock).
access_vector(allow,staff_t,lib_t,dir,search).
access_vector(allow,staff_t,lib_t,dir,ioctl).
access_vector(allow,staff_t,lib_t,lnk_file,read).
access_vector(allow,staff_t,lib_t,lnk_file,getattr).
access_vector(allow,staff_t,lib_t,lnk_file,lock).
access_vector(allow,staff_t,lib_t,lnk_file,ioctl).
access_vector(allow,staff_t,ld_so_t,file,read).
access_vector(allow,staff_t,ld_so_t,file,getattr).
access_vector(allow,staff_t,ld_so_t,file,lock).
access_vector(allow,staff_t,ld_so_t,file,execute).
access_vector(allow,staff_t,ld_so_t,file,ioctl).
access_vector(allow,staff_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_t,ld_so_t,lnk_file,read).
access_vector(allow,staff_t,ld_so_t,lnk_file,getattr).
access_vector(allow,staff_t,ld_so_t,lnk_file,lock).
access_vector(allow,staff_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,staff_t,shlib_t,file,read).
access_vector(allow,staff_t,shlib_t,file,getattr).
access_vector(allow,staff_t,shlib_t,file,lock).
access_vector(allow,staff_t,shlib_t,file,execute).
access_vector(allow,staff_t,shlib_t,file,ioctl).
access_vector(allow,staff_t,shlib_t,lnk_file,read).
access_vector(allow,staff_t,shlib_t,lnk_file,getattr).
access_vector(allow,staff_t,shlib_t,lnk_file,lock).
access_vector(allow,staff_t,shlib_t,lnk_file,ioctl).
access_vector(allow,staff_t,ld_so_cache_t,file,read).
access_vector(allow,staff_t,ld_so_cache_t,file,getattr).
access_vector(allow,staff_t,ld_so_cache_t,file,lock).
access_vector(allow,staff_t,ld_so_cache_t,file,ioctl).
access_vector(allow,staff_t,device_t,dir,search).
access_vector(allow,staff_t,null_device_t,chr_file,ioctl).
access_vector(allow,staff_t,null_device_t,chr_file,read).
access_vector(allow,staff_t,null_device_t,chr_file,getattr).
access_vector(allow,staff_t,null_device_t,chr_file,lock).
access_vector(allow,staff_t,null_device_t,chr_file,write).
access_vector(allow,staff_t,null_device_t,chr_file,append).
access_vector(allow,staff_t,self,capability,setgid).
access_vector(allow,staff_t,self,capability,chown).
access_vector(allow,staff_t,self,capability,fowner).
access_vector(dontaudit,staff_t,self,capability,sys_nice).
access_vector(dontaudit,staff_t,self,capability,fsetid).
type_decl(staff_home_dir_t,[],[file_type,sysadmfile,home_dir_type,user_home_dir_type,home_type,user_home_type]).
type_decl(staff_home_t,[],[file_type,sysadmfile,home_type,user_home_type]).
access_vector(allow,privhome,staff_home_dir_t,dir,read).
access_vector(allow,privhome,staff_home_dir_t,dir,getattr).
access_vector(allow,privhome,staff_home_dir_t,dir,lock).
access_vector(allow,privhome,staff_home_dir_t,dir,search).
access_vector(allow,privhome,staff_home_dir_t,dir,ioctl).
access_vector(allow,privhome,staff_home_dir_t,dir,add_name).
access_vector(allow,privhome,staff_home_dir_t,dir,remove_name).
access_vector(allow,privhome,staff_home_dir_t,dir,write).
access_vector(allow,privhome,staff_home_t,file,create).
access_vector(allow,privhome,staff_home_t,file,ioctl).
access_vector(allow,privhome,staff_home_t,file,read).
access_vector(allow,privhome,staff_home_t,file,getattr).
access_vector(allow,privhome,staff_home_t,file,lock).
access_vector(allow,privhome,staff_home_t,file,write).
access_vector(allow,privhome,staff_home_t,file,setattr).
access_vector(allow,privhome,staff_home_t,file,append).
access_vector(allow,privhome,staff_home_t,file,link).
access_vector(allow,privhome,staff_home_t,file,unlink).
access_vector(allow,privhome,staff_home_t,file,rename).
access_vector(allow,privhome,staff_home_t,lnk_file,create).
access_vector(allow,privhome,staff_home_t,lnk_file,ioctl).
access_vector(allow,privhome,staff_home_t,lnk_file,read).
access_vector(allow,privhome,staff_home_t,lnk_file,getattr).
access_vector(allow,privhome,staff_home_t,lnk_file,lock).
access_vector(allow,privhome,staff_home_t,lnk_file,write).
access_vector(allow,privhome,staff_home_t,lnk_file,setattr).
access_vector(allow,privhome,staff_home_t,lnk_file,append).
access_vector(allow,privhome,staff_home_t,lnk_file,link).
access_vector(allow,privhome,staff_home_t,lnk_file,unlink).
access_vector(allow,privhome,staff_home_t,lnk_file,rename).
access_vector(allow,privhome,staff_home_t,sock_file,create).
access_vector(allow,privhome,staff_home_t,sock_file,ioctl).
access_vector(allow,privhome,staff_home_t,sock_file,read).
access_vector(allow,privhome,staff_home_t,sock_file,getattr).
access_vector(allow,privhome,staff_home_t,sock_file,lock).
access_vector(allow,privhome,staff_home_t,sock_file,write).
access_vector(allow,privhome,staff_home_t,sock_file,setattr).
access_vector(allow,privhome,staff_home_t,sock_file,append).
access_vector(allow,privhome,staff_home_t,sock_file,link).
access_vector(allow,privhome,staff_home_t,sock_file,unlink).
access_vector(allow,privhome,staff_home_t,sock_file,rename).
access_vector(allow,privhome,staff_home_t,fifo_file,create).
access_vector(allow,privhome,staff_home_t,fifo_file,ioctl).
access_vector(allow,privhome,staff_home_t,fifo_file,read).
access_vector(allow,privhome,staff_home_t,fifo_file,getattr).
access_vector(allow,privhome,staff_home_t,fifo_file,lock).
access_vector(allow,privhome,staff_home_t,fifo_file,write).
access_vector(allow,privhome,staff_home_t,fifo_file,setattr).
access_vector(allow,privhome,staff_home_t,fifo_file,append).
access_vector(allow,privhome,staff_home_t,fifo_file,link).
access_vector(allow,privhome,staff_home_t,fifo_file,unlink).
access_vector(allow,privhome,staff_home_t,fifo_file,rename).
access_vector(allow,privhome,staff_home_t,dir,create).
access_vector(allow,privhome,staff_home_t,dir,read).
access_vector(allow,privhome,staff_home_t,dir,getattr).
access_vector(allow,privhome,staff_home_t,dir,lock).
access_vector(allow,privhome,staff_home_t,dir,setattr).
access_vector(allow,privhome,staff_home_t,dir,link).
access_vector(allow,privhome,staff_home_t,dir,unlink).
access_vector(allow,privhome,staff_home_t,dir,rename).
access_vector(allow,privhome,staff_home_t,dir,search).
access_vector(allow,privhome,staff_home_t,dir,add_name).
access_vector(allow,privhome,staff_home_t,dir,remove_name).
access_vector(allow,privhome,staff_home_t,dir,reparent).
access_vector(allow,privhome,staff_home_t,dir,write).
access_vector(allow,privhome,staff_home_t,dir,rmdir).
type_trans(privhome,staff_home_dir_t,dir,staff_home_t).
type_trans(privhome,staff_home_dir_t,[file,lnk_file,sock_file,fifo_file],staff_home_t).
type_decl(staff_tmp_t,[],[file_type,sysadmfile,tmpfile,user_tmpfile]).
access_vector(allow,staff_t,tmp_t,dir,read).
access_vector(allow,staff_t,tmp_t,dir,getattr).
access_vector(allow,staff_t,tmp_t,dir,lock).
access_vector(allow,staff_t,tmp_t,dir,search).
access_vector(allow,staff_t,tmp_t,dir,ioctl).
access_vector(allow,staff_t,tmp_t,dir,add_name).
access_vector(allow,staff_t,tmp_t,dir,remove_name).
access_vector(allow,staff_t,tmp_t,dir,write).
access_vector(allow,staff_t,staff_tmp_t,file,create).
access_vector(allow,staff_t,staff_tmp_t,file,ioctl).
access_vector(allow,staff_t,staff_tmp_t,file,read).
access_vector(allow,staff_t,staff_tmp_t,file,getattr).
access_vector(allow,staff_t,staff_tmp_t,file,lock).
access_vector(allow,staff_t,staff_tmp_t,file,write).
access_vector(allow,staff_t,staff_tmp_t,file,setattr).
access_vector(allow,staff_t,staff_tmp_t,file,append).
access_vector(allow,staff_t,staff_tmp_t,file,link).
access_vector(allow,staff_t,staff_tmp_t,file,unlink).
access_vector(allow,staff_t,staff_tmp_t,file,rename).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,create).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,ioctl).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,read).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,getattr).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,lock).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,write).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,setattr).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,append).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,link).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,unlink).
access_vector(allow,staff_t,staff_tmp_t,lnk_file,rename).
access_vector(allow,staff_t,staff_tmp_t,sock_file,create).
access_vector(allow,staff_t,staff_tmp_t,sock_file,ioctl).
access_vector(allow,staff_t,staff_tmp_t,sock_file,read).
access_vector(allow,staff_t,staff_tmp_t,sock_file,getattr).
access_vector(allow,staff_t,staff_tmp_t,sock_file,lock).
access_vector(allow,staff_t,staff_tmp_t,sock_file,write).
access_vector(allow,staff_t,staff_tmp_t,sock_file,setattr).
access_vector(allow,staff_t,staff_tmp_t,sock_file,append).
access_vector(allow,staff_t,staff_tmp_t,sock_file,link).
access_vector(allow,staff_t,staff_tmp_t,sock_file,unlink).
access_vector(allow,staff_t,staff_tmp_t,sock_file,rename).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,create).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,ioctl).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,read).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,getattr).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,lock).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,write).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,setattr).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,append).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,link).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,unlink).
access_vector(allow,staff_t,staff_tmp_t,fifo_file,rename).
access_vector(allow,staff_t,staff_tmp_t,dir,create).
access_vector(allow,staff_t,staff_tmp_t,dir,read).
access_vector(allow,staff_t,staff_tmp_t,dir,getattr).
access_vector(allow,staff_t,staff_tmp_t,dir,lock).
access_vector(allow,staff_t,staff_tmp_t,dir,setattr).
access_vector(allow,staff_t,staff_tmp_t,dir,link).
access_vector(allow,staff_t,staff_tmp_t,dir,unlink).
access_vector(allow,staff_t,staff_tmp_t,dir,rename).
access_vector(allow,staff_t,staff_tmp_t,dir,search).
access_vector(allow,staff_t,staff_tmp_t,dir,add_name).
access_vector(allow,staff_t,staff_tmp_t,dir,remove_name).
access_vector(allow,staff_t,staff_tmp_t,dir,reparent).
access_vector(allow,staff_t,staff_tmp_t,dir,write).
access_vector(allow,staff_t,staff_tmp_t,dir,rmdir).
type_trans(staff_t,tmp_t,dir,staff_tmp_t).
type_trans(staff_t,tmp_t,[file,lnk_file,sock_file,fifo_file],staff_tmp_t).
access_vector(allow,staff_t,staff_home_dir_t,dir,read).
access_vector(allow,staff_t,staff_home_dir_t,dir,getattr).
access_vector(allow,staff_t,staff_home_dir_t,dir,lock).
access_vector(allow,staff_t,staff_home_dir_t,dir,search).
access_vector(allow,staff_t,staff_home_dir_t,dir,ioctl).
access_vector(allow,staff_t,staff_home_dir_t,dir,add_name).
access_vector(allow,staff_t,staff_home_dir_t,dir,remove_name).
access_vector(allow,staff_t,staff_home_dir_t,dir,write).
access_vector(allow,staff_t,staff_home_t,file,create).
access_vector(allow,staff_t,staff_home_t,file,ioctl).
access_vector(allow,staff_t,staff_home_t,file,read).
access_vector(allow,staff_t,staff_home_t,file,getattr).
access_vector(allow,staff_t,staff_home_t,file,lock).
access_vector(allow,staff_t,staff_home_t,file,write).
access_vector(allow,staff_t,staff_home_t,file,setattr).
access_vector(allow,staff_t,staff_home_t,file,append).
access_vector(allow,staff_t,staff_home_t,file,link).
access_vector(allow,staff_t,staff_home_t,file,unlink).
access_vector(allow,staff_t,staff_home_t,file,rename).
access_vector(allow,staff_t,staff_home_t,lnk_file,create).
access_vector(allow,staff_t,staff_home_t,lnk_file,ioctl).
access_vector(allow,staff_t,staff_home_t,lnk_file,read).
access_vector(allow,staff_t,staff_home_t,lnk_file,getattr).
access_vector(allow,staff_t,staff_home_t,lnk_file,lock).
access_vector(allow,staff_t,staff_home_t,lnk_file,write).
access_vector(allow,staff_t,staff_home_t,lnk_file,setattr).
access_vector(allow,staff_t,staff_home_t,lnk_file,append).
access_vector(allow,staff_t,staff_home_t,lnk_file,link).
access_vector(allow,staff_t,staff_home_t,lnk_file,unlink).
access_vector(allow,staff_t,staff_home_t,lnk_file,rename).
access_vector(allow,staff_t,staff_home_t,sock_file,create).
access_vector(allow,staff_t,staff_home_t,sock_file,ioctl).
access_vector(allow,staff_t,staff_home_t,sock_file,read).
access_vector(allow,staff_t,staff_home_t,sock_file,getattr).
access_vector(allow,staff_t,staff_home_t,sock_file,lock).
access_vector(allow,staff_t,staff_home_t,sock_file,write).
access_vector(allow,staff_t,staff_home_t,sock_file,setattr).
access_vector(allow,staff_t,staff_home_t,sock_file,append).
access_vector(allow,staff_t,staff_home_t,sock_file,link).
access_vector(allow,staff_t,staff_home_t,sock_file,unlink).
access_vector(allow,staff_t,staff_home_t,sock_file,rename).
access_vector(allow,staff_t,staff_home_t,fifo_file,create).
access_vector(allow,staff_t,staff_home_t,fifo_file,ioctl).
access_vector(allow,staff_t,staff_home_t,fifo_file,read).
access_vector(allow,staff_t,staff_home_t,fifo_file,getattr).
access_vector(allow,staff_t,staff_home_t,fifo_file,lock).
access_vector(allow,staff_t,staff_home_t,fifo_file,write).
access_vector(allow,staff_t,staff_home_t,fifo_file,setattr).
access_vector(allow,staff_t,staff_home_t,fifo_file,append).
access_vector(allow,staff_t,staff_home_t,fifo_file,link).
access_vector(allow,staff_t,staff_home_t,fifo_file,unlink).
access_vector(allow,staff_t,staff_home_t,fifo_file,rename).
access_vector(allow,staff_t,staff_home_t,dir,create).
access_vector(allow,staff_t,staff_home_t,dir,read).
access_vector(allow,staff_t,staff_home_t,dir,getattr).
access_vector(allow,staff_t,staff_home_t,dir,lock).
access_vector(allow,staff_t,staff_home_t,dir,setattr).
access_vector(allow,staff_t,staff_home_t,dir,link).
access_vector(allow,staff_t,staff_home_t,dir,unlink).
access_vector(allow,staff_t,staff_home_t,dir,rename).
access_vector(allow,staff_t,staff_home_t,dir,search).
access_vector(allow,staff_t,staff_home_t,dir,add_name).
access_vector(allow,staff_t,staff_home_t,dir,remove_name).
access_vector(allow,staff_t,staff_home_t,dir,reparent).
access_vector(allow,staff_t,staff_home_t,dir,write).
access_vector(allow,staff_t,staff_home_t,dir,rmdir).
type_trans(staff_t,staff_home_dir_t,dir,staff_home_t).
type_trans(staff_t,staff_home_dir_t,[file,lnk_file,sock_file,fifo_file],staff_home_t).
access_vector(allow,staff_t,staff_home_t,dir,relabelfrom).
access_vector(allow,staff_t,staff_home_t,dir,relabelto).
access_vector(allow,staff_t,staff_home_t,file,relabelfrom).
access_vector(allow,staff_t,staff_home_t,file,relabelto).
access_vector(allow,staff_t,staff_home_t,lnk_file,relabelfrom).
access_vector(allow,staff_t,staff_home_t,lnk_file,relabelto).
access_vector(allow,staff_t,staff_home_t,sock_file,relabelfrom).
access_vector(allow,staff_t,staff_home_t,sock_file,relabelto).
access_vector(allow,staff_t,staff_home_t,fifo_file,relabelfrom).
access_vector(allow,staff_t,staff_home_t,fifo_file,relabelto).
access_vector(allow,staff_t,staff_home_t,chr_file,relabelfrom).
access_vector(allow,staff_t,staff_home_t,chr_file,relabelto).
access_vector(allow,staff_t,staff_home_t,blk_file,relabelfrom).
access_vector(allow,staff_t,staff_home_t,blk_file,relabelto).
access_vector(allow,staff_t,staff_tmp_t,unix_stream_socket,name_bind).
type_decl(staff_tty_device_t,[],[file_type,sysadmfile,ttyfile]).
access_vector(allow,staff_t,privfd,fd,use).
access_vector(allow,staff_t,staff_tty_device_t,chr_file,setattr).
access_vector(allow,staff_t,staff_tty_device_t,chr_file,ioctl).
access_vector(allow,staff_t,staff_tty_device_t,chr_file,read).
access_vector(allow,staff_t,staff_tty_device_t,chr_file,getattr).
access_vector(allow,staff_t,staff_tty_device_t,chr_file,lock).
access_vector(allow,staff_t,staff_tty_device_t,chr_file,write).
access_vector(allow,staff_t,staff_tty_device_t,chr_file,append).
type_change(staff_t,tty_device_t,chr_file,staff_tty_device_t).
type_change(staff_t,ttyfile,chr_file,staff_tty_device_t).
access_vector(allow,staff_t,var_lib_t,dir,read).
access_vector(allow,staff_t,var_lib_t,dir,getattr).
access_vector(allow,staff_t,var_lib_t,dir,lock).
access_vector(allow,staff_t,var_lib_t,dir,search).
access_vector(allow,staff_t,var_lib_t,dir,ioctl).
access_vector(allow,staff_t,etc_dpkg_t,dir,read).
access_vector(allow,staff_t,etc_dpkg_t,dir,getattr).
access_vector(allow,staff_t,etc_dpkg_t,dir,lock).
access_vector(allow,staff_t,etc_dpkg_t,dir,search).
access_vector(allow,staff_t,etc_dpkg_t,dir,ioctl).
access_vector(allow,staff_t,etc_dpkg_t,file,read).
access_vector(allow,staff_t,etc_dpkg_t,file,getattr).
access_vector(allow,staff_t,etc_dpkg_t,file,lock).
access_vector(allow,staff_t,etc_dpkg_t,file,ioctl).
access_vector(allow,staff_t,etc_dpkg_t,lnk_file,read).
access_vector(allow,staff_t,etc_dpkg_t,lnk_file,getattr).
access_vector(allow,staff_t,etc_dpkg_t,lnk_file,lock).
access_vector(allow,staff_t,etc_dpkg_t,lnk_file,ioctl).
access_vector(allow,staff_t,locale_t,dir,read).
access_vector(allow,staff_t,locale_t,dir,getattr).
access_vector(allow,staff_t,locale_t,dir,lock).
access_vector(allow,staff_t,locale_t,dir,search).
access_vector(allow,staff_t,locale_t,dir,ioctl).
access_vector(allow,staff_t,locale_t,file,read).
access_vector(allow,staff_t,locale_t,file,getattr).
access_vector(allow,staff_t,locale_t,file,lock).
access_vector(allow,staff_t,locale_t,file,ioctl).
access_vector(allow,staff_t,locale_t,lnk_file,read).
access_vector(allow,staff_t,locale_t,lnk_file,getattr).
access_vector(allow,staff_t,locale_t,lnk_file,lock).
access_vector(allow,staff_t,locale_t,lnk_file,ioctl).
access_vector(allow,staff_t,tetex_data_t,dir,read).
access_vector(allow,staff_t,tetex_data_t,dir,getattr).
access_vector(allow,staff_t,tetex_data_t,dir,lock).
access_vector(allow,staff_t,tetex_data_t,dir,search).
access_vector(allow,staff_t,tetex_data_t,dir,ioctl).
access_vector(allow,staff_t,tetex_data_t,file,read).
access_vector(allow,staff_t,tetex_data_t,file,getattr).
access_vector(allow,staff_t,tetex_data_t,file,lock).
access_vector(allow,staff_t,tetex_data_t,file,ioctl).
access_vector(allow,staff_t,tetex_data_t,lnk_file,read).
access_vector(allow,staff_t,tetex_data_t,lnk_file,getattr).
access_vector(allow,staff_t,tetex_data_t,lnk_file,lock).
access_vector(allow,staff_t,tetex_data_t,lnk_file,ioctl).
access_vector(allow,staff_t,tetex_data_t,file,read).
access_vector(allow,staff_t,tetex_data_t,file,getattr).
access_vector(allow,staff_t,tetex_data_t,file,lock).
access_vector(allow,staff_t,tetex_data_t,file,execute).
access_vector(allow,staff_t,tetex_data_t,file,ioctl).
access_vector(allow,staff_t,tetex_data_t,file,execute_no_trans).
access_vector(allow,staff_t,ptmx_t,chr_file,ioctl).
access_vector(allow,staff_t,ptmx_t,chr_file,read).
access_vector(allow,staff_t,ptmx_t,chr_file,getattr).
access_vector(allow,staff_t,ptmx_t,chr_file,lock).
access_vector(allow,staff_t,ptmx_t,chr_file,write).
access_vector(allow,staff_t,ptmx_t,chr_file,append).
access_vector(allow,staff_t,devpts_t,filesystem,getattr).
access_vector(allow,staff_t,devpts_t,dir,getattr).
access_vector(allow,staff_t,devpts_t,dir,read).
access_vector(allow,staff_t,devpts_t,dir,search).
type_decl(staff_devpts_t,[],[file_type,sysadmfile,ptyfile,userpty_type]).
access_vector(allow,staff_devpts_t,devpts_t,filesystem,associate).
type_trans(staff_t,devpts_t,chr_file,staff_devpts_t).
access_vector(allow,staff_t,staff_devpts_t,chr_file,setattr).
access_vector(allow,staff_t,staff_devpts_t,chr_file,ioctl).
access_vector(allow,staff_t,staff_devpts_t,chr_file,read).
access_vector(allow,staff_t,staff_devpts_t,chr_file,getattr).
access_vector(allow,staff_t,staff_devpts_t,chr_file,lock).
access_vector(allow,staff_t,staff_devpts_t,chr_file,write).
access_vector(allow,staff_t,staff_devpts_t,chr_file,append).
type_change(staff_t,sshd_devpts_t,chr_file,staff_devpts_t).
access_vector(allow,staff_t,sshd_t,tcp_socket,connectto).
access_vector(allow,staff_t,sshd_t,tcp_socket,recvfrom).
access_vector(allow,sshd_t,staff_t,tcp_socket,acceptfrom).
access_vector(allow,sshd_t,staff_t,tcp_socket,recvfrom).
access_vector(allow,staff_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(allow,staff_t,staff_ssh_t,tcp_socket,connectto).
access_vector(allow,staff_t,staff_ssh_t,tcp_socket,recvfrom).
access_vector(allow,staff_ssh_t,staff_t,tcp_socket,acceptfrom).
access_vector(allow,staff_ssh_t,staff_t,tcp_socket,recvfrom).
access_vector(allow,staff_ssh_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(allow,staff_t,sshd_t,fd,use).
access_vector(allow,staff_t,sshd_t,tcp_socket,ioctl).
access_vector(allow,staff_t,sshd_t,tcp_socket,read).
access_vector(allow,staff_t,sshd_t,tcp_socket,getattr).
access_vector(allow,staff_t,sshd_t,tcp_socket,write).
access_vector(allow,staff_t,sshd_t,tcp_socket,setattr).
access_vector(allow,staff_t,sshd_t,tcp_socket,append).
access_vector(allow,staff_t,sshd_t,tcp_socket,bind).
access_vector(allow,staff_t,sshd_t,tcp_socket,connect).
access_vector(allow,staff_t,sshd_t,tcp_socket,getopt).
access_vector(allow,staff_t,sshd_t,tcp_socket,setopt).
access_vector(allow,staff_t,sshd_t,tcp_socket,shutdown).
access_vector(allow,staff_t,sshd_t,tcp_socket,listen).
access_vector(allow,staff_t,sshd_t,tcp_socket,accept).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,ioctl).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,read).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,getattr).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,write).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,setattr).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,append).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,bind).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,connect).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,getopt).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,setopt).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,shutdown).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,listen).
access_vector(allow,staff_t,sshd_t,unix_stream_socket,accept).
access_vector(allow,staff_t,boot_t,dir,getattr).
access_vector(allow,staff_t,boot_t,dir,search).
access_vector(dontaudit,staff_t,boot_t,dir,read).
access_vector(dontaudit,staff_t,boot_t,lnk_file,getattr).
access_vector(dontaudit,staff_t,boot_t,file,getattr).
access_vector(dontaudit,staff_t,boot_t,file,read).
access_vector(allow,staff_t,system_map_t,file,getattr).
access_vector(allow,staff_t,system_map_t,file,read).
type_decl(staff_tmpfs_t,[],[file_type,sysadmfile,tmpfsfile]).
access_vector(allow,staff_t,tmpfs_t,dir,read).
access_vector(allow,staff_t,tmpfs_t,dir,getattr).
access_vector(allow,staff_t,tmpfs_t,dir,lock).
access_vector(allow,staff_t,tmpfs_t,dir,search).
access_vector(allow,staff_t,tmpfs_t,dir,ioctl).
access_vector(allow,staff_t,tmpfs_t,dir,add_name).
access_vector(allow,staff_t,tmpfs_t,dir,remove_name).
access_vector(allow,staff_t,tmpfs_t,dir,write).
access_vector(allow,staff_t,staff_tmpfs_t,file,create).
access_vector(allow,staff_t,staff_tmpfs_t,file,ioctl).
access_vector(allow,staff_t,staff_tmpfs_t,file,read).
access_vector(allow,staff_t,staff_tmpfs_t,file,getattr).
access_vector(allow,staff_t,staff_tmpfs_t,file,lock).
access_vector(allow,staff_t,staff_tmpfs_t,file,write).
access_vector(allow,staff_t,staff_tmpfs_t,file,setattr).
access_vector(allow,staff_t,staff_tmpfs_t,file,append).
access_vector(allow,staff_t,staff_tmpfs_t,file,link).
access_vector(allow,staff_t,staff_tmpfs_t,file,unlink).
access_vector(allow,staff_t,staff_tmpfs_t,file,rename).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,create).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,ioctl).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,read).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,getattr).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,lock).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,write).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,setattr).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,append).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,link).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,unlink).
access_vector(allow,staff_t,staff_tmpfs_t,lnk_file,rename).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,create).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,ioctl).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,read).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,getattr).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,lock).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,write).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,setattr).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,append).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,link).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,unlink).
access_vector(allow,staff_t,staff_tmpfs_t,sock_file,rename).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,create).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,ioctl).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,read).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,getattr).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,lock).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,write).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,setattr).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,append).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,link).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,unlink).
access_vector(allow,staff_t,staff_tmpfs_t,fifo_file,rename).
access_vector(allow,staff_t,staff_tmpfs_t,dir,create).
access_vector(allow,staff_t,staff_tmpfs_t,dir,read).
access_vector(allow,staff_t,staff_tmpfs_t,dir,getattr).
access_vector(allow,staff_t,staff_tmpfs_t,dir,lock).
access_vector(allow,staff_t,staff_tmpfs_t,dir,setattr).
access_vector(allow,staff_t,staff_tmpfs_t,dir,link).
access_vector(allow,staff_t,staff_tmpfs_t,dir,unlink).
access_vector(allow,staff_t,staff_tmpfs_t,dir,rename).
access_vector(allow,staff_t,staff_tmpfs_t,dir,search).
access_vector(allow,staff_t,staff_tmpfs_t,dir,add_name).
access_vector(allow,staff_t,staff_tmpfs_t,dir,remove_name).
access_vector(allow,staff_t,staff_tmpfs_t,dir,reparent).
access_vector(allow,staff_t,staff_tmpfs_t,dir,write).
access_vector(allow,staff_t,staff_tmpfs_t,dir,rmdir).
type_trans(staff_t,tmpfs_t,dir,staff_tmpfs_t).
type_trans(staff_t,tmpfs_t,[file,lnk_file,sock_file,fifo_file],staff_tmpfs_t).
access_vector(allow,staff_tmpfs_t,tmpfs_t,filesystem,associate).
access_vector(allow,staff_t,catman_t,dir,read).
access_vector(allow,staff_t,catman_t,dir,getattr).
access_vector(allow,staff_t,catman_t,dir,lock).
access_vector(allow,staff_t,catman_t,dir,search).
access_vector(allow,staff_t,catman_t,dir,ioctl).
access_vector(allow,staff_t,catman_t,dir,add_name).
access_vector(allow,staff_t,catman_t,dir,remove_name).
access_vector(allow,staff_t,catman_t,dir,write).
access_vector(allow,staff_t,catman_t,file,create).
access_vector(allow,staff_t,catman_t,file,ioctl).
access_vector(allow,staff_t,catman_t,file,read).
access_vector(allow,staff_t,catman_t,file,getattr).
access_vector(allow,staff_t,catman_t,file,lock).
access_vector(allow,staff_t,catman_t,file,write).
access_vector(allow,staff_t,catman_t,file,setattr).
access_vector(allow,staff_t,catman_t,file,append).
access_vector(allow,staff_t,catman_t,file,link).
access_vector(allow,staff_t,catman_t,file,unlink).
access_vector(allow,staff_t,catman_t,file,rename).
access_vector(allow,staff_t,catman_t,lnk_file,create).
access_vector(allow,staff_t,catman_t,lnk_file,ioctl).
access_vector(allow,staff_t,catman_t,lnk_file,read).
access_vector(allow,staff_t,catman_t,lnk_file,getattr).
access_vector(allow,staff_t,catman_t,lnk_file,lock).
access_vector(allow,staff_t,catman_t,lnk_file,write).
access_vector(allow,staff_t,catman_t,lnk_file,setattr).
access_vector(allow,staff_t,catman_t,lnk_file,append).
access_vector(allow,staff_t,catman_t,lnk_file,link).
access_vector(allow,staff_t,catman_t,lnk_file,unlink).
access_vector(allow,staff_t,catman_t,lnk_file,rename).
access_vector(allow,staff_t,catman_t,sock_file,create).
access_vector(allow,staff_t,catman_t,sock_file,ioctl).
access_vector(allow,staff_t,catman_t,sock_file,read).
access_vector(allow,staff_t,catman_t,sock_file,getattr).
access_vector(allow,staff_t,catman_t,sock_file,lock).
access_vector(allow,staff_t,catman_t,sock_file,write).
access_vector(allow,staff_t,catman_t,sock_file,setattr).
access_vector(allow,staff_t,catman_t,sock_file,append).
access_vector(allow,staff_t,catman_t,sock_file,link).
access_vector(allow,staff_t,catman_t,sock_file,unlink).
access_vector(allow,staff_t,catman_t,sock_file,rename).
access_vector(allow,staff_t,catman_t,fifo_file,create).
access_vector(allow,staff_t,catman_t,fifo_file,ioctl).
access_vector(allow,staff_t,catman_t,fifo_file,read).
access_vector(allow,staff_t,catman_t,fifo_file,getattr).
access_vector(allow,staff_t,catman_t,fifo_file,lock).
access_vector(allow,staff_t,catman_t,fifo_file,write).
access_vector(allow,staff_t,catman_t,fifo_file,setattr).
access_vector(allow,staff_t,catman_t,fifo_file,append).
access_vector(allow,staff_t,catman_t,fifo_file,link).
access_vector(allow,staff_t,catman_t,fifo_file,unlink).
access_vector(allow,staff_t,catman_t,fifo_file,rename).
access_vector(allow,staff_t,mail_spool_t,dir,read).
access_vector(allow,staff_t,mail_spool_t,dir,getattr).
access_vector(allow,staff_t,mail_spool_t,dir,lock).
access_vector(allow,staff_t,mail_spool_t,dir,search).
access_vector(allow,staff_t,mail_spool_t,dir,ioctl).
access_vector(allow,staff_t,mail_spool_t,file,ioctl).
access_vector(allow,staff_t,mail_spool_t,file,read).
access_vector(allow,staff_t,mail_spool_t,file,getattr).
access_vector(allow,staff_t,mail_spool_t,file,lock).
access_vector(allow,staff_t,mail_spool_t,file,write).
access_vector(allow,staff_t,mail_spool_t,file,append).
access_vector(allow,staff_t,mail_spool_t,lnk_file,read).
access_vector(allow,staff_t,fs_type,filesystem,quotaget).
access_vector(allow,staff_t,bin_t,lnk_file,getattr).
access_vector(allow,staff_t,bin_t,lnk_file,read).
access_vector(allow,staff_t,sbin_t,lnk_file,getattr).
access_vector(allow,staff_t,sbin_t,lnk_file,read).
access_vector(allow,staff_t,etc_t,lnk_file,getattr).
access_vector(allow,staff_t,etc_t,lnk_file,read).
access_vector(allow,staff_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_t,device_t,dir,search).
access_vector(allow,staff_t,etc_t,file,read).
access_vector(allow,staff_t,etc_t,file,getattr).
access_vector(allow,staff_t,etc_t,file,lock).
access_vector(allow,staff_t,etc_t,file,execute).
access_vector(allow,staff_t,etc_t,file,ioctl).
access_vector(allow,staff_t,etc_t,file,execute_no_trans).
access_vector(allow,staff_t,lib_t,file,read).
access_vector(allow,staff_t,lib_t,file,getattr).
access_vector(allow,staff_t,lib_t,file,lock).
access_vector(allow,staff_t,lib_t,file,execute).
access_vector(allow,staff_t,lib_t,file,ioctl).
access_vector(allow,staff_t,lib_t,file,execute_no_trans).
access_vector(allow,staff_t,bin_t,file,read).
access_vector(allow,staff_t,bin_t,file,getattr).
access_vector(allow,staff_t,bin_t,file,lock).
access_vector(allow,staff_t,bin_t,file,execute).
access_vector(allow,staff_t,bin_t,file,ioctl).
access_vector(allow,staff_t,bin_t,file,execute_no_trans).
access_vector(allow,staff_t,sbin_t,file,read).
access_vector(allow,staff_t,sbin_t,file,getattr).
access_vector(allow,staff_t,sbin_t,file,lock).
access_vector(allow,staff_t,sbin_t,file,execute).
access_vector(allow,staff_t,sbin_t,file,ioctl).
access_vector(allow,staff_t,sbin_t,file,execute_no_trans).
access_vector(allow,staff_t,exec_type,file,read).
access_vector(allow,staff_t,exec_type,file,getattr).
access_vector(allow,staff_t,exec_type,file,lock).
access_vector(allow,staff_t,exec_type,file,execute).
access_vector(allow,staff_t,exec_type,file,ioctl).
access_vector(allow,staff_t,exec_type,file,execute_no_trans).
access_vector(allow,staff_t,staff_home_t,file,read).
access_vector(allow,staff_t,staff_home_t,file,getattr).
access_vector(allow,staff_t,staff_home_t,file,lock).
access_vector(allow,staff_t,staff_home_t,file,execute).
access_vector(allow,staff_t,staff_home_t,file,ioctl).
access_vector(allow,staff_t,staff_home_t,file,execute_no_trans).
access_vector(allow,staff_t,staff_tmp_t,file,read).
access_vector(allow,staff_t,staff_tmp_t,file,getattr).
access_vector(allow,staff_t,staff_tmp_t,file,lock).
access_vector(allow,staff_t,staff_tmp_t,file,execute).
access_vector(allow,staff_t,staff_tmp_t,file,ioctl).
access_vector(allow,staff_t,staff_tmp_t,file,execute_no_trans).
type_decl(staff_su_t,[],[domain,privlog,auth]).
access_vector(allow,staff_t,staff_su_t,process,transition).
access_vector(dontaudit,staff_t,staff_su_t,process,noatsecure).
access_vector(allow,staff_t,su_exec_t,file,read).
access_vector(allow,staff_t,su_exec_t,file,getattr).
access_vector(allow,staff_t,su_exec_t,file,execute).
access_vector(allow,staff_su_t,staff_t,process,sigchld).
access_vector(allow,staff_su_t,staff_t,fd,use).
access_vector(allow,staff_t,staff_su_t,fd,use).
access_vector(allow,staff_su_t,staff_t,fifo_file,ioctl).
access_vector(allow,staff_su_t,staff_t,fifo_file,read).
access_vector(allow,staff_su_t,staff_t,fifo_file,getattr).
access_vector(allow,staff_su_t,staff_t,fifo_file,lock).
access_vector(allow,staff_su_t,staff_t,fifo_file,write).
access_vector(allow,staff_su_t,staff_t,fifo_file,append).
access_vector(allow,staff_su_t,su_exec_t,file,read).
access_vector(allow,staff_su_t,su_exec_t,file,getattr).
access_vector(allow,staff_su_t,su_exec_t,file,lock).
access_vector(allow,staff_su_t,su_exec_t,file,execute).
access_vector(allow,staff_su_t,su_exec_t,file,ioctl).
access_vector(allow,staff_su_t,su_exec_t,file,entrypoint).
type_trans(staff_t,su_exec_t,process,staff_su_t).
access_vector(allow,staff_su_t,root_t,dir,read).
access_vector(allow,staff_su_t,root_t,dir,getattr).
access_vector(allow,staff_su_t,root_t,dir,lock).
access_vector(allow,staff_su_t,root_t,dir,search).
access_vector(allow,staff_su_t,root_t,dir,ioctl).
access_vector(allow,staff_su_t,usr_t,dir,read).
access_vector(allow,staff_su_t,usr_t,dir,getattr).
access_vector(allow,staff_su_t,usr_t,dir,lock).
access_vector(allow,staff_su_t,usr_t,dir,search).
access_vector(allow,staff_su_t,usr_t,dir,ioctl).
access_vector(allow,staff_su_t,lib_t,dir,read).
access_vector(allow,staff_su_t,lib_t,dir,getattr).
access_vector(allow,staff_su_t,lib_t,dir,lock).
access_vector(allow,staff_su_t,lib_t,dir,search).
access_vector(allow,staff_su_t,lib_t,dir,ioctl).
access_vector(allow,staff_su_t,etc_t,dir,read).
access_vector(allow,staff_su_t,etc_t,dir,getattr).
access_vector(allow,staff_su_t,etc_t,dir,lock).
access_vector(allow,staff_su_t,etc_t,dir,search).
access_vector(allow,staff_su_t,etc_t,dir,ioctl).
access_vector(allow,staff_su_t,lib_t,lnk_file,read).
access_vector(allow,staff_su_t,lib_t,lnk_file,getattr).
access_vector(allow,staff_su_t,lib_t,lnk_file,lock).
access_vector(allow,staff_su_t,lib_t,lnk_file,ioctl).
access_vector(allow,staff_su_t,ld_so_t,file,read).
access_vector(allow,staff_su_t,ld_so_t,file,getattr).
access_vector(allow,staff_su_t,ld_so_t,file,lock).
access_vector(allow,staff_su_t,ld_so_t,file,execute).
access_vector(allow,staff_su_t,ld_so_t,file,ioctl).
access_vector(allow,staff_su_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_su_t,ld_so_t,lnk_file,read).
access_vector(allow,staff_su_t,ld_so_t,lnk_file,getattr).
access_vector(allow,staff_su_t,ld_so_t,lnk_file,lock).
access_vector(allow,staff_su_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,staff_su_t,shlib_t,file,read).
access_vector(allow,staff_su_t,shlib_t,file,getattr).
access_vector(allow,staff_su_t,shlib_t,file,lock).
access_vector(allow,staff_su_t,shlib_t,file,execute).
access_vector(allow,staff_su_t,shlib_t,file,ioctl).
access_vector(allow,staff_su_t,shlib_t,lnk_file,read).
access_vector(allow,staff_su_t,shlib_t,lnk_file,getattr).
access_vector(allow,staff_su_t,shlib_t,lnk_file,lock).
access_vector(allow,staff_su_t,shlib_t,lnk_file,ioctl).
access_vector(allow,staff_su_t,ld_so_cache_t,file,read).
access_vector(allow,staff_su_t,ld_so_cache_t,file,getattr).
access_vector(allow,staff_su_t,ld_so_cache_t,file,lock).
access_vector(allow,staff_su_t,ld_so_cache_t,file,ioctl).
access_vector(allow,staff_su_t,device_t,dir,search).
access_vector(allow,staff_su_t,null_device_t,chr_file,ioctl).
access_vector(allow,staff_su_t,null_device_t,chr_file,read).
access_vector(allow,staff_su_t,null_device_t,chr_file,getattr).
access_vector(allow,staff_su_t,null_device_t,chr_file,lock).
access_vector(allow,staff_su_t,null_device_t,chr_file,write).
access_vector(allow,staff_su_t,null_device_t,chr_file,append).
access_vector(allow,staff_su_t,etc_t,file,getattr).
access_vector(allow,staff_su_t,etc_t,file,read).
access_vector(allow,staff_su_t,etc_t,lnk_file,read).
access_vector(allow,staff_su_t,locale_t,dir,read).
access_vector(allow,staff_su_t,locale_t,dir,getattr).
access_vector(allow,staff_su_t,locale_t,dir,lock).
access_vector(allow,staff_su_t,locale_t,dir,search).
access_vector(allow,staff_su_t,locale_t,dir,ioctl).
access_vector(allow,staff_su_t,locale_t,file,read).
access_vector(allow,staff_su_t,locale_t,file,getattr).
access_vector(allow,staff_su_t,locale_t,file,lock).
access_vector(allow,staff_su_t,locale_t,file,ioctl).
access_vector(allow,staff_su_t,locale_t,lnk_file,read).
access_vector(allow,staff_su_t,locale_t,lnk_file,getattr).
access_vector(allow,staff_su_t,locale_t,lnk_file,lock).
access_vector(allow,staff_su_t,locale_t,lnk_file,ioctl).
access_vector(allow,staff_su_t,self,unix_dgram_socket,connect).
access_vector(allow,staff_su_t,self,unix_dgram_socket,create).
access_vector(allow,staff_su_t,self,unix_dgram_socket,write).
access_vector(allow,staff_su_t,self,unix_stream_socket,create).
access_vector(allow,staff_su_t,self,unix_stream_socket,ioctl).
access_vector(allow,staff_su_t,self,unix_stream_socket,read).
access_vector(allow,staff_su_t,self,unix_stream_socket,getattr).
access_vector(allow,staff_su_t,self,unix_stream_socket,write).
access_vector(allow,staff_su_t,self,unix_stream_socket,setattr).
access_vector(allow,staff_su_t,self,unix_stream_socket,append).
access_vector(allow,staff_su_t,self,unix_stream_socket,bind).
access_vector(allow,staff_su_t,self,unix_stream_socket,connect).
access_vector(allow,staff_su_t,self,unix_stream_socket,getopt).
access_vector(allow,staff_su_t,self,unix_stream_socket,setopt).
access_vector(allow,staff_su_t,self,unix_stream_socket,shutdown).
access_vector(allow,staff_su_t,self,unix_stream_socket,listen).
access_vector(allow,staff_su_t,self,unix_stream_socket,accept).
access_vector(allow,staff_su_t,proc_t,dir,search).
access_vector(allow,staff_su_t,proc_t,lnk_file,read).
access_vector(allow,staff_su_t,self,dir,read).
access_vector(allow,staff_su_t,self,dir,getattr).
access_vector(allow,staff_su_t,self,dir,lock).
access_vector(allow,staff_su_t,self,dir,search).
access_vector(allow,staff_su_t,self,dir,ioctl).
access_vector(allow,staff_su_t,self,file,read).
access_vector(allow,staff_su_t,self,file,getattr).
access_vector(allow,staff_su_t,self,file,lock).
access_vector(allow,staff_su_t,self,file,ioctl).
access_vector(allow,staff_su_t,self,lnk_file,read).
access_vector(allow,staff_su_t,self,lnk_file,getattr).
access_vector(allow,staff_su_t,self,lnk_file,lock).
access_vector(allow,staff_su_t,self,lnk_file,ioctl).
access_vector(allow,staff_su_t,self,process,setsched).
access_vector(allow,staff_su_t,device_t,dir,search).
access_vector(allow,staff_su_t,self,process,fork).
access_vector(allow,staff_su_t,self,process,sigchld).
access_vector(allow,staff_su_t,self,capability,setuid).
access_vector(allow,staff_su_t,self,capability,setgid).
access_vector(allow,staff_su_t,self,capability,net_bind_service).
access_vector(allow,staff_su_t,self,capability,chown).
access_vector(allow,staff_su_t,self,capability,dac_override).
access_vector(allow,staff_su_t,self,capability,sys_nice).
access_vector(allow,staff_su_t,self,capability,sys_resource).
access_vector(allow,staff_su_t,staff_t,process,transition).
access_vector(dontaudit,staff_su_t,staff_t,process,noatsecure).
access_vector(allow,staff_su_t,shell_exec_t,file,read).
access_vector(allow,staff_su_t,shell_exec_t,file,getattr).
access_vector(allow,staff_su_t,shell_exec_t,file,execute).
access_vector(allow,staff_t,staff_su_t,process,sigchld).
access_vector(allow,staff_t,staff_su_t,fd,use).
access_vector(allow,staff_su_t,staff_t,fd,use).
access_vector(allow,staff_t,staff_su_t,fifo_file,ioctl).
access_vector(allow,staff_t,staff_su_t,fifo_file,read).
access_vector(allow,staff_t,staff_su_t,fifo_file,getattr).
access_vector(allow,staff_t,staff_su_t,fifo_file,lock).
access_vector(allow,staff_t,staff_su_t,fifo_file,write).
access_vector(allow,staff_t,staff_su_t,fifo_file,append).
access_vector(allow,staff_t,shell_exec_t,file,read).
access_vector(allow,staff_t,shell_exec_t,file,getattr).
access_vector(allow,staff_t,shell_exec_t,file,lock).
access_vector(allow,staff_t,shell_exec_t,file,execute).
access_vector(allow,staff_t,shell_exec_t,file,ioctl).
access_vector(allow,staff_t,shell_exec_t,file,entrypoint).
type_trans(staff_su_t,shell_exec_t,process,staff_t).
access_vector(allow,staff_su_t,bin_t,dir,search).
access_vector(allow,staff_su_t,bin_t,lnk_file,read).
access_vector(allow,staff_su_t,privfd,fd,use).
access_vector(allow,staff_su_t,var_t,dir,search).
access_vector(allow,staff_su_t,var_run_t,dir,search).
access_vector(allow,staff_su_t,initrc_var_run_t,file,ioctl).
access_vector(allow,staff_su_t,initrc_var_run_t,file,read).
access_vector(allow,staff_su_t,initrc_var_run_t,file,getattr).
access_vector(allow,staff_su_t,initrc_var_run_t,file,lock).
access_vector(allow,staff_su_t,initrc_var_run_t,file,write).
access_vector(allow,staff_su_t,initrc_var_run_t,file,append).
access_vector(allow,staff_su_t,chkpwd_exec_t,file,read).
access_vector(allow,staff_su_t,chkpwd_exec_t,file,getattr).
access_vector(allow,staff_su_t,chkpwd_exec_t,file,lock).
access_vector(allow,staff_su_t,chkpwd_exec_t,file,execute).
access_vector(allow,staff_su_t,chkpwd_exec_t,file,ioctl).
access_vector(allow,staff_su_t,chkpwd_exec_t,file,execute_no_trans).
role_decl(staff_r,staff_su_t).
access_vector(allow,staff_su_t,staff_tty_device_t,chr_file,ioctl).
access_vector(allow,staff_su_t,staff_tty_device_t,chr_file,read).
access_vector(allow,staff_su_t,staff_tty_device_t,chr_file,getattr).
access_vector(allow,staff_su_t,staff_tty_device_t,chr_file,lock).
access_vector(allow,staff_su_t,staff_tty_device_t,chr_file,write).
access_vector(allow,staff_su_t,staff_tty_device_t,chr_file,append).
access_vector(allow,staff_su_t,staff_devpts_t,chr_file,ioctl).
access_vector(allow,staff_su_t,staff_devpts_t,chr_file,read).
access_vector(allow,staff_su_t,staff_devpts_t,chr_file,getattr).
access_vector(allow,staff_su_t,staff_devpts_t,chr_file,lock).
access_vector(allow,staff_su_t,staff_devpts_t,chr_file,write).
access_vector(allow,staff_su_t,staff_devpts_t,chr_file,append).
access_vector(allow,staff_su_t,home_root_t,dir,search).
access_vector(allow,staff_su_t,staff_home_dir_t,dir,search).
access_vector(allow,staff_su_t,sshd_tmp_t,dir,read).
access_vector(allow,staff_su_t,sshd_tmp_t,dir,getattr).
access_vector(allow,staff_su_t,sshd_tmp_t,dir,lock).
access_vector(allow,staff_su_t,sshd_tmp_t,dir,search).
access_vector(allow,staff_su_t,sshd_tmp_t,dir,ioctl).
access_vector(allow,staff_su_t,sshd_tmp_t,dir,add_name).
access_vector(allow,staff_su_t,sshd_tmp_t,dir,remove_name).
access_vector(allow,staff_su_t,sshd_tmp_t,dir,write).
access_vector(allow,staff_su_t,sshd_tmp_t,file,ioctl).
access_vector(allow,staff_su_t,sshd_tmp_t,file,read).
access_vector(allow,staff_su_t,sshd_tmp_t,file,getattr).
access_vector(allow,staff_su_t,sshd_tmp_t,file,lock).
access_vector(allow,staff_su_t,sshd_tmp_t,file,write).
access_vector(allow,staff_su_t,sshd_tmp_t,file,append).
access_vector(allow,staff_su_t,staff_tmp_t,file,create).
access_vector(allow,staff_su_t,staff_tmp_t,file,ioctl).
access_vector(allow,staff_su_t,staff_tmp_t,file,read).
access_vector(allow,staff_su_t,staff_tmp_t,file,getattr).
access_vector(allow,staff_su_t,staff_tmp_t,file,lock).
access_vector(allow,staff_su_t,staff_tmp_t,file,write).
access_vector(allow,staff_su_t,staff_tmp_t,file,setattr).
access_vector(allow,staff_su_t,staff_tmp_t,file,append).
access_vector(allow,staff_su_t,staff_tmp_t,file,link).
access_vector(allow,staff_su_t,staff_tmp_t,file,unlink).
access_vector(allow,staff_su_t,staff_tmp_t,file,rename).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,create).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,ioctl).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,read).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,getattr).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,lock).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,write).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,setattr).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,append).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,link).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,unlink).
access_vector(allow,staff_su_t,staff_tmp_t,lnk_file,rename).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,create).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,ioctl).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,read).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,getattr).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,lock).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,write).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,setattr).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,append).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,link).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,unlink).
access_vector(allow,staff_su_t,staff_tmp_t,sock_file,rename).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,create).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,ioctl).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,read).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,getattr).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,lock).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,write).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,setattr).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,append).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,link).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,unlink).
access_vector(allow,staff_su_t,staff_tmp_t,fifo_file,rename).
access_vector(allow,staff_su_t,staff_tmp_t,dir,create).
access_vector(allow,staff_su_t,staff_tmp_t,dir,read).
access_vector(allow,staff_su_t,staff_tmp_t,dir,getattr).
access_vector(allow,staff_su_t,staff_tmp_t,dir,lock).
access_vector(allow,staff_su_t,staff_tmp_t,dir,setattr).
access_vector(allow,staff_su_t,staff_tmp_t,dir,link).
access_vector(allow,staff_su_t,staff_tmp_t,dir,unlink).
access_vector(allow,staff_su_t,staff_tmp_t,dir,rename).
access_vector(allow,staff_su_t,staff_tmp_t,dir,search).
access_vector(allow,staff_su_t,staff_tmp_t,dir,add_name).
access_vector(allow,staff_su_t,staff_tmp_t,dir,remove_name).
access_vector(allow,staff_su_t,staff_tmp_t,dir,reparent).
access_vector(allow,staff_su_t,staff_tmp_t,dir,write).
access_vector(allow,staff_su_t,staff_tmp_t,dir,rmdir).
type_trans(staff_su_t,sshd_tmp_t,dir,staff_tmp_t).
type_trans(staff_su_t,sshd_tmp_t,[file,lnk_file,sock_file,fifo_file],staff_tmp_t).
access_vector(dontaudit,staff_su_t,file_type,dir,search).
type_decl(staff_chkpwd_t,[],[domain,privlog,auth]).
access_vector(allow,staff_t,staff_chkpwd_t,process,transition).
access_vector(dontaudit,staff_t,staff_chkpwd_t,process,noatsecure).
access_vector(allow,staff_t,chkpwd_exec_t,file,read).
access_vector(allow,staff_t,chkpwd_exec_t,file,getattr).
access_vector(allow,staff_t,chkpwd_exec_t,file,execute).
access_vector(allow,staff_chkpwd_t,staff_t,process,sigchld).
access_vector(allow,staff_chkpwd_t,staff_t,fd,use).
access_vector(allow,staff_t,staff_chkpwd_t,fd,use).
access_vector(allow,staff_chkpwd_t,staff_t,fifo_file,ioctl).
access_vector(allow,staff_chkpwd_t,staff_t,fifo_file,read).
access_vector(allow,staff_chkpwd_t,staff_t,fifo_file,getattr).
access_vector(allow,staff_chkpwd_t,staff_t,fifo_file,lock).
access_vector(allow,staff_chkpwd_t,staff_t,fifo_file,write).
access_vector(allow,staff_chkpwd_t,staff_t,fifo_file,append).
access_vector(allow,staff_chkpwd_t,chkpwd_exec_t,file,read).
access_vector(allow,staff_chkpwd_t,chkpwd_exec_t,file,getattr).
access_vector(allow,staff_chkpwd_t,chkpwd_exec_t,file,lock).
access_vector(allow,staff_chkpwd_t,chkpwd_exec_t,file,execute).
access_vector(allow,staff_chkpwd_t,chkpwd_exec_t,file,ioctl).
access_vector(allow,staff_chkpwd_t,chkpwd_exec_t,file,entrypoint).
type_trans(staff_t,chkpwd_exec_t,process,staff_chkpwd_t).
role_decl(staff_r,staff_chkpwd_t).
access_vector(allow,staff_chkpwd_t,root_t,dir,read).
access_vector(allow,staff_chkpwd_t,root_t,dir,getattr).
access_vector(allow,staff_chkpwd_t,root_t,dir,lock).
access_vector(allow,staff_chkpwd_t,root_t,dir,search).
access_vector(allow,staff_chkpwd_t,root_t,dir,ioctl).
access_vector(allow,staff_chkpwd_t,usr_t,dir,read).
access_vector(allow,staff_chkpwd_t,usr_t,dir,getattr).
access_vector(allow,staff_chkpwd_t,usr_t,dir,lock).
access_vector(allow,staff_chkpwd_t,usr_t,dir,search).
access_vector(allow,staff_chkpwd_t,usr_t,dir,ioctl).
access_vector(allow,staff_chkpwd_t,lib_t,dir,read).
access_vector(allow,staff_chkpwd_t,lib_t,dir,getattr).
access_vector(allow,staff_chkpwd_t,lib_t,dir,lock).
access_vector(allow,staff_chkpwd_t,lib_t,dir,search).
access_vector(allow,staff_chkpwd_t,lib_t,dir,ioctl).
access_vector(allow,staff_chkpwd_t,etc_t,dir,read).
access_vector(allow,staff_chkpwd_t,etc_t,dir,getattr).
access_vector(allow,staff_chkpwd_t,etc_t,dir,lock).
access_vector(allow,staff_chkpwd_t,etc_t,dir,search).
access_vector(allow,staff_chkpwd_t,etc_t,dir,ioctl).
access_vector(allow,staff_chkpwd_t,lib_t,lnk_file,read).
access_vector(allow,staff_chkpwd_t,lib_t,lnk_file,getattr).
access_vector(allow,staff_chkpwd_t,lib_t,lnk_file,lock).
access_vector(allow,staff_chkpwd_t,lib_t,lnk_file,ioctl).
access_vector(allow,staff_chkpwd_t,ld_so_t,file,read).
access_vector(allow,staff_chkpwd_t,ld_so_t,file,getattr).
access_vector(allow,staff_chkpwd_t,ld_so_t,file,lock).
access_vector(allow,staff_chkpwd_t,ld_so_t,file,execute).
access_vector(allow,staff_chkpwd_t,ld_so_t,file,ioctl).
access_vector(allow,staff_chkpwd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_chkpwd_t,ld_so_t,lnk_file,read).
access_vector(allow,staff_chkpwd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,staff_chkpwd_t,ld_so_t,lnk_file,lock).
access_vector(allow,staff_chkpwd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,staff_chkpwd_t,shlib_t,file,read).
access_vector(allow,staff_chkpwd_t,shlib_t,file,getattr).
access_vector(allow,staff_chkpwd_t,shlib_t,file,lock).
access_vector(allow,staff_chkpwd_t,shlib_t,file,execute).
access_vector(allow,staff_chkpwd_t,shlib_t,file,ioctl).
access_vector(allow,staff_chkpwd_t,shlib_t,lnk_file,read).
access_vector(allow,staff_chkpwd_t,shlib_t,lnk_file,getattr).
access_vector(allow,staff_chkpwd_t,shlib_t,lnk_file,lock).
access_vector(allow,staff_chkpwd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,staff_chkpwd_t,ld_so_cache_t,file,read).
access_vector(allow,staff_chkpwd_t,ld_so_cache_t,file,getattr).
access_vector(allow,staff_chkpwd_t,ld_so_cache_t,file,lock).
access_vector(allow,staff_chkpwd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,staff_chkpwd_t,device_t,dir,search).
access_vector(allow,staff_chkpwd_t,null_device_t,chr_file,ioctl).
access_vector(allow,staff_chkpwd_t,null_device_t,chr_file,read).
access_vector(allow,staff_chkpwd_t,null_device_t,chr_file,getattr).
access_vector(allow,staff_chkpwd_t,null_device_t,chr_file,lock).
access_vector(allow,staff_chkpwd_t,null_device_t,chr_file,write).
access_vector(allow,staff_chkpwd_t,null_device_t,chr_file,append).
access_vector(allow,staff_chkpwd_t,etc_t,file,getattr).
access_vector(allow,staff_chkpwd_t,etc_t,file,read).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,create).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,read).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,getattr).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,write).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,setattr).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,append).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,bind).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,connect).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,getopt).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,setopt).
access_vector(allow,staff_chkpwd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,create).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,ioctl).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,read).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,getattr).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,write).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,setattr).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,append).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,bind).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,connect).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,getopt).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,setopt).
access_vector(allow,staff_chkpwd_t,self,unix_stream_socket,shutdown).
access_vector(allow,staff_chkpwd_t,etc_t,lnk_file,read).
access_vector(allow,staff_chkpwd_t,locale_t,dir,read).
access_vector(allow,staff_chkpwd_t,locale_t,dir,getattr).
access_vector(allow,staff_chkpwd_t,locale_t,dir,lock).
access_vector(allow,staff_chkpwd_t,locale_t,dir,search).
access_vector(allow,staff_chkpwd_t,locale_t,dir,ioctl).
access_vector(allow,staff_chkpwd_t,locale_t,file,read).
access_vector(allow,staff_chkpwd_t,locale_t,file,getattr).
access_vector(allow,staff_chkpwd_t,locale_t,file,lock).
access_vector(allow,staff_chkpwd_t,locale_t,file,ioctl).
access_vector(allow,staff_chkpwd_t,locale_t,lnk_file,read).
access_vector(allow,staff_chkpwd_t,locale_t,lnk_file,getattr).
access_vector(allow,staff_chkpwd_t,locale_t,lnk_file,lock).
access_vector(allow,staff_chkpwd_t,locale_t,lnk_file,ioctl).
access_vector(allow,staff_chkpwd_t,self,capability,setuid).
access_vector(allow,staff_chkpwd_t,newrole_t,fd,use).
access_vector(allow,staff_chkpwd_t,staff_tty_device_t,chr_file,ioctl).
access_vector(allow,staff_chkpwd_t,staff_tty_device_t,chr_file,read).
access_vector(allow,staff_chkpwd_t,staff_tty_device_t,chr_file,getattr).
access_vector(allow,staff_chkpwd_t,staff_tty_device_t,chr_file,lock).
access_vector(allow,staff_chkpwd_t,staff_tty_device_t,chr_file,write).
access_vector(allow,staff_chkpwd_t,staff_tty_device_t,chr_file,append).
access_vector(allow,staff_chkpwd_t,staff_devpts_t,chr_file,ioctl).
access_vector(allow,staff_chkpwd_t,staff_devpts_t,chr_file,read).
access_vector(allow,staff_chkpwd_t,staff_devpts_t,chr_file,getattr).
access_vector(allow,staff_chkpwd_t,staff_devpts_t,chr_file,lock).
access_vector(allow,staff_chkpwd_t,staff_devpts_t,chr_file,write).
access_vector(allow,staff_chkpwd_t,staff_devpts_t,chr_file,append).
type_decl(staff_crontab_t,[],[domain,privlog]).
access_vector(allow,staff_t,staff_crontab_t,process,transition).
access_vector(dontaudit,staff_t,staff_crontab_t,process,noatsecure).
access_vector(allow,staff_t,crontab_exec_t,file,read).
access_vector(allow,staff_t,crontab_exec_t,file,getattr).
access_vector(allow,staff_t,crontab_exec_t,file,execute).
access_vector(allow,staff_crontab_t,staff_t,process,sigchld).
access_vector(allow,staff_crontab_t,staff_t,fd,use).
access_vector(allow,staff_t,staff_crontab_t,fd,use).
access_vector(allow,staff_crontab_t,staff_t,fifo_file,ioctl).
access_vector(allow,staff_crontab_t,staff_t,fifo_file,read).
access_vector(allow,staff_crontab_t,staff_t,fifo_file,getattr).
access_vector(allow,staff_crontab_t,staff_t,fifo_file,lock).
access_vector(allow,staff_crontab_t,staff_t,fifo_file,write).
access_vector(allow,staff_crontab_t,staff_t,fifo_file,append).
access_vector(allow,staff_crontab_t,crontab_exec_t,file,read).
access_vector(allow,staff_crontab_t,crontab_exec_t,file,getattr).
access_vector(allow,staff_crontab_t,crontab_exec_t,file,lock).
access_vector(allow,staff_crontab_t,crontab_exec_t,file,execute).
access_vector(allow,staff_crontab_t,crontab_exec_t,file,ioctl).
access_vector(allow,staff_crontab_t,crontab_exec_t,file,entrypoint).
type_trans(staff_t,crontab_exec_t,process,staff_crontab_t).
role_decl(staff_r,staff_crontab_t).
access_vector(allow,staff_crontab_t,root_t,dir,read).
access_vector(allow,staff_crontab_t,root_t,dir,getattr).
access_vector(allow,staff_crontab_t,root_t,dir,lock).
access_vector(allow,staff_crontab_t,root_t,dir,search).
access_vector(allow,staff_crontab_t,root_t,dir,ioctl).
access_vector(allow,staff_crontab_t,usr_t,dir,read).
access_vector(allow,staff_crontab_t,usr_t,dir,getattr).
access_vector(allow,staff_crontab_t,usr_t,dir,lock).
access_vector(allow,staff_crontab_t,usr_t,dir,search).
access_vector(allow,staff_crontab_t,usr_t,dir,ioctl).
access_vector(allow,staff_crontab_t,lib_t,dir,read).
access_vector(allow,staff_crontab_t,lib_t,dir,getattr).
access_vector(allow,staff_crontab_t,lib_t,dir,lock).
access_vector(allow,staff_crontab_t,lib_t,dir,search).
access_vector(allow,staff_crontab_t,lib_t,dir,ioctl).
access_vector(allow,staff_crontab_t,etc_t,dir,read).
access_vector(allow,staff_crontab_t,etc_t,dir,getattr).
access_vector(allow,staff_crontab_t,etc_t,dir,lock).
access_vector(allow,staff_crontab_t,etc_t,dir,search).
access_vector(allow,staff_crontab_t,etc_t,dir,ioctl).
access_vector(allow,staff_crontab_t,lib_t,lnk_file,read).
access_vector(allow,staff_crontab_t,lib_t,lnk_file,getattr).
access_vector(allow,staff_crontab_t,lib_t,lnk_file,lock).
access_vector(allow,staff_crontab_t,lib_t,lnk_file,ioctl).
access_vector(allow,staff_crontab_t,ld_so_t,file,read).
access_vector(allow,staff_crontab_t,ld_so_t,file,getattr).
access_vector(allow,staff_crontab_t,ld_so_t,file,lock).
access_vector(allow,staff_crontab_t,ld_so_t,file,execute).
access_vector(allow,staff_crontab_t,ld_so_t,file,ioctl).
access_vector(allow,staff_crontab_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_crontab_t,ld_so_t,lnk_file,read).
access_vector(allow,staff_crontab_t,ld_so_t,lnk_file,getattr).
access_vector(allow,staff_crontab_t,ld_so_t,lnk_file,lock).
access_vector(allow,staff_crontab_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,staff_crontab_t,shlib_t,file,read).
access_vector(allow,staff_crontab_t,shlib_t,file,getattr).
access_vector(allow,staff_crontab_t,shlib_t,file,lock).
access_vector(allow,staff_crontab_t,shlib_t,file,execute).
access_vector(allow,staff_crontab_t,shlib_t,file,ioctl).
access_vector(allow,staff_crontab_t,shlib_t,lnk_file,read).
access_vector(allow,staff_crontab_t,shlib_t,lnk_file,getattr).
access_vector(allow,staff_crontab_t,shlib_t,lnk_file,lock).
access_vector(allow,staff_crontab_t,shlib_t,lnk_file,ioctl).
access_vector(allow,staff_crontab_t,ld_so_cache_t,file,read).
access_vector(allow,staff_crontab_t,ld_so_cache_t,file,getattr).
access_vector(allow,staff_crontab_t,ld_so_cache_t,file,lock).
access_vector(allow,staff_crontab_t,ld_so_cache_t,file,ioctl).
access_vector(allow,staff_crontab_t,device_t,dir,search).
access_vector(allow,staff_crontab_t,null_device_t,chr_file,ioctl).
access_vector(allow,staff_crontab_t,null_device_t,chr_file,read).
access_vector(allow,staff_crontab_t,null_device_t,chr_file,getattr).
access_vector(allow,staff_crontab_t,null_device_t,chr_file,lock).
access_vector(allow,staff_crontab_t,null_device_t,chr_file,write).
access_vector(allow,staff_crontab_t,null_device_t,chr_file,append).
access_vector(allow,staff_crontab_t,etc_t,file,getattr).
access_vector(allow,staff_crontab_t,etc_t,file,read).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,create).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,ioctl).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,read).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,getattr).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,write).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,setattr).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,append).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,bind).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,connect).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,getopt).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,setopt).
access_vector(allow,staff_crontab_t,self,unix_stream_socket,shutdown).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,create).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,ioctl).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,read).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,getattr).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,write).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,setattr).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,append).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,bind).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,connect).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,getopt).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,setopt).
access_vector(allow,staff_crontab_t,self,unix_dgram_socket,shutdown).
access_vector(allow,staff_crontab_t,etc_t,lnk_file,read).
access_vector(allow,staff_crontab_t,locale_t,dir,read).
access_vector(allow,staff_crontab_t,locale_t,dir,getattr).
access_vector(allow,staff_crontab_t,locale_t,dir,lock).
access_vector(allow,staff_crontab_t,locale_t,dir,search).
access_vector(allow,staff_crontab_t,locale_t,dir,ioctl).
access_vector(allow,staff_crontab_t,locale_t,file,read).
access_vector(allow,staff_crontab_t,locale_t,file,getattr).
access_vector(allow,staff_crontab_t,locale_t,file,lock).
access_vector(allow,staff_crontab_t,locale_t,file,ioctl).
access_vector(allow,staff_crontab_t,locale_t,lnk_file,read).
access_vector(allow,staff_crontab_t,locale_t,lnk_file,getattr).
access_vector(allow,staff_crontab_t,locale_t,lnk_file,lock).
access_vector(allow,staff_crontab_t,locale_t,lnk_file,ioctl).
access_vector(allow,staff_crontab_t,staff_crontab_t,capability,setuid).
access_vector(allow,staff_crontab_t,staff_crontab_t,capability,setgid).
access_vector(allow,staff_crontab_t,staff_crontab_t,capability,chown).
access_vector(allow,staff_crontab_t,tmp_t,dir,read).
access_vector(allow,staff_crontab_t,tmp_t,dir,getattr).
access_vector(allow,staff_crontab_t,tmp_t,dir,lock).
access_vector(allow,staff_crontab_t,tmp_t,dir,search).
access_vector(allow,staff_crontab_t,tmp_t,dir,ioctl).
access_vector(allow,staff_crontab_t,tmp_t,dir,add_name).
access_vector(allow,staff_crontab_t,tmp_t,dir,remove_name).
access_vector(allow,staff_crontab_t,tmp_t,dir,write).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,create).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,ioctl).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,read).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,getattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,lock).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,write).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,setattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,append).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,link).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,unlink).
access_vector(allow,staff_crontab_t,staff_tmp_t,file,rename).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,create).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,ioctl).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,read).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,getattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,lock).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,write).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,setattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,append).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,link).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,unlink).
access_vector(allow,staff_crontab_t,staff_tmp_t,lnk_file,rename).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,create).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,ioctl).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,read).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,getattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,lock).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,write).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,setattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,append).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,link).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,unlink).
access_vector(allow,staff_crontab_t,staff_tmp_t,sock_file,rename).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,create).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,ioctl).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,read).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,getattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,lock).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,write).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,setattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,append).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,link).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,unlink).
access_vector(allow,staff_crontab_t,staff_tmp_t,fifo_file,rename).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,create).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,read).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,getattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,lock).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,setattr).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,link).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,unlink).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,rename).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,search).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,add_name).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,remove_name).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,reparent).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,write).
access_vector(allow,staff_crontab_t,staff_tmp_t,dir,rmdir).
type_trans(staff_crontab_t,tmp_t,dir,staff_tmp_t).
type_trans(staff_crontab_t,tmp_t,[file,lnk_file,sock_file,fifo_file],staff_tmp_t).
type_decl(staff_cron_spool_t,[],[file_type,sysadmfile]).
access_vector(allow,sysadm_crontab_t,staff_cron_spool_t,file,getattr).
access_vector(allow,sysadm_crontab_t,staff_cron_spool_t,file,read).
access_vector(allow,staff_crontab_t,var_t,dir,search).
access_vector(allow,staff_crontab_t,var_spool_t,dir,search).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,read).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,getattr).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,lock).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,search).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,ioctl).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,add_name).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,remove_name).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,write).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,create).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,ioctl).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,read).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,getattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,lock).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,write).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,setattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,append).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,link).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,unlink).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,file,rename).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,create).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,ioctl).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,read).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,getattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,lock).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,write).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,setattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,append).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,link).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,unlink).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,lnk_file,rename).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,create).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,ioctl).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,read).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,getattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,lock).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,write).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,setattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,append).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,link).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,unlink).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,sock_file,rename).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,create).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,ioctl).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,read).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,getattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,lock).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,write).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,setattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,append).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,link).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,unlink).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,fifo_file,rename).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,create).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,read).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,getattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,lock).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,setattr).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,link).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,unlink).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,rename).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,search).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,add_name).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,remove_name).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,reparent).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,write).
access_vector(allow,staff_crontab_t,staff_cron_spool_t,dir,rmdir).
type_trans(staff_crontab_t,cron_spool_t,dir,staff_cron_spool_t).
type_trans(staff_crontab_t,cron_spool_t,[file,lnk_file,sock_file,fifo_file],staff_cron_spool_t).
access_vector(allow,staff_crontab_t,self,process,fork).
access_vector(allow,staff_crontab_t,self,process,sigchld).
access_vector(allow,staff_crontab_t,self,process,sigkill).
access_vector(allow,staff_crontab_t,self,process,sigstop).
access_vector(allow,staff_crontab_t,self,process,signull).
access_vector(allow,staff_crontab_t,self,process,signal).
access_vector(allow,staff_crontab_t,cron_spool_t,dir,setattr).
access_vector(allow,crond_t,staff_cron_spool_t,file,read).
access_vector(allow,crond_t,staff_cron_spool_t,file,getattr).
access_vector(allow,crond_t,staff_cron_spool_t,file,lock).
access_vector(allow,crond_t,staff_cron_spool_t,file,ioctl).
access_vector(allow,staff_crontab_t,bin_t,dir,search).
access_vector(allow,staff_crontab_t,sbin_t,dir,search).
access_vector(allow,staff_crontab_t,bin_t,lnk_file,read).
access_vector(allow,staff_crontab_t,staff_t,process,transition).
access_vector(dontaudit,staff_crontab_t,staff_t,process,noatsecure).
access_vector(allow,staff_crontab_t,bin_t,file,read).
access_vector(allow,staff_crontab_t,bin_t,file,getattr).
access_vector(allow,staff_crontab_t,bin_t,file,execute).
access_vector(allow,staff_crontab_t,sbin_t,file,read).
access_vector(allow,staff_crontab_t,sbin_t,file,getattr).
access_vector(allow,staff_crontab_t,sbin_t,file,execute).
access_vector(allow,staff_crontab_t,shell_exec_t,file,read).
access_vector(allow,staff_crontab_t,shell_exec_t,file,getattr).
access_vector(allow,staff_crontab_t,shell_exec_t,file,execute).
access_vector(allow,staff_t,staff_crontab_t,process,sigchld).
access_vector(allow,staff_t,staff_crontab_t,fd,use).
access_vector(allow,staff_crontab_t,staff_t,fd,use).
access_vector(allow,staff_t,staff_crontab_t,fifo_file,ioctl).
access_vector(allow,staff_t,staff_crontab_t,fifo_file,read).
access_vector(allow,staff_t,staff_crontab_t,fifo_file,getattr).
access_vector(allow,staff_t,staff_crontab_t,fifo_file,lock).
access_vector(allow,staff_t,staff_crontab_t,fifo_file,write).
access_vector(allow,staff_t,staff_crontab_t,fifo_file,append).
access_vector(allow,staff_t,bin_t,file,read).
access_vector(allow,staff_t,bin_t,file,getattr).
access_vector(allow,staff_t,bin_t,file,lock).
access_vector(allow,staff_t,bin_t,file,execute).
access_vector(allow,staff_t,sbin_t,file,read).
access_vector(allow,staff_t,sbin_t,file,getattr).
access_vector(allow,staff_t,sbin_t,file,lock).
access_vector(allow,staff_t,sbin_t,file,execute).
access_vector(allow,staff_t,bin_t,file,entrypoint).
access_vector(allow,staff_t,sbin_t,file,entrypoint).
access_vector(allow,staff_t,shell_exec_t,file,entrypoint).
type_trans(staff_crontab_t,[bin_t,sbin_t,shell_exec_t],process,staff_t).
access_vector(allow,staff_crontab_t,staff_home_t,dir,read).
access_vector(allow,staff_crontab_t,staff_home_t,dir,getattr).
access_vector(allow,staff_crontab_t,staff_home_t,dir,lock).
access_vector(allow,staff_crontab_t,staff_home_t,dir,search).
access_vector(allow,staff_crontab_t,staff_home_t,dir,ioctl).
access_vector(allow,staff_crontab_t,staff_home_dir_t,dir,read).
access_vector(allow,staff_crontab_t,staff_home_dir_t,dir,getattr).
access_vector(allow,staff_crontab_t,staff_home_dir_t,dir,lock).
access_vector(allow,staff_crontab_t,staff_home_dir_t,dir,search).
access_vector(allow,staff_crontab_t,staff_home_dir_t,dir,ioctl).
access_vector(allow,staff_crontab_t,staff_home_t,file,read).
access_vector(allow,staff_crontab_t,staff_home_t,file,getattr).
access_vector(allow,staff_crontab_t,staff_home_t,file,lock).
access_vector(allow,staff_crontab_t,staff_home_t,file,ioctl).
access_vector(dontaudit,staff_crontab_t,staff_home_dir_t,dir,write).
access_vector(allow,staff_crontab_t,cron_log_t,file,read).
access_vector(allow,staff_crontab_t,cron_log_t,file,getattr).
access_vector(allow,staff_crontab_t,cron_log_t,file,lock).
access_vector(allow,staff_crontab_t,cron_log_t,file,ioctl).
access_vector(allow,staff_crontab_t,cron_log_t,file,append).
access_vector(allow,staff_crontab_t,device_t,dir,search).
access_vector(allow,staff_crontab_t,staff_tty_device_t,chr_file,ioctl).
access_vector(allow,staff_crontab_t,staff_tty_device_t,chr_file,read).
access_vector(allow,staff_crontab_t,staff_tty_device_t,chr_file,getattr).
access_vector(allow,staff_crontab_t,staff_tty_device_t,chr_file,lock).
access_vector(allow,staff_crontab_t,staff_tty_device_t,chr_file,write).
access_vector(allow,staff_crontab_t,staff_tty_device_t,chr_file,append).
access_vector(allow,staff_crontab_t,staff_devpts_t,chr_file,ioctl).
access_vector(allow,staff_crontab_t,staff_devpts_t,chr_file,read).
access_vector(allow,staff_crontab_t,staff_devpts_t,chr_file,getattr).
access_vector(allow,staff_crontab_t,staff_devpts_t,chr_file,lock).
access_vector(allow,staff_crontab_t,staff_devpts_t,chr_file,write).
access_vector(allow,staff_crontab_t,staff_devpts_t,chr_file,append).
access_vector(allow,staff_crontab_t,privfd,fd,use).
type_decl(staff_ssh_t,[],[domain,privlog]).
access_vector(allow,staff_t,staff_ssh_t,process,transition).
access_vector(dontaudit,staff_t,staff_ssh_t,process,noatsecure).
access_vector(allow,staff_t,ssh_exec_t,file,read).
access_vector(allow,staff_t,ssh_exec_t,file,getattr).
access_vector(allow,staff_t,ssh_exec_t,file,execute).
access_vector(allow,staff_ssh_t,staff_t,process,sigchld).
access_vector(allow,staff_ssh_t,staff_t,fd,use).
access_vector(allow,staff_t,staff_ssh_t,fd,use).
access_vector(allow,staff_ssh_t,staff_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,staff_t,fifo_file,read).
access_vector(allow,staff_ssh_t,staff_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,staff_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,staff_t,fifo_file,write).
access_vector(allow,staff_ssh_t,staff_t,fifo_file,append).
access_vector(allow,staff_ssh_t,ssh_exec_t,file,read).
access_vector(allow,staff_ssh_t,ssh_exec_t,file,getattr).
access_vector(allow,staff_ssh_t,ssh_exec_t,file,lock).
access_vector(allow,staff_ssh_t,ssh_exec_t,file,execute).
access_vector(allow,staff_ssh_t,ssh_exec_t,file,ioctl).
access_vector(allow,staff_ssh_t,ssh_exec_t,file,entrypoint).
type_trans(staff_t,ssh_exec_t,process,staff_ssh_t).
role_decl(staff_r,staff_ssh_t).
access_vector(allow,staff_ssh_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,staff_ssh_t,self,dir,read).
access_vector(allow,staff_ssh_t,self,dir,getattr).
access_vector(allow,staff_ssh_t,self,dir,lock).
access_vector(allow,staff_ssh_t,self,dir,search).
access_vector(allow,staff_ssh_t,self,dir,ioctl).
access_vector(allow,staff_ssh_t,self,file,read).
access_vector(allow,staff_ssh_t,self,file,getattr).
access_vector(allow,staff_ssh_t,self,file,lock).
access_vector(allow,staff_ssh_t,self,file,ioctl).
access_vector(allow,staff_ssh_t,self,lnk_file,read).
access_vector(allow,staff_ssh_t,self,lnk_file,getattr).
access_vector(allow,staff_ssh_t,self,lnk_file,lock).
access_vector(allow,staff_ssh_t,self,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,self,sock_file,read).
access_vector(allow,staff_ssh_t,self,sock_file,getattr).
access_vector(allow,staff_ssh_t,self,sock_file,lock).
access_vector(allow,staff_ssh_t,self,sock_file,ioctl).
access_vector(allow,staff_ssh_t,self,fifo_file,read).
access_vector(allow,staff_ssh_t,self,fifo_file,getattr).
access_vector(allow,staff_ssh_t,self,fifo_file,lock).
access_vector(allow,staff_ssh_t,self,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,self,fd,_).
access_vector(allow,staff_ssh_t,self,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,self,fifo_file,read).
access_vector(allow,staff_ssh_t,self,fifo_file,getattr).
access_vector(allow,staff_ssh_t,self,fifo_file,lock).
access_vector(allow,staff_ssh_t,self,fifo_file,write).
access_vector(allow,staff_ssh_t,self,fifo_file,append).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,create).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,ioctl).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,read).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,getattr).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,write).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,setattr).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,append).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,bind).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,connect).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,getopt).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,setopt).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,shutdown).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,create).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,ioctl).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,read).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,getattr).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,write).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,setattr).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,append).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,bind).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,connect).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,getopt).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,setopt).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,shutdown).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,listen).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,accept).
access_vector(allow,staff_ssh_t,self,unix_dgram_socket,sendto).
access_vector(allow,staff_ssh_t,self,unix_stream_socket,connectto).
access_vector(allow,staff_ssh_t,self,sem,associate).
access_vector(allow,staff_ssh_t,self,sem,getattr).
access_vector(allow,staff_ssh_t,self,sem,setattr).
access_vector(allow,staff_ssh_t,self,sem,create).
access_vector(allow,staff_ssh_t,self,sem,destroy).
access_vector(allow,staff_ssh_t,self,sem,read).
access_vector(allow,staff_ssh_t,self,sem,write).
access_vector(allow,staff_ssh_t,self,sem,unix_read).
access_vector(allow,staff_ssh_t,self,sem,unix_write).
access_vector(allow,staff_ssh_t,self,msg,send).
access_vector(allow,staff_ssh_t,self,msg,receive).
access_vector(allow,staff_ssh_t,self,msgq,associate).
access_vector(allow,staff_ssh_t,self,msgq,getattr).
access_vector(allow,staff_ssh_t,self,msgq,setattr).
access_vector(allow,staff_ssh_t,self,msgq,create).
access_vector(allow,staff_ssh_t,self,msgq,destroy).
access_vector(allow,staff_ssh_t,self,msgq,read).
access_vector(allow,staff_ssh_t,self,msgq,write).
access_vector(allow,staff_ssh_t,self,msgq,enqueue).
access_vector(allow,staff_ssh_t,self,msgq,unix_read).
access_vector(allow,staff_ssh_t,self,msgq,unix_write).
access_vector(allow,staff_ssh_t,self,shm,associate).
access_vector(allow,staff_ssh_t,self,shm,getattr).
access_vector(allow,staff_ssh_t,self,shm,setattr).
access_vector(allow,staff_ssh_t,self,shm,create).
access_vector(allow,staff_ssh_t,self,shm,destroy).
access_vector(allow,staff_ssh_t,self,shm,read).
access_vector(allow,staff_ssh_t,self,shm,write).
access_vector(allow,staff_ssh_t,self,shm,lock).
access_vector(allow,staff_ssh_t,self,shm,unix_read).
access_vector(allow,staff_ssh_t,self,shm,unix_write).
access_vector(allow,staff_ssh_t,privfd,fd,use).
access_vector(allow,staff_ssh_t,root_t,dir,read).
access_vector(allow,staff_ssh_t,root_t,dir,getattr).
access_vector(allow,staff_ssh_t,root_t,dir,lock).
access_vector(allow,staff_ssh_t,root_t,dir,search).
access_vector(allow,staff_ssh_t,root_t,dir,ioctl).
access_vector(allow,staff_ssh_t,usr_t,dir,read).
access_vector(allow,staff_ssh_t,usr_t,dir,getattr).
access_vector(allow,staff_ssh_t,usr_t,dir,lock).
access_vector(allow,staff_ssh_t,usr_t,dir,search).
access_vector(allow,staff_ssh_t,usr_t,dir,ioctl).
access_vector(allow,staff_ssh_t,lib_t,dir,read).
access_vector(allow,staff_ssh_t,lib_t,dir,getattr).
access_vector(allow,staff_ssh_t,lib_t,dir,lock).
access_vector(allow,staff_ssh_t,lib_t,dir,search).
access_vector(allow,staff_ssh_t,lib_t,dir,ioctl).
access_vector(allow,staff_ssh_t,etc_t,dir,read).
access_vector(allow,staff_ssh_t,etc_t,dir,getattr).
access_vector(allow,staff_ssh_t,etc_t,dir,lock).
access_vector(allow,staff_ssh_t,etc_t,dir,search).
access_vector(allow,staff_ssh_t,etc_t,dir,ioctl).
access_vector(allow,staff_ssh_t,lib_t,lnk_file,read).
access_vector(allow,staff_ssh_t,lib_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,lib_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,lib_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,ld_so_t,file,read).
access_vector(allow,staff_ssh_t,ld_so_t,file,getattr).
access_vector(allow,staff_ssh_t,ld_so_t,file,lock).
access_vector(allow,staff_ssh_t,ld_so_t,file,execute).
access_vector(allow,staff_ssh_t,ld_so_t,file,ioctl).
access_vector(allow,staff_ssh_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_ssh_t,ld_so_t,lnk_file,read).
access_vector(allow,staff_ssh_t,ld_so_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,ld_so_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,shlib_t,file,read).
access_vector(allow,staff_ssh_t,shlib_t,file,getattr).
access_vector(allow,staff_ssh_t,shlib_t,file,lock).
access_vector(allow,staff_ssh_t,shlib_t,file,execute).
access_vector(allow,staff_ssh_t,shlib_t,file,ioctl).
access_vector(allow,staff_ssh_t,shlib_t,lnk_file,read).
access_vector(allow,staff_ssh_t,shlib_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,shlib_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,shlib_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,ld_so_cache_t,file,read).
access_vector(allow,staff_ssh_t,ld_so_cache_t,file,getattr).
access_vector(allow,staff_ssh_t,ld_so_cache_t,file,lock).
access_vector(allow,staff_ssh_t,ld_so_cache_t,file,ioctl).
access_vector(allow,staff_ssh_t,device_t,dir,search).
access_vector(allow,staff_ssh_t,null_device_t,chr_file,ioctl).
access_vector(allow,staff_ssh_t,null_device_t,chr_file,read).
access_vector(allow,staff_ssh_t,null_device_t,chr_file,getattr).
access_vector(allow,staff_ssh_t,null_device_t,chr_file,lock).
access_vector(allow,staff_ssh_t,null_device_t,chr_file,write).
access_vector(allow,staff_ssh_t,null_device_t,chr_file,append).
access_vector(allow,staff_ssh_t,etc_t,lnk_file,read).
access_vector(allow,staff_ssh_t,locale_t,dir,read).
access_vector(allow,staff_ssh_t,locale_t,dir,getattr).
access_vector(allow,staff_ssh_t,locale_t,dir,lock).
access_vector(allow,staff_ssh_t,locale_t,dir,search).
access_vector(allow,staff_ssh_t,locale_t,dir,ioctl).
access_vector(allow,staff_ssh_t,locale_t,file,read).
access_vector(allow,staff_ssh_t,locale_t,file,getattr).
access_vector(allow,staff_ssh_t,locale_t,file,lock).
access_vector(allow,staff_ssh_t,locale_t,file,ioctl).
access_vector(allow,staff_ssh_t,locale_t,lnk_file,read).
access_vector(allow,staff_ssh_t,locale_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,locale_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,locale_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,fs_type,filesystem,getattr).
access_vector(allow,staff_ssh_t,root_t,file,read).
access_vector(allow,staff_ssh_t,root_t,file,getattr).
access_vector(allow,staff_ssh_t,root_t,file,lock).
access_vector(allow,staff_ssh_t,root_t,file,ioctl).
access_vector(allow,staff_ssh_t,root_t,lnk_file,read).
access_vector(allow,staff_ssh_t,root_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,root_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,root_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,root_t,sock_file,read).
access_vector(allow,staff_ssh_t,root_t,sock_file,getattr).
access_vector(allow,staff_ssh_t,root_t,sock_file,lock).
access_vector(allow,staff_ssh_t,root_t,sock_file,ioctl).
access_vector(allow,staff_ssh_t,root_t,fifo_file,read).
access_vector(allow,staff_ssh_t,root_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,root_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,root_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,home_root_t,dir,read).
access_vector(allow,staff_ssh_t,home_root_t,dir,getattr).
access_vector(allow,staff_ssh_t,home_root_t,dir,lock).
access_vector(allow,staff_ssh_t,home_root_t,dir,search).
access_vector(allow,staff_ssh_t,home_root_t,dir,ioctl).
access_vector(allow,staff_ssh_t,usr_t,file,read).
access_vector(allow,staff_ssh_t,usr_t,file,getattr).
access_vector(allow,staff_ssh_t,usr_t,file,lock).
access_vector(allow,staff_ssh_t,usr_t,file,ioctl).
access_vector(allow,staff_ssh_t,usr_t,lnk_file,read).
access_vector(allow,staff_ssh_t,usr_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,usr_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,usr_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,usr_t,sock_file,read).
access_vector(allow,staff_ssh_t,usr_t,sock_file,getattr).
access_vector(allow,staff_ssh_t,usr_t,sock_file,lock).
access_vector(allow,staff_ssh_t,usr_t,sock_file,ioctl).
access_vector(allow,staff_ssh_t,usr_t,fifo_file,read).
access_vector(allow,staff_ssh_t,usr_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,usr_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,usr_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,bin_t,dir,read).
access_vector(allow,staff_ssh_t,bin_t,dir,getattr).
access_vector(allow,staff_ssh_t,bin_t,dir,lock).
access_vector(allow,staff_ssh_t,bin_t,dir,search).
access_vector(allow,staff_ssh_t,bin_t,dir,ioctl).
access_vector(allow,staff_ssh_t,bin_t,file,read).
access_vector(allow,staff_ssh_t,bin_t,file,getattr).
access_vector(allow,staff_ssh_t,bin_t,file,lock).
access_vector(allow,staff_ssh_t,bin_t,file,ioctl).
access_vector(allow,staff_ssh_t,bin_t,lnk_file,read).
access_vector(allow,staff_ssh_t,bin_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,bin_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,bin_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,bin_t,sock_file,read).
access_vector(allow,staff_ssh_t,bin_t,sock_file,getattr).
access_vector(allow,staff_ssh_t,bin_t,sock_file,lock).
access_vector(allow,staff_ssh_t,bin_t,sock_file,ioctl).
access_vector(allow,staff_ssh_t,bin_t,fifo_file,read).
access_vector(allow,staff_ssh_t,bin_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,bin_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,bin_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,sbin_t,dir,read).
access_vector(allow,staff_ssh_t,sbin_t,dir,getattr).
access_vector(allow,staff_ssh_t,sbin_t,dir,lock).
access_vector(allow,staff_ssh_t,sbin_t,dir,search).
access_vector(allow,staff_ssh_t,sbin_t,dir,ioctl).
access_vector(allow,staff_ssh_t,sbin_t,file,read).
access_vector(allow,staff_ssh_t,sbin_t,file,getattr).
access_vector(allow,staff_ssh_t,sbin_t,file,lock).
access_vector(allow,staff_ssh_t,sbin_t,file,ioctl).
access_vector(allow,staff_ssh_t,sbin_t,lnk_file,read).
access_vector(allow,staff_ssh_t,sbin_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,sbin_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,sbin_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,sbin_t,sock_file,read).
access_vector(allow,staff_ssh_t,sbin_t,sock_file,getattr).
access_vector(allow,staff_ssh_t,sbin_t,sock_file,lock).
access_vector(allow,staff_ssh_t,sbin_t,sock_file,ioctl).
access_vector(allow,staff_ssh_t,sbin_t,fifo_file,read).
access_vector(allow,staff_ssh_t,sbin_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,sbin_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,sbin_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,devpts_t,dir,read).
access_vector(allow,staff_ssh_t,devpts_t,dir,getattr).
access_vector(allow,staff_ssh_t,devpts_t,dir,lock).
access_vector(allow,staff_ssh_t,devpts_t,dir,search).
access_vector(allow,staff_ssh_t,devpts_t,dir,ioctl).
access_vector(allow,staff_ssh_t,var_t,dir,read).
access_vector(allow,staff_ssh_t,var_t,dir,getattr).
access_vector(allow,staff_ssh_t,var_t,dir,lock).
access_vector(allow,staff_ssh_t,var_t,dir,search).
access_vector(allow,staff_ssh_t,var_t,dir,ioctl).
access_vector(allow,staff_ssh_t,var_t,file,read).
access_vector(allow,staff_ssh_t,var_t,file,getattr).
access_vector(allow,staff_ssh_t,var_t,file,lock).
access_vector(allow,staff_ssh_t,var_t,file,ioctl).
access_vector(allow,staff_ssh_t,var_t,lnk_file,read).
access_vector(allow,staff_ssh_t,var_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,var_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,var_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,var_t,sock_file,read).
access_vector(allow,staff_ssh_t,var_t,sock_file,getattr).
access_vector(allow,staff_ssh_t,var_t,sock_file,lock).
access_vector(allow,staff_ssh_t,var_t,sock_file,ioctl).
access_vector(allow,staff_ssh_t,var_t,fifo_file,read).
access_vector(allow,staff_ssh_t,var_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,var_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,var_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,var_run_t,dir,read).
access_vector(allow,staff_ssh_t,var_run_t,dir,getattr).
access_vector(allow,staff_ssh_t,var_run_t,dir,lock).
access_vector(allow,staff_ssh_t,var_run_t,dir,search).
access_vector(allow,staff_ssh_t,var_run_t,dir,ioctl).
access_vector(allow,staff_ssh_t,var_run_t,file,read).
access_vector(allow,staff_ssh_t,var_run_t,file,getattr).
access_vector(allow,staff_ssh_t,var_run_t,file,lock).
access_vector(allow,staff_ssh_t,var_run_t,file,ioctl).
access_vector(allow,staff_ssh_t,var_run_t,lnk_file,read).
access_vector(allow,staff_ssh_t,var_run_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,var_run_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,var_run_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,var_log_t,dir,read).
access_vector(allow,staff_ssh_t,var_log_t,dir,getattr).
access_vector(allow,staff_ssh_t,var_log_t,dir,lock).
access_vector(allow,staff_ssh_t,var_log_t,dir,search).
access_vector(allow,staff_ssh_t,var_log_t,dir,ioctl).
access_vector(allow,staff_ssh_t,var_log_t,file,read).
access_vector(allow,staff_ssh_t,var_log_t,file,getattr).
access_vector(allow,staff_ssh_t,var_log_t,file,lock).
access_vector(allow,staff_ssh_t,var_log_t,file,ioctl).
access_vector(allow,staff_ssh_t,var_log_t,lnk_file,read).
access_vector(allow,staff_ssh_t,var_log_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,var_log_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,var_log_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,etc_t,file,read).
access_vector(allow,staff_ssh_t,etc_t,file,getattr).
access_vector(allow,staff_ssh_t,etc_t,file,lock).
access_vector(allow,staff_ssh_t,etc_t,file,ioctl).
access_vector(allow,staff_ssh_t,etc_t,lnk_file,read).
access_vector(allow,staff_ssh_t,etc_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,etc_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,etc_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,etc_t,sock_file,read).
access_vector(allow,staff_ssh_t,etc_t,sock_file,getattr).
access_vector(allow,staff_ssh_t,etc_t,sock_file,lock).
access_vector(allow,staff_ssh_t,etc_t,sock_file,ioctl).
access_vector(allow,staff_ssh_t,etc_t,fifo_file,read).
access_vector(allow,staff_ssh_t,etc_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,etc_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,etc_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,etc_runtime_t,file,read).
access_vector(allow,staff_ssh_t,etc_runtime_t,file,getattr).
access_vector(allow,staff_ssh_t,etc_runtime_t,file,lock).
access_vector(allow,staff_ssh_t,etc_runtime_t,file,ioctl).
access_vector(allow,staff_ssh_t,etc_runtime_t,lnk_file,read).
access_vector(allow,staff_ssh_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,resolv_conf_t,file,read).
access_vector(allow,staff_ssh_t,resolv_conf_t,file,getattr).
access_vector(allow,staff_ssh_t,resolv_conf_t,file,lock).
access_vector(allow,staff_ssh_t,resolv_conf_t,file,ioctl).
access_vector(allow,staff_ssh_t,resolv_conf_t,lnk_file,read).
access_vector(allow,staff_ssh_t,resolv_conf_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,resolv_conf_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,resolv_conf_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,ld_so_t,file,read).
access_vector(allow,staff_ssh_t,ld_so_t,file,getattr).
access_vector(allow,staff_ssh_t,ld_so_t,file,lock).
access_vector(allow,staff_ssh_t,shlib_t,file,read).
access_vector(allow,staff_ssh_t,shlib_t,file,getattr).
access_vector(allow,staff_ssh_t,shlib_t,file,lock).
access_vector(allow,staff_ssh_t,exec_type,file,read).
access_vector(allow,staff_ssh_t,exec_type,file,getattr).
access_vector(allow,staff_ssh_t,exec_type,file,lock).
access_vector(allow,staff_ssh_t,exec_type,file,ioctl).
access_vector(allow,staff_ssh_t,exec_type,lnk_file,read).
access_vector(allow,staff_ssh_t,exec_type,lnk_file,getattr).
access_vector(allow,staff_ssh_t,exec_type,lnk_file,lock).
access_vector(allow,staff_ssh_t,exec_type,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,device_t,dir,read).
access_vector(allow,staff_ssh_t,device_t,dir,getattr).
access_vector(allow,staff_ssh_t,device_t,dir,lock).
access_vector(allow,staff_ssh_t,device_t,dir,search).
access_vector(allow,staff_ssh_t,device_t,dir,ioctl).
access_vector(allow,staff_ssh_t,device_t,lnk_file,read).
access_vector(allow,staff_ssh_t,device_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,device_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,device_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,random_device_t,chr_file,read).
access_vector(allow,staff_ssh_t,random_device_t,chr_file,getattr).
access_vector(allow,staff_ssh_t,random_device_t,chr_file,lock).
access_vector(allow,staff_ssh_t,random_device_t,chr_file,ioctl).
access_vector(allow,staff_ssh_t,devtty_t,chr_file,ioctl).
access_vector(allow,staff_ssh_t,devtty_t,chr_file,read).
access_vector(allow,staff_ssh_t,devtty_t,chr_file,getattr).
access_vector(allow,staff_ssh_t,devtty_t,chr_file,lock).
access_vector(allow,staff_ssh_t,devtty_t,chr_file,write).
access_vector(allow,staff_ssh_t,devtty_t,chr_file,append).
access_vector(allow,staff_ssh_t,zero_device_t,chr_file,ioctl).
access_vector(allow,staff_ssh_t,zero_device_t,chr_file,read).
access_vector(allow,staff_ssh_t,zero_device_t,chr_file,getattr).
access_vector(allow,staff_ssh_t,zero_device_t,chr_file,lock).
access_vector(allow,staff_ssh_t,zero_device_t,chr_file,write).
access_vector(allow,staff_ssh_t,zero_device_t,chr_file,append).
access_vector(allow,staff_ssh_t,self,udp_socket,create).
access_vector(allow,staff_ssh_t,self,udp_socket,ioctl).
access_vector(allow,staff_ssh_t,self,udp_socket,read).
access_vector(allow,staff_ssh_t,self,udp_socket,getattr).
access_vector(allow,staff_ssh_t,self,udp_socket,write).
access_vector(allow,staff_ssh_t,self,udp_socket,setattr).
access_vector(allow,staff_ssh_t,self,udp_socket,append).
access_vector(allow,staff_ssh_t,self,udp_socket,bind).
access_vector(allow,staff_ssh_t,self,udp_socket,connect).
access_vector(allow,staff_ssh_t,self,udp_socket,getopt).
access_vector(allow,staff_ssh_t,self,udp_socket,setopt).
access_vector(allow,staff_ssh_t,self,udp_socket,shutdown).
access_vector(allow,staff_ssh_t,self,tcp_socket,create).
access_vector(allow,staff_ssh_t,self,tcp_socket,ioctl).
access_vector(allow,staff_ssh_t,self,tcp_socket,read).
access_vector(allow,staff_ssh_t,self,tcp_socket,getattr).
access_vector(allow,staff_ssh_t,self,tcp_socket,write).
access_vector(allow,staff_ssh_t,self,tcp_socket,setattr).
access_vector(allow,staff_ssh_t,self,tcp_socket,append).
access_vector(allow,staff_ssh_t,self,tcp_socket,bind).
access_vector(allow,staff_ssh_t,self,tcp_socket,connect).
access_vector(allow,staff_ssh_t,self,tcp_socket,getopt).
access_vector(allow,staff_ssh_t,self,tcp_socket,setopt).
access_vector(allow,staff_ssh_t,self,tcp_socket,shutdown).
access_vector(allow,staff_ssh_t,self,tcp_socket,listen).
access_vector(allow,staff_ssh_t,self,tcp_socket,accept).
access_vector(allow,staff_ssh_t,any_socket_t,udp_socket,sendto).
access_vector(allow,staff_ssh_t,netif_type,netif,tcp_send).
access_vector(allow,staff_ssh_t,netif_type,netif,udp_send).
access_vector(allow,staff_ssh_t,netif_type,netif,rawip_send).
access_vector(allow,staff_ssh_t,netif_type,netif,tcp_recv).
access_vector(allow,staff_ssh_t,netif_type,netif,udp_recv).
access_vector(allow,staff_ssh_t,netif_type,netif,rawip_recv).
access_vector(allow,staff_ssh_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,staff_ssh_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,staff_ssh_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,staff_ssh_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,staff_ssh_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,staff_ssh_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,staff_ssh_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,staff_ssh_t,node_type,node,tcp_send).
access_vector(allow,staff_ssh_t,node_type,node,udp_send).
access_vector(allow,staff_ssh_t,node_type,node,rawip_send).
access_vector(allow,staff_ssh_t,node_type,node,tcp_recv).
access_vector(allow,staff_ssh_t,node_type,node,udp_recv).
access_vector(allow,staff_ssh_t,node_type,node,rawip_recv).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,ioctl).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,read).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,getattr).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,write).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,setattr).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,append).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,bind).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,connect).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,getopt).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,setopt).
access_vector(allow,staff_ssh_t,mount_t,udp_socket,shutdown).
access_vector(allow,staff_ssh_t,port_t,udp_socket,name_bind).
access_vector(allow,staff_ssh_t,port_t,tcp_socket,name_bind).
access_vector(allow,staff_ssh_t,staff_ssh_t,tcp_socket,connectto).
access_vector(allow,staff_ssh_t,staff_ssh_t,tcp_socket,recvfrom).
access_vector(allow,staff_ssh_t,staff_ssh_t,tcp_socket,acceptfrom).
access_vector(allow,staff_ssh_t,self,capability,setuid).
access_vector(allow,staff_ssh_t,self,capability,setgid).
access_vector(allow,staff_ssh_t,self,capability,dac_override).
access_vector(allow,staff_ssh_t,self,capability,dac_read_search).
access_vector(allow,staff_ssh_t,bin_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,bin_t,lnk_file,read).
access_vector(allow,staff_ssh_t,sbin_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,sbin_t,lnk_file,read).
access_vector(allow,staff_ssh_t,etc_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,etc_t,lnk_file,read).
access_vector(allow,staff_ssh_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_ssh_t,device_t,dir,search).
access_vector(allow,staff_ssh_t,etc_t,file,read).
access_vector(allow,staff_ssh_t,etc_t,file,getattr).
access_vector(allow,staff_ssh_t,etc_t,file,lock).
access_vector(allow,staff_ssh_t,etc_t,file,execute).
access_vector(allow,staff_ssh_t,etc_t,file,ioctl).
access_vector(allow,staff_ssh_t,etc_t,file,execute_no_trans).
access_vector(allow,staff_ssh_t,lib_t,file,read).
access_vector(allow,staff_ssh_t,lib_t,file,getattr).
access_vector(allow,staff_ssh_t,lib_t,file,lock).
access_vector(allow,staff_ssh_t,lib_t,file,execute).
access_vector(allow,staff_ssh_t,lib_t,file,ioctl).
access_vector(allow,staff_ssh_t,lib_t,file,execute_no_trans).
access_vector(allow,staff_ssh_t,bin_t,file,read).
access_vector(allow,staff_ssh_t,bin_t,file,getattr).
access_vector(allow,staff_ssh_t,bin_t,file,lock).
access_vector(allow,staff_ssh_t,bin_t,file,execute).
access_vector(allow,staff_ssh_t,bin_t,file,ioctl).
access_vector(allow,staff_ssh_t,bin_t,file,execute_no_trans).
access_vector(allow,staff_ssh_t,sbin_t,file,read).
access_vector(allow,staff_ssh_t,sbin_t,file,getattr).
access_vector(allow,staff_ssh_t,sbin_t,file,lock).
access_vector(allow,staff_ssh_t,sbin_t,file,execute).
access_vector(allow,staff_ssh_t,sbin_t,file,ioctl).
access_vector(allow,staff_ssh_t,sbin_t,file,execute_no_trans).
access_vector(allow,staff_ssh_t,exec_type,file,read).
access_vector(allow,staff_ssh_t,exec_type,file,getattr).
access_vector(allow,staff_ssh_t,exec_type,file,lock).
access_vector(allow,staff_ssh_t,exec_type,file,execute).
access_vector(allow,staff_ssh_t,exec_type,file,ioctl).
access_vector(allow,staff_ssh_t,exec_type,file,execute_no_trans).
access_vector(allow,staff_ssh_t,sshd_key_t,file,read).
access_vector(allow,staff_ssh_t,sshd_key_t,file,getattr).
access_vector(allow,staff_ssh_t,sshd_key_t,file,lock).
access_vector(allow,staff_ssh_t,sshd_key_t,file,ioctl).
access_vector(allow,staff_ssh_t,tmp_t,dir,read).
access_vector(allow,staff_ssh_t,tmp_t,dir,getattr).
access_vector(allow,staff_ssh_t,tmp_t,dir,lock).
access_vector(allow,staff_ssh_t,tmp_t,dir,search).
access_vector(allow,staff_ssh_t,tmp_t,dir,ioctl).
access_vector(allow,staff_ssh_t,tmp_t,dir,add_name).
access_vector(allow,staff_ssh_t,tmp_t,dir,remove_name).
access_vector(allow,staff_ssh_t,tmp_t,dir,write).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,create).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,ioctl).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,read).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,getattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,lock).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,write).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,setattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,append).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,link).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,unlink).
access_vector(allow,staff_ssh_t,sshd_tmp_t,file,rename).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,create).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,read).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,write).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,setattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,append).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,link).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,unlink).
access_vector(allow,staff_ssh_t,sshd_tmp_t,lnk_file,rename).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,create).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,ioctl).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,read).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,getattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,lock).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,write).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,setattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,append).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,link).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,unlink).
access_vector(allow,staff_ssh_t,sshd_tmp_t,sock_file,rename).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,create).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,read).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,write).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,setattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,append).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,link).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,unlink).
access_vector(allow,staff_ssh_t,sshd_tmp_t,fifo_file,rename).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,create).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,read).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,getattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,lock).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,setattr).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,link).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,unlink).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,rename).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,search).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,add_name).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,remove_name).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,reparent).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,write).
access_vector(allow,staff_ssh_t,sshd_tmp_t,dir,rmdir).
type_trans(staff_ssh_t,tmp_t,dir,sshd_tmp_t).
type_trans(staff_ssh_t,tmp_t,[file,lnk_file,sock_file,fifo_file],sshd_tmp_t).
access_vector(allow,staff_ssh_t,staff_tmp_t,dir,read).
access_vector(allow,staff_ssh_t,staff_tmp_t,dir,getattr).
access_vector(allow,staff_ssh_t,staff_tmp_t,dir,lock).
access_vector(allow,staff_ssh_t,staff_tmp_t,dir,search).
access_vector(allow,staff_ssh_t,staff_tmp_t,dir,ioctl).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,ioctl).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,read).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,getattr).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,write).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,setattr).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,append).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,bind).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,connect).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,getopt).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,setopt).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,shutdown).
type_decl(staff_home_ssh_t,[],[file_type,sysadmfile]).
access_vector(allow,sysadm_ssh_t,staff_home_dir_t,dir,read).
access_vector(allow,sysadm_ssh_t,staff_home_dir_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,staff_home_dir_t,dir,lock).
access_vector(allow,sysadm_ssh_t,staff_home_dir_t,dir,search).
access_vector(allow,sysadm_ssh_t,staff_home_dir_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,staff_home_dir_t,dir,add_name).
access_vector(allow,sysadm_ssh_t,staff_home_dir_t,dir,remove_name).
access_vector(allow,sysadm_ssh_t,staff_home_dir_t,dir,write).
access_vector(allow,staff_ssh_t,staff_home_dir_t,dir,read).
access_vector(allow,staff_ssh_t,staff_home_dir_t,dir,getattr).
access_vector(allow,staff_ssh_t,staff_home_dir_t,dir,lock).
access_vector(allow,staff_ssh_t,staff_home_dir_t,dir,search).
access_vector(allow,staff_ssh_t,staff_home_dir_t,dir,ioctl).
access_vector(allow,staff_ssh_t,staff_home_dir_t,dir,add_name).
access_vector(allow,staff_ssh_t,staff_home_dir_t,dir,remove_name).
access_vector(allow,staff_ssh_t,staff_home_dir_t,dir,write).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,create).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,read).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,getattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,lock).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,write).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,setattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,append).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,link).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,unlink).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,file,rename).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,create).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,ioctl).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,write).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,setattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,append).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,link).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,unlink).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,rename).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,create).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,ioctl).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,read).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,getattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,lock).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,write).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,setattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,append).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,link).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,unlink).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,sock_file,rename).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,create).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,ioctl).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,read).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,getattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,lock).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,write).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,setattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,append).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,link).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,unlink).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,fifo_file,rename).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,create).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,ioctl).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,read).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,getattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,lock).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,write).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,setattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,append).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,link).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,unlink).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,file,rename).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,create).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,ioctl).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,read).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,lock).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,write).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,setattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,append).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,link).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,unlink).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,rename).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,create).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,ioctl).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,read).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,getattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,lock).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,write).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,setattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,append).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,link).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,unlink).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,sock_file,rename).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,create).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,ioctl).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,read).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,getattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,lock).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,write).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,setattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,append).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,link).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,unlink).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,fifo_file,rename).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,create).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,read).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,lock).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,setattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,link).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,unlink).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,rename).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,search).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,add_name).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,remove_name).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,reparent).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,write).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,dir,rmdir).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,create).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,read).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,getattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,lock).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,setattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,link).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,unlink).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,rename).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,search).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,add_name).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,remove_name).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,reparent).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,write).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,dir,rmdir).
type_trans([sysadm_ssh_t,staff_ssh_t],staff_home_dir_t,dir,staff_home_ssh_t).
type_trans([sysadm_ssh_t,staff_ssh_t],staff_home_dir_t,[file,lnk_file,sock_file,fifo_file],staff_home_ssh_t).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,staff_home_ssh_t,lnk_file,read).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,staff_home_ssh_t,lnk_file,read).
access_vector(dontaudit,staff_ssh_t,staff_home_t,dir,search).
access_vector(allow,sshd_t,staff_home_ssh_t,dir,read).
access_vector(allow,sshd_t,staff_home_ssh_t,dir,getattr).
access_vector(allow,sshd_t,staff_home_ssh_t,dir,lock).
access_vector(allow,sshd_t,staff_home_ssh_t,dir,search).
access_vector(allow,sshd_t,staff_home_ssh_t,dir,ioctl).
access_vector(allow,sshd_t,staff_home_ssh_t,file,read).
access_vector(allow,sshd_t,staff_home_ssh_t,file,getattr).
access_vector(allow,sshd_t,staff_home_ssh_t,file,lock).
access_vector(allow,sshd_t,staff_home_ssh_t,file,ioctl).
access_vector(allow,sshd_t,staff_home_ssh_t,lnk_file,read).
access_vector(allow,sshd_t,staff_home_ssh_t,lnk_file,getattr).
access_vector(allow,sshd_t,staff_home_ssh_t,lnk_file,lock).
access_vector(allow,sshd_t,staff_home_ssh_t,lnk_file,ioctl).
access_vector(allow,staff_t,staff_home_ssh_t,dir,read).
access_vector(allow,staff_t,staff_home_ssh_t,dir,getattr).
access_vector(allow,staff_t,staff_home_ssh_t,dir,lock).
access_vector(allow,staff_t,staff_home_ssh_t,dir,search).
access_vector(allow,staff_t,staff_home_ssh_t,dir,ioctl).
access_vector(allow,staff_t,staff_home_ssh_t,dir,add_name).
access_vector(allow,staff_t,staff_home_ssh_t,dir,remove_name).
access_vector(allow,staff_t,staff_home_ssh_t,dir,write).
access_vector(allow,staff_t,staff_home_ssh_t,file,create).
access_vector(allow,staff_t,staff_home_ssh_t,file,ioctl).
access_vector(allow,staff_t,staff_home_ssh_t,file,read).
access_vector(allow,staff_t,staff_home_ssh_t,file,getattr).
access_vector(allow,staff_t,staff_home_ssh_t,file,lock).
access_vector(allow,staff_t,staff_home_ssh_t,file,write).
access_vector(allow,staff_t,staff_home_ssh_t,file,setattr).
access_vector(allow,staff_t,staff_home_ssh_t,file,append).
access_vector(allow,staff_t,staff_home_ssh_t,file,link).
access_vector(allow,staff_t,staff_home_ssh_t,file,unlink).
access_vector(allow,staff_t,staff_home_ssh_t,file,rename).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,create).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,ioctl).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,read).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,getattr).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,lock).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,write).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,setattr).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,append).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,link).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,unlink).
access_vector(allow,staff_t,staff_home_ssh_t,lnk_file,rename).
access_vector(dontaudit,staff_ssh_t,proc_t,dir,search).
access_vector(allow,staff_ssh_t,sshd_t,tcp_socket,connectto).
access_vector(allow,staff_ssh_t,sshd_t,tcp_socket,recvfrom).
access_vector(allow,sshd_t,staff_ssh_t,tcp_socket,acceptfrom).
access_vector(allow,sshd_t,staff_ssh_t,tcp_socket,recvfrom).
access_vector(allow,staff_ssh_t,staff_tty_device_t,chr_file,ioctl).
access_vector(allow,staff_ssh_t,staff_tty_device_t,chr_file,read).
access_vector(allow,staff_ssh_t,staff_tty_device_t,chr_file,getattr).
access_vector(allow,staff_ssh_t,staff_tty_device_t,chr_file,lock).
access_vector(allow,staff_ssh_t,staff_tty_device_t,chr_file,write).
access_vector(allow,staff_ssh_t,staff_tty_device_t,chr_file,append).
access_vector(allow,staff_ssh_t,staff_devpts_t,chr_file,ioctl).
access_vector(allow,staff_ssh_t,staff_devpts_t,chr_file,read).
access_vector(allow,staff_ssh_t,staff_devpts_t,chr_file,getattr).
access_vector(allow,staff_ssh_t,staff_devpts_t,chr_file,lock).
access_vector(allow,staff_ssh_t,staff_devpts_t,chr_file,write).
access_vector(allow,staff_ssh_t,staff_devpts_t,chr_file,append).
access_vector(allow,staff_t,staff_ssh_t,process,signal).
access_vector(allow,staff_t,staff_ssh_t,dir,search).
access_vector(allow,staff_t,staff_ssh_t,dir,getattr).
access_vector(allow,staff_t,staff_ssh_t,dir,read).
access_vector(allow,staff_t,staff_ssh_t,file,read).
access_vector(allow,staff_t,staff_ssh_t,file,getattr).
access_vector(allow,staff_t,staff_ssh_t,lnk_file,read).
access_vector(allow,staff_t,staff_ssh_t,lnk_file,getattr).
access_vector(allow,staff_ssh_t,staff_tmp_t,sock_file,write).
access_vector(allow,staff_ssh_t,staff_t,unix_stream_socket,connectto).
access_vector(allow,staff_ssh_t,sshd_t,unix_stream_socket,connectto).
type_decl(staff_crond_t,[],[domain,user_crond_domain]).
access_vector(allow,crond_t,staff_crond_t,process,transition).
access_vector(dontaudit,crond_t,staff_crond_t,process,noatsecure).
access_vector(allow,staff_crond_t,crond_t,process,sigchld).
access_vector(allow,staff_crond_t,crond_t,fd,use).
access_vector(allow,crond_t,staff_crond_t,fd,use).
access_vector(allow,staff_crond_t,crond_t,fifo_file,ioctl).
access_vector(allow,staff_crond_t,crond_t,fifo_file,read).
access_vector(allow,staff_crond_t,crond_t,fifo_file,getattr).
access_vector(allow,staff_crond_t,crond_t,fifo_file,lock).
access_vector(allow,staff_crond_t,crond_t,fifo_file,write).
access_vector(allow,staff_crond_t,crond_t,fifo_file,append).
access_vector(allow,staff_crond_t,shell_exec_t,file,read).
access_vector(allow,staff_crond_t,shell_exec_t,file,getattr).
access_vector(allow,staff_crond_t,shell_exec_t,file,lock).
access_vector(allow,staff_crond_t,shell_exec_t,file,execute).
access_vector(allow,staff_crond_t,shell_exec_t,file,ioctl).
access_vector(allow,staff_crond_t,shell_exec_t,file,entrypoint).
role_decl(staff_r,staff_crond_t).
access_vector(allow,staff_crond_t,self,udp_socket,create).
access_vector(allow,staff_crond_t,self,udp_socket,ioctl).
access_vector(allow,staff_crond_t,self,udp_socket,read).
access_vector(allow,staff_crond_t,self,udp_socket,getattr).
access_vector(allow,staff_crond_t,self,udp_socket,write).
access_vector(allow,staff_crond_t,self,udp_socket,setattr).
access_vector(allow,staff_crond_t,self,udp_socket,append).
access_vector(allow,staff_crond_t,self,udp_socket,bind).
access_vector(allow,staff_crond_t,self,udp_socket,connect).
access_vector(allow,staff_crond_t,self,udp_socket,getopt).
access_vector(allow,staff_crond_t,self,udp_socket,setopt).
access_vector(allow,staff_crond_t,self,udp_socket,shutdown).
access_vector(allow,staff_crond_t,self,tcp_socket,create).
access_vector(allow,staff_crond_t,self,tcp_socket,ioctl).
access_vector(allow,staff_crond_t,self,tcp_socket,read).
access_vector(allow,staff_crond_t,self,tcp_socket,getattr).
access_vector(allow,staff_crond_t,self,tcp_socket,write).
access_vector(allow,staff_crond_t,self,tcp_socket,setattr).
access_vector(allow,staff_crond_t,self,tcp_socket,append).
access_vector(allow,staff_crond_t,self,tcp_socket,bind).
access_vector(allow,staff_crond_t,self,tcp_socket,connect).
access_vector(allow,staff_crond_t,self,tcp_socket,getopt).
access_vector(allow,staff_crond_t,self,tcp_socket,setopt).
access_vector(allow,staff_crond_t,self,tcp_socket,shutdown).
access_vector(allow,staff_crond_t,self,tcp_socket,listen).
access_vector(allow,staff_crond_t,self,tcp_socket,accept).
access_vector(allow,staff_crond_t,any_socket_t,udp_socket,sendto).
access_vector(allow,staff_crond_t,netif_type,netif,tcp_send).
access_vector(allow,staff_crond_t,netif_type,netif,udp_send).
access_vector(allow,staff_crond_t,netif_type,netif,rawip_send).
access_vector(allow,staff_crond_t,netif_type,netif,tcp_recv).
access_vector(allow,staff_crond_t,netif_type,netif,udp_recv).
access_vector(allow,staff_crond_t,netif_type,netif,rawip_recv).
access_vector(allow,staff_crond_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,staff_crond_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,staff_crond_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,staff_crond_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,staff_crond_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,staff_crond_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,staff_crond_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,staff_crond_t,node_type,node,tcp_send).
access_vector(allow,staff_crond_t,node_type,node,udp_send).
access_vector(allow,staff_crond_t,node_type,node,rawip_send).
access_vector(allow,staff_crond_t,node_type,node,tcp_recv).
access_vector(allow,staff_crond_t,node_type,node,udp_recv).
access_vector(allow,staff_crond_t,node_type,node,rawip_recv).
access_vector(allow,staff_crond_t,mount_t,udp_socket,ioctl).
access_vector(allow,staff_crond_t,mount_t,udp_socket,read).
access_vector(allow,staff_crond_t,mount_t,udp_socket,getattr).
access_vector(allow,staff_crond_t,mount_t,udp_socket,write).
access_vector(allow,staff_crond_t,mount_t,udp_socket,setattr).
access_vector(allow,staff_crond_t,mount_t,udp_socket,append).
access_vector(allow,staff_crond_t,mount_t,udp_socket,bind).
access_vector(allow,staff_crond_t,mount_t,udp_socket,connect).
access_vector(allow,staff_crond_t,mount_t,udp_socket,getopt).
access_vector(allow,staff_crond_t,mount_t,udp_socket,setopt).
access_vector(allow,staff_crond_t,mount_t,udp_socket,shutdown).
access_vector(allow,staff_crond_t,port_t,udp_socket,name_bind).
access_vector(allow,staff_crond_t,port_t,tcp_socket,name_bind).
access_vector(allow,staff_crond_t,resolv_conf_t,file,getattr).
access_vector(allow,staff_crond_t,resolv_conf_t,file,read).
access_vector(allow,staff_crond_t,root_t,dir,read).
access_vector(allow,staff_crond_t,root_t,dir,getattr).
access_vector(allow,staff_crond_t,root_t,dir,lock).
access_vector(allow,staff_crond_t,root_t,dir,search).
access_vector(allow,staff_crond_t,root_t,dir,ioctl).
access_vector(allow,staff_crond_t,usr_t,dir,read).
access_vector(allow,staff_crond_t,usr_t,dir,getattr).
access_vector(allow,staff_crond_t,usr_t,dir,lock).
access_vector(allow,staff_crond_t,usr_t,dir,search).
access_vector(allow,staff_crond_t,usr_t,dir,ioctl).
access_vector(allow,staff_crond_t,lib_t,dir,read).
access_vector(allow,staff_crond_t,lib_t,dir,getattr).
access_vector(allow,staff_crond_t,lib_t,dir,lock).
access_vector(allow,staff_crond_t,lib_t,dir,search).
access_vector(allow,staff_crond_t,lib_t,dir,ioctl).
access_vector(allow,staff_crond_t,etc_t,dir,read).
access_vector(allow,staff_crond_t,etc_t,dir,getattr).
access_vector(allow,staff_crond_t,etc_t,dir,lock).
access_vector(allow,staff_crond_t,etc_t,dir,search).
access_vector(allow,staff_crond_t,etc_t,dir,ioctl).
access_vector(allow,staff_crond_t,lib_t,lnk_file,read).
access_vector(allow,staff_crond_t,lib_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,lib_t,lnk_file,lock).
access_vector(allow,staff_crond_t,lib_t,lnk_file,ioctl).
access_vector(allow,staff_crond_t,ld_so_t,file,read).
access_vector(allow,staff_crond_t,ld_so_t,file,getattr).
access_vector(allow,staff_crond_t,ld_so_t,file,lock).
access_vector(allow,staff_crond_t,ld_so_t,file,execute).
access_vector(allow,staff_crond_t,ld_so_t,file,ioctl).
access_vector(allow,staff_crond_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_crond_t,ld_so_t,lnk_file,read).
access_vector(allow,staff_crond_t,ld_so_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,ld_so_t,lnk_file,lock).
access_vector(allow,staff_crond_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,staff_crond_t,shlib_t,file,read).
access_vector(allow,staff_crond_t,shlib_t,file,getattr).
access_vector(allow,staff_crond_t,shlib_t,file,lock).
access_vector(allow,staff_crond_t,shlib_t,file,execute).
access_vector(allow,staff_crond_t,shlib_t,file,ioctl).
access_vector(allow,staff_crond_t,shlib_t,lnk_file,read).
access_vector(allow,staff_crond_t,shlib_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,shlib_t,lnk_file,lock).
access_vector(allow,staff_crond_t,shlib_t,lnk_file,ioctl).
access_vector(allow,staff_crond_t,ld_so_cache_t,file,read).
access_vector(allow,staff_crond_t,ld_so_cache_t,file,getattr).
access_vector(allow,staff_crond_t,ld_so_cache_t,file,lock).
access_vector(allow,staff_crond_t,ld_so_cache_t,file,ioctl).
access_vector(allow,staff_crond_t,device_t,dir,search).
access_vector(allow,staff_crond_t,null_device_t,chr_file,ioctl).
access_vector(allow,staff_crond_t,null_device_t,chr_file,read).
access_vector(allow,staff_crond_t,null_device_t,chr_file,getattr).
access_vector(allow,staff_crond_t,null_device_t,chr_file,lock).
access_vector(allow,staff_crond_t,null_device_t,chr_file,write).
access_vector(allow,staff_crond_t,null_device_t,chr_file,append).
access_vector(allow,staff_crond_t,self,dir,read).
access_vector(allow,staff_crond_t,self,dir,getattr).
access_vector(allow,staff_crond_t,self,dir,lock).
access_vector(allow,staff_crond_t,self,dir,search).
access_vector(allow,staff_crond_t,self,dir,ioctl).
access_vector(allow,staff_crond_t,self,file,read).
access_vector(allow,staff_crond_t,self,file,getattr).
access_vector(allow,staff_crond_t,self,file,lock).
access_vector(allow,staff_crond_t,self,file,ioctl).
access_vector(allow,staff_crond_t,self,lnk_file,read).
access_vector(allow,staff_crond_t,self,lnk_file,getattr).
access_vector(allow,staff_crond_t,self,lnk_file,lock).
access_vector(allow,staff_crond_t,self,lnk_file,ioctl).
access_vector(allow,staff_crond_t,self,fifo_file,ioctl).
access_vector(allow,staff_crond_t,self,fifo_file,read).
access_vector(allow,staff_crond_t,self,fifo_file,getattr).
access_vector(allow,staff_crond_t,self,fifo_file,lock).
access_vector(allow,staff_crond_t,self,fifo_file,write).
access_vector(allow,staff_crond_t,self,fifo_file,append).
access_vector(allow,staff_crond_t,self,unix_stream_socket,create).
access_vector(allow,staff_crond_t,self,unix_stream_socket,ioctl).
access_vector(allow,staff_crond_t,self,unix_stream_socket,read).
access_vector(allow,staff_crond_t,self,unix_stream_socket,getattr).
access_vector(allow,staff_crond_t,self,unix_stream_socket,write).
access_vector(allow,staff_crond_t,self,unix_stream_socket,setattr).
access_vector(allow,staff_crond_t,self,unix_stream_socket,append).
access_vector(allow,staff_crond_t,self,unix_stream_socket,bind).
access_vector(allow,staff_crond_t,self,unix_stream_socket,connect).
access_vector(allow,staff_crond_t,self,unix_stream_socket,getopt).
access_vector(allow,staff_crond_t,self,unix_stream_socket,setopt).
access_vector(allow,staff_crond_t,self,unix_stream_socket,shutdown).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,create).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,ioctl).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,read).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,getattr).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,write).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,setattr).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,append).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,bind).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,connect).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,getopt).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,setopt).
access_vector(allow,staff_crond_t,self,unix_dgram_socket,shutdown).
access_vector(allow,staff_crond_t,etc_runtime_t,file,getattr).
access_vector(allow,staff_crond_t,etc_runtime_t,file,read).
access_vector(allow,staff_crond_t,self,process,fork).
access_vector(allow,staff_crond_t,self,process,sigchld).
access_vector(allow,staff_crond_t,self,process,sigkill).
access_vector(allow,staff_crond_t,self,process,sigstop).
access_vector(allow,staff_crond_t,self,process,signull).
access_vector(allow,staff_crond_t,self,process,signal).
access_vector(allow,staff_crond_t,proc_t,dir,getattr).
access_vector(allow,staff_crond_t,proc_t,dir,search).
access_vector(allow,staff_crond_t,proc_t,dir,read).
access_vector(allow,staff_crond_t,proc_t,file,getattr).
access_vector(allow,staff_crond_t,proc_t,file,read).
access_vector(allow,staff_crond_t,etc_t,lnk_file,read).
access_vector(allow,staff_crond_t,locale_t,dir,read).
access_vector(allow,staff_crond_t,locale_t,dir,getattr).
access_vector(allow,staff_crond_t,locale_t,dir,lock).
access_vector(allow,staff_crond_t,locale_t,dir,search).
access_vector(allow,staff_crond_t,locale_t,dir,ioctl).
access_vector(allow,staff_crond_t,locale_t,file,read).
access_vector(allow,staff_crond_t,locale_t,file,getattr).
access_vector(allow,staff_crond_t,locale_t,file,lock).
access_vector(allow,staff_crond_t,locale_t,file,ioctl).
access_vector(allow,staff_crond_t,locale_t,lnk_file,read).
access_vector(allow,staff_crond_t,locale_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,locale_t,lnk_file,lock).
access_vector(allow,staff_crond_t,locale_t,lnk_file,ioctl).
access_vector(allow,staff_crond_t,sysctl_kernel_t,dir,search).
access_vector(allow,staff_crond_t,sysctl_kernel_t,file,getattr).
access_vector(allow,staff_crond_t,sysctl_kernel_t,file,read).
access_vector(allow,staff_crond_t,var_spool_t,dir,search).
access_vector(allow,staff_crond_t,fs_t,filesystem,getattr).
access_vector(allow,staff_crond_t,devtty_t,chr_file,read).
access_vector(allow,staff_crond_t,devtty_t,chr_file,write).
access_vector(allow,staff_crond_t,staff_crond_t,capability,dac_override).
access_vector(allow,staff_crond_t,initrc_t,fd,use).
access_vector(allow,staff_crond_t,staff_cron_spool_t,file,entrypoint).
access_vector(allow,staff_crond_t,home_root_t,dir,search).
access_vector(allow,staff_crond_t,staff_home_dir_t,dir,read).
access_vector(allow,staff_crond_t,staff_home_dir_t,dir,getattr).
access_vector(allow,staff_crond_t,staff_home_dir_t,dir,lock).
access_vector(allow,staff_crond_t,staff_home_dir_t,dir,search).
access_vector(allow,staff_crond_t,staff_home_dir_t,dir,ioctl).
access_vector(allow,staff_crond_t,staff_home_dir_t,dir,add_name).
access_vector(allow,staff_crond_t,staff_home_dir_t,dir,remove_name).
access_vector(allow,staff_crond_t,staff_home_dir_t,dir,write).
access_vector(allow,staff_crond_t,staff_home_t,file,create).
access_vector(allow,staff_crond_t,staff_home_t,file,ioctl).
access_vector(allow,staff_crond_t,staff_home_t,file,read).
access_vector(allow,staff_crond_t,staff_home_t,file,getattr).
access_vector(allow,staff_crond_t,staff_home_t,file,lock).
access_vector(allow,staff_crond_t,staff_home_t,file,write).
access_vector(allow,staff_crond_t,staff_home_t,file,setattr).
access_vector(allow,staff_crond_t,staff_home_t,file,append).
access_vector(allow,staff_crond_t,staff_home_t,file,link).
access_vector(allow,staff_crond_t,staff_home_t,file,unlink).
access_vector(allow,staff_crond_t,staff_home_t,file,rename).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,create).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,ioctl).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,read).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,lock).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,write).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,setattr).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,append).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,link).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,unlink).
access_vector(allow,staff_crond_t,staff_home_t,lnk_file,rename).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,create).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,ioctl).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,read).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,getattr).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,lock).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,write).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,setattr).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,append).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,link).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,unlink).
access_vector(allow,staff_crond_t,staff_home_t,sock_file,rename).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,create).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,ioctl).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,read).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,getattr).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,lock).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,write).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,setattr).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,append).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,link).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,unlink).
access_vector(allow,staff_crond_t,staff_home_t,fifo_file,rename).
access_vector(allow,staff_crond_t,staff_home_t,dir,create).
access_vector(allow,staff_crond_t,staff_home_t,dir,read).
access_vector(allow,staff_crond_t,staff_home_t,dir,getattr).
access_vector(allow,staff_crond_t,staff_home_t,dir,lock).
access_vector(allow,staff_crond_t,staff_home_t,dir,setattr).
access_vector(allow,staff_crond_t,staff_home_t,dir,link).
access_vector(allow,staff_crond_t,staff_home_t,dir,unlink).
access_vector(allow,staff_crond_t,staff_home_t,dir,rename).
access_vector(allow,staff_crond_t,staff_home_t,dir,search).
access_vector(allow,staff_crond_t,staff_home_t,dir,add_name).
access_vector(allow,staff_crond_t,staff_home_t,dir,remove_name).
access_vector(allow,staff_crond_t,staff_home_t,dir,reparent).
access_vector(allow,staff_crond_t,staff_home_t,dir,write).
access_vector(allow,staff_crond_t,staff_home_t,dir,rmdir).
type_trans(staff_crond_t,staff_home_dir_t,dir,staff_home_t).
type_trans(staff_crond_t,staff_home_dir_t,[file,lnk_file,sock_file,fifo_file],staff_home_t).
access_vector(allow,staff_crond_t,tmp_t,dir,read).
access_vector(allow,staff_crond_t,tmp_t,dir,getattr).
access_vector(allow,staff_crond_t,tmp_t,dir,lock).
access_vector(allow,staff_crond_t,tmp_t,dir,search).
access_vector(allow,staff_crond_t,tmp_t,dir,ioctl).
access_vector(allow,staff_crond_t,tmp_t,dir,add_name).
access_vector(allow,staff_crond_t,tmp_t,dir,remove_name).
access_vector(allow,staff_crond_t,tmp_t,dir,write).
access_vector(allow,staff_crond_t,staff_tmp_t,file,create).
access_vector(allow,staff_crond_t,staff_tmp_t,file,ioctl).
access_vector(allow,staff_crond_t,staff_tmp_t,file,read).
access_vector(allow,staff_crond_t,staff_tmp_t,file,getattr).
access_vector(allow,staff_crond_t,staff_tmp_t,file,lock).
access_vector(allow,staff_crond_t,staff_tmp_t,file,write).
access_vector(allow,staff_crond_t,staff_tmp_t,file,setattr).
access_vector(allow,staff_crond_t,staff_tmp_t,file,append).
access_vector(allow,staff_crond_t,staff_tmp_t,file,link).
access_vector(allow,staff_crond_t,staff_tmp_t,file,unlink).
access_vector(allow,staff_crond_t,staff_tmp_t,file,rename).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,create).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,ioctl).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,read).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,lock).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,write).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,setattr).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,append).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,link).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,unlink).
access_vector(allow,staff_crond_t,staff_tmp_t,lnk_file,rename).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,create).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,ioctl).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,read).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,getattr).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,lock).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,write).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,setattr).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,append).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,link).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,unlink).
access_vector(allow,staff_crond_t,staff_tmp_t,sock_file,rename).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,create).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,ioctl).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,read).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,getattr).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,lock).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,write).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,setattr).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,append).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,link).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,unlink).
access_vector(allow,staff_crond_t,staff_tmp_t,fifo_file,rename).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,create).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,read).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,getattr).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,lock).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,setattr).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,link).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,unlink).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,rename).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,search).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,add_name).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,remove_name).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,reparent).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,write).
access_vector(allow,staff_crond_t,staff_tmp_t,dir,rmdir).
type_trans(staff_crond_t,tmp_t,dir,staff_tmp_t).
type_trans(staff_crond_t,tmp_t,[file,lnk_file,sock_file,fifo_file],staff_tmp_t).
access_vector(allow,staff_crond_t,bin_t,dir,read).
access_vector(allow,staff_crond_t,bin_t,dir,getattr).
access_vector(allow,staff_crond_t,bin_t,dir,lock).
access_vector(allow,staff_crond_t,bin_t,dir,search).
access_vector(allow,staff_crond_t,bin_t,dir,ioctl).
access_vector(allow,staff_crond_t,sbin_t,dir,read).
access_vector(allow,staff_crond_t,sbin_t,dir,getattr).
access_vector(allow,staff_crond_t,sbin_t,dir,lock).
access_vector(allow,staff_crond_t,sbin_t,dir,search).
access_vector(allow,staff_crond_t,sbin_t,dir,ioctl).
access_vector(allow,staff_crond_t,bin_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,bin_t,lnk_file,read).
access_vector(allow,staff_crond_t,sbin_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,sbin_t,lnk_file,read).
access_vector(allow,staff_crond_t,etc_t,lnk_file,getattr).
access_vector(allow,staff_crond_t,etc_t,lnk_file,read).
access_vector(allow,staff_crond_t,ld_so_t,file,execute_no_trans).
access_vector(allow,staff_crond_t,device_t,dir,search).
access_vector(allow,staff_crond_t,etc_t,file,read).
access_vector(allow,staff_crond_t,etc_t,file,getattr).
access_vector(allow,staff_crond_t,etc_t,file,lock).
access_vector(allow,staff_crond_t,etc_t,file,execute).
access_vector(allow,staff_crond_t,etc_t,file,ioctl).
access_vector(allow,staff_crond_t,etc_t,file,execute_no_trans).
access_vector(allow,staff_crond_t,lib_t,file,read).
access_vector(allow,staff_crond_t,lib_t,file,getattr).
access_vector(allow,staff_crond_t,lib_t,file,lock).
access_vector(allow,staff_crond_t,lib_t,file,execute).
access_vector(allow,staff_crond_t,lib_t,file,ioctl).
access_vector(allow,staff_crond_t,lib_t,file,execute_no_trans).
access_vector(allow,staff_crond_t,bin_t,file,read).
access_vector(allow,staff_crond_t,bin_t,file,getattr).
access_vector(allow,staff_crond_t,bin_t,file,lock).
access_vector(allow,staff_crond_t,bin_t,file,execute).
access_vector(allow,staff_crond_t,bin_t,file,ioctl).
access_vector(allow,staff_crond_t,bin_t,file,execute_no_trans).
access_vector(allow,staff_crond_t,sbin_t,file,read).
access_vector(allow,staff_crond_t,sbin_t,file,getattr).
access_vector(allow,staff_crond_t,sbin_t,file,lock).
access_vector(allow,staff_crond_t,sbin_t,file,execute).
access_vector(allow,staff_crond_t,sbin_t,file,ioctl).
access_vector(allow,staff_crond_t,sbin_t,file,execute_no_trans).
access_vector(allow,staff_crond_t,exec_type,file,read).
access_vector(allow,staff_crond_t,exec_type,file,getattr).
access_vector(allow,staff_crond_t,exec_type,file,lock).
access_vector(allow,staff_crond_t,exec_type,file,execute).
access_vector(allow,staff_crond_t,exec_type,file,ioctl).
access_vector(allow,staff_crond_t,exec_type,file,execute_no_trans).
access_vector(allow,staff_crond_t,staff_home_t,file,read).
access_vector(allow,staff_crond_t,staff_home_t,file,getattr).
access_vector(allow,staff_crond_t,staff_home_t,file,lock).
access_vector(allow,staff_crond_t,staff_home_t,file,execute).
access_vector(allow,staff_crond_t,staff_home_t,file,ioctl).
access_vector(allow,staff_crond_t,staff_home_t,file,execute_no_trans).
access_vector(dontaudit,staff_crond_t,boot_t,dir,search).
access_vector(dontaudit,staff_crond_t,domain,dir,getattr).
access_vector(allow,staff_t,mouse_device_t,chr_file,read).
access_vector(allow,staff_t,mouse_device_t,chr_file,getattr).
access_vector(allow,staff_t,mouse_device_t,chr_file,lock).
access_vector(allow,staff_t,mouse_device_t,chr_file,ioctl).
access_vector(allow,staff_t,misc_device_t,file,ioctl).
access_vector(allow,staff_t,misc_device_t,file,read).
access_vector(allow,staff_t,misc_device_t,file,getattr).
access_vector(allow,staff_t,misc_device_t,file,lock).
access_vector(allow,staff_t,misc_device_t,file,write).
access_vector(allow,staff_t,misc_device_t,file,append).
access_vector(allow,staff_t,misc_device_t,lnk_file,ioctl).
access_vector(allow,staff_t,misc_device_t,lnk_file,read).
access_vector(allow,staff_t,misc_device_t,lnk_file,getattr).
access_vector(allow,staff_t,misc_device_t,lnk_file,lock).
access_vector(allow,staff_t,misc_device_t,lnk_file,write).
access_vector(allow,staff_t,misc_device_t,lnk_file,append).
access_vector(allow,staff_t,misc_device_t,sock_file,ioctl).
access_vector(allow,staff_t,misc_device_t,sock_file,read).
access_vector(allow,staff_t,misc_device_t,sock_file,getattr).
access_vector(allow,staff_t,misc_device_t,sock_file,lock).
access_vector(allow,staff_t,misc_device_t,sock_file,write).
access_vector(allow,staff_t,misc_device_t,sock_file,append).
access_vector(allow,staff_t,misc_device_t,fifo_file,ioctl).
access_vector(allow,staff_t,misc_device_t,fifo_file,read).
access_vector(allow,staff_t,misc_device_t,fifo_file,getattr).
access_vector(allow,staff_t,misc_device_t,fifo_file,lock).
access_vector(allow,staff_t,misc_device_t,fifo_file,write).
access_vector(allow,staff_t,misc_device_t,fifo_file,append).
access_vector(allow,staff_t,misc_device_t,chr_file,ioctl).
access_vector(allow,staff_t,misc_device_t,chr_file,read).
access_vector(allow,staff_t,misc_device_t,chr_file,getattr).
access_vector(allow,staff_t,misc_device_t,chr_file,lock).
access_vector(allow,staff_t,misc_device_t,chr_file,write).
access_vector(allow,staff_t,misc_device_t,chr_file,append).
access_vector(allow,staff_t,misc_device_t,blk_file,ioctl).
access_vector(allow,staff_t,misc_device_t,blk_file,read).
access_vector(allow,staff_t,misc_device_t,blk_file,getattr).
access_vector(allow,staff_t,misc_device_t,blk_file,lock).
access_vector(allow,staff_t,misc_device_t,blk_file,write).
access_vector(allow,staff_t,misc_device_t,blk_file,append).
access_vector(allow,staff_t,self,udp_socket,create).
access_vector(allow,staff_t,self,udp_socket,ioctl).
access_vector(allow,staff_t,self,udp_socket,read).
access_vector(allow,staff_t,self,udp_socket,getattr).
access_vector(allow,staff_t,self,udp_socket,write).
access_vector(allow,staff_t,self,udp_socket,setattr).
access_vector(allow,staff_t,self,udp_socket,append).
access_vector(allow,staff_t,self,udp_socket,bind).
access_vector(allow,staff_t,self,udp_socket,connect).
access_vector(allow,staff_t,self,udp_socket,getopt).
access_vector(allow,staff_t,self,udp_socket,setopt).
access_vector(allow,staff_t,self,udp_socket,shutdown).
access_vector(allow,staff_t,self,tcp_socket,create).
access_vector(allow,staff_t,self,tcp_socket,ioctl).
access_vector(allow,staff_t,self,tcp_socket,read).
access_vector(allow,staff_t,self,tcp_socket,getattr).
access_vector(allow,staff_t,self,tcp_socket,write).
access_vector(allow,staff_t,self,tcp_socket,setattr).
access_vector(allow,staff_t,self,tcp_socket,append).
access_vector(allow,staff_t,self,tcp_socket,bind).
access_vector(allow,staff_t,self,tcp_socket,connect).
access_vector(allow,staff_t,self,tcp_socket,getopt).
access_vector(allow,staff_t,self,tcp_socket,setopt).
access_vector(allow,staff_t,self,tcp_socket,shutdown).
access_vector(allow,staff_t,self,tcp_socket,listen).
access_vector(allow,staff_t,self,tcp_socket,accept).
access_vector(allow,staff_t,any_socket_t,udp_socket,sendto).
access_vector(allow,staff_t,netif_type,netif,tcp_send).
access_vector(allow,staff_t,netif_type,netif,udp_send).
access_vector(allow,staff_t,netif_type,netif,rawip_send).
access_vector(allow,staff_t,netif_type,netif,tcp_recv).
access_vector(allow,staff_t,netif_type,netif,udp_recv).
access_vector(allow,staff_t,netif_type,netif,rawip_recv).
access_vector(allow,staff_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,staff_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,staff_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,staff_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,staff_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,staff_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,staff_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,staff_t,node_type,node,tcp_send).
access_vector(allow,staff_t,node_type,node,udp_send).
access_vector(allow,staff_t,node_type,node,rawip_send).
access_vector(allow,staff_t,node_type,node,tcp_recv).
access_vector(allow,staff_t,node_type,node,udp_recv).
access_vector(allow,staff_t,node_type,node,rawip_recv).
access_vector(allow,staff_t,mount_t,udp_socket,ioctl).
access_vector(allow,staff_t,mount_t,udp_socket,read).
access_vector(allow,staff_t,mount_t,udp_socket,getattr).
access_vector(allow,staff_t,mount_t,udp_socket,write).
access_vector(allow,staff_t,mount_t,udp_socket,setattr).
access_vector(allow,staff_t,mount_t,udp_socket,append).
access_vector(allow,staff_t,mount_t,udp_socket,bind).
access_vector(allow,staff_t,mount_t,udp_socket,connect).
access_vector(allow,staff_t,mount_t,udp_socket,getopt).
access_vector(allow,staff_t,mount_t,udp_socket,setopt).
access_vector(allow,staff_t,mount_t,udp_socket,shutdown).
access_vector(allow,staff_t,port_t,udp_socket,name_bind).
access_vector(allow,staff_t,port_t,tcp_socket,name_bind).
access_vector(allow,staff_t,resolv_conf_t,file,getattr).
access_vector(allow,staff_t,resolv_conf_t,file,read).
access_vector(dontaudit,staff_t,resolv_conf_t,file,ioctl).
access_vector(allow,staff_t,node_lo_t,node,enforce_dest).
access_vector(allow,staff_t,staff_t,udp_socket,sendto).
access_vector(allow,staff_t,staff_t,udp_socket,recvfrom).
access_vector(allow,staff_t,staff_t,tcp_socket,connectto).
access_vector(allow,staff_t,staff_t,tcp_socket,recvfrom).
access_vector(allow,staff_t,staff_t,tcp_socket,acceptfrom).
access_vector(dontaudit,staff_t,kernel_t,system,syslog_read).
access_vector(allow,staff_t,kernel_t,system,ipc_info).
access_vector(dontaudit,staff_t,domain,dir,read).
access_vector(dontaudit,staff_t,domain,dir,getattr).
access_vector(dontaudit,staff_t,domain,dir,lock).
access_vector(dontaudit,staff_t,domain,dir,search).
access_vector(dontaudit,staff_t,domain,dir,ioctl).
access_vector(dontaudit,staff_t,domain,file,read).
access_vector(dontaudit,staff_t,domain,file,getattr).
access_vector(dontaudit,staff_t,domain,file,lock).
access_vector(dontaudit,staff_t,domain,file,ioctl).
access_vector(dontaudit,staff_t,domain,lnk_file,read).
access_vector(dontaudit,staff_t,domain,lnk_file,getattr).
access_vector(dontaudit,staff_t,domain,lnk_file,lock).
access_vector(dontaudit,staff_t,domain,lnk_file,ioctl).
access_vector(dontaudit,staff_t,domain,sock_file,read).
access_vector(dontaudit,staff_t,domain,sock_file,getattr).
access_vector(dontaudit,staff_t,domain,sock_file,lock).
access_vector(dontaudit,staff_t,domain,sock_file,ioctl).
access_vector(dontaudit,staff_t,domain,fifo_file,read).
access_vector(dontaudit,staff_t,domain,fifo_file,getattr).
access_vector(dontaudit,staff_t,domain,fifo_file,lock).
access_vector(dontaudit,staff_t,domain,fifo_file,ioctl).
access_vector(dontaudit,staff_t,initrc_var_run_t,file,getattr).
access_vector(dontaudit,staff_t,initrc_var_run_t,file,read).
access_vector(dontaudit,staff_t,initrc_var_run_t,file,write).
access_vector(dontaudit,staff_t,tmpfile,dir,getattr).
access_vector(dontaudit,staff_t,tmpfile,file,getattr).
access_vector(dontaudit,staff_t,tmpfile,lnk_file,getattr).
access_vector(dontaudit,staff_t,tmpfile,sock_file,getattr).
access_vector(dontaudit,staff_t,tmpfile,fifo_file,getattr).
access_vector(dontaudit,staff_t,tmpfile,chr_file,getattr).
access_vector(dontaudit,staff_t,tmpfile,blk_file,getattr).
access_vector(dontaudit,staff_t,removable_device_t,blk_file,getattr).
access_vector(dontaudit,staff_t,fixed_disk_device_t,blk_file,getattr).
access_vector(allow,staff_t,sound_device_t,chr_file,getattr).
access_vector(allow,staff_t,sound_device_t,chr_file,read).
access_vector(allow,staff_t,sound_device_t,chr_file,write).
access_vector(allow,staff_t,sound_device_t,chr_file,ioctl).
access_vector(allow,staff_t,fs_type,filesystem,getattr).
access_vector(allow,staff_t,devtty_t,chr_file,ioctl).
access_vector(allow,staff_t,devtty_t,chr_file,read).
access_vector(allow,staff_t,devtty_t,chr_file,getattr).
access_vector(allow,staff_t,devtty_t,chr_file,lock).
access_vector(allow,staff_t,devtty_t,chr_file,write).
access_vector(allow,staff_t,devtty_t,chr_file,append).
access_vector(allow,staff_t,zero_device_t,chr_file,ioctl).
access_vector(allow,staff_t,zero_device_t,chr_file,read).
access_vector(allow,staff_t,zero_device_t,chr_file,getattr).
access_vector(allow,staff_t,zero_device_t,chr_file,lock).
access_vector(allow,staff_t,zero_device_t,chr_file,write).
access_vector(allow,staff_t,zero_device_t,chr_file,append).
access_vector(allow,staff_t,zero_device_t,chr_file,execute).
access_vector(allow,staff_t,random_device_t,chr_file,getattr).
access_vector(allow,staff_t,random_device_t,chr_file,read).
access_vector(allow,staff_t,devpts_t,dir,read).
access_vector(allow,staff_t,devpts_t,dir,getattr).
access_vector(allow,staff_t,devpts_t,dir,lock).
access_vector(allow,staff_t,devpts_t,dir,search).
access_vector(allow,staff_t,devpts_t,dir,ioctl).
access_vector(dontaudit,staff_su_t,sysadm_home_t,dir,read).
access_vector(dontaudit,staff_su_t,sysadm_home_t,dir,getattr).
access_vector(dontaudit,staff_su_t,sysadm_home_t,dir,search).
access_vector(dontaudit,staff_su_t,sysadm_home_t,dir,write).
access_vector(dontaudit,staff_su_t,sysadm_home_t,dir,add_name).
access_vector(dontaudit,staff_su_t,sysadm_home_t,dir,remove_name).
access_vector(dontaudit,staff_su_t,sysadm_home_t,file,read).
access_vector(dontaudit,staff_su_t,sysadm_home_t,file,getattr).
access_vector(dontaudit,staff_su_t,sysadm_home_t,file,create).
access_vector(dontaudit,staff_su_t,sysadm_home_t,file,write).
access_vector(dontaudit,staff_su_t,sysadm_home_t,file,link).
access_vector(dontaudit,staff_su_t,sysadm_home_t,file,unlink).
access_vector(dontaudit,staff_t,sysadm_home_t,dir,read).
access_vector(dontaudit,staff_t,sysadm_home_t,dir,search).
access_vector(dontaudit,staff_t,sysadm_home_t,dir,getattr).
access_vector(dontaudit,staff_t,sysadm_home_t,file,read).
access_vector(dontaudit,staff_t,sysadm_home_t,file,getattr).
access_vector(dontaudit,staff_t,sysadm_home_t,file,append).
access_vector(dontaudit,staff_t,devlog_t,sock_file,read).
access_vector(dontaudit,staff_t,devlog_t,sock_file,write).
access_vector(dontaudit,staff_t,syslogd_t,unix_dgram_socket,sendto).
access_vector(dontaudit,staff_t,file_t,dir,getattr).
access_vector(dontaudit,staff_t,file_t,file,getattr).
access_vector(dontaudit,staff_t,file_t,lnk_file,getattr).
access_vector(allow,staff_t,unpriv_userdomain,process,sigchld).
access_vector(allow,staff_t,unpriv_userdomain,process,sigkill).
access_vector(allow,staff_t,unpriv_userdomain,process,sigstop).
access_vector(allow,staff_t,unpriv_userdomain,process,signull).
access_vector(allow,staff_t,unpriv_userdomain,process,signal).
access_vector(allow,staff_t,domain,dir,read).
access_vector(allow,staff_t,domain,dir,getattr).
access_vector(allow,staff_t,domain,dir,lock).
access_vector(allow,staff_t,domain,dir,search).
access_vector(allow,staff_t,domain,dir,ioctl).
access_vector(allow,staff_t,domain,file,read).
access_vector(allow,staff_t,domain,file,getattr).
access_vector(allow,staff_t,domain,file,lock).
access_vector(allow,staff_t,domain,file,ioctl).
access_vector(allow,staff_t,domain,lnk_file,read).
access_vector(allow,staff_t,domain,lnk_file,getattr).
access_vector(allow,staff_t,domain,lnk_file,lock).
access_vector(allow,staff_t,domain,lnk_file,ioctl).
access_vector(allow,staff_t,ttyfile,chr_file,getattr).
access_vector(allow,staff_t,ptyfile,chr_file,getattr).
access_vector(allow,staff_t,tty_device_t,chr_file,getattr).
access_vector(dontaudit,unpriv_userdomain,sysadm_home_dir_t,dir,getattr).
access_vector(dontaudit,unpriv_userdomain,sysadm_home_dir_t,dir,search).
role_decl(system_r,user_t).
role_allow(sysadm_r,user_r).
type_change(user_t,sysadm_devpts_t,chr_file,user_devpts_t).
type_change(user_t,sysadm_tty_device_t,chr_file,user_tty_device_t).
role_allow(staff_r,sysadm_r).
type_change(sysadm_t,staff_devpts_t,chr_file,sysadm_devpts_t).
type_change(sysadm_t,staff_tty_device_t,chr_file,sysadm_tty_device_t).
role_allow(sysadm_r,staff_r).
type_change(staff_t,sysadm_devpts_t,chr_file,staff_devpts_t).
type_change(staff_t,sysadm_tty_device_t,chr_file,staff_tty_device_t).
access_vector(dontaudit,unpriv_userdomain,ptyfile,chr_file,getattr).
type_decl(kernel_t,[],[domain]).
role_decl(system_r,kernel_t).
access_vector(allow,kernel_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,kernel_t,self,dir,read).
access_vector(allow,kernel_t,self,dir,getattr).
access_vector(allow,kernel_t,self,dir,lock).
access_vector(allow,kernel_t,self,dir,search).
access_vector(allow,kernel_t,self,dir,ioctl).
access_vector(allow,kernel_t,self,file,read).
access_vector(allow,kernel_t,self,file,getattr).
access_vector(allow,kernel_t,self,file,lock).
access_vector(allow,kernel_t,self,file,ioctl).
access_vector(allow,kernel_t,self,lnk_file,read).
access_vector(allow,kernel_t,self,lnk_file,getattr).
access_vector(allow,kernel_t,self,lnk_file,lock).
access_vector(allow,kernel_t,self,lnk_file,ioctl).
access_vector(allow,kernel_t,self,sock_file,read).
access_vector(allow,kernel_t,self,sock_file,getattr).
access_vector(allow,kernel_t,self,sock_file,lock).
access_vector(allow,kernel_t,self,sock_file,ioctl).
access_vector(allow,kernel_t,self,fifo_file,read).
access_vector(allow,kernel_t,self,fifo_file,getattr).
access_vector(allow,kernel_t,self,fifo_file,lock).
access_vector(allow,kernel_t,self,fifo_file,ioctl).
access_vector(allow,kernel_t,self,fd,_).
access_vector(allow,kernel_t,self,fifo_file,ioctl).
access_vector(allow,kernel_t,self,fifo_file,read).
access_vector(allow,kernel_t,self,fifo_file,getattr).
access_vector(allow,kernel_t,self,fifo_file,lock).
access_vector(allow,kernel_t,self,fifo_file,write).
access_vector(allow,kernel_t,self,fifo_file,append).
access_vector(allow,kernel_t,self,unix_dgram_socket,create).
access_vector(allow,kernel_t,self,unix_dgram_socket,ioctl).
access_vector(allow,kernel_t,self,unix_dgram_socket,read).
access_vector(allow,kernel_t,self,unix_dgram_socket,getattr).
access_vector(allow,kernel_t,self,unix_dgram_socket,write).
access_vector(allow,kernel_t,self,unix_dgram_socket,setattr).
access_vector(allow,kernel_t,self,unix_dgram_socket,append).
access_vector(allow,kernel_t,self,unix_dgram_socket,bind).
access_vector(allow,kernel_t,self,unix_dgram_socket,connect).
access_vector(allow,kernel_t,self,unix_dgram_socket,getopt).
access_vector(allow,kernel_t,self,unix_dgram_socket,setopt).
access_vector(allow,kernel_t,self,unix_dgram_socket,shutdown).
access_vector(allow,kernel_t,self,unix_stream_socket,create).
access_vector(allow,kernel_t,self,unix_stream_socket,ioctl).
access_vector(allow,kernel_t,self,unix_stream_socket,read).
access_vector(allow,kernel_t,self,unix_stream_socket,getattr).
access_vector(allow,kernel_t,self,unix_stream_socket,write).
access_vector(allow,kernel_t,self,unix_stream_socket,setattr).
access_vector(allow,kernel_t,self,unix_stream_socket,append).
access_vector(allow,kernel_t,self,unix_stream_socket,bind).
access_vector(allow,kernel_t,self,unix_stream_socket,connect).
access_vector(allow,kernel_t,self,unix_stream_socket,getopt).
access_vector(allow,kernel_t,self,unix_stream_socket,setopt).
access_vector(allow,kernel_t,self,unix_stream_socket,shutdown).
access_vector(allow,kernel_t,self,unix_stream_socket,listen).
access_vector(allow,kernel_t,self,unix_stream_socket,accept).
access_vector(allow,kernel_t,self,unix_dgram_socket,sendto).
access_vector(allow,kernel_t,self,unix_stream_socket,connectto).
access_vector(allow,kernel_t,self,sem,associate).
access_vector(allow,kernel_t,self,sem,getattr).
access_vector(allow,kernel_t,self,sem,setattr).
access_vector(allow,kernel_t,self,sem,create).
access_vector(allow,kernel_t,self,sem,destroy).
access_vector(allow,kernel_t,self,sem,read).
access_vector(allow,kernel_t,self,sem,write).
access_vector(allow,kernel_t,self,sem,unix_read).
access_vector(allow,kernel_t,self,sem,unix_write).
access_vector(allow,kernel_t,self,msg,send).
access_vector(allow,kernel_t,self,msg,receive).
access_vector(allow,kernel_t,self,msgq,associate).
access_vector(allow,kernel_t,self,msgq,getattr).
access_vector(allow,kernel_t,self,msgq,setattr).
access_vector(allow,kernel_t,self,msgq,create).
access_vector(allow,kernel_t,self,msgq,destroy).
access_vector(allow,kernel_t,self,msgq,read).
access_vector(allow,kernel_t,self,msgq,write).
access_vector(allow,kernel_t,self,msgq,enqueue).
access_vector(allow,kernel_t,self,msgq,unix_read).
access_vector(allow,kernel_t,self,msgq,unix_write).
access_vector(allow,kernel_t,self,shm,associate).
access_vector(allow,kernel_t,self,shm,getattr).
access_vector(allow,kernel_t,self,shm,setattr).
access_vector(allow,kernel_t,self,shm,create).
access_vector(allow,kernel_t,self,shm,destroy).
access_vector(allow,kernel_t,self,shm,read).
access_vector(allow,kernel_t,self,shm,write).
access_vector(allow,kernel_t,self,shm,lock).
access_vector(allow,kernel_t,self,shm,unix_read).
access_vector(allow,kernel_t,self,shm,unix_write).
access_vector(allow,kernel_t,proc_t,dir,read).
access_vector(allow,kernel_t,proc_t,dir,getattr).
access_vector(allow,kernel_t,proc_t,dir,lock).
access_vector(allow,kernel_t,proc_t,dir,search).
access_vector(allow,kernel_t,proc_t,dir,ioctl).
access_vector(allow,kernel_t,proc_t,file,read).
access_vector(allow,kernel_t,proc_t,file,getattr).
access_vector(allow,kernel_t,proc_t,file,lock).
access_vector(allow,kernel_t,proc_t,file,ioctl).
access_vector(allow,kernel_t,proc_t,lnk_file,read).
access_vector(allow,kernel_t,proc_t,lnk_file,getattr).
access_vector(allow,kernel_t,proc_t,lnk_file,lock).
access_vector(allow,kernel_t,proc_t,lnk_file,ioctl).
access_vector(allow,kernel_t,proc_t,sock_file,read).
access_vector(allow,kernel_t,proc_t,sock_file,getattr).
access_vector(allow,kernel_t,proc_t,sock_file,lock).
access_vector(allow,kernel_t,proc_t,sock_file,ioctl).
access_vector(allow,kernel_t,proc_t,fifo_file,read).
access_vector(allow,kernel_t,proc_t,fifo_file,getattr).
access_vector(allow,kernel_t,proc_t,fifo_file,lock).
access_vector(allow,kernel_t,proc_t,fifo_file,ioctl).
access_vector(allow,kernel_t,proc_kmsg_t,file,getattr).
access_vector(allow,kernel_t,proc_kcore_t,file,getattr).
access_vector(allow,kernel_t,sysctl_modprobe_t,file,read).
access_vector(allow,kernel_t,sysctl_modprobe_t,file,getattr).
access_vector(allow,kernel_t,sysctl_modprobe_t,file,lock).
access_vector(allow,kernel_t,sysctl_modprobe_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_t,file,read).
access_vector(allow,kernel_t,sysctl_t,file,getattr).
access_vector(allow,kernel_t,sysctl_t,file,lock).
access_vector(allow,kernel_t,sysctl_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_t,dir,read).
access_vector(allow,kernel_t,sysctl_t,dir,getattr).
access_vector(allow,kernel_t,sysctl_t,dir,lock).
access_vector(allow,kernel_t,sysctl_t,dir,search).
access_vector(allow,kernel_t,sysctl_t,dir,ioctl).
access_vector(allow,kernel_t,sysctl_fs_t,file,read).
access_vector(allow,kernel_t,sysctl_fs_t,file,getattr).
access_vector(allow,kernel_t,sysctl_fs_t,file,lock).
access_vector(allow,kernel_t,sysctl_fs_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_fs_t,dir,read).
access_vector(allow,kernel_t,sysctl_fs_t,dir,getattr).
access_vector(allow,kernel_t,sysctl_fs_t,dir,lock).
access_vector(allow,kernel_t,sysctl_fs_t,dir,search).
access_vector(allow,kernel_t,sysctl_fs_t,dir,ioctl).
access_vector(allow,kernel_t,sysctl_kernel_t,file,read).
access_vector(allow,kernel_t,sysctl_kernel_t,file,getattr).
access_vector(allow,kernel_t,sysctl_kernel_t,file,lock).
access_vector(allow,kernel_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_kernel_t,dir,read).
access_vector(allow,kernel_t,sysctl_kernel_t,dir,getattr).
access_vector(allow,kernel_t,sysctl_kernel_t,dir,lock).
access_vector(allow,kernel_t,sysctl_kernel_t,dir,search).
access_vector(allow,kernel_t,sysctl_kernel_t,dir,ioctl).
access_vector(allow,kernel_t,sysctl_net_t,file,read).
access_vector(allow,kernel_t,sysctl_net_t,file,getattr).
access_vector(allow,kernel_t,sysctl_net_t,file,lock).
access_vector(allow,kernel_t,sysctl_net_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_net_t,dir,read).
access_vector(allow,kernel_t,sysctl_net_t,dir,getattr).
access_vector(allow,kernel_t,sysctl_net_t,dir,lock).
access_vector(allow,kernel_t,sysctl_net_t,dir,search).
access_vector(allow,kernel_t,sysctl_net_t,dir,ioctl).
access_vector(allow,kernel_t,sysctl_vm_t,file,read).
access_vector(allow,kernel_t,sysctl_vm_t,file,getattr).
access_vector(allow,kernel_t,sysctl_vm_t,file,lock).
access_vector(allow,kernel_t,sysctl_vm_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_vm_t,dir,read).
access_vector(allow,kernel_t,sysctl_vm_t,dir,getattr).
access_vector(allow,kernel_t,sysctl_vm_t,dir,lock).
access_vector(allow,kernel_t,sysctl_vm_t,dir,search).
access_vector(allow,kernel_t,sysctl_vm_t,dir,ioctl).
access_vector(allow,kernel_t,sysctl_dev_t,file,read).
access_vector(allow,kernel_t,sysctl_dev_t,file,getattr).
access_vector(allow,kernel_t,sysctl_dev_t,file,lock).
access_vector(allow,kernel_t,sysctl_dev_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_dev_t,dir,read).
access_vector(allow,kernel_t,sysctl_dev_t,dir,getattr).
access_vector(allow,kernel_t,sysctl_dev_t,dir,lock).
access_vector(allow,kernel_t,sysctl_dev_t,dir,search).
access_vector(allow,kernel_t,sysctl_dev_t,dir,ioctl).
access_vector(allow,kernel_t,root_t,dir,read).
access_vector(allow,kernel_t,root_t,dir,getattr).
access_vector(allow,kernel_t,root_t,dir,lock).
access_vector(allow,kernel_t,root_t,dir,search).
access_vector(allow,kernel_t,root_t,dir,ioctl).
access_vector(allow,kernel_t,root_t,file,read).
access_vector(allow,kernel_t,root_t,file,getattr).
access_vector(allow,kernel_t,root_t,file,lock).
access_vector(allow,kernel_t,root_t,file,ioctl).
access_vector(allow,kernel_t,root_t,lnk_file,read).
access_vector(allow,kernel_t,root_t,lnk_file,getattr).
access_vector(allow,kernel_t,root_t,lnk_file,lock).
access_vector(allow,kernel_t,root_t,lnk_file,ioctl).
access_vector(allow,kernel_t,root_t,sock_file,read).
access_vector(allow,kernel_t,root_t,sock_file,getattr).
access_vector(allow,kernel_t,root_t,sock_file,lock).
access_vector(allow,kernel_t,root_t,sock_file,ioctl).
access_vector(allow,kernel_t,root_t,fifo_file,read).
access_vector(allow,kernel_t,root_t,fifo_file,getattr).
access_vector(allow,kernel_t,root_t,fifo_file,lock).
access_vector(allow,kernel_t,root_t,fifo_file,ioctl).
access_vector(allow,kernel_t,home_root_t,dir,read).
access_vector(allow,kernel_t,home_root_t,dir,getattr).
access_vector(allow,kernel_t,home_root_t,dir,lock).
access_vector(allow,kernel_t,home_root_t,dir,search).
access_vector(allow,kernel_t,home_root_t,dir,ioctl).
access_vector(allow,kernel_t,usr_t,dir,read).
access_vector(allow,kernel_t,usr_t,dir,getattr).
access_vector(allow,kernel_t,usr_t,dir,lock).
access_vector(allow,kernel_t,usr_t,dir,search).
access_vector(allow,kernel_t,usr_t,dir,ioctl).
access_vector(allow,kernel_t,usr_t,file,read).
access_vector(allow,kernel_t,usr_t,file,getattr).
access_vector(allow,kernel_t,usr_t,file,lock).
access_vector(allow,kernel_t,usr_t,file,ioctl).
access_vector(allow,kernel_t,usr_t,lnk_file,read).
access_vector(allow,kernel_t,usr_t,lnk_file,getattr).
access_vector(allow,kernel_t,usr_t,lnk_file,lock).
access_vector(allow,kernel_t,usr_t,lnk_file,ioctl).
access_vector(allow,kernel_t,usr_t,sock_file,read).
access_vector(allow,kernel_t,usr_t,sock_file,getattr).
access_vector(allow,kernel_t,usr_t,sock_file,lock).
access_vector(allow,kernel_t,usr_t,sock_file,ioctl).
access_vector(allow,kernel_t,usr_t,fifo_file,read).
access_vector(allow,kernel_t,usr_t,fifo_file,getattr).
access_vector(allow,kernel_t,usr_t,fifo_file,lock).
access_vector(allow,kernel_t,usr_t,fifo_file,ioctl).
access_vector(allow,kernel_t,bin_t,dir,read).
access_vector(allow,kernel_t,bin_t,dir,getattr).
access_vector(allow,kernel_t,bin_t,dir,lock).
access_vector(allow,kernel_t,bin_t,dir,search).
access_vector(allow,kernel_t,bin_t,dir,ioctl).
access_vector(allow,kernel_t,bin_t,file,read).
access_vector(allow,kernel_t,bin_t,file,getattr).
access_vector(allow,kernel_t,bin_t,file,lock).
access_vector(allow,kernel_t,bin_t,file,ioctl).
access_vector(allow,kernel_t,bin_t,lnk_file,read).
access_vector(allow,kernel_t,bin_t,lnk_file,getattr).
access_vector(allow,kernel_t,bin_t,lnk_file,lock).
access_vector(allow,kernel_t,bin_t,lnk_file,ioctl).
access_vector(allow,kernel_t,bin_t,sock_file,read).
access_vector(allow,kernel_t,bin_t,sock_file,getattr).
access_vector(allow,kernel_t,bin_t,sock_file,lock).
access_vector(allow,kernel_t,bin_t,sock_file,ioctl).
access_vector(allow,kernel_t,bin_t,fifo_file,read).
access_vector(allow,kernel_t,bin_t,fifo_file,getattr).
access_vector(allow,kernel_t,bin_t,fifo_file,lock).
access_vector(allow,kernel_t,bin_t,fifo_file,ioctl).
access_vector(allow,kernel_t,sbin_t,dir,read).
access_vector(allow,kernel_t,sbin_t,dir,getattr).
access_vector(allow,kernel_t,sbin_t,dir,lock).
access_vector(allow,kernel_t,sbin_t,dir,search).
access_vector(allow,kernel_t,sbin_t,dir,ioctl).
access_vector(allow,kernel_t,sbin_t,file,read).
access_vector(allow,kernel_t,sbin_t,file,getattr).
access_vector(allow,kernel_t,sbin_t,file,lock).
access_vector(allow,kernel_t,sbin_t,file,ioctl).
access_vector(allow,kernel_t,sbin_t,lnk_file,read).
access_vector(allow,kernel_t,sbin_t,lnk_file,getattr).
access_vector(allow,kernel_t,sbin_t,lnk_file,lock).
access_vector(allow,kernel_t,sbin_t,lnk_file,ioctl).
access_vector(allow,kernel_t,sbin_t,sock_file,read).
access_vector(allow,kernel_t,sbin_t,sock_file,getattr).
access_vector(allow,kernel_t,sbin_t,sock_file,lock).
access_vector(allow,kernel_t,sbin_t,sock_file,ioctl).
access_vector(allow,kernel_t,sbin_t,fifo_file,read).
access_vector(allow,kernel_t,sbin_t,fifo_file,getattr).
access_vector(allow,kernel_t,sbin_t,fifo_file,lock).
access_vector(allow,kernel_t,sbin_t,fifo_file,ioctl).
access_vector(allow,kernel_t,lib_t,dir,read).
access_vector(allow,kernel_t,lib_t,dir,getattr).
access_vector(allow,kernel_t,lib_t,dir,lock).
access_vector(allow,kernel_t,lib_t,dir,search).
access_vector(allow,kernel_t,lib_t,dir,ioctl).
access_vector(allow,kernel_t,etc_t,dir,read).
access_vector(allow,kernel_t,etc_t,dir,getattr).
access_vector(allow,kernel_t,etc_t,dir,lock).
access_vector(allow,kernel_t,etc_t,dir,search).
access_vector(allow,kernel_t,etc_t,dir,ioctl).
access_vector(allow,kernel_t,lib_t,lnk_file,read).
access_vector(allow,kernel_t,lib_t,lnk_file,getattr).
access_vector(allow,kernel_t,lib_t,lnk_file,lock).
access_vector(allow,kernel_t,lib_t,lnk_file,ioctl).
access_vector(allow,kernel_t,ld_so_t,file,read).
access_vector(allow,kernel_t,ld_so_t,file,getattr).
access_vector(allow,kernel_t,ld_so_t,file,lock).
access_vector(allow,kernel_t,ld_so_t,file,execute).
access_vector(allow,kernel_t,ld_so_t,file,ioctl).
access_vector(allow,kernel_t,ld_so_t,file,execute_no_trans).
access_vector(allow,kernel_t,ld_so_t,lnk_file,read).
access_vector(allow,kernel_t,ld_so_t,lnk_file,getattr).
access_vector(allow,kernel_t,ld_so_t,lnk_file,lock).
access_vector(allow,kernel_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,kernel_t,shlib_t,file,read).
access_vector(allow,kernel_t,shlib_t,file,getattr).
access_vector(allow,kernel_t,shlib_t,file,lock).
access_vector(allow,kernel_t,shlib_t,file,execute).
access_vector(allow,kernel_t,shlib_t,file,ioctl).
access_vector(allow,kernel_t,shlib_t,lnk_file,read).
access_vector(allow,kernel_t,shlib_t,lnk_file,getattr).
access_vector(allow,kernel_t,shlib_t,lnk_file,lock).
access_vector(allow,kernel_t,shlib_t,lnk_file,ioctl).
access_vector(allow,kernel_t,ld_so_cache_t,file,read).
access_vector(allow,kernel_t,ld_so_cache_t,file,getattr).
access_vector(allow,kernel_t,ld_so_cache_t,file,lock).
access_vector(allow,kernel_t,ld_so_cache_t,file,ioctl).
access_vector(allow,kernel_t,device_t,dir,search).
access_vector(allow,kernel_t,null_device_t,chr_file,ioctl).
access_vector(allow,kernel_t,null_device_t,chr_file,read).
access_vector(allow,kernel_t,null_device_t,chr_file,getattr).
access_vector(allow,kernel_t,null_device_t,chr_file,lock).
access_vector(allow,kernel_t,null_device_t,chr_file,write).
access_vector(allow,kernel_t,null_device_t,chr_file,append).
access_vector(allow,kernel_t,self,capability,_).
access_vector(allow,kernel_t,init_t,process,transition).
access_vector(dontaudit,kernel_t,init_t,process,noatsecure).
access_vector(allow,kernel_t,init_exec_t,file,read).
access_vector(allow,kernel_t,init_exec_t,file,getattr).
access_vector(allow,kernel_t,init_exec_t,file,execute).
access_vector(allow,init_t,kernel_t,process,sigchld).
access_vector(allow,init_t,kernel_t,fd,use).
access_vector(allow,kernel_t,init_t,fd,use).
access_vector(allow,init_t,kernel_t,fifo_file,ioctl).
access_vector(allow,init_t,kernel_t,fifo_file,read).
access_vector(allow,init_t,kernel_t,fifo_file,getattr).
access_vector(allow,init_t,kernel_t,fifo_file,lock).
access_vector(allow,init_t,kernel_t,fifo_file,write).
access_vector(allow,init_t,kernel_t,fifo_file,append).
access_vector(allow,init_t,init_exec_t,file,read).
access_vector(allow,init_t,init_exec_t,file,getattr).
access_vector(allow,init_t,init_exec_t,file,lock).
access_vector(allow,init_t,init_exec_t,file,execute).
access_vector(allow,init_t,init_exec_t,file,ioctl).
access_vector(allow,init_t,init_exec_t,file,entrypoint).
type_trans(kernel_t,init_exec_t,process,init_t).
access_vector(allow,kernel_t,init_t,process,share).
access_vector(allow,kernel_t,fs_type,filesystem,mount).
access_vector(allow,kernel_t,fs_type,filesystem,remount).
access_vector(allow,kernel_t,fs_type,filesystem,unmount).
access_vector(allow,kernel_t,fs_type,filesystem,getattr).
access_vector(allow,kernel_t,file_labels_t,dir,search).
access_vector(allow,kernel_t,domain,process,signal).
access_vector(allow,kernel_t,device_t,dir,search).
access_vector(allow,kernel_t,console_device_t,chr_file,ioctl).
access_vector(allow,kernel_t,console_device_t,chr_file,read).
access_vector(allow,kernel_t,console_device_t,chr_file,getattr).
access_vector(allow,kernel_t,console_device_t,chr_file,lock).
access_vector(allow,kernel_t,console_device_t,chr_file,write).
access_vector(allow,kernel_t,console_device_t,chr_file,append).
access_vector(allow,kernel_t,file_t,chr_file,ioctl).
access_vector(allow,kernel_t,file_t,chr_file,read).
access_vector(allow,kernel_t,file_t,chr_file,getattr).
access_vector(allow,kernel_t,file_t,chr_file,lock).
access_vector(allow,kernel_t,file_t,chr_file,write).
access_vector(allow,kernel_t,file_t,chr_file,append).
access_vector(allow,kernel_t,file_t,file,read).
access_vector(allow,kernel_t,file_t,file,getattr).
access_vector(allow,kernel_t,file_t,file,lock).
access_vector(allow,kernel_t,file_t,file,execute).
access_vector(allow,kernel_t,file_t,file,ioctl).
access_vector(allow,kernel_t,file_t,file,execute_no_trans).
access_vector(allow,kernel_t,self,capability,sys_chroot).
access_vector(allow,kernel_t,unlabeled_t,dir,mounton).
access_vector(allow,kernel_t,root_t,dir,mounton).
access_vector(allow,kernel_t,file_t,dir,mounton).
access_vector(allow,kernel_t,file_t,dir,read).
access_vector(allow,kernel_t,file_t,dir,getattr).
access_vector(allow,kernel_t,file_t,dir,lock).
access_vector(allow,kernel_t,file_t,dir,search).
access_vector(allow,kernel_t,file_t,dir,ioctl).
access_vector(allow,kernel_t,file_t,dir,add_name).
access_vector(allow,kernel_t,file_t,dir,remove_name).
access_vector(allow,kernel_t,file_t,dir,write).
access_vector(allow,kernel_t,file_t,blk_file,create).
access_vector(allow,kernel_t,file_t,blk_file,ioctl).
access_vector(allow,kernel_t,file_t,blk_file,read).
access_vector(allow,kernel_t,file_t,blk_file,getattr).
access_vector(allow,kernel_t,file_t,blk_file,lock).
access_vector(allow,kernel_t,file_t,blk_file,write).
access_vector(allow,kernel_t,file_t,blk_file,setattr).
access_vector(allow,kernel_t,file_t,blk_file,append).
access_vector(allow,kernel_t,file_t,blk_file,link).
access_vector(allow,kernel_t,file_t,blk_file,unlink).
access_vector(allow,kernel_t,file_t,blk_file,rename).
access_vector(allow,kernel_t,sysctl_t,file,setattr).
access_vector(allow,kernel_t,sysctl_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_t,file,read).
access_vector(allow,kernel_t,sysctl_t,file,getattr).
access_vector(allow,kernel_t,sysctl_t,file,lock).
access_vector(allow,kernel_t,sysctl_t,file,write).
access_vector(allow,kernel_t,sysctl_t,file,append).
access_vector(allow,kernel_t,sysctl_kernel_t,file,setattr).
access_vector(allow,kernel_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,kernel_t,sysctl_kernel_t,file,read).
access_vector(allow,kernel_t,sysctl_kernel_t,file,getattr).
access_vector(allow,kernel_t,sysctl_kernel_t,file,lock).
access_vector(allow,kernel_t,sysctl_kernel_t,file,write).
access_vector(allow,kernel_t,sysctl_kernel_t,file,append).
access_vector(allow,kernel_t,policy_config_t,dir,read).
access_vector(allow,kernel_t,policy_config_t,dir,getattr).
access_vector(allow,kernel_t,policy_config_t,dir,lock).
access_vector(allow,kernel_t,policy_config_t,dir,search).
access_vector(allow,kernel_t,policy_config_t,dir,ioctl).
access_vector(allow,kernel_t,security_t,dir,read).
access_vector(allow,kernel_t,security_t,dir,search).
access_vector(allow,kernel_t,security_t,dir,getattr).
access_vector(allow,kernel_t,security_t,file,getattr).
access_vector(allow,kernel_t,security_t,file,read).
access_vector(allow,kernel_t,security_t,file,write).
access_vector(allow,kernel_t,security_t,security,load_policy).
access_vector(auditallow,kernel_t,security_t,security,load_policy).
access_vector(allow,kernel_t,insmod_t,process,transition).
access_vector(dontaudit,kernel_t,insmod_t,process,noatsecure).
access_vector(allow,kernel_t,insmod_exec_t,file,read).
access_vector(allow,kernel_t,insmod_exec_t,file,getattr).
access_vector(allow,kernel_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,kernel_t,process,sigchld).
access_vector(allow,insmod_t,kernel_t,fd,use).
access_vector(allow,kernel_t,insmod_t,fd,use).
access_vector(allow,insmod_t,kernel_t,fifo_file,ioctl).
access_vector(allow,insmod_t,kernel_t,fifo_file,read).
access_vector(allow,insmod_t,kernel_t,fifo_file,getattr).
access_vector(allow,insmod_t,kernel_t,fifo_file,lock).
access_vector(allow,insmod_t,kernel_t,fifo_file,write).
access_vector(allow,insmod_t,kernel_t,fifo_file,append).
access_vector(allow,insmod_t,insmod_exec_t,file,read).
access_vector(allow,insmod_t,insmod_exec_t,file,getattr).
access_vector(allow,insmod_t,insmod_exec_t,file,lock).
access_vector(allow,insmod_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,insmod_exec_t,file,ioctl).
access_vector(allow,insmod_t,insmod_exec_t,file,entrypoint).
type_trans(kernel_t,insmod_exec_t,process,insmod_t).
access_vector(allow,kernel_t,insmod_exec_t,lnk_file,read).
access_vector(allow,kernel_t,bin_t,file,read).
access_vector(allow,kernel_t,bin_t,file,getattr).
access_vector(allow,kernel_t,bin_t,file,lock).
access_vector(allow,kernel_t,bin_t,file,execute).
access_vector(allow,kernel_t,bin_t,file,ioctl).
access_vector(allow,kernel_t,bin_t,file,execute_no_trans).
type_decl(checkpolicy_t,[],[domain]).
role_decl(sysadm_r,checkpolicy_t).
type_decl(checkpolicy_exec_t,[],[file_type,exec_type,sysadmfile]).
access_vector(allow,sysadm_t,checkpolicy_t,process,transition).
access_vector(dontaudit,sysadm_t,checkpolicy_t,process,noatsecure).
access_vector(allow,sysadm_t,checkpolicy_exec_t,file,read).
access_vector(allow,sysadm_t,checkpolicy_exec_t,file,getattr).
access_vector(allow,sysadm_t,checkpolicy_exec_t,file,execute).
access_vector(allow,checkpolicy_t,sysadm_t,process,sigchld).
access_vector(allow,checkpolicy_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,checkpolicy_t,fd,use).
access_vector(allow,checkpolicy_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,checkpolicy_t,sysadm_t,fifo_file,read).
access_vector(allow,checkpolicy_t,sysadm_t,fifo_file,getattr).
access_vector(allow,checkpolicy_t,sysadm_t,fifo_file,lock).
access_vector(allow,checkpolicy_t,sysadm_t,fifo_file,write).
access_vector(allow,checkpolicy_t,sysadm_t,fifo_file,append).
access_vector(allow,checkpolicy_t,checkpolicy_exec_t,file,read).
access_vector(allow,checkpolicy_t,checkpolicy_exec_t,file,getattr).
access_vector(allow,checkpolicy_t,checkpolicy_exec_t,file,lock).
access_vector(allow,checkpolicy_t,checkpolicy_exec_t,file,execute).
access_vector(allow,checkpolicy_t,checkpolicy_exec_t,file,ioctl).
access_vector(allow,checkpolicy_t,checkpolicy_exec_t,file,entrypoint).
type_trans(sysadm_t,checkpolicy_exec_t,process,checkpolicy_t).
access_vector(allow,checkpolicy_t,policy_config_t,dir,read).
access_vector(allow,checkpolicy_t,policy_config_t,dir,getattr).
access_vector(allow,checkpolicy_t,policy_config_t,dir,lock).
access_vector(allow,checkpolicy_t,policy_config_t,dir,search).
access_vector(allow,checkpolicy_t,policy_config_t,dir,ioctl).
access_vector(allow,checkpolicy_t,policy_config_t,dir,add_name).
access_vector(allow,checkpolicy_t,policy_config_t,dir,remove_name).
access_vector(allow,checkpolicy_t,policy_config_t,dir,write).
access_vector(allow,checkpolicy_t,policy_config_t,file,create).
access_vector(allow,checkpolicy_t,policy_config_t,file,ioctl).
access_vector(allow,checkpolicy_t,policy_config_t,file,read).
access_vector(allow,checkpolicy_t,policy_config_t,file,getattr).
access_vector(allow,checkpolicy_t,policy_config_t,file,lock).
access_vector(allow,checkpolicy_t,policy_config_t,file,write).
access_vector(allow,checkpolicy_t,policy_config_t,file,setattr).
access_vector(allow,checkpolicy_t,policy_config_t,file,append).
access_vector(allow,checkpolicy_t,policy_config_t,file,link).
access_vector(allow,checkpolicy_t,policy_config_t,file,unlink).
access_vector(allow,checkpolicy_t,policy_config_t,file,rename).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,create).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,ioctl).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,read).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,getattr).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,lock).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,write).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,setattr).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,append).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,link).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,unlink).
access_vector(allow,checkpolicy_t,policy_config_t,lnk_file,rename).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,create).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,ioctl).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,read).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,getattr).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,lock).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,write).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,setattr).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,append).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,link).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,unlink).
access_vector(allow,checkpolicy_t,policy_config_t,sock_file,rename).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,create).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,ioctl).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,read).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,getattr).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,lock).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,write).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,setattr).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,append).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,link).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,unlink).
access_vector(allow,checkpolicy_t,policy_config_t,fifo_file,rename).
access_vector(allow,checkpolicy_t,policy_src_t,dir,read).
access_vector(allow,checkpolicy_t,policy_src_t,dir,getattr).
access_vector(allow,checkpolicy_t,policy_src_t,dir,lock).
access_vector(allow,checkpolicy_t,policy_src_t,dir,search).
access_vector(allow,checkpolicy_t,policy_src_t,dir,ioctl).
access_vector(allow,checkpolicy_t,policy_src_t,file,read).
access_vector(allow,checkpolicy_t,policy_src_t,file,getattr).
access_vector(allow,checkpolicy_t,policy_src_t,file,lock).
access_vector(allow,checkpolicy_t,policy_src_t,file,ioctl).
access_vector(allow,checkpolicy_t,policy_src_t,lnk_file,read).
access_vector(allow,checkpolicy_t,policy_src_t,lnk_file,getattr).
access_vector(allow,checkpolicy_t,policy_src_t,lnk_file,lock).
access_vector(allow,checkpolicy_t,policy_src_t,lnk_file,ioctl).
access_vector(allow,checkpolicy_t,policy_src_t,sock_file,read).
access_vector(allow,checkpolicy_t,policy_src_t,sock_file,getattr).
access_vector(allow,checkpolicy_t,policy_src_t,sock_file,lock).
access_vector(allow,checkpolicy_t,policy_src_t,sock_file,ioctl).
access_vector(allow,checkpolicy_t,policy_src_t,fifo_file,read).
access_vector(allow,checkpolicy_t,policy_src_t,fifo_file,getattr).
access_vector(allow,checkpolicy_t,policy_src_t,fifo_file,lock).
access_vector(allow,checkpolicy_t,policy_src_t,fifo_file,ioctl).
access_vector(allow,checkpolicy_t,policy_src_t,dir,read).
access_vector(allow,checkpolicy_t,policy_src_t,dir,getattr).
access_vector(allow,checkpolicy_t,policy_src_t,dir,lock).
access_vector(allow,checkpolicy_t,policy_src_t,dir,search).
access_vector(allow,checkpolicy_t,policy_src_t,dir,ioctl).
access_vector(allow,checkpolicy_t,policy_src_t,dir,add_name).
access_vector(allow,checkpolicy_t,policy_src_t,dir,remove_name).
access_vector(allow,checkpolicy_t,policy_src_t,dir,write).
access_vector(allow,checkpolicy_t,policy_config_t,dir,create).
access_vector(allow,checkpolicy_t,policy_config_t,dir,read).
access_vector(allow,checkpolicy_t,policy_config_t,dir,getattr).
access_vector(allow,checkpolicy_t,policy_config_t,dir,lock).
access_vector(allow,checkpolicy_t,policy_config_t,dir,setattr).
access_vector(allow,checkpolicy_t,policy_config_t,dir,link).
access_vector(allow,checkpolicy_t,policy_config_t,dir,unlink).
access_vector(allow,checkpolicy_t,policy_config_t,dir,rename).
access_vector(allow,checkpolicy_t,policy_config_t,dir,search).
access_vector(allow,checkpolicy_t,policy_config_t,dir,add_name).
access_vector(allow,checkpolicy_t,policy_config_t,dir,remove_name).
access_vector(allow,checkpolicy_t,policy_config_t,dir,reparent).
access_vector(allow,checkpolicy_t,policy_config_t,dir,write).
access_vector(allow,checkpolicy_t,policy_config_t,dir,rmdir).
type_trans(checkpolicy_t,policy_src_t,dir,policy_config_t).
type_trans(checkpolicy_t,policy_src_t,[file,lnk_file,sock_file,fifo_file],policy_config_t).
access_vector(allow,checkpolicy_t,root_t,dir,search).
access_vector(allow,checkpolicy_t,etc_t,dir,search).
access_vector(allow,checkpolicy_t,devpts_t,dir,read).
access_vector(allow,checkpolicy_t,devpts_t,dir,getattr).
access_vector(allow,checkpolicy_t,devpts_t,dir,lock).
access_vector(allow,checkpolicy_t,devpts_t,dir,search).
access_vector(allow,checkpolicy_t,devpts_t,dir,ioctl).
access_vector(allow,checkpolicy_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,checkpolicy_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,checkpolicy_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,checkpolicy_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,checkpolicy_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,checkpolicy_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,checkpolicy_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,checkpolicy_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,checkpolicy_t,root_t,dir,read).
access_vector(allow,checkpolicy_t,root_t,dir,getattr).
access_vector(allow,checkpolicy_t,root_t,dir,lock).
access_vector(allow,checkpolicy_t,root_t,dir,search).
access_vector(allow,checkpolicy_t,root_t,dir,ioctl).
access_vector(allow,checkpolicy_t,usr_t,dir,read).
access_vector(allow,checkpolicy_t,usr_t,dir,getattr).
access_vector(allow,checkpolicy_t,usr_t,dir,lock).
access_vector(allow,checkpolicy_t,usr_t,dir,search).
access_vector(allow,checkpolicy_t,usr_t,dir,ioctl).
access_vector(allow,checkpolicy_t,lib_t,dir,read).
access_vector(allow,checkpolicy_t,lib_t,dir,getattr).
access_vector(allow,checkpolicy_t,lib_t,dir,lock).
access_vector(allow,checkpolicy_t,lib_t,dir,search).
access_vector(allow,checkpolicy_t,lib_t,dir,ioctl).
access_vector(allow,checkpolicy_t,etc_t,dir,read).
access_vector(allow,checkpolicy_t,etc_t,dir,getattr).
access_vector(allow,checkpolicy_t,etc_t,dir,lock).
access_vector(allow,checkpolicy_t,etc_t,dir,search).
access_vector(allow,checkpolicy_t,etc_t,dir,ioctl).
access_vector(allow,checkpolicy_t,lib_t,lnk_file,read).
access_vector(allow,checkpolicy_t,lib_t,lnk_file,getattr).
access_vector(allow,checkpolicy_t,lib_t,lnk_file,lock).
access_vector(allow,checkpolicy_t,lib_t,lnk_file,ioctl).
access_vector(allow,checkpolicy_t,ld_so_t,file,read).
access_vector(allow,checkpolicy_t,ld_so_t,file,getattr).
access_vector(allow,checkpolicy_t,ld_so_t,file,lock).
access_vector(allow,checkpolicy_t,ld_so_t,file,execute).
access_vector(allow,checkpolicy_t,ld_so_t,file,ioctl).
access_vector(allow,checkpolicy_t,ld_so_t,file,execute_no_trans).
access_vector(allow,checkpolicy_t,ld_so_t,lnk_file,read).
access_vector(allow,checkpolicy_t,ld_so_t,lnk_file,getattr).
access_vector(allow,checkpolicy_t,ld_so_t,lnk_file,lock).
access_vector(allow,checkpolicy_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,checkpolicy_t,shlib_t,file,read).
access_vector(allow,checkpolicy_t,shlib_t,file,getattr).
access_vector(allow,checkpolicy_t,shlib_t,file,lock).
access_vector(allow,checkpolicy_t,shlib_t,file,execute).
access_vector(allow,checkpolicy_t,shlib_t,file,ioctl).
access_vector(allow,checkpolicy_t,shlib_t,lnk_file,read).
access_vector(allow,checkpolicy_t,shlib_t,lnk_file,getattr).
access_vector(allow,checkpolicy_t,shlib_t,lnk_file,lock).
access_vector(allow,checkpolicy_t,shlib_t,lnk_file,ioctl).
access_vector(allow,checkpolicy_t,ld_so_cache_t,file,read).
access_vector(allow,checkpolicy_t,ld_so_cache_t,file,getattr).
access_vector(allow,checkpolicy_t,ld_so_cache_t,file,lock).
access_vector(allow,checkpolicy_t,ld_so_cache_t,file,ioctl).
access_vector(allow,checkpolicy_t,device_t,dir,search).
access_vector(allow,checkpolicy_t,null_device_t,chr_file,ioctl).
access_vector(allow,checkpolicy_t,null_device_t,chr_file,read).
access_vector(allow,checkpolicy_t,null_device_t,chr_file,getattr).
access_vector(allow,checkpolicy_t,null_device_t,chr_file,lock).
access_vector(allow,checkpolicy_t,null_device_t,chr_file,write).
access_vector(allow,checkpolicy_t,null_device_t,chr_file,append).
access_vector(allow,checkpolicy_t,self,capability,dac_override).
access_vector(allow,checkpolicy_t,sysadm_tmp_t,file,getattr).
access_vector(allow,checkpolicy_t,sysadm_tmp_t,file,write).
access_vector(allow,user_t,checkpolicy_exec_t,file,read).
access_vector(allow,user_t,checkpolicy_exec_t,file,getattr).
access_vector(allow,user_t,checkpolicy_exec_t,file,lock).
access_vector(allow,user_t,checkpolicy_exec_t,file,execute).
access_vector(allow,user_t,checkpolicy_exec_t,file,ioctl).
access_vector(allow,user_t,checkpolicy_exec_t,file,execute_no_trans).
access_vector(allow,checkpolicy_t,privfd,fd,use).
type_decl(chkpwd_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(crond_t,[],[domain,privlog,privrole,privmail,auth,privfd]).
type_decl(crond_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(system_r,crond_t).
access_vector(allow,initrc_t,crond_t,process,transition).
access_vector(dontaudit,initrc_t,crond_t,process,noatsecure).
access_vector(allow,initrc_t,crond_exec_t,file,read).
access_vector(allow,initrc_t,crond_exec_t,file,getattr).
access_vector(allow,initrc_t,crond_exec_t,file,execute).
access_vector(allow,crond_t,initrc_t,process,sigchld).
access_vector(allow,crond_t,initrc_t,fd,use).
access_vector(allow,initrc_t,crond_t,fd,use).
access_vector(allow,crond_t,initrc_t,fifo_file,ioctl).
access_vector(allow,crond_t,initrc_t,fifo_file,read).
access_vector(allow,crond_t,initrc_t,fifo_file,getattr).
access_vector(allow,crond_t,initrc_t,fifo_file,lock).
access_vector(allow,crond_t,initrc_t,fifo_file,write).
access_vector(allow,crond_t,initrc_t,fifo_file,append).
access_vector(allow,crond_t,crond_exec_t,file,read).
access_vector(allow,crond_t,crond_exec_t,file,getattr).
access_vector(allow,crond_t,crond_exec_t,file,lock).
access_vector(allow,crond_t,crond_exec_t,file,execute).
access_vector(allow,crond_t,crond_exec_t,file,ioctl).
access_vector(allow,crond_t,crond_exec_t,file,entrypoint).
type_trans(initrc_t,crond_exec_t,process,crond_t).
access_vector(allow,crond_t,init_t,fd,use).
access_vector(allow,crond_t,init_t,process,sigchld).
access_vector(allow,crond_t,privfd,fd,use).
access_vector(allow,crond_t,newrole_t,process,sigchld).
access_vector(allow,crond_t,self,process,sigchld).
access_vector(allow,crond_t,self,process,sigkill).
access_vector(allow,crond_t,self,process,sigstop).
access_vector(allow,crond_t,self,process,signull).
access_vector(allow,crond_t,self,process,signal).
access_vector(allow,crond_t,self,process,fork).
access_vector(allow,crond_t,root_t,dir,read).
access_vector(allow,crond_t,root_t,dir,getattr).
access_vector(allow,crond_t,root_t,dir,lock).
access_vector(allow,crond_t,root_t,dir,search).
access_vector(allow,crond_t,root_t,dir,ioctl).
access_vector(allow,crond_t,usr_t,dir,read).
access_vector(allow,crond_t,usr_t,dir,getattr).
access_vector(allow,crond_t,usr_t,dir,lock).
access_vector(allow,crond_t,usr_t,dir,search).
access_vector(allow,crond_t,usr_t,dir,ioctl).
access_vector(allow,crond_t,lib_t,dir,read).
access_vector(allow,crond_t,lib_t,dir,getattr).
access_vector(allow,crond_t,lib_t,dir,lock).
access_vector(allow,crond_t,lib_t,dir,search).
access_vector(allow,crond_t,lib_t,dir,ioctl).
access_vector(allow,crond_t,etc_t,dir,read).
access_vector(allow,crond_t,etc_t,dir,getattr).
access_vector(allow,crond_t,etc_t,dir,lock).
access_vector(allow,crond_t,etc_t,dir,search).
access_vector(allow,crond_t,etc_t,dir,ioctl).
access_vector(allow,crond_t,lib_t,lnk_file,read).
access_vector(allow,crond_t,lib_t,lnk_file,getattr).
access_vector(allow,crond_t,lib_t,lnk_file,lock).
access_vector(allow,crond_t,lib_t,lnk_file,ioctl).
access_vector(allow,crond_t,ld_so_t,file,read).
access_vector(allow,crond_t,ld_so_t,file,getattr).
access_vector(allow,crond_t,ld_so_t,file,lock).
access_vector(allow,crond_t,ld_so_t,file,execute).
access_vector(allow,crond_t,ld_so_t,file,ioctl).
access_vector(allow,crond_t,ld_so_t,file,execute_no_trans).
access_vector(allow,crond_t,ld_so_t,lnk_file,read).
access_vector(allow,crond_t,ld_so_t,lnk_file,getattr).
access_vector(allow,crond_t,ld_so_t,lnk_file,lock).
access_vector(allow,crond_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,crond_t,shlib_t,file,read).
access_vector(allow,crond_t,shlib_t,file,getattr).
access_vector(allow,crond_t,shlib_t,file,lock).
access_vector(allow,crond_t,shlib_t,file,execute).
access_vector(allow,crond_t,shlib_t,file,ioctl).
access_vector(allow,crond_t,shlib_t,lnk_file,read).
access_vector(allow,crond_t,shlib_t,lnk_file,getattr).
access_vector(allow,crond_t,shlib_t,lnk_file,lock).
access_vector(allow,crond_t,shlib_t,lnk_file,ioctl).
access_vector(allow,crond_t,ld_so_cache_t,file,read).
access_vector(allow,crond_t,ld_so_cache_t,file,getattr).
access_vector(allow,crond_t,ld_so_cache_t,file,lock).
access_vector(allow,crond_t,ld_so_cache_t,file,ioctl).
access_vector(allow,crond_t,device_t,dir,search).
access_vector(allow,crond_t,null_device_t,chr_file,ioctl).
access_vector(allow,crond_t,null_device_t,chr_file,read).
access_vector(allow,crond_t,null_device_t,chr_file,getattr).
access_vector(allow,crond_t,null_device_t,chr_file,lock).
access_vector(allow,crond_t,null_device_t,chr_file,write).
access_vector(allow,crond_t,null_device_t,chr_file,append).
access_vector(allow,crond_t,self,dir,read).
access_vector(allow,crond_t,self,dir,getattr).
access_vector(allow,crond_t,self,dir,lock).
access_vector(allow,crond_t,self,dir,search).
access_vector(allow,crond_t,self,dir,ioctl).
access_vector(allow,crond_t,proc_t,dir,read).
access_vector(allow,crond_t,proc_t,dir,getattr).
access_vector(allow,crond_t,proc_t,dir,lock).
access_vector(allow,crond_t,proc_t,dir,search).
access_vector(allow,crond_t,proc_t,dir,ioctl).
access_vector(allow,crond_t,self,lnk_file,read).
access_vector(allow,crond_t,proc_t,lnk_file,read).
access_vector(allow,crond_t,device_t,dir,getattr).
access_vector(allow,crond_t,device_t,dir,search).
access_vector(allow,crond_t,console_device_t,chr_file,ioctl).
access_vector(allow,crond_t,console_device_t,chr_file,read).
access_vector(allow,crond_t,console_device_t,chr_file,getattr).
access_vector(allow,crond_t,console_device_t,chr_file,lock).
access_vector(allow,crond_t,console_device_t,chr_file,write).
access_vector(allow,crond_t,console_device_t,chr_file,append).
access_vector(allow,crond_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,crond_t,initrc_devpts_t,chr_file,read).
access_vector(allow,crond_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,crond_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,crond_t,initrc_devpts_t,chr_file,write).
access_vector(allow,crond_t,initrc_devpts_t,chr_file,append).
access_vector(allow,crond_t,var_t,dir,getattr).
access_vector(allow,crond_t,var_t,dir,search).
type_decl(crond_var_run_t,var_run_crond_t,[file_type,sysadmfile,pidfile]).
access_vector(allow,crond_t,var_run_t,dir,read).
access_vector(allow,crond_t,var_run_t,dir,getattr).
access_vector(allow,crond_t,var_run_t,dir,lock).
access_vector(allow,crond_t,var_run_t,dir,search).
access_vector(allow,crond_t,var_run_t,dir,ioctl).
access_vector(allow,crond_t,var_run_t,dir,add_name).
access_vector(allow,crond_t,var_run_t,dir,remove_name).
access_vector(allow,crond_t,var_run_t,dir,write).
access_vector(allow,crond_t,crond_var_run_t,file,create).
access_vector(allow,crond_t,crond_var_run_t,file,ioctl).
access_vector(allow,crond_t,crond_var_run_t,file,read).
access_vector(allow,crond_t,crond_var_run_t,file,getattr).
access_vector(allow,crond_t,crond_var_run_t,file,lock).
access_vector(allow,crond_t,crond_var_run_t,file,write).
access_vector(allow,crond_t,crond_var_run_t,file,setattr).
access_vector(allow,crond_t,crond_var_run_t,file,append).
access_vector(allow,crond_t,crond_var_run_t,file,link).
access_vector(allow,crond_t,crond_var_run_t,file,unlink).
access_vector(allow,crond_t,crond_var_run_t,file,rename).
type_trans(crond_t,var_run_t,file,crond_var_run_t).
access_vector(allow,crond_t,crond_var_run_t,dir,read).
access_vector(allow,crond_t,crond_var_run_t,dir,getattr).
access_vector(allow,crond_t,crond_var_run_t,dir,lock).
access_vector(allow,crond_t,crond_var_run_t,dir,search).
access_vector(allow,crond_t,crond_var_run_t,dir,ioctl).
access_vector(allow,crond_t,crond_var_run_t,dir,add_name).
access_vector(allow,crond_t,crond_var_run_t,dir,remove_name).
access_vector(allow,crond_t,crond_var_run_t,dir,write).
access_vector(allow,crond_t,devtty_t,chr_file,ioctl).
access_vector(allow,crond_t,devtty_t,chr_file,read).
access_vector(allow,crond_t,devtty_t,chr_file,getattr).
access_vector(allow,crond_t,devtty_t,chr_file,lock).
access_vector(allow,crond_t,devtty_t,chr_file,write).
access_vector(allow,crond_t,devtty_t,chr_file,append).
access_vector(dontaudit,crond_t,sysadm_home_dir_t,dir,search).
access_vector(allow,crond_t,fs_type,filesystem,getattr).
access_vector(allow,crond_t,etc_t,lnk_file,read).
access_vector(allow,crond_t,locale_t,dir,read).
access_vector(allow,crond_t,locale_t,dir,getattr).
access_vector(allow,crond_t,locale_t,dir,lock).
access_vector(allow,crond_t,locale_t,dir,search).
access_vector(allow,crond_t,locale_t,dir,ioctl).
access_vector(allow,crond_t,locale_t,file,read).
access_vector(allow,crond_t,locale_t,file,getattr).
access_vector(allow,crond_t,locale_t,file,lock).
access_vector(allow,crond_t,locale_t,file,ioctl).
access_vector(allow,crond_t,locale_t,lnk_file,read).
access_vector(allow,crond_t,locale_t,lnk_file,getattr).
access_vector(allow,crond_t,locale_t,lnk_file,lock).
access_vector(allow,crond_t,locale_t,lnk_file,ioctl).
access_vector(allow,crond_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,crond_t,self,file,read).
access_vector(allow,crond_t,self,file,getattr).
access_vector(allow,crond_t,self,file,lock).
access_vector(allow,crond_t,self,file,ioctl).
access_vector(allow,crond_t,self,lnk_file,read).
access_vector(allow,crond_t,self,lnk_file,getattr).
access_vector(allow,crond_t,self,lnk_file,lock).
access_vector(allow,crond_t,self,lnk_file,ioctl).
access_vector(allow,crond_t,self,sock_file,read).
access_vector(allow,crond_t,self,sock_file,getattr).
access_vector(allow,crond_t,self,sock_file,lock).
access_vector(allow,crond_t,self,sock_file,ioctl).
access_vector(allow,crond_t,self,fifo_file,read).
access_vector(allow,crond_t,self,fifo_file,getattr).
access_vector(allow,crond_t,self,fifo_file,lock).
access_vector(allow,crond_t,self,fifo_file,ioctl).
access_vector(allow,crond_t,self,fd,_).
access_vector(allow,crond_t,self,fifo_file,ioctl).
access_vector(allow,crond_t,self,fifo_file,read).
access_vector(allow,crond_t,self,fifo_file,getattr).
access_vector(allow,crond_t,self,fifo_file,lock).
access_vector(allow,crond_t,self,fifo_file,write).
access_vector(allow,crond_t,self,fifo_file,append).
access_vector(allow,crond_t,self,unix_dgram_socket,create).
access_vector(allow,crond_t,self,unix_dgram_socket,ioctl).
access_vector(allow,crond_t,self,unix_dgram_socket,read).
access_vector(allow,crond_t,self,unix_dgram_socket,getattr).
access_vector(allow,crond_t,self,unix_dgram_socket,write).
access_vector(allow,crond_t,self,unix_dgram_socket,setattr).
access_vector(allow,crond_t,self,unix_dgram_socket,append).
access_vector(allow,crond_t,self,unix_dgram_socket,bind).
access_vector(allow,crond_t,self,unix_dgram_socket,connect).
access_vector(allow,crond_t,self,unix_dgram_socket,getopt).
access_vector(allow,crond_t,self,unix_dgram_socket,setopt).
access_vector(allow,crond_t,self,unix_dgram_socket,shutdown).
access_vector(allow,crond_t,self,unix_stream_socket,create).
access_vector(allow,crond_t,self,unix_stream_socket,ioctl).
access_vector(allow,crond_t,self,unix_stream_socket,read).
access_vector(allow,crond_t,self,unix_stream_socket,getattr).
access_vector(allow,crond_t,self,unix_stream_socket,write).
access_vector(allow,crond_t,self,unix_stream_socket,setattr).
access_vector(allow,crond_t,self,unix_stream_socket,append).
access_vector(allow,crond_t,self,unix_stream_socket,bind).
access_vector(allow,crond_t,self,unix_stream_socket,connect).
access_vector(allow,crond_t,self,unix_stream_socket,getopt).
access_vector(allow,crond_t,self,unix_stream_socket,setopt).
access_vector(allow,crond_t,self,unix_stream_socket,shutdown).
access_vector(allow,crond_t,self,unix_stream_socket,listen).
access_vector(allow,crond_t,self,unix_stream_socket,accept).
access_vector(allow,crond_t,self,unix_dgram_socket,sendto).
access_vector(allow,crond_t,self,unix_stream_socket,connectto).
access_vector(allow,crond_t,self,sem,associate).
access_vector(allow,crond_t,self,sem,getattr).
access_vector(allow,crond_t,self,sem,setattr).
access_vector(allow,crond_t,self,sem,create).
access_vector(allow,crond_t,self,sem,destroy).
access_vector(allow,crond_t,self,sem,read).
access_vector(allow,crond_t,self,sem,write).
access_vector(allow,crond_t,self,sem,unix_read).
access_vector(allow,crond_t,self,sem,unix_write).
access_vector(allow,crond_t,self,msg,send).
access_vector(allow,crond_t,self,msg,receive).
access_vector(allow,crond_t,self,msgq,associate).
access_vector(allow,crond_t,self,msgq,getattr).
access_vector(allow,crond_t,self,msgq,setattr).
access_vector(allow,crond_t,self,msgq,create).
access_vector(allow,crond_t,self,msgq,destroy).
access_vector(allow,crond_t,self,msgq,read).
access_vector(allow,crond_t,self,msgq,write).
access_vector(allow,crond_t,self,msgq,enqueue).
access_vector(allow,crond_t,self,msgq,unix_read).
access_vector(allow,crond_t,self,msgq,unix_write).
access_vector(allow,crond_t,self,shm,associate).
access_vector(allow,crond_t,self,shm,getattr).
access_vector(allow,crond_t,self,shm,setattr).
access_vector(allow,crond_t,self,shm,create).
access_vector(allow,crond_t,self,shm,destroy).
access_vector(allow,crond_t,self,shm,read).
access_vector(allow,crond_t,self,shm,write).
access_vector(allow,crond_t,self,shm,lock).
access_vector(allow,crond_t,self,shm,unix_read).
access_vector(allow,crond_t,self,shm,unix_write).
type_decl(anacron_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(crond_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,crond_t,tmp_t,dir,read).
access_vector(allow,crond_t,tmp_t,dir,getattr).
access_vector(allow,crond_t,tmp_t,dir,lock).
access_vector(allow,crond_t,tmp_t,dir,search).
access_vector(allow,crond_t,tmp_t,dir,ioctl).
access_vector(allow,crond_t,tmp_t,dir,add_name).
access_vector(allow,crond_t,tmp_t,dir,remove_name).
access_vector(allow,crond_t,tmp_t,dir,write).
access_vector(allow,crond_t,crond_tmp_t,file,create).
access_vector(allow,crond_t,crond_tmp_t,file,ioctl).
access_vector(allow,crond_t,crond_tmp_t,file,read).
access_vector(allow,crond_t,crond_tmp_t,file,getattr).
access_vector(allow,crond_t,crond_tmp_t,file,lock).
access_vector(allow,crond_t,crond_tmp_t,file,write).
access_vector(allow,crond_t,crond_tmp_t,file,setattr).
access_vector(allow,crond_t,crond_tmp_t,file,append).
access_vector(allow,crond_t,crond_tmp_t,file,link).
access_vector(allow,crond_t,crond_tmp_t,file,unlink).
access_vector(allow,crond_t,crond_tmp_t,file,rename).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,create).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,ioctl).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,read).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,getattr).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,lock).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,write).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,setattr).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,append).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,link).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,unlink).
access_vector(allow,crond_t,crond_tmp_t,lnk_file,rename).
access_vector(allow,crond_t,crond_tmp_t,sock_file,create).
access_vector(allow,crond_t,crond_tmp_t,sock_file,ioctl).
access_vector(allow,crond_t,crond_tmp_t,sock_file,read).
access_vector(allow,crond_t,crond_tmp_t,sock_file,getattr).
access_vector(allow,crond_t,crond_tmp_t,sock_file,lock).
access_vector(allow,crond_t,crond_tmp_t,sock_file,write).
access_vector(allow,crond_t,crond_tmp_t,sock_file,setattr).
access_vector(allow,crond_t,crond_tmp_t,sock_file,append).
access_vector(allow,crond_t,crond_tmp_t,sock_file,link).
access_vector(allow,crond_t,crond_tmp_t,sock_file,unlink).
access_vector(allow,crond_t,crond_tmp_t,sock_file,rename).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,create).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,ioctl).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,read).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,getattr).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,lock).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,write).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,setattr).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,append).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,link).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,unlink).
access_vector(allow,crond_t,crond_tmp_t,fifo_file,rename).
access_vector(allow,crond_t,crond_tmp_t,dir,create).
access_vector(allow,crond_t,crond_tmp_t,dir,read).
access_vector(allow,crond_t,crond_tmp_t,dir,getattr).
access_vector(allow,crond_t,crond_tmp_t,dir,lock).
access_vector(allow,crond_t,crond_tmp_t,dir,setattr).
access_vector(allow,crond_t,crond_tmp_t,dir,link).
access_vector(allow,crond_t,crond_tmp_t,dir,unlink).
access_vector(allow,crond_t,crond_tmp_t,dir,rename).
access_vector(allow,crond_t,crond_tmp_t,dir,search).
access_vector(allow,crond_t,crond_tmp_t,dir,add_name).
access_vector(allow,crond_t,crond_tmp_t,dir,remove_name).
access_vector(allow,crond_t,crond_tmp_t,dir,reparent).
access_vector(allow,crond_t,crond_tmp_t,dir,write).
access_vector(allow,crond_t,crond_tmp_t,dir,rmdir).
type_trans(crond_t,tmp_t,dir,crond_tmp_t).
type_trans(crond_t,tmp_t,[file,lnk_file,sock_file,fifo_file],crond_tmp_t).
type_decl(system_crond_t,[],[domain,privlog,privmail]).
access_vector(allow,system_crond_t,devtty_t,chr_file,ioctl).
access_vector(allow,system_crond_t,devtty_t,chr_file,read).
access_vector(allow,system_crond_t,devtty_t,chr_file,getattr).
access_vector(allow,system_crond_t,devtty_t,chr_file,lock).
access_vector(allow,system_crond_t,devtty_t,chr_file,write).
access_vector(allow,system_crond_t,devtty_t,chr_file,append).
access_vector(allow,system_crond_t,proc_t,dir,read).
access_vector(allow,system_crond_t,proc_t,dir,getattr).
access_vector(allow,system_crond_t,proc_t,dir,lock).
access_vector(allow,system_crond_t,proc_t,dir,search).
access_vector(allow,system_crond_t,proc_t,dir,ioctl).
access_vector(allow,system_crond_t,proc_t,file,read).
access_vector(allow,system_crond_t,proc_t,file,getattr).
access_vector(allow,system_crond_t,proc_t,file,lock).
access_vector(allow,system_crond_t,proc_t,file,ioctl).
access_vector(allow,system_crond_t,proc_t,lnk_file,read).
access_vector(dontaudit,system_crond_t,domain,dir,search).
access_vector(allow,system_crond_t,etc_t,file,read).
access_vector(allow,system_crond_t,etc_t,file,getattr).
access_vector(allow,system_crond_t,etc_t,file,lock).
access_vector(allow,system_crond_t,etc_t,file,ioctl).
access_vector(allow,system_crond_t,etc_t,lnk_file,read).
access_vector(allow,system_crond_t,etc_t,lnk_file,getattr).
access_vector(allow,system_crond_t,etc_t,lnk_file,lock).
access_vector(allow,system_crond_t,etc_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,etc_runtime_t,file,read).
access_vector(allow,crond_t,etc_t,lnk_file,read).
access_vector(allow,system_crond_t,etc_t,lnk_file,read).
access_vector(allow,system_crond_t,locale_t,dir,read).
access_vector(allow,system_crond_t,locale_t,dir,getattr).
access_vector(allow,system_crond_t,locale_t,dir,lock).
access_vector(allow,system_crond_t,locale_t,dir,search).
access_vector(allow,system_crond_t,locale_t,dir,ioctl).
access_vector(allow,system_crond_t,locale_t,file,read).
access_vector(allow,system_crond_t,locale_t,file,getattr).
access_vector(allow,system_crond_t,locale_t,file,lock).
access_vector(allow,system_crond_t,locale_t,file,ioctl).
access_vector(allow,system_crond_t,locale_t,lnk_file,read).
access_vector(allow,system_crond_t,locale_t,lnk_file,getattr).
access_vector(allow,system_crond_t,locale_t,lnk_file,lock).
access_vector(allow,system_crond_t,locale_t,lnk_file,ioctl).
type_decl(cron_log_t,[],[file_type,sysadmfile,logfile]).
access_vector(allow,crond_t,var_log_t,dir,read).
access_vector(allow,crond_t,var_log_t,dir,getattr).
access_vector(allow,crond_t,var_log_t,dir,lock).
access_vector(allow,crond_t,var_log_t,dir,search).
access_vector(allow,crond_t,var_log_t,dir,ioctl).
access_vector(allow,crond_t,var_log_t,dir,add_name).
access_vector(allow,crond_t,var_log_t,dir,remove_name).
access_vector(allow,crond_t,var_log_t,dir,write).
access_vector(allow,crond_t,cron_log_t,file,create).
access_vector(allow,crond_t,cron_log_t,file,ioctl).
access_vector(allow,crond_t,cron_log_t,file,read).
access_vector(allow,crond_t,cron_log_t,file,getattr).
access_vector(allow,crond_t,cron_log_t,file,lock).
access_vector(allow,crond_t,cron_log_t,file,write).
access_vector(allow,crond_t,cron_log_t,file,setattr).
access_vector(allow,crond_t,cron_log_t,file,append).
access_vector(allow,crond_t,cron_log_t,file,link).
access_vector(allow,crond_t,cron_log_t,file,unlink).
access_vector(allow,crond_t,cron_log_t,file,rename).
access_vector(allow,crond_t,cron_log_t,lnk_file,create).
access_vector(allow,crond_t,cron_log_t,lnk_file,ioctl).
access_vector(allow,crond_t,cron_log_t,lnk_file,read).
access_vector(allow,crond_t,cron_log_t,lnk_file,getattr).
access_vector(allow,crond_t,cron_log_t,lnk_file,lock).
access_vector(allow,crond_t,cron_log_t,lnk_file,write).
access_vector(allow,crond_t,cron_log_t,lnk_file,setattr).
access_vector(allow,crond_t,cron_log_t,lnk_file,append).
access_vector(allow,crond_t,cron_log_t,lnk_file,link).
access_vector(allow,crond_t,cron_log_t,lnk_file,unlink).
access_vector(allow,crond_t,cron_log_t,lnk_file,rename).
access_vector(allow,crond_t,cron_log_t,sock_file,create).
access_vector(allow,crond_t,cron_log_t,sock_file,ioctl).
access_vector(allow,crond_t,cron_log_t,sock_file,read).
access_vector(allow,crond_t,cron_log_t,sock_file,getattr).
access_vector(allow,crond_t,cron_log_t,sock_file,lock).
access_vector(allow,crond_t,cron_log_t,sock_file,write).
access_vector(allow,crond_t,cron_log_t,sock_file,setattr).
access_vector(allow,crond_t,cron_log_t,sock_file,append).
access_vector(allow,crond_t,cron_log_t,sock_file,link).
access_vector(allow,crond_t,cron_log_t,sock_file,unlink).
access_vector(allow,crond_t,cron_log_t,sock_file,rename).
access_vector(allow,crond_t,cron_log_t,fifo_file,create).
access_vector(allow,crond_t,cron_log_t,fifo_file,ioctl).
access_vector(allow,crond_t,cron_log_t,fifo_file,read).
access_vector(allow,crond_t,cron_log_t,fifo_file,getattr).
access_vector(allow,crond_t,cron_log_t,fifo_file,lock).
access_vector(allow,crond_t,cron_log_t,fifo_file,write).
access_vector(allow,crond_t,cron_log_t,fifo_file,setattr).
access_vector(allow,crond_t,cron_log_t,fifo_file,append).
access_vector(allow,crond_t,cron_log_t,fifo_file,link).
access_vector(allow,crond_t,cron_log_t,fifo_file,unlink).
access_vector(allow,crond_t,cron_log_t,fifo_file,rename).
access_vector(allow,crond_t,cron_log_t,dir,create).
access_vector(allow,crond_t,cron_log_t,dir,read).
access_vector(allow,crond_t,cron_log_t,dir,getattr).
access_vector(allow,crond_t,cron_log_t,dir,lock).
access_vector(allow,crond_t,cron_log_t,dir,setattr).
access_vector(allow,crond_t,cron_log_t,dir,link).
access_vector(allow,crond_t,cron_log_t,dir,unlink).
access_vector(allow,crond_t,cron_log_t,dir,rename).
access_vector(allow,crond_t,cron_log_t,dir,search).
access_vector(allow,crond_t,cron_log_t,dir,add_name).
access_vector(allow,crond_t,cron_log_t,dir,remove_name).
access_vector(allow,crond_t,cron_log_t,dir,reparent).
access_vector(allow,crond_t,cron_log_t,dir,write).
access_vector(allow,crond_t,cron_log_t,dir,rmdir).
type_trans(crond_t,var_log_t,dir,cron_log_t).
type_trans(crond_t,var_log_t,[file,lnk_file,sock_file,fifo_file],cron_log_t).
access_vector(allow,crond_t,crond_t,capability,setgid).
access_vector(allow,crond_t,crond_t,capability,setuid).
access_vector(allow,crond_t,crond_t,capability,net_bind_service).
access_vector(allow,crond_t,security_t,dir,read).
access_vector(allow,crond_t,security_t,dir,search).
access_vector(allow,crond_t,security_t,dir,getattr).
access_vector(allow,crond_t,security_t,file,getattr).
access_vector(allow,crond_t,security_t,file,read).
access_vector(allow,crond_t,security_t,file,write).
access_vector(allow,crond_t,security_t,security,check_context).
access_vector(allow,crond_t,security_t,security,compute_av).
access_vector(allow,crond_t,security_t,security,compute_create).
access_vector(allow,crond_t,security_t,security,compute_relabel).
access_vector(allow,crond_t,security_t,security,compute_user).
access_vector(allow,crond_t,bin_t,dir,search).
access_vector(allow,crond_t,sbin_t,dir,search).
access_vector(allow,crond_t,bin_t,lnk_file,read).
access_vector(allow,crond_t,var_lib_t,dir,search).
access_vector(allow,crond_t,var_spool_t,dir,read).
access_vector(allow,crond_t,var_spool_t,dir,getattr).
access_vector(allow,crond_t,var_spool_t,dir,lock).
access_vector(allow,crond_t,var_spool_t,dir,search).
access_vector(allow,crond_t,var_spool_t,dir,ioctl).
access_vector(allow,crond_t,cron_spool_t,dir,read).
access_vector(allow,crond_t,cron_spool_t,dir,getattr).
access_vector(allow,crond_t,cron_spool_t,dir,lock).
access_vector(allow,crond_t,cron_spool_t,dir,search).
access_vector(allow,crond_t,cron_spool_t,dir,ioctl).
access_vector(allow,crond_t,cron_spool_t,file,read).
access_vector(allow,crond_t,cron_spool_t,file,getattr).
access_vector(allow,crond_t,cron_spool_t,file,lock).
access_vector(allow,crond_t,cron_spool_t,file,ioctl).
access_vector(allow,crond_t,system_crond_script_t,file,read).
access_vector(allow,crond_t,system_crond_script_t,file,getattr).
access_vector(allow,crond_t,system_crond_script_t,file,lock).
access_vector(allow,crond_t,system_crond_script_t,file,ioctl).
access_vector(allow,crond_t,system_crond_script_t,dir,read).
access_vector(allow,crond_t,system_crond_script_t,dir,getattr).
access_vector(allow,crond_t,system_crond_script_t,dir,lock).
access_vector(allow,crond_t,system_crond_script_t,dir,search).
access_vector(allow,crond_t,system_crond_script_t,dir,ioctl).
access_vector(allow,crond_t,default_context_t,file,read).
access_vector(allow,crond_t,default_context_t,file,getattr).
access_vector(allow,crond_t,default_context_t,file,lock).
access_vector(allow,crond_t,default_context_t,file,ioctl).
access_vector(allow,crond_t,etc_t,file,getattr).
access_vector(allow,crond_t,etc_t,file,read).
access_vector(allow,crond_t,etc_t,lnk_file,read).
access_vector(allow,crond_t,sysadm_home_dir_t,dir,read).
access_vector(allow,crond_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,crond_t,sysadm_home_dir_t,dir,lock).
access_vector(allow,crond_t,sysadm_home_dir_t,dir,search).
access_vector(allow,crond_t,sysadm_home_dir_t,dir,ioctl).
access_vector(allow,crond_t,home_root_t,dir,getattr).
access_vector(allow,crond_t,home_root_t,dir,search).
access_vector(allow,crond_t,user_home_dir_type,dir,read).
access_vector(allow,crond_t,user_home_dir_type,dir,getattr).
access_vector(allow,crond_t,user_home_dir_type,dir,lock).
access_vector(allow,crond_t,user_home_dir_type,dir,search).
access_vector(allow,crond_t,user_home_dir_type,dir,ioctl).
access_vector(allow,crond_t,shell_exec_t,file,read).
access_vector(allow,crond_t,shell_exec_t,file,getattr).
access_vector(allow,crond_t,shell_exec_t,file,lock).
access_vector(allow,crond_t,shell_exec_t,file,execute).
access_vector(allow,crond_t,shell_exec_t,file,ioctl).
access_vector(allow,crond_t,shell_exec_t,file,execute_no_trans).
role_decl(system_r,system_crond_t).
access_vector(allow,system_crond_t,root_t,dir,read).
access_vector(allow,system_crond_t,root_t,dir,getattr).
access_vector(allow,system_crond_t,root_t,dir,lock).
access_vector(allow,system_crond_t,root_t,dir,search).
access_vector(allow,system_crond_t,root_t,dir,ioctl).
access_vector(allow,system_crond_t,usr_t,dir,read).
access_vector(allow,system_crond_t,usr_t,dir,getattr).
access_vector(allow,system_crond_t,usr_t,dir,lock).
access_vector(allow,system_crond_t,usr_t,dir,search).
access_vector(allow,system_crond_t,usr_t,dir,ioctl).
access_vector(allow,system_crond_t,lib_t,dir,read).
access_vector(allow,system_crond_t,lib_t,dir,getattr).
access_vector(allow,system_crond_t,lib_t,dir,lock).
access_vector(allow,system_crond_t,lib_t,dir,search).
access_vector(allow,system_crond_t,lib_t,dir,ioctl).
access_vector(allow,system_crond_t,etc_t,dir,read).
access_vector(allow,system_crond_t,etc_t,dir,getattr).
access_vector(allow,system_crond_t,etc_t,dir,lock).
access_vector(allow,system_crond_t,etc_t,dir,search).
access_vector(allow,system_crond_t,etc_t,dir,ioctl).
access_vector(allow,system_crond_t,lib_t,lnk_file,read).
access_vector(allow,system_crond_t,lib_t,lnk_file,getattr).
access_vector(allow,system_crond_t,lib_t,lnk_file,lock).
access_vector(allow,system_crond_t,lib_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,ld_so_t,file,read).
access_vector(allow,system_crond_t,ld_so_t,file,getattr).
access_vector(allow,system_crond_t,ld_so_t,file,lock).
access_vector(allow,system_crond_t,ld_so_t,file,execute).
access_vector(allow,system_crond_t,ld_so_t,file,ioctl).
access_vector(allow,system_crond_t,ld_so_t,file,execute_no_trans).
access_vector(allow,system_crond_t,ld_so_t,lnk_file,read).
access_vector(allow,system_crond_t,ld_so_t,lnk_file,getattr).
access_vector(allow,system_crond_t,ld_so_t,lnk_file,lock).
access_vector(allow,system_crond_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,shlib_t,file,read).
access_vector(allow,system_crond_t,shlib_t,file,getattr).
access_vector(allow,system_crond_t,shlib_t,file,lock).
access_vector(allow,system_crond_t,shlib_t,file,execute).
access_vector(allow,system_crond_t,shlib_t,file,ioctl).
access_vector(allow,system_crond_t,shlib_t,lnk_file,read).
access_vector(allow,system_crond_t,shlib_t,lnk_file,getattr).
access_vector(allow,system_crond_t,shlib_t,lnk_file,lock).
access_vector(allow,system_crond_t,shlib_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,ld_so_cache_t,file,read).
access_vector(allow,system_crond_t,ld_so_cache_t,file,getattr).
access_vector(allow,system_crond_t,ld_so_cache_t,file,lock).
access_vector(allow,system_crond_t,ld_so_cache_t,file,ioctl).
access_vector(allow,system_crond_t,device_t,dir,search).
access_vector(allow,system_crond_t,null_device_t,chr_file,ioctl).
access_vector(allow,system_crond_t,null_device_t,chr_file,read).
access_vector(allow,system_crond_t,null_device_t,chr_file,getattr).
access_vector(allow,system_crond_t,null_device_t,chr_file,lock).
access_vector(allow,system_crond_t,null_device_t,chr_file,write).
access_vector(allow,system_crond_t,null_device_t,chr_file,append).
access_vector(allow,system_crond_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,system_crond_t,self,dir,read).
access_vector(allow,system_crond_t,self,dir,getattr).
access_vector(allow,system_crond_t,self,dir,lock).
access_vector(allow,system_crond_t,self,dir,search).
access_vector(allow,system_crond_t,self,dir,ioctl).
access_vector(allow,system_crond_t,self,file,read).
access_vector(allow,system_crond_t,self,file,getattr).
access_vector(allow,system_crond_t,self,file,lock).
access_vector(allow,system_crond_t,self,file,ioctl).
access_vector(allow,system_crond_t,self,lnk_file,read).
access_vector(allow,system_crond_t,self,lnk_file,getattr).
access_vector(allow,system_crond_t,self,lnk_file,lock).
access_vector(allow,system_crond_t,self,lnk_file,ioctl).
access_vector(allow,system_crond_t,self,sock_file,read).
access_vector(allow,system_crond_t,self,sock_file,getattr).
access_vector(allow,system_crond_t,self,sock_file,lock).
access_vector(allow,system_crond_t,self,sock_file,ioctl).
access_vector(allow,system_crond_t,self,fifo_file,read).
access_vector(allow,system_crond_t,self,fifo_file,getattr).
access_vector(allow,system_crond_t,self,fifo_file,lock).
access_vector(allow,system_crond_t,self,fifo_file,ioctl).
access_vector(allow,system_crond_t,self,fd,_).
access_vector(allow,system_crond_t,self,fifo_file,ioctl).
access_vector(allow,system_crond_t,self,fifo_file,read).
access_vector(allow,system_crond_t,self,fifo_file,getattr).
access_vector(allow,system_crond_t,self,fifo_file,lock).
access_vector(allow,system_crond_t,self,fifo_file,write).
access_vector(allow,system_crond_t,self,fifo_file,append).
access_vector(allow,system_crond_t,self,unix_dgram_socket,create).
access_vector(allow,system_crond_t,self,unix_dgram_socket,ioctl).
access_vector(allow,system_crond_t,self,unix_dgram_socket,read).
access_vector(allow,system_crond_t,self,unix_dgram_socket,getattr).
access_vector(allow,system_crond_t,self,unix_dgram_socket,write).
access_vector(allow,system_crond_t,self,unix_dgram_socket,setattr).
access_vector(allow,system_crond_t,self,unix_dgram_socket,append).
access_vector(allow,system_crond_t,self,unix_dgram_socket,bind).
access_vector(allow,system_crond_t,self,unix_dgram_socket,connect).
access_vector(allow,system_crond_t,self,unix_dgram_socket,getopt).
access_vector(allow,system_crond_t,self,unix_dgram_socket,setopt).
access_vector(allow,system_crond_t,self,unix_dgram_socket,shutdown).
access_vector(allow,system_crond_t,self,unix_stream_socket,create).
access_vector(allow,system_crond_t,self,unix_stream_socket,ioctl).
access_vector(allow,system_crond_t,self,unix_stream_socket,read).
access_vector(allow,system_crond_t,self,unix_stream_socket,getattr).
access_vector(allow,system_crond_t,self,unix_stream_socket,write).
access_vector(allow,system_crond_t,self,unix_stream_socket,setattr).
access_vector(allow,system_crond_t,self,unix_stream_socket,append).
access_vector(allow,system_crond_t,self,unix_stream_socket,bind).
access_vector(allow,system_crond_t,self,unix_stream_socket,connect).
access_vector(allow,system_crond_t,self,unix_stream_socket,getopt).
access_vector(allow,system_crond_t,self,unix_stream_socket,setopt).
access_vector(allow,system_crond_t,self,unix_stream_socket,shutdown).
access_vector(allow,system_crond_t,self,unix_stream_socket,listen).
access_vector(allow,system_crond_t,self,unix_stream_socket,accept).
access_vector(allow,system_crond_t,self,unix_dgram_socket,sendto).
access_vector(allow,system_crond_t,self,unix_stream_socket,connectto).
access_vector(allow,system_crond_t,self,sem,associate).
access_vector(allow,system_crond_t,self,sem,getattr).
access_vector(allow,system_crond_t,self,sem,setattr).
access_vector(allow,system_crond_t,self,sem,create).
access_vector(allow,system_crond_t,self,sem,destroy).
access_vector(allow,system_crond_t,self,sem,read).
access_vector(allow,system_crond_t,self,sem,write).
access_vector(allow,system_crond_t,self,sem,unix_read).
access_vector(allow,system_crond_t,self,sem,unix_write).
access_vector(allow,system_crond_t,self,msg,send).
access_vector(allow,system_crond_t,self,msg,receive).
access_vector(allow,system_crond_t,self,msgq,associate).
access_vector(allow,system_crond_t,self,msgq,getattr).
access_vector(allow,system_crond_t,self,msgq,setattr).
access_vector(allow,system_crond_t,self,msgq,create).
access_vector(allow,system_crond_t,self,msgq,destroy).
access_vector(allow,system_crond_t,self,msgq,read).
access_vector(allow,system_crond_t,self,msgq,write).
access_vector(allow,system_crond_t,self,msgq,enqueue).
access_vector(allow,system_crond_t,self,msgq,unix_read).
access_vector(allow,system_crond_t,self,msgq,unix_write).
access_vector(allow,system_crond_t,self,shm,associate).
access_vector(allow,system_crond_t,self,shm,getattr).
access_vector(allow,system_crond_t,self,shm,setattr).
access_vector(allow,system_crond_t,self,shm,create).
access_vector(allow,system_crond_t,self,shm,destroy).
access_vector(allow,system_crond_t,self,shm,read).
access_vector(allow,system_crond_t,self,shm,write).
access_vector(allow,system_crond_t,self,shm,lock).
access_vector(allow,system_crond_t,self,shm,unix_read).
access_vector(allow,system_crond_t,self,shm,unix_write).
access_vector(allow,system_crond_t,var_log_t,file,read).
access_vector(allow,system_crond_t,var_log_t,file,getattr).
access_vector(allow,system_crond_t,var_log_t,file,lock).
access_vector(allow,system_crond_t,var_log_t,file,ioctl).
type_decl(system_crond_script_t,[],[file_type,sysadmfile]).
access_vector(allow,crond_t,system_crond_t,process,transition).
access_vector(dontaudit,crond_t,system_crond_t,process,noatsecure).
access_vector(allow,system_crond_t,crond_t,process,sigchld).
access_vector(allow,system_crond_t,crond_t,fd,use).
access_vector(allow,crond_t,system_crond_t,fd,use).
access_vector(allow,system_crond_t,crond_t,fifo_file,ioctl).
access_vector(allow,system_crond_t,crond_t,fifo_file,read).
access_vector(allow,system_crond_t,crond_t,fifo_file,getattr).
access_vector(allow,system_crond_t,crond_t,fifo_file,lock).
access_vector(allow,system_crond_t,crond_t,fifo_file,write).
access_vector(allow,system_crond_t,crond_t,fifo_file,append).
access_vector(allow,system_crond_t,shell_exec_t,file,read).
access_vector(allow,system_crond_t,shell_exec_t,file,getattr).
access_vector(allow,system_crond_t,shell_exec_t,file,lock).
access_vector(allow,system_crond_t,shell_exec_t,file,execute).
access_vector(allow,system_crond_t,shell_exec_t,file,ioctl).
access_vector(allow,system_crond_t,shell_exec_t,file,entrypoint).
access_vector(allow,crond_t,self,process,setexec).
access_vector(allow,crond_t,proc_t,dir,search).
access_vector(allow,crond_t,proc_t,lnk_file,read).
access_vector(allow,crond_t,self,dir,search).
access_vector(allow,crond_t,self,file,read).
access_vector(allow,crond_t,self,file,write).
access_vector(allow,initrc_t,system_crond_t,process,transition).
access_vector(dontaudit,initrc_t,system_crond_t,process,noatsecure).
access_vector(allow,initrc_t,anacron_exec_t,file,read).
access_vector(allow,initrc_t,anacron_exec_t,file,getattr).
access_vector(allow,initrc_t,anacron_exec_t,file,execute).
access_vector(allow,system_crond_t,initrc_t,process,sigchld).
access_vector(allow,system_crond_t,initrc_t,fd,use).
access_vector(allow,initrc_t,system_crond_t,fd,use).
access_vector(allow,system_crond_t,initrc_t,fifo_file,ioctl).
access_vector(allow,system_crond_t,initrc_t,fifo_file,read).
access_vector(allow,system_crond_t,initrc_t,fifo_file,getattr).
access_vector(allow,system_crond_t,initrc_t,fifo_file,lock).
access_vector(allow,system_crond_t,initrc_t,fifo_file,write).
access_vector(allow,system_crond_t,initrc_t,fifo_file,append).
access_vector(allow,system_crond_t,anacron_exec_t,file,read).
access_vector(allow,system_crond_t,anacron_exec_t,file,getattr).
access_vector(allow,system_crond_t,anacron_exec_t,file,lock).
access_vector(allow,system_crond_t,anacron_exec_t,file,execute).
access_vector(allow,system_crond_t,anacron_exec_t,file,ioctl).
access_vector(allow,system_crond_t,anacron_exec_t,file,entrypoint).
type_trans(initrc_t,anacron_exec_t,process,system_crond_t).
access_vector(allow,system_crond_t,var_log_t,dir,read).
access_vector(allow,system_crond_t,var_log_t,dir,getattr).
access_vector(allow,system_crond_t,var_log_t,dir,lock).
access_vector(allow,system_crond_t,var_log_t,dir,search).
access_vector(allow,system_crond_t,var_log_t,dir,ioctl).
access_vector(allow,system_crond_t,var_log_t,dir,add_name).
access_vector(allow,system_crond_t,var_log_t,dir,remove_name).
access_vector(allow,system_crond_t,var_log_t,dir,write).
access_vector(allow,system_crond_t,cron_log_t,file,create).
access_vector(allow,system_crond_t,cron_log_t,file,ioctl).
access_vector(allow,system_crond_t,cron_log_t,file,read).
access_vector(allow,system_crond_t,cron_log_t,file,getattr).
access_vector(allow,system_crond_t,cron_log_t,file,lock).
access_vector(allow,system_crond_t,cron_log_t,file,write).
access_vector(allow,system_crond_t,cron_log_t,file,setattr).
access_vector(allow,system_crond_t,cron_log_t,file,append).
access_vector(allow,system_crond_t,cron_log_t,file,link).
access_vector(allow,system_crond_t,cron_log_t,file,unlink).
access_vector(allow,system_crond_t,cron_log_t,file,rename).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,create).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,read).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,getattr).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,lock).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,write).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,setattr).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,append).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,link).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,unlink).
access_vector(allow,system_crond_t,cron_log_t,lnk_file,rename).
access_vector(allow,system_crond_t,cron_log_t,sock_file,create).
access_vector(allow,system_crond_t,cron_log_t,sock_file,ioctl).
access_vector(allow,system_crond_t,cron_log_t,sock_file,read).
access_vector(allow,system_crond_t,cron_log_t,sock_file,getattr).
access_vector(allow,system_crond_t,cron_log_t,sock_file,lock).
access_vector(allow,system_crond_t,cron_log_t,sock_file,write).
access_vector(allow,system_crond_t,cron_log_t,sock_file,setattr).
access_vector(allow,system_crond_t,cron_log_t,sock_file,append).
access_vector(allow,system_crond_t,cron_log_t,sock_file,link).
access_vector(allow,system_crond_t,cron_log_t,sock_file,unlink).
access_vector(allow,system_crond_t,cron_log_t,sock_file,rename).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,create).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,ioctl).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,read).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,getattr).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,lock).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,write).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,setattr).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,append).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,link).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,unlink).
access_vector(allow,system_crond_t,cron_log_t,fifo_file,rename).
access_vector(allow,system_crond_t,cron_log_t,dir,create).
access_vector(allow,system_crond_t,cron_log_t,dir,read).
access_vector(allow,system_crond_t,cron_log_t,dir,getattr).
access_vector(allow,system_crond_t,cron_log_t,dir,lock).
access_vector(allow,system_crond_t,cron_log_t,dir,setattr).
access_vector(allow,system_crond_t,cron_log_t,dir,link).
access_vector(allow,system_crond_t,cron_log_t,dir,unlink).
access_vector(allow,system_crond_t,cron_log_t,dir,rename).
access_vector(allow,system_crond_t,cron_log_t,dir,search).
access_vector(allow,system_crond_t,cron_log_t,dir,add_name).
access_vector(allow,system_crond_t,cron_log_t,dir,remove_name).
access_vector(allow,system_crond_t,cron_log_t,dir,reparent).
access_vector(allow,system_crond_t,cron_log_t,dir,write).
access_vector(allow,system_crond_t,cron_log_t,dir,rmdir).
type_trans(system_crond_t,var_log_t,dir,cron_log_t).
type_trans(system_crond_t,var_log_t,[file,lnk_file,sock_file,fifo_file],cron_log_t).
access_vector(allow,system_crond_t,init_t,fd,use).
access_vector(allow,system_crond_t,initrc_t,fd,use).
access_vector(allow,system_crond_t,initrc_t,udp_socket,ioctl).
access_vector(allow,system_crond_t,initrc_t,udp_socket,read).
access_vector(allow,system_crond_t,initrc_t,udp_socket,getattr).
access_vector(allow,system_crond_t,initrc_t,udp_socket,write).
access_vector(allow,system_crond_t,initrc_t,udp_socket,setattr).
access_vector(allow,system_crond_t,initrc_t,udp_socket,append).
access_vector(allow,system_crond_t,initrc_t,udp_socket,bind).
access_vector(allow,system_crond_t,initrc_t,udp_socket,connect).
access_vector(allow,system_crond_t,initrc_t,udp_socket,getopt).
access_vector(allow,system_crond_t,initrc_t,udp_socket,setopt).
access_vector(allow,system_crond_t,initrc_t,udp_socket,shutdown).
access_vector(allow,system_crond_t,system_crond_t,capability,setgid).
access_vector(allow,system_crond_t,system_crond_t,capability,setuid).
access_vector(allow,system_crond_t,system_crond_t,capability,dac_override).
access_vector(allow,system_crond_t,system_crond_t,capability,fowner).
access_vector(allow,system_crond_t,system_crond_t,capability,net_bind_service).
access_vector(allow,system_crond_t,system_crond_t,capability,fsetid).
access_vector(allow,system_crond_t,system_crond_script_t,file,read).
access_vector(allow,system_crond_t,system_crond_script_t,file,getattr).
access_vector(allow,system_crond_t,system_crond_script_t,file,lock).
access_vector(allow,system_crond_t,system_crond_script_t,file,ioctl).
access_vector(allow,system_crond_t,system_crond_script_t,file,entrypoint).
access_vector(allow,system_crond_t,bin_t,dir,read).
access_vector(allow,system_crond_t,bin_t,dir,getattr).
access_vector(allow,system_crond_t,bin_t,dir,lock).
access_vector(allow,system_crond_t,bin_t,dir,search).
access_vector(allow,system_crond_t,bin_t,dir,ioctl).
access_vector(allow,system_crond_t,sbin_t,dir,read).
access_vector(allow,system_crond_t,sbin_t,dir,getattr).
access_vector(allow,system_crond_t,sbin_t,dir,lock).
access_vector(allow,system_crond_t,sbin_t,dir,search).
access_vector(allow,system_crond_t,sbin_t,dir,ioctl).
access_vector(allow,system_crond_t,bin_t,lnk_file,read).
access_vector(allow,system_crond_t,sbin_t,lnk_file,read).
access_vector(allow,system_crond_t,bin_t,file,read).
access_vector(allow,system_crond_t,bin_t,file,getattr).
access_vector(allow,system_crond_t,bin_t,file,lock).
access_vector(allow,system_crond_t,bin_t,file,execute).
access_vector(allow,system_crond_t,bin_t,file,ioctl).
access_vector(allow,system_crond_t,bin_t,file,execute_no_trans).
access_vector(allow,system_crond_t,sbin_t,file,read).
access_vector(allow,system_crond_t,sbin_t,file,getattr).
access_vector(allow,system_crond_t,sbin_t,file,lock).
access_vector(allow,system_crond_t,sbin_t,file,execute).
access_vector(allow,system_crond_t,sbin_t,file,ioctl).
access_vector(allow,system_crond_t,sbin_t,file,execute_no_trans).
access_vector(allow,system_crond_t,exec_type,file,read).
access_vector(allow,system_crond_t,exec_type,file,getattr).
access_vector(allow,system_crond_t,exec_type,file,lock).
access_vector(allow,system_crond_t,exec_type,file,execute).
access_vector(allow,system_crond_t,exec_type,file,ioctl).
access_vector(allow,system_crond_t,exec_type,file,execute_no_trans).
access_vector(allow,system_crond_t,etc_t,file,read).
access_vector(allow,system_crond_t,etc_t,file,getattr).
access_vector(allow,system_crond_t,etc_t,file,lock).
access_vector(allow,system_crond_t,etc_t,file,execute).
access_vector(allow,system_crond_t,etc_t,file,ioctl).
access_vector(allow,system_crond_t,etc_t,file,execute_no_trans).
access_vector(allow,system_crond_t,cron_spool_t,dir,read).
access_vector(allow,system_crond_t,cron_spool_t,dir,getattr).
access_vector(allow,system_crond_t,cron_spool_t,dir,lock).
access_vector(allow,system_crond_t,cron_spool_t,dir,search).
access_vector(allow,system_crond_t,cron_spool_t,dir,ioctl).
access_vector(allow,system_crond_t,cron_spool_t,file,read).
access_vector(allow,system_crond_t,cron_spool_t,file,getattr).
access_vector(allow,system_crond_t,cron_spool_t,file,lock).
access_vector(allow,system_crond_t,cron_spool_t,file,ioctl).
access_vector(allow,system_crond_t,var_lib_t,dir,read).
access_vector(allow,system_crond_t,var_lib_t,dir,getattr).
access_vector(allow,system_crond_t,var_lib_t,dir,lock).
access_vector(allow,system_crond_t,var_lib_t,dir,search).
access_vector(allow,system_crond_t,var_lib_t,dir,ioctl).
access_vector(allow,system_crond_t,var_lib_t,dir,add_name).
access_vector(allow,system_crond_t,var_lib_t,dir,remove_name).
access_vector(allow,system_crond_t,var_lib_t,dir,write).
access_vector(allow,system_crond_t,var_lib_t,file,create).
access_vector(allow,system_crond_t,var_lib_t,file,ioctl).
access_vector(allow,system_crond_t,var_lib_t,file,read).
access_vector(allow,system_crond_t,var_lib_t,file,getattr).
access_vector(allow,system_crond_t,var_lib_t,file,lock).
access_vector(allow,system_crond_t,var_lib_t,file,write).
access_vector(allow,system_crond_t,var_lib_t,file,setattr).
access_vector(allow,system_crond_t,var_lib_t,file,append).
access_vector(allow,system_crond_t,var_lib_t,file,link).
access_vector(allow,system_crond_t,var_lib_t,file,unlink).
access_vector(allow,system_crond_t,var_lib_t,file,rename).
access_vector(allow,system_crond_t,catman_t,dir,create).
access_vector(allow,system_crond_t,catman_t,dir,read).
access_vector(allow,system_crond_t,catman_t,dir,getattr).
access_vector(allow,system_crond_t,catman_t,dir,lock).
access_vector(allow,system_crond_t,catman_t,dir,setattr).
access_vector(allow,system_crond_t,catman_t,dir,link).
access_vector(allow,system_crond_t,catman_t,dir,unlink).
access_vector(allow,system_crond_t,catman_t,dir,rename).
access_vector(allow,system_crond_t,catman_t,dir,search).
access_vector(allow,system_crond_t,catman_t,dir,add_name).
access_vector(allow,system_crond_t,catman_t,dir,remove_name).
access_vector(allow,system_crond_t,catman_t,dir,reparent).
access_vector(allow,system_crond_t,catman_t,dir,write).
access_vector(allow,system_crond_t,catman_t,dir,rmdir).
access_vector(allow,system_crond_t,catman_t,file,create).
access_vector(allow,system_crond_t,catman_t,file,ioctl).
access_vector(allow,system_crond_t,catman_t,file,read).
access_vector(allow,system_crond_t,catman_t,file,getattr).
access_vector(allow,system_crond_t,catman_t,file,lock).
access_vector(allow,system_crond_t,catman_t,file,write).
access_vector(allow,system_crond_t,catman_t,file,setattr).
access_vector(allow,system_crond_t,catman_t,file,append).
access_vector(allow,system_crond_t,catman_t,file,link).
access_vector(allow,system_crond_t,catman_t,file,unlink).
access_vector(allow,system_crond_t,catman_t,file,rename).
access_vector(allow,system_crond_t,man_t,file,read).
access_vector(allow,system_crond_t,man_t,file,getattr).
access_vector(allow,system_crond_t,man_t,file,lock).
access_vector(allow,system_crond_t,man_t,file,ioctl).
access_vector(allow,system_crond_t,man_t,lnk_file,read).
type_decl(system_crond_lock_t,[],[file_type,sysadmfile,lockfile]).
access_vector(allow,system_crond_t,var_lock_t,dir,read).
access_vector(allow,system_crond_t,var_lock_t,dir,getattr).
access_vector(allow,system_crond_t,var_lock_t,dir,lock).
access_vector(allow,system_crond_t,var_lock_t,dir,search).
access_vector(allow,system_crond_t,var_lock_t,dir,ioctl).
access_vector(allow,system_crond_t,var_lock_t,dir,add_name).
access_vector(allow,system_crond_t,var_lock_t,dir,remove_name).
access_vector(allow,system_crond_t,var_lock_t,dir,write).
access_vector(allow,system_crond_t,system_crond_lock_t,file,create).
access_vector(allow,system_crond_t,system_crond_lock_t,file,ioctl).
access_vector(allow,system_crond_t,system_crond_lock_t,file,read).
access_vector(allow,system_crond_t,system_crond_lock_t,file,getattr).
access_vector(allow,system_crond_t,system_crond_lock_t,file,lock).
access_vector(allow,system_crond_t,system_crond_lock_t,file,write).
access_vector(allow,system_crond_t,system_crond_lock_t,file,setattr).
access_vector(allow,system_crond_t,system_crond_lock_t,file,append).
access_vector(allow,system_crond_t,system_crond_lock_t,file,link).
access_vector(allow,system_crond_t,system_crond_lock_t,file,unlink).
access_vector(allow,system_crond_t,system_crond_lock_t,file,rename).
type_trans(system_crond_t,var_lock_t,file,system_crond_lock_t).
access_vector(allow,system_crond_t,insmod_t,process,transition).
access_vector(dontaudit,system_crond_t,insmod_t,process,noatsecure).
access_vector(allow,system_crond_t,insmod_exec_t,file,read).
access_vector(allow,system_crond_t,insmod_exec_t,file,getattr).
access_vector(allow,system_crond_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,system_crond_t,process,sigchld).
access_vector(allow,insmod_t,system_crond_t,fd,use).
access_vector(allow,system_crond_t,insmod_t,fd,use).
access_vector(allow,insmod_t,system_crond_t,fifo_file,ioctl).
access_vector(allow,insmod_t,system_crond_t,fifo_file,read).
access_vector(allow,insmod_t,system_crond_t,fifo_file,getattr).
access_vector(allow,insmod_t,system_crond_t,fifo_file,lock).
access_vector(allow,insmod_t,system_crond_t,fifo_file,write).
access_vector(allow,insmod_t,system_crond_t,fifo_file,append).
access_vector(allow,insmod_t,insmod_exec_t,file,entrypoint).
type_trans(system_crond_t,insmod_exec_t,process,insmod_t).
access_vector(allow,insmod_t,crond_t,fifo_file,getattr).
access_vector(allow,insmod_t,crond_t,fifo_file,read).
access_vector(allow,insmod_t,crond_t,fifo_file,write).
access_vector(allow,insmod_t,crond_t,fifo_file,ioctl).
access_vector(allow,insmod_t,crond_t,fd,use).
access_vector(allow,insmod_t,crond_t,process,sigchld).
access_vector(allow,crond_t,mail_spool_t,lnk_file,read).
access_vector(allow,system_crond_t,logrotate_t,process,transition).
access_vector(dontaudit,system_crond_t,logrotate_t,process,noatsecure).
access_vector(allow,system_crond_t,logrotate_exec_t,file,read).
access_vector(allow,system_crond_t,logrotate_exec_t,file,getattr).
access_vector(allow,system_crond_t,logrotate_exec_t,file,execute).
access_vector(allow,logrotate_t,system_crond_t,process,sigchld).
access_vector(allow,logrotate_t,system_crond_t,fd,use).
access_vector(allow,system_crond_t,logrotate_t,fd,use).
access_vector(allow,logrotate_t,system_crond_t,fifo_file,ioctl).
access_vector(allow,logrotate_t,system_crond_t,fifo_file,read).
access_vector(allow,logrotate_t,system_crond_t,fifo_file,getattr).
access_vector(allow,logrotate_t,system_crond_t,fifo_file,lock).
access_vector(allow,logrotate_t,system_crond_t,fifo_file,write).
access_vector(allow,logrotate_t,system_crond_t,fifo_file,append).
access_vector(allow,logrotate_t,logrotate_exec_t,file,read).
access_vector(allow,logrotate_t,logrotate_exec_t,file,getattr).
access_vector(allow,logrotate_t,logrotate_exec_t,file,lock).
access_vector(allow,logrotate_t,logrotate_exec_t,file,execute).
access_vector(allow,logrotate_t,logrotate_exec_t,file,ioctl).
access_vector(allow,logrotate_t,logrotate_exec_t,file,entrypoint).
type_trans(system_crond_t,logrotate_exec_t,process,logrotate_t).
access_vector(allow,logrotate_t,crond_t,fifo_file,getattr).
access_vector(allow,logrotate_t,crond_t,fifo_file,read).
access_vector(allow,logrotate_t,crond_t,fifo_file,write).
access_vector(allow,logrotate_t,crond_t,fifo_file,ioctl).
access_vector(allow,logrotate_t,crond_t,fd,use).
access_vector(allow,logrotate_t,crond_t,process,sigchld).
access_vector(allow,system_crond_t,file_type,file,getattr).
access_vector(allow,system_crond_t,file_type,lnk_file,getattr).
access_vector(allow,system_crond_t,file_type,sock_file,getattr).
access_vector(allow,system_crond_t,file_type,fifo_file,getattr).
access_vector(allow,system_crond_t,file_type,chr_file,getattr).
access_vector(allow,system_crond_t,file_type,blk_file,getattr).
access_vector(allow,system_crond_t,file_type,dir,read).
access_vector(allow,system_crond_t,file_type,dir,search).
access_vector(allow,system_crond_t,file_type,dir,getattr).
type_decl(system_crond_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,system_crond_t,tmp_t,dir,read).
access_vector(allow,system_crond_t,tmp_t,dir,getattr).
access_vector(allow,system_crond_t,tmp_t,dir,lock).
access_vector(allow,system_crond_t,tmp_t,dir,search).
access_vector(allow,system_crond_t,tmp_t,dir,ioctl).
access_vector(allow,system_crond_t,tmp_t,dir,add_name).
access_vector(allow,system_crond_t,tmp_t,dir,remove_name).
access_vector(allow,system_crond_t,tmp_t,dir,write).
access_vector(allow,system_crond_t,crond_tmp_t,dir,read).
access_vector(allow,system_crond_t,crond_tmp_t,dir,getattr).
access_vector(allow,system_crond_t,crond_tmp_t,dir,lock).
access_vector(allow,system_crond_t,crond_tmp_t,dir,search).
access_vector(allow,system_crond_t,crond_tmp_t,dir,ioctl).
access_vector(allow,system_crond_t,crond_tmp_t,dir,add_name).
access_vector(allow,system_crond_t,crond_tmp_t,dir,remove_name).
access_vector(allow,system_crond_t,crond_tmp_t,dir,write).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,create).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,ioctl).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,read).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,getattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,lock).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,write).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,setattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,append).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,link).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,unlink).
access_vector(allow,system_crond_t,system_crond_tmp_t,file,rename).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,create).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,read).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,getattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,lock).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,write).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,setattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,append).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,link).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,unlink).
access_vector(allow,system_crond_t,system_crond_tmp_t,lnk_file,rename).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,create).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,ioctl).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,read).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,getattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,lock).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,write).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,setattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,append).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,link).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,unlink).
access_vector(allow,system_crond_t,system_crond_tmp_t,sock_file,rename).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,create).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,ioctl).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,read).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,getattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,lock).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,write).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,setattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,append).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,link).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,unlink).
access_vector(allow,system_crond_t,system_crond_tmp_t,fifo_file,rename).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,create).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,read).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,getattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,lock).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,setattr).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,link).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,unlink).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,rename).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,search).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,add_name).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,remove_name).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,reparent).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,write).
access_vector(allow,system_crond_t,system_crond_tmp_t,dir,rmdir).
type_trans(system_crond_t,[tmp_t,crond_tmp_t],dir,system_crond_tmp_t).
type_trans(system_crond_t,[tmp_t,crond_tmp_t],[file,lnk_file,sock_file,fifo_file],system_crond_tmp_t).
access_vector(dontaudit,system_crond_t,initrc_var_run_t,file,read).
access_vector(dontaudit,system_crond_t,initrc_var_run_t,file,write).
access_vector(allow,system_crond_t,var_log_sa_t,file,create).
access_vector(allow,system_crond_t,var_log_sa_t,file,ioctl).
access_vector(allow,system_crond_t,var_log_sa_t,file,read).
access_vector(allow,system_crond_t,var_log_sa_t,file,getattr).
access_vector(allow,system_crond_t,var_log_sa_t,file,lock).
access_vector(allow,system_crond_t,var_log_sa_t,file,write).
access_vector(allow,system_crond_t,var_log_sa_t,file,setattr).
access_vector(allow,system_crond_t,var_log_sa_t,file,append).
access_vector(allow,system_crond_t,var_log_sa_t,file,link).
access_vector(allow,system_crond_t,var_log_sa_t,file,unlink).
access_vector(allow,system_crond_t,var_log_sa_t,file,rename).
access_vector(allow,system_crond_t,var_log_sa_t,dir,read).
access_vector(allow,system_crond_t,var_log_sa_t,dir,getattr).
access_vector(allow,system_crond_t,var_log_sa_t,dir,lock).
access_vector(allow,system_crond_t,var_log_sa_t,dir,search).
access_vector(allow,system_crond_t,var_log_sa_t,dir,ioctl).
access_vector(allow,system_crond_t,var_log_sa_t,dir,add_name).
access_vector(allow,system_crond_t,var_log_sa_t,dir,remove_name).
access_vector(allow,system_crond_t,var_log_sa_t,dir,write).
access_vector(allow,system_crond_t,fs_t,filesystem,getattr).
access_vector(allow,system_crond_t,sysctl_t,dir,search).
access_vector(allow,system_crond_t,sysctl_kernel_t,dir,search).
access_vector(allow,system_crond_t,sysctl_kernel_t,file,getattr).
access_vector(allow,system_crond_t,sysctl_kernel_t,file,read).
access_vector(allow,system_crond_t,var_spool_t,file,create).
access_vector(allow,system_crond_t,var_spool_t,file,ioctl).
access_vector(allow,system_crond_t,var_spool_t,file,read).
access_vector(allow,system_crond_t,var_spool_t,file,getattr).
access_vector(allow,system_crond_t,var_spool_t,file,lock).
access_vector(allow,system_crond_t,var_spool_t,file,write).
access_vector(allow,system_crond_t,var_spool_t,file,setattr).
access_vector(allow,system_crond_t,var_spool_t,file,append).
access_vector(allow,system_crond_t,var_spool_t,file,link).
access_vector(allow,system_crond_t,var_spool_t,file,unlink).
access_vector(allow,system_crond_t,var_spool_t,file,rename).
access_vector(allow,system_crond_t,var_spool_t,dir,read).
access_vector(allow,system_crond_t,var_spool_t,dir,getattr).
access_vector(allow,system_crond_t,var_spool_t,dir,lock).
access_vector(allow,system_crond_t,var_spool_t,dir,search).
access_vector(allow,system_crond_t,var_spool_t,dir,ioctl).
access_vector(allow,system_crond_t,var_spool_t,dir,add_name).
access_vector(allow,system_crond_t,var_spool_t,dir,remove_name).
access_vector(allow,system_crond_t,var_spool_t,dir,write).
access_vector(dontaudit,system_crond_t,unlabeled_t,dir,read).
access_vector(dontaudit,system_crond_t,unlabeled_t,dir,getattr).
access_vector(dontaudit,system_crond_t,unlabeled_t,dir,lock).
access_vector(dontaudit,system_crond_t,unlabeled_t,dir,search).
access_vector(dontaudit,system_crond_t,unlabeled_t,dir,ioctl).
access_vector(dontaudit,system_crond_t,unlabeled_t,file,read).
access_vector(dontaudit,system_crond_t,unlabeled_t,file,getattr).
access_vector(dontaudit,system_crond_t,unlabeled_t,file,lock).
access_vector(dontaudit,system_crond_t,unlabeled_t,file,ioctl).
type_decl(crontab_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(dpkg_t,[],[domain,admin,privlog,privmail]).
type_decl(dpkg_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(dpkg_var_lib_t,var_lib_dpkg_t,[file_type,sysadmfile]).
type_decl(etc_dpkg_t,[],[file_type,sysadmfile]).
type_decl(dpkg_lock_t,[],[file_type,sysadmfile]).
type_decl(debconf_cache_t,[],[file_type,sysadmfile]).
type_decl(dpkg_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,dpkg_t,tmp_t,dir,read).
access_vector(allow,dpkg_t,tmp_t,dir,getattr).
access_vector(allow,dpkg_t,tmp_t,dir,lock).
access_vector(allow,dpkg_t,tmp_t,dir,search).
access_vector(allow,dpkg_t,tmp_t,dir,ioctl).
access_vector(allow,dpkg_t,tmp_t,dir,add_name).
access_vector(allow,dpkg_t,tmp_t,dir,remove_name).
access_vector(allow,dpkg_t,tmp_t,dir,write).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,create).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,ioctl).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,read).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,getattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,lock).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,write).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,setattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,append).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,link).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,unlink).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,rename).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,create).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,ioctl).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,read).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,getattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,lock).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,write).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,setattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,append).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,link).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,unlink).
access_vector(allow,dpkg_t,dpkg_tmp_t,lnk_file,rename).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,create).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,ioctl).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,read).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,getattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,lock).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,write).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,setattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,append).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,link).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,unlink).
access_vector(allow,dpkg_t,dpkg_tmp_t,sock_file,rename).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,create).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,ioctl).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,read).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,getattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,lock).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,write).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,setattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,append).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,link).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,unlink).
access_vector(allow,dpkg_t,dpkg_tmp_t,fifo_file,rename).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,create).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,read).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,getattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,lock).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,setattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,link).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,unlink).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,rename).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,search).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,add_name).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,remove_name).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,reparent).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,write).
access_vector(allow,dpkg_t,dpkg_tmp_t,dir,rmdir).
type_trans(dpkg_t,tmp_t,dir,dpkg_tmp_t).
type_trans(dpkg_t,tmp_t,[file,lnk_file,sock_file,fifo_file],dpkg_tmp_t).
access_vector(allow,dpkg_t,dpkg_exec_t,file,read).
access_vector(allow,dpkg_t,dpkg_exec_t,file,getattr).
access_vector(allow,dpkg_t,dpkg_exec_t,file,lock).
access_vector(allow,dpkg_t,dpkg_exec_t,file,execute).
access_vector(allow,dpkg_t,dpkg_exec_t,file,ioctl).
access_vector(allow,dpkg_t,dpkg_exec_t,file,execute_no_trans).
access_vector(allow,dpkg_t,bin_t,file,read).
access_vector(allow,dpkg_t,bin_t,file,getattr).
access_vector(allow,dpkg_t,bin_t,file,lock).
access_vector(allow,dpkg_t,bin_t,file,execute).
access_vector(allow,dpkg_t,bin_t,file,ioctl).
access_vector(allow,dpkg_t,bin_t,file,execute_no_trans).
access_vector(allow,dpkg_t,shell_exec_t,file,read).
access_vector(allow,dpkg_t,shell_exec_t,file,getattr).
access_vector(allow,dpkg_t,shell_exec_t,file,lock).
access_vector(allow,dpkg_t,shell_exec_t,file,execute).
access_vector(allow,dpkg_t,shell_exec_t,file,ioctl).
access_vector(allow,dpkg_t,shell_exec_t,file,execute_no_trans).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,read).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,getattr).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,lock).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,execute).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,ioctl).
access_vector(allow,dpkg_t,dpkg_tmp_t,file,execute_no_trans).
access_vector(allow,dpkg_t,ls_exec_t,file,read).
access_vector(allow,dpkg_t,ls_exec_t,file,getattr).
access_vector(allow,dpkg_t,ls_exec_t,file,lock).
access_vector(allow,dpkg_t,ls_exec_t,file,execute).
access_vector(allow,dpkg_t,ls_exec_t,file,ioctl).
access_vector(allow,dpkg_t,ls_exec_t,file,execute_no_trans).
access_vector(allow,dpkg_t,dpkg_var_lib_t,file,read).
access_vector(allow,dpkg_t,dpkg_var_lib_t,file,getattr).
access_vector(allow,dpkg_t,dpkg_var_lib_t,file,lock).
access_vector(allow,dpkg_t,dpkg_var_lib_t,file,execute).
access_vector(allow,dpkg_t,dpkg_var_lib_t,file,ioctl).
access_vector(allow,dpkg_t,dpkg_var_lib_t,file,execute_no_trans).
access_vector(allow,dpkg_t,etc_dpkg_t,file,read).
access_vector(allow,dpkg_t,etc_dpkg_t,file,getattr).
access_vector(allow,dpkg_t,etc_dpkg_t,file,lock).
access_vector(allow,dpkg_t,etc_dpkg_t,file,execute).
access_vector(allow,dpkg_t,etc_dpkg_t,file,ioctl).
access_vector(allow,dpkg_t,etc_dpkg_t,file,execute_no_trans).
access_vector(allow,dpkg_t,sbin_t,file,read).
access_vector(allow,dpkg_t,sbin_t,file,getattr).
access_vector(allow,dpkg_t,sbin_t,file,lock).
access_vector(allow,dpkg_t,sbin_t,file,execute).
access_vector(allow,dpkg_t,sbin_t,file,ioctl).
access_vector(allow,dpkg_t,sbin_t,file,execute_no_trans).
access_vector(allow,dpkg_t,init_exec_t,file,read).
access_vector(allow,dpkg_t,init_exec_t,file,getattr).
access_vector(allow,dpkg_t,init_exec_t,file,lock).
access_vector(allow,dpkg_t,init_exec_t,file,execute).
access_vector(allow,dpkg_t,init_exec_t,file,ioctl).
access_vector(allow,dpkg_t,init_exec_t,file,execute_no_trans).
access_vector(allow,dpkg_t,random_device_t,chr_file,read).
access_vector(allow,dpkg_t,setfiles_t,process,transition).
access_vector(dontaudit,dpkg_t,setfiles_t,process,noatsecure).
access_vector(allow,dpkg_t,setfiles_exec_t,file,read).
access_vector(allow,dpkg_t,setfiles_exec_t,file,getattr).
access_vector(allow,dpkg_t,setfiles_exec_t,file,execute).
access_vector(allow,setfiles_t,dpkg_t,process,sigchld).
access_vector(allow,setfiles_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,setfiles_t,fd,use).
access_vector(allow,setfiles_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,setfiles_t,dpkg_t,fifo_file,read).
access_vector(allow,setfiles_t,dpkg_t,fifo_file,getattr).
access_vector(allow,setfiles_t,dpkg_t,fifo_file,lock).
access_vector(allow,setfiles_t,dpkg_t,fifo_file,write).
access_vector(allow,setfiles_t,dpkg_t,fifo_file,append).
access_vector(allow,setfiles_t,setfiles_exec_t,file,read).
access_vector(allow,setfiles_t,setfiles_exec_t,file,getattr).
access_vector(allow,setfiles_t,setfiles_exec_t,file,lock).
access_vector(allow,setfiles_t,setfiles_exec_t,file,execute).
access_vector(allow,setfiles_t,setfiles_exec_t,file,ioctl).
access_vector(allow,setfiles_t,setfiles_exec_t,file,entrypoint).
type_trans(dpkg_t,setfiles_exec_t,process,setfiles_t).
access_vector(allow,dpkg_t,update_modules_t,process,transition).
access_vector(dontaudit,dpkg_t,update_modules_t,process,noatsecure).
access_vector(allow,dpkg_t,update_modules_exec_t,file,read).
access_vector(allow,dpkg_t,update_modules_exec_t,file,getattr).
access_vector(allow,dpkg_t,update_modules_exec_t,file,execute).
access_vector(allow,update_modules_t,dpkg_t,process,sigchld).
access_vector(allow,update_modules_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,update_modules_t,fd,use).
access_vector(allow,update_modules_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,update_modules_t,dpkg_t,fifo_file,read).
access_vector(allow,update_modules_t,dpkg_t,fifo_file,getattr).
access_vector(allow,update_modules_t,dpkg_t,fifo_file,lock).
access_vector(allow,update_modules_t,dpkg_t,fifo_file,write).
access_vector(allow,update_modules_t,dpkg_t,fifo_file,append).
access_vector(allow,update_modules_t,update_modules_exec_t,file,read).
access_vector(allow,update_modules_t,update_modules_exec_t,file,getattr).
access_vector(allow,update_modules_t,update_modules_exec_t,file,lock).
access_vector(allow,update_modules_t,update_modules_exec_t,file,execute).
access_vector(allow,update_modules_t,update_modules_exec_t,file,ioctl).
access_vector(allow,update_modules_t,update_modules_exec_t,file,entrypoint).
type_trans(dpkg_t,update_modules_exec_t,process,update_modules_t).
access_vector(allow,dpkg_t,insmod_t,process,transition).
access_vector(dontaudit,dpkg_t,insmod_t,process,noatsecure).
access_vector(allow,dpkg_t,insmod_exec_t,file,read).
access_vector(allow,dpkg_t,insmod_exec_t,file,getattr).
access_vector(allow,dpkg_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,dpkg_t,process,sigchld).
access_vector(allow,insmod_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,insmod_t,fd,use).
access_vector(allow,insmod_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,insmod_t,dpkg_t,fifo_file,read).
access_vector(allow,insmod_t,dpkg_t,fifo_file,getattr).
access_vector(allow,insmod_t,dpkg_t,fifo_file,lock).
access_vector(allow,insmod_t,dpkg_t,fifo_file,write).
access_vector(allow,insmod_t,dpkg_t,fifo_file,append).
access_vector(allow,insmod_t,insmod_exec_t,file,entrypoint).
type_trans(dpkg_t,insmod_exec_t,process,insmod_t).
access_vector(allow,dpkg_t,depmod_t,process,transition).
access_vector(dontaudit,dpkg_t,depmod_t,process,noatsecure).
access_vector(allow,dpkg_t,depmod_exec_t,file,read).
access_vector(allow,dpkg_t,depmod_exec_t,file,getattr).
access_vector(allow,dpkg_t,depmod_exec_t,file,execute).
access_vector(allow,depmod_t,dpkg_t,process,sigchld).
access_vector(allow,depmod_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,depmod_t,fd,use).
access_vector(allow,depmod_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,depmod_t,dpkg_t,fifo_file,read).
access_vector(allow,depmod_t,dpkg_t,fifo_file,getattr).
access_vector(allow,depmod_t,dpkg_t,fifo_file,lock).
access_vector(allow,depmod_t,dpkg_t,fifo_file,write).
access_vector(allow,depmod_t,dpkg_t,fifo_file,append).
access_vector(allow,depmod_t,depmod_exec_t,file,read).
access_vector(allow,depmod_t,depmod_exec_t,file,getattr).
access_vector(allow,depmod_t,depmod_exec_t,file,lock).
access_vector(allow,depmod_t,depmod_exec_t,file,execute).
access_vector(allow,depmod_t,depmod_exec_t,file,ioctl).
access_vector(allow,depmod_t,depmod_exec_t,file,entrypoint).
type_trans(dpkg_t,depmod_exec_t,process,depmod_t).
access_vector(allow,dpkg_t,klogd_t,process,transition).
access_vector(dontaudit,dpkg_t,klogd_t,process,noatsecure).
access_vector(allow,dpkg_t,klogd_exec_t,file,read).
access_vector(allow,dpkg_t,klogd_exec_t,file,getattr).
access_vector(allow,dpkg_t,klogd_exec_t,file,execute).
access_vector(allow,klogd_t,dpkg_t,process,sigchld).
access_vector(allow,klogd_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,klogd_t,fd,use).
access_vector(allow,klogd_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,klogd_t,dpkg_t,fifo_file,read).
access_vector(allow,klogd_t,dpkg_t,fifo_file,getattr).
access_vector(allow,klogd_t,dpkg_t,fifo_file,lock).
access_vector(allow,klogd_t,dpkg_t,fifo_file,write).
access_vector(allow,klogd_t,dpkg_t,fifo_file,append).
access_vector(allow,klogd_t,klogd_exec_t,file,read).
access_vector(allow,klogd_t,klogd_exec_t,file,getattr).
access_vector(allow,klogd_t,klogd_exec_t,file,lock).
access_vector(allow,klogd_t,klogd_exec_t,file,execute).
access_vector(allow,klogd_t,klogd_exec_t,file,ioctl).
access_vector(allow,klogd_t,klogd_exec_t,file,entrypoint).
type_trans(dpkg_t,klogd_exec_t,process,klogd_t).
access_vector(allow,dpkg_t,syslogd_t,process,transition).
access_vector(dontaudit,dpkg_t,syslogd_t,process,noatsecure).
access_vector(allow,dpkg_t,syslogd_exec_t,file,read).
access_vector(allow,dpkg_t,syslogd_exec_t,file,getattr).
access_vector(allow,dpkg_t,syslogd_exec_t,file,execute).
access_vector(allow,syslogd_t,dpkg_t,process,sigchld).
access_vector(allow,syslogd_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,syslogd_t,fd,use).
access_vector(allow,syslogd_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,syslogd_t,dpkg_t,fifo_file,read).
access_vector(allow,syslogd_t,dpkg_t,fifo_file,getattr).
access_vector(allow,syslogd_t,dpkg_t,fifo_file,lock).
access_vector(allow,syslogd_t,dpkg_t,fifo_file,write).
access_vector(allow,syslogd_t,dpkg_t,fifo_file,append).
access_vector(allow,syslogd_t,syslogd_exec_t,file,read).
access_vector(allow,syslogd_t,syslogd_exec_t,file,getattr).
access_vector(allow,syslogd_t,syslogd_exec_t,file,lock).
access_vector(allow,syslogd_t,syslogd_exec_t,file,execute).
access_vector(allow,syslogd_t,syslogd_exec_t,file,ioctl).
access_vector(allow,syslogd_t,syslogd_exec_t,file,entrypoint).
type_trans(dpkg_t,syslogd_exec_t,process,syslogd_t).
access_vector(allow,system_crond_t,syslogd_t,dir,search).
access_vector(allow,system_crond_t,syslogd_t,file,getattr).
access_vector(allow,system_crond_t,syslogd_t,file,read).
access_vector(allow,system_crond_t,syslogd_t,process,signal).
access_vector(allow,load_policy_t,initrc_t,fifo_file,read).
access_vector(allow,load_policy_t,initrc_t,fifo_file,write).
access_vector(allow,dpkg_t,checkpolicy_t,process,transition).
access_vector(dontaudit,dpkg_t,checkpolicy_t,process,noatsecure).
access_vector(allow,dpkg_t,checkpolicy_exec_t,file,read).
access_vector(allow,dpkg_t,checkpolicy_exec_t,file,getattr).
access_vector(allow,dpkg_t,checkpolicy_exec_t,file,execute).
access_vector(allow,checkpolicy_t,dpkg_t,process,sigchld).
access_vector(allow,checkpolicy_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,checkpolicy_t,fd,use).
access_vector(allow,checkpolicy_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,checkpolicy_t,dpkg_t,fifo_file,read).
access_vector(allow,checkpolicy_t,dpkg_t,fifo_file,getattr).
access_vector(allow,checkpolicy_t,dpkg_t,fifo_file,lock).
access_vector(allow,checkpolicy_t,dpkg_t,fifo_file,write).
access_vector(allow,checkpolicy_t,dpkg_t,fifo_file,append).
access_vector(allow,checkpolicy_t,checkpolicy_exec_t,file,entrypoint).
type_trans(dpkg_t,checkpolicy_exec_t,process,checkpolicy_t).
role_decl(system_r,checkpolicy_t).
access_vector(allow,checkpolicy_t,initrc_t,fd,use).
access_vector(allow,checkpolicy_t,initrc_devpts_t,chr_file,read).
access_vector(allow,checkpolicy_t,initrc_devpts_t,chr_file,write).
type_decl(apt_t,[],[domain,admin,privmail,web_client_domain]).
type_decl(apt_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(apt_var_lib_t,var_lib_apt_t,[file_type,sysadmfile]).
type_decl(var_cache_apt_t,[],[file_type,sysadmfile]).
type_decl(etc_apt_t,[],[file_type,sysadmfile]).
type_decl(apt_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,apt_t,tmp_t,dir,read).
access_vector(allow,apt_t,tmp_t,dir,getattr).
access_vector(allow,apt_t,tmp_t,dir,lock).
access_vector(allow,apt_t,tmp_t,dir,search).
access_vector(allow,apt_t,tmp_t,dir,ioctl).
access_vector(allow,apt_t,tmp_t,dir,add_name).
access_vector(allow,apt_t,tmp_t,dir,remove_name).
access_vector(allow,apt_t,tmp_t,dir,write).
access_vector(allow,apt_t,apt_tmp_t,file,create).
access_vector(allow,apt_t,apt_tmp_t,file,ioctl).
access_vector(allow,apt_t,apt_tmp_t,file,read).
access_vector(allow,apt_t,apt_tmp_t,file,getattr).
access_vector(allow,apt_t,apt_tmp_t,file,lock).
access_vector(allow,apt_t,apt_tmp_t,file,write).
access_vector(allow,apt_t,apt_tmp_t,file,setattr).
access_vector(allow,apt_t,apt_tmp_t,file,append).
access_vector(allow,apt_t,apt_tmp_t,file,link).
access_vector(allow,apt_t,apt_tmp_t,file,unlink).
access_vector(allow,apt_t,apt_tmp_t,file,rename).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,create).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,ioctl).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,read).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,getattr).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,lock).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,write).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,setattr).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,append).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,link).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,unlink).
access_vector(allow,apt_t,apt_tmp_t,lnk_file,rename).
access_vector(allow,apt_t,apt_tmp_t,sock_file,create).
access_vector(allow,apt_t,apt_tmp_t,sock_file,ioctl).
access_vector(allow,apt_t,apt_tmp_t,sock_file,read).
access_vector(allow,apt_t,apt_tmp_t,sock_file,getattr).
access_vector(allow,apt_t,apt_tmp_t,sock_file,lock).
access_vector(allow,apt_t,apt_tmp_t,sock_file,write).
access_vector(allow,apt_t,apt_tmp_t,sock_file,setattr).
access_vector(allow,apt_t,apt_tmp_t,sock_file,append).
access_vector(allow,apt_t,apt_tmp_t,sock_file,link).
access_vector(allow,apt_t,apt_tmp_t,sock_file,unlink).
access_vector(allow,apt_t,apt_tmp_t,sock_file,rename).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,create).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,ioctl).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,read).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,getattr).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,lock).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,write).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,setattr).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,append).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,link).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,unlink).
access_vector(allow,apt_t,apt_tmp_t,fifo_file,rename).
access_vector(allow,apt_t,apt_tmp_t,dir,create).
access_vector(allow,apt_t,apt_tmp_t,dir,read).
access_vector(allow,apt_t,apt_tmp_t,dir,getattr).
access_vector(allow,apt_t,apt_tmp_t,dir,lock).
access_vector(allow,apt_t,apt_tmp_t,dir,setattr).
access_vector(allow,apt_t,apt_tmp_t,dir,link).
access_vector(allow,apt_t,apt_tmp_t,dir,unlink).
access_vector(allow,apt_t,apt_tmp_t,dir,rename).
access_vector(allow,apt_t,apt_tmp_t,dir,search).
access_vector(allow,apt_t,apt_tmp_t,dir,add_name).
access_vector(allow,apt_t,apt_tmp_t,dir,remove_name).
access_vector(allow,apt_t,apt_tmp_t,dir,reparent).
access_vector(allow,apt_t,apt_tmp_t,dir,write).
access_vector(allow,apt_t,apt_tmp_t,dir,rmdir).
type_trans(apt_t,tmp_t,dir,apt_tmp_t).
type_trans(apt_t,tmp_t,[file,lnk_file,sock_file,fifo_file],apt_tmp_t).
access_vector(allow,apt_t,apt_tmp_t,file,read).
access_vector(allow,apt_t,apt_tmp_t,file,getattr).
access_vector(allow,apt_t,apt_tmp_t,file,lock).
access_vector(allow,apt_t,apt_tmp_t,file,execute).
access_vector(allow,apt_t,apt_tmp_t,file,ioctl).
access_vector(allow,apt_t,apt_tmp_t,file,execute_no_trans).
access_vector(allow,apt_t,device_t,dir,search).
access_vector(allow,dpkg_t,device_t,dir,search).
access_vector(allow,install_menu_t,device_t,dir,search).
access_vector(dontaudit,apt_t,var_log_t,dir,getattr).
access_vector(dontaudit,apt_t,var_run_t,dir,search).
access_vector(allow,apt_t,sysadm_home_t,dir,read).
access_vector(allow,apt_t,sysadm_home_t,dir,getattr).
access_vector(allow,apt_t,sysadm_home_t,dir,lock).
access_vector(allow,apt_t,sysadm_home_t,dir,search).
access_vector(allow,apt_t,sysadm_home_t,dir,ioctl).
access_vector(allow,apt_t,sysadm_home_t,file,read).
access_vector(allow,apt_t,sysadm_home_t,file,getattr).
access_vector(allow,apt_t,sysadm_home_t,file,lock).
access_vector(allow,apt_t,sysadm_home_t,file,ioctl).
access_vector(allow,apt_t,sysadm_home_t,lnk_file,read).
access_vector(allow,apt_t,sysadm_home_t,lnk_file,getattr).
access_vector(allow,apt_t,sysadm_home_t,lnk_file,lock).
access_vector(allow,apt_t,sysadm_home_t,lnk_file,ioctl).
access_vector(allow,apt_t,sysadm_home_dir_t,dir,search).
access_vector(allow,apt_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,apt_t,bin_t,lnk_file,read).
access_vector(allow,apt_t,bin_t,lnk_file,getattr).
access_vector(allow,apt_t,bin_t,lnk_file,lock).
access_vector(allow,apt_t,bin_t,lnk_file,ioctl).
access_vector(allow,apt_t,debconf_cache_t,dir,read).
access_vector(allow,apt_t,debconf_cache_t,dir,getattr).
access_vector(allow,apt_t,debconf_cache_t,dir,lock).
access_vector(allow,apt_t,debconf_cache_t,dir,search).
access_vector(allow,apt_t,debconf_cache_t,dir,ioctl).
access_vector(allow,apt_t,debconf_cache_t,dir,add_name).
access_vector(allow,apt_t,debconf_cache_t,dir,remove_name).
access_vector(allow,apt_t,debconf_cache_t,dir,write).
access_vector(allow,apt_t,debconf_cache_t,file,create).
access_vector(allow,apt_t,debconf_cache_t,file,ioctl).
access_vector(allow,apt_t,debconf_cache_t,file,read).
access_vector(allow,apt_t,debconf_cache_t,file,getattr).
access_vector(allow,apt_t,debconf_cache_t,file,lock).
access_vector(allow,apt_t,debconf_cache_t,file,write).
access_vector(allow,apt_t,debconf_cache_t,file,setattr).
access_vector(allow,apt_t,debconf_cache_t,file,append).
access_vector(allow,apt_t,debconf_cache_t,file,link).
access_vector(allow,apt_t,debconf_cache_t,file,unlink).
access_vector(allow,apt_t,debconf_cache_t,file,rename).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,create).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,ioctl).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,read).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,getattr).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,lock).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,write).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,setattr).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,append).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,link).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,unlink).
access_vector(allow,apt_t,debconf_cache_t,lnk_file,rename).
access_vector(allow,userdomain,debconf_cache_t,dir,read).
access_vector(allow,userdomain,debconf_cache_t,dir,getattr).
access_vector(allow,userdomain,debconf_cache_t,dir,lock).
access_vector(allow,userdomain,debconf_cache_t,dir,search).
access_vector(allow,userdomain,debconf_cache_t,dir,ioctl).
access_vector(allow,userdomain,debconf_cache_t,file,read).
access_vector(allow,userdomain,debconf_cache_t,file,getattr).
access_vector(allow,userdomain,debconf_cache_t,file,lock).
access_vector(allow,userdomain,debconf_cache_t,file,ioctl).
access_vector(allow,userdomain,debconf_cache_t,lnk_file,read).
access_vector(allow,userdomain,debconf_cache_t,lnk_file,getattr).
access_vector(allow,userdomain,debconf_cache_t,lnk_file,lock).
access_vector(allow,userdomain,debconf_cache_t,lnk_file,ioctl).
access_vector(allow,apt_t,sysctl_kernel_t,dir,search).
access_vector(allow,dpkg_t,sysctl_kernel_t,dir,search).
access_vector(allow,apt_t,sysctl_kernel_t,file,read).
access_vector(allow,apt_t,sysctl_kernel_t,file,getattr).
access_vector(allow,apt_t,sysctl_kernel_t,file,lock).
access_vector(allow,apt_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,dpkg_t,sysctl_kernel_t,file,read).
access_vector(allow,dpkg_t,sysctl_kernel_t,file,getattr).
access_vector(allow,dpkg_t,sysctl_kernel_t,file,lock).
access_vector(allow,dpkg_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,dpkg_t,sysctl_t,dir,search).
access_vector(allow,dpkg_t,console_device_t,chr_file,ioctl).
access_vector(allow,dpkg_t,console_device_t,chr_file,read).
access_vector(allow,dpkg_t,console_device_t,chr_file,getattr).
access_vector(allow,dpkg_t,console_device_t,chr_file,lock).
access_vector(allow,dpkg_t,console_device_t,chr_file,write).
access_vector(allow,dpkg_t,console_device_t,chr_file,append).
access_vector(allow,apt_t,self,unix_stream_socket,create).
access_vector(allow,apt_t,self,unix_stream_socket,ioctl).
access_vector(allow,apt_t,self,unix_stream_socket,read).
access_vector(allow,apt_t,self,unix_stream_socket,getattr).
access_vector(allow,apt_t,self,unix_stream_socket,write).
access_vector(allow,apt_t,self,unix_stream_socket,setattr).
access_vector(allow,apt_t,self,unix_stream_socket,append).
access_vector(allow,apt_t,self,unix_stream_socket,bind).
access_vector(allow,apt_t,self,unix_stream_socket,connect).
access_vector(allow,apt_t,self,unix_stream_socket,getopt).
access_vector(allow,apt_t,self,unix_stream_socket,setopt).
access_vector(allow,apt_t,self,unix_stream_socket,shutdown).
access_vector(allow,dpkg_t,domain,dir,read).
access_vector(allow,dpkg_t,domain,dir,getattr).
access_vector(allow,dpkg_t,domain,dir,lock).
access_vector(allow,dpkg_t,domain,dir,search).
access_vector(allow,dpkg_t,domain,dir,ioctl).
access_vector(allow,dpkg_t,domain,file,read).
access_vector(allow,dpkg_t,domain,file,getattr).
access_vector(allow,dpkg_t,domain,file,lock).
access_vector(allow,dpkg_t,domain,file,ioctl).
access_vector(allow,dpkg_t,domain,lnk_file,read).
access_vector(allow,dpkg_t,domain,lnk_file,getattr).
access_vector(allow,dpkg_t,domain,lnk_file,lock).
access_vector(allow,dpkg_t,domain,lnk_file,ioctl).
access_vector(allow,apt_t,lib_t,file,execute).
access_vector(allow,dpkg_t,lib_t,file,execute).
access_vector(allow,dpkg_t,initrc_t,process,transition).
access_vector(dontaudit,dpkg_t,initrc_t,process,noatsecure).
access_vector(allow,dpkg_t,etc_t,file,read).
access_vector(allow,dpkg_t,etc_t,file,getattr).
access_vector(allow,dpkg_t,etc_t,file,execute).
access_vector(allow,initrc_t,dpkg_t,process,sigchld).
access_vector(allow,initrc_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,initrc_t,fd,use).
access_vector(allow,initrc_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,initrc_t,dpkg_t,fifo_file,read).
access_vector(allow,initrc_t,dpkg_t,fifo_file,getattr).
access_vector(allow,initrc_t,dpkg_t,fifo_file,lock).
access_vector(allow,initrc_t,dpkg_t,fifo_file,write).
access_vector(allow,initrc_t,dpkg_t,fifo_file,append).
access_vector(allow,initrc_t,etc_t,file,read).
access_vector(allow,initrc_t,etc_t,file,getattr).
access_vector(allow,initrc_t,etc_t,file,lock).
access_vector(allow,initrc_t,etc_t,file,execute).
access_vector(allow,initrc_t,etc_t,file,ioctl).
access_vector(allow,initrc_t,etc_t,file,entrypoint).
type_trans(dpkg_t,etc_t,process,initrc_t).
access_vector(dontaudit,dpkg_t,fixed_disk_device_t,blk_file,read).
access_vector(allow,userdomain,dpkg_exec_t,dir,read).
access_vector(allow,userdomain,dpkg_exec_t,dir,getattr).
access_vector(allow,userdomain,dpkg_exec_t,dir,lock).
access_vector(allow,userdomain,dpkg_exec_t,dir,search).
access_vector(allow,userdomain,dpkg_exec_t,dir,ioctl).
access_vector(allow,userdomain,dpkg_exec_t,file,read).
access_vector(allow,userdomain,dpkg_exec_t,file,getattr).
access_vector(allow,userdomain,dpkg_exec_t,file,lock).
access_vector(allow,userdomain,dpkg_exec_t,file,execute).
access_vector(allow,userdomain,dpkg_exec_t,file,ioctl).
access_vector(allow,userdomain,dpkg_exec_t,file,execute_no_trans).
access_vector(allow,userdomain,apt_exec_t,file,read).
access_vector(allow,userdomain,apt_exec_t,file,getattr).
access_vector(allow,userdomain,apt_exec_t,file,lock).
access_vector(allow,userdomain,apt_exec_t,file,execute).
access_vector(allow,userdomain,apt_exec_t,file,ioctl).
access_vector(allow,userdomain,apt_exec_t,file,execute_no_trans).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,read).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,getattr).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,lock).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,search).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,ioctl).
access_vector(allow,apt_t,apt_var_lib_t,dir,read).
access_vector(allow,apt_t,apt_var_lib_t,dir,getattr).
access_vector(allow,apt_t,apt_var_lib_t,dir,lock).
access_vector(allow,apt_t,apt_var_lib_t,dir,search).
access_vector(allow,apt_t,apt_var_lib_t,dir,ioctl).
access_vector(allow,apt_t,var_cache_apt_t,dir,read).
access_vector(allow,apt_t,var_cache_apt_t,dir,getattr).
access_vector(allow,apt_t,var_cache_apt_t,dir,lock).
access_vector(allow,apt_t,var_cache_apt_t,dir,search).
access_vector(allow,apt_t,var_cache_apt_t,dir,ioctl).
access_vector(allow,userdomain,dpkg_var_lib_t,dir,read).
access_vector(allow,userdomain,dpkg_var_lib_t,dir,getattr).
access_vector(allow,userdomain,dpkg_var_lib_t,dir,lock).
access_vector(allow,userdomain,dpkg_var_lib_t,dir,search).
access_vector(allow,userdomain,dpkg_var_lib_t,dir,ioctl).
access_vector(allow,userdomain,apt_var_lib_t,dir,read).
access_vector(allow,userdomain,apt_var_lib_t,dir,getattr).
access_vector(allow,userdomain,apt_var_lib_t,dir,lock).
access_vector(allow,userdomain,apt_var_lib_t,dir,search).
access_vector(allow,userdomain,apt_var_lib_t,dir,ioctl).
access_vector(allow,userdomain,var_cache_apt_t,dir,read).
access_vector(allow,userdomain,var_cache_apt_t,dir,getattr).
access_vector(allow,userdomain,var_cache_apt_t,dir,lock).
access_vector(allow,userdomain,var_cache_apt_t,dir,search).
access_vector(allow,userdomain,var_cache_apt_t,dir,ioctl).
access_vector(allow,apt_t,dpkg_var_lib_t,file,read).
access_vector(allow,apt_t,dpkg_var_lib_t,file,getattr).
access_vector(allow,apt_t,dpkg_var_lib_t,file,lock).
access_vector(allow,apt_t,dpkg_var_lib_t,file,ioctl).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,read).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,getattr).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,lock).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,ioctl).
access_vector(allow,apt_t,apt_var_lib_t,file,read).
access_vector(allow,apt_t,apt_var_lib_t,file,getattr).
access_vector(allow,apt_t,apt_var_lib_t,file,lock).
access_vector(allow,apt_t,apt_var_lib_t,file,ioctl).
access_vector(allow,apt_t,apt_var_lib_t,lnk_file,read).
access_vector(allow,apt_t,apt_var_lib_t,lnk_file,getattr).
access_vector(allow,apt_t,apt_var_lib_t,lnk_file,lock).
access_vector(allow,apt_t,apt_var_lib_t,lnk_file,ioctl).
access_vector(allow,apt_t,var_cache_apt_t,file,read).
access_vector(allow,apt_t,var_cache_apt_t,file,getattr).
access_vector(allow,apt_t,var_cache_apt_t,file,lock).
access_vector(allow,apt_t,var_cache_apt_t,file,ioctl).
access_vector(allow,apt_t,var_cache_apt_t,lnk_file,read).
access_vector(allow,apt_t,var_cache_apt_t,lnk_file,getattr).
access_vector(allow,apt_t,var_cache_apt_t,lnk_file,lock).
access_vector(allow,apt_t,var_cache_apt_t,lnk_file,ioctl).
access_vector(allow,userdomain,dpkg_var_lib_t,file,read).
access_vector(allow,userdomain,dpkg_var_lib_t,file,getattr).
access_vector(allow,userdomain,dpkg_var_lib_t,file,lock).
access_vector(allow,userdomain,dpkg_var_lib_t,file,ioctl).
access_vector(allow,userdomain,dpkg_var_lib_t,lnk_file,read).
access_vector(allow,userdomain,dpkg_var_lib_t,lnk_file,getattr).
access_vector(allow,userdomain,dpkg_var_lib_t,lnk_file,lock).
access_vector(allow,userdomain,dpkg_var_lib_t,lnk_file,ioctl).
access_vector(allow,userdomain,apt_var_lib_t,file,read).
access_vector(allow,userdomain,apt_var_lib_t,file,getattr).
access_vector(allow,userdomain,apt_var_lib_t,file,lock).
access_vector(allow,userdomain,apt_var_lib_t,file,ioctl).
access_vector(allow,userdomain,apt_var_lib_t,lnk_file,read).
access_vector(allow,userdomain,apt_var_lib_t,lnk_file,getattr).
access_vector(allow,userdomain,apt_var_lib_t,lnk_file,lock).
access_vector(allow,userdomain,apt_var_lib_t,lnk_file,ioctl).
access_vector(allow,userdomain,var_cache_apt_t,file,read).
access_vector(allow,userdomain,var_cache_apt_t,file,getattr).
access_vector(allow,userdomain,var_cache_apt_t,file,lock).
access_vector(allow,userdomain,var_cache_apt_t,file,ioctl).
access_vector(allow,userdomain,var_cache_apt_t,lnk_file,read).
access_vector(allow,userdomain,var_cache_apt_t,lnk_file,getattr).
access_vector(allow,userdomain,var_cache_apt_t,lnk_file,lock).
access_vector(allow,userdomain,var_cache_apt_t,lnk_file,ioctl).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,read).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,getattr).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,lock).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,search).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,ioctl).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,add_name).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,remove_name).
access_vector(allow,apt_t,dpkg_var_lib_t,dir,write).
access_vector(allow,apt_t,dpkg_var_lib_t,file,create).
access_vector(allow,apt_t,dpkg_var_lib_t,file,ioctl).
access_vector(allow,apt_t,dpkg_var_lib_t,file,read).
access_vector(allow,apt_t,dpkg_var_lib_t,file,getattr).
access_vector(allow,apt_t,dpkg_var_lib_t,file,lock).
access_vector(allow,apt_t,dpkg_var_lib_t,file,write).
access_vector(allow,apt_t,dpkg_var_lib_t,file,setattr).
access_vector(allow,apt_t,dpkg_var_lib_t,file,append).
access_vector(allow,apt_t,dpkg_var_lib_t,file,link).
access_vector(allow,apt_t,dpkg_var_lib_t,file,unlink).
access_vector(allow,apt_t,dpkg_var_lib_t,file,rename).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,create).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,ioctl).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,read).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,getattr).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,lock).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,write).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,setattr).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,append).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,link).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,unlink).
access_vector(allow,apt_t,dpkg_var_lib_t,lnk_file,rename).
access_vector(allow,system_crond_t,dpkg_var_lib_t,dir,read).
access_vector(allow,system_crond_t,dpkg_var_lib_t,dir,getattr).
access_vector(allow,system_crond_t,dpkg_var_lib_t,dir,lock).
access_vector(allow,system_crond_t,dpkg_var_lib_t,dir,search).
access_vector(allow,system_crond_t,dpkg_var_lib_t,dir,ioctl).
access_vector(allow,system_crond_t,dpkg_var_lib_t,file,read).
access_vector(allow,system_crond_t,dpkg_var_lib_t,file,getattr).
access_vector(allow,system_crond_t,dpkg_var_lib_t,file,lock).
access_vector(allow,system_crond_t,dpkg_var_lib_t,file,ioctl).
access_vector(allow,system_crond_t,dpkg_var_lib_t,lnk_file,read).
access_vector(allow,system_crond_t,dpkg_var_lib_t,lnk_file,getattr).
access_vector(allow,system_crond_t,dpkg_var_lib_t,lnk_file,lock).
access_vector(allow,system_crond_t,dpkg_var_lib_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,etc_dpkg_t,file,read).
access_vector(allow,system_crond_t,etc_dpkg_t,file,getattr).
access_vector(allow,system_crond_t,etc_dpkg_t,file,lock).
access_vector(allow,system_crond_t,etc_dpkg_t,file,ioctl).
access_vector(allow,system_crond_t,shadow_t,file,read).
access_vector(allow,system_crond_t,shadow_t,file,getattr).
access_vector(allow,system_crond_t,tetex_data_t,dir,create).
access_vector(allow,system_crond_t,tetex_data_t,dir,read).
access_vector(allow,system_crond_t,tetex_data_t,dir,getattr).
access_vector(allow,system_crond_t,tetex_data_t,dir,lock).
access_vector(allow,system_crond_t,tetex_data_t,dir,setattr).
access_vector(allow,system_crond_t,tetex_data_t,dir,link).
access_vector(allow,system_crond_t,tetex_data_t,dir,unlink).
access_vector(allow,system_crond_t,tetex_data_t,dir,rename).
access_vector(allow,system_crond_t,tetex_data_t,dir,search).
access_vector(allow,system_crond_t,tetex_data_t,dir,add_name).
access_vector(allow,system_crond_t,tetex_data_t,dir,remove_name).
access_vector(allow,system_crond_t,tetex_data_t,dir,reparent).
access_vector(allow,system_crond_t,tetex_data_t,dir,write).
access_vector(allow,system_crond_t,tetex_data_t,dir,rmdir).
access_vector(allow,system_crond_t,tetex_data_t,file,create).
access_vector(allow,system_crond_t,tetex_data_t,file,ioctl).
access_vector(allow,system_crond_t,tetex_data_t,file,read).
access_vector(allow,system_crond_t,tetex_data_t,file,getattr).
access_vector(allow,system_crond_t,tetex_data_t,file,lock).
access_vector(allow,system_crond_t,tetex_data_t,file,write).
access_vector(allow,system_crond_t,tetex_data_t,file,setattr).
access_vector(allow,system_crond_t,tetex_data_t,file,append).
access_vector(allow,system_crond_t,tetex_data_t,file,link).
access_vector(allow,system_crond_t,tetex_data_t,file,unlink).
access_vector(allow,system_crond_t,tetex_data_t,file,rename).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,create).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,read).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,getattr).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,lock).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,write).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,setattr).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,append).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,link).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,unlink).
access_vector(allow,system_crond_t,tetex_data_t,lnk_file,rename).
access_vector(allow,dpkg_t,tetex_data_t,file,read).
access_vector(allow,dpkg_t,tetex_data_t,file,getattr).
access_vector(allow,dpkg_t,tetex_data_t,file,lock).
access_vector(allow,dpkg_t,tetex_data_t,file,execute).
access_vector(allow,dpkg_t,tetex_data_t,file,ioctl).
access_vector(allow,dpkg_t,tetex_data_t,file,execute_no_trans).
access_vector(allow,install_menu_t,var_lib_t,dir,read).
access_vector(allow,install_menu_t,var_lib_t,dir,getattr).
access_vector(allow,install_menu_t,var_lib_t,dir,lock).
access_vector(allow,install_menu_t,var_lib_t,dir,search).
access_vector(allow,install_menu_t,var_lib_t,dir,ioctl).
access_vector(allow,install_menu_t,dpkg_var_lib_t,dir,read).
access_vector(allow,install_menu_t,dpkg_var_lib_t,dir,getattr).
access_vector(allow,install_menu_t,dpkg_var_lib_t,dir,lock).
access_vector(allow,install_menu_t,dpkg_var_lib_t,dir,search).
access_vector(allow,install_menu_t,dpkg_var_lib_t,dir,ioctl).
access_vector(allow,install_menu_t,var_lib_t,file,read).
access_vector(allow,install_menu_t,var_lib_t,file,getattr).
access_vector(allow,install_menu_t,var_lib_t,file,lock).
access_vector(allow,install_menu_t,var_lib_t,file,ioctl).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,read).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,getattr).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,lock).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,ioctl).
access_vector(allow,install_menu_t,dpkg_var_lib_t,file,read).
access_vector(allow,install_menu_t,dpkg_var_lib_t,file,getattr).
access_vector(allow,install_menu_t,dpkg_var_lib_t,file,lock).
access_vector(allow,install_menu_t,dpkg_var_lib_t,file,ioctl).
access_vector(allow,install_menu_t,dpkg_var_lib_t,lnk_file,read).
access_vector(allow,install_menu_t,dpkg_var_lib_t,lnk_file,getattr).
access_vector(allow,install_menu_t,dpkg_var_lib_t,lnk_file,lock).
access_vector(allow,install_menu_t,dpkg_var_lib_t,lnk_file,ioctl).
access_vector(allow,install_menu_t,initrc_t,fifo_file,read).
access_vector(allow,install_menu_t,initrc_t,fifo_file,write).
access_vector(allow,apt_t,etc_dpkg_t,file,read).
access_vector(allow,apt_t,etc_dpkg_t,file,getattr).
access_vector(allow,apt_t,etc_dpkg_t,file,lock).
access_vector(allow,apt_t,etc_dpkg_t,file,ioctl).
access_vector(allow,install_menu_t,etc_dpkg_t,file,read).
access_vector(allow,install_menu_t,etc_dpkg_t,file,getattr).
access_vector(allow,install_menu_t,etc_dpkg_t,file,lock).
access_vector(allow,install_menu_t,etc_dpkg_t,file,ioctl).
access_vector(allow,userdomain,etc_dpkg_t,file,read).
access_vector(allow,userdomain,etc_dpkg_t,file,getattr).
access_vector(allow,userdomain,etc_dpkg_t,file,lock).
access_vector(allow,userdomain,etc_dpkg_t,file,ioctl).
access_vector(allow,sysadm_t,etc_dpkg_t,file,read).
access_vector(allow,sysadm_t,etc_dpkg_t,file,getattr).
access_vector(allow,sysadm_t,etc_dpkg_t,file,lock).
access_vector(allow,sysadm_t,etc_dpkg_t,file,execute).
access_vector(allow,sysadm_t,etc_dpkg_t,file,ioctl).
access_vector(allow,sysadm_t,etc_dpkg_t,file,execute_no_trans).
access_vector(allow,apt_t,initrc_t,fd,use).
access_vector(allow,dpkg_t,initrc_t,fd,use).
access_vector(allow,install_menu_t,initrc_t,fd,use).
access_vector(dontaudit,dpkg_t,privfd,fd,use).
access_vector(allow,apt_t,devpts_t,dir,search).
access_vector(allow,dpkg_t,devpts_t,dir,search).
access_vector(allow,install_menu_t,devpts_t,dir,search).
access_vector(allow,apt_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,apt_t,initrc_devpts_t,chr_file,read).
access_vector(allow,apt_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,apt_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,apt_t,initrc_devpts_t,chr_file,write).
access_vector(allow,apt_t,initrc_devpts_t,chr_file,append).
access_vector(allow,dpkg_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,dpkg_t,initrc_devpts_t,chr_file,read).
access_vector(allow,dpkg_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,dpkg_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,dpkg_t,initrc_devpts_t,chr_file,write).
access_vector(allow,dpkg_t,initrc_devpts_t,chr_file,append).
access_vector(allow,install_menu_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,install_menu_t,initrc_devpts_t,chr_file,read).
access_vector(allow,install_menu_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,install_menu_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,install_menu_t,initrc_devpts_t,chr_file,write).
access_vector(allow,install_menu_t,initrc_devpts_t,chr_file,append).
access_vector(allow,ifconfig_t,dpkg_t,fd,use).
access_vector(allow,ifconfig_t,dpkg_t,fifo_file,read).
access_vector(allow,ifconfig_t,dpkg_t,fifo_file,write).
access_vector(allow,dpkg_t,root_t,dir,read).
access_vector(allow,dpkg_t,root_t,dir,getattr).
access_vector(allow,dpkg_t,root_t,dir,lock).
access_vector(allow,dpkg_t,root_t,dir,search).
access_vector(allow,dpkg_t,root_t,dir,ioctl).
access_vector(allow,dpkg_t,usr_t,dir,read).
access_vector(allow,dpkg_t,usr_t,dir,getattr).
access_vector(allow,dpkg_t,usr_t,dir,lock).
access_vector(allow,dpkg_t,usr_t,dir,search).
access_vector(allow,dpkg_t,usr_t,dir,ioctl).
access_vector(allow,dpkg_t,lib_t,dir,read).
access_vector(allow,dpkg_t,lib_t,dir,getattr).
access_vector(allow,dpkg_t,lib_t,dir,lock).
access_vector(allow,dpkg_t,lib_t,dir,search).
access_vector(allow,dpkg_t,lib_t,dir,ioctl).
access_vector(allow,dpkg_t,etc_t,dir,read).
access_vector(allow,dpkg_t,etc_t,dir,getattr).
access_vector(allow,dpkg_t,etc_t,dir,lock).
access_vector(allow,dpkg_t,etc_t,dir,search).
access_vector(allow,dpkg_t,etc_t,dir,ioctl).
access_vector(allow,apt_t,root_t,dir,read).
access_vector(allow,apt_t,root_t,dir,getattr).
access_vector(allow,apt_t,root_t,dir,lock).
access_vector(allow,apt_t,root_t,dir,search).
access_vector(allow,apt_t,root_t,dir,ioctl).
access_vector(allow,apt_t,usr_t,dir,read).
access_vector(allow,apt_t,usr_t,dir,getattr).
access_vector(allow,apt_t,usr_t,dir,lock).
access_vector(allow,apt_t,usr_t,dir,search).
access_vector(allow,apt_t,usr_t,dir,ioctl).
access_vector(allow,apt_t,lib_t,dir,read).
access_vector(allow,apt_t,lib_t,dir,getattr).
access_vector(allow,apt_t,lib_t,dir,lock).
access_vector(allow,apt_t,lib_t,dir,search).
access_vector(allow,apt_t,lib_t,dir,ioctl).
access_vector(allow,apt_t,etc_t,dir,read).
access_vector(allow,apt_t,etc_t,dir,getattr).
access_vector(allow,apt_t,etc_t,dir,lock).
access_vector(allow,apt_t,etc_t,dir,search).
access_vector(allow,apt_t,etc_t,dir,ioctl).
access_vector(allow,dpkg_t,lib_t,lnk_file,read).
access_vector(allow,dpkg_t,lib_t,lnk_file,getattr).
access_vector(allow,dpkg_t,lib_t,lnk_file,lock).
access_vector(allow,dpkg_t,lib_t,lnk_file,ioctl).
access_vector(allow,apt_t,lib_t,lnk_file,read).
access_vector(allow,apt_t,lib_t,lnk_file,getattr).
access_vector(allow,apt_t,lib_t,lnk_file,lock).
access_vector(allow,apt_t,lib_t,lnk_file,ioctl).
access_vector(allow,dpkg_t,ld_so_t,file,read).
access_vector(allow,dpkg_t,ld_so_t,file,getattr).
access_vector(allow,dpkg_t,ld_so_t,file,lock).
access_vector(allow,dpkg_t,ld_so_t,file,execute).
access_vector(allow,dpkg_t,ld_so_t,file,ioctl).
access_vector(allow,apt_t,ld_so_t,file,read).
access_vector(allow,apt_t,ld_so_t,file,getattr).
access_vector(allow,apt_t,ld_so_t,file,lock).
access_vector(allow,apt_t,ld_so_t,file,execute).
access_vector(allow,apt_t,ld_so_t,file,ioctl).
access_vector(allow,dpkg_t,ld_so_t,file,execute_no_trans).
access_vector(allow,apt_t,ld_so_t,file,execute_no_trans).
access_vector(allow,dpkg_t,ld_so_t,lnk_file,read).
access_vector(allow,dpkg_t,ld_so_t,lnk_file,getattr).
access_vector(allow,dpkg_t,ld_so_t,lnk_file,lock).
access_vector(allow,dpkg_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,apt_t,ld_so_t,lnk_file,read).
access_vector(allow,apt_t,ld_so_t,lnk_file,getattr).
access_vector(allow,apt_t,ld_so_t,lnk_file,lock).
access_vector(allow,apt_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,dpkg_t,shlib_t,file,read).
access_vector(allow,dpkg_t,shlib_t,file,getattr).
access_vector(allow,dpkg_t,shlib_t,file,lock).
access_vector(allow,dpkg_t,shlib_t,file,execute).
access_vector(allow,dpkg_t,shlib_t,file,ioctl).
access_vector(allow,apt_t,shlib_t,file,read).
access_vector(allow,apt_t,shlib_t,file,getattr).
access_vector(allow,apt_t,shlib_t,file,lock).
access_vector(allow,apt_t,shlib_t,file,execute).
access_vector(allow,apt_t,shlib_t,file,ioctl).
access_vector(allow,dpkg_t,shlib_t,lnk_file,read).
access_vector(allow,dpkg_t,shlib_t,lnk_file,getattr).
access_vector(allow,dpkg_t,shlib_t,lnk_file,lock).
access_vector(allow,dpkg_t,shlib_t,lnk_file,ioctl).
access_vector(allow,apt_t,shlib_t,lnk_file,read).
access_vector(allow,apt_t,shlib_t,lnk_file,getattr).
access_vector(allow,apt_t,shlib_t,lnk_file,lock).
access_vector(allow,apt_t,shlib_t,lnk_file,ioctl).
access_vector(allow,dpkg_t,ld_so_cache_t,file,read).
access_vector(allow,dpkg_t,ld_so_cache_t,file,getattr).
access_vector(allow,dpkg_t,ld_so_cache_t,file,lock).
access_vector(allow,dpkg_t,ld_so_cache_t,file,ioctl).
access_vector(allow,apt_t,ld_so_cache_t,file,read).
access_vector(allow,apt_t,ld_so_cache_t,file,getattr).
access_vector(allow,apt_t,ld_so_cache_t,file,lock).
access_vector(allow,apt_t,ld_so_cache_t,file,ioctl).
access_vector(allow,dpkg_t,device_t,dir,search).
access_vector(allow,apt_t,device_t,dir,search).
access_vector(allow,dpkg_t,null_device_t,chr_file,ioctl).
access_vector(allow,dpkg_t,null_device_t,chr_file,read).
access_vector(allow,dpkg_t,null_device_t,chr_file,getattr).
access_vector(allow,dpkg_t,null_device_t,chr_file,lock).
access_vector(allow,dpkg_t,null_device_t,chr_file,write).
access_vector(allow,dpkg_t,null_device_t,chr_file,append).
access_vector(allow,apt_t,null_device_t,chr_file,ioctl).
access_vector(allow,apt_t,null_device_t,chr_file,read).
access_vector(allow,apt_t,null_device_t,chr_file,getattr).
access_vector(allow,apt_t,null_device_t,chr_file,lock).
access_vector(allow,apt_t,null_device_t,chr_file,write).
access_vector(allow,apt_t,null_device_t,chr_file,append).
access_vector(allow,dpkg_t,proc_t,dir,read).
access_vector(allow,dpkg_t,proc_t,dir,getattr).
access_vector(allow,dpkg_t,proc_t,dir,lock).
access_vector(allow,dpkg_t,proc_t,dir,search).
access_vector(allow,dpkg_t,proc_t,dir,ioctl).
access_vector(allow,dpkg_t,proc_t,file,read).
access_vector(allow,dpkg_t,proc_t,file,getattr).
access_vector(allow,dpkg_t,proc_t,file,lock).
access_vector(allow,dpkg_t,proc_t,file,ioctl).
access_vector(allow,dpkg_t,proc_t,lnk_file,read).
access_vector(allow,dpkg_t,proc_t,lnk_file,getattr).
access_vector(allow,dpkg_t,proc_t,lnk_file,lock).
access_vector(allow,dpkg_t,proc_t,lnk_file,ioctl).
access_vector(allow,dpkg_t,fs_t,filesystem,getattr).
access_vector(allow,dpkg_t,self,capability,chown).
access_vector(allow,dpkg_t,self,capability,dac_override).
access_vector(allow,dpkg_t,self,capability,fowner).
access_vector(allow,dpkg_t,self,capability,fsetid).
access_vector(allow,dpkg_t,self,capability,kill).
access_vector(allow,dpkg_t,self,capability,setgid).
access_vector(allow,dpkg_t,self,capability,setuid).
access_vector(allow,dpkg_t,self,capability,sys_resource).
access_vector(allow,dpkg_t,self,capability,mknod).
access_vector(allow,dpkg_t,self,unix_dgram_socket,create).
access_vector(allow,dpkg_t,self,unix_dgram_socket,ioctl).
access_vector(allow,dpkg_t,self,unix_dgram_socket,read).
access_vector(allow,dpkg_t,self,unix_dgram_socket,getattr).
access_vector(allow,dpkg_t,self,unix_dgram_socket,write).
access_vector(allow,dpkg_t,self,unix_dgram_socket,setattr).
access_vector(allow,dpkg_t,self,unix_dgram_socket,append).
access_vector(allow,dpkg_t,self,unix_dgram_socket,bind).
access_vector(allow,dpkg_t,self,unix_dgram_socket,connect).
access_vector(allow,dpkg_t,self,unix_dgram_socket,getopt).
access_vector(allow,dpkg_t,self,unix_dgram_socket,setopt).
access_vector(allow,dpkg_t,self,unix_dgram_socket,shutdown).
access_vector(allow,dpkg_t,self,unix_stream_socket,create).
access_vector(allow,dpkg_t,self,unix_stream_socket,ioctl).
access_vector(allow,dpkg_t,self,unix_stream_socket,read).
access_vector(allow,dpkg_t,self,unix_stream_socket,getattr).
access_vector(allow,dpkg_t,self,unix_stream_socket,write).
access_vector(allow,dpkg_t,self,unix_stream_socket,setattr).
access_vector(allow,dpkg_t,self,unix_stream_socket,append).
access_vector(allow,dpkg_t,self,unix_stream_socket,bind).
access_vector(allow,dpkg_t,self,unix_stream_socket,connect).
access_vector(allow,dpkg_t,self,unix_stream_socket,getopt).
access_vector(allow,dpkg_t,self,unix_stream_socket,setopt).
access_vector(allow,dpkg_t,self,unix_stream_socket,shutdown).
access_vector(allow,dpkg_t,self,unix_stream_socket,listen).
access_vector(allow,dpkg_t,self,unix_stream_socket,accept).
access_vector(allow,dpkg_t,self,unix_dgram_socket,sendto).
access_vector(allow,dpkg_t,self,unix_stream_socket,connect).
access_vector(allow,dpkg_t,devtty_t,chr_file,ioctl).
access_vector(allow,dpkg_t,devtty_t,chr_file,read).
access_vector(allow,dpkg_t,devtty_t,chr_file,getattr).
access_vector(allow,dpkg_t,devtty_t,chr_file,lock).
access_vector(allow,dpkg_t,devtty_t,chr_file,write).
access_vector(allow,dpkg_t,devtty_t,chr_file,append).
access_vector(allow,apt_t,devtty_t,chr_file,ioctl).
access_vector(allow,apt_t,devtty_t,chr_file,read).
access_vector(allow,apt_t,devtty_t,chr_file,getattr).
access_vector(allow,apt_t,devtty_t,chr_file,lock).
access_vector(allow,apt_t,devtty_t,chr_file,write).
access_vector(allow,apt_t,devtty_t,chr_file,append).
access_vector(allow,dpkg_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,dpkg_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,dpkg_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,dpkg_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,dpkg_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,dpkg_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,apt_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,apt_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,apt_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,apt_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,apt_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,apt_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,dpkg_t,domain,process,signal).
access_vector(allow,dpkg_t,sysadm_t,process,sigchld).
access_vector(allow,dpkg_t,self,process,setpgid).
access_vector(allow,dpkg_t,self,process,sigchld).
access_vector(allow,dpkg_t,self,process,sigkill).
access_vector(allow,dpkg_t,self,process,sigstop).
access_vector(allow,dpkg_t,self,process,signull).
access_vector(allow,dpkg_t,self,process,signal).
access_vector(allow,dpkg_t,self,process,fork).
access_vector(allow,dpkg_t,self,process,getsched).
access_vector(allow,dpkg_t,file_type,dir,create).
access_vector(allow,dpkg_t,file_type,dir,read).
access_vector(allow,dpkg_t,file_type,dir,getattr).
access_vector(allow,dpkg_t,file_type,dir,lock).
access_vector(allow,dpkg_t,file_type,dir,setattr).
access_vector(allow,dpkg_t,file_type,dir,link).
access_vector(allow,dpkg_t,file_type,dir,unlink).
access_vector(allow,dpkg_t,file_type,dir,rename).
access_vector(allow,dpkg_t,file_type,dir,search).
access_vector(allow,dpkg_t,file_type,dir,add_name).
access_vector(allow,dpkg_t,file_type,dir,remove_name).
access_vector(allow,dpkg_t,file_type,dir,reparent).
access_vector(allow,dpkg_t,file_type,dir,write).
access_vector(allow,dpkg_t,file_type,dir,rmdir).
access_vector(allow,dpkg_t,file_type,file,create).
access_vector(allow,dpkg_t,file_type,file,ioctl).
access_vector(allow,dpkg_t,file_type,file,read).
access_vector(allow,dpkg_t,file_type,file,getattr).
access_vector(allow,dpkg_t,file_type,file,lock).
access_vector(allow,dpkg_t,file_type,file,write).
access_vector(allow,dpkg_t,file_type,file,setattr).
access_vector(allow,dpkg_t,file_type,file,append).
access_vector(allow,dpkg_t,file_type,file,link).
access_vector(allow,dpkg_t,file_type,file,unlink).
access_vector(allow,dpkg_t,file_type,file,rename).
access_vector(allow,dpkg_t,file_type,lnk_file,create).
access_vector(allow,dpkg_t,file_type,lnk_file,ioctl).
access_vector(allow,dpkg_t,file_type,lnk_file,read).
access_vector(allow,dpkg_t,file_type,lnk_file,getattr).
access_vector(allow,dpkg_t,file_type,lnk_file,lock).
access_vector(allow,dpkg_t,file_type,lnk_file,write).
access_vector(allow,dpkg_t,file_type,lnk_file,setattr).
access_vector(allow,dpkg_t,file_type,lnk_file,append).
access_vector(allow,dpkg_t,file_type,lnk_file,link).
access_vector(allow,dpkg_t,file_type,lnk_file,unlink).
access_vector(allow,dpkg_t,file_type,lnk_file,rename).
access_vector(allow,dpkg_t,file_type,fifo_file,create).
access_vector(allow,dpkg_t,file_type,fifo_file,ioctl).
access_vector(allow,dpkg_t,file_type,fifo_file,read).
access_vector(allow,dpkg_t,file_type,fifo_file,getattr).
access_vector(allow,dpkg_t,file_type,fifo_file,lock).
access_vector(allow,dpkg_t,file_type,fifo_file,write).
access_vector(allow,dpkg_t,file_type,fifo_file,setattr).
access_vector(allow,dpkg_t,file_type,fifo_file,append).
access_vector(allow,dpkg_t,file_type,fifo_file,link).
access_vector(allow,dpkg_t,file_type,fifo_file,unlink).
access_vector(allow,dpkg_t,file_type,fifo_file,rename).
access_vector(allow,dpkg_t,file_type,sock_file,create).
access_vector(allow,dpkg_t,file_type,sock_file,ioctl).
access_vector(allow,dpkg_t,file_type,sock_file,read).
access_vector(allow,dpkg_t,file_type,sock_file,getattr).
access_vector(allow,dpkg_t,file_type,sock_file,lock).
access_vector(allow,dpkg_t,file_type,sock_file,write).
access_vector(allow,dpkg_t,file_type,sock_file,setattr).
access_vector(allow,dpkg_t,file_type,sock_file,append).
access_vector(allow,dpkg_t,file_type,sock_file,link).
access_vector(allow,dpkg_t,file_type,sock_file,unlink).
access_vector(allow,dpkg_t,file_type,sock_file,rename).
access_vector(allow,dpkg_t,file_type,chr_file,create).
access_vector(allow,dpkg_t,file_type,chr_file,getattr).
access_vector(allow,dpkg_t,file_type,chr_file,setattr).
access_vector(allow,dpkg_t,file_type,chr_file,rename).
access_vector(allow,dpkg_t,file_type,blk_file,create).
access_vector(allow,dpkg_t,file_type,blk_file,getattr).
access_vector(allow,dpkg_t,file_type,blk_file,setattr).
access_vector(allow,dpkg_t,file_type,blk_file,rename).
access_vector(dontaudit,dpkg_t,domain,socket,getattr).
access_vector(dontaudit,dpkg_t,domain,unix_dgram_socket,getattr).
access_vector(dontaudit,dpkg_t,domain,udp_socket,getattr).
access_vector(dontaudit,dpkg_t,domain,unix_stream_socket,getattr).
access_vector(dontaudit,dpkg_t,domain,tcp_socket,getattr).
access_vector(dontaudit,dpkg_t,domain,fifo_file,getattr).
access_vector(dontaudit,dpkg_t,domain,rawip_socket,getattr).
access_vector(dontaudit,dpkg_t,domain,packet_socket,getattr).
access_vector(allow,dpkg_t,proc_kmsg_t,file,getattr).
access_vector(allow,dpkg_t,root_dir_type,dir,getattr).
access_vector(allow,dpkg_t,apt_t,process,transition).
access_vector(dontaudit,dpkg_t,apt_t,process,noatsecure).
access_vector(allow,dpkg_t,apt_exec_t,file,read).
access_vector(allow,dpkg_t,apt_exec_t,file,getattr).
access_vector(allow,dpkg_t,apt_exec_t,file,execute).
access_vector(allow,apt_t,dpkg_t,process,sigchld).
access_vector(allow,apt_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,apt_t,fd,use).
access_vector(allow,apt_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,apt_t,dpkg_t,fifo_file,read).
access_vector(allow,apt_t,dpkg_t,fifo_file,getattr).
access_vector(allow,apt_t,dpkg_t,fifo_file,lock).
access_vector(allow,apt_t,dpkg_t,fifo_file,write).
access_vector(allow,apt_t,dpkg_t,fifo_file,append).
access_vector(allow,apt_t,apt_exec_t,file,read).
access_vector(allow,apt_t,apt_exec_t,file,getattr).
access_vector(allow,apt_t,apt_exec_t,file,lock).
access_vector(allow,apt_t,apt_exec_t,file,execute).
access_vector(allow,apt_t,apt_exec_t,file,ioctl).
access_vector(allow,apt_t,apt_exec_t,file,entrypoint).
type_trans(dpkg_t,apt_exec_t,process,apt_t).
access_vector(allow,apt_t,apt_var_lib_t,dir,read).
access_vector(allow,apt_t,apt_var_lib_t,dir,getattr).
access_vector(allow,apt_t,apt_var_lib_t,dir,lock).
access_vector(allow,apt_t,apt_var_lib_t,dir,search).
access_vector(allow,apt_t,apt_var_lib_t,dir,ioctl).
access_vector(allow,apt_t,apt_var_lib_t,dir,add_name).
access_vector(allow,apt_t,apt_var_lib_t,dir,remove_name).
access_vector(allow,apt_t,apt_var_lib_t,dir,write).
access_vector(allow,apt_t,var_cache_apt_t,dir,read).
access_vector(allow,apt_t,var_cache_apt_t,dir,getattr).
access_vector(allow,apt_t,var_cache_apt_t,dir,lock).
access_vector(allow,apt_t,var_cache_apt_t,dir,search).
access_vector(allow,apt_t,var_cache_apt_t,dir,ioctl).
access_vector(allow,apt_t,var_cache_apt_t,dir,add_name).
access_vector(allow,apt_t,var_cache_apt_t,dir,remove_name).
access_vector(allow,apt_t,var_cache_apt_t,dir,write).
access_vector(allow,apt_t,apt_var_lib_t,file,create).
access_vector(allow,apt_t,apt_var_lib_t,file,ioctl).
access_vector(allow,apt_t,apt_var_lib_t,file,read).
access_vector(allow,apt_t,apt_var_lib_t,file,getattr).
access_vector(allow,apt_t,apt_var_lib_t,file,lock).
access_vector(allow,apt_t,apt_var_lib_t,file,write).
access_vector(allow,apt_t,apt_var_lib_t,file,setattr).
access_vector(allow,apt_t,apt_var_lib_t,file,append).
access_vector(allow,apt_t,apt_var_lib_t,file,link).
access_vector(allow,apt_t,apt_var_lib_t,file,unlink).
access_vector(allow,apt_t,apt_var_lib_t,file,rename).
access_vector(allow,apt_t,var_cache_apt_t,file,create).
access_vector(allow,apt_t,var_cache_apt_t,file,ioctl).
access_vector(allow,apt_t,var_cache_apt_t,file,read).
access_vector(allow,apt_t,var_cache_apt_t,file,getattr).
access_vector(allow,apt_t,var_cache_apt_t,file,lock).
access_vector(allow,apt_t,var_cache_apt_t,file,write).
access_vector(allow,apt_t,var_cache_apt_t,file,setattr).
access_vector(allow,apt_t,var_cache_apt_t,file,append).
access_vector(allow,apt_t,var_cache_apt_t,file,link).
access_vector(allow,apt_t,var_cache_apt_t,file,unlink).
access_vector(allow,apt_t,var_cache_apt_t,file,rename).
access_vector(allow,apt_t,lib_t,dir,read).
access_vector(allow,apt_t,lib_t,dir,getattr).
access_vector(allow,apt_t,lib_t,dir,lock).
access_vector(allow,apt_t,lib_t,dir,search).
access_vector(allow,apt_t,lib_t,dir,ioctl).
access_vector(allow,apt_t,lib_t,dir,add_name).
access_vector(allow,apt_t,lib_t,dir,remove_name).
access_vector(allow,apt_t,lib_t,dir,write).
access_vector(allow,apt_t,lib_t,file,create).
access_vector(allow,apt_t,lib_t,file,ioctl).
access_vector(allow,apt_t,lib_t,file,read).
access_vector(allow,apt_t,lib_t,file,getattr).
access_vector(allow,apt_t,lib_t,file,lock).
access_vector(allow,apt_t,lib_t,file,write).
access_vector(allow,apt_t,lib_t,file,setattr).
access_vector(allow,apt_t,lib_t,file,append).
access_vector(allow,apt_t,lib_t,file,link).
access_vector(allow,apt_t,lib_t,file,unlink).
access_vector(allow,apt_t,lib_t,file,rename).
access_vector(allow,apt_t,lib_t,lnk_file,create).
access_vector(allow,apt_t,lib_t,lnk_file,ioctl).
access_vector(allow,apt_t,lib_t,lnk_file,read).
access_vector(allow,apt_t,lib_t,lnk_file,getattr).
access_vector(allow,apt_t,lib_t,lnk_file,lock).
access_vector(allow,apt_t,lib_t,lnk_file,write).
access_vector(allow,apt_t,lib_t,lnk_file,setattr).
access_vector(allow,apt_t,lib_t,lnk_file,append).
access_vector(allow,apt_t,lib_t,lnk_file,link).
access_vector(allow,apt_t,lib_t,lnk_file,unlink).
access_vector(allow,apt_t,lib_t,lnk_file,rename).
access_vector(allow,apt_t,self,capability,dac_override).
access_vector(allow,apt_t,apt_exec_t,file,read).
access_vector(allow,apt_t,apt_exec_t,file,getattr).
access_vector(allow,apt_t,apt_exec_t,file,lock).
access_vector(allow,apt_t,apt_exec_t,file,execute).
access_vector(allow,apt_t,apt_exec_t,file,ioctl).
access_vector(allow,apt_t,apt_exec_t,file,execute_no_trans).
access_vector(allow,apt_t,bin_t,file,read).
access_vector(allow,apt_t,bin_t,file,getattr).
access_vector(allow,apt_t,bin_t,file,lock).
access_vector(allow,apt_t,bin_t,file,execute).
access_vector(allow,apt_t,bin_t,file,ioctl).
access_vector(allow,apt_t,bin_t,file,execute_no_trans).
access_vector(allow,apt_t,sbin_t,file,read).
access_vector(allow,apt_t,sbin_t,file,getattr).
access_vector(allow,apt_t,sbin_t,file,lock).
access_vector(allow,apt_t,sbin_t,file,execute).
access_vector(allow,apt_t,sbin_t,file,ioctl).
access_vector(allow,apt_t,sbin_t,file,execute_no_trans).
access_vector(allow,apt_t,shell_exec_t,file,read).
access_vector(allow,apt_t,shell_exec_t,file,getattr).
access_vector(allow,apt_t,shell_exec_t,file,lock).
access_vector(allow,apt_t,shell_exec_t,file,execute).
access_vector(allow,apt_t,shell_exec_t,file,ioctl).
access_vector(allow,apt_t,shell_exec_t,file,execute_no_trans).
access_vector(allow,apt_t,bin_t,dir,search).
access_vector(allow,apt_t,sbin_t,dir,search).
access_vector(allow,apt_t,self,process,signal).
access_vector(allow,apt_t,self,process,sigchld).
access_vector(allow,apt_t,self,process,fork).
access_vector(allow,apt_t,sysadm_t,process,sigchld).
access_vector(allow,apt_t,self,udp_socket,create).
access_vector(allow,apt_t,self,udp_socket,ioctl).
access_vector(allow,apt_t,self,udp_socket,read).
access_vector(allow,apt_t,self,udp_socket,getattr).
access_vector(allow,apt_t,self,udp_socket,write).
access_vector(allow,apt_t,self,udp_socket,setattr).
access_vector(allow,apt_t,self,udp_socket,append).
access_vector(allow,apt_t,self,udp_socket,bind).
access_vector(allow,apt_t,self,udp_socket,connect).
access_vector(allow,apt_t,self,udp_socket,getopt).
access_vector(allow,apt_t,self,udp_socket,setopt).
access_vector(allow,apt_t,self,udp_socket,shutdown).
access_vector(allow,dpkg_t,self,udp_socket,create).
access_vector(allow,dpkg_t,self,udp_socket,ioctl).
access_vector(allow,dpkg_t,self,udp_socket,read).
access_vector(allow,dpkg_t,self,udp_socket,getattr).
access_vector(allow,dpkg_t,self,udp_socket,write).
access_vector(allow,dpkg_t,self,udp_socket,setattr).
access_vector(allow,dpkg_t,self,udp_socket,append).
access_vector(allow,dpkg_t,self,udp_socket,bind).
access_vector(allow,dpkg_t,self,udp_socket,connect).
access_vector(allow,dpkg_t,self,udp_socket,getopt).
access_vector(allow,dpkg_t,self,udp_socket,setopt).
access_vector(allow,dpkg_t,self,udp_socket,shutdown).
access_vector(allow,apt_t,self,tcp_socket,create).
access_vector(allow,apt_t,self,tcp_socket,ioctl).
access_vector(allow,apt_t,self,tcp_socket,read).
access_vector(allow,apt_t,self,tcp_socket,getattr).
access_vector(allow,apt_t,self,tcp_socket,write).
access_vector(allow,apt_t,self,tcp_socket,setattr).
access_vector(allow,apt_t,self,tcp_socket,append).
access_vector(allow,apt_t,self,tcp_socket,bind).
access_vector(allow,apt_t,self,tcp_socket,connect).
access_vector(allow,apt_t,self,tcp_socket,getopt).
access_vector(allow,apt_t,self,tcp_socket,setopt).
access_vector(allow,apt_t,self,tcp_socket,shutdown).
access_vector(allow,apt_t,self,tcp_socket,listen).
access_vector(allow,apt_t,self,tcp_socket,accept).
access_vector(allow,dpkg_t,self,tcp_socket,create).
access_vector(allow,dpkg_t,self,tcp_socket,ioctl).
access_vector(allow,dpkg_t,self,tcp_socket,read).
access_vector(allow,dpkg_t,self,tcp_socket,getattr).
access_vector(allow,dpkg_t,self,tcp_socket,write).
access_vector(allow,dpkg_t,self,tcp_socket,setattr).
access_vector(allow,dpkg_t,self,tcp_socket,append).
access_vector(allow,dpkg_t,self,tcp_socket,bind).
access_vector(allow,dpkg_t,self,tcp_socket,connect).
access_vector(allow,dpkg_t,self,tcp_socket,getopt).
access_vector(allow,dpkg_t,self,tcp_socket,setopt).
access_vector(allow,dpkg_t,self,tcp_socket,shutdown).
access_vector(allow,dpkg_t,self,tcp_socket,listen).
access_vector(allow,dpkg_t,self,tcp_socket,accept).
access_vector(allow,apt_t,any_socket_t,udp_socket,sendto).
access_vector(allow,dpkg_t,any_socket_t,udp_socket,sendto).
access_vector(allow,apt_t,netif_type,netif,tcp_send).
access_vector(allow,apt_t,netif_type,netif,udp_send).
access_vector(allow,apt_t,netif_type,netif,rawip_send).
access_vector(allow,dpkg_t,netif_type,netif,tcp_send).
access_vector(allow,dpkg_t,netif_type,netif,udp_send).
access_vector(allow,dpkg_t,netif_type,netif,rawip_send).
access_vector(allow,apt_t,netif_type,netif,tcp_recv).
access_vector(allow,apt_t,netif_type,netif,udp_recv).
access_vector(allow,apt_t,netif_type,netif,rawip_recv).
access_vector(allow,dpkg_t,netif_type,netif,tcp_recv).
access_vector(allow,dpkg_t,netif_type,netif,udp_recv).
access_vector(allow,dpkg_t,netif_type,netif,rawip_recv).
access_vector(allow,apt_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,apt_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,apt_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,dpkg_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,dpkg_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,dpkg_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,apt_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,apt_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,dpkg_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,dpkg_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,apt_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(allow,dpkg_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,apt_t,tcp_socket_t,tcp_socket,connectto).
access_vector(dontaudit,dpkg_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,apt_t,node_type,node,tcp_send).
access_vector(allow,apt_t,node_type,node,udp_send).
access_vector(allow,apt_t,node_type,node,rawip_send).
access_vector(allow,dpkg_t,node_type,node,tcp_send).
access_vector(allow,dpkg_t,node_type,node,udp_send).
access_vector(allow,dpkg_t,node_type,node,rawip_send).
access_vector(allow,apt_t,node_type,node,tcp_recv).
access_vector(allow,apt_t,node_type,node,udp_recv).
access_vector(allow,apt_t,node_type,node,rawip_recv).
access_vector(allow,dpkg_t,node_type,node,tcp_recv).
access_vector(allow,dpkg_t,node_type,node,udp_recv).
access_vector(allow,dpkg_t,node_type,node,rawip_recv).
access_vector(allow,apt_t,mount_t,udp_socket,ioctl).
access_vector(allow,apt_t,mount_t,udp_socket,read).
access_vector(allow,apt_t,mount_t,udp_socket,getattr).
access_vector(allow,apt_t,mount_t,udp_socket,write).
access_vector(allow,apt_t,mount_t,udp_socket,setattr).
access_vector(allow,apt_t,mount_t,udp_socket,append).
access_vector(allow,apt_t,mount_t,udp_socket,bind).
access_vector(allow,apt_t,mount_t,udp_socket,connect).
access_vector(allow,apt_t,mount_t,udp_socket,getopt).
access_vector(allow,apt_t,mount_t,udp_socket,setopt).
access_vector(allow,apt_t,mount_t,udp_socket,shutdown).
access_vector(allow,dpkg_t,mount_t,udp_socket,ioctl).
access_vector(allow,dpkg_t,mount_t,udp_socket,read).
access_vector(allow,dpkg_t,mount_t,udp_socket,getattr).
access_vector(allow,dpkg_t,mount_t,udp_socket,write).
access_vector(allow,dpkg_t,mount_t,udp_socket,setattr).
access_vector(allow,dpkg_t,mount_t,udp_socket,append).
access_vector(allow,dpkg_t,mount_t,udp_socket,bind).
access_vector(allow,dpkg_t,mount_t,udp_socket,connect).
access_vector(allow,dpkg_t,mount_t,udp_socket,getopt).
access_vector(allow,dpkg_t,mount_t,udp_socket,setopt).
access_vector(allow,dpkg_t,mount_t,udp_socket,shutdown).
access_vector(allow,apt_t,port_t,udp_socket,name_bind).
access_vector(allow,dpkg_t,port_t,udp_socket,name_bind).
access_vector(allow,apt_t,port_t,tcp_socket,name_bind).
access_vector(allow,dpkg_t,port_t,tcp_socket,name_bind).
access_vector(allow,apt_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,apt_t,var_t,dir,search).
access_vector(allow,apt_t,var_t,dir,getattr).
access_vector(allow,dpkg_t,var_t,dir,search).
access_vector(allow,dpkg_t,var_t,dir,getattr).
access_vector(dontaudit,apt_t,fs_type,dir,getattr).
access_vector(dontaudit,apt_t,file_type,dir,getattr).
access_vector(allow,apt_t,var_lib_t,dir,read).
access_vector(allow,apt_t,var_lib_t,dir,getattr).
access_vector(allow,apt_t,var_lib_t,dir,lock).
access_vector(allow,apt_t,var_lib_t,dir,search).
access_vector(allow,apt_t,var_lib_t,dir,ioctl).
access_vector(allow,apt_t,bin_t,dir,read).
access_vector(allow,apt_t,bin_t,dir,getattr).
access_vector(allow,apt_t,bin_t,dir,lock).
access_vector(allow,apt_t,bin_t,dir,search).
access_vector(allow,apt_t,bin_t,dir,ioctl).
access_vector(allow,dpkg_t,var_lib_t,dir,read).
access_vector(allow,dpkg_t,var_lib_t,dir,getattr).
access_vector(allow,dpkg_t,var_lib_t,dir,lock).
access_vector(allow,dpkg_t,var_lib_t,dir,search).
access_vector(allow,dpkg_t,var_lib_t,dir,ioctl).
access_vector(allow,dpkg_t,bin_t,dir,read).
access_vector(allow,dpkg_t,bin_t,dir,getattr).
access_vector(allow,dpkg_t,bin_t,dir,lock).
access_vector(allow,dpkg_t,bin_t,dir,search).
access_vector(allow,dpkg_t,bin_t,dir,ioctl).
access_vector(allow,apt_t,dpkg_lock_t,file,setattr).
access_vector(allow,apt_t,dpkg_lock_t,file,ioctl).
access_vector(allow,apt_t,dpkg_lock_t,file,read).
access_vector(allow,apt_t,dpkg_lock_t,file,getattr).
access_vector(allow,apt_t,dpkg_lock_t,file,lock).
access_vector(allow,apt_t,dpkg_lock_t,file,write).
access_vector(allow,apt_t,dpkg_lock_t,file,append).
access_vector(allow,dpkg_t,dpkg_lock_t,file,setattr).
access_vector(allow,dpkg_t,dpkg_lock_t,file,ioctl).
access_vector(allow,dpkg_t,dpkg_lock_t,file,read).
access_vector(allow,dpkg_t,dpkg_lock_t,file,getattr).
access_vector(allow,dpkg_t,dpkg_lock_t,file,lock).
access_vector(allow,dpkg_t,dpkg_lock_t,file,write).
access_vector(allow,dpkg_t,dpkg_lock_t,file,append).
access_vector(allow,apt_t,proc_t,dir,read).
access_vector(allow,apt_t,proc_t,dir,getattr).
access_vector(allow,apt_t,proc_t,dir,lock).
access_vector(allow,apt_t,proc_t,dir,search).
access_vector(allow,apt_t,proc_t,dir,ioctl).
access_vector(allow,apt_t,apt_t,dir,read).
access_vector(allow,apt_t,apt_t,dir,getattr).
access_vector(allow,apt_t,apt_t,dir,lock).
access_vector(allow,apt_t,apt_t,dir,search).
access_vector(allow,apt_t,apt_t,dir,ioctl).
access_vector(allow,apt_t,proc_t,file,read).
access_vector(allow,apt_t,proc_t,file,getattr).
access_vector(allow,apt_t,proc_t,file,lock).
access_vector(allow,apt_t,proc_t,file,ioctl).
access_vector(allow,apt_t,proc_t,lnk_file,read).
access_vector(allow,apt_t,proc_t,lnk_file,getattr).
access_vector(allow,apt_t,proc_t,lnk_file,lock).
access_vector(allow,apt_t,proc_t,lnk_file,ioctl).
access_vector(allow,apt_t,apt_t,file,read).
access_vector(allow,apt_t,apt_t,file,getattr).
access_vector(allow,apt_t,apt_t,file,lock).
access_vector(allow,apt_t,apt_t,file,ioctl).
access_vector(allow,apt_t,apt_t,lnk_file,read).
access_vector(allow,apt_t,apt_t,lnk_file,getattr).
access_vector(allow,apt_t,apt_t,lnk_file,lock).
access_vector(allow,apt_t,apt_t,lnk_file,ioctl).
access_vector(allow,apt_t,self,fifo_file,ioctl).
access_vector(allow,apt_t,self,fifo_file,read).
access_vector(allow,apt_t,self,fifo_file,getattr).
access_vector(allow,apt_t,self,fifo_file,lock).
access_vector(allow,apt_t,self,fifo_file,write).
access_vector(allow,apt_t,self,fifo_file,append).
access_vector(allow,dpkg_t,self,fifo_file,ioctl).
access_vector(allow,dpkg_t,self,fifo_file,read).
access_vector(allow,dpkg_t,self,fifo_file,getattr).
access_vector(allow,dpkg_t,self,fifo_file,lock).
access_vector(allow,dpkg_t,self,fifo_file,write).
access_vector(allow,dpkg_t,self,fifo_file,append).
access_vector(allow,apt_t,etc_t,file,read).
access_vector(allow,apt_t,etc_t,file,getattr).
access_vector(allow,apt_t,etc_t,file,lock).
access_vector(allow,apt_t,etc_t,file,ioctl).
access_vector(allow,apt_t,resolv_conf_t,file,read).
access_vector(allow,apt_t,resolv_conf_t,file,getattr).
access_vector(allow,apt_t,resolv_conf_t,file,lock).
access_vector(allow,apt_t,resolv_conf_t,file,ioctl).
access_vector(allow,apt_t,etc_t,lnk_file,read).
access_vector(allow,apt_t,etc_t,lnk_file,read).
access_vector(allow,apt_t,locale_t,dir,read).
access_vector(allow,apt_t,locale_t,dir,getattr).
access_vector(allow,apt_t,locale_t,dir,lock).
access_vector(allow,apt_t,locale_t,dir,search).
access_vector(allow,apt_t,locale_t,dir,ioctl).
access_vector(allow,apt_t,locale_t,file,read).
access_vector(allow,apt_t,locale_t,file,getattr).
access_vector(allow,apt_t,locale_t,file,lock).
access_vector(allow,apt_t,locale_t,file,ioctl).
access_vector(allow,apt_t,locale_t,lnk_file,read).
access_vector(allow,apt_t,locale_t,lnk_file,getattr).
access_vector(allow,apt_t,locale_t,lnk_file,lock).
access_vector(allow,apt_t,locale_t,lnk_file,ioctl).
access_vector(allow,userdomain,etc_apt_t,dir,read).
access_vector(allow,userdomain,etc_apt_t,dir,getattr).
access_vector(allow,userdomain,etc_apt_t,dir,lock).
access_vector(allow,userdomain,etc_apt_t,dir,search).
access_vector(allow,userdomain,etc_apt_t,dir,ioctl).
access_vector(allow,apt_t,etc_apt_t,dir,read).
access_vector(allow,apt_t,etc_apt_t,dir,getattr).
access_vector(allow,apt_t,etc_apt_t,dir,lock).
access_vector(allow,apt_t,etc_apt_t,dir,search).
access_vector(allow,apt_t,etc_apt_t,dir,ioctl).
access_vector(allow,userdomain,etc_apt_t,file,read).
access_vector(allow,userdomain,etc_apt_t,file,getattr).
access_vector(allow,userdomain,etc_apt_t,file,lock).
access_vector(allow,userdomain,etc_apt_t,file,ioctl).
access_vector(allow,userdomain,etc_apt_t,lnk_file,read).
access_vector(allow,userdomain,etc_apt_t,lnk_file,getattr).
access_vector(allow,userdomain,etc_apt_t,lnk_file,lock).
access_vector(allow,userdomain,etc_apt_t,lnk_file,ioctl).
access_vector(allow,apt_t,etc_apt_t,file,read).
access_vector(allow,apt_t,etc_apt_t,file,getattr).
access_vector(allow,apt_t,etc_apt_t,file,lock).
access_vector(allow,apt_t,etc_apt_t,file,ioctl).
access_vector(allow,apt_t,etc_apt_t,lnk_file,read).
access_vector(allow,apt_t,etc_apt_t,lnk_file,getattr).
access_vector(allow,apt_t,etc_apt_t,lnk_file,lock).
access_vector(allow,apt_t,etc_apt_t,lnk_file,ioctl).
access_vector(allow,apt_t,fs_t,filesystem,getattr).
access_vector(allow,apt_t,etc_runtime_t,file,read).
access_vector(allow,apt_t,etc_runtime_t,file,getattr).
access_vector(allow,apt_t,etc_runtime_t,file,lock).
access_vector(allow,apt_t,etc_runtime_t,file,ioctl).
access_vector(allow,apt_t,dpkg_t,process,transition).
access_vector(dontaudit,apt_t,dpkg_t,process,noatsecure).
access_vector(allow,apt_t,dpkg_exec_t,file,read).
access_vector(allow,apt_t,dpkg_exec_t,file,getattr).
access_vector(allow,apt_t,dpkg_exec_t,file,execute).
access_vector(allow,dpkg_t,apt_t,process,sigchld).
access_vector(allow,dpkg_t,apt_t,fd,use).
access_vector(allow,apt_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,apt_t,fifo_file,ioctl).
access_vector(allow,dpkg_t,apt_t,fifo_file,read).
access_vector(allow,dpkg_t,apt_t,fifo_file,getattr).
access_vector(allow,dpkg_t,apt_t,fifo_file,lock).
access_vector(allow,dpkg_t,apt_t,fifo_file,write).
access_vector(allow,dpkg_t,apt_t,fifo_file,append).
access_vector(allow,dpkg_t,dpkg_exec_t,file,read).
access_vector(allow,dpkg_t,dpkg_exec_t,file,getattr).
access_vector(allow,dpkg_t,dpkg_exec_t,file,lock).
access_vector(allow,dpkg_t,dpkg_exec_t,file,execute).
access_vector(allow,dpkg_t,dpkg_exec_t,file,ioctl).
access_vector(allow,dpkg_t,dpkg_exec_t,file,entrypoint).
type_trans(apt_t,dpkg_exec_t,process,dpkg_t).
type_decl(install_menu_t,[],[domain,admin]).
type_decl(install_menu_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(install_menu_var_run_t,var_run_install_menu_t,[file_type,sysadmfile,pidfile]).
access_vector(allow,install_menu_t,var_run_t,dir,read).
access_vector(allow,install_menu_t,var_run_t,dir,getattr).
access_vector(allow,install_menu_t,var_run_t,dir,lock).
access_vector(allow,install_menu_t,var_run_t,dir,search).
access_vector(allow,install_menu_t,var_run_t,dir,ioctl).
access_vector(allow,install_menu_t,var_run_t,dir,add_name).
access_vector(allow,install_menu_t,var_run_t,dir,remove_name).
access_vector(allow,install_menu_t,var_run_t,dir,write).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,create).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,ioctl).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,read).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,getattr).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,lock).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,write).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,setattr).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,append).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,link).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,unlink).
access_vector(allow,install_menu_t,install_menu_var_run_t,file,rename).
type_trans(install_menu_t,var_run_t,file,install_menu_var_run_t).
access_vector(allow,install_menu_t,install_menu_var_run_t,dir,read).
access_vector(allow,install_menu_t,install_menu_var_run_t,dir,getattr).
access_vector(allow,install_menu_t,install_menu_var_run_t,dir,lock).
access_vector(allow,install_menu_t,install_menu_var_run_t,dir,search).
access_vector(allow,install_menu_t,install_menu_var_run_t,dir,ioctl).
access_vector(allow,install_menu_t,install_menu_var_run_t,dir,add_name).
access_vector(allow,install_menu_t,install_menu_var_run_t,dir,remove_name).
access_vector(allow,install_menu_t,install_menu_var_run_t,dir,write).
access_vector(allow,install_menu_t,self,unix_stream_socket,create).
access_vector(allow,install_menu_t,self,unix_stream_socket,ioctl).
access_vector(allow,install_menu_t,self,unix_stream_socket,read).
access_vector(allow,install_menu_t,self,unix_stream_socket,getattr).
access_vector(allow,install_menu_t,self,unix_stream_socket,write).
access_vector(allow,install_menu_t,self,unix_stream_socket,setattr).
access_vector(allow,install_menu_t,self,unix_stream_socket,append).
access_vector(allow,install_menu_t,self,unix_stream_socket,bind).
access_vector(allow,install_menu_t,self,unix_stream_socket,connect).
access_vector(allow,install_menu_t,self,unix_stream_socket,getopt).
access_vector(allow,install_menu_t,self,unix_stream_socket,setopt).
access_vector(allow,install_menu_t,self,unix_stream_socket,shutdown).
type_decl(debian_menu_t,[],[file_type,sysadmfile]).
access_vector(allow,userdomain,debian_menu_t,dir,read).
access_vector(allow,userdomain,debian_menu_t,dir,getattr).
access_vector(allow,userdomain,debian_menu_t,dir,lock).
access_vector(allow,userdomain,debian_menu_t,dir,search).
access_vector(allow,userdomain,debian_menu_t,dir,ioctl).
access_vector(allow,userdomain,debian_menu_t,file,read).
access_vector(allow,userdomain,debian_menu_t,file,getattr).
access_vector(allow,userdomain,debian_menu_t,file,lock).
access_vector(allow,userdomain,debian_menu_t,file,ioctl).
access_vector(allow,userdomain,debian_menu_t,lnk_file,read).
access_vector(allow,userdomain,debian_menu_t,lnk_file,getattr).
access_vector(allow,userdomain,debian_menu_t,lnk_file,lock).
access_vector(allow,userdomain,debian_menu_t,lnk_file,ioctl).
access_vector(dontaudit,install_menu_t,sysadm_home_dir_t,dir,search).
access_vector(allow,install_menu_t,debian_menu_t,dir,create).
access_vector(allow,install_menu_t,debian_menu_t,dir,read).
access_vector(allow,install_menu_t,debian_menu_t,dir,getattr).
access_vector(allow,install_menu_t,debian_menu_t,dir,lock).
access_vector(allow,install_menu_t,debian_menu_t,dir,setattr).
access_vector(allow,install_menu_t,debian_menu_t,dir,link).
access_vector(allow,install_menu_t,debian_menu_t,dir,unlink).
access_vector(allow,install_menu_t,debian_menu_t,dir,rename).
access_vector(allow,install_menu_t,debian_menu_t,dir,search).
access_vector(allow,install_menu_t,debian_menu_t,dir,add_name).
access_vector(allow,install_menu_t,debian_menu_t,dir,remove_name).
access_vector(allow,install_menu_t,debian_menu_t,dir,reparent).
access_vector(allow,install_menu_t,debian_menu_t,dir,write).
access_vector(allow,install_menu_t,debian_menu_t,dir,rmdir).
access_vector(allow,install_menu_t,debian_menu_t,file,create).
access_vector(allow,install_menu_t,debian_menu_t,file,ioctl).
access_vector(allow,install_menu_t,debian_menu_t,file,read).
access_vector(allow,install_menu_t,debian_menu_t,file,getattr).
access_vector(allow,install_menu_t,debian_menu_t,file,lock).
access_vector(allow,install_menu_t,debian_menu_t,file,write).
access_vector(allow,install_menu_t,debian_menu_t,file,setattr).
access_vector(allow,install_menu_t,debian_menu_t,file,append).
access_vector(allow,install_menu_t,debian_menu_t,file,link).
access_vector(allow,install_menu_t,debian_menu_t,file,unlink).
access_vector(allow,install_menu_t,debian_menu_t,file,rename).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,create).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,ioctl).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,read).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,getattr).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,lock).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,write).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,setattr).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,append).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,link).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,unlink).
access_vector(allow,install_menu_t,debian_menu_t,lnk_file,rename).
access_vector(allow,install_menu_t,dpkg_lock_t,file,setattr).
access_vector(allow,install_menu_t,dpkg_lock_t,file,ioctl).
access_vector(allow,install_menu_t,dpkg_lock_t,file,read).
access_vector(allow,install_menu_t,dpkg_lock_t,file,getattr).
access_vector(allow,install_menu_t,dpkg_lock_t,file,lock).
access_vector(allow,install_menu_t,dpkg_lock_t,file,write).
access_vector(allow,install_menu_t,dpkg_lock_t,file,append).
access_vector(allow,install_menu_t,self,process,signal).
access_vector(allow,install_menu_t,proc_t,dir,search).
access_vector(allow,install_menu_t,proc_t,file,read).
access_vector(allow,install_menu_t,proc_t,file,getattr).
access_vector(allow,install_menu_t,proc_t,file,lock).
access_vector(allow,install_menu_t,proc_t,file,ioctl).
access_vector(allow,install_menu_t,bin_t,file,read).
access_vector(allow,install_menu_t,bin_t,file,getattr).
access_vector(allow,install_menu_t,bin_t,file,lock).
access_vector(allow,install_menu_t,bin_t,file,execute).
access_vector(allow,install_menu_t,bin_t,file,ioctl).
access_vector(allow,install_menu_t,bin_t,file,execute_no_trans).
access_vector(allow,install_menu_t,sbin_t,file,read).
access_vector(allow,install_menu_t,sbin_t,file,getattr).
access_vector(allow,install_menu_t,sbin_t,file,lock).
access_vector(allow,install_menu_t,sbin_t,file,execute).
access_vector(allow,install_menu_t,sbin_t,file,ioctl).
access_vector(allow,install_menu_t,sbin_t,file,execute_no_trans).
access_vector(allow,install_menu_t,shell_exec_t,file,read).
access_vector(allow,install_menu_t,shell_exec_t,file,getattr).
access_vector(allow,install_menu_t,shell_exec_t,file,lock).
access_vector(allow,install_menu_t,shell_exec_t,file,execute).
access_vector(allow,install_menu_t,shell_exec_t,file,ioctl).
access_vector(allow,install_menu_t,shell_exec_t,file,execute_no_trans).
access_vector(allow,install_menu_t,install_menu_exec_t,file,read).
access_vector(allow,install_menu_t,install_menu_exec_t,file,getattr).
access_vector(allow,install_menu_t,install_menu_exec_t,file,lock).
access_vector(allow,install_menu_t,install_menu_exec_t,file,execute).
access_vector(allow,install_menu_t,install_menu_exec_t,file,ioctl).
access_vector(allow,install_menu_t,install_menu_exec_t,file,execute_no_trans).
access_vector(allow,install_menu_t,dpkg_exec_t,file,read).
access_vector(allow,install_menu_t,dpkg_exec_t,file,getattr).
access_vector(allow,install_menu_t,dpkg_exec_t,file,lock).
access_vector(allow,install_menu_t,dpkg_exec_t,file,execute).
access_vector(allow,install_menu_t,dpkg_exec_t,file,ioctl).
access_vector(allow,install_menu_t,dpkg_exec_t,file,execute_no_trans).
access_vector(allow,install_menu_t,install_menu_t,file,read).
access_vector(allow,install_menu_t,install_menu_t,file,getattr).
access_vector(allow,install_menu_t,install_menu_t,file,lock).
access_vector(allow,install_menu_t,install_menu_t,file,execute).
access_vector(allow,install_menu_t,install_menu_t,file,ioctl).
access_vector(allow,install_menu_t,install_menu_t,file,execute_no_trans).
access_vector(allow,install_menu_t,bin_t,dir,search).
access_vector(allow,install_menu_t,sbin_t,dir,search).
access_vector(allow,install_menu_t,bin_t,lnk_file,read).
access_vector(allow,install_menu_t,etc_t,file,read).
access_vector(allow,install_menu_t,etc_t,file,getattr).
access_vector(allow,install_menu_t,etc_t,file,lock).
access_vector(allow,install_menu_t,etc_t,file,execute).
access_vector(allow,install_menu_t,etc_t,file,ioctl).
access_vector(allow,install_menu_t,etc_t,file,execute_no_trans).
access_vector(allow,install_menu_t,var_t,dir,search).
type_decl(install_menu_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,install_menu_t,tmp_t,dir,read).
access_vector(allow,install_menu_t,tmp_t,dir,getattr).
access_vector(allow,install_menu_t,tmp_t,dir,lock).
access_vector(allow,install_menu_t,tmp_t,dir,search).
access_vector(allow,install_menu_t,tmp_t,dir,ioctl).
access_vector(allow,install_menu_t,tmp_t,dir,add_name).
access_vector(allow,install_menu_t,tmp_t,dir,remove_name).
access_vector(allow,install_menu_t,tmp_t,dir,write).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,create).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,ioctl).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,read).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,getattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,lock).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,write).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,setattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,append).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,link).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,unlink).
access_vector(allow,install_menu_t,install_menu_tmp_t,file,rename).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,create).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,ioctl).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,read).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,getattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,lock).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,write).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,setattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,append).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,link).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,unlink).
access_vector(allow,install_menu_t,install_menu_tmp_t,lnk_file,rename).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,create).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,ioctl).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,read).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,getattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,lock).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,write).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,setattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,append).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,link).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,unlink).
access_vector(allow,install_menu_t,install_menu_tmp_t,sock_file,rename).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,create).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,ioctl).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,read).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,getattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,lock).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,write).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,setattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,append).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,link).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,unlink).
access_vector(allow,install_menu_t,install_menu_tmp_t,fifo_file,rename).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,create).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,read).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,getattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,lock).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,setattr).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,link).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,unlink).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,rename).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,search).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,add_name).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,remove_name).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,reparent).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,write).
access_vector(allow,install_menu_t,install_menu_tmp_t,dir,rmdir).
type_trans(install_menu_t,tmp_t,dir,install_menu_tmp_t).
type_trans(install_menu_t,tmp_t,[file,lnk_file,sock_file,fifo_file],install_menu_tmp_t).
access_vector(allow,install_menu_t,var_lib_t,dir,create).
access_vector(allow,install_menu_t,var_lib_t,dir,read).
access_vector(allow,install_menu_t,var_lib_t,dir,getattr).
access_vector(allow,install_menu_t,var_lib_t,dir,lock).
access_vector(allow,install_menu_t,var_lib_t,dir,setattr).
access_vector(allow,install_menu_t,var_lib_t,dir,link).
access_vector(allow,install_menu_t,var_lib_t,dir,unlink).
access_vector(allow,install_menu_t,var_lib_t,dir,rename).
access_vector(allow,install_menu_t,var_lib_t,dir,search).
access_vector(allow,install_menu_t,var_lib_t,dir,add_name).
access_vector(allow,install_menu_t,var_lib_t,dir,remove_name).
access_vector(allow,install_menu_t,var_lib_t,dir,reparent).
access_vector(allow,install_menu_t,var_lib_t,dir,write).
access_vector(allow,install_menu_t,var_lib_t,dir,rmdir).
access_vector(allow,install_menu_t,var_lib_t,file,create).
access_vector(allow,install_menu_t,var_lib_t,file,ioctl).
access_vector(allow,install_menu_t,var_lib_t,file,read).
access_vector(allow,install_menu_t,var_lib_t,file,getattr).
access_vector(allow,install_menu_t,var_lib_t,file,lock).
access_vector(allow,install_menu_t,var_lib_t,file,write).
access_vector(allow,install_menu_t,var_lib_t,file,setattr).
access_vector(allow,install_menu_t,var_lib_t,file,append).
access_vector(allow,install_menu_t,var_lib_t,file,link).
access_vector(allow,install_menu_t,var_lib_t,file,unlink).
access_vector(allow,install_menu_t,var_lib_t,file,rename).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,create).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,ioctl).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,read).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,getattr).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,lock).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,write).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,setattr).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,append).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,link).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,unlink).
access_vector(allow,install_menu_t,var_lib_t,lnk_file,rename).
access_vector(allow,install_menu_t,var_spool_t,dir,read).
access_vector(allow,install_menu_t,var_spool_t,dir,getattr).
access_vector(allow,install_menu_t,var_spool_t,dir,lock).
access_vector(allow,install_menu_t,var_spool_t,dir,search).
access_vector(allow,install_menu_t,var_spool_t,dir,ioctl).
access_vector(allow,install_menu_t,var_spool_t,dir,add_name).
access_vector(allow,install_menu_t,var_spool_t,dir,remove_name).
access_vector(allow,install_menu_t,var_spool_t,dir,write).
access_vector(allow,install_menu_t,etc_t,dir,read).
access_vector(allow,install_menu_t,etc_t,dir,getattr).
access_vector(allow,install_menu_t,etc_t,dir,lock).
access_vector(allow,install_menu_t,etc_t,dir,search).
access_vector(allow,install_menu_t,etc_t,dir,ioctl).
access_vector(allow,install_menu_t,etc_t,dir,add_name).
access_vector(allow,install_menu_t,etc_t,dir,remove_name).
access_vector(allow,install_menu_t,etc_t,dir,write).
access_vector(allow,install_menu_t,var_spool_t,file,create).
access_vector(allow,install_menu_t,var_spool_t,file,ioctl).
access_vector(allow,install_menu_t,var_spool_t,file,read).
access_vector(allow,install_menu_t,var_spool_t,file,getattr).
access_vector(allow,install_menu_t,var_spool_t,file,lock).
access_vector(allow,install_menu_t,var_spool_t,file,write).
access_vector(allow,install_menu_t,var_spool_t,file,setattr).
access_vector(allow,install_menu_t,var_spool_t,file,append).
access_vector(allow,install_menu_t,var_spool_t,file,link).
access_vector(allow,install_menu_t,var_spool_t,file,unlink).
access_vector(allow,install_menu_t,var_spool_t,file,rename).
access_vector(allow,install_menu_t,etc_t,file,create).
access_vector(allow,install_menu_t,etc_t,file,ioctl).
access_vector(allow,install_menu_t,etc_t,file,read).
access_vector(allow,install_menu_t,etc_t,file,getattr).
access_vector(allow,install_menu_t,etc_t,file,lock).
access_vector(allow,install_menu_t,etc_t,file,write).
access_vector(allow,install_menu_t,etc_t,file,setattr).
access_vector(allow,install_menu_t,etc_t,file,append).
access_vector(allow,install_menu_t,etc_t,file,link).
access_vector(allow,install_menu_t,etc_t,file,unlink).
access_vector(allow,install_menu_t,etc_t,file,rename).
access_vector(allow,install_menu_t,self,fifo_file,ioctl).
access_vector(allow,install_menu_t,self,fifo_file,read).
access_vector(allow,install_menu_t,self,fifo_file,getattr).
access_vector(allow,install_menu_t,self,fifo_file,lock).
access_vector(allow,install_menu_t,self,fifo_file,write).
access_vector(allow,install_menu_t,self,fifo_file,append).
access_vector(allow,install_menu_t,etc_runtime_t,file,read).
access_vector(allow,install_menu_t,etc_runtime_t,file,getattr).
access_vector(allow,install_menu_t,etc_runtime_t,file,lock).
access_vector(allow,install_menu_t,etc_runtime_t,file,ioctl).
access_vector(allow,install_menu_t,devtty_t,chr_file,ioctl).
access_vector(allow,install_menu_t,devtty_t,chr_file,read).
access_vector(allow,install_menu_t,devtty_t,chr_file,getattr).
access_vector(allow,install_menu_t,devtty_t,chr_file,lock).
access_vector(allow,install_menu_t,devtty_t,chr_file,write).
access_vector(allow,install_menu_t,devtty_t,chr_file,append).
access_vector(allow,install_menu_t,fs_t,filesystem,getattr).
access_vector(allow,dpkg_t,install_menu_t,process,transition).
access_vector(dontaudit,dpkg_t,install_menu_t,process,noatsecure).
access_vector(allow,dpkg_t,install_menu_exec_t,file,read).
access_vector(allow,dpkg_t,install_menu_exec_t,file,getattr).
access_vector(allow,dpkg_t,install_menu_exec_t,file,execute).
access_vector(allow,install_menu_t,dpkg_t,process,sigchld).
access_vector(allow,install_menu_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,install_menu_t,fd,use).
access_vector(allow,install_menu_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,install_menu_t,dpkg_t,fifo_file,read).
access_vector(allow,install_menu_t,dpkg_t,fifo_file,getattr).
access_vector(allow,install_menu_t,dpkg_t,fifo_file,lock).
access_vector(allow,install_menu_t,dpkg_t,fifo_file,write).
access_vector(allow,install_menu_t,dpkg_t,fifo_file,append).
access_vector(allow,install_menu_t,install_menu_exec_t,file,read).
access_vector(allow,install_menu_t,install_menu_exec_t,file,getattr).
access_vector(allow,install_menu_t,install_menu_exec_t,file,lock).
access_vector(allow,install_menu_t,install_menu_exec_t,file,execute).
access_vector(allow,install_menu_t,install_menu_exec_t,file,ioctl).
access_vector(allow,install_menu_t,install_menu_exec_t,file,entrypoint).
type_trans(dpkg_t,install_menu_exec_t,process,install_menu_t).
access_vector(allow,dpkg_t,install_menu_t,process,sigchld).
access_vector(allow,dpkg_t,install_menu_t,process,sigkill).
access_vector(allow,dpkg_t,install_menu_t,process,sigstop).
access_vector(allow,dpkg_t,install_menu_t,process,signull).
access_vector(allow,dpkg_t,install_menu_t,process,signal).
access_vector(allow,install_menu_t,privfd,fd,use).
access_vector(allow,install_menu_t,root_t,dir,read).
access_vector(allow,install_menu_t,root_t,dir,getattr).
access_vector(allow,install_menu_t,root_t,dir,lock).
access_vector(allow,install_menu_t,root_t,dir,search).
access_vector(allow,install_menu_t,root_t,dir,ioctl).
access_vector(allow,install_menu_t,usr_t,dir,read).
access_vector(allow,install_menu_t,usr_t,dir,getattr).
access_vector(allow,install_menu_t,usr_t,dir,lock).
access_vector(allow,install_menu_t,usr_t,dir,search).
access_vector(allow,install_menu_t,usr_t,dir,ioctl).
access_vector(allow,install_menu_t,lib_t,dir,read).
access_vector(allow,install_menu_t,lib_t,dir,getattr).
access_vector(allow,install_menu_t,lib_t,dir,lock).
access_vector(allow,install_menu_t,lib_t,dir,search).
access_vector(allow,install_menu_t,lib_t,dir,ioctl).
access_vector(allow,install_menu_t,etc_t,dir,read).
access_vector(allow,install_menu_t,etc_t,dir,getattr).
access_vector(allow,install_menu_t,etc_t,dir,lock).
access_vector(allow,install_menu_t,etc_t,dir,search).
access_vector(allow,install_menu_t,etc_t,dir,ioctl).
access_vector(allow,install_menu_t,lib_t,lnk_file,read).
access_vector(allow,install_menu_t,lib_t,lnk_file,getattr).
access_vector(allow,install_menu_t,lib_t,lnk_file,lock).
access_vector(allow,install_menu_t,lib_t,lnk_file,ioctl).
access_vector(allow,install_menu_t,ld_so_t,file,read).
access_vector(allow,install_menu_t,ld_so_t,file,getattr).
access_vector(allow,install_menu_t,ld_so_t,file,lock).
access_vector(allow,install_menu_t,ld_so_t,file,execute).
access_vector(allow,install_menu_t,ld_so_t,file,ioctl).
access_vector(allow,install_menu_t,ld_so_t,file,execute_no_trans).
access_vector(allow,install_menu_t,ld_so_t,lnk_file,read).
access_vector(allow,install_menu_t,ld_so_t,lnk_file,getattr).
access_vector(allow,install_menu_t,ld_so_t,lnk_file,lock).
access_vector(allow,install_menu_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,install_menu_t,shlib_t,file,read).
access_vector(allow,install_menu_t,shlib_t,file,getattr).
access_vector(allow,install_menu_t,shlib_t,file,lock).
access_vector(allow,install_menu_t,shlib_t,file,execute).
access_vector(allow,install_menu_t,shlib_t,file,ioctl).
access_vector(allow,install_menu_t,shlib_t,lnk_file,read).
access_vector(allow,install_menu_t,shlib_t,lnk_file,getattr).
access_vector(allow,install_menu_t,shlib_t,lnk_file,lock).
access_vector(allow,install_menu_t,shlib_t,lnk_file,ioctl).
access_vector(allow,install_menu_t,ld_so_cache_t,file,read).
access_vector(allow,install_menu_t,ld_so_cache_t,file,getattr).
access_vector(allow,install_menu_t,ld_so_cache_t,file,lock).
access_vector(allow,install_menu_t,ld_so_cache_t,file,ioctl).
access_vector(allow,install_menu_t,device_t,dir,search).
access_vector(allow,install_menu_t,null_device_t,chr_file,ioctl).
access_vector(allow,install_menu_t,null_device_t,chr_file,read).
access_vector(allow,install_menu_t,null_device_t,chr_file,getattr).
access_vector(allow,install_menu_t,null_device_t,chr_file,lock).
access_vector(allow,install_menu_t,null_device_t,chr_file,write).
access_vector(allow,install_menu_t,null_device_t,chr_file,append).
access_vector(allow,install_menu_t,self,process,fork).
access_vector(allow,install_menu_t,self,process,sigchld).
role_decl(system_r,dpkg_t).
role_decl(system_r,apt_t).
role_decl(system_r,install_menu_t).
access_vector(allow,initrc_t,dpkg_t,process,transition).
access_vector(dontaudit,initrc_t,dpkg_t,process,noatsecure).
access_vector(allow,initrc_t,dpkg_exec_t,file,read).
access_vector(allow,initrc_t,dpkg_exec_t,file,getattr).
access_vector(allow,initrc_t,dpkg_exec_t,file,execute).
access_vector(allow,dpkg_t,initrc_t,process,sigchld).
access_vector(allow,dpkg_t,initrc_t,fd,use).
access_vector(allow,initrc_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,initrc_t,fifo_file,ioctl).
access_vector(allow,dpkg_t,initrc_t,fifo_file,read).
access_vector(allow,dpkg_t,initrc_t,fifo_file,getattr).
access_vector(allow,dpkg_t,initrc_t,fifo_file,lock).
access_vector(allow,dpkg_t,initrc_t,fifo_file,write).
access_vector(allow,dpkg_t,initrc_t,fifo_file,append).
access_vector(allow,dpkg_t,dpkg_exec_t,file,entrypoint).
type_trans(initrc_t,dpkg_exec_t,process,dpkg_t).
access_vector(allow,initrc_t,apt_t,process,transition).
access_vector(dontaudit,initrc_t,apt_t,process,noatsecure).
access_vector(allow,initrc_t,apt_exec_t,file,read).
access_vector(allow,initrc_t,apt_exec_t,file,getattr).
access_vector(allow,initrc_t,apt_exec_t,file,execute).
access_vector(allow,apt_t,initrc_t,process,sigchld).
access_vector(allow,apt_t,initrc_t,fd,use).
access_vector(allow,initrc_t,apt_t,fd,use).
access_vector(allow,apt_t,initrc_t,fifo_file,ioctl).
access_vector(allow,apt_t,initrc_t,fifo_file,read).
access_vector(allow,apt_t,initrc_t,fifo_file,getattr).
access_vector(allow,apt_t,initrc_t,fifo_file,lock).
access_vector(allow,apt_t,initrc_t,fifo_file,write).
access_vector(allow,apt_t,initrc_t,fifo_file,append).
access_vector(allow,apt_t,apt_exec_t,file,entrypoint).
type_trans(initrc_t,apt_exec_t,process,apt_t).
type_decl(fsadm_t,[],[domain,privlog]).
role_decl(system_r,fsadm_t).
role_decl(sysadm_r,fsadm_t).
access_vector(allow,fsadm_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,fsadm_t,self,dir,read).
access_vector(allow,fsadm_t,self,dir,getattr).
access_vector(allow,fsadm_t,self,dir,lock).
access_vector(allow,fsadm_t,self,dir,search).
access_vector(allow,fsadm_t,self,dir,ioctl).
access_vector(allow,fsadm_t,self,file,read).
access_vector(allow,fsadm_t,self,file,getattr).
access_vector(allow,fsadm_t,self,file,lock).
access_vector(allow,fsadm_t,self,file,ioctl).
access_vector(allow,fsadm_t,self,lnk_file,read).
access_vector(allow,fsadm_t,self,lnk_file,getattr).
access_vector(allow,fsadm_t,self,lnk_file,lock).
access_vector(allow,fsadm_t,self,lnk_file,ioctl).
access_vector(allow,fsadm_t,self,sock_file,read).
access_vector(allow,fsadm_t,self,sock_file,getattr).
access_vector(allow,fsadm_t,self,sock_file,lock).
access_vector(allow,fsadm_t,self,sock_file,ioctl).
access_vector(allow,fsadm_t,self,fifo_file,read).
access_vector(allow,fsadm_t,self,fifo_file,getattr).
access_vector(allow,fsadm_t,self,fifo_file,lock).
access_vector(allow,fsadm_t,self,fifo_file,ioctl).
access_vector(allow,fsadm_t,self,fd,_).
access_vector(allow,fsadm_t,self,fifo_file,ioctl).
access_vector(allow,fsadm_t,self,fifo_file,read).
access_vector(allow,fsadm_t,self,fifo_file,getattr).
access_vector(allow,fsadm_t,self,fifo_file,lock).
access_vector(allow,fsadm_t,self,fifo_file,write).
access_vector(allow,fsadm_t,self,fifo_file,append).
access_vector(allow,fsadm_t,self,unix_dgram_socket,create).
access_vector(allow,fsadm_t,self,unix_dgram_socket,ioctl).
access_vector(allow,fsadm_t,self,unix_dgram_socket,read).
access_vector(allow,fsadm_t,self,unix_dgram_socket,getattr).
access_vector(allow,fsadm_t,self,unix_dgram_socket,write).
access_vector(allow,fsadm_t,self,unix_dgram_socket,setattr).
access_vector(allow,fsadm_t,self,unix_dgram_socket,append).
access_vector(allow,fsadm_t,self,unix_dgram_socket,bind).
access_vector(allow,fsadm_t,self,unix_dgram_socket,connect).
access_vector(allow,fsadm_t,self,unix_dgram_socket,getopt).
access_vector(allow,fsadm_t,self,unix_dgram_socket,setopt).
access_vector(allow,fsadm_t,self,unix_dgram_socket,shutdown).
access_vector(allow,fsadm_t,self,unix_stream_socket,create).
access_vector(allow,fsadm_t,self,unix_stream_socket,ioctl).
access_vector(allow,fsadm_t,self,unix_stream_socket,read).
access_vector(allow,fsadm_t,self,unix_stream_socket,getattr).
access_vector(allow,fsadm_t,self,unix_stream_socket,write).
access_vector(allow,fsadm_t,self,unix_stream_socket,setattr).
access_vector(allow,fsadm_t,self,unix_stream_socket,append).
access_vector(allow,fsadm_t,self,unix_stream_socket,bind).
access_vector(allow,fsadm_t,self,unix_stream_socket,connect).
access_vector(allow,fsadm_t,self,unix_stream_socket,getopt).
access_vector(allow,fsadm_t,self,unix_stream_socket,setopt).
access_vector(allow,fsadm_t,self,unix_stream_socket,shutdown).
access_vector(allow,fsadm_t,self,unix_stream_socket,listen).
access_vector(allow,fsadm_t,self,unix_stream_socket,accept).
access_vector(allow,fsadm_t,self,unix_dgram_socket,sendto).
access_vector(allow,fsadm_t,self,unix_stream_socket,connectto).
access_vector(allow,fsadm_t,self,sem,associate).
access_vector(allow,fsadm_t,self,sem,getattr).
access_vector(allow,fsadm_t,self,sem,setattr).
access_vector(allow,fsadm_t,self,sem,create).
access_vector(allow,fsadm_t,self,sem,destroy).
access_vector(allow,fsadm_t,self,sem,read).
access_vector(allow,fsadm_t,self,sem,write).
access_vector(allow,fsadm_t,self,sem,unix_read).
access_vector(allow,fsadm_t,self,sem,unix_write).
access_vector(allow,fsadm_t,self,msg,send).
access_vector(allow,fsadm_t,self,msg,receive).
access_vector(allow,fsadm_t,self,msgq,associate).
access_vector(allow,fsadm_t,self,msgq,getattr).
access_vector(allow,fsadm_t,self,msgq,setattr).
access_vector(allow,fsadm_t,self,msgq,create).
access_vector(allow,fsadm_t,self,msgq,destroy).
access_vector(allow,fsadm_t,self,msgq,read).
access_vector(allow,fsadm_t,self,msgq,write).
access_vector(allow,fsadm_t,self,msgq,enqueue).
access_vector(allow,fsadm_t,self,msgq,unix_read).
access_vector(allow,fsadm_t,self,msgq,unix_write).
access_vector(allow,fsadm_t,self,shm,associate).
access_vector(allow,fsadm_t,self,shm,getattr).
access_vector(allow,fsadm_t,self,shm,setattr).
access_vector(allow,fsadm_t,self,shm,create).
access_vector(allow,fsadm_t,self,shm,destroy).
access_vector(allow,fsadm_t,self,shm,read).
access_vector(allow,fsadm_t,self,shm,write).
access_vector(allow,fsadm_t,self,shm,lock).
access_vector(allow,fsadm_t,self,shm,unix_read).
access_vector(allow,fsadm_t,self,shm,unix_write).
access_vector(allow,fsadm_t,proc_t,dir,read).
access_vector(allow,fsadm_t,proc_t,dir,getattr).
access_vector(allow,fsadm_t,proc_t,dir,lock).
access_vector(allow,fsadm_t,proc_t,dir,search).
access_vector(allow,fsadm_t,proc_t,dir,ioctl).
access_vector(allow,fsadm_t,proc_t,file,read).
access_vector(allow,fsadm_t,proc_t,file,getattr).
access_vector(allow,fsadm_t,proc_t,file,lock).
access_vector(allow,fsadm_t,proc_t,file,ioctl).
access_vector(allow,fsadm_t,proc_t,lnk_file,read).
access_vector(allow,fsadm_t,proc_t,lnk_file,getattr).
access_vector(allow,fsadm_t,proc_t,lnk_file,lock).
access_vector(allow,fsadm_t,proc_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,proc_t,sock_file,read).
access_vector(allow,fsadm_t,proc_t,sock_file,getattr).
access_vector(allow,fsadm_t,proc_t,sock_file,lock).
access_vector(allow,fsadm_t,proc_t,sock_file,ioctl).
access_vector(allow,fsadm_t,proc_t,fifo_file,read).
access_vector(allow,fsadm_t,proc_t,fifo_file,getattr).
access_vector(allow,fsadm_t,proc_t,fifo_file,lock).
access_vector(allow,fsadm_t,proc_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,sysctl_kernel_t,file,read).
access_vector(allow,fsadm_t,sysctl_kernel_t,file,getattr).
access_vector(allow,fsadm_t,sysctl_kernel_t,file,lock).
access_vector(allow,fsadm_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,fsadm_t,sysctl_kernel_t,dir,read).
access_vector(allow,fsadm_t,sysctl_kernel_t,dir,getattr).
access_vector(allow,fsadm_t,sysctl_kernel_t,dir,lock).
access_vector(allow,fsadm_t,sysctl_kernel_t,dir,search).
access_vector(allow,fsadm_t,sysctl_kernel_t,dir,ioctl).
access_vector(allow,fsadm_t,root_t,dir,read).
access_vector(allow,fsadm_t,root_t,dir,getattr).
access_vector(allow,fsadm_t,root_t,dir,lock).
access_vector(allow,fsadm_t,root_t,dir,search).
access_vector(allow,fsadm_t,root_t,dir,ioctl).
access_vector(allow,fsadm_t,root_t,file,read).
access_vector(allow,fsadm_t,root_t,file,getattr).
access_vector(allow,fsadm_t,root_t,file,lock).
access_vector(allow,fsadm_t,root_t,file,ioctl).
access_vector(allow,fsadm_t,root_t,lnk_file,read).
access_vector(allow,fsadm_t,root_t,lnk_file,getattr).
access_vector(allow,fsadm_t,root_t,lnk_file,lock).
access_vector(allow,fsadm_t,root_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,root_t,sock_file,read).
access_vector(allow,fsadm_t,root_t,sock_file,getattr).
access_vector(allow,fsadm_t,root_t,sock_file,lock).
access_vector(allow,fsadm_t,root_t,sock_file,ioctl).
access_vector(allow,fsadm_t,root_t,fifo_file,read).
access_vector(allow,fsadm_t,root_t,fifo_file,getattr).
access_vector(allow,fsadm_t,root_t,fifo_file,lock).
access_vector(allow,fsadm_t,root_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,home_root_t,dir,read).
access_vector(allow,fsadm_t,home_root_t,dir,getattr).
access_vector(allow,fsadm_t,home_root_t,dir,lock).
access_vector(allow,fsadm_t,home_root_t,dir,search).
access_vector(allow,fsadm_t,home_root_t,dir,ioctl).
access_vector(allow,fsadm_t,usr_t,dir,read).
access_vector(allow,fsadm_t,usr_t,dir,getattr).
access_vector(allow,fsadm_t,usr_t,dir,lock).
access_vector(allow,fsadm_t,usr_t,dir,search).
access_vector(allow,fsadm_t,usr_t,dir,ioctl).
access_vector(allow,fsadm_t,usr_t,file,read).
access_vector(allow,fsadm_t,usr_t,file,getattr).
access_vector(allow,fsadm_t,usr_t,file,lock).
access_vector(allow,fsadm_t,usr_t,file,ioctl).
access_vector(allow,fsadm_t,usr_t,lnk_file,read).
access_vector(allow,fsadm_t,usr_t,lnk_file,getattr).
access_vector(allow,fsadm_t,usr_t,lnk_file,lock).
access_vector(allow,fsadm_t,usr_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,usr_t,sock_file,read).
access_vector(allow,fsadm_t,usr_t,sock_file,getattr).
access_vector(allow,fsadm_t,usr_t,sock_file,lock).
access_vector(allow,fsadm_t,usr_t,sock_file,ioctl).
access_vector(allow,fsadm_t,usr_t,fifo_file,read).
access_vector(allow,fsadm_t,usr_t,fifo_file,getattr).
access_vector(allow,fsadm_t,usr_t,fifo_file,lock).
access_vector(allow,fsadm_t,usr_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,bin_t,dir,read).
access_vector(allow,fsadm_t,bin_t,dir,getattr).
access_vector(allow,fsadm_t,bin_t,dir,lock).
access_vector(allow,fsadm_t,bin_t,dir,search).
access_vector(allow,fsadm_t,bin_t,dir,ioctl).
access_vector(allow,fsadm_t,bin_t,file,read).
access_vector(allow,fsadm_t,bin_t,file,getattr).
access_vector(allow,fsadm_t,bin_t,file,lock).
access_vector(allow,fsadm_t,bin_t,file,ioctl).
access_vector(allow,fsadm_t,bin_t,lnk_file,read).
access_vector(allow,fsadm_t,bin_t,lnk_file,getattr).
access_vector(allow,fsadm_t,bin_t,lnk_file,lock).
access_vector(allow,fsadm_t,bin_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,bin_t,sock_file,read).
access_vector(allow,fsadm_t,bin_t,sock_file,getattr).
access_vector(allow,fsadm_t,bin_t,sock_file,lock).
access_vector(allow,fsadm_t,bin_t,sock_file,ioctl).
access_vector(allow,fsadm_t,bin_t,fifo_file,read).
access_vector(allow,fsadm_t,bin_t,fifo_file,getattr).
access_vector(allow,fsadm_t,bin_t,fifo_file,lock).
access_vector(allow,fsadm_t,bin_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,sbin_t,dir,read).
access_vector(allow,fsadm_t,sbin_t,dir,getattr).
access_vector(allow,fsadm_t,sbin_t,dir,lock).
access_vector(allow,fsadm_t,sbin_t,dir,search).
access_vector(allow,fsadm_t,sbin_t,dir,ioctl).
access_vector(allow,fsadm_t,sbin_t,file,read).
access_vector(allow,fsadm_t,sbin_t,file,getattr).
access_vector(allow,fsadm_t,sbin_t,file,lock).
access_vector(allow,fsadm_t,sbin_t,file,ioctl).
access_vector(allow,fsadm_t,sbin_t,lnk_file,read).
access_vector(allow,fsadm_t,sbin_t,lnk_file,getattr).
access_vector(allow,fsadm_t,sbin_t,lnk_file,lock).
access_vector(allow,fsadm_t,sbin_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,sbin_t,sock_file,read).
access_vector(allow,fsadm_t,sbin_t,sock_file,getattr).
access_vector(allow,fsadm_t,sbin_t,sock_file,lock).
access_vector(allow,fsadm_t,sbin_t,sock_file,ioctl).
access_vector(allow,fsadm_t,sbin_t,fifo_file,read).
access_vector(allow,fsadm_t,sbin_t,fifo_file,getattr).
access_vector(allow,fsadm_t,sbin_t,fifo_file,lock).
access_vector(allow,fsadm_t,sbin_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,etc_t,dir,read).
access_vector(allow,fsadm_t,etc_t,dir,getattr).
access_vector(allow,fsadm_t,etc_t,dir,lock).
access_vector(allow,fsadm_t,etc_t,dir,search).
access_vector(allow,fsadm_t,etc_t,dir,ioctl).
access_vector(allow,fsadm_t,etc_t,file,read).
access_vector(allow,fsadm_t,etc_t,file,getattr).
access_vector(allow,fsadm_t,etc_t,file,lock).
access_vector(allow,fsadm_t,etc_t,file,ioctl).
access_vector(allow,fsadm_t,etc_t,lnk_file,read).
access_vector(allow,fsadm_t,etc_t,lnk_file,getattr).
access_vector(allow,fsadm_t,etc_t,lnk_file,lock).
access_vector(allow,fsadm_t,etc_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,etc_t,sock_file,read).
access_vector(allow,fsadm_t,etc_t,sock_file,getattr).
access_vector(allow,fsadm_t,etc_t,sock_file,lock).
access_vector(allow,fsadm_t,etc_t,sock_file,ioctl).
access_vector(allow,fsadm_t,etc_t,fifo_file,read).
access_vector(allow,fsadm_t,etc_t,fifo_file,getattr).
access_vector(allow,fsadm_t,etc_t,fifo_file,lock).
access_vector(allow,fsadm_t,etc_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,modules_conf_t,file,read).
access_vector(allow,fsadm_t,modules_conf_t,file,getattr).
access_vector(allow,fsadm_t,modules_conf_t,file,lock).
access_vector(allow,fsadm_t,modules_conf_t,file,ioctl).
access_vector(allow,fsadm_t,modules_conf_t,lnk_file,read).
access_vector(allow,fsadm_t,modules_conf_t,lnk_file,getattr).
access_vector(allow,fsadm_t,modules_conf_t,lnk_file,lock).
access_vector(allow,fsadm_t,modules_conf_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,device_t,dir,read).
access_vector(allow,fsadm_t,device_t,dir,getattr).
access_vector(allow,fsadm_t,device_t,dir,lock).
access_vector(allow,fsadm_t,device_t,dir,search).
access_vector(allow,fsadm_t,device_t,dir,ioctl).
access_vector(allow,fsadm_t,device_t,lnk_file,read).
access_vector(allow,fsadm_t,device_t,lnk_file,getattr).
access_vector(allow,fsadm_t,device_t,lnk_file,lock).
access_vector(allow,fsadm_t,device_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,lib_t,dir,read).
access_vector(allow,fsadm_t,lib_t,dir,getattr).
access_vector(allow,fsadm_t,lib_t,dir,lock).
access_vector(allow,fsadm_t,lib_t,dir,search).
access_vector(allow,fsadm_t,lib_t,dir,ioctl).
access_vector(allow,fsadm_t,lib_t,lnk_file,read).
access_vector(allow,fsadm_t,lib_t,lnk_file,getattr).
access_vector(allow,fsadm_t,lib_t,lnk_file,lock).
access_vector(allow,fsadm_t,lib_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,ld_so_t,file,read).
access_vector(allow,fsadm_t,ld_so_t,file,getattr).
access_vector(allow,fsadm_t,ld_so_t,file,lock).
access_vector(allow,fsadm_t,ld_so_t,file,execute).
access_vector(allow,fsadm_t,ld_so_t,file,ioctl).
access_vector(allow,fsadm_t,ld_so_t,file,execute_no_trans).
access_vector(allow,fsadm_t,ld_so_t,lnk_file,read).
access_vector(allow,fsadm_t,ld_so_t,lnk_file,getattr).
access_vector(allow,fsadm_t,ld_so_t,lnk_file,lock).
access_vector(allow,fsadm_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,shlib_t,file,read).
access_vector(allow,fsadm_t,shlib_t,file,getattr).
access_vector(allow,fsadm_t,shlib_t,file,lock).
access_vector(allow,fsadm_t,shlib_t,file,execute).
access_vector(allow,fsadm_t,shlib_t,file,ioctl).
access_vector(allow,fsadm_t,shlib_t,lnk_file,read).
access_vector(allow,fsadm_t,shlib_t,lnk_file,getattr).
access_vector(allow,fsadm_t,shlib_t,lnk_file,lock).
access_vector(allow,fsadm_t,shlib_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,ld_so_cache_t,file,read).
access_vector(allow,fsadm_t,ld_so_cache_t,file,getattr).
access_vector(allow,fsadm_t,ld_so_cache_t,file,lock).
access_vector(allow,fsadm_t,ld_so_cache_t,file,ioctl).
access_vector(allow,fsadm_t,device_t,dir,search).
access_vector(allow,fsadm_t,null_device_t,chr_file,ioctl).
access_vector(allow,fsadm_t,null_device_t,chr_file,read).
access_vector(allow,fsadm_t,null_device_t,chr_file,getattr).
access_vector(allow,fsadm_t,null_device_t,chr_file,lock).
access_vector(allow,fsadm_t,null_device_t,chr_file,write).
access_vector(allow,fsadm_t,null_device_t,chr_file,append).
type_decl(fsadm_exec_t,[],[file_type,sysadmfile,exec_type]).
access_vector(allow,initrc_t,fsadm_t,process,transition).
access_vector(dontaudit,initrc_t,fsadm_t,process,noatsecure).
access_vector(allow,initrc_t,fsadm_exec_t,file,read).
access_vector(allow,initrc_t,fsadm_exec_t,file,getattr).
access_vector(allow,initrc_t,fsadm_exec_t,file,execute).
access_vector(allow,fsadm_t,initrc_t,process,sigchld).
access_vector(allow,fsadm_t,initrc_t,fd,use).
access_vector(allow,initrc_t,fsadm_t,fd,use).
access_vector(allow,fsadm_t,initrc_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,initrc_t,fifo_file,read).
access_vector(allow,fsadm_t,initrc_t,fifo_file,getattr).
access_vector(allow,fsadm_t,initrc_t,fifo_file,lock).
access_vector(allow,fsadm_t,initrc_t,fifo_file,write).
access_vector(allow,fsadm_t,initrc_t,fifo_file,append).
access_vector(allow,fsadm_t,fsadm_exec_t,file,read).
access_vector(allow,fsadm_t,fsadm_exec_t,file,getattr).
access_vector(allow,fsadm_t,fsadm_exec_t,file,lock).
access_vector(allow,fsadm_t,fsadm_exec_t,file,execute).
access_vector(allow,fsadm_t,fsadm_exec_t,file,ioctl).
access_vector(allow,fsadm_t,fsadm_exec_t,file,entrypoint).
type_trans(initrc_t,fsadm_exec_t,process,fsadm_t).
access_vector(allow,sysadm_t,fsadm_t,process,transition).
access_vector(dontaudit,sysadm_t,fsadm_t,process,noatsecure).
access_vector(allow,sysadm_t,fsadm_exec_t,file,read).
access_vector(allow,sysadm_t,fsadm_exec_t,file,getattr).
access_vector(allow,sysadm_t,fsadm_exec_t,file,execute).
access_vector(allow,fsadm_t,sysadm_t,process,sigchld).
access_vector(allow,fsadm_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,fsadm_t,fd,use).
access_vector(allow,fsadm_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,sysadm_t,fifo_file,read).
access_vector(allow,fsadm_t,sysadm_t,fifo_file,getattr).
access_vector(allow,fsadm_t,sysadm_t,fifo_file,lock).
access_vector(allow,fsadm_t,sysadm_t,fifo_file,write).
access_vector(allow,fsadm_t,sysadm_t,fifo_file,append).
access_vector(allow,fsadm_t,fsadm_exec_t,file,entrypoint).
type_trans(sysadm_t,fsadm_exec_t,process,fsadm_t).
type_decl(fsadm_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,fsadm_t,tmp_t,dir,read).
access_vector(allow,fsadm_t,tmp_t,dir,getattr).
access_vector(allow,fsadm_t,tmp_t,dir,lock).
access_vector(allow,fsadm_t,tmp_t,dir,search).
access_vector(allow,fsadm_t,tmp_t,dir,ioctl).
access_vector(allow,fsadm_t,tmp_t,dir,add_name).
access_vector(allow,fsadm_t,tmp_t,dir,remove_name).
access_vector(allow,fsadm_t,tmp_t,dir,write).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,create).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,ioctl).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,read).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,getattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,lock).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,write).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,setattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,append).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,link).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,unlink).
access_vector(allow,fsadm_t,fsadm_tmp_t,file,rename).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,create).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,read).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,getattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,lock).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,write).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,setattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,append).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,link).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,unlink).
access_vector(allow,fsadm_t,fsadm_tmp_t,lnk_file,rename).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,create).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,ioctl).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,read).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,getattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,lock).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,write).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,setattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,append).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,link).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,unlink).
access_vector(allow,fsadm_t,fsadm_tmp_t,sock_file,rename).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,create).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,read).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,getattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,lock).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,write).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,setattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,append).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,link).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,unlink).
access_vector(allow,fsadm_t,fsadm_tmp_t,fifo_file,rename).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,create).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,read).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,getattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,lock).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,setattr).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,link).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,unlink).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,rename).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,search).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,add_name).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,remove_name).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,reparent).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,write).
access_vector(allow,fsadm_t,fsadm_tmp_t,dir,rmdir).
type_trans(fsadm_t,tmp_t,dir,fsadm_tmp_t).
type_trans(fsadm_t,tmp_t,[file,lnk_file,sock_file,fifo_file],fsadm_tmp_t).
access_vector(allow,fsadm_t,fs_t,filesystem,remount).
access_vector(allow,fsadm_t,proc_t,filesystem,getattr).
access_vector(allow,fsadm_t,random_device_t,chr_file,getattr).
access_vector(allow,fsadm_t,random_device_t,chr_file,read).
access_vector(allow,fsadm_t,self,capability,ipc_lock).
access_vector(allow,fsadm_t,self,capability,sys_rawio).
access_vector(allow,fsadm_t,self,capability,sys_admin).
access_vector(allow,fsadm_t,etc_t,dir,read).
access_vector(allow,fsadm_t,etc_t,dir,getattr).
access_vector(allow,fsadm_t,etc_t,dir,lock).
access_vector(allow,fsadm_t,etc_t,dir,search).
access_vector(allow,fsadm_t,etc_t,dir,ioctl).
access_vector(allow,fsadm_t,etc_t,dir,add_name).
access_vector(allow,fsadm_t,etc_t,dir,remove_name).
access_vector(allow,fsadm_t,etc_t,dir,write).
access_vector(allow,fsadm_t,etc_runtime_t,file,create).
access_vector(allow,fsadm_t,etc_runtime_t,file,ioctl).
access_vector(allow,fsadm_t,etc_runtime_t,file,read).
access_vector(allow,fsadm_t,etc_runtime_t,file,getattr).
access_vector(allow,fsadm_t,etc_runtime_t,file,lock).
access_vector(allow,fsadm_t,etc_runtime_t,file,write).
access_vector(allow,fsadm_t,etc_runtime_t,file,setattr).
access_vector(allow,fsadm_t,etc_runtime_t,file,append).
access_vector(allow,fsadm_t,etc_runtime_t,file,link).
access_vector(allow,fsadm_t,etc_runtime_t,file,unlink).
access_vector(allow,fsadm_t,etc_runtime_t,file,rename).
type_trans(fsadm_t,etc_t,file,etc_runtime_t).
access_vector(allow,fsadm_t,init_t,fd,use).
access_vector(allow,fsadm_t,fsadm_exec_t,file,read).
access_vector(allow,fsadm_t,fsadm_exec_t,file,getattr).
access_vector(allow,fsadm_t,fsadm_exec_t,file,lock).
access_vector(allow,fsadm_t,fsadm_exec_t,file,execute).
access_vector(allow,fsadm_t,fsadm_exec_t,file,ioctl).
access_vector(allow,fsadm_t,fsadm_exec_t,file,execute_no_trans).
access_vector(allow,fsadm_t,fixed_disk_device_t,chr_file,ioctl).
access_vector(allow,fsadm_t,fixed_disk_device_t,chr_file,read).
access_vector(allow,fsadm_t,fixed_disk_device_t,chr_file,getattr).
access_vector(allow,fsadm_t,fixed_disk_device_t,chr_file,lock).
access_vector(allow,fsadm_t,fixed_disk_device_t,chr_file,write).
access_vector(allow,fsadm_t,fixed_disk_device_t,chr_file,append).
access_vector(allow,fsadm_t,fixed_disk_device_t,blk_file,ioctl).
access_vector(allow,fsadm_t,fixed_disk_device_t,blk_file,read).
access_vector(allow,fsadm_t,fixed_disk_device_t,blk_file,getattr).
access_vector(allow,fsadm_t,fixed_disk_device_t,blk_file,lock).
access_vector(allow,fsadm_t,fixed_disk_device_t,blk_file,write).
access_vector(allow,fsadm_t,fixed_disk_device_t,blk_file,append).
access_vector(allow,fsadm_t,removable_device_t,chr_file,ioctl).
access_vector(allow,fsadm_t,removable_device_t,chr_file,read).
access_vector(allow,fsadm_t,removable_device_t,chr_file,getattr).
access_vector(allow,fsadm_t,removable_device_t,chr_file,lock).
access_vector(allow,fsadm_t,removable_device_t,chr_file,write).
access_vector(allow,fsadm_t,removable_device_t,chr_file,append).
access_vector(allow,fsadm_t,removable_device_t,blk_file,ioctl).
access_vector(allow,fsadm_t,removable_device_t,blk_file,read).
access_vector(allow,fsadm_t,removable_device_t,blk_file,getattr).
access_vector(allow,fsadm_t,removable_device_t,blk_file,lock).
access_vector(allow,fsadm_t,removable_device_t,blk_file,write).
access_vector(allow,fsadm_t,removable_device_t,blk_file,append).
access_vector(allow,fsadm_t,lost_found_t,dir,create).
access_vector(allow,fsadm_t,lost_found_t,dir,read).
access_vector(allow,fsadm_t,lost_found_t,dir,getattr).
access_vector(allow,fsadm_t,lost_found_t,dir,lock).
access_vector(allow,fsadm_t,lost_found_t,dir,setattr).
access_vector(allow,fsadm_t,lost_found_t,dir,link).
access_vector(allow,fsadm_t,lost_found_t,dir,unlink).
access_vector(allow,fsadm_t,lost_found_t,dir,rename).
access_vector(allow,fsadm_t,lost_found_t,dir,search).
access_vector(allow,fsadm_t,lost_found_t,dir,add_name).
access_vector(allow,fsadm_t,lost_found_t,dir,remove_name).
access_vector(allow,fsadm_t,lost_found_t,dir,reparent).
access_vector(allow,fsadm_t,lost_found_t,dir,write).
access_vector(allow,fsadm_t,lost_found_t,dir,rmdir).
access_vector(allow,fsadm_t,lost_found_t,file,create).
access_vector(allow,fsadm_t,lost_found_t,file,ioctl).
access_vector(allow,fsadm_t,lost_found_t,file,read).
access_vector(allow,fsadm_t,lost_found_t,file,getattr).
access_vector(allow,fsadm_t,lost_found_t,file,lock).
access_vector(allow,fsadm_t,lost_found_t,file,write).
access_vector(allow,fsadm_t,lost_found_t,file,setattr).
access_vector(allow,fsadm_t,lost_found_t,file,append).
access_vector(allow,fsadm_t,lost_found_t,file,link).
access_vector(allow,fsadm_t,lost_found_t,file,unlink).
access_vector(allow,fsadm_t,lost_found_t,file,rename).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,create).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,ioctl).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,read).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,getattr).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,lock).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,write).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,setattr).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,append).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,link).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,unlink).
access_vector(allow,fsadm_t,lost_found_t,lnk_file,rename).
access_vector(allow,fsadm_t,lost_found_t,sock_file,create).
access_vector(allow,fsadm_t,lost_found_t,sock_file,ioctl).
access_vector(allow,fsadm_t,lost_found_t,sock_file,read).
access_vector(allow,fsadm_t,lost_found_t,sock_file,getattr).
access_vector(allow,fsadm_t,lost_found_t,sock_file,lock).
access_vector(allow,fsadm_t,lost_found_t,sock_file,write).
access_vector(allow,fsadm_t,lost_found_t,sock_file,setattr).
access_vector(allow,fsadm_t,lost_found_t,sock_file,append).
access_vector(allow,fsadm_t,lost_found_t,sock_file,link).
access_vector(allow,fsadm_t,lost_found_t,sock_file,unlink).
access_vector(allow,fsadm_t,lost_found_t,sock_file,rename).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,create).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,ioctl).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,read).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,getattr).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,lock).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,write).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,setattr).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,append).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,link).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,unlink).
access_vector(allow,fsadm_t,lost_found_t,fifo_file,rename).
access_vector(allow,fsadm_t,file_t,dir,search).
access_vector(allow,fsadm_t,file_t,dir,read).
access_vector(allow,fsadm_t,file_t,dir,getattr).
access_vector(allow,fsadm_t,file_t,dir,rmdir).
access_vector(allow,fsadm_t,file_t,dir,create).
access_vector(allow,fsadm_t,device_t,dir,read).
access_vector(allow,fsadm_t,device_t,dir,getattr).
access_vector(allow,fsadm_t,device_t,dir,lock).
access_vector(allow,fsadm_t,device_t,dir,search).
access_vector(allow,fsadm_t,device_t,dir,ioctl).
access_vector(allow,fsadm_t,device_t,dir,add_name).
access_vector(allow,fsadm_t,device_t,dir,remove_name).
access_vector(allow,fsadm_t,device_t,dir,write).
access_vector(allow,fsadm_t,device_t,lnk_file,unlink).
access_vector(allow,fsadm_t,device_t,lnk_file,create).
access_vector(allow,fsadm_t,swapfile_t,file,getattr).
access_vector(allow,fsadm_t,swapfile_t,file,swapon).
access_vector(allow,fsadm_t,fixed_disk_device_t,blk_file,getattr).
access_vector(allow,fsadm_t,fixed_disk_device_t,blk_file,swapon).
access_vector(allow,fsadm_t,insmod_t,process,transition).
access_vector(dontaudit,fsadm_t,insmod_t,process,noatsecure).
access_vector(allow,fsadm_t,insmod_exec_t,file,read).
access_vector(allow,fsadm_t,insmod_exec_t,file,getattr).
access_vector(allow,fsadm_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,fsadm_t,process,sigchld).
access_vector(allow,insmod_t,fsadm_t,fd,use).
access_vector(allow,fsadm_t,insmod_t,fd,use).
access_vector(allow,insmod_t,fsadm_t,fifo_file,ioctl).
access_vector(allow,insmod_t,fsadm_t,fifo_file,read).
access_vector(allow,insmod_t,fsadm_t,fifo_file,getattr).
access_vector(allow,insmod_t,fsadm_t,fifo_file,lock).
access_vector(allow,insmod_t,fsadm_t,fifo_file,write).
access_vector(allow,insmod_t,fsadm_t,fifo_file,append).
access_vector(allow,insmod_t,insmod_exec_t,file,entrypoint).
type_trans(fsadm_t,insmod_exec_t,process,insmod_t).
access_vector(allow,fsadm_t,kernel_t,system,syslog_console).
access_vector(allow,fsadm_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,fsadm_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,fsadm_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,fsadm_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,fsadm_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,fsadm_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,fsadm_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,fsadm_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,fsadm_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,fsadm_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,fsadm_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,fsadm_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,fsadm_t,privfd,fd,use).
access_vector(allow,fsadm_t,etc_t,lnk_file,read).
access_vector(allow,fsadm_t,locale_t,dir,read).
access_vector(allow,fsadm_t,locale_t,dir,getattr).
access_vector(allow,fsadm_t,locale_t,dir,lock).
access_vector(allow,fsadm_t,locale_t,dir,search).
access_vector(allow,fsadm_t,locale_t,dir,ioctl).
access_vector(allow,fsadm_t,locale_t,file,read).
access_vector(allow,fsadm_t,locale_t,file,getattr).
access_vector(allow,fsadm_t,locale_t,file,lock).
access_vector(allow,fsadm_t,locale_t,file,ioctl).
access_vector(allow,fsadm_t,locale_t,lnk_file,read).
access_vector(allow,fsadm_t,locale_t,lnk_file,getattr).
access_vector(allow,fsadm_t,locale_t,lnk_file,lock).
access_vector(allow,fsadm_t,locale_t,lnk_file,ioctl).
type_decl(getty_t,[],[domain,privlog,mlstrustedwriter,privfd]).
type_decl(getty_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(system_r,getty_t).
access_vector(allow,initrc_t,getty_t,process,transition).
access_vector(dontaudit,initrc_t,getty_t,process,noatsecure).
access_vector(allow,initrc_t,getty_exec_t,file,read).
access_vector(allow,initrc_t,getty_exec_t,file,getattr).
access_vector(allow,initrc_t,getty_exec_t,file,execute).
access_vector(allow,getty_t,initrc_t,process,sigchld).
access_vector(allow,getty_t,initrc_t,fd,use).
access_vector(allow,initrc_t,getty_t,fd,use).
access_vector(allow,getty_t,initrc_t,fifo_file,ioctl).
access_vector(allow,getty_t,initrc_t,fifo_file,read).
access_vector(allow,getty_t,initrc_t,fifo_file,getattr).
access_vector(allow,getty_t,initrc_t,fifo_file,lock).
access_vector(allow,getty_t,initrc_t,fifo_file,write).
access_vector(allow,getty_t,initrc_t,fifo_file,append).
access_vector(allow,getty_t,getty_exec_t,file,read).
access_vector(allow,getty_t,getty_exec_t,file,getattr).
access_vector(allow,getty_t,getty_exec_t,file,lock).
access_vector(allow,getty_t,getty_exec_t,file,execute).
access_vector(allow,getty_t,getty_exec_t,file,ioctl).
access_vector(allow,getty_t,getty_exec_t,file,entrypoint).
type_trans(initrc_t,getty_exec_t,process,getty_t).
access_vector(allow,getty_t,init_t,fd,use).
access_vector(allow,getty_t,init_t,process,sigchld).
access_vector(allow,getty_t,privfd,fd,use).
access_vector(allow,getty_t,newrole_t,process,sigchld).
access_vector(allow,getty_t,self,process,sigchld).
access_vector(allow,getty_t,self,process,sigkill).
access_vector(allow,getty_t,self,process,sigstop).
access_vector(allow,getty_t,self,process,signull).
access_vector(allow,getty_t,self,process,signal).
access_vector(allow,getty_t,self,process,fork).
access_vector(allow,getty_t,root_t,dir,read).
access_vector(allow,getty_t,root_t,dir,getattr).
access_vector(allow,getty_t,root_t,dir,lock).
access_vector(allow,getty_t,root_t,dir,search).
access_vector(allow,getty_t,root_t,dir,ioctl).
access_vector(allow,getty_t,usr_t,dir,read).
access_vector(allow,getty_t,usr_t,dir,getattr).
access_vector(allow,getty_t,usr_t,dir,lock).
access_vector(allow,getty_t,usr_t,dir,search).
access_vector(allow,getty_t,usr_t,dir,ioctl).
access_vector(allow,getty_t,lib_t,dir,read).
access_vector(allow,getty_t,lib_t,dir,getattr).
access_vector(allow,getty_t,lib_t,dir,lock).
access_vector(allow,getty_t,lib_t,dir,search).
access_vector(allow,getty_t,lib_t,dir,ioctl).
access_vector(allow,getty_t,etc_t,dir,read).
access_vector(allow,getty_t,etc_t,dir,getattr).
access_vector(allow,getty_t,etc_t,dir,lock).
access_vector(allow,getty_t,etc_t,dir,search).
access_vector(allow,getty_t,etc_t,dir,ioctl).
access_vector(allow,getty_t,lib_t,lnk_file,read).
access_vector(allow,getty_t,lib_t,lnk_file,getattr).
access_vector(allow,getty_t,lib_t,lnk_file,lock).
access_vector(allow,getty_t,lib_t,lnk_file,ioctl).
access_vector(allow,getty_t,ld_so_t,file,read).
access_vector(allow,getty_t,ld_so_t,file,getattr).
access_vector(allow,getty_t,ld_so_t,file,lock).
access_vector(allow,getty_t,ld_so_t,file,execute).
access_vector(allow,getty_t,ld_so_t,file,ioctl).
access_vector(allow,getty_t,ld_so_t,file,execute_no_trans).
access_vector(allow,getty_t,ld_so_t,lnk_file,read).
access_vector(allow,getty_t,ld_so_t,lnk_file,getattr).
access_vector(allow,getty_t,ld_so_t,lnk_file,lock).
access_vector(allow,getty_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,getty_t,shlib_t,file,read).
access_vector(allow,getty_t,shlib_t,file,getattr).
access_vector(allow,getty_t,shlib_t,file,lock).
access_vector(allow,getty_t,shlib_t,file,execute).
access_vector(allow,getty_t,shlib_t,file,ioctl).
access_vector(allow,getty_t,shlib_t,lnk_file,read).
access_vector(allow,getty_t,shlib_t,lnk_file,getattr).
access_vector(allow,getty_t,shlib_t,lnk_file,lock).
access_vector(allow,getty_t,shlib_t,lnk_file,ioctl).
access_vector(allow,getty_t,ld_so_cache_t,file,read).
access_vector(allow,getty_t,ld_so_cache_t,file,getattr).
access_vector(allow,getty_t,ld_so_cache_t,file,lock).
access_vector(allow,getty_t,ld_so_cache_t,file,ioctl).
access_vector(allow,getty_t,device_t,dir,search).
access_vector(allow,getty_t,null_device_t,chr_file,ioctl).
access_vector(allow,getty_t,null_device_t,chr_file,read).
access_vector(allow,getty_t,null_device_t,chr_file,getattr).
access_vector(allow,getty_t,null_device_t,chr_file,lock).
access_vector(allow,getty_t,null_device_t,chr_file,write).
access_vector(allow,getty_t,null_device_t,chr_file,append).
access_vector(allow,getty_t,self,dir,read).
access_vector(allow,getty_t,self,dir,getattr).
access_vector(allow,getty_t,self,dir,lock).
access_vector(allow,getty_t,self,dir,search).
access_vector(allow,getty_t,self,dir,ioctl).
access_vector(allow,getty_t,proc_t,dir,read).
access_vector(allow,getty_t,proc_t,dir,getattr).
access_vector(allow,getty_t,proc_t,dir,lock).
access_vector(allow,getty_t,proc_t,dir,search).
access_vector(allow,getty_t,proc_t,dir,ioctl).
access_vector(allow,getty_t,self,lnk_file,read).
access_vector(allow,getty_t,proc_t,lnk_file,read).
access_vector(allow,getty_t,device_t,dir,getattr).
access_vector(allow,getty_t,device_t,dir,search).
access_vector(allow,getty_t,console_device_t,chr_file,ioctl).
access_vector(allow,getty_t,console_device_t,chr_file,read).
access_vector(allow,getty_t,console_device_t,chr_file,getattr).
access_vector(allow,getty_t,console_device_t,chr_file,lock).
access_vector(allow,getty_t,console_device_t,chr_file,write).
access_vector(allow,getty_t,console_device_t,chr_file,append).
access_vector(allow,getty_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,getty_t,initrc_devpts_t,chr_file,read).
access_vector(allow,getty_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,getty_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,getty_t,initrc_devpts_t,chr_file,write).
access_vector(allow,getty_t,initrc_devpts_t,chr_file,append).
access_vector(allow,getty_t,var_t,dir,getattr).
access_vector(allow,getty_t,var_t,dir,search).
type_decl(getty_var_run_t,var_run_getty_t,[file_type,sysadmfile,pidfile]).
access_vector(allow,getty_t,var_run_t,dir,read).
access_vector(allow,getty_t,var_run_t,dir,getattr).
access_vector(allow,getty_t,var_run_t,dir,lock).
access_vector(allow,getty_t,var_run_t,dir,search).
access_vector(allow,getty_t,var_run_t,dir,ioctl).
access_vector(allow,getty_t,var_run_t,dir,add_name).
access_vector(allow,getty_t,var_run_t,dir,remove_name).
access_vector(allow,getty_t,var_run_t,dir,write).
access_vector(allow,getty_t,getty_var_run_t,file,create).
access_vector(allow,getty_t,getty_var_run_t,file,ioctl).
access_vector(allow,getty_t,getty_var_run_t,file,read).
access_vector(allow,getty_t,getty_var_run_t,file,getattr).
access_vector(allow,getty_t,getty_var_run_t,file,lock).
access_vector(allow,getty_t,getty_var_run_t,file,write).
access_vector(allow,getty_t,getty_var_run_t,file,setattr).
access_vector(allow,getty_t,getty_var_run_t,file,append).
access_vector(allow,getty_t,getty_var_run_t,file,link).
access_vector(allow,getty_t,getty_var_run_t,file,unlink).
access_vector(allow,getty_t,getty_var_run_t,file,rename).
type_trans(getty_t,var_run_t,file,getty_var_run_t).
access_vector(allow,getty_t,getty_var_run_t,dir,read).
access_vector(allow,getty_t,getty_var_run_t,dir,getattr).
access_vector(allow,getty_t,getty_var_run_t,dir,lock).
access_vector(allow,getty_t,getty_var_run_t,dir,search).
access_vector(allow,getty_t,getty_var_run_t,dir,ioctl).
access_vector(allow,getty_t,getty_var_run_t,dir,add_name).
access_vector(allow,getty_t,getty_var_run_t,dir,remove_name).
access_vector(allow,getty_t,getty_var_run_t,dir,write).
access_vector(allow,getty_t,devtty_t,chr_file,ioctl).
access_vector(allow,getty_t,devtty_t,chr_file,read).
access_vector(allow,getty_t,devtty_t,chr_file,getattr).
access_vector(allow,getty_t,devtty_t,chr_file,lock).
access_vector(allow,getty_t,devtty_t,chr_file,write).
access_vector(allow,getty_t,devtty_t,chr_file,append).
access_vector(dontaudit,getty_t,sysadm_home_dir_t,dir,search).
access_vector(allow,getty_t,fs_type,filesystem,getattr).
access_vector(allow,getty_t,etc_t,lnk_file,read).
access_vector(allow,getty_t,locale_t,dir,read).
access_vector(allow,getty_t,locale_t,dir,getattr).
access_vector(allow,getty_t,locale_t,dir,lock).
access_vector(allow,getty_t,locale_t,dir,search).
access_vector(allow,getty_t,locale_t,dir,ioctl).
access_vector(allow,getty_t,locale_t,file,read).
access_vector(allow,getty_t,locale_t,file,getattr).
access_vector(allow,getty_t,locale_t,file,lock).
access_vector(allow,getty_t,locale_t,file,ioctl).
access_vector(allow,getty_t,locale_t,lnk_file,read).
access_vector(allow,getty_t,locale_t,lnk_file,getattr).
access_vector(allow,getty_t,locale_t,lnk_file,lock).
access_vector(allow,getty_t,locale_t,lnk_file,ioctl).
type_decl(etc_getty_t,[],[file_type,sysadmfile]).
access_vector(allow,getty_t,etc_getty_t,dir,read).
access_vector(allow,getty_t,etc_getty_t,dir,getattr).
access_vector(allow,getty_t,etc_getty_t,dir,lock).
access_vector(allow,getty_t,etc_getty_t,dir,search).
access_vector(allow,getty_t,etc_getty_t,dir,ioctl).
access_vector(allow,getty_t,etc_getty_t,file,read).
access_vector(allow,getty_t,etc_getty_t,file,getattr).
access_vector(allow,getty_t,etc_getty_t,file,lock).
access_vector(allow,getty_t,etc_getty_t,file,ioctl).
access_vector(allow,getty_t,etc_getty_t,lnk_file,read).
access_vector(allow,getty_t,etc_getty_t,lnk_file,getattr).
access_vector(allow,getty_t,etc_getty_t,lnk_file,lock).
access_vector(allow,getty_t,etc_getty_t,lnk_file,ioctl).
access_vector(allow,getty_t,console_device_t,chr_file,setattr).
type_decl(getty_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,getty_t,tmp_t,dir,read).
access_vector(allow,getty_t,tmp_t,dir,getattr).
access_vector(allow,getty_t,tmp_t,dir,lock).
access_vector(allow,getty_t,tmp_t,dir,search).
access_vector(allow,getty_t,tmp_t,dir,ioctl).
access_vector(allow,getty_t,tmp_t,dir,add_name).
access_vector(allow,getty_t,tmp_t,dir,remove_name).
access_vector(allow,getty_t,tmp_t,dir,write).
access_vector(allow,getty_t,getty_tmp_t,file,create).
access_vector(allow,getty_t,getty_tmp_t,file,ioctl).
access_vector(allow,getty_t,getty_tmp_t,file,read).
access_vector(allow,getty_t,getty_tmp_t,file,getattr).
access_vector(allow,getty_t,getty_tmp_t,file,lock).
access_vector(allow,getty_t,getty_tmp_t,file,write).
access_vector(allow,getty_t,getty_tmp_t,file,setattr).
access_vector(allow,getty_t,getty_tmp_t,file,append).
access_vector(allow,getty_t,getty_tmp_t,file,link).
access_vector(allow,getty_t,getty_tmp_t,file,unlink).
access_vector(allow,getty_t,getty_tmp_t,file,rename).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,create).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,ioctl).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,read).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,getattr).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,lock).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,write).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,setattr).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,append).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,link).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,unlink).
access_vector(allow,getty_t,getty_tmp_t,lnk_file,rename).
access_vector(allow,getty_t,getty_tmp_t,sock_file,create).
access_vector(allow,getty_t,getty_tmp_t,sock_file,ioctl).
access_vector(allow,getty_t,getty_tmp_t,sock_file,read).
access_vector(allow,getty_t,getty_tmp_t,sock_file,getattr).
access_vector(allow,getty_t,getty_tmp_t,sock_file,lock).
access_vector(allow,getty_t,getty_tmp_t,sock_file,write).
access_vector(allow,getty_t,getty_tmp_t,sock_file,setattr).
access_vector(allow,getty_t,getty_tmp_t,sock_file,append).
access_vector(allow,getty_t,getty_tmp_t,sock_file,link).
access_vector(allow,getty_t,getty_tmp_t,sock_file,unlink).
access_vector(allow,getty_t,getty_tmp_t,sock_file,rename).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,create).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,ioctl).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,read).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,getattr).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,lock).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,write).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,setattr).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,append).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,link).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,unlink).
access_vector(allow,getty_t,getty_tmp_t,fifo_file,rename).
access_vector(allow,getty_t,getty_tmp_t,dir,create).
access_vector(allow,getty_t,getty_tmp_t,dir,read).
access_vector(allow,getty_t,getty_tmp_t,dir,getattr).
access_vector(allow,getty_t,getty_tmp_t,dir,lock).
access_vector(allow,getty_t,getty_tmp_t,dir,setattr).
access_vector(allow,getty_t,getty_tmp_t,dir,link).
access_vector(allow,getty_t,getty_tmp_t,dir,unlink).
access_vector(allow,getty_t,getty_tmp_t,dir,rename).
access_vector(allow,getty_t,getty_tmp_t,dir,search).
access_vector(allow,getty_t,getty_tmp_t,dir,add_name).
access_vector(allow,getty_t,getty_tmp_t,dir,remove_name).
access_vector(allow,getty_t,getty_tmp_t,dir,reparent).
access_vector(allow,getty_t,getty_tmp_t,dir,write).
access_vector(allow,getty_t,getty_tmp_t,dir,rmdir).
type_trans(getty_t,tmp_t,dir,getty_tmp_t).
type_trans(getty_t,tmp_t,[file,lnk_file,sock_file,fifo_file],getty_tmp_t).
type_decl(getty_log_t,[],[file_type,sysadmfile,logfile]).
access_vector(allow,getty_t,var_log_t,dir,read).
access_vector(allow,getty_t,var_log_t,dir,getattr).
access_vector(allow,getty_t,var_log_t,dir,lock).
access_vector(allow,getty_t,var_log_t,dir,search).
access_vector(allow,getty_t,var_log_t,dir,ioctl).
access_vector(allow,getty_t,var_log_t,dir,add_name).
access_vector(allow,getty_t,var_log_t,dir,remove_name).
access_vector(allow,getty_t,var_log_t,dir,write).
access_vector(allow,getty_t,getty_log_t,file,create).
access_vector(allow,getty_t,getty_log_t,file,ioctl).
access_vector(allow,getty_t,getty_log_t,file,read).
access_vector(allow,getty_t,getty_log_t,file,getattr).
access_vector(allow,getty_t,getty_log_t,file,lock).
access_vector(allow,getty_t,getty_log_t,file,write).
access_vector(allow,getty_t,getty_log_t,file,setattr).
access_vector(allow,getty_t,getty_log_t,file,append).
access_vector(allow,getty_t,getty_log_t,file,link).
access_vector(allow,getty_t,getty_log_t,file,unlink).
access_vector(allow,getty_t,getty_log_t,file,rename).
access_vector(allow,getty_t,getty_log_t,lnk_file,create).
access_vector(allow,getty_t,getty_log_t,lnk_file,ioctl).
access_vector(allow,getty_t,getty_log_t,lnk_file,read).
access_vector(allow,getty_t,getty_log_t,lnk_file,getattr).
access_vector(allow,getty_t,getty_log_t,lnk_file,lock).
access_vector(allow,getty_t,getty_log_t,lnk_file,write).
access_vector(allow,getty_t,getty_log_t,lnk_file,setattr).
access_vector(allow,getty_t,getty_log_t,lnk_file,append).
access_vector(allow,getty_t,getty_log_t,lnk_file,link).
access_vector(allow,getty_t,getty_log_t,lnk_file,unlink).
access_vector(allow,getty_t,getty_log_t,lnk_file,rename).
access_vector(allow,getty_t,getty_log_t,sock_file,create).
access_vector(allow,getty_t,getty_log_t,sock_file,ioctl).
access_vector(allow,getty_t,getty_log_t,sock_file,read).
access_vector(allow,getty_t,getty_log_t,sock_file,getattr).
access_vector(allow,getty_t,getty_log_t,sock_file,lock).
access_vector(allow,getty_t,getty_log_t,sock_file,write).
access_vector(allow,getty_t,getty_log_t,sock_file,setattr).
access_vector(allow,getty_t,getty_log_t,sock_file,append).
access_vector(allow,getty_t,getty_log_t,sock_file,link).
access_vector(allow,getty_t,getty_log_t,sock_file,unlink).
access_vector(allow,getty_t,getty_log_t,sock_file,rename).
access_vector(allow,getty_t,getty_log_t,fifo_file,create).
access_vector(allow,getty_t,getty_log_t,fifo_file,ioctl).
access_vector(allow,getty_t,getty_log_t,fifo_file,read).
access_vector(allow,getty_t,getty_log_t,fifo_file,getattr).
access_vector(allow,getty_t,getty_log_t,fifo_file,lock).
access_vector(allow,getty_t,getty_log_t,fifo_file,write).
access_vector(allow,getty_t,getty_log_t,fifo_file,setattr).
access_vector(allow,getty_t,getty_log_t,fifo_file,append).
access_vector(allow,getty_t,getty_log_t,fifo_file,link).
access_vector(allow,getty_t,getty_log_t,fifo_file,unlink).
access_vector(allow,getty_t,getty_log_t,fifo_file,rename).
access_vector(allow,getty_t,getty_log_t,dir,create).
access_vector(allow,getty_t,getty_log_t,dir,read).
access_vector(allow,getty_t,getty_log_t,dir,getattr).
access_vector(allow,getty_t,getty_log_t,dir,lock).
access_vector(allow,getty_t,getty_log_t,dir,setattr).
access_vector(allow,getty_t,getty_log_t,dir,link).
access_vector(allow,getty_t,getty_log_t,dir,unlink).
access_vector(allow,getty_t,getty_log_t,dir,rename).
access_vector(allow,getty_t,getty_log_t,dir,search).
access_vector(allow,getty_t,getty_log_t,dir,add_name).
access_vector(allow,getty_t,getty_log_t,dir,remove_name).
access_vector(allow,getty_t,getty_log_t,dir,reparent).
access_vector(allow,getty_t,getty_log_t,dir,write).
access_vector(allow,getty_t,getty_log_t,dir,rmdir).
type_trans(getty_t,var_log_t,dir,getty_log_t).
type_trans(getty_t,var_log_t,[file,lnk_file,sock_file,fifo_file],getty_log_t).
access_vector(allow,getty_t,etc_t,file,getattr).
access_vector(allow,getty_t,etc_t,file,read).
access_vector(allow,getty_t,etc_runtime_t,file,getattr).
access_vector(allow,getty_t,etc_runtime_t,file,read).
access_vector(allow,getty_t,etc_t,lnk_file,read).
access_vector(allow,getty_t,self,process,getpgid).
access_vector(allow,getty_t,self,process,getsession).
access_vector(allow,getty_t,self,unix_dgram_socket,create).
access_vector(allow,getty_t,self,unix_dgram_socket,ioctl).
access_vector(allow,getty_t,self,unix_dgram_socket,read).
access_vector(allow,getty_t,self,unix_dgram_socket,getattr).
access_vector(allow,getty_t,self,unix_dgram_socket,write).
access_vector(allow,getty_t,self,unix_dgram_socket,setattr).
access_vector(allow,getty_t,self,unix_dgram_socket,append).
access_vector(allow,getty_t,self,unix_dgram_socket,bind).
access_vector(allow,getty_t,self,unix_dgram_socket,connect).
access_vector(allow,getty_t,self,unix_dgram_socket,getopt).
access_vector(allow,getty_t,self,unix_dgram_socket,setopt).
access_vector(allow,getty_t,self,unix_dgram_socket,shutdown).
access_vector(allow,getty_t,self,unix_stream_socket,create).
access_vector(allow,getty_t,self,unix_stream_socket,ioctl).
access_vector(allow,getty_t,self,unix_stream_socket,read).
access_vector(allow,getty_t,self,unix_stream_socket,getattr).
access_vector(allow,getty_t,self,unix_stream_socket,write).
access_vector(allow,getty_t,self,unix_stream_socket,setattr).
access_vector(allow,getty_t,self,unix_stream_socket,append).
access_vector(allow,getty_t,self,unix_stream_socket,bind).
access_vector(allow,getty_t,self,unix_stream_socket,connect).
access_vector(allow,getty_t,self,unix_stream_socket,getopt).
access_vector(allow,getty_t,self,unix_stream_socket,setopt).
access_vector(allow,getty_t,self,unix_stream_socket,shutdown).
access_vector(allow,getty_t,resolv_conf_t,file,getattr).
access_vector(allow,getty_t,resolv_conf_t,file,read).
access_vector(allow,getty_t,getty_t,capability,dac_override).
access_vector(allow,getty_t,getty_t,capability,chown).
access_vector(allow,getty_t,getty_t,capability,sys_tty_config).
access_vector(allow,getty_t,getty_t,capability,fsetid).
access_vector(allow,init_t,getty_t,process,transition).
access_vector(dontaudit,init_t,getty_t,process,noatsecure).
access_vector(allow,init_t,getty_exec_t,file,read).
access_vector(allow,init_t,getty_exec_t,file,getattr).
access_vector(allow,init_t,getty_exec_t,file,execute).
access_vector(allow,getty_t,init_t,process,sigchld).
access_vector(allow,getty_t,init_t,fd,use).
access_vector(allow,init_t,getty_t,fd,use).
access_vector(allow,getty_t,init_t,fifo_file,ioctl).
access_vector(allow,getty_t,init_t,fifo_file,read).
access_vector(allow,getty_t,init_t,fifo_file,getattr).
access_vector(allow,getty_t,init_t,fifo_file,lock).
access_vector(allow,getty_t,init_t,fifo_file,write).
access_vector(allow,getty_t,init_t,fifo_file,append).
access_vector(allow,getty_t,getty_exec_t,file,entrypoint).
type_trans(init_t,getty_exec_t,process,getty_t).
access_vector(allow,getty_t,init_t,fd,use).
access_vector(allow,getty_t,bin_t,dir,search).
access_vector(allow,getty_t,local_login_t,process,transition).
access_vector(dontaudit,getty_t,local_login_t,process,noatsecure).
access_vector(allow,getty_t,login_exec_t,file,read).
access_vector(allow,getty_t,login_exec_t,file,getattr).
access_vector(allow,getty_t,login_exec_t,file,execute).
access_vector(allow,local_login_t,getty_t,process,sigchld).
access_vector(allow,local_login_t,getty_t,fd,use).
access_vector(allow,getty_t,local_login_t,fd,use).
access_vector(allow,local_login_t,getty_t,fifo_file,ioctl).
access_vector(allow,local_login_t,getty_t,fifo_file,read).
access_vector(allow,local_login_t,getty_t,fifo_file,getattr).
access_vector(allow,local_login_t,getty_t,fifo_file,lock).
access_vector(allow,local_login_t,getty_t,fifo_file,write).
access_vector(allow,local_login_t,getty_t,fifo_file,append).
access_vector(allow,local_login_t,login_exec_t,file,read).
access_vector(allow,local_login_t,login_exec_t,file,getattr).
access_vector(allow,local_login_t,login_exec_t,file,lock).
access_vector(allow,local_login_t,login_exec_t,file,execute).
access_vector(allow,local_login_t,login_exec_t,file,ioctl).
access_vector(allow,local_login_t,login_exec_t,file,entrypoint).
type_trans(getty_t,login_exec_t,process,local_login_t).
access_vector(allow,getty_t,initrc_var_run_t,file,ioctl).
access_vector(allow,getty_t,initrc_var_run_t,file,read).
access_vector(allow,getty_t,initrc_var_run_t,file,getattr).
access_vector(allow,getty_t,initrc_var_run_t,file,lock).
access_vector(allow,getty_t,initrc_var_run_t,file,write).
access_vector(allow,getty_t,initrc_var_run_t,file,append).
access_vector(allow,getty_t,wtmp_t,file,ioctl).
access_vector(allow,getty_t,wtmp_t,file,read).
access_vector(allow,getty_t,wtmp_t,file,getattr).
access_vector(allow,getty_t,wtmp_t,file,lock).
access_vector(allow,getty_t,wtmp_t,file,write).
access_vector(allow,getty_t,wtmp_t,file,append).
access_vector(allow,getty_t,tty_device_t,chr_file,setattr).
access_vector(allow,getty_t,tty_device_t,chr_file,ioctl).
access_vector(allow,getty_t,tty_device_t,chr_file,read).
access_vector(allow,getty_t,tty_device_t,chr_file,getattr).
access_vector(allow,getty_t,tty_device_t,chr_file,lock).
access_vector(allow,getty_t,tty_device_t,chr_file,write).
access_vector(allow,getty_t,tty_device_t,chr_file,append).
access_vector(allow,getty_t,ttyfile,chr_file,setattr).
access_vector(allow,getty_t,ttyfile,chr_file,ioctl).
access_vector(allow,getty_t,ttyfile,chr_file,read).
access_vector(allow,getty_t,ttyfile,chr_file,getattr).
access_vector(allow,getty_t,ttyfile,chr_file,lock).
access_vector(allow,getty_t,ttyfile,chr_file,write).
access_vector(allow,getty_t,ttyfile,chr_file,append).
access_vector(allow,getty_t,var_lock_t,dir,read).
access_vector(allow,getty_t,var_lock_t,dir,getattr).
access_vector(allow,getty_t,var_lock_t,dir,lock).
access_vector(allow,getty_t,var_lock_t,dir,search).
access_vector(allow,getty_t,var_lock_t,dir,ioctl).
access_vector(allow,getty_t,var_lock_t,dir,add_name).
access_vector(allow,getty_t,var_lock_t,dir,remove_name).
access_vector(allow,getty_t,var_lock_t,dir,write).
access_vector(allow,getty_t,var_lock_t,file,create).
access_vector(allow,getty_t,var_lock_t,file,ioctl).
access_vector(allow,getty_t,var_lock_t,file,read).
access_vector(allow,getty_t,var_lock_t,file,getattr).
access_vector(allow,getty_t,var_lock_t,file,lock).
access_vector(allow,getty_t,var_lock_t,file,write).
access_vector(allow,getty_t,var_lock_t,file,setattr).
access_vector(allow,getty_t,var_lock_t,file,append).
access_vector(allow,getty_t,var_lock_t,file,link).
access_vector(allow,getty_t,var_lock_t,file,unlink).
access_vector(allow,getty_t,var_lock_t,file,rename).
access_vector(allow,getty_t,var_lock_t,lnk_file,create).
access_vector(allow,getty_t,var_lock_t,lnk_file,ioctl).
access_vector(allow,getty_t,var_lock_t,lnk_file,read).
access_vector(allow,getty_t,var_lock_t,lnk_file,getattr).
access_vector(allow,getty_t,var_lock_t,lnk_file,lock).
access_vector(allow,getty_t,var_lock_t,lnk_file,write).
access_vector(allow,getty_t,var_lock_t,lnk_file,setattr).
access_vector(allow,getty_t,var_lock_t,lnk_file,append).
access_vector(allow,getty_t,var_lock_t,lnk_file,link).
access_vector(allow,getty_t,var_lock_t,lnk_file,unlink).
access_vector(allow,getty_t,var_lock_t,lnk_file,rename).
type_decl(ifconfig_t,[],[domain,privlog]).
type_decl(ifconfig_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(system_r,ifconfig_t).
role_decl(sysadm_r,ifconfig_t).
access_vector(allow,ifconfig_t,root_t,dir,read).
access_vector(allow,ifconfig_t,root_t,dir,getattr).
access_vector(allow,ifconfig_t,root_t,dir,lock).
access_vector(allow,ifconfig_t,root_t,dir,search).
access_vector(allow,ifconfig_t,root_t,dir,ioctl).
access_vector(allow,ifconfig_t,usr_t,dir,read).
access_vector(allow,ifconfig_t,usr_t,dir,getattr).
access_vector(allow,ifconfig_t,usr_t,dir,lock).
access_vector(allow,ifconfig_t,usr_t,dir,search).
access_vector(allow,ifconfig_t,usr_t,dir,ioctl).
access_vector(allow,ifconfig_t,lib_t,dir,read).
access_vector(allow,ifconfig_t,lib_t,dir,getattr).
access_vector(allow,ifconfig_t,lib_t,dir,lock).
access_vector(allow,ifconfig_t,lib_t,dir,search).
access_vector(allow,ifconfig_t,lib_t,dir,ioctl).
access_vector(allow,ifconfig_t,etc_t,dir,read).
access_vector(allow,ifconfig_t,etc_t,dir,getattr).
access_vector(allow,ifconfig_t,etc_t,dir,lock).
access_vector(allow,ifconfig_t,etc_t,dir,search).
access_vector(allow,ifconfig_t,etc_t,dir,ioctl).
access_vector(allow,ifconfig_t,lib_t,lnk_file,read).
access_vector(allow,ifconfig_t,lib_t,lnk_file,getattr).
access_vector(allow,ifconfig_t,lib_t,lnk_file,lock).
access_vector(allow,ifconfig_t,lib_t,lnk_file,ioctl).
access_vector(allow,ifconfig_t,ld_so_t,file,read).
access_vector(allow,ifconfig_t,ld_so_t,file,getattr).
access_vector(allow,ifconfig_t,ld_so_t,file,lock).
access_vector(allow,ifconfig_t,ld_so_t,file,execute).
access_vector(allow,ifconfig_t,ld_so_t,file,ioctl).
access_vector(allow,ifconfig_t,ld_so_t,file,execute_no_trans).
access_vector(allow,ifconfig_t,ld_so_t,lnk_file,read).
access_vector(allow,ifconfig_t,ld_so_t,lnk_file,getattr).
access_vector(allow,ifconfig_t,ld_so_t,lnk_file,lock).
access_vector(allow,ifconfig_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,ifconfig_t,shlib_t,file,read).
access_vector(allow,ifconfig_t,shlib_t,file,getattr).
access_vector(allow,ifconfig_t,shlib_t,file,lock).
access_vector(allow,ifconfig_t,shlib_t,file,execute).
access_vector(allow,ifconfig_t,shlib_t,file,ioctl).
access_vector(allow,ifconfig_t,shlib_t,lnk_file,read).
access_vector(allow,ifconfig_t,shlib_t,lnk_file,getattr).
access_vector(allow,ifconfig_t,shlib_t,lnk_file,lock).
access_vector(allow,ifconfig_t,shlib_t,lnk_file,ioctl).
access_vector(allow,ifconfig_t,ld_so_cache_t,file,read).
access_vector(allow,ifconfig_t,ld_so_cache_t,file,getattr).
access_vector(allow,ifconfig_t,ld_so_cache_t,file,lock).
access_vector(allow,ifconfig_t,ld_so_cache_t,file,ioctl).
access_vector(allow,ifconfig_t,device_t,dir,search).
access_vector(allow,ifconfig_t,null_device_t,chr_file,ioctl).
access_vector(allow,ifconfig_t,null_device_t,chr_file,read).
access_vector(allow,ifconfig_t,null_device_t,chr_file,getattr).
access_vector(allow,ifconfig_t,null_device_t,chr_file,lock).
access_vector(allow,ifconfig_t,null_device_t,chr_file,write).
access_vector(allow,ifconfig_t,null_device_t,chr_file,append).
access_vector(allow,ifconfig_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,ifconfig_t,self,dir,read).
access_vector(allow,ifconfig_t,self,dir,getattr).
access_vector(allow,ifconfig_t,self,dir,lock).
access_vector(allow,ifconfig_t,self,dir,search).
access_vector(allow,ifconfig_t,self,dir,ioctl).
access_vector(allow,ifconfig_t,self,file,read).
access_vector(allow,ifconfig_t,self,file,getattr).
access_vector(allow,ifconfig_t,self,file,lock).
access_vector(allow,ifconfig_t,self,file,ioctl).
access_vector(allow,ifconfig_t,self,lnk_file,read).
access_vector(allow,ifconfig_t,self,lnk_file,getattr).
access_vector(allow,ifconfig_t,self,lnk_file,lock).
access_vector(allow,ifconfig_t,self,lnk_file,ioctl).
access_vector(allow,ifconfig_t,self,sock_file,read).
access_vector(allow,ifconfig_t,self,sock_file,getattr).
access_vector(allow,ifconfig_t,self,sock_file,lock).
access_vector(allow,ifconfig_t,self,sock_file,ioctl).
access_vector(allow,ifconfig_t,self,fifo_file,read).
access_vector(allow,ifconfig_t,self,fifo_file,getattr).
access_vector(allow,ifconfig_t,self,fifo_file,lock).
access_vector(allow,ifconfig_t,self,fifo_file,ioctl).
access_vector(allow,ifconfig_t,self,fd,_).
access_vector(allow,ifconfig_t,self,fifo_file,ioctl).
access_vector(allow,ifconfig_t,self,fifo_file,read).
access_vector(allow,ifconfig_t,self,fifo_file,getattr).
access_vector(allow,ifconfig_t,self,fifo_file,lock).
access_vector(allow,ifconfig_t,self,fifo_file,write).
access_vector(allow,ifconfig_t,self,fifo_file,append).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,create).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,ioctl).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,read).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,getattr).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,write).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,setattr).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,append).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,bind).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,connect).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,getopt).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,setopt).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,shutdown).
access_vector(allow,ifconfig_t,self,unix_stream_socket,create).
access_vector(allow,ifconfig_t,self,unix_stream_socket,ioctl).
access_vector(allow,ifconfig_t,self,unix_stream_socket,read).
access_vector(allow,ifconfig_t,self,unix_stream_socket,getattr).
access_vector(allow,ifconfig_t,self,unix_stream_socket,write).
access_vector(allow,ifconfig_t,self,unix_stream_socket,setattr).
access_vector(allow,ifconfig_t,self,unix_stream_socket,append).
access_vector(allow,ifconfig_t,self,unix_stream_socket,bind).
access_vector(allow,ifconfig_t,self,unix_stream_socket,connect).
access_vector(allow,ifconfig_t,self,unix_stream_socket,getopt).
access_vector(allow,ifconfig_t,self,unix_stream_socket,setopt).
access_vector(allow,ifconfig_t,self,unix_stream_socket,shutdown).
access_vector(allow,ifconfig_t,self,unix_stream_socket,listen).
access_vector(allow,ifconfig_t,self,unix_stream_socket,accept).
access_vector(allow,ifconfig_t,self,unix_dgram_socket,sendto).
access_vector(allow,ifconfig_t,self,unix_stream_socket,connectto).
access_vector(allow,ifconfig_t,self,sem,associate).
access_vector(allow,ifconfig_t,self,sem,getattr).
access_vector(allow,ifconfig_t,self,sem,setattr).
access_vector(allow,ifconfig_t,self,sem,create).
access_vector(allow,ifconfig_t,self,sem,destroy).
access_vector(allow,ifconfig_t,self,sem,read).
access_vector(allow,ifconfig_t,self,sem,write).
access_vector(allow,ifconfig_t,self,sem,unix_read).
access_vector(allow,ifconfig_t,self,sem,unix_write).
access_vector(allow,ifconfig_t,self,msg,send).
access_vector(allow,ifconfig_t,self,msg,receive).
access_vector(allow,ifconfig_t,self,msgq,associate).
access_vector(allow,ifconfig_t,self,msgq,getattr).
access_vector(allow,ifconfig_t,self,msgq,setattr).
access_vector(allow,ifconfig_t,self,msgq,create).
access_vector(allow,ifconfig_t,self,msgq,destroy).
access_vector(allow,ifconfig_t,self,msgq,read).
access_vector(allow,ifconfig_t,self,msgq,write).
access_vector(allow,ifconfig_t,self,msgq,enqueue).
access_vector(allow,ifconfig_t,self,msgq,unix_read).
access_vector(allow,ifconfig_t,self,msgq,unix_write).
access_vector(allow,ifconfig_t,self,shm,associate).
access_vector(allow,ifconfig_t,self,shm,getattr).
access_vector(allow,ifconfig_t,self,shm,setattr).
access_vector(allow,ifconfig_t,self,shm,create).
access_vector(allow,ifconfig_t,self,shm,destroy).
access_vector(allow,ifconfig_t,self,shm,read).
access_vector(allow,ifconfig_t,self,shm,write).
access_vector(allow,ifconfig_t,self,shm,lock).
access_vector(allow,ifconfig_t,self,shm,unix_read).
access_vector(allow,ifconfig_t,self,shm,unix_write).
access_vector(allow,initrc_t,ifconfig_t,process,transition).
access_vector(dontaudit,initrc_t,ifconfig_t,process,noatsecure).
access_vector(allow,initrc_t,ifconfig_exec_t,file,read).
access_vector(allow,initrc_t,ifconfig_exec_t,file,getattr).
access_vector(allow,initrc_t,ifconfig_exec_t,file,execute).
access_vector(allow,ifconfig_t,initrc_t,process,sigchld).
access_vector(allow,ifconfig_t,initrc_t,fd,use).
access_vector(allow,initrc_t,ifconfig_t,fd,use).
access_vector(allow,ifconfig_t,initrc_t,fifo_file,ioctl).
access_vector(allow,ifconfig_t,initrc_t,fifo_file,read).
access_vector(allow,ifconfig_t,initrc_t,fifo_file,getattr).
access_vector(allow,ifconfig_t,initrc_t,fifo_file,lock).
access_vector(allow,ifconfig_t,initrc_t,fifo_file,write).
access_vector(allow,ifconfig_t,initrc_t,fifo_file,append).
access_vector(allow,ifconfig_t,ifconfig_exec_t,file,read).
access_vector(allow,ifconfig_t,ifconfig_exec_t,file,getattr).
access_vector(allow,ifconfig_t,ifconfig_exec_t,file,lock).
access_vector(allow,ifconfig_t,ifconfig_exec_t,file,execute).
access_vector(allow,ifconfig_t,ifconfig_exec_t,file,ioctl).
access_vector(allow,ifconfig_t,ifconfig_exec_t,file,entrypoint).
type_trans(initrc_t,ifconfig_exec_t,process,ifconfig_t).
access_vector(allow,sysadm_t,ifconfig_t,process,transition).
access_vector(dontaudit,sysadm_t,ifconfig_t,process,noatsecure).
access_vector(allow,sysadm_t,ifconfig_exec_t,file,read).
access_vector(allow,sysadm_t,ifconfig_exec_t,file,getattr).
access_vector(allow,sysadm_t,ifconfig_exec_t,file,execute).
access_vector(allow,ifconfig_t,sysadm_t,process,sigchld).
access_vector(allow,ifconfig_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,ifconfig_t,fd,use).
access_vector(allow,ifconfig_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,ifconfig_t,sysadm_t,fifo_file,read).
access_vector(allow,ifconfig_t,sysadm_t,fifo_file,getattr).
access_vector(allow,ifconfig_t,sysadm_t,fifo_file,lock).
access_vector(allow,ifconfig_t,sysadm_t,fifo_file,write).
access_vector(allow,ifconfig_t,sysadm_t,fifo_file,append).
access_vector(allow,ifconfig_t,ifconfig_exec_t,file,entrypoint).
type_trans(sysadm_t,ifconfig_exec_t,process,ifconfig_t).
access_vector(allow,ifconfig_t,ifconfig_t,capability,sys_module).
access_vector(allow,ifconfig_t,ifconfig_t,capability,net_admin).
access_vector(allow,ifconfig_t,init_t,fd,use).
access_vector(allow,ifconfig_t,insmod_t,process,transition).
access_vector(dontaudit,ifconfig_t,insmod_t,process,noatsecure).
access_vector(allow,ifconfig_t,insmod_exec_t,file,read).
access_vector(allow,ifconfig_t,insmod_exec_t,file,getattr).
access_vector(allow,ifconfig_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,ifconfig_t,process,sigchld).
access_vector(allow,insmod_t,ifconfig_t,fd,use).
access_vector(allow,ifconfig_t,insmod_t,fd,use).
access_vector(allow,insmod_t,ifconfig_t,fifo_file,ioctl).
access_vector(allow,insmod_t,ifconfig_t,fifo_file,read).
access_vector(allow,insmod_t,ifconfig_t,fifo_file,getattr).
access_vector(allow,insmod_t,ifconfig_t,fifo_file,lock).
access_vector(allow,insmod_t,ifconfig_t,fifo_file,write).
access_vector(allow,insmod_t,ifconfig_t,fifo_file,append).
access_vector(allow,insmod_t,insmod_exec_t,file,entrypoint).
type_trans(ifconfig_t,insmod_exec_t,process,insmod_t).
access_vector(allow,ifconfig_t,proc_t,dir,read).
access_vector(allow,ifconfig_t,proc_t,dir,getattr).
access_vector(allow,ifconfig_t,proc_t,dir,lock).
access_vector(allow,ifconfig_t,proc_t,dir,search).
access_vector(allow,ifconfig_t,proc_t,dir,ioctl).
access_vector(allow,ifconfig_t,proc_t,file,read).
access_vector(allow,ifconfig_t,proc_t,file,getattr).
access_vector(allow,ifconfig_t,proc_t,file,lock).
access_vector(allow,ifconfig_t,proc_t,file,ioctl).
access_vector(allow,ifconfig_t,privfd,fd,use).
access_vector(allow,ifconfig_t,self,udp_socket,create).
access_vector(allow,ifconfig_t,self,udp_socket,ioctl).
access_vector(allow,ifconfig_t,self,udp_socket,read).
access_vector(allow,ifconfig_t,self,udp_socket,getattr).
access_vector(allow,ifconfig_t,self,udp_socket,write).
access_vector(allow,ifconfig_t,self,udp_socket,setattr).
access_vector(allow,ifconfig_t,self,udp_socket,append).
access_vector(allow,ifconfig_t,self,udp_socket,bind).
access_vector(allow,ifconfig_t,self,udp_socket,connect).
access_vector(allow,ifconfig_t,self,udp_socket,getopt).
access_vector(allow,ifconfig_t,self,udp_socket,setopt).
access_vector(allow,ifconfig_t,self,udp_socket,shutdown).
access_vector(allow,ifconfig_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,ifconfig_t,initrc_devpts_t,chr_file,read).
access_vector(allow,ifconfig_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,ifconfig_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,ifconfig_t,initrc_devpts_t,chr_file,write).
access_vector(allow,ifconfig_t,initrc_devpts_t,chr_file,append).
access_vector(allow,ifconfig_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,ifconfig_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,ifconfig_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,ifconfig_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,ifconfig_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,ifconfig_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,ifconfig_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,ifconfig_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,ifconfig_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,ifconfig_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,ifconfig_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,ifconfig_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,ifconfig_t,tun_tap_device_t,chr_file,read).
access_vector(allow,ifconfig_t,tun_tap_device_t,chr_file,write).
access_vector(dontaudit,ifconfig_t,sysctl_t,dir,search).
access_vector(dontaudit,ifconfig_t,sysctl_net_t,dir,search).
access_vector(allow,ifconfig_t,fs_t,filesystem,getattr).
type_decl(initrc_t,[],[domain,privlog,privowner,privmail]).
role_decl(system_r,initrc_t).
access_vector(allow,initrc_t,root_t,dir,read).
access_vector(allow,initrc_t,root_t,dir,getattr).
access_vector(allow,initrc_t,root_t,dir,lock).
access_vector(allow,initrc_t,root_t,dir,search).
access_vector(allow,initrc_t,root_t,dir,ioctl).
access_vector(allow,initrc_t,usr_t,dir,read).
access_vector(allow,initrc_t,usr_t,dir,getattr).
access_vector(allow,initrc_t,usr_t,dir,lock).
access_vector(allow,initrc_t,usr_t,dir,search).
access_vector(allow,initrc_t,usr_t,dir,ioctl).
access_vector(allow,initrc_t,lib_t,dir,read).
access_vector(allow,initrc_t,lib_t,dir,getattr).
access_vector(allow,initrc_t,lib_t,dir,lock).
access_vector(allow,initrc_t,lib_t,dir,search).
access_vector(allow,initrc_t,lib_t,dir,ioctl).
access_vector(allow,initrc_t,etc_t,dir,read).
access_vector(allow,initrc_t,etc_t,dir,getattr).
access_vector(allow,initrc_t,etc_t,dir,lock).
access_vector(allow,initrc_t,etc_t,dir,search).
access_vector(allow,initrc_t,etc_t,dir,ioctl).
access_vector(allow,initrc_t,lib_t,lnk_file,read).
access_vector(allow,initrc_t,lib_t,lnk_file,getattr).
access_vector(allow,initrc_t,lib_t,lnk_file,lock).
access_vector(allow,initrc_t,lib_t,lnk_file,ioctl).
access_vector(allow,initrc_t,ld_so_t,file,read).
access_vector(allow,initrc_t,ld_so_t,file,getattr).
access_vector(allow,initrc_t,ld_so_t,file,lock).
access_vector(allow,initrc_t,ld_so_t,file,execute).
access_vector(allow,initrc_t,ld_so_t,file,ioctl).
access_vector(allow,initrc_t,ld_so_t,file,execute_no_trans).
access_vector(allow,initrc_t,ld_so_t,lnk_file,read).
access_vector(allow,initrc_t,ld_so_t,lnk_file,getattr).
access_vector(allow,initrc_t,ld_so_t,lnk_file,lock).
access_vector(allow,initrc_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,initrc_t,shlib_t,file,read).
access_vector(allow,initrc_t,shlib_t,file,getattr).
access_vector(allow,initrc_t,shlib_t,file,lock).
access_vector(allow,initrc_t,shlib_t,file,execute).
access_vector(allow,initrc_t,shlib_t,file,ioctl).
access_vector(allow,initrc_t,shlib_t,lnk_file,read).
access_vector(allow,initrc_t,shlib_t,lnk_file,getattr).
access_vector(allow,initrc_t,shlib_t,lnk_file,lock).
access_vector(allow,initrc_t,shlib_t,lnk_file,ioctl).
access_vector(allow,initrc_t,ld_so_cache_t,file,read).
access_vector(allow,initrc_t,ld_so_cache_t,file,getattr).
access_vector(allow,initrc_t,ld_so_cache_t,file,lock).
access_vector(allow,initrc_t,ld_so_cache_t,file,ioctl).
access_vector(allow,initrc_t,device_t,dir,search).
access_vector(allow,initrc_t,null_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,null_device_t,chr_file,read).
access_vector(allow,initrc_t,null_device_t,chr_file,getattr).
access_vector(allow,initrc_t,null_device_t,chr_file,lock).
access_vector(allow,initrc_t,null_device_t,chr_file,write).
access_vector(allow,initrc_t,null_device_t,chr_file,append).
type_decl(initrc_exec_t,[],[file_type,sysadmfile,exec_type]).
access_vector(allow,initrc_t,etc_t,lnk_file,read).
access_vector(allow,initrc_t,etc_t,lnk_file,getattr).
access_vector(allow,initrc_t,etc_t,lnk_file,lock).
access_vector(allow,initrc_t,etc_t,lnk_file,ioctl).
access_vector(allow,initrc_t,etc_t,lnk_file,read).
access_vector(allow,initrc_t,locale_t,dir,read).
access_vector(allow,initrc_t,locale_t,dir,getattr).
access_vector(allow,initrc_t,locale_t,dir,lock).
access_vector(allow,initrc_t,locale_t,dir,search).
access_vector(allow,initrc_t,locale_t,dir,ioctl).
access_vector(allow,initrc_t,locale_t,file,read).
access_vector(allow,initrc_t,locale_t,file,getattr).
access_vector(allow,initrc_t,locale_t,file,lock).
access_vector(allow,initrc_t,locale_t,file,ioctl).
access_vector(allow,initrc_t,locale_t,lnk_file,read).
access_vector(allow,initrc_t,locale_t,lnk_file,getattr).
access_vector(allow,initrc_t,locale_t,lnk_file,lock).
access_vector(allow,initrc_t,locale_t,lnk_file,ioctl).
access_vector(allow,initrc_t,proc_t,dir,read).
access_vector(allow,initrc_t,proc_t,dir,getattr).
access_vector(allow,initrc_t,proc_t,dir,lock).
access_vector(allow,initrc_t,proc_t,dir,search).
access_vector(allow,initrc_t,proc_t,dir,ioctl).
access_vector(allow,initrc_t,proc_t,file,read).
access_vector(allow,initrc_t,proc_t,file,getattr).
access_vector(allow,initrc_t,proc_t,file,lock).
access_vector(allow,initrc_t,proc_t,file,ioctl).
access_vector(allow,initrc_t,proc_t,lnk_file,read).
access_vector(allow,initrc_t,proc_t,lnk_file,getattr).
access_vector(allow,initrc_t,proc_t,lnk_file,lock).
access_vector(allow,initrc_t,proc_t,lnk_file,ioctl).
access_vector(allow,initrc_t,self,unix_dgram_socket,create).
access_vector(allow,initrc_t,self,unix_dgram_socket,ioctl).
access_vector(allow,initrc_t,self,unix_dgram_socket,read).
access_vector(allow,initrc_t,self,unix_dgram_socket,getattr).
access_vector(allow,initrc_t,self,unix_dgram_socket,write).
access_vector(allow,initrc_t,self,unix_dgram_socket,setattr).
access_vector(allow,initrc_t,self,unix_dgram_socket,append).
access_vector(allow,initrc_t,self,unix_dgram_socket,bind).
access_vector(allow,initrc_t,self,unix_dgram_socket,connect).
access_vector(allow,initrc_t,self,unix_dgram_socket,getopt).
access_vector(allow,initrc_t,self,unix_dgram_socket,setopt).
access_vector(allow,initrc_t,self,unix_dgram_socket,shutdown).
access_vector(allow,initrc_t,self,unix_stream_socket,create).
access_vector(allow,initrc_t,self,unix_stream_socket,ioctl).
access_vector(allow,initrc_t,self,unix_stream_socket,read).
access_vector(allow,initrc_t,self,unix_stream_socket,getattr).
access_vector(allow,initrc_t,self,unix_stream_socket,write).
access_vector(allow,initrc_t,self,unix_stream_socket,setattr).
access_vector(allow,initrc_t,self,unix_stream_socket,append).
access_vector(allow,initrc_t,self,unix_stream_socket,bind).
access_vector(allow,initrc_t,self,unix_stream_socket,connect).
access_vector(allow,initrc_t,self,unix_stream_socket,getopt).
access_vector(allow,initrc_t,self,unix_stream_socket,setopt).
access_vector(allow,initrc_t,self,unix_stream_socket,shutdown).
access_vector(allow,initrc_t,self,fifo_file,ioctl).
access_vector(allow,initrc_t,self,fifo_file,read).
access_vector(allow,initrc_t,self,fifo_file,getattr).
access_vector(allow,initrc_t,self,fifo_file,lock).
access_vector(allow,initrc_t,self,fifo_file,write).
access_vector(allow,initrc_t,self,fifo_file,append).
access_vector(allow,initrc_t,usbdevfs_t,dir,read).
access_vector(allow,initrc_t,usbdevfs_t,dir,getattr).
access_vector(allow,initrc_t,usbdevfs_t,dir,lock).
access_vector(allow,initrc_t,usbdevfs_t,dir,search).
access_vector(allow,initrc_t,usbdevfs_t,dir,ioctl).
access_vector(allow,initrc_t,usbdevfs_t,file,read).
access_vector(allow,initrc_t,usbdevfs_t,file,getattr).
access_vector(allow,initrc_t,usbdevfs_t,file,lock).
access_vector(allow,initrc_t,usbdevfs_t,file,ioctl).
access_vector(allow,initrc_t,usbdevfs_t,lnk_file,read).
access_vector(allow,initrc_t,usbdevfs_t,lnk_file,getattr).
access_vector(allow,initrc_t,usbdevfs_t,lnk_file,lock).
access_vector(allow,initrc_t,usbdevfs_t,lnk_file,ioctl).
access_vector(allow,initrc_t,usbdevfs_device_t,file,getattr).
access_vector(allow,initrc_t,self,process,fork).
access_vector(allow,initrc_t,self,process,sigchld).
access_vector(allow,initrc_t,self,process,setsched).
access_vector(allow,initrc_t,ptmx_t,chr_file,ioctl).
access_vector(allow,initrc_t,ptmx_t,chr_file,read).
access_vector(allow,initrc_t,ptmx_t,chr_file,getattr).
access_vector(allow,initrc_t,ptmx_t,chr_file,lock).
access_vector(allow,initrc_t,ptmx_t,chr_file,write).
access_vector(allow,initrc_t,ptmx_t,chr_file,append).
access_vector(allow,initrc_t,devpts_t,filesystem,getattr).
access_vector(allow,initrc_t,devpts_t,dir,getattr).
access_vector(allow,initrc_t,devpts_t,dir,read).
access_vector(allow,initrc_t,devpts_t,dir,search).
type_decl(initrc_devpts_t,[],[file_type,sysadmfile,ptyfile]).
access_vector(allow,initrc_devpts_t,devpts_t,filesystem,associate).
type_trans(initrc_t,devpts_t,chr_file,initrc_devpts_t).
access_vector(allow,initrc_t,initrc_devpts_t,chr_file,setattr).
access_vector(allow,initrc_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,initrc_t,initrc_devpts_t,chr_file,read).
access_vector(allow,initrc_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,initrc_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,initrc_t,initrc_devpts_t,chr_file,write).
access_vector(allow,initrc_t,initrc_devpts_t,chr_file,append).
type_decl(initrc_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,initrc_t,tmp_t,dir,read).
access_vector(allow,initrc_t,tmp_t,dir,getattr).
access_vector(allow,initrc_t,tmp_t,dir,lock).
access_vector(allow,initrc_t,tmp_t,dir,search).
access_vector(allow,initrc_t,tmp_t,dir,ioctl).
access_vector(allow,initrc_t,tmp_t,dir,add_name).
access_vector(allow,initrc_t,tmp_t,dir,remove_name).
access_vector(allow,initrc_t,tmp_t,dir,write).
access_vector(allow,initrc_t,initrc_tmp_t,file,create).
access_vector(allow,initrc_t,initrc_tmp_t,file,ioctl).
access_vector(allow,initrc_t,initrc_tmp_t,file,read).
access_vector(allow,initrc_t,initrc_tmp_t,file,getattr).
access_vector(allow,initrc_t,initrc_tmp_t,file,lock).
access_vector(allow,initrc_t,initrc_tmp_t,file,write).
access_vector(allow,initrc_t,initrc_tmp_t,file,setattr).
access_vector(allow,initrc_t,initrc_tmp_t,file,append).
access_vector(allow,initrc_t,initrc_tmp_t,file,link).
access_vector(allow,initrc_t,initrc_tmp_t,file,unlink).
access_vector(allow,initrc_t,initrc_tmp_t,file,rename).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,create).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,ioctl).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,read).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,getattr).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,lock).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,write).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,setattr).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,append).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,link).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,unlink).
access_vector(allow,initrc_t,initrc_tmp_t,lnk_file,rename).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,create).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,ioctl).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,read).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,getattr).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,lock).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,write).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,setattr).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,append).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,link).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,unlink).
access_vector(allow,initrc_t,initrc_tmp_t,sock_file,rename).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,create).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,ioctl).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,read).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,getattr).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,lock).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,write).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,setattr).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,append).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,link).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,unlink).
access_vector(allow,initrc_t,initrc_tmp_t,fifo_file,rename).
access_vector(allow,initrc_t,initrc_tmp_t,dir,create).
access_vector(allow,initrc_t,initrc_tmp_t,dir,read).
access_vector(allow,initrc_t,initrc_tmp_t,dir,getattr).
access_vector(allow,initrc_t,initrc_tmp_t,dir,lock).
access_vector(allow,initrc_t,initrc_tmp_t,dir,setattr).
access_vector(allow,initrc_t,initrc_tmp_t,dir,link).
access_vector(allow,initrc_t,initrc_tmp_t,dir,unlink).
access_vector(allow,initrc_t,initrc_tmp_t,dir,rename).
access_vector(allow,initrc_t,initrc_tmp_t,dir,search).
access_vector(allow,initrc_t,initrc_tmp_t,dir,add_name).
access_vector(allow,initrc_t,initrc_tmp_t,dir,remove_name).
access_vector(allow,initrc_t,initrc_tmp_t,dir,reparent).
access_vector(allow,initrc_t,initrc_tmp_t,dir,write).
access_vector(allow,initrc_t,initrc_tmp_t,dir,rmdir).
type_trans(initrc_t,tmp_t,dir,initrc_tmp_t).
type_trans(initrc_t,tmp_t,[file,lnk_file,sock_file,fifo_file],initrc_tmp_t).
type_decl(initrc_var_run_t,var_run_initrc_t,[file_type,sysadmfile,pidfile]).
access_vector(allow,initrc_t,var_run_t,dir,read).
access_vector(allow,initrc_t,var_run_t,dir,getattr).
access_vector(allow,initrc_t,var_run_t,dir,lock).
access_vector(allow,initrc_t,var_run_t,dir,search).
access_vector(allow,initrc_t,var_run_t,dir,ioctl).
access_vector(allow,initrc_t,var_run_t,dir,add_name).
access_vector(allow,initrc_t,var_run_t,dir,remove_name).
access_vector(allow,initrc_t,var_run_t,dir,write).
access_vector(allow,initrc_t,initrc_var_run_t,file,create).
access_vector(allow,initrc_t,initrc_var_run_t,file,ioctl).
access_vector(allow,initrc_t,initrc_var_run_t,file,read).
access_vector(allow,initrc_t,initrc_var_run_t,file,getattr).
access_vector(allow,initrc_t,initrc_var_run_t,file,lock).
access_vector(allow,initrc_t,initrc_var_run_t,file,write).
access_vector(allow,initrc_t,initrc_var_run_t,file,setattr).
access_vector(allow,initrc_t,initrc_var_run_t,file,append).
access_vector(allow,initrc_t,initrc_var_run_t,file,link).
access_vector(allow,initrc_t,initrc_var_run_t,file,unlink).
access_vector(allow,initrc_t,initrc_var_run_t,file,rename).
type_trans(initrc_t,var_run_t,file,initrc_var_run_t).
access_vector(allow,initrc_t,initrc_var_run_t,dir,read).
access_vector(allow,initrc_t,initrc_var_run_t,dir,getattr).
access_vector(allow,initrc_t,initrc_var_run_t,dir,lock).
access_vector(allow,initrc_t,initrc_var_run_t,dir,search).
access_vector(allow,initrc_t,initrc_var_run_t,dir,ioctl).
access_vector(allow,initrc_t,initrc_var_run_t,dir,add_name).
access_vector(allow,initrc_t,initrc_var_run_t,dir,remove_name).
access_vector(allow,initrc_t,initrc_var_run_t,dir,write).
access_vector(allow,initrc_t,var_run_t,file,unlink).
access_vector(allow,initrc_t,var_run_t,sock_file,unlink).
access_vector(allow,initrc_t,var_run_t,lnk_file,unlink).
access_vector(allow,initrc_t,framebuf_device_t,chr_file,read).
access_vector(allow,initrc_t,framebuf_device_t,chr_file,getattr).
access_vector(allow,initrc_t,framebuf_device_t,chr_file,lock).
access_vector(allow,initrc_t,framebuf_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,initrc_t,capability,except(sys_module)).
access_vector(allow,initrc_t,kernel_t,system,_).
access_vector(allow,initrc_t,security_t,dir,read).
access_vector(allow,initrc_t,security_t,dir,search).
access_vector(allow,initrc_t,security_t,dir,getattr).
access_vector(allow,initrc_t,security_t,file,getattr).
access_vector(allow,initrc_t,security_t,file,read).
access_vector(allow,initrc_t,security_t,file,write).
access_vector(allow,initrc_t,security_t,security,setenforce).
access_vector(auditallow,initrc_t,security_t,security,setenforce).
access_vector(allow,initrc_t,sysctl_t,dir,read).
access_vector(allow,initrc_t,sysctl_t,dir,getattr).
access_vector(allow,initrc_t,sysctl_t,dir,lock).
access_vector(allow,initrc_t,sysctl_t,dir,search).
access_vector(allow,initrc_t,sysctl_t,dir,ioctl).
access_vector(allow,initrc_t,sysctl_t,file,setattr).
access_vector(allow,initrc_t,sysctl_t,file,ioctl).
access_vector(allow,initrc_t,sysctl_t,file,read).
access_vector(allow,initrc_t,sysctl_t,file,getattr).
access_vector(allow,initrc_t,sysctl_t,file,lock).
access_vector(allow,initrc_t,sysctl_t,file,write).
access_vector(allow,initrc_t,sysctl_t,file,append).
access_vector(allow,initrc_t,sysctl_fs_t,dir,read).
access_vector(allow,initrc_t,sysctl_fs_t,dir,getattr).
access_vector(allow,initrc_t,sysctl_fs_t,dir,lock).
access_vector(allow,initrc_t,sysctl_fs_t,dir,search).
access_vector(allow,initrc_t,sysctl_fs_t,dir,ioctl).
access_vector(allow,initrc_t,sysctl_fs_t,file,setattr).
access_vector(allow,initrc_t,sysctl_fs_t,file,ioctl).
access_vector(allow,initrc_t,sysctl_fs_t,file,read).
access_vector(allow,initrc_t,sysctl_fs_t,file,getattr).
access_vector(allow,initrc_t,sysctl_fs_t,file,lock).
access_vector(allow,initrc_t,sysctl_fs_t,file,write).
access_vector(allow,initrc_t,sysctl_fs_t,file,append).
access_vector(allow,initrc_t,sysctl_kernel_t,dir,read).
access_vector(allow,initrc_t,sysctl_kernel_t,dir,getattr).
access_vector(allow,initrc_t,sysctl_kernel_t,dir,lock).
access_vector(allow,initrc_t,sysctl_kernel_t,dir,search).
access_vector(allow,initrc_t,sysctl_kernel_t,dir,ioctl).
access_vector(allow,initrc_t,sysctl_kernel_t,file,setattr).
access_vector(allow,initrc_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,initrc_t,sysctl_kernel_t,file,read).
access_vector(allow,initrc_t,sysctl_kernel_t,file,getattr).
access_vector(allow,initrc_t,sysctl_kernel_t,file,lock).
access_vector(allow,initrc_t,sysctl_kernel_t,file,write).
access_vector(allow,initrc_t,sysctl_kernel_t,file,append).
access_vector(allow,initrc_t,sysctl_net_t,dir,read).
access_vector(allow,initrc_t,sysctl_net_t,dir,getattr).
access_vector(allow,initrc_t,sysctl_net_t,dir,lock).
access_vector(allow,initrc_t,sysctl_net_t,dir,search).
access_vector(allow,initrc_t,sysctl_net_t,dir,ioctl).
access_vector(allow,initrc_t,sysctl_net_t,file,setattr).
access_vector(allow,initrc_t,sysctl_net_t,file,ioctl).
access_vector(allow,initrc_t,sysctl_net_t,file,read).
access_vector(allow,initrc_t,sysctl_net_t,file,getattr).
access_vector(allow,initrc_t,sysctl_net_t,file,lock).
access_vector(allow,initrc_t,sysctl_net_t,file,write).
access_vector(allow,initrc_t,sysctl_net_t,file,append).
access_vector(allow,initrc_t,sysctl_net_unix_t,dir,read).
access_vector(allow,initrc_t,sysctl_net_unix_t,dir,getattr).
access_vector(allow,initrc_t,sysctl_net_unix_t,dir,lock).
access_vector(allow,initrc_t,sysctl_net_unix_t,dir,search).
access_vector(allow,initrc_t,sysctl_net_unix_t,dir,ioctl).
access_vector(allow,initrc_t,sysctl_net_unix_t,file,setattr).
access_vector(allow,initrc_t,sysctl_net_unix_t,file,ioctl).
access_vector(allow,initrc_t,sysctl_net_unix_t,file,read).
access_vector(allow,initrc_t,sysctl_net_unix_t,file,getattr).
access_vector(allow,initrc_t,sysctl_net_unix_t,file,lock).
access_vector(allow,initrc_t,sysctl_net_unix_t,file,write).
access_vector(allow,initrc_t,sysctl_net_unix_t,file,append).
access_vector(allow,initrc_t,sysctl_vm_t,dir,read).
access_vector(allow,initrc_t,sysctl_vm_t,dir,getattr).
access_vector(allow,initrc_t,sysctl_vm_t,dir,lock).
access_vector(allow,initrc_t,sysctl_vm_t,dir,search).
access_vector(allow,initrc_t,sysctl_vm_t,dir,ioctl).
access_vector(allow,initrc_t,sysctl_vm_t,file,setattr).
access_vector(allow,initrc_t,sysctl_vm_t,file,ioctl).
access_vector(allow,initrc_t,sysctl_vm_t,file,read).
access_vector(allow,initrc_t,sysctl_vm_t,file,getattr).
access_vector(allow,initrc_t,sysctl_vm_t,file,lock).
access_vector(allow,initrc_t,sysctl_vm_t,file,write).
access_vector(allow,initrc_t,sysctl_vm_t,file,append).
access_vector(allow,initrc_t,sysctl_dev_t,dir,read).
access_vector(allow,initrc_t,sysctl_dev_t,dir,getattr).
access_vector(allow,initrc_t,sysctl_dev_t,dir,lock).
access_vector(allow,initrc_t,sysctl_dev_t,dir,search).
access_vector(allow,initrc_t,sysctl_dev_t,dir,ioctl).
access_vector(allow,initrc_t,sysctl_dev_t,file,setattr).
access_vector(allow,initrc_t,sysctl_dev_t,file,ioctl).
access_vector(allow,initrc_t,sysctl_dev_t,file,read).
access_vector(allow,initrc_t,sysctl_dev_t,file,getattr).
access_vector(allow,initrc_t,sysctl_dev_t,file,lock).
access_vector(allow,initrc_t,sysctl_dev_t,file,write).
access_vector(allow,initrc_t,sysctl_dev_t,file,append).
access_vector(allow,initrc_t,sysctl_modprobe_t,file,setattr).
access_vector(allow,initrc_t,sysctl_modprobe_t,file,ioctl).
access_vector(allow,initrc_t,sysctl_modprobe_t,file,read).
access_vector(allow,initrc_t,sysctl_modprobe_t,file,getattr).
access_vector(allow,initrc_t,sysctl_modprobe_t,file,lock).
access_vector(allow,initrc_t,sysctl_modprobe_t,file,write).
access_vector(allow,initrc_t,sysctl_modprobe_t,file,append).
access_vector(allow,initrc_t,bin_t,dir,read).
access_vector(allow,initrc_t,bin_t,dir,getattr).
access_vector(allow,initrc_t,bin_t,dir,lock).
access_vector(allow,initrc_t,bin_t,dir,search).
access_vector(allow,initrc_t,bin_t,dir,ioctl).
access_vector(allow,initrc_t,sbin_t,dir,read).
access_vector(allow,initrc_t,sbin_t,dir,getattr).
access_vector(allow,initrc_t,sbin_t,dir,lock).
access_vector(allow,initrc_t,sbin_t,dir,search).
access_vector(allow,initrc_t,sbin_t,dir,ioctl).
access_vector(allow,initrc_t,bin_t,lnk_file,read).
access_vector(allow,initrc_t,sbin_t,lnk_file,read).
access_vector(allow,initrc_t,etc_t,file,read).
access_vector(allow,initrc_t,etc_t,file,getattr).
access_vector(allow,initrc_t,etc_t,file,lock).
access_vector(allow,initrc_t,etc_t,file,execute).
access_vector(allow,initrc_t,etc_t,file,ioctl).
access_vector(allow,initrc_t,etc_t,file,execute_no_trans).
access_vector(allow,initrc_t,lib_t,file,read).
access_vector(allow,initrc_t,lib_t,file,getattr).
access_vector(allow,initrc_t,lib_t,file,lock).
access_vector(allow,initrc_t,lib_t,file,execute).
access_vector(allow,initrc_t,lib_t,file,ioctl).
access_vector(allow,initrc_t,lib_t,file,execute_no_trans).
access_vector(allow,initrc_t,bin_t,file,read).
access_vector(allow,initrc_t,bin_t,file,getattr).
access_vector(allow,initrc_t,bin_t,file,lock).
access_vector(allow,initrc_t,bin_t,file,execute).
access_vector(allow,initrc_t,bin_t,file,ioctl).
access_vector(allow,initrc_t,bin_t,file,execute_no_trans).
access_vector(allow,initrc_t,sbin_t,file,read).
access_vector(allow,initrc_t,sbin_t,file,getattr).
access_vector(allow,initrc_t,sbin_t,file,lock).
access_vector(allow,initrc_t,sbin_t,file,execute).
access_vector(allow,initrc_t,sbin_t,file,ioctl).
access_vector(allow,initrc_t,sbin_t,file,execute_no_trans).
access_vector(allow,initrc_t,exec_type,file,read).
access_vector(allow,initrc_t,exec_type,file,getattr).
access_vector(allow,initrc_t,exec_type,file,lock).
access_vector(allow,initrc_t,exec_type,file,execute).
access_vector(allow,initrc_t,exec_type,file,ioctl).
access_vector(allow,initrc_t,exec_type,file,execute_no_trans).
access_vector(allow,initrc_t,modules_conf_t,file,read).
access_vector(allow,initrc_t,modules_conf_t,file,getattr).
access_vector(allow,initrc_t,modules_conf_t,file,lock).
access_vector(allow,initrc_t,modules_conf_t,file,ioctl).
access_vector(allow,initrc_t,initrc_exec_t,file,read).
access_vector(allow,initrc_t,initrc_exec_t,file,getattr).
access_vector(allow,initrc_t,initrc_exec_t,file,lock).
access_vector(allow,initrc_t,initrc_exec_t,file,execute).
access_vector(allow,initrc_t,initrc_exec_t,file,ioctl).
access_vector(allow,initrc_t,initrc_exec_t,file,execute_no_trans).
access_vector(allow,initrc_t,init_exec_t,file,read).
access_vector(allow,initrc_t,init_exec_t,file,getattr).
access_vector(allow,initrc_t,init_exec_t,file,lock).
access_vector(allow,initrc_t,init_exec_t,file,execute).
access_vector(allow,initrc_t,init_exec_t,file,ioctl).
access_vector(allow,initrc_t,init_exec_t,file,execute_no_trans).
access_vector(allow,initrc_t,initctl_t,fifo_file,ioctl).
access_vector(allow,initrc_t,initctl_t,fifo_file,read).
access_vector(allow,initrc_t,initctl_t,fifo_file,getattr).
access_vector(allow,initrc_t,initctl_t,fifo_file,lock).
access_vector(allow,initrc_t,initctl_t,fifo_file,write).
access_vector(allow,initrc_t,initctl_t,fifo_file,append).
access_vector(allow,initrc_t,file_labels_t,dir,read).
access_vector(allow,initrc_t,file_labels_t,dir,getattr).
access_vector(allow,initrc_t,file_labels_t,dir,lock).
access_vector(allow,initrc_t,file_labels_t,dir,search).
access_vector(allow,initrc_t,file_labels_t,dir,ioctl).
access_vector(allow,initrc_t,file_labels_t,file,getattr).
access_vector(allow,initrc_t,domain,file,read).
access_vector(allow,initrc_t,domain,file,getattr).
access_vector(allow,initrc_t,domain,file,lock).
access_vector(allow,initrc_t,domain,file,ioctl).
access_vector(allow,initrc_t,domain,lnk_file,read).
access_vector(allow,initrc_t,domain,lnk_file,getattr).
access_vector(allow,initrc_t,domain,lnk_file,lock).
access_vector(allow,initrc_t,domain,lnk_file,ioctl).
access_vector(allow,initrc_t,domain,sock_file,read).
access_vector(allow,initrc_t,domain,sock_file,getattr).
access_vector(allow,initrc_t,domain,sock_file,lock).
access_vector(allow,initrc_t,domain,sock_file,ioctl).
access_vector(allow,initrc_t,domain,fifo_file,read).
access_vector(allow,initrc_t,domain,fifo_file,getattr).
access_vector(allow,initrc_t,domain,fifo_file,lock).
access_vector(allow,initrc_t,domain,fifo_file,ioctl).
access_vector(allow,initrc_t,domain,dir,read).
access_vector(allow,initrc_t,domain,dir,getattr).
access_vector(allow,initrc_t,domain,dir,lock).
access_vector(allow,initrc_t,domain,dir,search).
access_vector(allow,initrc_t,domain,dir,ioctl).
access_vector(allow,initrc_t,fs_type,filesystem,mount).
access_vector(allow,initrc_t,fs_type,filesystem,remount).
access_vector(allow,initrc_t,fs_type,filesystem,unmount).
access_vector(allow,initrc_t,fs_type,filesystem,getattr).
access_vector(allow,initrc_t,file_t,dir,read).
access_vector(allow,initrc_t,file_t,dir,search).
access_vector(allow,initrc_t,file_t,dir,getattr).
access_vector(allow,initrc_t,file_t,dir,mounton).
access_vector(allow,initrc_t,etc_t,dir,read).
access_vector(allow,initrc_t,etc_t,dir,getattr).
access_vector(allow,initrc_t,etc_t,dir,lock).
access_vector(allow,initrc_t,etc_t,dir,search).
access_vector(allow,initrc_t,etc_t,dir,ioctl).
access_vector(allow,initrc_t,etc_t,dir,add_name).
access_vector(allow,initrc_t,etc_t,dir,remove_name).
access_vector(allow,initrc_t,etc_t,dir,write).
access_vector(allow,initrc_t,etc_runtime_t,file,create).
access_vector(allow,initrc_t,etc_runtime_t,file,ioctl).
access_vector(allow,initrc_t,etc_runtime_t,file,read).
access_vector(allow,initrc_t,etc_runtime_t,file,getattr).
access_vector(allow,initrc_t,etc_runtime_t,file,lock).
access_vector(allow,initrc_t,etc_runtime_t,file,write).
access_vector(allow,initrc_t,etc_runtime_t,file,setattr).
access_vector(allow,initrc_t,etc_runtime_t,file,append).
access_vector(allow,initrc_t,etc_runtime_t,file,link).
access_vector(allow,initrc_t,etc_runtime_t,file,unlink).
access_vector(allow,initrc_t,etc_runtime_t,file,rename).
type_trans(initrc_t,etc_t,file,etc_runtime_t).
access_vector(allow,initrc_t,ld_so_cache_t,file,ioctl).
access_vector(allow,initrc_t,ld_so_cache_t,file,read).
access_vector(allow,initrc_t,ld_so_cache_t,file,getattr).
access_vector(allow,initrc_t,ld_so_cache_t,file,lock).
access_vector(allow,initrc_t,ld_so_cache_t,file,write).
access_vector(allow,initrc_t,ld_so_cache_t,file,append).
access_vector(allow,initrc_t,wtmp_t,file,setattr).
access_vector(allow,initrc_t,wtmp_t,file,ioctl).
access_vector(allow,initrc_t,wtmp_t,file,read).
access_vector(allow,initrc_t,wtmp_t,file,getattr).
access_vector(allow,initrc_t,wtmp_t,file,lock).
access_vector(allow,initrc_t,wtmp_t,file,write).
access_vector(allow,initrc_t,wtmp_t,file,append).
access_vector(allow,initrc_t,var_log_t,file,setattr).
access_vector(allow,initrc_t,var_log_t,file,ioctl).
access_vector(allow,initrc_t,var_log_t,file,read).
access_vector(allow,initrc_t,var_log_t,file,getattr).
access_vector(allow,initrc_t,var_log_t,file,lock).
access_vector(allow,initrc_t,var_log_t,file,write).
access_vector(allow,initrc_t,var_log_t,file,append).
access_vector(allow,initrc_t,lastlog_t,file,setattr).
access_vector(allow,initrc_t,lastlog_t,file,ioctl).
access_vector(allow,initrc_t,lastlog_t,file,read).
access_vector(allow,initrc_t,lastlog_t,file,getattr).
access_vector(allow,initrc_t,lastlog_t,file,lock).
access_vector(allow,initrc_t,lastlog_t,file,write).
access_vector(allow,initrc_t,lastlog_t,file,append).
access_vector(allow,initrc_t,lockfile,dir,read).
access_vector(allow,initrc_t,lockfile,dir,getattr).
access_vector(allow,initrc_t,lockfile,dir,lock).
access_vector(allow,initrc_t,lockfile,dir,search).
access_vector(allow,initrc_t,lockfile,dir,ioctl).
access_vector(allow,initrc_t,lockfile,dir,add_name).
access_vector(allow,initrc_t,lockfile,dir,remove_name).
access_vector(allow,initrc_t,lockfile,dir,write).
access_vector(allow,initrc_t,lockfile,file,getattr).
access_vector(allow,initrc_t,lockfile,file,unlink).
access_vector(allow,initrc_t,var_lib_t,file,ioctl).
access_vector(allow,initrc_t,var_lib_t,file,read).
access_vector(allow,initrc_t,var_lib_t,file,getattr).
access_vector(allow,initrc_t,var_lib_t,file,lock).
access_vector(allow,initrc_t,var_lib_t,file,write).
access_vector(allow,initrc_t,var_lib_t,file,append).
access_vector(allow,initrc_t,var_lib_t,file,unlink).
access_vector(allow,initrc_t,var_lock_t,dir,create).
access_vector(allow,initrc_t,var_lock_t,dir,read).
access_vector(allow,initrc_t,var_lock_t,dir,getattr).
access_vector(allow,initrc_t,var_lock_t,dir,lock).
access_vector(allow,initrc_t,var_lock_t,dir,setattr).
access_vector(allow,initrc_t,var_lock_t,dir,link).
access_vector(allow,initrc_t,var_lock_t,dir,unlink).
access_vector(allow,initrc_t,var_lock_t,dir,rename).
access_vector(allow,initrc_t,var_lock_t,dir,search).
access_vector(allow,initrc_t,var_lock_t,dir,add_name).
access_vector(allow,initrc_t,var_lock_t,dir,remove_name).
access_vector(allow,initrc_t,var_lock_t,dir,reparent).
access_vector(allow,initrc_t,var_lock_t,dir,write).
access_vector(allow,initrc_t,var_lock_t,dir,rmdir).
access_vector(allow,initrc_t,var_lock_t,file,create).
access_vector(allow,initrc_t,var_lock_t,file,ioctl).
access_vector(allow,initrc_t,var_lock_t,file,read).
access_vector(allow,initrc_t,var_lock_t,file,getattr).
access_vector(allow,initrc_t,var_lock_t,file,lock).
access_vector(allow,initrc_t,var_lock_t,file,write).
access_vector(allow,initrc_t,var_lock_t,file,setattr).
access_vector(allow,initrc_t,var_lock_t,file,append).
access_vector(allow,initrc_t,var_lock_t,file,link).
access_vector(allow,initrc_t,var_lock_t,file,unlink).
access_vector(allow,initrc_t,var_lock_t,file,rename).
access_vector(allow,initrc_t,clock_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,clock_device_t,chr_file,read).
access_vector(allow,initrc_t,clock_device_t,chr_file,getattr).
access_vector(allow,initrc_t,clock_device_t,chr_file,lock).
access_vector(allow,initrc_t,clock_device_t,chr_file,write).
access_vector(allow,initrc_t,clock_device_t,chr_file,append).
access_vector(allow,initrc_t,clock_device_t,blk_file,ioctl).
access_vector(allow,initrc_t,clock_device_t,blk_file,read).
access_vector(allow,initrc_t,clock_device_t,blk_file,getattr).
access_vector(allow,initrc_t,clock_device_t,blk_file,lock).
access_vector(allow,initrc_t,clock_device_t,blk_file,write).
access_vector(allow,initrc_t,clock_device_t,blk_file,append).
access_vector(allow,initrc_t,domain,process,sigchld).
access_vector(allow,initrc_t,domain,process,sigkill).
access_vector(allow,initrc_t,domain,process,sigstop).
access_vector(allow,initrc_t,domain,process,signull).
access_vector(allow,initrc_t,domain,process,signal).
access_vector(allow,initrc_t,pidfile,file,getattr).
access_vector(allow,initrc_t,pidfile,file,read).
access_vector(allow,initrc_t,pidfile,file,unlink).
access_vector(allow,initrc_t,random_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,random_device_t,chr_file,read).
access_vector(allow,initrc_t,random_device_t,chr_file,getattr).
access_vector(allow,initrc_t,random_device_t,chr_file,lock).
access_vector(allow,initrc_t,random_device_t,chr_file,write).
access_vector(allow,initrc_t,random_device_t,chr_file,append).
access_vector(allow,initrc_t,psaux_t,chr_file,ioctl).
access_vector(allow,initrc_t,psaux_t,chr_file,read).
access_vector(allow,initrc_t,psaux_t,chr_file,getattr).
access_vector(allow,initrc_t,psaux_t,chr_file,lock).
access_vector(allow,initrc_t,psaux_t,chr_file,write).
access_vector(allow,initrc_t,psaux_t,chr_file,append).
access_vector(allow,initrc_t,framebuf_device_t,lnk_file,read).
access_vector(allow,initrc_t,framebuf_device_t,chr_file,setattr).
access_vector(allow,initrc_t,framebuf_device_t,blk_file,setattr).
access_vector(allow,initrc_t,misc_device_t,chr_file,setattr).
access_vector(allow,initrc_t,misc_device_t,blk_file,setattr).
access_vector(allow,initrc_t,device_t,chr_file,setattr).
access_vector(allow,initrc_t,device_t,blk_file,setattr).
access_vector(allow,initrc_t,fixed_disk_device_t,chr_file,setattr).
access_vector(allow,initrc_t,fixed_disk_device_t,blk_file,setattr).
access_vector(allow,initrc_t,removable_device_t,chr_file,setattr).
access_vector(allow,initrc_t,removable_device_t,blk_file,setattr).
access_vector(allow,initrc_t,file_type,file,getattr).
access_vector(allow,initrc_t,file_type,lnk_file,getattr).
access_vector(allow,initrc_t,file_type,sock_file,getattr).
access_vector(allow,initrc_t,file_type,fifo_file,getattr).
access_vector(allow,initrc_t,file_type,chr_file,getattr).
access_vector(allow,initrc_t,file_type,blk_file,getattr).
access_vector(allow,initrc_t,file_type,dir,search).
access_vector(allow,initrc_t,file_type,dir,getattr).
access_vector(allow,initrc_t,devtty_t,chr_file,ioctl).
access_vector(allow,initrc_t,devtty_t,chr_file,read).
access_vector(allow,initrc_t,devtty_t,chr_file,getattr).
access_vector(allow,initrc_t,devtty_t,chr_file,lock).
access_vector(allow,initrc_t,devtty_t,chr_file,write).
access_vector(allow,initrc_t,devtty_t,chr_file,append).
access_vector(allow,initrc_t,console_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,console_device_t,chr_file,read).
access_vector(allow,initrc_t,console_device_t,chr_file,getattr).
access_vector(allow,initrc_t,console_device_t,chr_file,lock).
access_vector(allow,initrc_t,console_device_t,chr_file,write).
access_vector(allow,initrc_t,console_device_t,chr_file,append).
access_vector(allow,initrc_t,tty_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,tty_device_t,chr_file,read).
access_vector(allow,initrc_t,tty_device_t,chr_file,getattr).
access_vector(allow,initrc_t,tty_device_t,chr_file,lock).
access_vector(allow,initrc_t,tty_device_t,chr_file,write).
access_vector(allow,initrc_t,tty_device_t,chr_file,append).
access_vector(allow,initrc_t,ttyfile,chr_file,ioctl).
access_vector(allow,initrc_t,ttyfile,chr_file,read).
access_vector(allow,initrc_t,ttyfile,chr_file,getattr).
access_vector(allow,initrc_t,ttyfile,chr_file,lock).
access_vector(allow,initrc_t,ttyfile,chr_file,write).
access_vector(allow,initrc_t,ttyfile,chr_file,append).
access_vector(allow,initrc_t,ptyfile,chr_file,ioctl).
access_vector(allow,initrc_t,ptyfile,chr_file,read).
access_vector(allow,initrc_t,ptyfile,chr_file,getattr).
access_vector(allow,initrc_t,ptyfile,chr_file,lock).
access_vector(allow,initrc_t,ptyfile,chr_file,write).
access_vector(allow,initrc_t,ptyfile,chr_file,append).
access_vector(allow,initrc_t,ttyfile,chr_file,relabelfrom).
access_vector(allow,initrc_t,tty_device_t,chr_file,relabelto).
access_vector(allow,initrc_t,system_map_t,file,read).
access_vector(allow,initrc_t,system_map_t,file,getattr).
access_vector(allow,initrc_t,system_map_t,file,lock).
access_vector(allow,initrc_t,system_map_t,file,ioctl).
access_vector(allow,initrc_t,system_map_t,lnk_file,read).
access_vector(allow,initrc_t,system_map_t,lnk_file,getattr).
access_vector(allow,initrc_t,system_map_t,lnk_file,lock).
access_vector(allow,initrc_t,system_map_t,lnk_file,ioctl).
access_vector(allow,initrc_t,root_t,dir,search).
access_vector(allow,initrc_t,root_t,dir,write).
access_vector(allow,initrc_t,root_t,dir,remove_name).
access_vector(allow,initrc_t,root_t,file,unlink).
access_vector(allow,initrc_t,root_t,file,write).
access_vector(allow,initrc_t,var_spool_t,file,ioctl).
access_vector(allow,initrc_t,var_spool_t,file,read).
access_vector(allow,initrc_t,var_spool_t,file,getattr).
access_vector(allow,initrc_t,var_spool_t,file,lock).
access_vector(allow,initrc_t,var_spool_t,file,write).
access_vector(allow,initrc_t,var_spool_t,file,append).
access_vector(allow,initrc_t,fs_type,filesystem,quotamod).
access_vector(allow,initrc_t,fs_type,filesystem,quotaget).
access_vector(allow,initrc_t,mouse_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,mouse_device_t,chr_file,read).
access_vector(allow,initrc_t,mouse_device_t,chr_file,getattr).
access_vector(allow,initrc_t,mouse_device_t,chr_file,lock).
access_vector(allow,initrc_t,mouse_device_t,chr_file,write).
access_vector(allow,initrc_t,mouse_device_t,chr_file,append).
access_vector(allow,initrc_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,initrc_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,initrc_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,initrc_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,initrc_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,initrc_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,initrc_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,initrc_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,initrc_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,initrc_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,initrc_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,initrc_t,sound_device_t,chr_file,setattr).
access_vector(allow,initrc_t,sound_device_t,chr_file,ioctl).
access_vector(allow,initrc_t,sound_device_t,chr_file,read).
access_vector(allow,initrc_t,sound_device_t,chr_file,write).
access_vector(allow,initrc_t,var_log_t,dir,read).
access_vector(allow,initrc_t,var_log_t,dir,getattr).
access_vector(allow,initrc_t,var_log_t,dir,lock).
access_vector(allow,initrc_t,var_log_t,dir,search).
access_vector(allow,initrc_t,var_log_t,dir,ioctl).
access_vector(allow,initrc_t,var_log_t,dir,add_name).
access_vector(allow,initrc_t,var_log_t,dir,remove_name).
access_vector(allow,initrc_t,var_log_t,dir,write).
access_vector(allow,initrc_t,var_log_ksyms_t,file,create).
access_vector(allow,initrc_t,var_log_ksyms_t,file,ioctl).
access_vector(allow,initrc_t,var_log_ksyms_t,file,read).
access_vector(allow,initrc_t,var_log_ksyms_t,file,getattr).
access_vector(allow,initrc_t,var_log_ksyms_t,file,lock).
access_vector(allow,initrc_t,var_log_ksyms_t,file,write).
access_vector(allow,initrc_t,var_log_ksyms_t,file,setattr).
access_vector(allow,initrc_t,var_log_ksyms_t,file,append).
access_vector(allow,initrc_t,var_log_ksyms_t,file,link).
access_vector(allow,initrc_t,var_log_ksyms_t,file,unlink).
access_vector(allow,initrc_t,var_log_ksyms_t,file,rename).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,create).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,ioctl).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,read).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,getattr).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,lock).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,write).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,setattr).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,append).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,link).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,unlink).
access_vector(allow,initrc_t,var_log_ksyms_t,lnk_file,rename).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,create).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,ioctl).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,read).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,getattr).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,lock).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,write).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,setattr).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,append).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,link).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,unlink).
access_vector(allow,initrc_t,var_log_ksyms_t,sock_file,rename).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,create).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,ioctl).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,read).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,getattr).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,lock).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,write).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,setattr).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,append).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,link).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,unlink).
access_vector(allow,initrc_t,var_log_ksyms_t,fifo_file,rename).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,create).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,read).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,getattr).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,lock).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,setattr).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,link).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,unlink).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,rename).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,search).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,add_name).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,remove_name).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,reparent).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,write).
access_vector(allow,initrc_t,var_log_ksyms_t,dir,rmdir).
type_trans(initrc_t,var_log_t,dir,var_log_ksyms_t).
type_trans(initrc_t,var_log_t,[file,lnk_file,sock_file,fifo_file],var_log_ksyms_t).
access_vector(allow,initrc_t,removable_device_t,blk_file,ioctl).
access_vector(allow,initrc_t,removable_device_t,blk_file,read).
access_vector(allow,initrc_t,removable_device_t,blk_file,getattr).
access_vector(allow,initrc_t,removable_device_t,blk_file,lock).
access_vector(allow,initrc_t,removable_device_t,blk_file,write).
access_vector(allow,initrc_t,removable_device_t,blk_file,append).
access_vector(allow,initrc_t,root_t,dir,search).
access_vector(allow,initrc_t,root_t,dir,write).
access_vector(allow,initrc_t,root_t,dir,add_name).
access_vector(allow,initrc_t,root_t,file,create).
access_vector(allow,initrc_t,root_t,file,setattr).
access_vector(allow,initrc_t,root_t,file,unlink).
access_vector(allow,initrc_t,root_t,file,getattr).
access_vector(allow,initrc_t,file_t,file,unlink).
access_vector(allow,initrc_t,file_t,file,getattr).
access_vector(allow,initrc_t,home_root_t,dir,read).
access_vector(allow,initrc_t,home_root_t,dir,getattr).
access_vector(allow,initrc_t,home_root_t,dir,lock).
access_vector(allow,initrc_t,home_root_t,dir,search).
access_vector(allow,initrc_t,home_root_t,dir,ioctl).
access_vector(allow,initrc_t,home_type,dir,read).
access_vector(allow,initrc_t,home_type,dir,getattr).
access_vector(allow,initrc_t,home_type,dir,lock).
access_vector(allow,initrc_t,home_type,dir,search).
access_vector(allow,initrc_t,home_type,dir,ioctl).
access_vector(allow,initrc_t,home_type,file,read).
access_vector(allow,initrc_t,home_type,file,getattr).
access_vector(allow,initrc_t,home_type,file,lock).
access_vector(allow,initrc_t,home_type,file,ioctl).
access_vector(allow,initrc_t,pidfile,dir,read).
access_vector(allow,initrc_t,pidfile,dir,getattr).
access_vector(allow,initrc_t,pidfile,dir,lock).
access_vector(allow,initrc_t,pidfile,dir,search).
access_vector(allow,initrc_t,pidfile,dir,ioctl).
access_vector(allow,initrc_t,pidfile,dir,add_name).
access_vector(allow,initrc_t,pidfile,dir,remove_name).
access_vector(allow,initrc_t,pidfile,dir,write).
access_vector(allow,initrc_t,pidfile,sock_file,unlink).
access_vector(allow,initrc_t,tmpfile,sock_file,unlink).
access_vector(allow,initrc_t,var_lib_t,dir,read).
access_vector(allow,initrc_t,var_lib_t,dir,getattr).
access_vector(allow,initrc_t,var_lib_t,dir,lock).
access_vector(allow,initrc_t,var_lib_t,dir,search).
access_vector(allow,initrc_t,var_lib_t,dir,ioctl).
access_vector(allow,initrc_t,var_lib_t,dir,add_name).
access_vector(allow,initrc_t,var_lib_t,dir,remove_name).
access_vector(allow,initrc_t,var_lib_t,dir,write).
access_vector(allow,initrc_t,var_lib_t,file,create).
access_vector(allow,initrc_t,var_lib_t,file,ioctl).
access_vector(allow,initrc_t,var_lib_t,file,read).
access_vector(allow,initrc_t,var_lib_t,file,getattr).
access_vector(allow,initrc_t,var_lib_t,file,lock).
access_vector(allow,initrc_t,var_lib_t,file,write).
access_vector(allow,initrc_t,var_lib_t,file,setattr).
access_vector(allow,initrc_t,var_lib_t,file,append).
access_vector(allow,initrc_t,var_lib_t,file,link).
access_vector(allow,initrc_t,var_lib_t,file,unlink).
access_vector(allow,initrc_t,var_lib_t,file,rename).
access_vector(allow,initrc_t,var_lib_t,lnk_file,create).
access_vector(allow,initrc_t,var_lib_t,lnk_file,ioctl).
access_vector(allow,initrc_t,var_lib_t,lnk_file,read).
access_vector(allow,initrc_t,var_lib_t,lnk_file,getattr).
access_vector(allow,initrc_t,var_lib_t,lnk_file,lock).
access_vector(allow,initrc_t,var_lib_t,lnk_file,write).
access_vector(allow,initrc_t,var_lib_t,lnk_file,setattr).
access_vector(allow,initrc_t,var_lib_t,lnk_file,append).
access_vector(allow,initrc_t,var_lib_t,lnk_file,link).
access_vector(allow,initrc_t,var_lib_t,lnk_file,unlink).
access_vector(allow,initrc_t,var_lib_t,lnk_file,rename).
access_vector(allow,initrc_t,tmpfile,dir,read).
access_vector(allow,initrc_t,tmpfile,dir,getattr).
access_vector(allow,initrc_t,tmpfile,dir,lock).
access_vector(allow,initrc_t,tmpfile,dir,search).
access_vector(allow,initrc_t,tmpfile,dir,ioctl).
access_vector(allow,initrc_t,tmpfile,dir,add_name).
access_vector(allow,initrc_t,tmpfile,dir,remove_name).
access_vector(allow,initrc_t,tmpfile,dir,write).
access_vector(allow,initrc_t,tmpfile,dir,rmdir).
access_vector(allow,initrc_t,tmpfile,file,getattr).
access_vector(allow,initrc_t,tmpfile,file,unlink).
access_vector(allow,initrc_t,tmpfile,lnk_file,getattr).
access_vector(allow,initrc_t,tmpfile,lnk_file,unlink).
access_vector(allow,initrc_t,tmpfile,sock_file,getattr).
access_vector(allow,initrc_t,tmpfile,sock_file,unlink).
access_vector(allow,initrc_t,tmpfile,fifo_file,getattr).
access_vector(allow,initrc_t,tmpfile,fifo_file,unlink).
type_decl(run_init_exec_t,[],[file_type,exec_type,sysadmfile]).
type_decl(run_init_t,[],[domain,privrole,privuser,privlog,auth]).
access_vector(allow,sysadm_t,run_init_t,process,transition).
access_vector(dontaudit,sysadm_t,run_init_t,process,noatsecure).
access_vector(allow,sysadm_t,run_init_exec_t,file,read).
access_vector(allow,sysadm_t,run_init_exec_t,file,getattr).
access_vector(allow,sysadm_t,run_init_exec_t,file,execute).
access_vector(allow,run_init_t,sysadm_t,process,sigchld).
access_vector(allow,run_init_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,run_init_t,fd,use).
access_vector(allow,run_init_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,run_init_t,sysadm_t,fifo_file,read).
access_vector(allow,run_init_t,sysadm_t,fifo_file,getattr).
access_vector(allow,run_init_t,sysadm_t,fifo_file,lock).
access_vector(allow,run_init_t,sysadm_t,fifo_file,write).
access_vector(allow,run_init_t,sysadm_t,fifo_file,append).
access_vector(allow,run_init_t,run_init_exec_t,file,read).
access_vector(allow,run_init_t,run_init_exec_t,file,getattr).
access_vector(allow,run_init_t,run_init_exec_t,file,lock).
access_vector(allow,run_init_t,run_init_exec_t,file,execute).
access_vector(allow,run_init_t,run_init_exec_t,file,ioctl).
access_vector(allow,run_init_t,run_init_exec_t,file,entrypoint).
type_trans(sysadm_t,run_init_exec_t,process,run_init_t).
role_decl(sysadm_r,run_init_t).
access_vector(allow,run_init_t,initrc_var_run_t,file,ioctl).
access_vector(allow,run_init_t,initrc_var_run_t,file,read).
access_vector(allow,run_init_t,initrc_var_run_t,file,getattr).
access_vector(allow,run_init_t,initrc_var_run_t,file,lock).
access_vector(allow,run_init_t,initrc_var_run_t,file,write).
access_vector(allow,run_init_t,initrc_var_run_t,file,append).
access_vector(allow,run_init_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,run_init_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,run_init_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,run_init_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,run_init_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,run_init_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,run_init_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,run_init_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,run_init_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,run_init_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,run_init_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,run_init_t,sysadm_devpts_t,chr_file,append).
access_vector(dontaudit,run_init_t,devpts_t,dir,getattr).
access_vector(dontaudit,run_init_t,devpts_t,dir,read).
access_vector(dontaudit,run_init_t,device_t,dir,read).
access_vector(dontaudit,run_init_t,file_type,dir,search).
access_vector(dontaudit,run_init_t,self,capability,dac_override).
access_vector(dontaudit,run_init_t,self,capability,dac_read_search).
access_vector(allow,run_init_t,bin_t,file,read).
access_vector(allow,run_init_t,bin_t,file,getattr).
access_vector(allow,run_init_t,bin_t,file,lock).
access_vector(allow,run_init_t,bin_t,file,execute).
access_vector(allow,run_init_t,bin_t,file,ioctl).
access_vector(allow,run_init_t,bin_t,file,execute_no_trans).
access_vector(allow,run_init_t,chkpwd_exec_t,file,read).
access_vector(allow,run_init_t,chkpwd_exec_t,file,getattr).
access_vector(allow,run_init_t,chkpwd_exec_t,file,lock).
access_vector(allow,run_init_t,chkpwd_exec_t,file,execute).
access_vector(allow,run_init_t,chkpwd_exec_t,file,ioctl).
access_vector(allow,run_init_t,chkpwd_exec_t,file,execute_no_trans).
access_vector(allow,run_init_t,shell_exec_t,file,read).
access_vector(allow,run_init_t,shell_exec_t,file,getattr).
access_vector(allow,run_init_t,shell_exec_t,file,lock).
access_vector(allow,run_init_t,shell_exec_t,file,execute).
access_vector(allow,run_init_t,shell_exec_t,file,ioctl).
access_vector(allow,run_init_t,shell_exec_t,file,execute_no_trans).
access_vector(allow,run_init_t,initrc_t,process,transition).
access_vector(dontaudit,run_init_t,initrc_t,process,noatsecure).
access_vector(allow,run_init_t,initrc_exec_t,file,read).
access_vector(allow,run_init_t,initrc_exec_t,file,getattr).
access_vector(allow,run_init_t,initrc_exec_t,file,execute).
access_vector(allow,initrc_t,run_init_t,process,sigchld).
access_vector(allow,initrc_t,run_init_t,fd,use).
access_vector(allow,run_init_t,initrc_t,fd,use).
access_vector(allow,initrc_t,run_init_t,fifo_file,ioctl).
access_vector(allow,initrc_t,run_init_t,fifo_file,read).
access_vector(allow,initrc_t,run_init_t,fifo_file,getattr).
access_vector(allow,initrc_t,run_init_t,fifo_file,lock).
access_vector(allow,initrc_t,run_init_t,fifo_file,write).
access_vector(allow,initrc_t,run_init_t,fifo_file,append).
access_vector(allow,initrc_t,initrc_exec_t,file,read).
access_vector(allow,initrc_t,initrc_exec_t,file,getattr).
access_vector(allow,initrc_t,initrc_exec_t,file,lock).
access_vector(allow,initrc_t,initrc_exec_t,file,execute).
access_vector(allow,initrc_t,initrc_exec_t,file,ioctl).
access_vector(allow,initrc_t,initrc_exec_t,file,entrypoint).
access_vector(allow,run_init_t,self,process,setexec).
access_vector(allow,run_init_t,proc_t,dir,search).
access_vector(allow,run_init_t,proc_t,lnk_file,read).
access_vector(allow,run_init_t,self,dir,search).
access_vector(allow,run_init_t,self,file,read).
access_vector(allow,run_init_t,self,file,write).
access_vector(allow,run_init_t,privfd,fd,use).
access_vector(allow,run_init_t,root_t,dir,read).
access_vector(allow,run_init_t,root_t,dir,getattr).
access_vector(allow,run_init_t,root_t,dir,lock).
access_vector(allow,run_init_t,root_t,dir,search).
access_vector(allow,run_init_t,root_t,dir,ioctl).
access_vector(allow,run_init_t,usr_t,dir,read).
access_vector(allow,run_init_t,usr_t,dir,getattr).
access_vector(allow,run_init_t,usr_t,dir,lock).
access_vector(allow,run_init_t,usr_t,dir,search).
access_vector(allow,run_init_t,usr_t,dir,ioctl).
access_vector(allow,run_init_t,lib_t,dir,read).
access_vector(allow,run_init_t,lib_t,dir,getattr).
access_vector(allow,run_init_t,lib_t,dir,lock).
access_vector(allow,run_init_t,lib_t,dir,search).
access_vector(allow,run_init_t,lib_t,dir,ioctl).
access_vector(allow,run_init_t,etc_t,dir,read).
access_vector(allow,run_init_t,etc_t,dir,getattr).
access_vector(allow,run_init_t,etc_t,dir,lock).
access_vector(allow,run_init_t,etc_t,dir,search).
access_vector(allow,run_init_t,etc_t,dir,ioctl).
access_vector(allow,run_init_t,lib_t,lnk_file,read).
access_vector(allow,run_init_t,lib_t,lnk_file,getattr).
access_vector(allow,run_init_t,lib_t,lnk_file,lock).
access_vector(allow,run_init_t,lib_t,lnk_file,ioctl).
access_vector(allow,run_init_t,ld_so_t,file,read).
access_vector(allow,run_init_t,ld_so_t,file,getattr).
access_vector(allow,run_init_t,ld_so_t,file,lock).
access_vector(allow,run_init_t,ld_so_t,file,execute).
access_vector(allow,run_init_t,ld_so_t,file,ioctl).
access_vector(allow,run_init_t,ld_so_t,file,execute_no_trans).
access_vector(allow,run_init_t,ld_so_t,lnk_file,read).
access_vector(allow,run_init_t,ld_so_t,lnk_file,getattr).
access_vector(allow,run_init_t,ld_so_t,lnk_file,lock).
access_vector(allow,run_init_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,run_init_t,shlib_t,file,read).
access_vector(allow,run_init_t,shlib_t,file,getattr).
access_vector(allow,run_init_t,shlib_t,file,lock).
access_vector(allow,run_init_t,shlib_t,file,execute).
access_vector(allow,run_init_t,shlib_t,file,ioctl).
access_vector(allow,run_init_t,shlib_t,lnk_file,read).
access_vector(allow,run_init_t,shlib_t,lnk_file,getattr).
access_vector(allow,run_init_t,shlib_t,lnk_file,lock).
access_vector(allow,run_init_t,shlib_t,lnk_file,ioctl).
access_vector(allow,run_init_t,ld_so_cache_t,file,read).
access_vector(allow,run_init_t,ld_so_cache_t,file,getattr).
access_vector(allow,run_init_t,ld_so_cache_t,file,lock).
access_vector(allow,run_init_t,ld_so_cache_t,file,ioctl).
access_vector(allow,run_init_t,device_t,dir,search).
access_vector(allow,run_init_t,null_device_t,chr_file,ioctl).
access_vector(allow,run_init_t,null_device_t,chr_file,read).
access_vector(allow,run_init_t,null_device_t,chr_file,getattr).
access_vector(allow,run_init_t,null_device_t,chr_file,lock).
access_vector(allow,run_init_t,null_device_t,chr_file,write).
access_vector(allow,run_init_t,null_device_t,chr_file,append).
access_vector(allow,run_init_t,security_t,dir,read).
access_vector(allow,run_init_t,security_t,dir,search).
access_vector(allow,run_init_t,security_t,dir,getattr).
access_vector(allow,run_init_t,security_t,file,getattr).
access_vector(allow,run_init_t,security_t,file,read).
access_vector(allow,run_init_t,security_t,file,write).
access_vector(allow,run_init_t,security_t,security,check_context).
access_vector(allow,run_init_t,security_t,security,compute_av).
access_vector(allow,run_init_t,security_t,security,compute_create).
access_vector(allow,run_init_t,security_t,security,compute_relabel).
access_vector(allow,run_init_t,security_t,security,compute_user).
access_vector(allow,run_init_t,self,unix_stream_socket,create).
access_vector(allow,run_init_t,self,unix_stream_socket,ioctl).
access_vector(allow,run_init_t,self,unix_stream_socket,read).
access_vector(allow,run_init_t,self,unix_stream_socket,getattr).
access_vector(allow,run_init_t,self,unix_stream_socket,write).
access_vector(allow,run_init_t,self,unix_stream_socket,setattr).
access_vector(allow,run_init_t,self,unix_stream_socket,append).
access_vector(allow,run_init_t,self,unix_stream_socket,bind).
access_vector(allow,run_init_t,self,unix_stream_socket,connect).
access_vector(allow,run_init_t,self,unix_stream_socket,getopt).
access_vector(allow,run_init_t,self,unix_stream_socket,setopt).
access_vector(allow,run_init_t,self,unix_stream_socket,shutdown).
access_vector(allow,run_init_t,self,unix_dgram_socket,create).
access_vector(allow,run_init_t,self,unix_dgram_socket,ioctl).
access_vector(allow,run_init_t,self,unix_dgram_socket,read).
access_vector(allow,run_init_t,self,unix_dgram_socket,getattr).
access_vector(allow,run_init_t,self,unix_dgram_socket,write).
access_vector(allow,run_init_t,self,unix_dgram_socket,setattr).
access_vector(allow,run_init_t,self,unix_dgram_socket,append).
access_vector(allow,run_init_t,self,unix_dgram_socket,bind).
access_vector(allow,run_init_t,self,unix_dgram_socket,connect).
access_vector(allow,run_init_t,self,unix_dgram_socket,getopt).
access_vector(allow,run_init_t,self,unix_dgram_socket,setopt).
access_vector(allow,run_init_t,self,unix_dgram_socket,shutdown).
access_vector(allow,run_init_t,etc_t,file,getattr).
access_vector(allow,run_init_t,etc_t,file,read).
access_vector(allow,run_init_t,etc_t,lnk_file,read).
access_vector(allow,run_init_t,locale_t,dir,read).
access_vector(allow,run_init_t,locale_t,dir,getattr).
access_vector(allow,run_init_t,locale_t,dir,lock).
access_vector(allow,run_init_t,locale_t,dir,search).
access_vector(allow,run_init_t,locale_t,dir,ioctl).
access_vector(allow,run_init_t,locale_t,file,read).
access_vector(allow,run_init_t,locale_t,file,getattr).
access_vector(allow,run_init_t,locale_t,file,lock).
access_vector(allow,run_init_t,locale_t,file,ioctl).
access_vector(allow,run_init_t,locale_t,lnk_file,read).
access_vector(allow,run_init_t,locale_t,lnk_file,getattr).
access_vector(allow,run_init_t,locale_t,lnk_file,lock).
access_vector(allow,run_init_t,locale_t,lnk_file,ioctl).
access_vector(allow,run_init_t,fs_t,filesystem,getattr).
access_vector(allow,run_init_t,bin_t,dir,search).
access_vector(allow,run_init_t,sbin_t,dir,search).
access_vector(dontaudit,run_init_t,proc_t,dir,getattr).
access_vector(dontaudit,run_init_t,proc_t,dir,search).
access_vector(dontaudit,run_init_t,device_t,dir,getattr).
access_vector(dontaudit,run_init_t,device_t,dir,search).
access_vector(allow,initrc_t,privfd,fd,use).
type_decl(init_t,[],[domain,privlog,mlstrustedreader,mlstrustedwriter]).
role_decl(system_r,init_t).
access_vector(allow,init_t,root_t,dir,read).
access_vector(allow,init_t,root_t,dir,getattr).
access_vector(allow,init_t,root_t,dir,lock).
access_vector(allow,init_t,root_t,dir,search).
access_vector(allow,init_t,root_t,dir,ioctl).
access_vector(allow,init_t,usr_t,dir,read).
access_vector(allow,init_t,usr_t,dir,getattr).
access_vector(allow,init_t,usr_t,dir,lock).
access_vector(allow,init_t,usr_t,dir,search).
access_vector(allow,init_t,usr_t,dir,ioctl).
access_vector(allow,init_t,lib_t,dir,read).
access_vector(allow,init_t,lib_t,dir,getattr).
access_vector(allow,init_t,lib_t,dir,lock).
access_vector(allow,init_t,lib_t,dir,search).
access_vector(allow,init_t,lib_t,dir,ioctl).
access_vector(allow,init_t,etc_t,dir,read).
access_vector(allow,init_t,etc_t,dir,getattr).
access_vector(allow,init_t,etc_t,dir,lock).
access_vector(allow,init_t,etc_t,dir,search).
access_vector(allow,init_t,etc_t,dir,ioctl).
access_vector(allow,init_t,lib_t,lnk_file,read).
access_vector(allow,init_t,lib_t,lnk_file,getattr).
access_vector(allow,init_t,lib_t,lnk_file,lock).
access_vector(allow,init_t,lib_t,lnk_file,ioctl).
access_vector(allow,init_t,ld_so_t,file,read).
access_vector(allow,init_t,ld_so_t,file,getattr).
access_vector(allow,init_t,ld_so_t,file,lock).
access_vector(allow,init_t,ld_so_t,file,execute).
access_vector(allow,init_t,ld_so_t,file,ioctl).
access_vector(allow,init_t,ld_so_t,file,execute_no_trans).
access_vector(allow,init_t,ld_so_t,lnk_file,read).
access_vector(allow,init_t,ld_so_t,lnk_file,getattr).
access_vector(allow,init_t,ld_so_t,lnk_file,lock).
access_vector(allow,init_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,init_t,shlib_t,file,read).
access_vector(allow,init_t,shlib_t,file,getattr).
access_vector(allow,init_t,shlib_t,file,lock).
access_vector(allow,init_t,shlib_t,file,execute).
access_vector(allow,init_t,shlib_t,file,ioctl).
access_vector(allow,init_t,shlib_t,lnk_file,read).
access_vector(allow,init_t,shlib_t,lnk_file,getattr).
access_vector(allow,init_t,shlib_t,lnk_file,lock).
access_vector(allow,init_t,shlib_t,lnk_file,ioctl).
access_vector(allow,init_t,ld_so_cache_t,file,read).
access_vector(allow,init_t,ld_so_cache_t,file,getattr).
access_vector(allow,init_t,ld_so_cache_t,file,lock).
access_vector(allow,init_t,ld_so_cache_t,file,ioctl).
access_vector(allow,init_t,device_t,dir,search).
access_vector(allow,init_t,null_device_t,chr_file,ioctl).
access_vector(allow,init_t,null_device_t,chr_file,read).
access_vector(allow,init_t,null_device_t,chr_file,getattr).
access_vector(allow,init_t,null_device_t,chr_file,lock).
access_vector(allow,init_t,null_device_t,chr_file,write).
access_vector(allow,init_t,null_device_t,chr_file,append).
type_decl(init_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(initctl_t,[],[file_type,sysadmfile]).
type_decl(sulogin_exec_t,[],[file_type,exec_type,sysadmfile]).
access_vector(allow,init_t,file_t,dir,search).
access_vector(allow,init_t,init_t,capability,except(sys_module)).
access_vector(allow,init_t,initrc_t,process,transition).
access_vector(dontaudit,init_t,initrc_t,process,noatsecure).
access_vector(allow,init_t,initrc_exec_t,file,read).
access_vector(allow,init_t,initrc_exec_t,file,getattr).
access_vector(allow,init_t,initrc_exec_t,file,execute).
access_vector(allow,initrc_t,init_t,process,sigchld).
access_vector(allow,initrc_t,init_t,fd,use).
access_vector(allow,init_t,initrc_t,fd,use).
access_vector(allow,initrc_t,init_t,fifo_file,ioctl).
access_vector(allow,initrc_t,init_t,fifo_file,read).
access_vector(allow,initrc_t,init_t,fifo_file,getattr).
access_vector(allow,initrc_t,init_t,fifo_file,lock).
access_vector(allow,initrc_t,init_t,fifo_file,write).
access_vector(allow,initrc_t,init_t,fifo_file,append).
access_vector(allow,initrc_t,initrc_exec_t,file,entrypoint).
type_trans(init_t,initrc_exec_t,process,initrc_t).
access_vector(allow,init_t,sysadm_t,process,transition).
access_vector(dontaudit,init_t,sysadm_t,process,noatsecure).
access_vector(allow,init_t,shell_exec_t,file,read).
access_vector(allow,init_t,shell_exec_t,file,getattr).
access_vector(allow,init_t,shell_exec_t,file,execute).
access_vector(allow,sysadm_t,init_t,process,sigchld).
access_vector(allow,sysadm_t,init_t,fd,use).
access_vector(allow,init_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,init_t,fifo_file,ioctl).
access_vector(allow,sysadm_t,init_t,fifo_file,read).
access_vector(allow,sysadm_t,init_t,fifo_file,getattr).
access_vector(allow,sysadm_t,init_t,fifo_file,lock).
access_vector(allow,sysadm_t,init_t,fifo_file,write).
access_vector(allow,sysadm_t,init_t,fifo_file,append).
access_vector(allow,sysadm_t,shell_exec_t,file,entrypoint).
type_trans(init_t,shell_exec_t,process,sysadm_t).
access_vector(allow,init_t,sysadm_t,process,transition).
access_vector(dontaudit,init_t,sysadm_t,process,noatsecure).
access_vector(allow,init_t,sulogin_exec_t,file,read).
access_vector(allow,init_t,sulogin_exec_t,file,getattr).
access_vector(allow,init_t,sulogin_exec_t,file,execute).
access_vector(allow,sysadm_t,init_t,process,sigchld).
access_vector(allow,sysadm_t,init_t,fd,use).
access_vector(allow,init_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,sulogin_exec_t,file,read).
access_vector(allow,sysadm_t,sulogin_exec_t,file,getattr).
access_vector(allow,sysadm_t,sulogin_exec_t,file,lock).
access_vector(allow,sysadm_t,sulogin_exec_t,file,execute).
access_vector(allow,sysadm_t,sulogin_exec_t,file,ioctl).
access_vector(allow,sysadm_t,sulogin_exec_t,file,entrypoint).
type_trans(init_t,sulogin_exec_t,process,sysadm_t).
access_vector(allow,init_t,sbin_t,file,read).
access_vector(allow,init_t,sbin_t,file,getattr).
access_vector(allow,init_t,sbin_t,file,lock).
access_vector(allow,init_t,sbin_t,file,execute).
access_vector(allow,init_t,sbin_t,file,ioctl).
access_vector(allow,init_t,sbin_t,file,execute_no_trans).
access_vector(allow,init_t,init_exec_t,file,read).
access_vector(allow,init_t,init_exec_t,file,getattr).
access_vector(allow,init_t,init_exec_t,file,lock).
access_vector(allow,init_t,init_exec_t,file,execute).
access_vector(allow,init_t,init_exec_t,file,ioctl).
access_vector(allow,init_t,init_exec_t,file,execute_no_trans).
access_vector(allow,init_t,device_t,dir,read).
access_vector(allow,init_t,device_t,dir,getattr).
access_vector(allow,init_t,device_t,dir,lock).
access_vector(allow,init_t,device_t,dir,search).
access_vector(allow,init_t,device_t,dir,ioctl).
access_vector(allow,init_t,device_t,dir,add_name).
access_vector(allow,init_t,device_t,dir,remove_name).
access_vector(allow,init_t,device_t,dir,write).
access_vector(allow,init_t,initctl_t,fifo_file,create).
access_vector(allow,init_t,initctl_t,fifo_file,ioctl).
access_vector(allow,init_t,initctl_t,fifo_file,read).
access_vector(allow,init_t,initctl_t,fifo_file,getattr).
access_vector(allow,init_t,initctl_t,fifo_file,lock).
access_vector(allow,init_t,initctl_t,fifo_file,write).
access_vector(allow,init_t,initctl_t,fifo_file,setattr).
access_vector(allow,init_t,initctl_t,fifo_file,append).
access_vector(allow,init_t,initctl_t,fifo_file,link).
access_vector(allow,init_t,initctl_t,fifo_file,unlink).
access_vector(allow,init_t,initctl_t,fifo_file,rename).
type_trans(init_t,device_t,fifo_file,initctl_t).
access_vector(allow,init_t,etc_t,dir,read).
access_vector(allow,init_t,etc_t,dir,getattr).
access_vector(allow,init_t,etc_t,dir,lock).
access_vector(allow,init_t,etc_t,dir,search).
access_vector(allow,init_t,etc_t,dir,ioctl).
access_vector(allow,init_t,etc_t,dir,add_name).
access_vector(allow,init_t,etc_t,dir,remove_name).
access_vector(allow,init_t,etc_t,dir,write).
access_vector(allow,init_t,etc_runtime_t,file,create).
access_vector(allow,init_t,etc_runtime_t,file,ioctl).
access_vector(allow,init_t,etc_runtime_t,file,read).
access_vector(allow,init_t,etc_runtime_t,file,getattr).
access_vector(allow,init_t,etc_runtime_t,file,lock).
access_vector(allow,init_t,etc_runtime_t,file,write).
access_vector(allow,init_t,etc_runtime_t,file,setattr).
access_vector(allow,init_t,etc_runtime_t,file,append).
access_vector(allow,init_t,etc_runtime_t,file,link).
access_vector(allow,init_t,etc_runtime_t,file,unlink).
access_vector(allow,init_t,etc_runtime_t,file,rename).
type_trans(init_t,etc_t,file,etc_runtime_t).
access_vector(allow,init_t,ld_so_cache_t,file,ioctl).
access_vector(allow,init_t,ld_so_cache_t,file,read).
access_vector(allow,init_t,ld_so_cache_t,file,getattr).
access_vector(allow,init_t,ld_so_cache_t,file,lock).
access_vector(allow,init_t,ld_so_cache_t,file,write).
access_vector(allow,init_t,ld_so_cache_t,file,append).
access_vector(allow,init_t,var_t,dir,search).
access_vector(allow,init_t,var_log_t,dir,search).
access_vector(allow,init_t,etc_t,lnk_file,read).
access_vector(allow,init_t,locale_t,dir,read).
access_vector(allow,init_t,locale_t,dir,getattr).
access_vector(allow,init_t,locale_t,dir,lock).
access_vector(allow,init_t,locale_t,dir,search).
access_vector(allow,init_t,locale_t,dir,ioctl).
access_vector(allow,init_t,locale_t,file,read).
access_vector(allow,init_t,locale_t,file,getattr).
access_vector(allow,init_t,locale_t,file,lock).
access_vector(allow,init_t,locale_t,file,ioctl).
access_vector(allow,init_t,locale_t,lnk_file,read).
access_vector(allow,init_t,locale_t,lnk_file,getattr).
access_vector(allow,init_t,locale_t,lnk_file,lock).
access_vector(allow,init_t,locale_t,lnk_file,ioctl).
access_vector(allow,init_t,self,unix_dgram_socket,create).
access_vector(allow,init_t,self,unix_dgram_socket,ioctl).
access_vector(allow,init_t,self,unix_dgram_socket,read).
access_vector(allow,init_t,self,unix_dgram_socket,getattr).
access_vector(allow,init_t,self,unix_dgram_socket,write).
access_vector(allow,init_t,self,unix_dgram_socket,setattr).
access_vector(allow,init_t,self,unix_dgram_socket,append).
access_vector(allow,init_t,self,unix_dgram_socket,bind).
access_vector(allow,init_t,self,unix_dgram_socket,connect).
access_vector(allow,init_t,self,unix_dgram_socket,getopt).
access_vector(allow,init_t,self,unix_dgram_socket,setopt).
access_vector(allow,init_t,self,unix_dgram_socket,shutdown).
access_vector(allow,init_t,self,unix_stream_socket,create).
access_vector(allow,init_t,self,unix_stream_socket,ioctl).
access_vector(allow,init_t,self,unix_stream_socket,read).
access_vector(allow,init_t,self,unix_stream_socket,getattr).
access_vector(allow,init_t,self,unix_stream_socket,write).
access_vector(allow,init_t,self,unix_stream_socket,setattr).
access_vector(allow,init_t,self,unix_stream_socket,append).
access_vector(allow,init_t,self,unix_stream_socket,bind).
access_vector(allow,init_t,self,unix_stream_socket,connect).
access_vector(allow,init_t,self,unix_stream_socket,getopt).
access_vector(allow,init_t,self,unix_stream_socket,setopt).
access_vector(allow,init_t,self,unix_stream_socket,shutdown).
access_vector(allow,init_t,self,fifo_file,ioctl).
access_vector(allow,init_t,self,fifo_file,read).
access_vector(allow,init_t,self,fifo_file,getattr).
access_vector(allow,init_t,self,fifo_file,lock).
access_vector(allow,init_t,self,fifo_file,write).
access_vector(allow,init_t,self,fifo_file,append).
access_vector(allow,init_t,bin_t,dir,read).
access_vector(allow,init_t,bin_t,dir,getattr).
access_vector(allow,init_t,bin_t,dir,lock).
access_vector(allow,init_t,bin_t,dir,search).
access_vector(allow,init_t,bin_t,dir,ioctl).
access_vector(allow,init_t,bin_t,file,read).
access_vector(allow,init_t,bin_t,file,getattr).
access_vector(allow,init_t,bin_t,file,lock).
access_vector(allow,init_t,bin_t,file,ioctl).
access_vector(allow,init_t,bin_t,lnk_file,read).
access_vector(allow,init_t,bin_t,lnk_file,getattr).
access_vector(allow,init_t,bin_t,lnk_file,lock).
access_vector(allow,init_t,bin_t,lnk_file,ioctl).
access_vector(allow,init_t,bin_t,sock_file,read).
access_vector(allow,init_t,bin_t,sock_file,getattr).
access_vector(allow,init_t,bin_t,sock_file,lock).
access_vector(allow,init_t,bin_t,sock_file,ioctl).
access_vector(allow,init_t,bin_t,fifo_file,read).
access_vector(allow,init_t,bin_t,fifo_file,getattr).
access_vector(allow,init_t,bin_t,fifo_file,lock).
access_vector(allow,init_t,bin_t,fifo_file,ioctl).
access_vector(allow,init_t,exec_type,file,read).
access_vector(allow,init_t,exec_type,file,getattr).
access_vector(allow,init_t,exec_type,file,lock).
access_vector(allow,init_t,exec_type,file,ioctl).
access_vector(allow,init_t,exec_type,lnk_file,read).
access_vector(allow,init_t,exec_type,lnk_file,getattr).
access_vector(allow,init_t,exec_type,lnk_file,lock).
access_vector(allow,init_t,exec_type,lnk_file,ioctl).
access_vector(allow,init_t,sbin_t,dir,read).
access_vector(allow,init_t,sbin_t,dir,getattr).
access_vector(allow,init_t,sbin_t,dir,lock).
access_vector(allow,init_t,sbin_t,dir,search).
access_vector(allow,init_t,sbin_t,dir,ioctl).
access_vector(allow,init_t,sbin_t,file,read).
access_vector(allow,init_t,sbin_t,file,getattr).
access_vector(allow,init_t,sbin_t,file,lock).
access_vector(allow,init_t,sbin_t,file,ioctl).
access_vector(allow,init_t,sbin_t,lnk_file,read).
access_vector(allow,init_t,sbin_t,lnk_file,getattr).
access_vector(allow,init_t,sbin_t,lnk_file,lock).
access_vector(allow,init_t,sbin_t,lnk_file,ioctl).
access_vector(allow,init_t,sbin_t,sock_file,read).
access_vector(allow,init_t,sbin_t,sock_file,getattr).
access_vector(allow,init_t,sbin_t,sock_file,lock).
access_vector(allow,init_t,sbin_t,sock_file,ioctl).
access_vector(allow,init_t,sbin_t,fifo_file,read).
access_vector(allow,init_t,sbin_t,fifo_file,getattr).
access_vector(allow,init_t,sbin_t,fifo_file,lock).
access_vector(allow,init_t,sbin_t,fifo_file,ioctl).
access_vector(allow,init_t,self,process,fork).
access_vector(allow,init_t,self,process,sigchld).
access_vector(allow,init_t,var_run_t,file,ioctl).
access_vector(allow,init_t,var_run_t,file,read).
access_vector(allow,init_t,var_run_t,file,getattr).
access_vector(allow,init_t,var_run_t,file,lock).
access_vector(allow,init_t,var_run_t,file,write).
access_vector(allow,init_t,var_run_t,file,append).
access_vector(allow,init_t,initrc_var_run_t,file,setattr).
access_vector(allow,init_t,initrc_var_run_t,file,ioctl).
access_vector(allow,init_t,initrc_var_run_t,file,read).
access_vector(allow,init_t,initrc_var_run_t,file,getattr).
access_vector(allow,init_t,initrc_var_run_t,file,lock).
access_vector(allow,init_t,initrc_var_run_t,file,write).
access_vector(allow,init_t,initrc_var_run_t,file,append).
type_decl(init_var_run_t,var_run_init_t,[file_type,sysadmfile,pidfile]).
access_vector(allow,init_t,var_run_t,dir,read).
access_vector(allow,init_t,var_run_t,dir,getattr).
access_vector(allow,init_t,var_run_t,dir,lock).
access_vector(allow,init_t,var_run_t,dir,search).
access_vector(allow,init_t,var_run_t,dir,ioctl).
access_vector(allow,init_t,var_run_t,dir,add_name).
access_vector(allow,init_t,var_run_t,dir,remove_name).
access_vector(allow,init_t,var_run_t,dir,write).
access_vector(allow,init_t,init_var_run_t,file,create).
access_vector(allow,init_t,init_var_run_t,file,ioctl).
access_vector(allow,init_t,init_var_run_t,file,read).
access_vector(allow,init_t,init_var_run_t,file,getattr).
access_vector(allow,init_t,init_var_run_t,file,lock).
access_vector(allow,init_t,init_var_run_t,file,write).
access_vector(allow,init_t,init_var_run_t,file,setattr).
access_vector(allow,init_t,init_var_run_t,file,append).
access_vector(allow,init_t,init_var_run_t,file,link).
access_vector(allow,init_t,init_var_run_t,file,unlink).
access_vector(allow,init_t,init_var_run_t,file,rename).
type_trans(init_t,var_run_t,file,init_var_run_t).
access_vector(allow,init_t,init_var_run_t,dir,read).
access_vector(allow,init_t,init_var_run_t,dir,getattr).
access_vector(allow,init_t,init_var_run_t,dir,lock).
access_vector(allow,init_t,init_var_run_t,dir,search).
access_vector(allow,init_t,init_var_run_t,dir,ioctl).
access_vector(allow,init_t,init_var_run_t,dir,add_name).
access_vector(allow,init_t,init_var_run_t,dir,remove_name).
access_vector(allow,init_t,init_var_run_t,dir,write).
access_vector(allow,init_t,proc_t,dir,read).
access_vector(allow,init_t,proc_t,dir,getattr).
access_vector(allow,init_t,proc_t,dir,lock).
access_vector(allow,init_t,proc_t,dir,search).
access_vector(allow,init_t,proc_t,dir,ioctl).
access_vector(allow,init_t,proc_t,lnk_file,read).
access_vector(allow,init_t,proc_t,lnk_file,getattr).
access_vector(allow,init_t,proc_t,lnk_file,lock).
access_vector(allow,init_t,proc_t,lnk_file,ioctl).
access_vector(allow,init_t,self,dir,read).
access_vector(allow,init_t,self,dir,getattr).
access_vector(allow,init_t,self,dir,lock).
access_vector(allow,init_t,self,dir,search).
access_vector(allow,init_t,self,dir,ioctl).
access_vector(allow,init_t,self,lnk_file,read).
access_vector(allow,init_t,self,lnk_file,getattr).
access_vector(allow,init_t,self,lnk_file,lock).
access_vector(allow,init_t,self,lnk_file,ioctl).
access_vector(allow,init_t,devpts_t,dir,read).
access_vector(allow,init_t,devpts_t,dir,getattr).
access_vector(allow,init_t,devpts_t,dir,lock).
access_vector(allow,init_t,devpts_t,dir,ioctl).
access_vector(allow,init_t,wtmp_t,file,ioctl).
access_vector(allow,init_t,wtmp_t,file,read).
access_vector(allow,init_t,wtmp_t,file,getattr).
access_vector(allow,init_t,wtmp_t,file,lock).
access_vector(allow,init_t,wtmp_t,file,write).
access_vector(allow,init_t,wtmp_t,file,append).
access_vector(allow,init_t,domain,process,sigchld).
access_vector(allow,init_t,domain,process,sigkill).
access_vector(allow,init_t,domain,process,sigstop).
access_vector(allow,init_t,domain,process,signull).
access_vector(allow,init_t,domain,process,signal).
access_vector(allow,domain,init_t,process,sigchld).
access_vector(allow,domain,init_t,process,signull).
access_vector(allow,unlabeled_t,init_t,process,sigchld).
access_vector(allow,init_t,console_device_t,chr_file,ioctl).
access_vector(allow,init_t,console_device_t,chr_file,read).
access_vector(allow,init_t,console_device_t,chr_file,getattr).
access_vector(allow,init_t,console_device_t,chr_file,lock).
access_vector(allow,init_t,console_device_t,chr_file,write).
access_vector(allow,init_t,console_device_t,chr_file,append).
access_vector(allow,init_t,tty_device_t,chr_file,ioctl).
access_vector(allow,init_t,tty_device_t,chr_file,read).
access_vector(allow,init_t,tty_device_t,chr_file,getattr).
access_vector(allow,init_t,tty_device_t,chr_file,lock).
access_vector(allow,init_t,tty_device_t,chr_file,write).
access_vector(allow,init_t,tty_device_t,chr_file,append).
access_vector(allow,init_t,ttyfile,chr_file,ioctl).
access_vector(allow,init_t,ttyfile,chr_file,read).
access_vector(allow,init_t,ttyfile,chr_file,getattr).
access_vector(allow,init_t,ttyfile,chr_file,lock).
access_vector(allow,init_t,ttyfile,chr_file,write).
access_vector(allow,init_t,ttyfile,chr_file,append).
access_vector(allow,init_t,ptyfile,chr_file,ioctl).
access_vector(allow,init_t,ptyfile,chr_file,read).
access_vector(allow,init_t,ptyfile,chr_file,getattr).
access_vector(allow,init_t,ptyfile,chr_file,lock).
access_vector(allow,init_t,ptyfile,chr_file,write).
access_vector(allow,init_t,ptyfile,chr_file,append).
access_vector(allow,init_t,bin_t,file,read).
access_vector(allow,init_t,bin_t,file,getattr).
access_vector(allow,init_t,bin_t,file,lock).
access_vector(allow,init_t,bin_t,file,execute).
access_vector(allow,init_t,bin_t,file,ioctl).
access_vector(allow,init_t,bin_t,file,execute_no_trans).
access_vector(allow,init_t,etc_t,file,read).
access_vector(allow,init_t,etc_t,file,getattr).
access_vector(allow,init_t,etc_t,file,lock).
access_vector(allow,init_t,etc_t,file,execute).
access_vector(allow,init_t,etc_t,file,ioctl).
access_vector(allow,init_t,etc_t,file,execute_no_trans).
access_vector(dontaudit,init_t,file_labels_t,dir,search).
type_decl(klogd_t,[],[domain,privlog,privmem]).
type_decl(klogd_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(system_r,klogd_t).
access_vector(allow,initrc_t,klogd_t,process,transition).
access_vector(dontaudit,initrc_t,klogd_t,process,noatsecure).
access_vector(allow,initrc_t,klogd_exec_t,file,read).
access_vector(allow,initrc_t,klogd_exec_t,file,getattr).
access_vector(allow,initrc_t,klogd_exec_t,file,execute).
access_vector(allow,klogd_t,initrc_t,process,sigchld).
access_vector(allow,klogd_t,initrc_t,fd,use).
access_vector(allow,initrc_t,klogd_t,fd,use).
access_vector(allow,klogd_t,initrc_t,fifo_file,ioctl).
access_vector(allow,klogd_t,initrc_t,fifo_file,read).
access_vector(allow,klogd_t,initrc_t,fifo_file,getattr).
access_vector(allow,klogd_t,initrc_t,fifo_file,lock).
access_vector(allow,klogd_t,initrc_t,fifo_file,write).
access_vector(allow,klogd_t,initrc_t,fifo_file,append).
access_vector(allow,klogd_t,klogd_exec_t,file,entrypoint).
type_trans(initrc_t,klogd_exec_t,process,klogd_t).
access_vector(allow,klogd_t,init_t,fd,use).
access_vector(allow,klogd_t,init_t,process,sigchld).
access_vector(allow,klogd_t,privfd,fd,use).
access_vector(allow,klogd_t,newrole_t,process,sigchld).
access_vector(allow,klogd_t,self,process,sigchld).
access_vector(allow,klogd_t,self,process,sigkill).
access_vector(allow,klogd_t,self,process,sigstop).
access_vector(allow,klogd_t,self,process,signull).
access_vector(allow,klogd_t,self,process,signal).
access_vector(allow,klogd_t,self,process,fork).
access_vector(allow,klogd_t,root_t,dir,read).
access_vector(allow,klogd_t,root_t,dir,getattr).
access_vector(allow,klogd_t,root_t,dir,lock).
access_vector(allow,klogd_t,root_t,dir,search).
access_vector(allow,klogd_t,root_t,dir,ioctl).
access_vector(allow,klogd_t,usr_t,dir,read).
access_vector(allow,klogd_t,usr_t,dir,getattr).
access_vector(allow,klogd_t,usr_t,dir,lock).
access_vector(allow,klogd_t,usr_t,dir,search).
access_vector(allow,klogd_t,usr_t,dir,ioctl).
access_vector(allow,klogd_t,lib_t,dir,read).
access_vector(allow,klogd_t,lib_t,dir,getattr).
access_vector(allow,klogd_t,lib_t,dir,lock).
access_vector(allow,klogd_t,lib_t,dir,search).
access_vector(allow,klogd_t,lib_t,dir,ioctl).
access_vector(allow,klogd_t,etc_t,dir,read).
access_vector(allow,klogd_t,etc_t,dir,getattr).
access_vector(allow,klogd_t,etc_t,dir,lock).
access_vector(allow,klogd_t,etc_t,dir,search).
access_vector(allow,klogd_t,etc_t,dir,ioctl).
access_vector(allow,klogd_t,lib_t,lnk_file,read).
access_vector(allow,klogd_t,lib_t,lnk_file,getattr).
access_vector(allow,klogd_t,lib_t,lnk_file,lock).
access_vector(allow,klogd_t,lib_t,lnk_file,ioctl).
access_vector(allow,klogd_t,ld_so_t,file,read).
access_vector(allow,klogd_t,ld_so_t,file,getattr).
access_vector(allow,klogd_t,ld_so_t,file,lock).
access_vector(allow,klogd_t,ld_so_t,file,execute).
access_vector(allow,klogd_t,ld_so_t,file,ioctl).
access_vector(allow,klogd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,klogd_t,ld_so_t,lnk_file,read).
access_vector(allow,klogd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,klogd_t,ld_so_t,lnk_file,lock).
access_vector(allow,klogd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,klogd_t,shlib_t,file,read).
access_vector(allow,klogd_t,shlib_t,file,getattr).
access_vector(allow,klogd_t,shlib_t,file,lock).
access_vector(allow,klogd_t,shlib_t,file,execute).
access_vector(allow,klogd_t,shlib_t,file,ioctl).
access_vector(allow,klogd_t,shlib_t,lnk_file,read).
access_vector(allow,klogd_t,shlib_t,lnk_file,getattr).
access_vector(allow,klogd_t,shlib_t,lnk_file,lock).
access_vector(allow,klogd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,klogd_t,ld_so_cache_t,file,read).
access_vector(allow,klogd_t,ld_so_cache_t,file,getattr).
access_vector(allow,klogd_t,ld_so_cache_t,file,lock).
access_vector(allow,klogd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,klogd_t,device_t,dir,search).
access_vector(allow,klogd_t,null_device_t,chr_file,ioctl).
access_vector(allow,klogd_t,null_device_t,chr_file,read).
access_vector(allow,klogd_t,null_device_t,chr_file,getattr).
access_vector(allow,klogd_t,null_device_t,chr_file,lock).
access_vector(allow,klogd_t,null_device_t,chr_file,write).
access_vector(allow,klogd_t,null_device_t,chr_file,append).
access_vector(allow,klogd_t,self,dir,read).
access_vector(allow,klogd_t,self,dir,getattr).
access_vector(allow,klogd_t,self,dir,lock).
access_vector(allow,klogd_t,self,dir,search).
access_vector(allow,klogd_t,self,dir,ioctl).
access_vector(allow,klogd_t,proc_t,dir,read).
access_vector(allow,klogd_t,proc_t,dir,getattr).
access_vector(allow,klogd_t,proc_t,dir,lock).
access_vector(allow,klogd_t,proc_t,dir,search).
access_vector(allow,klogd_t,proc_t,dir,ioctl).
access_vector(allow,klogd_t,self,lnk_file,read).
access_vector(allow,klogd_t,proc_t,lnk_file,read).
access_vector(allow,klogd_t,device_t,dir,getattr).
access_vector(allow,klogd_t,device_t,dir,search).
access_vector(allow,klogd_t,console_device_t,chr_file,ioctl).
access_vector(allow,klogd_t,console_device_t,chr_file,read).
access_vector(allow,klogd_t,console_device_t,chr_file,getattr).
access_vector(allow,klogd_t,console_device_t,chr_file,lock).
access_vector(allow,klogd_t,console_device_t,chr_file,write).
access_vector(allow,klogd_t,console_device_t,chr_file,append).
access_vector(allow,klogd_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,klogd_t,initrc_devpts_t,chr_file,read).
access_vector(allow,klogd_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,klogd_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,klogd_t,initrc_devpts_t,chr_file,write).
access_vector(allow,klogd_t,initrc_devpts_t,chr_file,append).
access_vector(allow,klogd_t,var_t,dir,getattr).
access_vector(allow,klogd_t,var_t,dir,search).
type_decl(klogd_var_run_t,var_run_klogd_t,[file_type,sysadmfile,pidfile]).
access_vector(allow,klogd_t,var_run_t,dir,read).
access_vector(allow,klogd_t,var_run_t,dir,getattr).
access_vector(allow,klogd_t,var_run_t,dir,lock).
access_vector(allow,klogd_t,var_run_t,dir,search).
access_vector(allow,klogd_t,var_run_t,dir,ioctl).
access_vector(allow,klogd_t,var_run_t,dir,add_name).
access_vector(allow,klogd_t,var_run_t,dir,remove_name).
access_vector(allow,klogd_t,var_run_t,dir,write).
access_vector(allow,klogd_t,klogd_var_run_t,file,create).
access_vector(allow,klogd_t,klogd_var_run_t,file,ioctl).
access_vector(allow,klogd_t,klogd_var_run_t,file,read).
access_vector(allow,klogd_t,klogd_var_run_t,file,getattr).
access_vector(allow,klogd_t,klogd_var_run_t,file,lock).
access_vector(allow,klogd_t,klogd_var_run_t,file,write).
access_vector(allow,klogd_t,klogd_var_run_t,file,setattr).
access_vector(allow,klogd_t,klogd_var_run_t,file,append).
access_vector(allow,klogd_t,klogd_var_run_t,file,link).
access_vector(allow,klogd_t,klogd_var_run_t,file,unlink).
access_vector(allow,klogd_t,klogd_var_run_t,file,rename).
type_trans(klogd_t,var_run_t,file,klogd_var_run_t).
access_vector(allow,klogd_t,klogd_var_run_t,dir,read).
access_vector(allow,klogd_t,klogd_var_run_t,dir,getattr).
access_vector(allow,klogd_t,klogd_var_run_t,dir,lock).
access_vector(allow,klogd_t,klogd_var_run_t,dir,search).
access_vector(allow,klogd_t,klogd_var_run_t,dir,ioctl).
access_vector(allow,klogd_t,klogd_var_run_t,dir,add_name).
access_vector(allow,klogd_t,klogd_var_run_t,dir,remove_name).
access_vector(allow,klogd_t,klogd_var_run_t,dir,write).
access_vector(allow,klogd_t,devtty_t,chr_file,ioctl).
access_vector(allow,klogd_t,devtty_t,chr_file,read).
access_vector(allow,klogd_t,devtty_t,chr_file,getattr).
access_vector(allow,klogd_t,devtty_t,chr_file,lock).
access_vector(allow,klogd_t,devtty_t,chr_file,write).
access_vector(allow,klogd_t,devtty_t,chr_file,append).
access_vector(dontaudit,klogd_t,sysadm_home_dir_t,dir,search).
access_vector(allow,klogd_t,fs_type,filesystem,getattr).
access_vector(allow,klogd_t,etc_t,lnk_file,read).
access_vector(allow,klogd_t,locale_t,dir,read).
access_vector(allow,klogd_t,locale_t,dir,getattr).
access_vector(allow,klogd_t,locale_t,dir,lock).
access_vector(allow,klogd_t,locale_t,dir,search).
access_vector(allow,klogd_t,locale_t,dir,ioctl).
access_vector(allow,klogd_t,locale_t,file,read).
access_vector(allow,klogd_t,locale_t,file,getattr).
access_vector(allow,klogd_t,locale_t,file,lock).
access_vector(allow,klogd_t,locale_t,file,ioctl).
access_vector(allow,klogd_t,locale_t,lnk_file,read).
access_vector(allow,klogd_t,locale_t,lnk_file,getattr).
access_vector(allow,klogd_t,locale_t,lnk_file,lock).
access_vector(allow,klogd_t,locale_t,lnk_file,ioctl).
type_decl(klogd_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,klogd_t,tmp_t,dir,read).
access_vector(allow,klogd_t,tmp_t,dir,getattr).
access_vector(allow,klogd_t,tmp_t,dir,lock).
access_vector(allow,klogd_t,tmp_t,dir,search).
access_vector(allow,klogd_t,tmp_t,dir,ioctl).
access_vector(allow,klogd_t,tmp_t,dir,add_name).
access_vector(allow,klogd_t,tmp_t,dir,remove_name).
access_vector(allow,klogd_t,tmp_t,dir,write).
access_vector(allow,klogd_t,klogd_tmp_t,file,create).
access_vector(allow,klogd_t,klogd_tmp_t,file,ioctl).
access_vector(allow,klogd_t,klogd_tmp_t,file,read).
access_vector(allow,klogd_t,klogd_tmp_t,file,getattr).
access_vector(allow,klogd_t,klogd_tmp_t,file,lock).
access_vector(allow,klogd_t,klogd_tmp_t,file,write).
access_vector(allow,klogd_t,klogd_tmp_t,file,setattr).
access_vector(allow,klogd_t,klogd_tmp_t,file,append).
access_vector(allow,klogd_t,klogd_tmp_t,file,link).
access_vector(allow,klogd_t,klogd_tmp_t,file,unlink).
access_vector(allow,klogd_t,klogd_tmp_t,file,rename).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,create).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,ioctl).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,read).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,getattr).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,lock).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,write).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,setattr).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,append).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,link).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,unlink).
access_vector(allow,klogd_t,klogd_tmp_t,lnk_file,rename).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,create).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,ioctl).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,read).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,getattr).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,lock).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,write).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,setattr).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,append).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,link).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,unlink).
access_vector(allow,klogd_t,klogd_tmp_t,sock_file,rename).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,create).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,ioctl).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,read).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,getattr).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,lock).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,write).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,setattr).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,append).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,link).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,unlink).
access_vector(allow,klogd_t,klogd_tmp_t,fifo_file,rename).
access_vector(allow,klogd_t,klogd_tmp_t,dir,create).
access_vector(allow,klogd_t,klogd_tmp_t,dir,read).
access_vector(allow,klogd_t,klogd_tmp_t,dir,getattr).
access_vector(allow,klogd_t,klogd_tmp_t,dir,lock).
access_vector(allow,klogd_t,klogd_tmp_t,dir,setattr).
access_vector(allow,klogd_t,klogd_tmp_t,dir,link).
access_vector(allow,klogd_t,klogd_tmp_t,dir,unlink).
access_vector(allow,klogd_t,klogd_tmp_t,dir,rename).
access_vector(allow,klogd_t,klogd_tmp_t,dir,search).
access_vector(allow,klogd_t,klogd_tmp_t,dir,add_name).
access_vector(allow,klogd_t,klogd_tmp_t,dir,remove_name).
access_vector(allow,klogd_t,klogd_tmp_t,dir,reparent).
access_vector(allow,klogd_t,klogd_tmp_t,dir,write).
access_vector(allow,klogd_t,klogd_tmp_t,dir,rmdir).
type_trans(klogd_t,tmp_t,dir,klogd_tmp_t).
type_trans(klogd_t,tmp_t,[file,lnk_file,sock_file,fifo_file],klogd_tmp_t).
access_vector(allow,klogd_t,proc_t,lnk_file,read).
access_vector(allow,klogd_t,proc_t,lnk_file,getattr).
access_vector(allow,klogd_t,proc_t,lnk_file,lock).
access_vector(allow,klogd_t,proc_t,lnk_file,ioctl).
access_vector(allow,klogd_t,proc_t,file,getattr).
access_vector(allow,klogd_t,proc_t,file,read).
access_vector(allow,klogd_t,self,lnk_file,read).
access_vector(allow,klogd_t,self,lnk_file,getattr).
access_vector(allow,klogd_t,self,lnk_file,lock).
access_vector(allow,klogd_t,self,lnk_file,ioctl).
access_vector(allow,klogd_t,etc_t,lnk_file,read).
access_vector(allow,klogd_t,etc_t,file,read).
access_vector(allow,klogd_t,etc_t,file,getattr).
access_vector(allow,klogd_t,etc_t,file,lock).
access_vector(allow,klogd_t,etc_t,file,ioctl).
access_vector(allow,klogd_t,etc_t,lnk_file,read).
access_vector(allow,klogd_t,etc_runtime_t,file,getattr).
access_vector(allow,klogd_t,etc_runtime_t,file,read).
access_vector(allow,klogd_t,self,unix_dgram_socket,create).
access_vector(allow,klogd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,klogd_t,self,unix_dgram_socket,read).
access_vector(allow,klogd_t,self,unix_dgram_socket,getattr).
access_vector(allow,klogd_t,self,unix_dgram_socket,write).
access_vector(allow,klogd_t,self,unix_dgram_socket,setattr).
access_vector(allow,klogd_t,self,unix_dgram_socket,append).
access_vector(allow,klogd_t,self,unix_dgram_socket,bind).
access_vector(allow,klogd_t,self,unix_dgram_socket,connect).
access_vector(allow,klogd_t,self,unix_dgram_socket,getopt).
access_vector(allow,klogd_t,self,unix_dgram_socket,setopt).
access_vector(allow,klogd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,klogd_t,klogd_t,capability,sys_admin).
access_vector(allow,klogd_t,klogd_t,capability,sys_rawio).
access_vector(allow,klogd_t,proc_kmsg_t,file,read).
access_vector(allow,klogd_t,proc_kmsg_t,file,getattr).
access_vector(allow,klogd_t,proc_kmsg_t,file,lock).
access_vector(allow,klogd_t,proc_kmsg_t,file,ioctl).
access_vector(allow,klogd_t,memory_device_t,chr_file,read).
access_vector(allow,klogd_t,memory_device_t,chr_file,getattr).
access_vector(allow,klogd_t,memory_device_t,chr_file,lock).
access_vector(allow,klogd_t,memory_device_t,chr_file,ioctl).
access_vector(allow,klogd_t,kernel_t,system,syslog_mod).
access_vector(allow,klogd_t,kernel_t,system,syslog_console).
access_vector(allow,klogd_t,system_map_t,file,read).
access_vector(allow,klogd_t,system_map_t,file,getattr).
access_vector(allow,klogd_t,system_map_t,file,lock).
access_vector(allow,klogd_t,system_map_t,file,ioctl).
access_vector(allow,klogd_t,boot_t,dir,read).
access_vector(allow,klogd_t,boot_t,dir,getattr).
access_vector(allow,klogd_t,boot_t,dir,lock).
access_vector(allow,klogd_t,boot_t,dir,search).
access_vector(allow,klogd_t,boot_t,dir,ioctl).
type_decl(ldconfig_t,[],[domain,privlog]).
type_decl(ldconfig_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(sysadm_r,ldconfig_t).
role_decl(system_r,ldconfig_t).
access_vector(allow,sysadm_t,ldconfig_t,process,transition).
access_vector(allow,initrc_t,ldconfig_t,process,transition).
access_vector(allow,dpkg_t,ldconfig_t,process,transition).
access_vector(dontaudit,sysadm_t,ldconfig_t,process,noatsecure).
access_vector(dontaudit,initrc_t,ldconfig_t,process,noatsecure).
access_vector(dontaudit,dpkg_t,ldconfig_t,process,noatsecure).
access_vector(allow,sysadm_t,ldconfig_exec_t,file,read).
access_vector(allow,sysadm_t,ldconfig_exec_t,file,getattr).
access_vector(allow,sysadm_t,ldconfig_exec_t,file,execute).
access_vector(allow,initrc_t,ldconfig_exec_t,file,read).
access_vector(allow,initrc_t,ldconfig_exec_t,file,getattr).
access_vector(allow,initrc_t,ldconfig_exec_t,file,execute).
access_vector(allow,dpkg_t,ldconfig_exec_t,file,read).
access_vector(allow,dpkg_t,ldconfig_exec_t,file,getattr).
access_vector(allow,dpkg_t,ldconfig_exec_t,file,execute).
access_vector(allow,ldconfig_t,sysadm_t,process,sigchld).
access_vector(allow,ldconfig_t,initrc_t,process,sigchld).
access_vector(allow,ldconfig_t,dpkg_t,process,sigchld).
access_vector(allow,ldconfig_t,sysadm_t,fd,use).
access_vector(allow,ldconfig_t,initrc_t,fd,use).
access_vector(allow,ldconfig_t,dpkg_t,fd,use).
access_vector(allow,sysadm_t,ldconfig_t,fd,use).
access_vector(allow,initrc_t,ldconfig_t,fd,use).
access_vector(allow,dpkg_t,ldconfig_t,fd,use).
access_vector(allow,ldconfig_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,ldconfig_t,sysadm_t,fifo_file,read).
access_vector(allow,ldconfig_t,sysadm_t,fifo_file,getattr).
access_vector(allow,ldconfig_t,sysadm_t,fifo_file,lock).
access_vector(allow,ldconfig_t,sysadm_t,fifo_file,write).
access_vector(allow,ldconfig_t,sysadm_t,fifo_file,append).
access_vector(allow,ldconfig_t,initrc_t,fifo_file,ioctl).
access_vector(allow,ldconfig_t,initrc_t,fifo_file,read).
access_vector(allow,ldconfig_t,initrc_t,fifo_file,getattr).
access_vector(allow,ldconfig_t,initrc_t,fifo_file,lock).
access_vector(allow,ldconfig_t,initrc_t,fifo_file,write).
access_vector(allow,ldconfig_t,initrc_t,fifo_file,append).
access_vector(allow,ldconfig_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,ldconfig_t,dpkg_t,fifo_file,read).
access_vector(allow,ldconfig_t,dpkg_t,fifo_file,getattr).
access_vector(allow,ldconfig_t,dpkg_t,fifo_file,lock).
access_vector(allow,ldconfig_t,dpkg_t,fifo_file,write).
access_vector(allow,ldconfig_t,dpkg_t,fifo_file,append).
access_vector(allow,ldconfig_t,ldconfig_exec_t,file,read).
access_vector(allow,ldconfig_t,ldconfig_exec_t,file,getattr).
access_vector(allow,ldconfig_t,ldconfig_exec_t,file,lock).
access_vector(allow,ldconfig_t,ldconfig_exec_t,file,execute).
access_vector(allow,ldconfig_t,ldconfig_exec_t,file,ioctl).
access_vector(allow,ldconfig_t,ldconfig_exec_t,file,entrypoint).
type_trans([sysadm_t,initrc_t,dpkg_t],ldconfig_exec_t,process,ldconfig_t).
access_vector(dontaudit,ldconfig_t,device_t,dir,search).
access_vector(allow,ldconfig_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,ldconfig_t,initrc_devpts_t,chr_file,read).
access_vector(allow,ldconfig_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,ldconfig_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,ldconfig_t,initrc_devpts_t,chr_file,write).
access_vector(allow,ldconfig_t,initrc_devpts_t,chr_file,append).
access_vector(allow,ldconfig_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,ldconfig_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,ldconfig_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,ldconfig_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,ldconfig_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,ldconfig_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,ldconfig_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,ldconfig_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,ldconfig_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,ldconfig_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,ldconfig_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,ldconfig_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,ldconfig_t,privfd,fd,use).
access_vector(allow,ldconfig_t,root_t,dir,read).
access_vector(allow,ldconfig_t,root_t,dir,getattr).
access_vector(allow,ldconfig_t,root_t,dir,lock).
access_vector(allow,ldconfig_t,root_t,dir,search).
access_vector(allow,ldconfig_t,root_t,dir,ioctl).
access_vector(allow,ldconfig_t,usr_t,dir,read).
access_vector(allow,ldconfig_t,usr_t,dir,getattr).
access_vector(allow,ldconfig_t,usr_t,dir,lock).
access_vector(allow,ldconfig_t,usr_t,dir,search).
access_vector(allow,ldconfig_t,usr_t,dir,ioctl).
access_vector(allow,ldconfig_t,lib_t,dir,read).
access_vector(allow,ldconfig_t,lib_t,dir,getattr).
access_vector(allow,ldconfig_t,lib_t,dir,lock).
access_vector(allow,ldconfig_t,lib_t,dir,search).
access_vector(allow,ldconfig_t,lib_t,dir,ioctl).
access_vector(allow,ldconfig_t,etc_t,dir,read).
access_vector(allow,ldconfig_t,etc_t,dir,getattr).
access_vector(allow,ldconfig_t,etc_t,dir,lock).
access_vector(allow,ldconfig_t,etc_t,dir,search).
access_vector(allow,ldconfig_t,etc_t,dir,ioctl).
access_vector(allow,ldconfig_t,lib_t,lnk_file,read).
access_vector(allow,ldconfig_t,lib_t,lnk_file,getattr).
access_vector(allow,ldconfig_t,lib_t,lnk_file,lock).
access_vector(allow,ldconfig_t,lib_t,lnk_file,ioctl).
access_vector(allow,ldconfig_t,ld_so_t,file,read).
access_vector(allow,ldconfig_t,ld_so_t,file,getattr).
access_vector(allow,ldconfig_t,ld_so_t,file,lock).
access_vector(allow,ldconfig_t,ld_so_t,file,execute).
access_vector(allow,ldconfig_t,ld_so_t,file,ioctl).
access_vector(allow,ldconfig_t,ld_so_t,file,execute_no_trans).
access_vector(allow,ldconfig_t,ld_so_t,lnk_file,read).
access_vector(allow,ldconfig_t,ld_so_t,lnk_file,getattr).
access_vector(allow,ldconfig_t,ld_so_t,lnk_file,lock).
access_vector(allow,ldconfig_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,ldconfig_t,shlib_t,file,read).
access_vector(allow,ldconfig_t,shlib_t,file,getattr).
access_vector(allow,ldconfig_t,shlib_t,file,lock).
access_vector(allow,ldconfig_t,shlib_t,file,execute).
access_vector(allow,ldconfig_t,shlib_t,file,ioctl).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,read).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,getattr).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,lock).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,ioctl).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,read).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,getattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,lock).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,ioctl).
access_vector(allow,ldconfig_t,device_t,dir,search).
access_vector(allow,ldconfig_t,null_device_t,chr_file,ioctl).
access_vector(allow,ldconfig_t,null_device_t,chr_file,read).
access_vector(allow,ldconfig_t,null_device_t,chr_file,getattr).
access_vector(allow,ldconfig_t,null_device_t,chr_file,lock).
access_vector(allow,ldconfig_t,null_device_t,chr_file,write).
access_vector(allow,ldconfig_t,null_device_t,chr_file,append).
access_vector(allow,ldconfig_t,etc_t,dir,read).
access_vector(allow,ldconfig_t,etc_t,dir,getattr).
access_vector(allow,ldconfig_t,etc_t,dir,lock).
access_vector(allow,ldconfig_t,etc_t,dir,search).
access_vector(allow,ldconfig_t,etc_t,dir,ioctl).
access_vector(allow,ldconfig_t,etc_t,dir,add_name).
access_vector(allow,ldconfig_t,etc_t,dir,remove_name).
access_vector(allow,ldconfig_t,etc_t,dir,write).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,create).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,ioctl).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,read).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,getattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,lock).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,write).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,setattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,append).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,link).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,unlink).
access_vector(allow,ldconfig_t,ld_so_cache_t,file,rename).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,create).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,ioctl).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,read).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,getattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,lock).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,write).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,setattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,append).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,link).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,unlink).
access_vector(allow,ldconfig_t,ld_so_cache_t,lnk_file,rename).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,create).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,ioctl).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,read).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,getattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,lock).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,write).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,setattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,append).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,link).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,unlink).
access_vector(allow,ldconfig_t,ld_so_cache_t,sock_file,rename).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,create).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,ioctl).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,read).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,getattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,lock).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,write).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,setattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,append).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,link).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,unlink).
access_vector(allow,ldconfig_t,ld_so_cache_t,fifo_file,rename).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,create).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,read).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,getattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,lock).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,setattr).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,link).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,unlink).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,rename).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,search).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,add_name).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,remove_name).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,reparent).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,write).
access_vector(allow,ldconfig_t,ld_so_cache_t,dir,rmdir).
type_trans(ldconfig_t,etc_t,dir,ld_so_cache_t).
type_trans(ldconfig_t,etc_t,[file,lnk_file,sock_file,fifo_file],ld_so_cache_t).
access_vector(allow,ldconfig_t,lib_t,dir,read).
access_vector(allow,ldconfig_t,lib_t,dir,getattr).
access_vector(allow,ldconfig_t,lib_t,dir,lock).
access_vector(allow,ldconfig_t,lib_t,dir,search).
access_vector(allow,ldconfig_t,lib_t,dir,ioctl).
access_vector(allow,ldconfig_t,lib_t,dir,add_name).
access_vector(allow,ldconfig_t,lib_t,dir,remove_name).
access_vector(allow,ldconfig_t,lib_t,dir,write).
access_vector(allow,ldconfig_t,shlib_t,file,create).
access_vector(allow,ldconfig_t,shlib_t,file,ioctl).
access_vector(allow,ldconfig_t,shlib_t,file,read).
access_vector(allow,ldconfig_t,shlib_t,file,getattr).
access_vector(allow,ldconfig_t,shlib_t,file,lock).
access_vector(allow,ldconfig_t,shlib_t,file,write).
access_vector(allow,ldconfig_t,shlib_t,file,setattr).
access_vector(allow,ldconfig_t,shlib_t,file,append).
access_vector(allow,ldconfig_t,shlib_t,file,link).
access_vector(allow,ldconfig_t,shlib_t,file,unlink).
access_vector(allow,ldconfig_t,shlib_t,file,rename).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,create).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,ioctl).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,read).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,getattr).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,lock).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,write).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,setattr).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,append).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,link).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,unlink).
access_vector(allow,ldconfig_t,shlib_t,lnk_file,rename).
access_vector(allow,ldconfig_t,shlib_t,sock_file,create).
access_vector(allow,ldconfig_t,shlib_t,sock_file,ioctl).
access_vector(allow,ldconfig_t,shlib_t,sock_file,read).
access_vector(allow,ldconfig_t,shlib_t,sock_file,getattr).
access_vector(allow,ldconfig_t,shlib_t,sock_file,lock).
access_vector(allow,ldconfig_t,shlib_t,sock_file,write).
access_vector(allow,ldconfig_t,shlib_t,sock_file,setattr).
access_vector(allow,ldconfig_t,shlib_t,sock_file,append).
access_vector(allow,ldconfig_t,shlib_t,sock_file,link).
access_vector(allow,ldconfig_t,shlib_t,sock_file,unlink).
access_vector(allow,ldconfig_t,shlib_t,sock_file,rename).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,create).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,ioctl).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,read).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,getattr).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,lock).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,write).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,setattr).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,append).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,link).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,unlink).
access_vector(allow,ldconfig_t,shlib_t,fifo_file,rename).
access_vector(allow,ldconfig_t,shlib_t,dir,create).
access_vector(allow,ldconfig_t,shlib_t,dir,read).
access_vector(allow,ldconfig_t,shlib_t,dir,getattr).
access_vector(allow,ldconfig_t,shlib_t,dir,lock).
access_vector(allow,ldconfig_t,shlib_t,dir,setattr).
access_vector(allow,ldconfig_t,shlib_t,dir,link).
access_vector(allow,ldconfig_t,shlib_t,dir,unlink).
access_vector(allow,ldconfig_t,shlib_t,dir,rename).
access_vector(allow,ldconfig_t,shlib_t,dir,search).
access_vector(allow,ldconfig_t,shlib_t,dir,add_name).
access_vector(allow,ldconfig_t,shlib_t,dir,remove_name).
access_vector(allow,ldconfig_t,shlib_t,dir,reparent).
access_vector(allow,ldconfig_t,shlib_t,dir,write).
access_vector(allow,ldconfig_t,shlib_t,dir,rmdir).
type_trans(ldconfig_t,lib_t,dir,shlib_t).
type_trans(ldconfig_t,lib_t,[file,lnk_file,sock_file,fifo_file],shlib_t).
access_vector(allow,ldconfig_t,lib_t,lnk_file,unlink).
access_vector(allow,ldconfig_t,userdomain,fd,use).
access_vector(allow,ldconfig_t,etc_t,file,getattr).
access_vector(allow,ldconfig_t,etc_t,file,read).
access_vector(allow,ldconfig_t,etc_t,lnk_file,read).
access_vector(allow,ldconfig_t,fs_t,filesystem,getattr).
type_decl(load_policy_t,[],[domain]).
role_decl(sysadm_r,load_policy_t).
type_decl(load_policy_exec_t,[],[file_type,exec_type,sysadmfile]).
access_vector(allow,sysadm_t,load_policy_t,process,transition).
access_vector(dontaudit,sysadm_t,load_policy_t,process,noatsecure).
access_vector(allow,sysadm_t,load_policy_exec_t,file,read).
access_vector(allow,sysadm_t,load_policy_exec_t,file,getattr).
access_vector(allow,sysadm_t,load_policy_exec_t,file,execute).
access_vector(allow,load_policy_t,sysadm_t,process,sigchld).
access_vector(allow,load_policy_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,load_policy_t,fd,use).
access_vector(allow,load_policy_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,load_policy_t,sysadm_t,fifo_file,read).
access_vector(allow,load_policy_t,sysadm_t,fifo_file,getattr).
access_vector(allow,load_policy_t,sysadm_t,fifo_file,lock).
access_vector(allow,load_policy_t,sysadm_t,fifo_file,write).
access_vector(allow,load_policy_t,sysadm_t,fifo_file,append).
access_vector(allow,load_policy_t,load_policy_exec_t,file,read).
access_vector(allow,load_policy_t,load_policy_exec_t,file,getattr).
access_vector(allow,load_policy_t,load_policy_exec_t,file,lock).
access_vector(allow,load_policy_t,load_policy_exec_t,file,execute).
access_vector(allow,load_policy_t,load_policy_exec_t,file,ioctl).
access_vector(allow,load_policy_t,load_policy_exec_t,file,entrypoint).
type_trans(sysadm_t,load_policy_exec_t,process,load_policy_t).
role_decl(system_r,load_policy_t).
access_vector(allow,dpkg_t,load_policy_t,process,transition).
access_vector(dontaudit,dpkg_t,load_policy_t,process,noatsecure).
access_vector(allow,dpkg_t,load_policy_exec_t,file,read).
access_vector(allow,dpkg_t,load_policy_exec_t,file,getattr).
access_vector(allow,dpkg_t,load_policy_exec_t,file,execute).
access_vector(allow,load_policy_t,dpkg_t,process,sigchld).
access_vector(allow,load_policy_t,dpkg_t,fd,use).
access_vector(allow,dpkg_t,load_policy_t,fd,use).
access_vector(allow,load_policy_t,dpkg_t,fifo_file,ioctl).
access_vector(allow,load_policy_t,dpkg_t,fifo_file,read).
access_vector(allow,load_policy_t,dpkg_t,fifo_file,getattr).
access_vector(allow,load_policy_t,dpkg_t,fifo_file,lock).
access_vector(allow,load_policy_t,dpkg_t,fifo_file,write).
access_vector(allow,load_policy_t,dpkg_t,fifo_file,append).
access_vector(allow,load_policy_t,load_policy_exec_t,file,entrypoint).
type_trans(dpkg_t,load_policy_exec_t,process,load_policy_t).
access_vector(allow,load_policy_t,security_t,dir,read).
access_vector(allow,load_policy_t,security_t,dir,search).
access_vector(allow,load_policy_t,security_t,dir,getattr).
access_vector(allow,load_policy_t,security_t,file,getattr).
access_vector(allow,load_policy_t,security_t,file,read).
access_vector(allow,load_policy_t,security_t,file,write).
access_vector(allow,load_policy_t,security_t,security,load_policy).
access_vector(auditallow,load_policy_t,security_t,security,load_policy).
access_vector(allow,load_policy_t,policy_config_t,dir,read).
access_vector(allow,load_policy_t,policy_config_t,dir,getattr).
access_vector(allow,load_policy_t,policy_config_t,dir,lock).
access_vector(allow,load_policy_t,policy_config_t,dir,search).
access_vector(allow,load_policy_t,policy_config_t,dir,ioctl).
access_vector(allow,load_policy_t,policy_config_t,file,read).
access_vector(allow,load_policy_t,policy_config_t,file,getattr).
access_vector(allow,load_policy_t,policy_config_t,file,lock).
access_vector(allow,load_policy_t,policy_config_t,file,ioctl).
access_vector(allow,load_policy_t,policy_config_t,lnk_file,read).
access_vector(allow,load_policy_t,policy_config_t,lnk_file,getattr).
access_vector(allow,load_policy_t,policy_config_t,lnk_file,lock).
access_vector(allow,load_policy_t,policy_config_t,lnk_file,ioctl).
access_vector(allow,load_policy_t,policy_config_t,sock_file,read).
access_vector(allow,load_policy_t,policy_config_t,sock_file,getattr).
access_vector(allow,load_policy_t,policy_config_t,sock_file,lock).
access_vector(allow,load_policy_t,policy_config_t,sock_file,ioctl).
access_vector(allow,load_policy_t,policy_config_t,fifo_file,read).
access_vector(allow,load_policy_t,policy_config_t,fifo_file,getattr).
access_vector(allow,load_policy_t,policy_config_t,fifo_file,lock).
access_vector(allow,load_policy_t,policy_config_t,fifo_file,ioctl).
access_vector(allow,load_policy_t,root_t,dir,search).
access_vector(allow,load_policy_t,etc_t,dir,search).
access_vector(allow,load_policy_t,devpts_t,dir,read).
access_vector(allow,load_policy_t,devpts_t,dir,getattr).
access_vector(allow,load_policy_t,devpts_t,dir,lock).
access_vector(allow,load_policy_t,devpts_t,dir,search).
access_vector(allow,load_policy_t,devpts_t,dir,ioctl).
access_vector(allow,load_policy_t,initrc_devpts_t,chr_file,read).
access_vector(allow,load_policy_t,initrc_devpts_t,chr_file,write).
access_vector(allow,load_policy_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,load_policy_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,load_policy_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,load_policy_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,load_policy_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,load_policy_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,load_policy_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,load_policy_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,load_policy_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,load_policy_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,load_policy_t,root_t,dir,read).
access_vector(allow,load_policy_t,root_t,dir,getattr).
access_vector(allow,load_policy_t,root_t,dir,lock).
access_vector(allow,load_policy_t,root_t,dir,search).
access_vector(allow,load_policy_t,root_t,dir,ioctl).
access_vector(allow,load_policy_t,usr_t,dir,read).
access_vector(allow,load_policy_t,usr_t,dir,getattr).
access_vector(allow,load_policy_t,usr_t,dir,lock).
access_vector(allow,load_policy_t,usr_t,dir,search).
access_vector(allow,load_policy_t,usr_t,dir,ioctl).
access_vector(allow,load_policy_t,lib_t,dir,read).
access_vector(allow,load_policy_t,lib_t,dir,getattr).
access_vector(allow,load_policy_t,lib_t,dir,lock).
access_vector(allow,load_policy_t,lib_t,dir,search).
access_vector(allow,load_policy_t,lib_t,dir,ioctl).
access_vector(allow,load_policy_t,etc_t,dir,read).
access_vector(allow,load_policy_t,etc_t,dir,getattr).
access_vector(allow,load_policy_t,etc_t,dir,lock).
access_vector(allow,load_policy_t,etc_t,dir,search).
access_vector(allow,load_policy_t,etc_t,dir,ioctl).
access_vector(allow,load_policy_t,lib_t,lnk_file,read).
access_vector(allow,load_policy_t,lib_t,lnk_file,getattr).
access_vector(allow,load_policy_t,lib_t,lnk_file,lock).
access_vector(allow,load_policy_t,lib_t,lnk_file,ioctl).
access_vector(allow,load_policy_t,ld_so_t,file,read).
access_vector(allow,load_policy_t,ld_so_t,file,getattr).
access_vector(allow,load_policy_t,ld_so_t,file,lock).
access_vector(allow,load_policy_t,ld_so_t,file,execute).
access_vector(allow,load_policy_t,ld_so_t,file,ioctl).
access_vector(allow,load_policy_t,ld_so_t,file,execute_no_trans).
access_vector(allow,load_policy_t,ld_so_t,lnk_file,read).
access_vector(allow,load_policy_t,ld_so_t,lnk_file,getattr).
access_vector(allow,load_policy_t,ld_so_t,lnk_file,lock).
access_vector(allow,load_policy_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,load_policy_t,shlib_t,file,read).
access_vector(allow,load_policy_t,shlib_t,file,getattr).
access_vector(allow,load_policy_t,shlib_t,file,lock).
access_vector(allow,load_policy_t,shlib_t,file,execute).
access_vector(allow,load_policy_t,shlib_t,file,ioctl).
access_vector(allow,load_policy_t,shlib_t,lnk_file,read).
access_vector(allow,load_policy_t,shlib_t,lnk_file,getattr).
access_vector(allow,load_policy_t,shlib_t,lnk_file,lock).
access_vector(allow,load_policy_t,shlib_t,lnk_file,ioctl).
access_vector(allow,load_policy_t,ld_so_cache_t,file,read).
access_vector(allow,load_policy_t,ld_so_cache_t,file,getattr).
access_vector(allow,load_policy_t,ld_so_cache_t,file,lock).
access_vector(allow,load_policy_t,ld_so_cache_t,file,ioctl).
access_vector(allow,load_policy_t,device_t,dir,search).
access_vector(allow,load_policy_t,null_device_t,chr_file,ioctl).
access_vector(allow,load_policy_t,null_device_t,chr_file,read).
access_vector(allow,load_policy_t,null_device_t,chr_file,getattr).
access_vector(allow,load_policy_t,null_device_t,chr_file,lock).
access_vector(allow,load_policy_t,null_device_t,chr_file,write).
access_vector(allow,load_policy_t,null_device_t,chr_file,append).
access_vector(allow,load_policy_t,self,capability,dac_override).
access_vector(allow,load_policy_t,initrc_t,fd,use).
access_vector(allow,load_policy_t,privfd,fd,use).
access_vector(allow,load_policy_t,fs_t,filesystem,getattr).
access_vector(allow,load_policy_t,sysadm_tmp_t,file,getattr).
access_vector(allow,load_policy_t,sysadm_tmp_t,file,write).
type_decl(login_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(local_login_t,[],[domain,privuser,privrole,privlog,auth,privowner,mlstrustedreader,mlstrustedwriter,mlstrustedobject,privfd]).
role_decl(system_r,local_login_t).
access_vector(allow,local_login_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,local_login_t,self,dir,read).
access_vector(allow,local_login_t,self,dir,getattr).
access_vector(allow,local_login_t,self,dir,lock).
access_vector(allow,local_login_t,self,dir,search).
access_vector(allow,local_login_t,self,dir,ioctl).
access_vector(allow,local_login_t,self,file,read).
access_vector(allow,local_login_t,self,file,getattr).
access_vector(allow,local_login_t,self,file,lock).
access_vector(allow,local_login_t,self,file,ioctl).
access_vector(allow,local_login_t,self,lnk_file,read).
access_vector(allow,local_login_t,self,lnk_file,getattr).
access_vector(allow,local_login_t,self,lnk_file,lock).
access_vector(allow,local_login_t,self,lnk_file,ioctl).
access_vector(allow,local_login_t,self,sock_file,read).
access_vector(allow,local_login_t,self,sock_file,getattr).
access_vector(allow,local_login_t,self,sock_file,lock).
access_vector(allow,local_login_t,self,sock_file,ioctl).
access_vector(allow,local_login_t,self,fifo_file,read).
access_vector(allow,local_login_t,self,fifo_file,getattr).
access_vector(allow,local_login_t,self,fifo_file,lock).
access_vector(allow,local_login_t,self,fifo_file,ioctl).
access_vector(allow,local_login_t,self,fd,_).
access_vector(allow,local_login_t,self,fifo_file,ioctl).
access_vector(allow,local_login_t,self,fifo_file,read).
access_vector(allow,local_login_t,self,fifo_file,getattr).
access_vector(allow,local_login_t,self,fifo_file,lock).
access_vector(allow,local_login_t,self,fifo_file,write).
access_vector(allow,local_login_t,self,fifo_file,append).
access_vector(allow,local_login_t,self,unix_dgram_socket,create).
access_vector(allow,local_login_t,self,unix_dgram_socket,ioctl).
access_vector(allow,local_login_t,self,unix_dgram_socket,read).
access_vector(allow,local_login_t,self,unix_dgram_socket,getattr).
access_vector(allow,local_login_t,self,unix_dgram_socket,write).
access_vector(allow,local_login_t,self,unix_dgram_socket,setattr).
access_vector(allow,local_login_t,self,unix_dgram_socket,append).
access_vector(allow,local_login_t,self,unix_dgram_socket,bind).
access_vector(allow,local_login_t,self,unix_dgram_socket,connect).
access_vector(allow,local_login_t,self,unix_dgram_socket,getopt).
access_vector(allow,local_login_t,self,unix_dgram_socket,setopt).
access_vector(allow,local_login_t,self,unix_dgram_socket,shutdown).
access_vector(allow,local_login_t,self,unix_stream_socket,create).
access_vector(allow,local_login_t,self,unix_stream_socket,ioctl).
access_vector(allow,local_login_t,self,unix_stream_socket,read).
access_vector(allow,local_login_t,self,unix_stream_socket,getattr).
access_vector(allow,local_login_t,self,unix_stream_socket,write).
access_vector(allow,local_login_t,self,unix_stream_socket,setattr).
access_vector(allow,local_login_t,self,unix_stream_socket,append).
access_vector(allow,local_login_t,self,unix_stream_socket,bind).
access_vector(allow,local_login_t,self,unix_stream_socket,connect).
access_vector(allow,local_login_t,self,unix_stream_socket,getopt).
access_vector(allow,local_login_t,self,unix_stream_socket,setopt).
access_vector(allow,local_login_t,self,unix_stream_socket,shutdown).
access_vector(allow,local_login_t,self,unix_stream_socket,listen).
access_vector(allow,local_login_t,self,unix_stream_socket,accept).
access_vector(allow,local_login_t,self,unix_dgram_socket,sendto).
access_vector(allow,local_login_t,self,unix_stream_socket,connectto).
access_vector(allow,local_login_t,self,sem,associate).
access_vector(allow,local_login_t,self,sem,getattr).
access_vector(allow,local_login_t,self,sem,setattr).
access_vector(allow,local_login_t,self,sem,create).
access_vector(allow,local_login_t,self,sem,destroy).
access_vector(allow,local_login_t,self,sem,read).
access_vector(allow,local_login_t,self,sem,write).
access_vector(allow,local_login_t,self,sem,unix_read).
access_vector(allow,local_login_t,self,sem,unix_write).
access_vector(allow,local_login_t,self,msg,send).
access_vector(allow,local_login_t,self,msg,receive).
access_vector(allow,local_login_t,self,msgq,associate).
access_vector(allow,local_login_t,self,msgq,getattr).
access_vector(allow,local_login_t,self,msgq,setattr).
access_vector(allow,local_login_t,self,msgq,create).
access_vector(allow,local_login_t,self,msgq,destroy).
access_vector(allow,local_login_t,self,msgq,read).
access_vector(allow,local_login_t,self,msgq,write).
access_vector(allow,local_login_t,self,msgq,enqueue).
access_vector(allow,local_login_t,self,msgq,unix_read).
access_vector(allow,local_login_t,self,msgq,unix_write).
access_vector(allow,local_login_t,self,shm,associate).
access_vector(allow,local_login_t,self,shm,getattr).
access_vector(allow,local_login_t,self,shm,setattr).
access_vector(allow,local_login_t,self,shm,create).
access_vector(allow,local_login_t,self,shm,destroy).
access_vector(allow,local_login_t,self,shm,read).
access_vector(allow,local_login_t,self,shm,write).
access_vector(allow,local_login_t,self,shm,lock).
access_vector(allow,local_login_t,self,shm,unix_read).
access_vector(allow,local_login_t,self,shm,unix_write).
access_vector(allow,local_login_t,proc_t,dir,read).
access_vector(allow,local_login_t,proc_t,dir,getattr).
access_vector(allow,local_login_t,proc_t,dir,lock).
access_vector(allow,local_login_t,proc_t,dir,search).
access_vector(allow,local_login_t,proc_t,dir,ioctl).
access_vector(allow,local_login_t,proc_t,file,read).
access_vector(allow,local_login_t,proc_t,file,getattr).
access_vector(allow,local_login_t,proc_t,file,lock).
access_vector(allow,local_login_t,proc_t,file,ioctl).
access_vector(allow,local_login_t,proc_t,lnk_file,read).
access_vector(allow,local_login_t,proc_t,lnk_file,getattr).
access_vector(allow,local_login_t,proc_t,lnk_file,lock).
access_vector(allow,local_login_t,proc_t,lnk_file,ioctl).
access_vector(allow,local_login_t,proc_t,sock_file,read).
access_vector(allow,local_login_t,proc_t,sock_file,getattr).
access_vector(allow,local_login_t,proc_t,sock_file,lock).
access_vector(allow,local_login_t,proc_t,sock_file,ioctl).
access_vector(allow,local_login_t,proc_t,fifo_file,read).
access_vector(allow,local_login_t,proc_t,fifo_file,getattr).
access_vector(allow,local_login_t,proc_t,fifo_file,lock).
access_vector(allow,local_login_t,proc_t,fifo_file,ioctl).
access_vector(allow,local_login_t,root_t,dir,read).
access_vector(allow,local_login_t,root_t,dir,getattr).
access_vector(allow,local_login_t,root_t,dir,lock).
access_vector(allow,local_login_t,root_t,dir,search).
access_vector(allow,local_login_t,root_t,dir,ioctl).
access_vector(allow,local_login_t,root_t,file,read).
access_vector(allow,local_login_t,root_t,file,getattr).
access_vector(allow,local_login_t,root_t,file,lock).
access_vector(allow,local_login_t,root_t,file,ioctl).
access_vector(allow,local_login_t,root_t,lnk_file,read).
access_vector(allow,local_login_t,root_t,lnk_file,getattr).
access_vector(allow,local_login_t,root_t,lnk_file,lock).
access_vector(allow,local_login_t,root_t,lnk_file,ioctl).
access_vector(allow,local_login_t,root_t,sock_file,read).
access_vector(allow,local_login_t,root_t,sock_file,getattr).
access_vector(allow,local_login_t,root_t,sock_file,lock).
access_vector(allow,local_login_t,root_t,sock_file,ioctl).
access_vector(allow,local_login_t,root_t,fifo_file,read).
access_vector(allow,local_login_t,root_t,fifo_file,getattr).
access_vector(allow,local_login_t,root_t,fifo_file,lock).
access_vector(allow,local_login_t,root_t,fifo_file,ioctl).
access_vector(allow,local_login_t,home_root_t,dir,read).
access_vector(allow,local_login_t,home_root_t,dir,getattr).
access_vector(allow,local_login_t,home_root_t,dir,lock).
access_vector(allow,local_login_t,home_root_t,dir,search).
access_vector(allow,local_login_t,home_root_t,dir,ioctl).
access_vector(allow,local_login_t,usr_t,dir,read).
access_vector(allow,local_login_t,usr_t,dir,getattr).
access_vector(allow,local_login_t,usr_t,dir,lock).
access_vector(allow,local_login_t,usr_t,dir,search).
access_vector(allow,local_login_t,usr_t,dir,ioctl).
access_vector(allow,local_login_t,usr_t,file,read).
access_vector(allow,local_login_t,usr_t,file,getattr).
access_vector(allow,local_login_t,usr_t,file,lock).
access_vector(allow,local_login_t,usr_t,file,ioctl).
access_vector(allow,local_login_t,usr_t,lnk_file,read).
access_vector(allow,local_login_t,usr_t,lnk_file,getattr).
access_vector(allow,local_login_t,usr_t,lnk_file,lock).
access_vector(allow,local_login_t,usr_t,lnk_file,ioctl).
access_vector(allow,local_login_t,usr_t,sock_file,read).
access_vector(allow,local_login_t,usr_t,sock_file,getattr).
access_vector(allow,local_login_t,usr_t,sock_file,lock).
access_vector(allow,local_login_t,usr_t,sock_file,ioctl).
access_vector(allow,local_login_t,usr_t,fifo_file,read).
access_vector(allow,local_login_t,usr_t,fifo_file,getattr).
access_vector(allow,local_login_t,usr_t,fifo_file,lock).
access_vector(allow,local_login_t,usr_t,fifo_file,ioctl).
access_vector(allow,local_login_t,bin_t,dir,read).
access_vector(allow,local_login_t,bin_t,dir,getattr).
access_vector(allow,local_login_t,bin_t,dir,lock).
access_vector(allow,local_login_t,bin_t,dir,search).
access_vector(allow,local_login_t,bin_t,dir,ioctl).
access_vector(allow,local_login_t,bin_t,file,read).
access_vector(allow,local_login_t,bin_t,file,getattr).
access_vector(allow,local_login_t,bin_t,file,lock).
access_vector(allow,local_login_t,bin_t,file,ioctl).
access_vector(allow,local_login_t,bin_t,lnk_file,read).
access_vector(allow,local_login_t,bin_t,lnk_file,getattr).
access_vector(allow,local_login_t,bin_t,lnk_file,lock).
access_vector(allow,local_login_t,bin_t,lnk_file,ioctl).
access_vector(allow,local_login_t,bin_t,sock_file,read).
access_vector(allow,local_login_t,bin_t,sock_file,getattr).
access_vector(allow,local_login_t,bin_t,sock_file,lock).
access_vector(allow,local_login_t,bin_t,sock_file,ioctl).
access_vector(allow,local_login_t,bin_t,fifo_file,read).
access_vector(allow,local_login_t,bin_t,fifo_file,getattr).
access_vector(allow,local_login_t,bin_t,fifo_file,lock).
access_vector(allow,local_login_t,bin_t,fifo_file,ioctl).
access_vector(allow,local_login_t,sbin_t,dir,read).
access_vector(allow,local_login_t,sbin_t,dir,getattr).
access_vector(allow,local_login_t,sbin_t,dir,lock).
access_vector(allow,local_login_t,sbin_t,dir,search).
access_vector(allow,local_login_t,sbin_t,dir,ioctl).
access_vector(allow,local_login_t,sbin_t,file,read).
access_vector(allow,local_login_t,sbin_t,file,getattr).
access_vector(allow,local_login_t,sbin_t,file,lock).
access_vector(allow,local_login_t,sbin_t,file,ioctl).
access_vector(allow,local_login_t,sbin_t,lnk_file,read).
access_vector(allow,local_login_t,sbin_t,lnk_file,getattr).
access_vector(allow,local_login_t,sbin_t,lnk_file,lock).
access_vector(allow,local_login_t,sbin_t,lnk_file,ioctl).
access_vector(allow,local_login_t,sbin_t,sock_file,read).
access_vector(allow,local_login_t,sbin_t,sock_file,getattr).
access_vector(allow,local_login_t,sbin_t,sock_file,lock).
access_vector(allow,local_login_t,sbin_t,sock_file,ioctl).
access_vector(allow,local_login_t,sbin_t,fifo_file,read).
access_vector(allow,local_login_t,sbin_t,fifo_file,getattr).
access_vector(allow,local_login_t,sbin_t,fifo_file,lock).
access_vector(allow,local_login_t,sbin_t,fifo_file,ioctl).
access_vector(allow,local_login_t,readable_t,dir,read).
access_vector(allow,local_login_t,readable_t,dir,getattr).
access_vector(allow,local_login_t,readable_t,dir,lock).
access_vector(allow,local_login_t,readable_t,dir,search).
access_vector(allow,local_login_t,readable_t,dir,ioctl).
access_vector(allow,local_login_t,readable_t,file,read).
access_vector(allow,local_login_t,readable_t,file,getattr).
access_vector(allow,local_login_t,readable_t,file,lock).
access_vector(allow,local_login_t,readable_t,file,ioctl).
access_vector(allow,local_login_t,readable_t,lnk_file,read).
access_vector(allow,local_login_t,readable_t,lnk_file,getattr).
access_vector(allow,local_login_t,readable_t,lnk_file,lock).
access_vector(allow,local_login_t,readable_t,lnk_file,ioctl).
access_vector(allow,local_login_t,readable_t,sock_file,read).
access_vector(allow,local_login_t,readable_t,sock_file,getattr).
access_vector(allow,local_login_t,readable_t,sock_file,lock).
access_vector(allow,local_login_t,readable_t,sock_file,ioctl).
access_vector(allow,local_login_t,readable_t,fifo_file,read).
access_vector(allow,local_login_t,readable_t,fifo_file,getattr).
access_vector(allow,local_login_t,readable_t,fifo_file,lock).
access_vector(allow,local_login_t,readable_t,fifo_file,ioctl).
access_vector(allow,local_login_t,var_t,dir,search).
access_vector(allow,local_login_t,var_spool_t,dir,search).
access_vector(allow,local_login_t,etc_t,dir,read).
access_vector(allow,local_login_t,etc_t,dir,getattr).
access_vector(allow,local_login_t,etc_t,dir,lock).
access_vector(allow,local_login_t,etc_t,dir,search).
access_vector(allow,local_login_t,etc_t,dir,ioctl).
access_vector(allow,local_login_t,etc_t,file,read).
access_vector(allow,local_login_t,etc_t,file,getattr).
access_vector(allow,local_login_t,etc_t,file,lock).
access_vector(allow,local_login_t,etc_t,file,ioctl).
access_vector(allow,local_login_t,etc_t,lnk_file,read).
access_vector(allow,local_login_t,etc_t,lnk_file,getattr).
access_vector(allow,local_login_t,etc_t,lnk_file,lock).
access_vector(allow,local_login_t,etc_t,lnk_file,ioctl).
access_vector(allow,local_login_t,etc_t,sock_file,read).
access_vector(allow,local_login_t,etc_t,sock_file,getattr).
access_vector(allow,local_login_t,etc_t,sock_file,lock).
access_vector(allow,local_login_t,etc_t,sock_file,ioctl).
access_vector(allow,local_login_t,etc_t,fifo_file,read).
access_vector(allow,local_login_t,etc_t,fifo_file,getattr).
access_vector(allow,local_login_t,etc_t,fifo_file,lock).
access_vector(allow,local_login_t,etc_t,fifo_file,ioctl).
access_vector(allow,local_login_t,etc_runtime_t,file,read).
access_vector(allow,local_login_t,etc_runtime_t,file,getattr).
access_vector(allow,local_login_t,etc_runtime_t,file,lock).
access_vector(allow,local_login_t,etc_runtime_t,file,ioctl).
access_vector(allow,local_login_t,etc_runtime_t,lnk_file,read).
access_vector(allow,local_login_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,local_login_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,local_login_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,local_login_t,etc_t,lnk_file,read).
access_vector(allow,local_login_t,locale_t,dir,read).
access_vector(allow,local_login_t,locale_t,dir,getattr).
access_vector(allow,local_login_t,locale_t,dir,lock).
access_vector(allow,local_login_t,locale_t,dir,search).
access_vector(allow,local_login_t,locale_t,dir,ioctl).
access_vector(allow,local_login_t,locale_t,file,read).
access_vector(allow,local_login_t,locale_t,file,getattr).
access_vector(allow,local_login_t,locale_t,file,lock).
access_vector(allow,local_login_t,locale_t,file,ioctl).
access_vector(allow,local_login_t,locale_t,lnk_file,read).
access_vector(allow,local_login_t,locale_t,lnk_file,getattr).
access_vector(allow,local_login_t,locale_t,lnk_file,lock).
access_vector(allow,local_login_t,locale_t,lnk_file,ioctl).
access_vector(allow,local_login_t,exec_type,file,read).
access_vector(allow,local_login_t,exec_type,file,getattr).
access_vector(allow,local_login_t,exec_type,file,lock).
access_vector(allow,local_login_t,exec_type,file,ioctl).
access_vector(allow,local_login_t,exec_type,lnk_file,read).
access_vector(allow,local_login_t,exec_type,lnk_file,getattr).
access_vector(allow,local_login_t,exec_type,lnk_file,lock).
access_vector(allow,local_login_t,exec_type,lnk_file,ioctl).
access_vector(allow,local_login_t,device_t,dir,read).
access_vector(allow,local_login_t,device_t,dir,getattr).
access_vector(allow,local_login_t,device_t,dir,lock).
access_vector(allow,local_login_t,device_t,dir,search).
access_vector(allow,local_login_t,device_t,dir,ioctl).
access_vector(allow,local_login_t,device_t,lnk_file,read).
access_vector(allow,local_login_t,device_t,lnk_file,getattr).
access_vector(allow,local_login_t,device_t,lnk_file,lock).
access_vector(allow,local_login_t,device_t,lnk_file,ioctl).
access_vector(allow,local_login_t,lib_t,dir,read).
access_vector(allow,local_login_t,lib_t,dir,getattr).
access_vector(allow,local_login_t,lib_t,dir,lock).
access_vector(allow,local_login_t,lib_t,dir,search).
access_vector(allow,local_login_t,lib_t,dir,ioctl).
access_vector(allow,local_login_t,lib_t,lnk_file,read).
access_vector(allow,local_login_t,lib_t,lnk_file,getattr).
access_vector(allow,local_login_t,lib_t,lnk_file,lock).
access_vector(allow,local_login_t,lib_t,lnk_file,ioctl).
access_vector(allow,local_login_t,ld_so_t,file,read).
access_vector(allow,local_login_t,ld_so_t,file,getattr).
access_vector(allow,local_login_t,ld_so_t,file,lock).
access_vector(allow,local_login_t,ld_so_t,file,execute).
access_vector(allow,local_login_t,ld_so_t,file,ioctl).
access_vector(allow,local_login_t,ld_so_t,file,execute_no_trans).
access_vector(allow,local_login_t,ld_so_t,lnk_file,read).
access_vector(allow,local_login_t,ld_so_t,lnk_file,getattr).
access_vector(allow,local_login_t,ld_so_t,lnk_file,lock).
access_vector(allow,local_login_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,local_login_t,shlib_t,file,read).
access_vector(allow,local_login_t,shlib_t,file,getattr).
access_vector(allow,local_login_t,shlib_t,file,lock).
access_vector(allow,local_login_t,shlib_t,file,execute).
access_vector(allow,local_login_t,shlib_t,file,ioctl).
access_vector(allow,local_login_t,shlib_t,lnk_file,read).
access_vector(allow,local_login_t,shlib_t,lnk_file,getattr).
access_vector(allow,local_login_t,shlib_t,lnk_file,lock).
access_vector(allow,local_login_t,shlib_t,lnk_file,ioctl).
access_vector(allow,local_login_t,ld_so_cache_t,file,read).
access_vector(allow,local_login_t,ld_so_cache_t,file,getattr).
access_vector(allow,local_login_t,ld_so_cache_t,file,lock).
access_vector(allow,local_login_t,ld_so_cache_t,file,ioctl).
access_vector(allow,local_login_t,device_t,dir,search).
access_vector(allow,local_login_t,null_device_t,chr_file,ioctl).
access_vector(allow,local_login_t,null_device_t,chr_file,read).
access_vector(allow,local_login_t,null_device_t,chr_file,getattr).
access_vector(allow,local_login_t,null_device_t,chr_file,lock).
access_vector(allow,local_login_t,null_device_t,chr_file,write).
access_vector(allow,local_login_t,null_device_t,chr_file,append).
type_decl(local_login_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,local_login_t,tmp_t,dir,read).
access_vector(allow,local_login_t,tmp_t,dir,getattr).
access_vector(allow,local_login_t,tmp_t,dir,lock).
access_vector(allow,local_login_t,tmp_t,dir,search).
access_vector(allow,local_login_t,tmp_t,dir,ioctl).
access_vector(allow,local_login_t,tmp_t,dir,add_name).
access_vector(allow,local_login_t,tmp_t,dir,remove_name).
access_vector(allow,local_login_t,tmp_t,dir,write).
access_vector(allow,local_login_t,local_login_tmp_t,file,create).
access_vector(allow,local_login_t,local_login_tmp_t,file,ioctl).
access_vector(allow,local_login_t,local_login_tmp_t,file,read).
access_vector(allow,local_login_t,local_login_tmp_t,file,getattr).
access_vector(allow,local_login_t,local_login_tmp_t,file,lock).
access_vector(allow,local_login_t,local_login_tmp_t,file,write).
access_vector(allow,local_login_t,local_login_tmp_t,file,setattr).
access_vector(allow,local_login_t,local_login_tmp_t,file,append).
access_vector(allow,local_login_t,local_login_tmp_t,file,link).
access_vector(allow,local_login_t,local_login_tmp_t,file,unlink).
access_vector(allow,local_login_t,local_login_tmp_t,file,rename).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,create).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,ioctl).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,read).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,getattr).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,lock).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,write).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,setattr).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,append).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,link).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,unlink).
access_vector(allow,local_login_t,local_login_tmp_t,lnk_file,rename).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,create).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,ioctl).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,read).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,getattr).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,lock).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,write).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,setattr).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,append).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,link).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,unlink).
access_vector(allow,local_login_t,local_login_tmp_t,sock_file,rename).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,create).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,ioctl).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,read).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,getattr).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,lock).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,write).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,setattr).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,append).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,link).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,unlink).
access_vector(allow,local_login_t,local_login_tmp_t,fifo_file,rename).
access_vector(allow,local_login_t,local_login_tmp_t,dir,create).
access_vector(allow,local_login_t,local_login_tmp_t,dir,read).
access_vector(allow,local_login_t,local_login_tmp_t,dir,getattr).
access_vector(allow,local_login_t,local_login_tmp_t,dir,lock).
access_vector(allow,local_login_t,local_login_tmp_t,dir,setattr).
access_vector(allow,local_login_t,local_login_tmp_t,dir,link).
access_vector(allow,local_login_t,local_login_tmp_t,dir,unlink).
access_vector(allow,local_login_t,local_login_tmp_t,dir,rename).
access_vector(allow,local_login_t,local_login_tmp_t,dir,search).
access_vector(allow,local_login_t,local_login_tmp_t,dir,add_name).
access_vector(allow,local_login_t,local_login_tmp_t,dir,remove_name).
access_vector(allow,local_login_t,local_login_tmp_t,dir,reparent).
access_vector(allow,local_login_t,local_login_tmp_t,dir,write).
access_vector(allow,local_login_t,local_login_tmp_t,dir,rmdir).
type_trans(local_login_t,tmp_t,dir,local_login_tmp_t).
type_trans(local_login_t,tmp_t,[file,lnk_file,sock_file,fifo_file],local_login_tmp_t).
access_vector(allow,local_login_t,self,capability,setuid).
access_vector(allow,local_login_t,self,capability,setgid).
access_vector(allow,local_login_t,self,capability,chown).
access_vector(allow,local_login_t,self,capability,fowner).
access_vector(allow,local_login_t,self,capability,fsetid).
access_vector(allow,local_login_t,self,capability,net_bind_service).
access_vector(allow,local_login_t,self,capability,sys_tty_config).
access_vector(allow,local_login_t,self,capability,dac_override).
access_vector(allow,local_login_t,self,capability,sys_nice).
access_vector(allow,local_login_t,self,capability,sys_resource).
access_vector(allow,local_login_t,user_t,process,transition).
access_vector(dontaudit,local_login_t,user_t,process,noatsecure).
access_vector(allow,local_login_t,shell_exec_t,file,read).
access_vector(allow,local_login_t,shell_exec_t,file,getattr).
access_vector(allow,local_login_t,shell_exec_t,file,execute).
access_vector(allow,user_t,local_login_t,process,sigchld).
access_vector(allow,user_t,local_login_t,fd,use).
access_vector(allow,local_login_t,user_t,fd,use).
access_vector(allow,user_t,local_login_t,fifo_file,ioctl).
access_vector(allow,user_t,local_login_t,fifo_file,read).
access_vector(allow,user_t,local_login_t,fifo_file,getattr).
access_vector(allow,user_t,local_login_t,fifo_file,lock).
access_vector(allow,user_t,local_login_t,fifo_file,write).
access_vector(allow,user_t,local_login_t,fifo_file,append).
access_vector(allow,user_t,shell_exec_t,file,entrypoint).
type_trans(local_login_t,shell_exec_t,process,user_t).
access_vector(allow,local_login_t,self,process,setexec).
access_vector(allow,local_login_t,proc_t,dir,search).
access_vector(allow,local_login_t,proc_t,lnk_file,read).
access_vector(allow,local_login_t,self,dir,search).
access_vector(allow,local_login_t,self,file,read).
access_vector(allow,local_login_t,self,file,write).
access_vector(allow,local_login_t,home_root_t,dir,search).
access_vector(allow,local_login_t,home_dir_type,dir,search).
access_vector(allow,local_login_t,var_run_t,dir,search).
access_vector(allow,local_login_t,initrc_var_run_t,file,ioctl).
access_vector(allow,local_login_t,initrc_var_run_t,file,read).
access_vector(allow,local_login_t,initrc_var_run_t,file,getattr).
access_vector(allow,local_login_t,initrc_var_run_t,file,lock).
access_vector(allow,local_login_t,initrc_var_run_t,file,write).
access_vector(allow,local_login_t,initrc_var_run_t,file,append).
access_vector(allow,local_login_t,var_log_t,dir,search).
access_vector(allow,local_login_t,wtmp_t,file,ioctl).
access_vector(allow,local_login_t,wtmp_t,file,read).
access_vector(allow,local_login_t,wtmp_t,file,getattr).
access_vector(allow,local_login_t,wtmp_t,file,lock).
access_vector(allow,local_login_t,wtmp_t,file,write).
access_vector(allow,local_login_t,wtmp_t,file,append).
access_vector(allow,local_login_t,lastlog_t,file,ioctl).
access_vector(allow,local_login_t,lastlog_t,file,read).
access_vector(allow,local_login_t,lastlog_t,file,getattr).
access_vector(allow,local_login_t,lastlog_t,file,lock).
access_vector(allow,local_login_t,lastlog_t,file,write).
access_vector(allow,local_login_t,lastlog_t,file,append).
access_vector(allow,local_login_t,faillog_t,file,append).
access_vector(allow,local_login_t,faillog_t,file,read).
access_vector(allow,local_login_t,faillog_t,file,write).
access_vector(allow,local_login_t,mail_spool_t,dir,read).
access_vector(allow,local_login_t,mail_spool_t,dir,getattr).
access_vector(allow,local_login_t,mail_spool_t,dir,lock).
access_vector(allow,local_login_t,mail_spool_t,dir,search).
access_vector(allow,local_login_t,mail_spool_t,dir,ioctl).
access_vector(allow,local_login_t,mail_spool_t,file,getattr).
access_vector(allow,local_login_t,mail_spool_t,lnk_file,read).
access_vector(allow,local_login_t,security_t,dir,read).
access_vector(allow,local_login_t,security_t,dir,search).
access_vector(allow,local_login_t,security_t,dir,getattr).
access_vector(allow,local_login_t,security_t,file,getattr).
access_vector(allow,local_login_t,security_t,file,read).
access_vector(allow,local_login_t,security_t,file,write).
access_vector(allow,local_login_t,security_t,security,check_context).
access_vector(allow,local_login_t,security_t,security,compute_av).
access_vector(allow,local_login_t,security_t,security,compute_create).
access_vector(allow,local_login_t,security_t,security,compute_relabel).
access_vector(allow,local_login_t,security_t,security,compute_user).
access_vector(allow,local_login_t,default_context_t,file,read).
access_vector(allow,local_login_t,default_context_t,file,getattr).
access_vector(allow,local_login_t,default_context_t,file,lock).
access_vector(allow,local_login_t,default_context_t,file,ioctl).
access_vector(allow,local_login_t,userdomain,process,transition).
access_vector(dontaudit,local_login_t,userdomain,process,noatsecure).
access_vector(allow,userdomain,local_login_t,process,sigchld).
access_vector(allow,userdomain,local_login_t,fd,use).
access_vector(allow,local_login_t,userdomain,fd,use).
access_vector(allow,userdomain,local_login_t,fifo_file,ioctl).
access_vector(allow,userdomain,local_login_t,fifo_file,read).
access_vector(allow,userdomain,local_login_t,fifo_file,getattr).
access_vector(allow,userdomain,local_login_t,fifo_file,lock).
access_vector(allow,userdomain,local_login_t,fifo_file,write).
access_vector(allow,userdomain,local_login_t,fifo_file,append).
access_vector(allow,userdomain,shell_exec_t,file,read).
access_vector(allow,userdomain,shell_exec_t,file,getattr).
access_vector(allow,userdomain,shell_exec_t,file,lock).
access_vector(allow,userdomain,shell_exec_t,file,execute).
access_vector(allow,userdomain,shell_exec_t,file,ioctl).
access_vector(allow,userdomain,shell_exec_t,file,entrypoint).
access_vector(dontaudit,local_login_t,fixed_disk_device_t,blk_file,getattr).
access_vector(dontaudit,local_login_t,fixed_disk_device_t,blk_file,setattr).
access_vector(dontaudit,local_login_t,removable_device_t,blk_file,getattr).
access_vector(dontaudit,local_login_t,removable_device_t,blk_file,setattr).
access_vector(dontaudit,local_login_t,device_t,chr_file,getattr).
access_vector(dontaudit,local_login_t,device_t,chr_file,setattr).
access_vector(dontaudit,local_login_t,device_t,blk_file,getattr).
access_vector(dontaudit,local_login_t,device_t,blk_file,setattr).
access_vector(dontaudit,local_login_t,device_t,lnk_file,getattr).
access_vector(dontaudit,local_login_t,device_t,lnk_file,setattr).
access_vector(dontaudit,local_login_t,misc_device_t,chr_file,getattr).
access_vector(dontaudit,local_login_t,misc_device_t,chr_file,setattr).
access_vector(dontaudit,local_login_t,misc_device_t,blk_file,getattr).
access_vector(dontaudit,local_login_t,misc_device_t,blk_file,setattr).
access_vector(dontaudit,local_login_t,misc_device_t,lnk_file,getattr).
access_vector(dontaudit,local_login_t,misc_device_t,lnk_file,setattr).
access_vector(dontaudit,local_login_t,framebuf_device_t,chr_file,getattr).
access_vector(dontaudit,local_login_t,framebuf_device_t,chr_file,setattr).
access_vector(dontaudit,local_login_t,framebuf_device_t,chr_file,read).
access_vector(dontaudit,local_login_t,framebuf_device_t,blk_file,getattr).
access_vector(dontaudit,local_login_t,framebuf_device_t,blk_file,setattr).
access_vector(dontaudit,local_login_t,framebuf_device_t,blk_file,read).
access_vector(dontaudit,local_login_t,framebuf_device_t,lnk_file,getattr).
access_vector(dontaudit,local_login_t,framebuf_device_t,lnk_file,setattr).
access_vector(dontaudit,local_login_t,framebuf_device_t,lnk_file,read).
access_vector(dontaudit,local_login_t,apm_bios_t,chr_file,getattr).
access_vector(dontaudit,local_login_t,apm_bios_t,chr_file,setattr).
access_vector(dontaudit,local_login_t,v4l_device_t,chr_file,getattr).
access_vector(dontaudit,local_login_t,v4l_device_t,chr_file,setattr).
access_vector(dontaudit,local_login_t,v4l_device_t,chr_file,read).
access_vector(dontaudit,local_login_t,v4l_device_t,blk_file,getattr).
access_vector(dontaudit,local_login_t,v4l_device_t,blk_file,setattr).
access_vector(dontaudit,local_login_t,v4l_device_t,blk_file,read).
access_vector(dontaudit,local_login_t,v4l_device_t,lnk_file,getattr).
access_vector(dontaudit,local_login_t,v4l_device_t,lnk_file,setattr).
access_vector(dontaudit,local_login_t,v4l_device_t,lnk_file,read).
access_vector(dontaudit,local_login_t,v4l_device_t,dir,read).
access_vector(dontaudit,local_login_t,v4l_device_t,dir,search).
access_vector(dontaudit,local_login_t,v4l_device_t,dir,getattr).
access_vector(dontaudit,local_login_t,file_t,dir,read).
access_vector(dontaudit,local_login_t,file_t,dir,getattr).
access_vector(dontaudit,local_login_t,file_t,dir,lock).
access_vector(dontaudit,local_login_t,file_t,dir,search).
access_vector(dontaudit,local_login_t,file_t,dir,ioctl).
access_vector(allow,local_login_t,var_lock_t,dir,read).
access_vector(allow,local_login_t,var_lock_t,dir,getattr).
access_vector(allow,local_login_t,var_lock_t,dir,lock).
access_vector(allow,local_login_t,var_lock_t,dir,search).
access_vector(allow,local_login_t,var_lock_t,dir,ioctl).
access_vector(allow,local_login_t,var_lock_t,dir,add_name).
access_vector(allow,local_login_t,var_lock_t,dir,remove_name).
access_vector(allow,local_login_t,var_lock_t,dir,write).
access_vector(allow,local_login_t,var_lock_t,file,create).
access_vector(allow,local_login_t,var_lock_t,file,ioctl).
access_vector(allow,local_login_t,var_lock_t,file,read).
access_vector(allow,local_login_t,var_lock_t,file,getattr).
access_vector(allow,local_login_t,var_lock_t,file,lock).
access_vector(allow,local_login_t,var_lock_t,file,write).
access_vector(allow,local_login_t,var_lock_t,file,setattr).
access_vector(allow,local_login_t,var_lock_t,file,append).
access_vector(allow,local_login_t,var_lock_t,file,link).
access_vector(allow,local_login_t,var_lock_t,file,unlink).
access_vector(allow,local_login_t,var_lock_t,file,rename).
access_vector(allow,local_login_t,tty_device_t,chr_file,setattr).
access_vector(allow,local_login_t,tty_device_t,chr_file,ioctl).
access_vector(allow,local_login_t,tty_device_t,chr_file,read).
access_vector(allow,local_login_t,tty_device_t,chr_file,getattr).
access_vector(allow,local_login_t,tty_device_t,chr_file,lock).
access_vector(allow,local_login_t,tty_device_t,chr_file,write).
access_vector(allow,local_login_t,tty_device_t,chr_file,append).
access_vector(allow,local_login_t,ttyfile,chr_file,setattr).
access_vector(allow,local_login_t,ttyfile,chr_file,ioctl).
access_vector(allow,local_login_t,ttyfile,chr_file,read).
access_vector(allow,local_login_t,ttyfile,chr_file,getattr).
access_vector(allow,local_login_t,ttyfile,chr_file,lock).
access_vector(allow,local_login_t,ttyfile,chr_file,write).
access_vector(allow,local_login_t,ttyfile,chr_file,append).
access_vector(allow,local_login_t,tty_device_t,chr_file,getattr).
access_vector(allow,local_login_t,tty_device_t,chr_file,relabelfrom).
access_vector(allow,local_login_t,tty_device_t,chr_file,relabelto).
access_vector(allow,local_login_t,ttyfile,chr_file,getattr).
access_vector(allow,local_login_t,ttyfile,chr_file,relabelfrom).
access_vector(allow,local_login_t,ttyfile,chr_file,relabelto).
access_vector(allow,local_login_t,sound_device_t,chr_file,getattr).
access_vector(allow,local_login_t,sound_device_t,chr_file,setattr).
access_vector(allow,local_login_t,var_run_t,dir,read).
access_vector(allow,local_login_t,var_run_t,dir,getattr).
access_vector(allow,local_login_t,var_run_t,dir,lock).
access_vector(allow,local_login_t,var_run_t,dir,search).
access_vector(allow,local_login_t,var_run_t,dir,ioctl).
access_vector(allow,local_login_t,var_run_t,dir,add_name).
access_vector(allow,local_login_t,var_run_t,dir,remove_name).
access_vector(allow,local_login_t,var_run_t,dir,write).
access_vector(allow,local_login_t,var_run_t,file,create).
access_vector(allow,local_login_t,var_run_t,file,ioctl).
access_vector(allow,local_login_t,var_run_t,file,read).
access_vector(allow,local_login_t,var_run_t,file,getattr).
access_vector(allow,local_login_t,var_run_t,file,lock).
access_vector(allow,local_login_t,var_run_t,file,write).
access_vector(allow,local_login_t,var_run_t,file,setattr).
access_vector(allow,local_login_t,var_run_t,file,append).
access_vector(allow,local_login_t,var_run_t,file,link).
access_vector(allow,local_login_t,var_run_t,file,unlink).
access_vector(allow,local_login_t,var_run_t,file,rename).
type_decl(remote_login_t,[],[domain,privuser,privrole,privlog,auth,privowner,mlstrustedreader,mlstrustedwriter,mlstrustedobject,privfd]).
role_decl(system_r,remote_login_t).
access_vector(allow,remote_login_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,remote_login_t,self,dir,read).
access_vector(allow,remote_login_t,self,dir,getattr).
access_vector(allow,remote_login_t,self,dir,lock).
access_vector(allow,remote_login_t,self,dir,search).
access_vector(allow,remote_login_t,self,dir,ioctl).
access_vector(allow,remote_login_t,self,file,read).
access_vector(allow,remote_login_t,self,file,getattr).
access_vector(allow,remote_login_t,self,file,lock).
access_vector(allow,remote_login_t,self,file,ioctl).
access_vector(allow,remote_login_t,self,lnk_file,read).
access_vector(allow,remote_login_t,self,lnk_file,getattr).
access_vector(allow,remote_login_t,self,lnk_file,lock).
access_vector(allow,remote_login_t,self,lnk_file,ioctl).
access_vector(allow,remote_login_t,self,sock_file,read).
access_vector(allow,remote_login_t,self,sock_file,getattr).
access_vector(allow,remote_login_t,self,sock_file,lock).
access_vector(allow,remote_login_t,self,sock_file,ioctl).
access_vector(allow,remote_login_t,self,fifo_file,read).
access_vector(allow,remote_login_t,self,fifo_file,getattr).
access_vector(allow,remote_login_t,self,fifo_file,lock).
access_vector(allow,remote_login_t,self,fifo_file,ioctl).
access_vector(allow,remote_login_t,self,fd,_).
access_vector(allow,remote_login_t,self,fifo_file,ioctl).
access_vector(allow,remote_login_t,self,fifo_file,read).
access_vector(allow,remote_login_t,self,fifo_file,getattr).
access_vector(allow,remote_login_t,self,fifo_file,lock).
access_vector(allow,remote_login_t,self,fifo_file,write).
access_vector(allow,remote_login_t,self,fifo_file,append).
access_vector(allow,remote_login_t,self,unix_dgram_socket,create).
access_vector(allow,remote_login_t,self,unix_dgram_socket,ioctl).
access_vector(allow,remote_login_t,self,unix_dgram_socket,read).
access_vector(allow,remote_login_t,self,unix_dgram_socket,getattr).
access_vector(allow,remote_login_t,self,unix_dgram_socket,write).
access_vector(allow,remote_login_t,self,unix_dgram_socket,setattr).
access_vector(allow,remote_login_t,self,unix_dgram_socket,append).
access_vector(allow,remote_login_t,self,unix_dgram_socket,bind).
access_vector(allow,remote_login_t,self,unix_dgram_socket,connect).
access_vector(allow,remote_login_t,self,unix_dgram_socket,getopt).
access_vector(allow,remote_login_t,self,unix_dgram_socket,setopt).
access_vector(allow,remote_login_t,self,unix_dgram_socket,shutdown).
access_vector(allow,remote_login_t,self,unix_stream_socket,create).
access_vector(allow,remote_login_t,self,unix_stream_socket,ioctl).
access_vector(allow,remote_login_t,self,unix_stream_socket,read).
access_vector(allow,remote_login_t,self,unix_stream_socket,getattr).
access_vector(allow,remote_login_t,self,unix_stream_socket,write).
access_vector(allow,remote_login_t,self,unix_stream_socket,setattr).
access_vector(allow,remote_login_t,self,unix_stream_socket,append).
access_vector(allow,remote_login_t,self,unix_stream_socket,bind).
access_vector(allow,remote_login_t,self,unix_stream_socket,connect).
access_vector(allow,remote_login_t,self,unix_stream_socket,getopt).
access_vector(allow,remote_login_t,self,unix_stream_socket,setopt).
access_vector(allow,remote_login_t,self,unix_stream_socket,shutdown).
access_vector(allow,remote_login_t,self,unix_stream_socket,listen).
access_vector(allow,remote_login_t,self,unix_stream_socket,accept).
access_vector(allow,remote_login_t,self,unix_dgram_socket,sendto).
access_vector(allow,remote_login_t,self,unix_stream_socket,connectto).
access_vector(allow,remote_login_t,self,sem,associate).
access_vector(allow,remote_login_t,self,sem,getattr).
access_vector(allow,remote_login_t,self,sem,setattr).
access_vector(allow,remote_login_t,self,sem,create).
access_vector(allow,remote_login_t,self,sem,destroy).
access_vector(allow,remote_login_t,self,sem,read).
access_vector(allow,remote_login_t,self,sem,write).
access_vector(allow,remote_login_t,self,sem,unix_read).
access_vector(allow,remote_login_t,self,sem,unix_write).
access_vector(allow,remote_login_t,self,msg,send).
access_vector(allow,remote_login_t,self,msg,receive).
access_vector(allow,remote_login_t,self,msgq,associate).
access_vector(allow,remote_login_t,self,msgq,getattr).
access_vector(allow,remote_login_t,self,msgq,setattr).
access_vector(allow,remote_login_t,self,msgq,create).
access_vector(allow,remote_login_t,self,msgq,destroy).
access_vector(allow,remote_login_t,self,msgq,read).
access_vector(allow,remote_login_t,self,msgq,write).
access_vector(allow,remote_login_t,self,msgq,enqueue).
access_vector(allow,remote_login_t,self,msgq,unix_read).
access_vector(allow,remote_login_t,self,msgq,unix_write).
access_vector(allow,remote_login_t,self,shm,associate).
access_vector(allow,remote_login_t,self,shm,getattr).
access_vector(allow,remote_login_t,self,shm,setattr).
access_vector(allow,remote_login_t,self,shm,create).
access_vector(allow,remote_login_t,self,shm,destroy).
access_vector(allow,remote_login_t,self,shm,read).
access_vector(allow,remote_login_t,self,shm,write).
access_vector(allow,remote_login_t,self,shm,lock).
access_vector(allow,remote_login_t,self,shm,unix_read).
access_vector(allow,remote_login_t,self,shm,unix_write).
access_vector(allow,remote_login_t,proc_t,dir,read).
access_vector(allow,remote_login_t,proc_t,dir,getattr).
access_vector(allow,remote_login_t,proc_t,dir,lock).
access_vector(allow,remote_login_t,proc_t,dir,search).
access_vector(allow,remote_login_t,proc_t,dir,ioctl).
access_vector(allow,remote_login_t,proc_t,file,read).
access_vector(allow,remote_login_t,proc_t,file,getattr).
access_vector(allow,remote_login_t,proc_t,file,lock).
access_vector(allow,remote_login_t,proc_t,file,ioctl).
access_vector(allow,remote_login_t,proc_t,lnk_file,read).
access_vector(allow,remote_login_t,proc_t,lnk_file,getattr).
access_vector(allow,remote_login_t,proc_t,lnk_file,lock).
access_vector(allow,remote_login_t,proc_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,proc_t,sock_file,read).
access_vector(allow,remote_login_t,proc_t,sock_file,getattr).
access_vector(allow,remote_login_t,proc_t,sock_file,lock).
access_vector(allow,remote_login_t,proc_t,sock_file,ioctl).
access_vector(allow,remote_login_t,proc_t,fifo_file,read).
access_vector(allow,remote_login_t,proc_t,fifo_file,getattr).
access_vector(allow,remote_login_t,proc_t,fifo_file,lock).
access_vector(allow,remote_login_t,proc_t,fifo_file,ioctl).
access_vector(allow,remote_login_t,root_t,dir,read).
access_vector(allow,remote_login_t,root_t,dir,getattr).
access_vector(allow,remote_login_t,root_t,dir,lock).
access_vector(allow,remote_login_t,root_t,dir,search).
access_vector(allow,remote_login_t,root_t,dir,ioctl).
access_vector(allow,remote_login_t,root_t,file,read).
access_vector(allow,remote_login_t,root_t,file,getattr).
access_vector(allow,remote_login_t,root_t,file,lock).
access_vector(allow,remote_login_t,root_t,file,ioctl).
access_vector(allow,remote_login_t,root_t,lnk_file,read).
access_vector(allow,remote_login_t,root_t,lnk_file,getattr).
access_vector(allow,remote_login_t,root_t,lnk_file,lock).
access_vector(allow,remote_login_t,root_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,root_t,sock_file,read).
access_vector(allow,remote_login_t,root_t,sock_file,getattr).
access_vector(allow,remote_login_t,root_t,sock_file,lock).
access_vector(allow,remote_login_t,root_t,sock_file,ioctl).
access_vector(allow,remote_login_t,root_t,fifo_file,read).
access_vector(allow,remote_login_t,root_t,fifo_file,getattr).
access_vector(allow,remote_login_t,root_t,fifo_file,lock).
access_vector(allow,remote_login_t,root_t,fifo_file,ioctl).
access_vector(allow,remote_login_t,home_root_t,dir,read).
access_vector(allow,remote_login_t,home_root_t,dir,getattr).
access_vector(allow,remote_login_t,home_root_t,dir,lock).
access_vector(allow,remote_login_t,home_root_t,dir,search).
access_vector(allow,remote_login_t,home_root_t,dir,ioctl).
access_vector(allow,remote_login_t,usr_t,dir,read).
access_vector(allow,remote_login_t,usr_t,dir,getattr).
access_vector(allow,remote_login_t,usr_t,dir,lock).
access_vector(allow,remote_login_t,usr_t,dir,search).
access_vector(allow,remote_login_t,usr_t,dir,ioctl).
access_vector(allow,remote_login_t,usr_t,file,read).
access_vector(allow,remote_login_t,usr_t,file,getattr).
access_vector(allow,remote_login_t,usr_t,file,lock).
access_vector(allow,remote_login_t,usr_t,file,ioctl).
access_vector(allow,remote_login_t,usr_t,lnk_file,read).
access_vector(allow,remote_login_t,usr_t,lnk_file,getattr).
access_vector(allow,remote_login_t,usr_t,lnk_file,lock).
access_vector(allow,remote_login_t,usr_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,usr_t,sock_file,read).
access_vector(allow,remote_login_t,usr_t,sock_file,getattr).
access_vector(allow,remote_login_t,usr_t,sock_file,lock).
access_vector(allow,remote_login_t,usr_t,sock_file,ioctl).
access_vector(allow,remote_login_t,usr_t,fifo_file,read).
access_vector(allow,remote_login_t,usr_t,fifo_file,getattr).
access_vector(allow,remote_login_t,usr_t,fifo_file,lock).
access_vector(allow,remote_login_t,usr_t,fifo_file,ioctl).
access_vector(allow,remote_login_t,bin_t,dir,read).
access_vector(allow,remote_login_t,bin_t,dir,getattr).
access_vector(allow,remote_login_t,bin_t,dir,lock).
access_vector(allow,remote_login_t,bin_t,dir,search).
access_vector(allow,remote_login_t,bin_t,dir,ioctl).
access_vector(allow,remote_login_t,bin_t,file,read).
access_vector(allow,remote_login_t,bin_t,file,getattr).
access_vector(allow,remote_login_t,bin_t,file,lock).
access_vector(allow,remote_login_t,bin_t,file,ioctl).
access_vector(allow,remote_login_t,bin_t,lnk_file,read).
access_vector(allow,remote_login_t,bin_t,lnk_file,getattr).
access_vector(allow,remote_login_t,bin_t,lnk_file,lock).
access_vector(allow,remote_login_t,bin_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,bin_t,sock_file,read).
access_vector(allow,remote_login_t,bin_t,sock_file,getattr).
access_vector(allow,remote_login_t,bin_t,sock_file,lock).
access_vector(allow,remote_login_t,bin_t,sock_file,ioctl).
access_vector(allow,remote_login_t,bin_t,fifo_file,read).
access_vector(allow,remote_login_t,bin_t,fifo_file,getattr).
access_vector(allow,remote_login_t,bin_t,fifo_file,lock).
access_vector(allow,remote_login_t,bin_t,fifo_file,ioctl).
access_vector(allow,remote_login_t,sbin_t,dir,read).
access_vector(allow,remote_login_t,sbin_t,dir,getattr).
access_vector(allow,remote_login_t,sbin_t,dir,lock).
access_vector(allow,remote_login_t,sbin_t,dir,search).
access_vector(allow,remote_login_t,sbin_t,dir,ioctl).
access_vector(allow,remote_login_t,sbin_t,file,read).
access_vector(allow,remote_login_t,sbin_t,file,getattr).
access_vector(allow,remote_login_t,sbin_t,file,lock).
access_vector(allow,remote_login_t,sbin_t,file,ioctl).
access_vector(allow,remote_login_t,sbin_t,lnk_file,read).
access_vector(allow,remote_login_t,sbin_t,lnk_file,getattr).
access_vector(allow,remote_login_t,sbin_t,lnk_file,lock).
access_vector(allow,remote_login_t,sbin_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,sbin_t,sock_file,read).
access_vector(allow,remote_login_t,sbin_t,sock_file,getattr).
access_vector(allow,remote_login_t,sbin_t,sock_file,lock).
access_vector(allow,remote_login_t,sbin_t,sock_file,ioctl).
access_vector(allow,remote_login_t,sbin_t,fifo_file,read).
access_vector(allow,remote_login_t,sbin_t,fifo_file,getattr).
access_vector(allow,remote_login_t,sbin_t,fifo_file,lock).
access_vector(allow,remote_login_t,sbin_t,fifo_file,ioctl).
access_vector(allow,remote_login_t,readable_t,dir,read).
access_vector(allow,remote_login_t,readable_t,dir,getattr).
access_vector(allow,remote_login_t,readable_t,dir,lock).
access_vector(allow,remote_login_t,readable_t,dir,search).
access_vector(allow,remote_login_t,readable_t,dir,ioctl).
access_vector(allow,remote_login_t,readable_t,file,read).
access_vector(allow,remote_login_t,readable_t,file,getattr).
access_vector(allow,remote_login_t,readable_t,file,lock).
access_vector(allow,remote_login_t,readable_t,file,ioctl).
access_vector(allow,remote_login_t,readable_t,lnk_file,read).
access_vector(allow,remote_login_t,readable_t,lnk_file,getattr).
access_vector(allow,remote_login_t,readable_t,lnk_file,lock).
access_vector(allow,remote_login_t,readable_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,readable_t,sock_file,read).
access_vector(allow,remote_login_t,readable_t,sock_file,getattr).
access_vector(allow,remote_login_t,readable_t,sock_file,lock).
access_vector(allow,remote_login_t,readable_t,sock_file,ioctl).
access_vector(allow,remote_login_t,readable_t,fifo_file,read).
access_vector(allow,remote_login_t,readable_t,fifo_file,getattr).
access_vector(allow,remote_login_t,readable_t,fifo_file,lock).
access_vector(allow,remote_login_t,readable_t,fifo_file,ioctl).
access_vector(allow,remote_login_t,var_t,dir,search).
access_vector(allow,remote_login_t,var_spool_t,dir,search).
access_vector(allow,remote_login_t,etc_t,dir,read).
access_vector(allow,remote_login_t,etc_t,dir,getattr).
access_vector(allow,remote_login_t,etc_t,dir,lock).
access_vector(allow,remote_login_t,etc_t,dir,search).
access_vector(allow,remote_login_t,etc_t,dir,ioctl).
access_vector(allow,remote_login_t,etc_t,file,read).
access_vector(allow,remote_login_t,etc_t,file,getattr).
access_vector(allow,remote_login_t,etc_t,file,lock).
access_vector(allow,remote_login_t,etc_t,file,ioctl).
access_vector(allow,remote_login_t,etc_t,lnk_file,read).
access_vector(allow,remote_login_t,etc_t,lnk_file,getattr).
access_vector(allow,remote_login_t,etc_t,lnk_file,lock).
access_vector(allow,remote_login_t,etc_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,etc_t,sock_file,read).
access_vector(allow,remote_login_t,etc_t,sock_file,getattr).
access_vector(allow,remote_login_t,etc_t,sock_file,lock).
access_vector(allow,remote_login_t,etc_t,sock_file,ioctl).
access_vector(allow,remote_login_t,etc_t,fifo_file,read).
access_vector(allow,remote_login_t,etc_t,fifo_file,getattr).
access_vector(allow,remote_login_t,etc_t,fifo_file,lock).
access_vector(allow,remote_login_t,etc_t,fifo_file,ioctl).
access_vector(allow,remote_login_t,etc_runtime_t,file,read).
access_vector(allow,remote_login_t,etc_runtime_t,file,getattr).
access_vector(allow,remote_login_t,etc_runtime_t,file,lock).
access_vector(allow,remote_login_t,etc_runtime_t,file,ioctl).
access_vector(allow,remote_login_t,etc_runtime_t,lnk_file,read).
access_vector(allow,remote_login_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,remote_login_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,remote_login_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,etc_t,lnk_file,read).
access_vector(allow,remote_login_t,locale_t,dir,read).
access_vector(allow,remote_login_t,locale_t,dir,getattr).
access_vector(allow,remote_login_t,locale_t,dir,lock).
access_vector(allow,remote_login_t,locale_t,dir,search).
access_vector(allow,remote_login_t,locale_t,dir,ioctl).
access_vector(allow,remote_login_t,locale_t,file,read).
access_vector(allow,remote_login_t,locale_t,file,getattr).
access_vector(allow,remote_login_t,locale_t,file,lock).
access_vector(allow,remote_login_t,locale_t,file,ioctl).
access_vector(allow,remote_login_t,locale_t,lnk_file,read).
access_vector(allow,remote_login_t,locale_t,lnk_file,getattr).
access_vector(allow,remote_login_t,locale_t,lnk_file,lock).
access_vector(allow,remote_login_t,locale_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,exec_type,file,read).
access_vector(allow,remote_login_t,exec_type,file,getattr).
access_vector(allow,remote_login_t,exec_type,file,lock).
access_vector(allow,remote_login_t,exec_type,file,ioctl).
access_vector(allow,remote_login_t,exec_type,lnk_file,read).
access_vector(allow,remote_login_t,exec_type,lnk_file,getattr).
access_vector(allow,remote_login_t,exec_type,lnk_file,lock).
access_vector(allow,remote_login_t,exec_type,lnk_file,ioctl).
access_vector(allow,remote_login_t,device_t,dir,read).
access_vector(allow,remote_login_t,device_t,dir,getattr).
access_vector(allow,remote_login_t,device_t,dir,lock).
access_vector(allow,remote_login_t,device_t,dir,search).
access_vector(allow,remote_login_t,device_t,dir,ioctl).
access_vector(allow,remote_login_t,device_t,lnk_file,read).
access_vector(allow,remote_login_t,device_t,lnk_file,getattr).
access_vector(allow,remote_login_t,device_t,lnk_file,lock).
access_vector(allow,remote_login_t,device_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,lib_t,dir,read).
access_vector(allow,remote_login_t,lib_t,dir,getattr).
access_vector(allow,remote_login_t,lib_t,dir,lock).
access_vector(allow,remote_login_t,lib_t,dir,search).
access_vector(allow,remote_login_t,lib_t,dir,ioctl).
access_vector(allow,remote_login_t,lib_t,lnk_file,read).
access_vector(allow,remote_login_t,lib_t,lnk_file,getattr).
access_vector(allow,remote_login_t,lib_t,lnk_file,lock).
access_vector(allow,remote_login_t,lib_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,ld_so_t,file,read).
access_vector(allow,remote_login_t,ld_so_t,file,getattr).
access_vector(allow,remote_login_t,ld_so_t,file,lock).
access_vector(allow,remote_login_t,ld_so_t,file,execute).
access_vector(allow,remote_login_t,ld_so_t,file,ioctl).
access_vector(allow,remote_login_t,ld_so_t,file,execute_no_trans).
access_vector(allow,remote_login_t,ld_so_t,lnk_file,read).
access_vector(allow,remote_login_t,ld_so_t,lnk_file,getattr).
access_vector(allow,remote_login_t,ld_so_t,lnk_file,lock).
access_vector(allow,remote_login_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,shlib_t,file,read).
access_vector(allow,remote_login_t,shlib_t,file,getattr).
access_vector(allow,remote_login_t,shlib_t,file,lock).
access_vector(allow,remote_login_t,shlib_t,file,execute).
access_vector(allow,remote_login_t,shlib_t,file,ioctl).
access_vector(allow,remote_login_t,shlib_t,lnk_file,read).
access_vector(allow,remote_login_t,shlib_t,lnk_file,getattr).
access_vector(allow,remote_login_t,shlib_t,lnk_file,lock).
access_vector(allow,remote_login_t,shlib_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,ld_so_cache_t,file,read).
access_vector(allow,remote_login_t,ld_so_cache_t,file,getattr).
access_vector(allow,remote_login_t,ld_so_cache_t,file,lock).
access_vector(allow,remote_login_t,ld_so_cache_t,file,ioctl).
access_vector(allow,remote_login_t,device_t,dir,search).
access_vector(allow,remote_login_t,null_device_t,chr_file,ioctl).
access_vector(allow,remote_login_t,null_device_t,chr_file,read).
access_vector(allow,remote_login_t,null_device_t,chr_file,getattr).
access_vector(allow,remote_login_t,null_device_t,chr_file,lock).
access_vector(allow,remote_login_t,null_device_t,chr_file,write).
access_vector(allow,remote_login_t,null_device_t,chr_file,append).
type_decl(remote_login_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,remote_login_t,tmp_t,dir,read).
access_vector(allow,remote_login_t,tmp_t,dir,getattr).
access_vector(allow,remote_login_t,tmp_t,dir,lock).
access_vector(allow,remote_login_t,tmp_t,dir,search).
access_vector(allow,remote_login_t,tmp_t,dir,ioctl).
access_vector(allow,remote_login_t,tmp_t,dir,add_name).
access_vector(allow,remote_login_t,tmp_t,dir,remove_name).
access_vector(allow,remote_login_t,tmp_t,dir,write).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,create).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,ioctl).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,read).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,getattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,lock).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,write).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,setattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,append).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,link).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,unlink).
access_vector(allow,remote_login_t,remote_login_tmp_t,file,rename).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,create).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,ioctl).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,read).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,getattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,lock).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,write).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,setattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,append).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,link).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,unlink).
access_vector(allow,remote_login_t,remote_login_tmp_t,lnk_file,rename).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,create).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,ioctl).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,read).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,getattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,lock).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,write).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,setattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,append).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,link).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,unlink).
access_vector(allow,remote_login_t,remote_login_tmp_t,sock_file,rename).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,create).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,ioctl).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,read).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,getattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,lock).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,write).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,setattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,append).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,link).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,unlink).
access_vector(allow,remote_login_t,remote_login_tmp_t,fifo_file,rename).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,create).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,read).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,getattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,lock).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,setattr).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,link).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,unlink).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,rename).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,search).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,add_name).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,remove_name).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,reparent).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,write).
access_vector(allow,remote_login_t,remote_login_tmp_t,dir,rmdir).
type_trans(remote_login_t,tmp_t,dir,remote_login_tmp_t).
type_trans(remote_login_t,tmp_t,[file,lnk_file,sock_file,fifo_file],remote_login_tmp_t).
access_vector(allow,remote_login_t,self,capability,setuid).
access_vector(allow,remote_login_t,self,capability,setgid).
access_vector(allow,remote_login_t,self,capability,chown).
access_vector(allow,remote_login_t,self,capability,fowner).
access_vector(allow,remote_login_t,self,capability,fsetid).
access_vector(allow,remote_login_t,self,capability,net_bind_service).
access_vector(allow,remote_login_t,self,capability,sys_tty_config).
access_vector(allow,remote_login_t,self,capability,dac_override).
access_vector(allow,remote_login_t,self,capability,sys_nice).
access_vector(allow,remote_login_t,self,capability,sys_resource).
access_vector(allow,remote_login_t,user_t,process,transition).
access_vector(dontaudit,remote_login_t,user_t,process,noatsecure).
access_vector(allow,remote_login_t,shell_exec_t,file,read).
access_vector(allow,remote_login_t,shell_exec_t,file,getattr).
access_vector(allow,remote_login_t,shell_exec_t,file,execute).
access_vector(allow,user_t,remote_login_t,process,sigchld).
access_vector(allow,user_t,remote_login_t,fd,use).
access_vector(allow,remote_login_t,user_t,fd,use).
access_vector(allow,user_t,remote_login_t,fifo_file,ioctl).
access_vector(allow,user_t,remote_login_t,fifo_file,read).
access_vector(allow,user_t,remote_login_t,fifo_file,getattr).
access_vector(allow,user_t,remote_login_t,fifo_file,lock).
access_vector(allow,user_t,remote_login_t,fifo_file,write).
access_vector(allow,user_t,remote_login_t,fifo_file,append).
access_vector(allow,user_t,shell_exec_t,file,entrypoint).
type_trans(remote_login_t,shell_exec_t,process,user_t).
access_vector(allow,remote_login_t,self,process,setexec).
access_vector(allow,remote_login_t,proc_t,dir,search).
access_vector(allow,remote_login_t,proc_t,lnk_file,read).
access_vector(allow,remote_login_t,self,dir,search).
access_vector(allow,remote_login_t,self,file,read).
access_vector(allow,remote_login_t,self,file,write).
access_vector(allow,remote_login_t,home_root_t,dir,search).
access_vector(allow,remote_login_t,home_dir_type,dir,search).
access_vector(allow,remote_login_t,var_run_t,dir,search).
access_vector(allow,remote_login_t,initrc_var_run_t,file,ioctl).
access_vector(allow,remote_login_t,initrc_var_run_t,file,read).
access_vector(allow,remote_login_t,initrc_var_run_t,file,getattr).
access_vector(allow,remote_login_t,initrc_var_run_t,file,lock).
access_vector(allow,remote_login_t,initrc_var_run_t,file,write).
access_vector(allow,remote_login_t,initrc_var_run_t,file,append).
access_vector(allow,remote_login_t,var_log_t,dir,search).
access_vector(allow,remote_login_t,wtmp_t,file,ioctl).
access_vector(allow,remote_login_t,wtmp_t,file,read).
access_vector(allow,remote_login_t,wtmp_t,file,getattr).
access_vector(allow,remote_login_t,wtmp_t,file,lock).
access_vector(allow,remote_login_t,wtmp_t,file,write).
access_vector(allow,remote_login_t,wtmp_t,file,append).
access_vector(allow,remote_login_t,lastlog_t,file,ioctl).
access_vector(allow,remote_login_t,lastlog_t,file,read).
access_vector(allow,remote_login_t,lastlog_t,file,getattr).
access_vector(allow,remote_login_t,lastlog_t,file,lock).
access_vector(allow,remote_login_t,lastlog_t,file,write).
access_vector(allow,remote_login_t,lastlog_t,file,append).
access_vector(allow,remote_login_t,faillog_t,file,append).
access_vector(allow,remote_login_t,faillog_t,file,read).
access_vector(allow,remote_login_t,faillog_t,file,write).
access_vector(allow,remote_login_t,mail_spool_t,dir,read).
access_vector(allow,remote_login_t,mail_spool_t,dir,getattr).
access_vector(allow,remote_login_t,mail_spool_t,dir,lock).
access_vector(allow,remote_login_t,mail_spool_t,dir,search).
access_vector(allow,remote_login_t,mail_spool_t,dir,ioctl).
access_vector(allow,remote_login_t,mail_spool_t,file,getattr).
access_vector(allow,remote_login_t,mail_spool_t,lnk_file,read).
access_vector(allow,remote_login_t,security_t,dir,read).
access_vector(allow,remote_login_t,security_t,dir,search).
access_vector(allow,remote_login_t,security_t,dir,getattr).
access_vector(allow,remote_login_t,security_t,file,getattr).
access_vector(allow,remote_login_t,security_t,file,read).
access_vector(allow,remote_login_t,security_t,file,write).
access_vector(allow,remote_login_t,security_t,security,check_context).
access_vector(allow,remote_login_t,security_t,security,compute_av).
access_vector(allow,remote_login_t,security_t,security,compute_create).
access_vector(allow,remote_login_t,security_t,security,compute_relabel).
access_vector(allow,remote_login_t,security_t,security,compute_user).
access_vector(allow,remote_login_t,default_context_t,file,read).
access_vector(allow,remote_login_t,default_context_t,file,getattr).
access_vector(allow,remote_login_t,default_context_t,file,lock).
access_vector(allow,remote_login_t,default_context_t,file,ioctl).
access_vector(allow,remote_login_t,unpriv_userdomain,process,transition).
access_vector(dontaudit,remote_login_t,unpriv_userdomain,process,noatsecure).
access_vector(allow,unpriv_userdomain,remote_login_t,process,sigchld).
access_vector(allow,unpriv_userdomain,remote_login_t,fd,use).
access_vector(allow,remote_login_t,unpriv_userdomain,fd,use).
access_vector(allow,unpriv_userdomain,remote_login_t,fifo_file,ioctl).
access_vector(allow,unpriv_userdomain,remote_login_t,fifo_file,read).
access_vector(allow,unpriv_userdomain,remote_login_t,fifo_file,getattr).
access_vector(allow,unpriv_userdomain,remote_login_t,fifo_file,lock).
access_vector(allow,unpriv_userdomain,remote_login_t,fifo_file,write).
access_vector(allow,unpriv_userdomain,remote_login_t,fifo_file,append).
access_vector(allow,unpriv_userdomain,shell_exec_t,file,read).
access_vector(allow,unpriv_userdomain,shell_exec_t,file,getattr).
access_vector(allow,unpriv_userdomain,shell_exec_t,file,lock).
access_vector(allow,unpriv_userdomain,shell_exec_t,file,execute).
access_vector(allow,unpriv_userdomain,shell_exec_t,file,ioctl).
access_vector(allow,unpriv_userdomain,shell_exec_t,file,entrypoint).
access_vector(allow,remote_login_t,devpts_t,dir,search).
access_vector(allow,remote_login_t,ptyfile,chr_file,getattr).
access_vector(allow,remote_login_t,ptyfile,chr_file,relabelfrom).
access_vector(allow,remote_login_t,ptyfile,chr_file,relabelto).
type_decl(logrotate_t,[],[domain,privowner,privmail]).
role_decl(system_r,logrotate_t).
role_decl(sysadm_r,logrotate_t).
access_vector(allow,logrotate_t,root_t,dir,read).
access_vector(allow,logrotate_t,root_t,dir,getattr).
access_vector(allow,logrotate_t,root_t,dir,lock).
access_vector(allow,logrotate_t,root_t,dir,search).
access_vector(allow,logrotate_t,root_t,dir,ioctl).
access_vector(allow,logrotate_t,usr_t,dir,read).
access_vector(allow,logrotate_t,usr_t,dir,getattr).
access_vector(allow,logrotate_t,usr_t,dir,lock).
access_vector(allow,logrotate_t,usr_t,dir,search).
access_vector(allow,logrotate_t,usr_t,dir,ioctl).
access_vector(allow,logrotate_t,lib_t,dir,read).
access_vector(allow,logrotate_t,lib_t,dir,getattr).
access_vector(allow,logrotate_t,lib_t,dir,lock).
access_vector(allow,logrotate_t,lib_t,dir,search).
access_vector(allow,logrotate_t,lib_t,dir,ioctl).
access_vector(allow,logrotate_t,etc_t,dir,read).
access_vector(allow,logrotate_t,etc_t,dir,getattr).
access_vector(allow,logrotate_t,etc_t,dir,lock).
access_vector(allow,logrotate_t,etc_t,dir,search).
access_vector(allow,logrotate_t,etc_t,dir,ioctl).
access_vector(allow,logrotate_t,lib_t,lnk_file,read).
access_vector(allow,logrotate_t,lib_t,lnk_file,getattr).
access_vector(allow,logrotate_t,lib_t,lnk_file,lock).
access_vector(allow,logrotate_t,lib_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,ld_so_t,file,read).
access_vector(allow,logrotate_t,ld_so_t,file,getattr).
access_vector(allow,logrotate_t,ld_so_t,file,lock).
access_vector(allow,logrotate_t,ld_so_t,file,execute).
access_vector(allow,logrotate_t,ld_so_t,file,ioctl).
access_vector(allow,logrotate_t,ld_so_t,file,execute_no_trans).
access_vector(allow,logrotate_t,ld_so_t,lnk_file,read).
access_vector(allow,logrotate_t,ld_so_t,lnk_file,getattr).
access_vector(allow,logrotate_t,ld_so_t,lnk_file,lock).
access_vector(allow,logrotate_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,shlib_t,file,read).
access_vector(allow,logrotate_t,shlib_t,file,getattr).
access_vector(allow,logrotate_t,shlib_t,file,lock).
access_vector(allow,logrotate_t,shlib_t,file,execute).
access_vector(allow,logrotate_t,shlib_t,file,ioctl).
access_vector(allow,logrotate_t,shlib_t,lnk_file,read).
access_vector(allow,logrotate_t,shlib_t,lnk_file,getattr).
access_vector(allow,logrotate_t,shlib_t,lnk_file,lock).
access_vector(allow,logrotate_t,shlib_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,ld_so_cache_t,file,read).
access_vector(allow,logrotate_t,ld_so_cache_t,file,getattr).
access_vector(allow,logrotate_t,ld_so_cache_t,file,lock).
access_vector(allow,logrotate_t,ld_so_cache_t,file,ioctl).
access_vector(allow,logrotate_t,device_t,dir,search).
access_vector(allow,logrotate_t,null_device_t,chr_file,ioctl).
access_vector(allow,logrotate_t,null_device_t,chr_file,read).
access_vector(allow,logrotate_t,null_device_t,chr_file,getattr).
access_vector(allow,logrotate_t,null_device_t,chr_file,lock).
access_vector(allow,logrotate_t,null_device_t,chr_file,write).
access_vector(allow,logrotate_t,null_device_t,chr_file,append).
access_vector(allow,logrotate_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,logrotate_t,self,dir,read).
access_vector(allow,logrotate_t,self,dir,getattr).
access_vector(allow,logrotate_t,self,dir,lock).
access_vector(allow,logrotate_t,self,dir,search).
access_vector(allow,logrotate_t,self,dir,ioctl).
access_vector(allow,logrotate_t,self,file,read).
access_vector(allow,logrotate_t,self,file,getattr).
access_vector(allow,logrotate_t,self,file,lock).
access_vector(allow,logrotate_t,self,file,ioctl).
access_vector(allow,logrotate_t,self,lnk_file,read).
access_vector(allow,logrotate_t,self,lnk_file,getattr).
access_vector(allow,logrotate_t,self,lnk_file,lock).
access_vector(allow,logrotate_t,self,lnk_file,ioctl).
access_vector(allow,logrotate_t,self,sock_file,read).
access_vector(allow,logrotate_t,self,sock_file,getattr).
access_vector(allow,logrotate_t,self,sock_file,lock).
access_vector(allow,logrotate_t,self,sock_file,ioctl).
access_vector(allow,logrotate_t,self,fifo_file,read).
access_vector(allow,logrotate_t,self,fifo_file,getattr).
access_vector(allow,logrotate_t,self,fifo_file,lock).
access_vector(allow,logrotate_t,self,fifo_file,ioctl).
access_vector(allow,logrotate_t,self,fd,_).
access_vector(allow,logrotate_t,self,fifo_file,ioctl).
access_vector(allow,logrotate_t,self,fifo_file,read).
access_vector(allow,logrotate_t,self,fifo_file,getattr).
access_vector(allow,logrotate_t,self,fifo_file,lock).
access_vector(allow,logrotate_t,self,fifo_file,write).
access_vector(allow,logrotate_t,self,fifo_file,append).
access_vector(allow,logrotate_t,self,unix_dgram_socket,create).
access_vector(allow,logrotate_t,self,unix_dgram_socket,ioctl).
access_vector(allow,logrotate_t,self,unix_dgram_socket,read).
access_vector(allow,logrotate_t,self,unix_dgram_socket,getattr).
access_vector(allow,logrotate_t,self,unix_dgram_socket,write).
access_vector(allow,logrotate_t,self,unix_dgram_socket,setattr).
access_vector(allow,logrotate_t,self,unix_dgram_socket,append).
access_vector(allow,logrotate_t,self,unix_dgram_socket,bind).
access_vector(allow,logrotate_t,self,unix_dgram_socket,connect).
access_vector(allow,logrotate_t,self,unix_dgram_socket,getopt).
access_vector(allow,logrotate_t,self,unix_dgram_socket,setopt).
access_vector(allow,logrotate_t,self,unix_dgram_socket,shutdown).
access_vector(allow,logrotate_t,self,unix_stream_socket,create).
access_vector(allow,logrotate_t,self,unix_stream_socket,ioctl).
access_vector(allow,logrotate_t,self,unix_stream_socket,read).
access_vector(allow,logrotate_t,self,unix_stream_socket,getattr).
access_vector(allow,logrotate_t,self,unix_stream_socket,write).
access_vector(allow,logrotate_t,self,unix_stream_socket,setattr).
access_vector(allow,logrotate_t,self,unix_stream_socket,append).
access_vector(allow,logrotate_t,self,unix_stream_socket,bind).
access_vector(allow,logrotate_t,self,unix_stream_socket,connect).
access_vector(allow,logrotate_t,self,unix_stream_socket,getopt).
access_vector(allow,logrotate_t,self,unix_stream_socket,setopt).
access_vector(allow,logrotate_t,self,unix_stream_socket,shutdown).
access_vector(allow,logrotate_t,self,unix_stream_socket,listen).
access_vector(allow,logrotate_t,self,unix_stream_socket,accept).
access_vector(allow,logrotate_t,self,unix_dgram_socket,sendto).
access_vector(allow,logrotate_t,self,unix_stream_socket,connectto).
access_vector(allow,logrotate_t,self,sem,associate).
access_vector(allow,logrotate_t,self,sem,getattr).
access_vector(allow,logrotate_t,self,sem,setattr).
access_vector(allow,logrotate_t,self,sem,create).
access_vector(allow,logrotate_t,self,sem,destroy).
access_vector(allow,logrotate_t,self,sem,read).
access_vector(allow,logrotate_t,self,sem,write).
access_vector(allow,logrotate_t,self,sem,unix_read).
access_vector(allow,logrotate_t,self,sem,unix_write).
access_vector(allow,logrotate_t,self,msg,send).
access_vector(allow,logrotate_t,self,msg,receive).
access_vector(allow,logrotate_t,self,msgq,associate).
access_vector(allow,logrotate_t,self,msgq,getattr).
access_vector(allow,logrotate_t,self,msgq,setattr).
access_vector(allow,logrotate_t,self,msgq,create).
access_vector(allow,logrotate_t,self,msgq,destroy).
access_vector(allow,logrotate_t,self,msgq,read).
access_vector(allow,logrotate_t,self,msgq,write).
access_vector(allow,logrotate_t,self,msgq,enqueue).
access_vector(allow,logrotate_t,self,msgq,unix_read).
access_vector(allow,logrotate_t,self,msgq,unix_write).
access_vector(allow,logrotate_t,self,shm,associate).
access_vector(allow,logrotate_t,self,shm,getattr).
access_vector(allow,logrotate_t,self,shm,setattr).
access_vector(allow,logrotate_t,self,shm,create).
access_vector(allow,logrotate_t,self,shm,destroy).
access_vector(allow,logrotate_t,self,shm,read).
access_vector(allow,logrotate_t,self,shm,write).
access_vector(allow,logrotate_t,self,shm,lock).
access_vector(allow,logrotate_t,self,shm,unix_read).
access_vector(allow,logrotate_t,self,shm,unix_write).
type_decl(logrotate_exec_t,[],[file_type,sysadmfile,exec_type]).
access_vector(allow,system_crond_t,logrotate_t,process,transition).
access_vector(dontaudit,system_crond_t,logrotate_t,process,noatsecure).
access_vector(allow,logrotate_t,system_crond_t,process,sigchld).
access_vector(allow,logrotate_t,system_crond_t,fd,use).
access_vector(allow,system_crond_t,logrotate_t,fd,use).
access_vector(allow,logrotate_t,logrotate_exec_t,file,entrypoint).
type_trans(system_crond_t,logrotate_exec_t,process,logrotate_t).
access_vector(allow,logrotate_t,crond_t,fd,use).
access_vector(allow,logrotate_t,crond_t,process,sigchld).
access_vector(allow,sysadm_t,logrotate_t,process,transition).
access_vector(dontaudit,sysadm_t,logrotate_t,process,noatsecure).
access_vector(allow,sysadm_t,logrotate_exec_t,file,read).
access_vector(allow,sysadm_t,logrotate_exec_t,file,getattr).
access_vector(allow,sysadm_t,logrotate_exec_t,file,execute).
access_vector(allow,logrotate_t,sysadm_t,process,sigchld).
access_vector(allow,logrotate_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,logrotate_t,fd,use).
access_vector(allow,logrotate_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,logrotate_t,sysadm_t,fifo_file,read).
access_vector(allow,logrotate_t,sysadm_t,fifo_file,getattr).
access_vector(allow,logrotate_t,sysadm_t,fifo_file,lock).
access_vector(allow,logrotate_t,sysadm_t,fifo_file,write).
access_vector(allow,logrotate_t,sysadm_t,fifo_file,append).
access_vector(allow,logrotate_t,logrotate_exec_t,file,entrypoint).
type_trans(sysadm_t,logrotate_exec_t,process,logrotate_t).
access_vector(allow,logrotate_t,self,unix_stream_socket,create).
access_vector(allow,logrotate_t,self,unix_stream_socket,ioctl).
access_vector(allow,logrotate_t,self,unix_stream_socket,read).
access_vector(allow,logrotate_t,self,unix_stream_socket,getattr).
access_vector(allow,logrotate_t,self,unix_stream_socket,write).
access_vector(allow,logrotate_t,self,unix_stream_socket,setattr).
access_vector(allow,logrotate_t,self,unix_stream_socket,append).
access_vector(allow,logrotate_t,self,unix_stream_socket,bind).
access_vector(allow,logrotate_t,self,unix_stream_socket,connect).
access_vector(allow,logrotate_t,self,unix_stream_socket,getopt).
access_vector(allow,logrotate_t,self,unix_stream_socket,setopt).
access_vector(allow,logrotate_t,self,unix_stream_socket,shutdown).
access_vector(allow,logrotate_t,devtty_t,chr_file,ioctl).
access_vector(allow,logrotate_t,devtty_t,chr_file,read).
access_vector(allow,logrotate_t,devtty_t,chr_file,getattr).
access_vector(allow,logrotate_t,devtty_t,chr_file,lock).
access_vector(allow,logrotate_t,devtty_t,chr_file,write).
access_vector(allow,logrotate_t,devtty_t,chr_file,append).
access_vector(allow,logrotate_t,etc_t,file,getattr).
access_vector(allow,logrotate_t,etc_t,file,read).
access_vector(allow,logrotate_t,etc_t,lnk_file,read).
access_vector(allow,logrotate_t,etc_runtime_t,file,read).
access_vector(allow,logrotate_t,etc_runtime_t,file,getattr).
access_vector(allow,logrotate_t,etc_runtime_t,file,lock).
access_vector(allow,logrotate_t,etc_runtime_t,file,ioctl).
access_vector(allow,logrotate_t,etc_runtime_t,lnk_file,read).
access_vector(allow,logrotate_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,logrotate_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,logrotate_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,sysadm_home_dir_t,dir,read).
access_vector(allow,logrotate_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,logrotate_t,sysadm_home_dir_t,dir,search).
access_vector(allow,logrotate_t,var_lock_t,dir,read).
access_vector(allow,logrotate_t,var_lock_t,dir,getattr).
access_vector(allow,logrotate_t,var_lock_t,dir,lock).
access_vector(allow,logrotate_t,var_lock_t,dir,search).
access_vector(allow,logrotate_t,var_lock_t,dir,ioctl).
access_vector(allow,logrotate_t,var_lock_t,dir,add_name).
access_vector(allow,logrotate_t,var_lock_t,dir,remove_name).
access_vector(allow,logrotate_t,var_lock_t,dir,write).
access_vector(allow,logrotate_t,var_lock_t,file,create).
access_vector(allow,logrotate_t,var_lock_t,file,ioctl).
access_vector(allow,logrotate_t,var_lock_t,file,read).
access_vector(allow,logrotate_t,var_lock_t,file,getattr).
access_vector(allow,logrotate_t,var_lock_t,file,lock).
access_vector(allow,logrotate_t,var_lock_t,file,write).
access_vector(allow,logrotate_t,var_lock_t,file,setattr).
access_vector(allow,logrotate_t,var_lock_t,file,append).
access_vector(allow,logrotate_t,var_lock_t,file,link).
access_vector(allow,logrotate_t,var_lock_t,file,unlink).
access_vector(allow,logrotate_t,var_lock_t,file,rename).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,create).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,read).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,getattr).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,lock).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,write).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,setattr).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,append).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,link).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,unlink).
access_vector(allow,logrotate_t,var_lock_t,lnk_file,rename).
type_decl(logrotate_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,logrotate_t,tmp_t,dir,read).
access_vector(allow,logrotate_t,tmp_t,dir,getattr).
access_vector(allow,logrotate_t,tmp_t,dir,lock).
access_vector(allow,logrotate_t,tmp_t,dir,search).
access_vector(allow,logrotate_t,tmp_t,dir,ioctl).
access_vector(allow,logrotate_t,tmp_t,dir,add_name).
access_vector(allow,logrotate_t,tmp_t,dir,remove_name).
access_vector(allow,logrotate_t,tmp_t,dir,write).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,create).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,ioctl).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,read).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,getattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,lock).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,write).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,setattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,append).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,link).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,unlink).
access_vector(allow,logrotate_t,logrotate_tmp_t,file,rename).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,create).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,read).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,getattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,lock).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,write).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,setattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,append).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,link).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,unlink).
access_vector(allow,logrotate_t,logrotate_tmp_t,lnk_file,rename).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,create).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,ioctl).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,read).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,getattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,lock).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,write).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,setattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,append).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,link).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,unlink).
access_vector(allow,logrotate_t,logrotate_tmp_t,sock_file,rename).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,create).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,ioctl).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,read).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,getattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,lock).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,write).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,setattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,append).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,link).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,unlink).
access_vector(allow,logrotate_t,logrotate_tmp_t,fifo_file,rename).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,create).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,read).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,getattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,lock).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,setattr).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,link).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,unlink).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,rename).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,search).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,add_name).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,remove_name).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,reparent).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,write).
access_vector(allow,logrotate_t,logrotate_tmp_t,dir,rmdir).
type_trans(logrotate_t,tmp_t,dir,logrotate_tmp_t).
type_trans(logrotate_t,tmp_t,[file,lnk_file,sock_file,fifo_file],logrotate_tmp_t).
access_vector(allow,logrotate_t,bin_t,dir,read).
access_vector(allow,logrotate_t,bin_t,dir,getattr).
access_vector(allow,logrotate_t,bin_t,dir,lock).
access_vector(allow,logrotate_t,bin_t,dir,search).
access_vector(allow,logrotate_t,bin_t,dir,ioctl).
access_vector(allow,logrotate_t,sbin_t,dir,read).
access_vector(allow,logrotate_t,sbin_t,dir,getattr).
access_vector(allow,logrotate_t,sbin_t,dir,lock).
access_vector(allow,logrotate_t,sbin_t,dir,search).
access_vector(allow,logrotate_t,sbin_t,dir,ioctl).
access_vector(allow,logrotate_t,bin_t,lnk_file,read).
access_vector(allow,logrotate_t,sbin_t,lnk_file,read).
access_vector(allow,logrotate_t,bin_t,file,read).
access_vector(allow,logrotate_t,bin_t,file,getattr).
access_vector(allow,logrotate_t,bin_t,file,lock).
access_vector(allow,logrotate_t,bin_t,file,execute).
access_vector(allow,logrotate_t,bin_t,file,ioctl).
access_vector(allow,logrotate_t,bin_t,file,execute_no_trans).
access_vector(allow,logrotate_t,sbin_t,file,read).
access_vector(allow,logrotate_t,sbin_t,file,getattr).
access_vector(allow,logrotate_t,sbin_t,file,lock).
access_vector(allow,logrotate_t,sbin_t,file,execute).
access_vector(allow,logrotate_t,sbin_t,file,ioctl).
access_vector(allow,logrotate_t,sbin_t,file,execute_no_trans).
access_vector(allow,logrotate_t,shell_exec_t,file,read).
access_vector(allow,logrotate_t,shell_exec_t,file,getattr).
access_vector(allow,logrotate_t,shell_exec_t,file,lock).
access_vector(allow,logrotate_t,shell_exec_t,file,execute).
access_vector(allow,logrotate_t,shell_exec_t,file,ioctl).
access_vector(allow,logrotate_t,shell_exec_t,file,execute_no_trans).
access_vector(allow,logrotate_t,etc_t,file,read).
access_vector(allow,logrotate_t,etc_t,file,getattr).
access_vector(allow,logrotate_t,etc_t,file,lock).
access_vector(allow,logrotate_t,etc_t,file,execute).
access_vector(allow,logrotate_t,etc_t,file,ioctl).
access_vector(allow,logrotate_t,etc_t,file,execute_no_trans).
access_vector(allow,logrotate_t,ls_exec_t,file,read).
access_vector(allow,logrotate_t,ls_exec_t,file,getattr).
access_vector(allow,logrotate_t,ls_exec_t,file,lock).
access_vector(allow,logrotate_t,ls_exec_t,file,execute).
access_vector(allow,logrotate_t,ls_exec_t,file,ioctl).
access_vector(allow,logrotate_t,ls_exec_t,file,execute_no_trans).
access_vector(allow,logrotate_t,pidfile,file,read).
access_vector(allow,logrotate_t,pidfile,file,getattr).
access_vector(allow,logrotate_t,pidfile,file,lock).
access_vector(allow,logrotate_t,pidfile,file,ioctl).
access_vector(allow,logrotate_t,proc_t,dir,read).
access_vector(allow,logrotate_t,proc_t,dir,getattr).
access_vector(allow,logrotate_t,proc_t,dir,lock).
access_vector(allow,logrotate_t,proc_t,dir,search).
access_vector(allow,logrotate_t,proc_t,dir,ioctl).
access_vector(allow,logrotate_t,proc_t,file,read).
access_vector(allow,logrotate_t,proc_t,file,getattr).
access_vector(allow,logrotate_t,proc_t,file,lock).
access_vector(allow,logrotate_t,proc_t,file,ioctl).
access_vector(allow,logrotate_t,proc_t,lnk_file,read).
access_vector(allow,logrotate_t,proc_t,lnk_file,getattr).
access_vector(allow,logrotate_t,proc_t,lnk_file,lock).
access_vector(allow,logrotate_t,proc_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,sysctl_t,dir,search).
access_vector(allow,logrotate_t,sysctl_kernel_t,dir,search).
access_vector(allow,logrotate_t,sysctl_kernel_t,file,getattr).
access_vector(allow,logrotate_t,sysctl_kernel_t,file,read).
access_vector(allow,logrotate_t,domain,file,read).
access_vector(allow,logrotate_t,domain,file,getattr).
access_vector(allow,logrotate_t,domain,file,lock).
access_vector(allow,logrotate_t,domain,file,ioctl).
access_vector(allow,logrotate_t,domain,lnk_file,read).
access_vector(allow,logrotate_t,domain,lnk_file,getattr).
access_vector(allow,logrotate_t,domain,lnk_file,lock).
access_vector(allow,logrotate_t,domain,lnk_file,ioctl).
access_vector(allow,logrotate_t,domain,sock_file,read).
access_vector(allow,logrotate_t,domain,sock_file,getattr).
access_vector(allow,logrotate_t,domain,sock_file,lock).
access_vector(allow,logrotate_t,domain,sock_file,ioctl).
access_vector(allow,logrotate_t,domain,fifo_file,read).
access_vector(allow,logrotate_t,domain,fifo_file,getattr).
access_vector(allow,logrotate_t,domain,fifo_file,lock).
access_vector(allow,logrotate_t,domain,fifo_file,ioctl).
access_vector(allow,logrotate_t,domain,dir,read).
access_vector(allow,logrotate_t,domain,dir,getattr).
access_vector(allow,logrotate_t,domain,dir,lock).
access_vector(allow,logrotate_t,domain,dir,search).
access_vector(allow,logrotate_t,domain,dir,ioctl).
access_vector(allow,logrotate_t,exec_type,file,getattr).
access_vector(allow,logrotate_t,device_t,dir,read).
access_vector(allow,logrotate_t,device_t,dir,getattr).
access_vector(allow,logrotate_t,device_t,dir,lock).
access_vector(allow,logrotate_t,device_t,dir,search).
access_vector(allow,logrotate_t,device_t,dir,ioctl).
access_vector(allow,logrotate_t,device_t,lnk_file,read).
access_vector(allow,logrotate_t,device_t,lnk_file,getattr).
access_vector(allow,logrotate_t,device_t,lnk_file,lock).
access_vector(allow,logrotate_t,device_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,domain,process,signal).
access_vector(allow,logrotate_t,var_t,dir,read).
access_vector(allow,logrotate_t,var_t,dir,getattr).
access_vector(allow,logrotate_t,var_t,dir,lock).
access_vector(allow,logrotate_t,var_t,dir,search).
access_vector(allow,logrotate_t,var_t,dir,ioctl).
access_vector(allow,logrotate_t,logfile,dir,read).
access_vector(allow,logrotate_t,logfile,dir,getattr).
access_vector(allow,logrotate_t,logfile,dir,lock).
access_vector(allow,logrotate_t,logfile,dir,search).
access_vector(allow,logrotate_t,logfile,dir,ioctl).
access_vector(allow,logrotate_t,logfile,dir,add_name).
access_vector(allow,logrotate_t,logfile,dir,remove_name).
access_vector(allow,logrotate_t,logfile,dir,write).
access_vector(allow,logrotate_t,logfile,lnk_file,read).
access_vector(allow,logrotate_t,logfile,file,create).
access_vector(allow,logrotate_t,logfile,file,ioctl).
access_vector(allow,logrotate_t,logfile,file,read).
access_vector(allow,logrotate_t,logfile,file,getattr).
access_vector(allow,logrotate_t,logfile,file,lock).
access_vector(allow,logrotate_t,logfile,file,write).
access_vector(allow,logrotate_t,logfile,file,setattr).
access_vector(allow,logrotate_t,logfile,file,append).
access_vector(allow,logrotate_t,logfile,file,link).
access_vector(allow,logrotate_t,logfile,file,unlink).
access_vector(allow,logrotate_t,logfile,file,rename).
access_vector(allow,logrotate_t,wtmp_t,file,create).
access_vector(allow,logrotate_t,wtmp_t,file,ioctl).
access_vector(allow,logrotate_t,wtmp_t,file,read).
access_vector(allow,logrotate_t,wtmp_t,file,getattr).
access_vector(allow,logrotate_t,wtmp_t,file,lock).
access_vector(allow,logrotate_t,wtmp_t,file,write).
access_vector(allow,logrotate_t,wtmp_t,file,setattr).
access_vector(allow,logrotate_t,wtmp_t,file,append).
access_vector(allow,logrotate_t,wtmp_t,file,link).
access_vector(allow,logrotate_t,wtmp_t,file,unlink).
access_vector(allow,logrotate_t,wtmp_t,file,rename).
access_vector(allow,logrotate_t,self,process,setfscreate).
access_vector(allow,logrotate_t,proc_t,dir,search).
access_vector(allow,logrotate_t,proc_t,lnk_file,read).
access_vector(allow,logrotate_t,self,dir,search).
access_vector(allow,logrotate_t,self,file,read).
access_vector(allow,logrotate_t,self,file,write).
access_vector(allow,logrotate_t,self,capability,chown).
access_vector(allow,logrotate_t,self,capability,dac_override).
access_vector(allow,logrotate_t,self,capability,kill).
access_vector(allow,logrotate_t,self,capability,fsetid).
access_vector(allow,logrotate_t,self,capability,fowner).
access_vector(dontaudit,logrotate_t,self,capability,setuid).
access_vector(dontaudit,logrotate_t,self,capability,setgid).
access_vector(allow,logrotate_t,var_run_t,dir,read).
access_vector(allow,logrotate_t,var_run_t,dir,getattr).
access_vector(allow,logrotate_t,var_run_t,dir,lock).
access_vector(allow,logrotate_t,var_run_t,dir,search).
access_vector(allow,logrotate_t,var_run_t,dir,ioctl).
type_decl(logrotate_var_lib_t,var_lib_logrotate_t,[file_type,sysadmfile]).
access_vector(allow,logrotate_t,var_lib_t,dir,read).
access_vector(allow,logrotate_t,var_lib_t,dir,getattr).
access_vector(allow,logrotate_t,var_lib_t,dir,lock).
access_vector(allow,logrotate_t,var_lib_t,dir,search).
access_vector(allow,logrotate_t,var_lib_t,dir,ioctl).
access_vector(allow,logrotate_t,var_lib_t,dir,add_name).
access_vector(allow,logrotate_t,var_lib_t,dir,remove_name).
access_vector(allow,logrotate_t,var_lib_t,dir,write).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,create).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,ioctl).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,read).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,getattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,lock).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,write).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,setattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,append).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,link).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,unlink).
access_vector(allow,logrotate_t,logrotate_var_lib_t,file,rename).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,create).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,read).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,getattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,lock).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,write).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,setattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,append).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,link).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,unlink).
access_vector(allow,logrotate_t,logrotate_var_lib_t,lnk_file,rename).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,create).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,ioctl).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,read).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,getattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,lock).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,write).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,setattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,append).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,link).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,unlink).
access_vector(allow,logrotate_t,logrotate_var_lib_t,sock_file,rename).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,create).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,ioctl).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,read).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,getattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,lock).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,write).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,setattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,append).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,link).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,unlink).
access_vector(allow,logrotate_t,logrotate_var_lib_t,fifo_file,rename).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,create).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,read).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,getattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,lock).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,setattr).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,link).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,unlink).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,rename).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,search).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,add_name).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,remove_name).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,reparent).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,write).
access_vector(allow,logrotate_t,logrotate_var_lib_t,dir,rmdir).
type_trans(logrotate_t,var_lib_t,dir,logrotate_var_lib_t).
type_trans(logrotate_t,var_lib_t,[file,lnk_file,sock_file,fifo_file],logrotate_var_lib_t).
access_vector(allow,logrotate_t,var_spool_t,dir,search).
access_vector(allow,logrotate_t,var_spool_t,dir,write).
access_vector(allow,logrotate_t,var_spool_t,dir,add_name).
access_vector(allow,logrotate_t,var_spool_t,dir,remove_name).
access_vector(allow,logrotate_t,var_spool_t,file,rename).
access_vector(allow,logrotate_t,var_spool_t,file,create).
access_vector(allow,logrotate_t,var_spool_t,file,setattr).
access_vector(allow,logrotate_t,var_spool_t,file,unlink).
access_vector(allow,logrotate_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,logrotate_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,logrotate_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,logrotate_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,logrotate_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,logrotate_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,logrotate_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,logrotate_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,logrotate_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,logrotate_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,logrotate_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,logrotate_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,logrotate_t,etc_t,lnk_file,read).
access_vector(allow,logrotate_t,locale_t,dir,read).
access_vector(allow,logrotate_t,locale_t,dir,getattr).
access_vector(allow,logrotate_t,locale_t,dir,lock).
access_vector(allow,logrotate_t,locale_t,dir,search).
access_vector(allow,logrotate_t,locale_t,dir,ioctl).
access_vector(allow,logrotate_t,locale_t,file,read).
access_vector(allow,logrotate_t,locale_t,file,getattr).
access_vector(allow,logrotate_t,locale_t,file,lock).
access_vector(allow,logrotate_t,locale_t,file,ioctl).
access_vector(allow,logrotate_t,locale_t,lnk_file,read).
access_vector(allow,logrotate_t,locale_t,lnk_file,getattr).
access_vector(allow,logrotate_t,locale_t,lnk_file,lock).
access_vector(allow,logrotate_t,locale_t,lnk_file,ioctl).
access_vector(allow,logrotate_t,fs_t,filesystem,getattr).
type_decl(modules_dep_t,[],[file_type,sysadmfile]).
type_decl(modules_conf_t,[],[file_type,sysadmfile]).
type_decl(modules_object_t,[],[file_type,sysadmfile]).
type_decl(depmod_t,[],[domain]).
role_decl(system_r,depmod_t).
role_decl(sysadm_r,depmod_t).
access_vector(allow,depmod_t,root_t,dir,read).
access_vector(allow,depmod_t,root_t,dir,getattr).
access_vector(allow,depmod_t,root_t,dir,lock).
access_vector(allow,depmod_t,root_t,dir,search).
access_vector(allow,depmod_t,root_t,dir,ioctl).
access_vector(allow,depmod_t,usr_t,dir,read).
access_vector(allow,depmod_t,usr_t,dir,getattr).
access_vector(allow,depmod_t,usr_t,dir,lock).
access_vector(allow,depmod_t,usr_t,dir,search).
access_vector(allow,depmod_t,usr_t,dir,ioctl).
access_vector(allow,depmod_t,lib_t,dir,read).
access_vector(allow,depmod_t,lib_t,dir,getattr).
access_vector(allow,depmod_t,lib_t,dir,lock).
access_vector(allow,depmod_t,lib_t,dir,search).
access_vector(allow,depmod_t,lib_t,dir,ioctl).
access_vector(allow,depmod_t,etc_t,dir,read).
access_vector(allow,depmod_t,etc_t,dir,getattr).
access_vector(allow,depmod_t,etc_t,dir,lock).
access_vector(allow,depmod_t,etc_t,dir,search).
access_vector(allow,depmod_t,etc_t,dir,ioctl).
access_vector(allow,depmod_t,lib_t,lnk_file,read).
access_vector(allow,depmod_t,lib_t,lnk_file,getattr).
access_vector(allow,depmod_t,lib_t,lnk_file,lock).
access_vector(allow,depmod_t,lib_t,lnk_file,ioctl).
access_vector(allow,depmod_t,ld_so_t,file,read).
access_vector(allow,depmod_t,ld_so_t,file,getattr).
access_vector(allow,depmod_t,ld_so_t,file,lock).
access_vector(allow,depmod_t,ld_so_t,file,execute).
access_vector(allow,depmod_t,ld_so_t,file,ioctl).
access_vector(allow,depmod_t,ld_so_t,file,execute_no_trans).
access_vector(allow,depmod_t,ld_so_t,lnk_file,read).
access_vector(allow,depmod_t,ld_so_t,lnk_file,getattr).
access_vector(allow,depmod_t,ld_so_t,lnk_file,lock).
access_vector(allow,depmod_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,depmod_t,shlib_t,file,read).
access_vector(allow,depmod_t,shlib_t,file,getattr).
access_vector(allow,depmod_t,shlib_t,file,lock).
access_vector(allow,depmod_t,shlib_t,file,execute).
access_vector(allow,depmod_t,shlib_t,file,ioctl).
access_vector(allow,depmod_t,shlib_t,lnk_file,read).
access_vector(allow,depmod_t,shlib_t,lnk_file,getattr).
access_vector(allow,depmod_t,shlib_t,lnk_file,lock).
access_vector(allow,depmod_t,shlib_t,lnk_file,ioctl).
access_vector(allow,depmod_t,ld_so_cache_t,file,read).
access_vector(allow,depmod_t,ld_so_cache_t,file,getattr).
access_vector(allow,depmod_t,ld_so_cache_t,file,lock).
access_vector(allow,depmod_t,ld_so_cache_t,file,ioctl).
access_vector(allow,depmod_t,device_t,dir,search).
access_vector(allow,depmod_t,null_device_t,chr_file,ioctl).
access_vector(allow,depmod_t,null_device_t,chr_file,read).
access_vector(allow,depmod_t,null_device_t,chr_file,getattr).
access_vector(allow,depmod_t,null_device_t,chr_file,lock).
access_vector(allow,depmod_t,null_device_t,chr_file,write).
access_vector(allow,depmod_t,null_device_t,chr_file,append).
type_decl(depmod_exec_t,[],[file_type,exec_type,sysadmfile]).
access_vector(allow,initrc_t,depmod_t,process,transition).
access_vector(dontaudit,initrc_t,depmod_t,process,noatsecure).
access_vector(allow,initrc_t,depmod_exec_t,file,read).
access_vector(allow,initrc_t,depmod_exec_t,file,getattr).
access_vector(allow,initrc_t,depmod_exec_t,file,execute).
access_vector(allow,depmod_t,initrc_t,process,sigchld).
access_vector(allow,depmod_t,initrc_t,fd,use).
access_vector(allow,initrc_t,depmod_t,fd,use).
access_vector(allow,depmod_t,initrc_t,fifo_file,ioctl).
access_vector(allow,depmod_t,initrc_t,fifo_file,read).
access_vector(allow,depmod_t,initrc_t,fifo_file,getattr).
access_vector(allow,depmod_t,initrc_t,fifo_file,lock).
access_vector(allow,depmod_t,initrc_t,fifo_file,write).
access_vector(allow,depmod_t,initrc_t,fifo_file,append).
access_vector(allow,depmod_t,depmod_exec_t,file,entrypoint).
type_trans(initrc_t,depmod_exec_t,process,depmod_t).
access_vector(allow,depmod_t,bin_t,dir,search).
access_vector(allow,depmod_t,sbin_t,dir,search).
access_vector(allow,depmod_t,depmod_exec_t,file,read).
access_vector(allow,depmod_t,depmod_exec_t,file,getattr).
access_vector(allow,depmod_t,depmod_exec_t,file,lock).
access_vector(allow,depmod_t,depmod_exec_t,file,execute).
access_vector(allow,depmod_t,depmod_exec_t,file,ioctl).
access_vector(allow,depmod_t,depmod_exec_t,file,execute_no_trans).
access_vector(allow,sysadm_t,depmod_t,process,transition).
access_vector(dontaudit,sysadm_t,depmod_t,process,noatsecure).
access_vector(allow,sysadm_t,depmod_exec_t,file,read).
access_vector(allow,sysadm_t,depmod_exec_t,file,getattr).
access_vector(allow,sysadm_t,depmod_exec_t,file,execute).
access_vector(allow,depmod_t,sysadm_t,process,sigchld).
access_vector(allow,depmod_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,depmod_t,fd,use).
access_vector(allow,depmod_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,depmod_t,sysadm_t,fifo_file,read).
access_vector(allow,depmod_t,sysadm_t,fifo_file,getattr).
access_vector(allow,depmod_t,sysadm_t,fifo_file,lock).
access_vector(allow,depmod_t,sysadm_t,fifo_file,write).
access_vector(allow,depmod_t,sysadm_t,fifo_file,append).
access_vector(allow,depmod_t,depmod_exec_t,file,entrypoint).
type_trans(sysadm_t,depmod_exec_t,process,depmod_t).
access_vector(allow,depmod_t,init_t,fd,use).
access_vector(allow,depmod_t,privfd,fd,use).
access_vector(allow,depmod_t,etc_t,file,getattr).
access_vector(allow,depmod_t,etc_t,file,read).
access_vector(allow,depmod_t,etc_runtime_t,file,getattr).
access_vector(allow,depmod_t,etc_runtime_t,file,read).
access_vector(allow,depmod_t,device_t,dir,search).
access_vector(allow,depmod_t,proc_t,dir,search).
access_vector(allow,depmod_t,proc_t,file,getattr).
access_vector(allow,depmod_t,proc_t,file,read).
access_vector(allow,depmod_t,fs_t,filesystem,getattr).
access_vector(allow,depmod_t,boot_t,dir,search).
access_vector(allow,depmod_t,system_map_t,file,getattr).
access_vector(allow,depmod_t,system_map_t,file,read).
access_vector(allow,depmod_t,modules_conf_t,file,read).
access_vector(allow,depmod_t,modules_conf_t,file,getattr).
access_vector(allow,depmod_t,modules_conf_t,file,lock).
access_vector(allow,depmod_t,modules_conf_t,file,ioctl).
access_vector(allow,depmod_t,modules_object_t,dir,read).
access_vector(allow,depmod_t,modules_object_t,dir,getattr).
access_vector(allow,depmod_t,modules_object_t,dir,lock).
access_vector(allow,depmod_t,modules_object_t,dir,search).
access_vector(allow,depmod_t,modules_object_t,dir,ioctl).
access_vector(allow,depmod_t,modules_object_t,dir,add_name).
access_vector(allow,depmod_t,modules_object_t,dir,remove_name).
access_vector(allow,depmod_t,modules_object_t,dir,write).
access_vector(allow,depmod_t,modules_dep_t,file,create).
access_vector(allow,depmod_t,modules_dep_t,file,ioctl).
access_vector(allow,depmod_t,modules_dep_t,file,read).
access_vector(allow,depmod_t,modules_dep_t,file,getattr).
access_vector(allow,depmod_t,modules_dep_t,file,lock).
access_vector(allow,depmod_t,modules_dep_t,file,write).
access_vector(allow,depmod_t,modules_dep_t,file,setattr).
access_vector(allow,depmod_t,modules_dep_t,file,append).
access_vector(allow,depmod_t,modules_dep_t,file,link).
access_vector(allow,depmod_t,modules_dep_t,file,unlink).
access_vector(allow,depmod_t,modules_dep_t,file,rename).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,create).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,ioctl).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,read).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,getattr).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,lock).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,write).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,setattr).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,append).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,link).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,unlink).
access_vector(allow,depmod_t,modules_dep_t,lnk_file,rename).
access_vector(allow,depmod_t,modules_dep_t,sock_file,create).
access_vector(allow,depmod_t,modules_dep_t,sock_file,ioctl).
access_vector(allow,depmod_t,modules_dep_t,sock_file,read).
access_vector(allow,depmod_t,modules_dep_t,sock_file,getattr).
access_vector(allow,depmod_t,modules_dep_t,sock_file,lock).
access_vector(allow,depmod_t,modules_dep_t,sock_file,write).
access_vector(allow,depmod_t,modules_dep_t,sock_file,setattr).
access_vector(allow,depmod_t,modules_dep_t,sock_file,append).
access_vector(allow,depmod_t,modules_dep_t,sock_file,link).
access_vector(allow,depmod_t,modules_dep_t,sock_file,unlink).
access_vector(allow,depmod_t,modules_dep_t,sock_file,rename).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,create).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,ioctl).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,read).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,getattr).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,lock).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,write).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,setattr).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,append).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,link).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,unlink).
access_vector(allow,depmod_t,modules_dep_t,fifo_file,rename).
access_vector(allow,depmod_t,modules_dep_t,dir,create).
access_vector(allow,depmod_t,modules_dep_t,dir,read).
access_vector(allow,depmod_t,modules_dep_t,dir,getattr).
access_vector(allow,depmod_t,modules_dep_t,dir,lock).
access_vector(allow,depmod_t,modules_dep_t,dir,setattr).
access_vector(allow,depmod_t,modules_dep_t,dir,link).
access_vector(allow,depmod_t,modules_dep_t,dir,unlink).
access_vector(allow,depmod_t,modules_dep_t,dir,rename).
access_vector(allow,depmod_t,modules_dep_t,dir,search).
access_vector(allow,depmod_t,modules_dep_t,dir,add_name).
access_vector(allow,depmod_t,modules_dep_t,dir,remove_name).
access_vector(allow,depmod_t,modules_dep_t,dir,reparent).
access_vector(allow,depmod_t,modules_dep_t,dir,write).
access_vector(allow,depmod_t,modules_dep_t,dir,rmdir).
type_trans(depmod_t,modules_object_t,dir,modules_dep_t).
type_trans(depmod_t,modules_object_t,[file,lnk_file,sock_file,fifo_file],modules_dep_t).
access_vector(allow,depmod_t,modules_object_t,dir,read).
access_vector(allow,depmod_t,modules_object_t,dir,getattr).
access_vector(allow,depmod_t,modules_object_t,dir,lock).
access_vector(allow,depmod_t,modules_object_t,dir,search).
access_vector(allow,depmod_t,modules_object_t,dir,ioctl).
access_vector(allow,depmod_t,modules_object_t,file,read).
access_vector(allow,depmod_t,modules_object_t,file,getattr).
access_vector(allow,depmod_t,modules_object_t,file,lock).
access_vector(allow,depmod_t,modules_object_t,file,ioctl).
access_vector(allow,depmod_t,modules_object_t,lnk_file,read).
access_vector(allow,depmod_t,modules_object_t,lnk_file,getattr).
access_vector(allow,depmod_t,modules_object_t,lnk_file,lock).
access_vector(allow,depmod_t,modules_object_t,lnk_file,ioctl).
access_vector(allow,depmod_t,console_device_t,chr_file,ioctl).
access_vector(allow,depmod_t,console_device_t,chr_file,read).
access_vector(allow,depmod_t,console_device_t,chr_file,getattr).
access_vector(allow,depmod_t,console_device_t,chr_file,lock).
access_vector(allow,depmod_t,console_device_t,chr_file,write).
access_vector(allow,depmod_t,console_device_t,chr_file,append).
access_vector(allow,depmod_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,depmod_t,initrc_devpts_t,chr_file,read).
access_vector(allow,depmod_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,depmod_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,depmod_t,initrc_devpts_t,chr_file,write).
access_vector(allow,depmod_t,initrc_devpts_t,chr_file,append).
access_vector(allow,depmod_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,depmod_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,depmod_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,depmod_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,depmod_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,depmod_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,depmod_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,depmod_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,depmod_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,depmod_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,depmod_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,depmod_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,depmod_t,home_root_t,dir,read).
access_vector(allow,depmod_t,home_root_t,dir,getattr).
access_vector(allow,depmod_t,home_root_t,dir,lock).
access_vector(allow,depmod_t,home_root_t,dir,search).
access_vector(allow,depmod_t,home_root_t,dir,ioctl).
access_vector(allow,depmod_t,user_home_dir_type,dir,read).
access_vector(allow,depmod_t,user_home_dir_type,dir,getattr).
access_vector(allow,depmod_t,user_home_dir_type,dir,lock).
access_vector(allow,depmod_t,user_home_dir_type,dir,search).
access_vector(allow,depmod_t,user_home_dir_type,dir,ioctl).
access_vector(allow,depmod_t,sysadm_home_dir_t,dir,read).
access_vector(allow,depmod_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,depmod_t,sysadm_home_dir_t,dir,lock).
access_vector(allow,depmod_t,sysadm_home_dir_t,dir,search).
access_vector(allow,depmod_t,sysadm_home_dir_t,dir,ioctl).
access_vector(allow,depmod_t,user_home_type,dir,read).
access_vector(allow,depmod_t,user_home_type,dir,getattr).
access_vector(allow,depmod_t,user_home_type,dir,lock).
access_vector(allow,depmod_t,user_home_type,dir,search).
access_vector(allow,depmod_t,user_home_type,dir,ioctl).
access_vector(allow,depmod_t,sysadm_home_t,dir,read).
access_vector(allow,depmod_t,sysadm_home_t,dir,getattr).
access_vector(allow,depmod_t,sysadm_home_t,dir,lock).
access_vector(allow,depmod_t,sysadm_home_t,dir,search).
access_vector(allow,depmod_t,sysadm_home_t,dir,ioctl).
access_vector(allow,depmod_t,user_home_type,file,read).
access_vector(allow,depmod_t,user_home_type,file,getattr).
access_vector(allow,depmod_t,user_home_type,file,lock).
access_vector(allow,depmod_t,user_home_type,file,ioctl).
access_vector(allow,depmod_t,user_home_type,lnk_file,read).
access_vector(allow,depmod_t,user_home_type,lnk_file,getattr).
access_vector(allow,depmod_t,user_home_type,lnk_file,lock).
access_vector(allow,depmod_t,user_home_type,lnk_file,ioctl).
access_vector(allow,depmod_t,sysadm_home_t,file,read).
access_vector(allow,depmod_t,sysadm_home_t,file,getattr).
access_vector(allow,depmod_t,sysadm_home_t,file,lock).
access_vector(allow,depmod_t,sysadm_home_t,file,ioctl).
access_vector(allow,depmod_t,sysadm_home_t,lnk_file,read).
access_vector(allow,depmod_t,sysadm_home_t,lnk_file,getattr).
access_vector(allow,depmod_t,sysadm_home_t,lnk_file,lock).
access_vector(allow,depmod_t,sysadm_home_t,lnk_file,ioctl).
type_decl(insmod_t,[],[domain,privlog]).
role_decl(system_r,insmod_t).
role_decl(sysadm_r,insmod_t).
access_vector(allow,insmod_t,root_t,dir,read).
access_vector(allow,insmod_t,root_t,dir,getattr).
access_vector(allow,insmod_t,root_t,dir,lock).
access_vector(allow,insmod_t,root_t,dir,search).
access_vector(allow,insmod_t,root_t,dir,ioctl).
access_vector(allow,insmod_t,usr_t,dir,read).
access_vector(allow,insmod_t,usr_t,dir,getattr).
access_vector(allow,insmod_t,usr_t,dir,lock).
access_vector(allow,insmod_t,usr_t,dir,search).
access_vector(allow,insmod_t,usr_t,dir,ioctl).
access_vector(allow,insmod_t,lib_t,dir,read).
access_vector(allow,insmod_t,lib_t,dir,getattr).
access_vector(allow,insmod_t,lib_t,dir,lock).
access_vector(allow,insmod_t,lib_t,dir,search).
access_vector(allow,insmod_t,lib_t,dir,ioctl).
access_vector(allow,insmod_t,etc_t,dir,read).
access_vector(allow,insmod_t,etc_t,dir,getattr).
access_vector(allow,insmod_t,etc_t,dir,lock).
access_vector(allow,insmod_t,etc_t,dir,search).
access_vector(allow,insmod_t,etc_t,dir,ioctl).
access_vector(allow,insmod_t,lib_t,lnk_file,read).
access_vector(allow,insmod_t,lib_t,lnk_file,getattr).
access_vector(allow,insmod_t,lib_t,lnk_file,lock).
access_vector(allow,insmod_t,lib_t,lnk_file,ioctl).
access_vector(allow,insmod_t,ld_so_t,file,read).
access_vector(allow,insmod_t,ld_so_t,file,getattr).
access_vector(allow,insmod_t,ld_so_t,file,lock).
access_vector(allow,insmod_t,ld_so_t,file,execute).
access_vector(allow,insmod_t,ld_so_t,file,ioctl).
access_vector(allow,insmod_t,ld_so_t,file,execute_no_trans).
access_vector(allow,insmod_t,ld_so_t,lnk_file,read).
access_vector(allow,insmod_t,ld_so_t,lnk_file,getattr).
access_vector(allow,insmod_t,ld_so_t,lnk_file,lock).
access_vector(allow,insmod_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,insmod_t,shlib_t,file,read).
access_vector(allow,insmod_t,shlib_t,file,getattr).
access_vector(allow,insmod_t,shlib_t,file,lock).
access_vector(allow,insmod_t,shlib_t,file,execute).
access_vector(allow,insmod_t,shlib_t,file,ioctl).
access_vector(allow,insmod_t,shlib_t,lnk_file,read).
access_vector(allow,insmod_t,shlib_t,lnk_file,getattr).
access_vector(allow,insmod_t,shlib_t,lnk_file,lock).
access_vector(allow,insmod_t,shlib_t,lnk_file,ioctl).
access_vector(allow,insmod_t,ld_so_cache_t,file,read).
access_vector(allow,insmod_t,ld_so_cache_t,file,getattr).
access_vector(allow,insmod_t,ld_so_cache_t,file,lock).
access_vector(allow,insmod_t,ld_so_cache_t,file,ioctl).
access_vector(allow,insmod_t,device_t,dir,search).
access_vector(allow,insmod_t,null_device_t,chr_file,ioctl).
access_vector(allow,insmod_t,null_device_t,chr_file,read).
access_vector(allow,insmod_t,null_device_t,chr_file,getattr).
access_vector(allow,insmod_t,null_device_t,chr_file,lock).
access_vector(allow,insmod_t,null_device_t,chr_file,write).
access_vector(allow,insmod_t,null_device_t,chr_file,append).
access_vector(allow,insmod_t,etc_t,lnk_file,read).
access_vector(allow,insmod_t,locale_t,dir,read).
access_vector(allow,insmod_t,locale_t,dir,getattr).
access_vector(allow,insmod_t,locale_t,dir,lock).
access_vector(allow,insmod_t,locale_t,dir,search).
access_vector(allow,insmod_t,locale_t,dir,ioctl).
access_vector(allow,insmod_t,locale_t,file,read).
access_vector(allow,insmod_t,locale_t,file,getattr).
access_vector(allow,insmod_t,locale_t,file,lock).
access_vector(allow,insmod_t,locale_t,file,ioctl).
access_vector(allow,insmod_t,locale_t,lnk_file,read).
access_vector(allow,insmod_t,locale_t,lnk_file,getattr).
access_vector(allow,insmod_t,locale_t,lnk_file,lock).
access_vector(allow,insmod_t,locale_t,lnk_file,ioctl).
access_vector(allow,insmod_t,self,udp_socket,create).
access_vector(allow,insmod_t,self,udp_socket,ioctl).
access_vector(allow,insmod_t,self,udp_socket,read).
access_vector(allow,insmod_t,self,udp_socket,getattr).
access_vector(allow,insmod_t,self,udp_socket,write).
access_vector(allow,insmod_t,self,udp_socket,setattr).
access_vector(allow,insmod_t,self,udp_socket,append).
access_vector(allow,insmod_t,self,udp_socket,bind).
access_vector(allow,insmod_t,self,udp_socket,connect).
access_vector(allow,insmod_t,self,udp_socket,getopt).
access_vector(allow,insmod_t,self,udp_socket,setopt).
access_vector(allow,insmod_t,self,udp_socket,shutdown).
type_decl(insmod_exec_t,[],[file_type,exec_type,sysadmfile]).
access_vector(allow,initrc_t,insmod_t,process,transition).
access_vector(allow,kernel_t,insmod_t,process,transition).
access_vector(dontaudit,initrc_t,insmod_t,process,noatsecure).
access_vector(dontaudit,kernel_t,insmod_t,process,noatsecure).
access_vector(allow,initrc_t,insmod_exec_t,file,read).
access_vector(allow,initrc_t,insmod_exec_t,file,getattr).
access_vector(allow,initrc_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,initrc_t,process,sigchld).
access_vector(allow,insmod_t,kernel_t,process,sigchld).
access_vector(allow,insmod_t,initrc_t,fd,use).
access_vector(allow,insmod_t,kernel_t,fd,use).
access_vector(allow,initrc_t,insmod_t,fd,use).
access_vector(allow,kernel_t,insmod_t,fd,use).
access_vector(allow,insmod_t,initrc_t,fifo_file,ioctl).
access_vector(allow,insmod_t,initrc_t,fifo_file,read).
access_vector(allow,insmod_t,initrc_t,fifo_file,getattr).
access_vector(allow,insmod_t,initrc_t,fifo_file,lock).
access_vector(allow,insmod_t,initrc_t,fifo_file,write).
access_vector(allow,insmod_t,initrc_t,fifo_file,append).
access_vector(allow,insmod_t,insmod_exec_t,file,entrypoint).
type_trans([initrc_t,kernel_t],insmod_exec_t,process,insmod_t).
access_vector(allow,initrc_t,insmod_exec_t,lnk_file,read).
access_vector(allow,insmod_t,insmod_exec_t,file,read).
access_vector(allow,insmod_t,insmod_exec_t,file,getattr).
access_vector(allow,insmod_t,insmod_exec_t,file,lock).
access_vector(allow,insmod_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,insmod_exec_t,file,ioctl).
access_vector(allow,insmod_t,insmod_exec_t,file,execute_no_trans).
access_vector(allow,insmod_t,bin_t,dir,search).
access_vector(allow,insmod_t,sbin_t,dir,search).
access_vector(allow,insmod_t,sbin_t,lnk_file,read).
access_vector(allow,insmod_t,init_t,fd,use).
access_vector(allow,sysadm_t,insmod_t,process,transition).
access_vector(dontaudit,sysadm_t,insmod_t,process,noatsecure).
access_vector(allow,sysadm_t,insmod_exec_t,file,read).
access_vector(allow,sysadm_t,insmod_exec_t,file,getattr).
access_vector(allow,sysadm_t,insmod_exec_t,file,execute).
access_vector(allow,insmod_t,sysadm_t,process,sigchld).
access_vector(allow,insmod_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,insmod_t,fd,use).
access_vector(allow,insmod_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,insmod_t,sysadm_t,fifo_file,read).
access_vector(allow,insmod_t,sysadm_t,fifo_file,getattr).
access_vector(allow,insmod_t,sysadm_t,fifo_file,lock).
access_vector(allow,insmod_t,sysadm_t,fifo_file,write).
access_vector(allow,insmod_t,sysadm_t,fifo_file,append).
access_vector(allow,insmod_t,insmod_exec_t,file,entrypoint).
type_trans(sysadm_t,insmod_exec_t,process,insmod_t).
access_vector(allow,insmod_t,fs_t,filesystem,getattr).
access_vector(allow,insmod_t,modules_conf_t,file,getattr).
access_vector(allow,insmod_t,modules_conf_t,file,read).
access_vector(allow,insmod_t,modules_dep_t,file,getattr).
access_vector(allow,insmod_t,modules_dep_t,file,read).
access_vector(allow,insmod_t,modules_object_t,dir,read).
access_vector(allow,insmod_t,modules_object_t,dir,getattr).
access_vector(allow,insmod_t,modules_object_t,dir,lock).
access_vector(allow,insmod_t,modules_object_t,dir,search).
access_vector(allow,insmod_t,modules_object_t,dir,ioctl).
access_vector(allow,insmod_t,modules_object_t,file,read).
access_vector(allow,insmod_t,modules_object_t,file,getattr).
access_vector(allow,insmod_t,modules_object_t,file,lock).
access_vector(allow,insmod_t,modules_object_t,file,ioctl).
access_vector(allow,insmod_t,modules_object_t,lnk_file,read).
access_vector(allow,insmod_t,modules_object_t,lnk_file,getattr).
access_vector(allow,insmod_t,modules_object_t,lnk_file,lock).
access_vector(allow,insmod_t,modules_object_t,lnk_file,ioctl).
access_vector(allow,insmod_t,self,unix_dgram_socket,create).
access_vector(allow,insmod_t,self,unix_dgram_socket,ioctl).
access_vector(allow,insmod_t,self,unix_dgram_socket,read).
access_vector(allow,insmod_t,self,unix_dgram_socket,getattr).
access_vector(allow,insmod_t,self,unix_dgram_socket,write).
access_vector(allow,insmod_t,self,unix_dgram_socket,setattr).
access_vector(allow,insmod_t,self,unix_dgram_socket,append).
access_vector(allow,insmod_t,self,unix_dgram_socket,bind).
access_vector(allow,insmod_t,self,unix_dgram_socket,connect).
access_vector(allow,insmod_t,self,unix_dgram_socket,getopt).
access_vector(allow,insmod_t,self,unix_dgram_socket,setopt).
access_vector(allow,insmod_t,self,unix_dgram_socket,shutdown).
access_vector(allow,insmod_t,self,capability,sys_module).
access_vector(allow,insmod_t,self,capability,kill).
access_vector(allow,insmod_t,self,capability,net_raw).
access_vector(allow,insmod_t,privfd,fd,use).
access_vector(allow,insmod_t,domain,process,signal).
access_vector(allow,insmod_t,proc_t,dir,search).
access_vector(allow,insmod_t,sysctl_t,dir,search).
access_vector(allow,insmod_t,sysctl_kernel_t,dir,search).
access_vector(allow,insmod_t,sysctl_kernel_t,file,setattr).
access_vector(allow,insmod_t,sysctl_kernel_t,file,ioctl).
access_vector(allow,insmod_t,sysctl_kernel_t,file,read).
access_vector(allow,insmod_t,sysctl_kernel_t,file,getattr).
access_vector(allow,insmod_t,sysctl_kernel_t,file,lock).
access_vector(allow,insmod_t,sysctl_kernel_t,file,write).
access_vector(allow,insmod_t,sysctl_kernel_t,file,append).
access_vector(allow,insmod_t,sysctl_t,file,write).
access_vector(allow,insmod_t,proc_t,file,getattr).
access_vector(allow,insmod_t,proc_t,file,read).
access_vector(allow,insmod_t,var_t,dir,read).
access_vector(allow,insmod_t,var_t,dir,getattr).
access_vector(allow,insmod_t,var_t,dir,lock).
access_vector(allow,insmod_t,var_t,dir,search).
access_vector(allow,insmod_t,var_t,dir,ioctl).
access_vector(allow,insmod_t,var_log_t,dir,read).
access_vector(allow,insmod_t,var_log_t,dir,getattr).
access_vector(allow,insmod_t,var_log_t,dir,lock).
access_vector(allow,insmod_t,var_log_t,dir,search).
access_vector(allow,insmod_t,var_log_t,dir,ioctl).
access_vector(allow,insmod_t,var_log_ksyms_t,file,create).
access_vector(allow,insmod_t,var_log_ksyms_t,file,ioctl).
access_vector(allow,insmod_t,var_log_ksyms_t,file,read).
access_vector(allow,insmod_t,var_log_ksyms_t,file,getattr).
access_vector(allow,insmod_t,var_log_ksyms_t,file,lock).
access_vector(allow,insmod_t,var_log_ksyms_t,file,write).
access_vector(allow,insmod_t,var_log_ksyms_t,file,setattr).
access_vector(allow,insmod_t,var_log_ksyms_t,file,append).
access_vector(allow,insmod_t,var_log_ksyms_t,file,link).
access_vector(allow,insmod_t,var_log_ksyms_t,file,unlink).
access_vector(allow,insmod_t,var_log_ksyms_t,file,rename).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,create).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,read).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,getattr).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,lock).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,setattr).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,link).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,unlink).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,rename).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,search).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,add_name).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,remove_name).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,reparent).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,write).
access_vector(allow,insmod_t,var_log_ksyms_t,dir,rmdir).
access_vector(allow,system_crond_t,var_log_ksyms_t,dir,read).
access_vector(allow,system_crond_t,var_log_ksyms_t,dir,getattr).
access_vector(allow,system_crond_t,var_log_ksyms_t,dir,lock).
access_vector(allow,system_crond_t,var_log_ksyms_t,dir,search).
access_vector(allow,system_crond_t,var_log_ksyms_t,dir,ioctl).
access_vector(allow,system_crond_t,var_log_ksyms_t,dir,add_name).
access_vector(allow,system_crond_t,var_log_ksyms_t,dir,remove_name).
access_vector(allow,system_crond_t,var_log_ksyms_t,dir,write).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,create).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,ioctl).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,read).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,getattr).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,lock).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,write).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,setattr).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,append).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,link).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,unlink).
access_vector(allow,system_crond_t,var_log_ksyms_t,file,rename).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,create).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,ioctl).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,read).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,getattr).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,lock).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,write).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,setattr).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,append).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,link).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,unlink).
access_vector(allow,system_crond_t,var_log_ksyms_t,lnk_file,rename).
access_vector(allow,insmod_t,device_t,dir,search).
access_vector(allow,insmod_t,etc_runtime_t,file,getattr).
access_vector(allow,insmod_t,etc_runtime_t,file,read).
access_vector(allow,insmod_t,self,process,fork).
access_vector(allow,insmod_t,self,process,sigchld).
access_vector(allow,insmod_t,self,process,sigkill).
access_vector(allow,insmod_t,self,process,sigstop).
access_vector(allow,insmod_t,self,process,signull).
access_vector(allow,insmod_t,self,process,signal).
access_vector(allow,insmod_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,insmod_t,initrc_devpts_t,chr_file,read).
access_vector(allow,insmod_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,insmod_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,insmod_t,initrc_devpts_t,chr_file,write).
access_vector(allow,insmod_t,initrc_devpts_t,chr_file,append).
access_vector(allow,insmod_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,insmod_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,insmod_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,insmod_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,insmod_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,insmod_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,insmod_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,insmod_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,insmod_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,insmod_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,insmod_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,insmod_t,sysadm_devpts_t,chr_file,append).
access_vector(allow,insmod_t,ld_so_t,file,execute_no_trans).
access_vector(allow,insmod_t,device_t,dir,search).
access_vector(dontaudit,insmod_t,file_t,dir,search).
type_decl(update_modules_t,[],[domain,privlog]).
type_decl(update_modules_exec_t,[],[file_type,exec_type,sysadmfile]).
role_decl(system_r,update_modules_t).
role_decl(sysadm_r,update_modules_t).
access_vector(allow,initrc_t,update_modules_t,process,transition).
access_vector(allow,sysadm_t,update_modules_t,process,transition).
access_vector(dontaudit,initrc_t,update_modules_t,process,noatsecure).
access_vector(dontaudit,sysadm_t,update_modules_t,process,noatsecure).
access_vector(allow,initrc_t,update_modules_exec_t,file,read).
access_vector(allow,initrc_t,update_modules_exec_t,file,getattr).
access_vector(allow,initrc_t,update_modules_exec_t,file,execute).
access_vector(allow,sysadm_t,update_modules_exec_t,file,read).
access_vector(allow,sysadm_t,update_modules_exec_t,file,getattr).
access_vector(allow,sysadm_t,update_modules_exec_t,file,execute).
access_vector(allow,update_modules_t,initrc_t,process,sigchld).
access_vector(allow,update_modules_t,sysadm_t,process,sigchld).
access_vector(allow,update_modules_t,initrc_t,fd,use).
access_vector(allow,update_modules_t,sysadm_t,fd,use).
access_vector(allow,initrc_t,update_modules_t,fd,use).
access_vector(allow,sysadm_t,update_modules_t,fd,use).
access_vector(allow,update_modules_t,initrc_t,fifo_file,ioctl).
access_vector(allow,update_modules_t,initrc_t,fifo_file,read).
access_vector(allow,update_modules_t,initrc_t,fifo_file,getattr).
access_vector(allow,update_modules_t,initrc_t,fifo_file,lock).
access_vector(allow,update_modules_t,initrc_t,fifo_file,write).
access_vector(allow,update_modules_t,initrc_t,fifo_file,append).
access_vector(allow,update_modules_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,update_modules_t,sysadm_t,fifo_file,read).
access_vector(allow,update_modules_t,sysadm_t,fifo_file,getattr).
access_vector(allow,update_modules_t,sysadm_t,fifo_file,lock).
access_vector(allow,update_modules_t,sysadm_t,fifo_file,write).
access_vector(allow,update_modules_t,sysadm_t,fifo_file,append).
access_vector(allow,update_modules_t,update_modules_exec_t,file,entrypoint).
type_trans([initrc_t,sysadm_t],update_modules_exec_t,process,update_modules_t).
access_vector(allow,update_modules_t,privfd,fd,use).
access_vector(allow,update_modules_t,init_t,fd,use).
access_vector(allow,update_modules_t,device_t,dir,getattr).
access_vector(allow,update_modules_t,device_t,dir,search).
access_vector(allow,update_modules_t,console_device_t,chr_file,ioctl).
access_vector(allow,update_modules_t,console_device_t,chr_file,read).
access_vector(allow,update_modules_t,console_device_t,chr_file,getattr).
access_vector(allow,update_modules_t,console_device_t,chr_file,lock).
access_vector(allow,update_modules_t,console_device_t,chr_file,write).
access_vector(allow,update_modules_t,console_device_t,chr_file,append).
access_vector(allow,update_modules_t,devtty_t,chr_file,ioctl).
access_vector(allow,update_modules_t,devtty_t,chr_file,read).
access_vector(allow,update_modules_t,devtty_t,chr_file,getattr).
access_vector(allow,update_modules_t,devtty_t,chr_file,lock).
access_vector(allow,update_modules_t,devtty_t,chr_file,write).
access_vector(allow,update_modules_t,devtty_t,chr_file,append).
access_vector(allow,update_modules_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,update_modules_t,initrc_devpts_t,chr_file,read).
access_vector(allow,update_modules_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,update_modules_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,update_modules_t,initrc_devpts_t,chr_file,write).
access_vector(allow,update_modules_t,initrc_devpts_t,chr_file,append).
access_vector(allow,update_modules_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,update_modules_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,update_modules_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,update_modules_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,update_modules_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,update_modules_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,update_modules_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,update_modules_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,update_modules_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,update_modules_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,update_modules_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,update_modules_t,sysadm_devpts_t,chr_file,append).
access_vector(dontaudit,update_modules_t,sysadm_home_dir_t,dir,search).
access_vector(allow,update_modules_t,root_t,dir,read).
access_vector(allow,update_modules_t,root_t,dir,getattr).
access_vector(allow,update_modules_t,root_t,dir,lock).
access_vector(allow,update_modules_t,root_t,dir,search).
access_vector(allow,update_modules_t,root_t,dir,ioctl).
access_vector(allow,update_modules_t,usr_t,dir,read).
access_vector(allow,update_modules_t,usr_t,dir,getattr).
access_vector(allow,update_modules_t,usr_t,dir,lock).
access_vector(allow,update_modules_t,usr_t,dir,search).
access_vector(allow,update_modules_t,usr_t,dir,ioctl).
access_vector(allow,update_modules_t,lib_t,dir,read).
access_vector(allow,update_modules_t,lib_t,dir,getattr).
access_vector(allow,update_modules_t,lib_t,dir,lock).
access_vector(allow,update_modules_t,lib_t,dir,search).
access_vector(allow,update_modules_t,lib_t,dir,ioctl).
access_vector(allow,update_modules_t,etc_t,dir,read).
access_vector(allow,update_modules_t,etc_t,dir,getattr).
access_vector(allow,update_modules_t,etc_t,dir,lock).
access_vector(allow,update_modules_t,etc_t,dir,search).
access_vector(allow,update_modules_t,etc_t,dir,ioctl).
access_vector(allow,update_modules_t,lib_t,lnk_file,read).
access_vector(allow,update_modules_t,lib_t,lnk_file,getattr).
access_vector(allow,update_modules_t,lib_t,lnk_file,lock).
access_vector(allow,update_modules_t,lib_t,lnk_file,ioctl).
access_vector(allow,update_modules_t,ld_so_t,file,read).
access_vector(allow,update_modules_t,ld_so_t,file,getattr).
access_vector(allow,update_modules_t,ld_so_t,file,lock).
access_vector(allow,update_modules_t,ld_so_t,file,execute).
access_vector(allow,update_modules_t,ld_so_t,file,ioctl).
access_vector(allow,update_modules_t,ld_so_t,file,execute_no_trans).
access_vector(allow,update_modules_t,ld_so_t,lnk_file,read).
access_vector(allow,update_modules_t,ld_so_t,lnk_file,getattr).
access_vector(allow,update_modules_t,ld_so_t,lnk_file,lock).
access_vector(allow,update_modules_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,update_modules_t,shlib_t,file,read).
access_vector(allow,update_modules_t,shlib_t,file,getattr).
access_vector(allow,update_modules_t,shlib_t,file,lock).
access_vector(allow,update_modules_t,shlib_t,file,execute).
access_vector(allow,update_modules_t,shlib_t,file,ioctl).
access_vector(allow,update_modules_t,shlib_t,lnk_file,read).
access_vector(allow,update_modules_t,shlib_t,lnk_file,getattr).
access_vector(allow,update_modules_t,shlib_t,lnk_file,lock).
access_vector(allow,update_modules_t,shlib_t,lnk_file,ioctl).
access_vector(allow,update_modules_t,ld_so_cache_t,file,read).
access_vector(allow,update_modules_t,ld_so_cache_t,file,getattr).
access_vector(allow,update_modules_t,ld_so_cache_t,file,lock).
access_vector(allow,update_modules_t,ld_so_cache_t,file,ioctl).
access_vector(allow,update_modules_t,device_t,dir,search).
access_vector(allow,update_modules_t,null_device_t,chr_file,ioctl).
access_vector(allow,update_modules_t,null_device_t,chr_file,read).
access_vector(allow,update_modules_t,null_device_t,chr_file,getattr).
access_vector(allow,update_modules_t,null_device_t,chr_file,lock).
access_vector(allow,update_modules_t,null_device_t,chr_file,write).
access_vector(allow,update_modules_t,null_device_t,chr_file,append).
access_vector(allow,update_modules_t,self,process,fork).
access_vector(allow,update_modules_t,self,process,sigchld).
access_vector(allow,update_modules_t,self,fifo_file,ioctl).
access_vector(allow,update_modules_t,self,fifo_file,read).
access_vector(allow,update_modules_t,self,fifo_file,getattr).
access_vector(allow,update_modules_t,self,fifo_file,lock).
access_vector(allow,update_modules_t,self,fifo_file,write).
access_vector(allow,update_modules_t,self,fifo_file,append).
access_vector(allow,update_modules_t,modules_dep_t,file,ioctl).
access_vector(allow,update_modules_t,modules_dep_t,file,read).
access_vector(allow,update_modules_t,modules_dep_t,file,getattr).
access_vector(allow,update_modules_t,modules_dep_t,file,lock).
access_vector(allow,update_modules_t,modules_dep_t,file,write).
access_vector(allow,update_modules_t,modules_dep_t,file,append).
access_vector(allow,update_modules_t,modules_object_t,dir,read).
access_vector(allow,update_modules_t,modules_object_t,dir,getattr).
access_vector(allow,update_modules_t,modules_object_t,dir,lock).
access_vector(allow,update_modules_t,modules_object_t,dir,search).
access_vector(allow,update_modules_t,modules_object_t,dir,ioctl).
access_vector(allow,update_modules_t,modules_object_t,dir,add_name).
access_vector(allow,update_modules_t,modules_object_t,dir,remove_name).
access_vector(allow,update_modules_t,modules_object_t,dir,write).
access_vector(allow,update_modules_t,modules_conf_t,file,create).
access_vector(allow,update_modules_t,modules_conf_t,file,ioctl).
access_vector(allow,update_modules_t,modules_conf_t,file,read).
access_vector(allow,update_modules_t,modules_conf_t,file,getattr).
access_vector(allow,update_modules_t,modules_conf_t,file,lock).
access_vector(allow,update_modules_t,modules_conf_t,file,write).
access_vector(allow,update_modules_t,modules_conf_t,file,setattr).
access_vector(allow,update_modules_t,modules_conf_t,file,append).
access_vector(allow,update_modules_t,modules_conf_t,file,link).
access_vector(allow,update_modules_t,modules_conf_t,file,unlink).
access_vector(allow,update_modules_t,modules_conf_t,file,rename).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,create).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,ioctl).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,read).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,getattr).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,lock).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,write).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,setattr).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,append).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,link).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,unlink).
access_vector(allow,update_modules_t,modules_conf_t,lnk_file,rename).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,create).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,ioctl).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,read).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,getattr).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,lock).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,write).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,setattr).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,append).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,link).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,unlink).
access_vector(allow,update_modules_t,modules_conf_t,sock_file,rename).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,create).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,ioctl).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,read).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,getattr).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,lock).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,write).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,setattr).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,append).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,link).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,unlink).
access_vector(allow,update_modules_t,modules_conf_t,fifo_file,rename).
access_vector(allow,update_modules_t,modules_conf_t,dir,create).
access_vector(allow,update_modules_t,modules_conf_t,dir,read).
access_vector(allow,update_modules_t,modules_conf_t,dir,getattr).
access_vector(allow,update_modules_t,modules_conf_t,dir,lock).
access_vector(allow,update_modules_t,modules_conf_t,dir,setattr).
access_vector(allow,update_modules_t,modules_conf_t,dir,link).
access_vector(allow,update_modules_t,modules_conf_t,dir,unlink).
access_vector(allow,update_modules_t,modules_conf_t,dir,rename).
access_vector(allow,update_modules_t,modules_conf_t,dir,search).
access_vector(allow,update_modules_t,modules_conf_t,dir,add_name).
access_vector(allow,update_modules_t,modules_conf_t,dir,remove_name).
access_vector(allow,update_modules_t,modules_conf_t,dir,reparent).
access_vector(allow,update_modules_t,modules_conf_t,dir,write).
access_vector(allow,update_modules_t,modules_conf_t,dir,rmdir).
type_trans(update_modules_t,modules_object_t,dir,modules_conf_t).
type_trans(update_modules_t,modules_object_t,[file,lnk_file,sock_file,fifo_file],modules_conf_t).
access_vector(allow,update_modules_t,depmod_t,process,transition).
access_vector(dontaudit,update_modules_t,depmod_t,process,noatsecure).
access_vector(allow,update_modules_t,depmod_exec_t,file,read).
access_vector(allow,update_modules_t,depmod_exec_t,file,getattr).
access_vector(allow,update_modules_t,depmod_exec_t,file,execute).
access_vector(allow,depmod_t,update_modules_t,process,sigchld).
access_vector(allow,depmod_t,update_modules_t,fd,use).
access_vector(allow,update_modules_t,depmod_t,fd,use).
access_vector(allow,depmod_t,update_modules_t,fifo_file,ioctl).
access_vector(allow,depmod_t,update_modules_t,fifo_file,read).
access_vector(allow,depmod_t,update_modules_t,fifo_file,getattr).
access_vector(allow,depmod_t,update_modules_t,fifo_file,lock).
access_vector(allow,depmod_t,update_modules_t,fifo_file,write).
access_vector(allow,depmod_t,update_modules_t,fifo_file,append).
access_vector(allow,depmod_t,depmod_exec_t,file,entrypoint).
type_trans(update_modules_t,depmod_exec_t,process,depmod_t).
access_vector(allow,update_modules_t,shell_exec_t,file,read).
access_vector(allow,update_modules_t,shell_exec_t,file,getattr).
access_vector(allow,update_modules_t,shell_exec_t,file,lock).
access_vector(allow,update_modules_t,shell_exec_t,file,execute).
access_vector(allow,update_modules_t,shell_exec_t,file,ioctl).
access_vector(allow,update_modules_t,shell_exec_t,file,execute_no_trans).
access_vector(allow,update_modules_t,bin_t,file,read).
access_vector(allow,update_modules_t,bin_t,file,getattr).
access_vector(allow,update_modules_t,bin_t,file,lock).
access_vector(allow,update_modules_t,bin_t,file,execute).
access_vector(allow,update_modules_t,bin_t,file,ioctl).
access_vector(allow,update_modules_t,bin_t,file,execute_no_trans).
access_vector(allow,update_modules_t,sbin_t,file,read).
access_vector(allow,update_modules_t,sbin_t,file,getattr).
access_vector(allow,update_modules_t,sbin_t,file,lock).
access_vector(allow,update_modules_t,sbin_t,file,execute).
access_vector(allow,update_modules_t,sbin_t,file,ioctl).
access_vector(allow,update_modules_t,sbin_t,file,execute_no_trans).
access_vector(allow,update_modules_t,update_modules_exec_t,file,read).
access_vector(allow,update_modules_t,update_modules_exec_t,file,getattr).
access_vector(allow,update_modules_t,update_modules_exec_t,file,lock).
access_vector(allow,update_modules_t,update_modules_exec_t,file,execute).
access_vector(allow,update_modules_t,update_modules_exec_t,file,ioctl).
access_vector(allow,update_modules_t,update_modules_exec_t,file,execute_no_trans).
access_vector(allow,update_modules_t,etc_t,file,read).
access_vector(allow,update_modules_t,etc_t,file,getattr).
access_vector(allow,update_modules_t,etc_t,file,lock).
access_vector(allow,update_modules_t,etc_t,file,execute).
access_vector(allow,update_modules_t,etc_t,file,ioctl).
access_vector(allow,update_modules_t,etc_t,file,execute_no_trans).
access_vector(allow,update_modules_t,bin_t,lnk_file,read).
access_vector(allow,update_modules_t,sbin_t,dir,search).
access_vector(allow,update_modules_t,bin_t,dir,search).
access_vector(allow,update_modules_t,etc_t,file,read).
access_vector(allow,update_modules_t,etc_t,file,getattr).
access_vector(allow,update_modules_t,etc_t,file,lock).
access_vector(allow,update_modules_t,etc_t,file,ioctl).
access_vector(allow,update_modules_t,etc_runtime_t,file,read).
access_vector(allow,update_modules_t,etc_runtime_t,file,getattr).
access_vector(allow,update_modules_t,etc_runtime_t,file,lock).
access_vector(allow,update_modules_t,etc_runtime_t,file,ioctl).
access_vector(allow,update_modules_t,etc_t,lnk_file,read).
access_vector(allow,update_modules_t,fs_t,filesystem,getattr).
access_vector(allow,update_modules_t,proc_t,dir,search).
access_vector(allow,update_modules_t,proc_t,file,read).
access_vector(allow,update_modules_t,proc_t,file,getattr).
access_vector(allow,update_modules_t,proc_t,file,lock).
access_vector(allow,update_modules_t,proc_t,file,ioctl).
access_vector(allow,update_modules_t,self,lnk_file,read).
access_vector(allow,update_modules_t,proc_t,lnk_file,read).
access_vector(allow,update_modules_t,sysctl_t,dir,search).
access_vector(allow,update_modules_t,sysctl_kernel_t,dir,search).
access_vector(allow,update_modules_t,sysctl_kernel_t,file,getattr).
access_vector(allow,update_modules_t,sysctl_kernel_t,file,read).
access_vector(allow,update_modules_t,self,dir,search).
access_vector(allow,update_modules_t,self,unix_stream_socket,create).
access_vector(allow,update_modules_t,self,unix_stream_socket,ioctl).
access_vector(allow,update_modules_t,self,unix_stream_socket,read).
access_vector(allow,update_modules_t,self,unix_stream_socket,getattr).
access_vector(allow,update_modules_t,self,unix_stream_socket,write).
access_vector(allow,update_modules_t,self,unix_stream_socket,setattr).
access_vector(allow,update_modules_t,self,unix_stream_socket,append).
access_vector(allow,update_modules_t,self,unix_stream_socket,bind).
access_vector(allow,update_modules_t,self,unix_stream_socket,connect).
access_vector(allow,update_modules_t,self,unix_stream_socket,getopt).
access_vector(allow,update_modules_t,self,unix_stream_socket,setopt).
access_vector(allow,update_modules_t,self,unix_stream_socket,shutdown).
access_vector(allow,update_modules_t,etc_t,dir,read).
access_vector(allow,update_modules_t,etc_t,dir,getattr).
access_vector(allow,update_modules_t,etc_t,dir,lock).
access_vector(allow,update_modules_t,etc_t,dir,search).
access_vector(allow,update_modules_t,etc_t,dir,ioctl).
access_vector(allow,update_modules_t,etc_t,dir,add_name).
access_vector(allow,update_modules_t,etc_t,dir,remove_name).
access_vector(allow,update_modules_t,etc_t,dir,write).
type_trans(update_modules_t,etc_t,dir,modules_conf_t).
type_trans(update_modules_t,etc_t,[file,lnk_file,sock_file,fifo_file],modules_conf_t).
access_vector(allow,update_modules_t,etc_t,file,unlink).
type_decl(update_modules_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,update_modules_t,tmp_t,dir,read).
access_vector(allow,update_modules_t,tmp_t,dir,getattr).
access_vector(allow,update_modules_t,tmp_t,dir,lock).
access_vector(allow,update_modules_t,tmp_t,dir,search).
access_vector(allow,update_modules_t,tmp_t,dir,ioctl).
access_vector(allow,update_modules_t,tmp_t,dir,add_name).
access_vector(allow,update_modules_t,tmp_t,dir,remove_name).
access_vector(allow,update_modules_t,tmp_t,dir,write).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,create).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,ioctl).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,read).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,getattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,lock).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,write).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,setattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,append).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,link).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,unlink).
access_vector(allow,update_modules_t,update_modules_tmp_t,file,rename).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,create).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,ioctl).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,read).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,getattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,lock).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,write).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,setattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,append).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,link).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,unlink).
access_vector(allow,update_modules_t,update_modules_tmp_t,lnk_file,rename).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,create).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,ioctl).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,read).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,getattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,lock).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,write).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,setattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,append).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,link).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,unlink).
access_vector(allow,update_modules_t,update_modules_tmp_t,sock_file,rename).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,create).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,ioctl).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,read).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,getattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,lock).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,write).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,setattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,append).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,link).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,unlink).
access_vector(allow,update_modules_t,update_modules_tmp_t,fifo_file,rename).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,create).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,read).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,getattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,lock).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,setattr).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,link).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,unlink).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,rename).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,search).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,add_name).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,remove_name).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,reparent).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,write).
access_vector(allow,update_modules_t,update_modules_tmp_t,dir,rmdir).
type_trans(update_modules_t,tmp_t,dir,update_modules_tmp_t).
type_trans(update_modules_t,tmp_t,[file,lnk_file,sock_file,fifo_file],update_modules_tmp_t).
type_decl(mount_exec_t,[],[file_type,sysadmfile,exec_type]).
type_decl(mount_t,[],[domain,privlog]).
access_vector(allow,mount_t,root_t,dir,read).
access_vector(allow,mount_t,root_t,dir,getattr).
access_vector(allow,mount_t,root_t,dir,lock).
access_vector(allow,mount_t,root_t,dir,search).
access_vector(allow,mount_t,root_t,dir,ioctl).
access_vector(allow,mount_t,usr_t,dir,read).
access_vector(allow,mount_t,usr_t,dir,getattr).
access_vector(allow,mount_t,usr_t,dir,lock).
access_vector(allow,mount_t,usr_t,dir,search).
access_vector(allow,mount_t,usr_t,dir,ioctl).
access_vector(allow,mount_t,lib_t,dir,read).
access_vector(allow,mount_t,lib_t,dir,getattr).
access_vector(allow,mount_t,lib_t,dir,lock).
access_vector(allow,mount_t,lib_t,dir,search).
access_vector(allow,mount_t,lib_t,dir,ioctl).
access_vector(allow,mount_t,etc_t,dir,read).
access_vector(allow,mount_t,etc_t,dir,getattr).
access_vector(allow,mount_t,etc_t,dir,lock).
access_vector(allow,mount_t,etc_t,dir,search).
access_vector(allow,mount_t,etc_t,dir,ioctl).
access_vector(allow,mount_t,lib_t,lnk_file,read).
access_vector(allow,mount_t,lib_t,lnk_file,getattr).
access_vector(allow,mount_t,lib_t,lnk_file,lock).
access_vector(allow,mount_t,lib_t,lnk_file,ioctl).
access_vector(allow,mount_t,ld_so_t,file,read).
access_vector(allow,mount_t,ld_so_t,file,getattr).
access_vector(allow,mount_t,ld_so_t,file,lock).
access_vector(allow,mount_t,ld_so_t,file,execute).
access_vector(allow,mount_t,ld_so_t,file,ioctl).
access_vector(allow,mount_t,ld_so_t,file,execute_no_trans).
access_vector(allow,mount_t,ld_so_t,lnk_file,read).
access_vector(allow,mount_t,ld_so_t,lnk_file,getattr).
access_vector(allow,mount_t,ld_so_t,lnk_file,lock).
access_vector(allow,mount_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,mount_t,shlib_t,file,read).
access_vector(allow,mount_t,shlib_t,file,getattr).
access_vector(allow,mount_t,shlib_t,file,lock).
access_vector(allow,mount_t,shlib_t,file,execute).
access_vector(allow,mount_t,shlib_t,file,ioctl).
access_vector(allow,mount_t,shlib_t,lnk_file,read).
access_vector(allow,mount_t,shlib_t,lnk_file,getattr).
access_vector(allow,mount_t,shlib_t,lnk_file,lock).
access_vector(allow,mount_t,shlib_t,lnk_file,ioctl).
access_vector(allow,mount_t,ld_so_cache_t,file,read).
access_vector(allow,mount_t,ld_so_cache_t,file,getattr).
access_vector(allow,mount_t,ld_so_cache_t,file,lock).
access_vector(allow,mount_t,ld_so_cache_t,file,ioctl).
access_vector(allow,mount_t,device_t,dir,search).
access_vector(allow,mount_t,null_device_t,chr_file,ioctl).
access_vector(allow,mount_t,null_device_t,chr_file,read).
access_vector(allow,mount_t,null_device_t,chr_file,getattr).
access_vector(allow,mount_t,null_device_t,chr_file,lock).
access_vector(allow,mount_t,null_device_t,chr_file,write).
access_vector(allow,mount_t,null_device_t,chr_file,append).
access_vector(allow,sysadm_t,mount_t,process,transition).
access_vector(dontaudit,sysadm_t,mount_t,process,noatsecure).
access_vector(allow,sysadm_t,mount_exec_t,file,read).
access_vector(allow,sysadm_t,mount_exec_t,file,getattr).
access_vector(allow,sysadm_t,mount_exec_t,file,execute).
access_vector(allow,mount_t,sysadm_t,process,sigchld).
access_vector(allow,mount_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,mount_t,fd,use).
access_vector(allow,mount_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,mount_t,sysadm_t,fifo_file,read).
access_vector(allow,mount_t,sysadm_t,fifo_file,getattr).
access_vector(allow,mount_t,sysadm_t,fifo_file,lock).
access_vector(allow,mount_t,sysadm_t,fifo_file,write).
access_vector(allow,mount_t,sysadm_t,fifo_file,append).
access_vector(allow,mount_t,mount_exec_t,file,read).
access_vector(allow,mount_t,mount_exec_t,file,getattr).
access_vector(allow,mount_t,mount_exec_t,file,lock).
access_vector(allow,mount_t,mount_exec_t,file,execute).
access_vector(allow,mount_t,mount_exec_t,file,ioctl).
access_vector(allow,mount_t,mount_exec_t,file,entrypoint).
type_trans(sysadm_t,mount_exec_t,process,mount_t).
access_vector(allow,mount_t,proc_t,dir,search).
type_decl(mount_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,mount_t,tmp_t,dir,read).
access_vector(allow,mount_t,tmp_t,dir,getattr).
access_vector(allow,mount_t,tmp_t,dir,lock).
access_vector(allow,mount_t,tmp_t,dir,search).
access_vector(allow,mount_t,tmp_t,dir,ioctl).
access_vector(allow,mount_t,tmp_t,dir,add_name).
access_vector(allow,mount_t,tmp_t,dir,remove_name).
access_vector(allow,mount_t,tmp_t,dir,write).
access_vector(allow,mount_t,mount_tmp_t,file,create).
access_vector(allow,mount_t,mount_tmp_t,file,ioctl).
access_vector(allow,mount_t,mount_tmp_t,file,read).
access_vector(allow,mount_t,mount_tmp_t,file,getattr).
access_vector(allow,mount_t,mount_tmp_t,file,lock).
access_vector(allow,mount_t,mount_tmp_t,file,write).
access_vector(allow,mount_t,mount_tmp_t,file,setattr).
access_vector(allow,mount_t,mount_tmp_t,file,append).
access_vector(allow,mount_t,mount_tmp_t,file,link).
access_vector(allow,mount_t,mount_tmp_t,file,unlink).
access_vector(allow,mount_t,mount_tmp_t,file,rename).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,create).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,ioctl).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,read).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,getattr).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,lock).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,write).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,setattr).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,append).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,link).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,unlink).
access_vector(allow,mount_t,mount_tmp_t,lnk_file,rename).
access_vector(allow,mount_t,mount_tmp_t,sock_file,create).
access_vector(allow,mount_t,mount_tmp_t,sock_file,ioctl).
access_vector(allow,mount_t,mount_tmp_t,sock_file,read).
access_vector(allow,mount_t,mount_tmp_t,sock_file,getattr).
access_vector(allow,mount_t,mount_tmp_t,sock_file,lock).
access_vector(allow,mount_t,mount_tmp_t,sock_file,write).
access_vector(allow,mount_t,mount_tmp_t,sock_file,setattr).
access_vector(allow,mount_t,mount_tmp_t,sock_file,append).
access_vector(allow,mount_t,mount_tmp_t,sock_file,link).
access_vector(allow,mount_t,mount_tmp_t,sock_file,unlink).
access_vector(allow,mount_t,mount_tmp_t,sock_file,rename).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,create).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,ioctl).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,read).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,getattr).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,lock).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,write).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,setattr).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,append).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,link).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,unlink).
access_vector(allow,mount_t,mount_tmp_t,fifo_file,rename).
access_vector(allow,mount_t,mount_tmp_t,dir,create).
access_vector(allow,mount_t,mount_tmp_t,dir,read).
access_vector(allow,mount_t,mount_tmp_t,dir,getattr).
access_vector(allow,mount_t,mount_tmp_t,dir,lock).
access_vector(allow,mount_t,mount_tmp_t,dir,setattr).
access_vector(allow,mount_t,mount_tmp_t,dir,link).
access_vector(allow,mount_t,mount_tmp_t,dir,unlink).
access_vector(allow,mount_t,mount_tmp_t,dir,rename).
access_vector(allow,mount_t,mount_tmp_t,dir,search).
access_vector(allow,mount_t,mount_tmp_t,dir,add_name).
access_vector(allow,mount_t,mount_tmp_t,dir,remove_name).
access_vector(allow,mount_t,mount_tmp_t,dir,reparent).
access_vector(allow,mount_t,mount_tmp_t,dir,write).
access_vector(allow,mount_t,mount_tmp_t,dir,rmdir).
type_trans(mount_t,tmp_t,dir,mount_tmp_t).
type_trans(mount_t,tmp_t,[file,lnk_file,sock_file,fifo_file],mount_tmp_t).
access_vector(allow,mount_t,self,capability,net_bind_service).
access_vector(allow,mount_t,self,capability,sys_rawio).
access_vector(allow,mount_t,self,capability,sys_admin).
access_vector(allow,mount_t,etc_t,dir,read).
access_vector(allow,mount_t,etc_t,dir,getattr).
access_vector(allow,mount_t,etc_t,dir,lock).
access_vector(allow,mount_t,etc_t,dir,search).
access_vector(allow,mount_t,etc_t,dir,ioctl).
access_vector(allow,mount_t,etc_t,dir,add_name).
access_vector(allow,mount_t,etc_t,dir,remove_name).
access_vector(allow,mount_t,etc_t,dir,write).
access_vector(allow,mount_t,etc_runtime_t,file,create).
access_vector(allow,mount_t,etc_runtime_t,file,ioctl).
access_vector(allow,mount_t,etc_runtime_t,file,read).
access_vector(allow,mount_t,etc_runtime_t,file,getattr).
access_vector(allow,mount_t,etc_runtime_t,file,lock).
access_vector(allow,mount_t,etc_runtime_t,file,write).
access_vector(allow,mount_t,etc_runtime_t,file,setattr).
access_vector(allow,mount_t,etc_runtime_t,file,append).
access_vector(allow,mount_t,etc_runtime_t,file,link).
access_vector(allow,mount_t,etc_runtime_t,file,unlink).
access_vector(allow,mount_t,etc_runtime_t,file,rename).
type_trans(mount_t,etc_t,file,etc_runtime_t).
access_vector(allow,mount_t,etc_t,file,getattr).
access_vector(allow,mount_t,etc_t,file,read).
access_vector(allow,mount_t,etc_t,lnk_file,read).
access_vector(allow,mount_t,locale_t,dir,read).
access_vector(allow,mount_t,locale_t,dir,getattr).
access_vector(allow,mount_t,locale_t,dir,lock).
access_vector(allow,mount_t,locale_t,dir,search).
access_vector(allow,mount_t,locale_t,dir,ioctl).
access_vector(allow,mount_t,locale_t,file,read).
access_vector(allow,mount_t,locale_t,file,getattr).
access_vector(allow,mount_t,locale_t,file,lock).
access_vector(allow,mount_t,locale_t,file,ioctl).
access_vector(allow,mount_t,locale_t,lnk_file,read).
access_vector(allow,mount_t,locale_t,lnk_file,getattr).
access_vector(allow,mount_t,locale_t,lnk_file,lock).
access_vector(allow,mount_t,locale_t,lnk_file,ioctl).
access_vector(allow,mount_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,mount_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,mount_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,mount_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,mount_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,mount_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,mount_t,sysadm_devpts_t,chr_file,write).
role_decl(sysadm_r,mount_t).
role_decl(system_r,mount_t).
access_vector(allow,initrc_t,mount_t,process,transition).
access_vector(dontaudit,initrc_t,mount_t,process,noatsecure).
access_vector(allow,initrc_t,mount_exec_t,file,read).
access_vector(allow,initrc_t,mount_exec_t,file,getattr).
access_vector(allow,initrc_t,mount_exec_t,file,execute).
access_vector(allow,mount_t,initrc_t,process,sigchld).
access_vector(allow,mount_t,initrc_t,fd,use).
access_vector(allow,initrc_t,mount_t,fd,use).
access_vector(allow,mount_t,initrc_t,fifo_file,ioctl).
access_vector(allow,mount_t,initrc_t,fifo_file,read).
access_vector(allow,mount_t,initrc_t,fifo_file,getattr).
access_vector(allow,mount_t,initrc_t,fifo_file,lock).
access_vector(allow,mount_t,initrc_t,fifo_file,write).
access_vector(allow,mount_t,initrc_t,fifo_file,append).
access_vector(allow,mount_t,mount_exec_t,file,entrypoint).
type_trans(initrc_t,mount_exec_t,process,mount_t).
access_vector(allow,mount_t,init_t,fd,use).
access_vector(allow,mount_t,privfd,fd,use).
access_vector(allow,mount_t,self,capability,ipc_lock).
access_vector(allow,mount_t,self,capability,dac_override).
access_vector(allow,mount_t,self,process,fork).
access_vector(allow,mount_t,self,process,sigchld).
access_vector(allow,mount_t,self,process,sigkill).
access_vector(allow,mount_t,self,process,sigstop).
access_vector(allow,mount_t,self,process,signull).
access_vector(allow,mount_t,self,process,signal).
access_vector(allow,mount_t,file_type,dir,search).
access_vector(allow,mount_t,fixed_disk_device_t,chr_file,ioctl).
access_vector(allow,mount_t,fixed_disk_device_t,chr_file,read).
access_vector(allow,mount_t,fixed_disk_device_t,chr_file,getattr).
access_vector(allow,mount_t,fixed_disk_device_t,chr_file,lock).
access_vector(allow,mount_t,fixed_disk_device_t,chr_file,write).
access_vector(allow,mount_t,fixed_disk_device_t,chr_file,append).
access_vector(allow,mount_t,fixed_disk_device_t,blk_file,ioctl).
access_vector(allow,mount_t,fixed_disk_device_t,blk_file,read).
access_vector(allow,mount_t,fixed_disk_device_t,blk_file,getattr).
access_vector(allow,mount_t,fixed_disk_device_t,blk_file,lock).
access_vector(allow,mount_t,fixed_disk_device_t,blk_file,write).
access_vector(allow,mount_t,fixed_disk_device_t,blk_file,append).
access_vector(allow,mount_t,removable_device_t,chr_file,ioctl).
access_vector(allow,mount_t,removable_device_t,chr_file,read).
access_vector(allow,mount_t,removable_device_t,chr_file,getattr).
access_vector(allow,mount_t,removable_device_t,chr_file,lock).
access_vector(allow,mount_t,removable_device_t,chr_file,write).
access_vector(allow,mount_t,removable_device_t,chr_file,append).
access_vector(allow,mount_t,removable_device_t,blk_file,ioctl).
access_vector(allow,mount_t,removable_device_t,blk_file,read).
access_vector(allow,mount_t,removable_device_t,blk_file,getattr).
access_vector(allow,mount_t,removable_device_t,blk_file,lock).
access_vector(allow,mount_t,removable_device_t,blk_file,write).
access_vector(allow,mount_t,removable_device_t,blk_file,append).
access_vector(allow,mount_t,fs_type,filesystem,mount).
access_vector(allow,mount_t,fs_type,filesystem,remount).
access_vector(allow,mount_t,fs_type,filesystem,unmount).
access_vector(allow,mount_t,fs_type,filesystem,getattr).
access_vector(allow,mount_t,file_t,dir,mounton).
access_vector(allow,mount_t,usr_t,dir,mounton).
access_vector(allow,mount_t,proc_t,dir,mounton).
access_vector(allow,mount_t,root_t,dir,mounton).
access_vector(allow,mount_t,home_root_t,dir,mounton).
access_vector(allow,mount_t,boot_t,dir,mounton).
access_vector(allow,mount_t,device_t,dir,mounton).
access_vector(allow,mount_t,root_t,filesystem,unmount).
type_decl(netutils_t,[],[domain,privlog]).
type_decl(netutils_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(system_r,netutils_t).
role_decl(sysadm_r,netutils_t).
access_vector(allow,netutils_t,root_t,dir,read).
access_vector(allow,netutils_t,root_t,dir,getattr).
access_vector(allow,netutils_t,root_t,dir,lock).
access_vector(allow,netutils_t,root_t,dir,search).
access_vector(allow,netutils_t,root_t,dir,ioctl).
access_vector(allow,netutils_t,usr_t,dir,read).
access_vector(allow,netutils_t,usr_t,dir,getattr).
access_vector(allow,netutils_t,usr_t,dir,lock).
access_vector(allow,netutils_t,usr_t,dir,search).
access_vector(allow,netutils_t,usr_t,dir,ioctl).
access_vector(allow,netutils_t,lib_t,dir,read).
access_vector(allow,netutils_t,lib_t,dir,getattr).
access_vector(allow,netutils_t,lib_t,dir,lock).
access_vector(allow,netutils_t,lib_t,dir,search).
access_vector(allow,netutils_t,lib_t,dir,ioctl).
access_vector(allow,netutils_t,etc_t,dir,read).
access_vector(allow,netutils_t,etc_t,dir,getattr).
access_vector(allow,netutils_t,etc_t,dir,lock).
access_vector(allow,netutils_t,etc_t,dir,search).
access_vector(allow,netutils_t,etc_t,dir,ioctl).
access_vector(allow,netutils_t,lib_t,lnk_file,read).
access_vector(allow,netutils_t,lib_t,lnk_file,getattr).
access_vector(allow,netutils_t,lib_t,lnk_file,lock).
access_vector(allow,netutils_t,lib_t,lnk_file,ioctl).
access_vector(allow,netutils_t,ld_so_t,file,read).
access_vector(allow,netutils_t,ld_so_t,file,getattr).
access_vector(allow,netutils_t,ld_so_t,file,lock).
access_vector(allow,netutils_t,ld_so_t,file,execute).
access_vector(allow,netutils_t,ld_so_t,file,ioctl).
access_vector(allow,netutils_t,ld_so_t,file,execute_no_trans).
access_vector(allow,netutils_t,ld_so_t,lnk_file,read).
access_vector(allow,netutils_t,ld_so_t,lnk_file,getattr).
access_vector(allow,netutils_t,ld_so_t,lnk_file,lock).
access_vector(allow,netutils_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,netutils_t,shlib_t,file,read).
access_vector(allow,netutils_t,shlib_t,file,getattr).
access_vector(allow,netutils_t,shlib_t,file,lock).
access_vector(allow,netutils_t,shlib_t,file,execute).
access_vector(allow,netutils_t,shlib_t,file,ioctl).
access_vector(allow,netutils_t,shlib_t,lnk_file,read).
access_vector(allow,netutils_t,shlib_t,lnk_file,getattr).
access_vector(allow,netutils_t,shlib_t,lnk_file,lock).
access_vector(allow,netutils_t,shlib_t,lnk_file,ioctl).
access_vector(allow,netutils_t,ld_so_cache_t,file,read).
access_vector(allow,netutils_t,ld_so_cache_t,file,getattr).
access_vector(allow,netutils_t,ld_so_cache_t,file,lock).
access_vector(allow,netutils_t,ld_so_cache_t,file,ioctl).
access_vector(allow,netutils_t,device_t,dir,search).
access_vector(allow,netutils_t,null_device_t,chr_file,ioctl).
access_vector(allow,netutils_t,null_device_t,chr_file,read).
access_vector(allow,netutils_t,null_device_t,chr_file,getattr).
access_vector(allow,netutils_t,null_device_t,chr_file,lock).
access_vector(allow,netutils_t,null_device_t,chr_file,write).
access_vector(allow,netutils_t,null_device_t,chr_file,append).
access_vector(allow,netutils_t,self,udp_socket,create).
access_vector(allow,netutils_t,self,udp_socket,ioctl).
access_vector(allow,netutils_t,self,udp_socket,read).
access_vector(allow,netutils_t,self,udp_socket,getattr).
access_vector(allow,netutils_t,self,udp_socket,write).
access_vector(allow,netutils_t,self,udp_socket,setattr).
access_vector(allow,netutils_t,self,udp_socket,append).
access_vector(allow,netutils_t,self,udp_socket,bind).
access_vector(allow,netutils_t,self,udp_socket,connect).
access_vector(allow,netutils_t,self,udp_socket,getopt).
access_vector(allow,netutils_t,self,udp_socket,setopt).
access_vector(allow,netutils_t,self,udp_socket,shutdown).
access_vector(allow,netutils_t,self,tcp_socket,create).
access_vector(allow,netutils_t,self,tcp_socket,ioctl).
access_vector(allow,netutils_t,self,tcp_socket,read).
access_vector(allow,netutils_t,self,tcp_socket,getattr).
access_vector(allow,netutils_t,self,tcp_socket,write).
access_vector(allow,netutils_t,self,tcp_socket,setattr).
access_vector(allow,netutils_t,self,tcp_socket,append).
access_vector(allow,netutils_t,self,tcp_socket,bind).
access_vector(allow,netutils_t,self,tcp_socket,connect).
access_vector(allow,netutils_t,self,tcp_socket,getopt).
access_vector(allow,netutils_t,self,tcp_socket,setopt).
access_vector(allow,netutils_t,self,tcp_socket,shutdown).
access_vector(allow,netutils_t,self,tcp_socket,listen).
access_vector(allow,netutils_t,self,tcp_socket,accept).
access_vector(allow,netutils_t,any_socket_t,udp_socket,sendto).
access_vector(allow,netutils_t,netif_type,netif,tcp_send).
access_vector(allow,netutils_t,netif_type,netif,udp_send).
access_vector(allow,netutils_t,netif_type,netif,rawip_send).
access_vector(allow,netutils_t,netif_type,netif,tcp_recv).
access_vector(allow,netutils_t,netif_type,netif,udp_recv).
access_vector(allow,netutils_t,netif_type,netif,rawip_recv).
access_vector(allow,netutils_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,netutils_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,netutils_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,netutils_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,netutils_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,netutils_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,netutils_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,netutils_t,node_type,node,tcp_send).
access_vector(allow,netutils_t,node_type,node,udp_send).
access_vector(allow,netutils_t,node_type,node,rawip_send).
access_vector(allow,netutils_t,node_type,node,tcp_recv).
access_vector(allow,netutils_t,node_type,node,udp_recv).
access_vector(allow,netutils_t,node_type,node,rawip_recv).
access_vector(allow,netutils_t,mount_t,udp_socket,ioctl).
access_vector(allow,netutils_t,mount_t,udp_socket,read).
access_vector(allow,netutils_t,mount_t,udp_socket,getattr).
access_vector(allow,netutils_t,mount_t,udp_socket,write).
access_vector(allow,netutils_t,mount_t,udp_socket,setattr).
access_vector(allow,netutils_t,mount_t,udp_socket,append).
access_vector(allow,netutils_t,mount_t,udp_socket,bind).
access_vector(allow,netutils_t,mount_t,udp_socket,connect).
access_vector(allow,netutils_t,mount_t,udp_socket,getopt).
access_vector(allow,netutils_t,mount_t,udp_socket,setopt).
access_vector(allow,netutils_t,mount_t,udp_socket,shutdown).
access_vector(allow,netutils_t,port_t,udp_socket,name_bind).
access_vector(allow,netutils_t,port_t,tcp_socket,name_bind).
access_vector(allow,initrc_t,netutils_t,process,transition).
access_vector(dontaudit,initrc_t,netutils_t,process,noatsecure).
access_vector(allow,initrc_t,netutils_exec_t,file,read).
access_vector(allow,initrc_t,netutils_exec_t,file,getattr).
access_vector(allow,initrc_t,netutils_exec_t,file,execute).
access_vector(allow,netutils_t,initrc_t,process,sigchld).
access_vector(allow,netutils_t,initrc_t,fd,use).
access_vector(allow,initrc_t,netutils_t,fd,use).
access_vector(allow,netutils_t,initrc_t,fifo_file,ioctl).
access_vector(allow,netutils_t,initrc_t,fifo_file,read).
access_vector(allow,netutils_t,initrc_t,fifo_file,getattr).
access_vector(allow,netutils_t,initrc_t,fifo_file,lock).
access_vector(allow,netutils_t,initrc_t,fifo_file,write).
access_vector(allow,netutils_t,initrc_t,fifo_file,append).
access_vector(allow,netutils_t,netutils_exec_t,file,read).
access_vector(allow,netutils_t,netutils_exec_t,file,getattr).
access_vector(allow,netutils_t,netutils_exec_t,file,lock).
access_vector(allow,netutils_t,netutils_exec_t,file,execute).
access_vector(allow,netutils_t,netutils_exec_t,file,ioctl).
access_vector(allow,netutils_t,netutils_exec_t,file,entrypoint).
type_trans(initrc_t,netutils_exec_t,process,netutils_t).
access_vector(allow,sysadm_t,netutils_t,process,transition).
access_vector(dontaudit,sysadm_t,netutils_t,process,noatsecure).
access_vector(allow,sysadm_t,netutils_exec_t,file,read).
access_vector(allow,sysadm_t,netutils_exec_t,file,getattr).
access_vector(allow,sysadm_t,netutils_exec_t,file,execute).
access_vector(allow,netutils_t,sysadm_t,process,sigchld).
access_vector(allow,netutils_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,netutils_t,fd,use).
access_vector(allow,netutils_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,netutils_t,sysadm_t,fifo_file,read).
access_vector(allow,netutils_t,sysadm_t,fifo_file,getattr).
access_vector(allow,netutils_t,sysadm_t,fifo_file,lock).
access_vector(allow,netutils_t,sysadm_t,fifo_file,write).
access_vector(allow,netutils_t,sysadm_t,fifo_file,append).
access_vector(allow,netutils_t,netutils_exec_t,file,entrypoint).
type_trans(sysadm_t,netutils_exec_t,process,netutils_t).
access_vector(allow,netutils_t,init_t,fd,use).
access_vector(allow,netutils_t,self,process,fork).
access_vector(allow,netutils_t,self,process,sigchld).
access_vector(allow,netutils_t,self,process,sigkill).
access_vector(allow,netutils_t,self,process,sigstop).
access_vector(allow,netutils_t,self,process,signull).
access_vector(allow,netutils_t,self,process,signal).
access_vector(allow,netutils_t,self,capability,net_admin).
access_vector(allow,netutils_t,self,capability,net_raw).
access_vector(allow,netutils_t,self,capability,setuid).
access_vector(allow,netutils_t,self,capability,setgid).
access_vector(allow,netutils_t,self,netlink_socket,create).
access_vector(allow,netutils_t,self,netlink_socket,ioctl).
access_vector(allow,netutils_t,self,netlink_socket,read).
access_vector(allow,netutils_t,self,netlink_socket,getattr).
access_vector(allow,netutils_t,self,netlink_socket,write).
access_vector(allow,netutils_t,self,netlink_socket,setattr).
access_vector(allow,netutils_t,self,netlink_socket,append).
access_vector(allow,netutils_t,self,netlink_socket,bind).
access_vector(allow,netutils_t,self,netlink_socket,connect).
access_vector(allow,netutils_t,self,netlink_socket,getopt).
access_vector(allow,netutils_t,self,netlink_socket,setopt).
access_vector(allow,netutils_t,self,netlink_socket,shutdown).
access_vector(allow,netutils_t,self,packet_socket,create).
access_vector(allow,netutils_t,self,packet_socket,ioctl).
access_vector(allow,netutils_t,self,packet_socket,read).
access_vector(allow,netutils_t,self,packet_socket,getattr).
access_vector(allow,netutils_t,self,packet_socket,write).
access_vector(allow,netutils_t,self,packet_socket,setattr).
access_vector(allow,netutils_t,self,packet_socket,append).
access_vector(allow,netutils_t,self,packet_socket,bind).
access_vector(allow,netutils_t,self,packet_socket,connect).
access_vector(allow,netutils_t,self,packet_socket,getopt).
access_vector(allow,netutils_t,self,packet_socket,setopt).
access_vector(allow,netutils_t,self,packet_socket,shutdown).
access_vector(allow,netutils_t,self,tcp_socket,create).
access_vector(allow,netutils_t,self,tcp_socket,ioctl).
access_vector(allow,netutils_t,self,tcp_socket,read).
access_vector(allow,netutils_t,self,tcp_socket,getattr).
access_vector(allow,netutils_t,self,tcp_socket,write).
access_vector(allow,netutils_t,self,tcp_socket,setattr).
access_vector(allow,netutils_t,self,tcp_socket,append).
access_vector(allow,netutils_t,self,tcp_socket,bind).
access_vector(allow,netutils_t,self,tcp_socket,connect).
access_vector(allow,netutils_t,self,tcp_socket,getopt).
access_vector(allow,netutils_t,self,tcp_socket,setopt).
access_vector(allow,netutils_t,self,tcp_socket,shutdown).
access_vector(allow,netutils_t,self,unix_stream_socket,create).
access_vector(allow,netutils_t,self,unix_stream_socket,ioctl).
access_vector(allow,netutils_t,self,unix_stream_socket,read).
access_vector(allow,netutils_t,self,unix_stream_socket,getattr).
access_vector(allow,netutils_t,self,unix_stream_socket,write).
access_vector(allow,netutils_t,self,unix_stream_socket,setattr).
access_vector(allow,netutils_t,self,unix_stream_socket,append).
access_vector(allow,netutils_t,self,unix_stream_socket,bind).
access_vector(allow,netutils_t,self,unix_stream_socket,connect).
access_vector(allow,netutils_t,self,unix_stream_socket,getopt).
access_vector(allow,netutils_t,self,unix_stream_socket,setopt).
access_vector(allow,netutils_t,self,unix_stream_socket,shutdown).
access_vector(allow,netutils_t,etc_t,file,read).
access_vector(allow,netutils_t,etc_t,file,getattr).
access_vector(allow,netutils_t,etc_t,file,lock).
access_vector(allow,netutils_t,etc_t,file,ioctl).
access_vector(allow,netutils_t,resolv_conf_t,file,read).
access_vector(allow,netutils_t,resolv_conf_t,file,getattr).
access_vector(allow,netutils_t,resolv_conf_t,file,lock).
access_vector(allow,netutils_t,resolv_conf_t,file,ioctl).
access_vector(allow,netutils_t,etc_t,lnk_file,read).
access_vector(allow,netutils_t,locale_t,dir,read).
access_vector(allow,netutils_t,locale_t,dir,getattr).
access_vector(allow,netutils_t,locale_t,dir,lock).
access_vector(allow,netutils_t,locale_t,dir,search).
access_vector(allow,netutils_t,locale_t,dir,ioctl).
access_vector(allow,netutils_t,locale_t,file,read).
access_vector(allow,netutils_t,locale_t,file,getattr).
access_vector(allow,netutils_t,locale_t,file,lock).
access_vector(allow,netutils_t,locale_t,file,ioctl).
access_vector(allow,netutils_t,locale_t,lnk_file,read).
access_vector(allow,netutils_t,locale_t,lnk_file,getattr).
access_vector(allow,netutils_t,locale_t,lnk_file,lock).
access_vector(allow,netutils_t,locale_t,lnk_file,ioctl).
access_vector(allow,netutils_t,fs_t,filesystem,getattr).
access_vector(allow,netutils_t,privfd,fd,use).
access_vector(allow,netutils_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,netutils_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,netutils_t,sysadm_tty_device_t,chr_file,getattr).
access_vector(allow,netutils_t,sysadm_tty_device_t,chr_file,lock).
access_vector(allow,netutils_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,netutils_t,sysadm_tty_device_t,chr_file,append).
access_vector(allow,netutils_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,netutils_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,netutils_t,sysadm_devpts_t,chr_file,getattr).
access_vector(allow,netutils_t,sysadm_devpts_t,chr_file,lock).
access_vector(allow,netutils_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,netutils_t,sysadm_devpts_t,chr_file,append).
type_decl(newrole_t,[],[domain,privrole,privowner,privlog,auth,privfd]).
role_decl(user_r,newrole_t).
role_decl(staff_r,newrole_t).
role_decl(sysadm_r,newrole_t).
access_vector(allow,newrole_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,newrole_t,self,dir,read).
access_vector(allow,newrole_t,self,dir,getattr).
access_vector(allow,newrole_t,self,dir,lock).
access_vector(allow,newrole_t,self,dir,search).
access_vector(allow,newrole_t,self,dir,ioctl).
access_vector(allow,newrole_t,self,file,read).
access_vector(allow,newrole_t,self,file,getattr).
access_vector(allow,newrole_t,self,file,lock).
access_vector(allow,newrole_t,self,file,ioctl).
access_vector(allow,newrole_t,self,lnk_file,read).
access_vector(allow,newrole_t,self,lnk_file,getattr).
access_vector(allow,newrole_t,self,lnk_file,lock).
access_vector(allow,newrole_t,self,lnk_file,ioctl).
access_vector(allow,newrole_t,self,sock_file,read).
access_vector(allow,newrole_t,self,sock_file,getattr).
access_vector(allow,newrole_t,self,sock_file,lock).
access_vector(allow,newrole_t,self,sock_file,ioctl).
access_vector(allow,newrole_t,self,fifo_file,read).
access_vector(allow,newrole_t,self,fifo_file,getattr).
access_vector(allow,newrole_t,self,fifo_file,lock).
access_vector(allow,newrole_t,self,fifo_file,ioctl).
access_vector(allow,newrole_t,self,fd,_).
access_vector(allow,newrole_t,self,fifo_file,ioctl).
access_vector(allow,newrole_t,self,fifo_file,read).
access_vector(allow,newrole_t,self,fifo_file,getattr).
access_vector(allow,newrole_t,self,fifo_file,lock).
access_vector(allow,newrole_t,self,fifo_file,write).
access_vector(allow,newrole_t,self,fifo_file,append).
access_vector(allow,newrole_t,self,unix_dgram_socket,create).
access_vector(allow,newrole_t,self,unix_dgram_socket,ioctl).
access_vector(allow,newrole_t,self,unix_dgram_socket,read).
access_vector(allow,newrole_t,self,unix_dgram_socket,getattr).
access_vector(allow,newrole_t,self,unix_dgram_socket,write).
access_vector(allow,newrole_t,self,unix_dgram_socket,setattr).
access_vector(allow,newrole_t,self,unix_dgram_socket,append).
access_vector(allow,newrole_t,self,unix_dgram_socket,bind).
access_vector(allow,newrole_t,self,unix_dgram_socket,connect).
access_vector(allow,newrole_t,self,unix_dgram_socket,getopt).
access_vector(allow,newrole_t,self,unix_dgram_socket,setopt).
access_vector(allow,newrole_t,self,unix_dgram_socket,shutdown).
access_vector(allow,newrole_t,self,unix_stream_socket,create).
access_vector(allow,newrole_t,self,unix_stream_socket,ioctl).
access_vector(allow,newrole_t,self,unix_stream_socket,read).
access_vector(allow,newrole_t,self,unix_stream_socket,getattr).
access_vector(allow,newrole_t,self,unix_stream_socket,write).
access_vector(allow,newrole_t,self,unix_stream_socket,setattr).
access_vector(allow,newrole_t,self,unix_stream_socket,append).
access_vector(allow,newrole_t,self,unix_stream_socket,bind).
access_vector(allow,newrole_t,self,unix_stream_socket,connect).
access_vector(allow,newrole_t,self,unix_stream_socket,getopt).
access_vector(allow,newrole_t,self,unix_stream_socket,setopt).
access_vector(allow,newrole_t,self,unix_stream_socket,shutdown).
access_vector(allow,newrole_t,self,unix_stream_socket,listen).
access_vector(allow,newrole_t,self,unix_stream_socket,accept).
access_vector(allow,newrole_t,self,unix_dgram_socket,sendto).
access_vector(allow,newrole_t,self,unix_stream_socket,connectto).
access_vector(allow,newrole_t,self,sem,associate).
access_vector(allow,newrole_t,self,sem,getattr).
access_vector(allow,newrole_t,self,sem,setattr).
access_vector(allow,newrole_t,self,sem,create).
access_vector(allow,newrole_t,self,sem,destroy).
access_vector(allow,newrole_t,self,sem,read).
access_vector(allow,newrole_t,self,sem,write).
access_vector(allow,newrole_t,self,sem,unix_read).
access_vector(allow,newrole_t,self,sem,unix_write).
access_vector(allow,newrole_t,self,msg,send).
access_vector(allow,newrole_t,self,msg,receive).
access_vector(allow,newrole_t,self,msgq,associate).
access_vector(allow,newrole_t,self,msgq,getattr).
access_vector(allow,newrole_t,self,msgq,setattr).
access_vector(allow,newrole_t,self,msgq,create).
access_vector(allow,newrole_t,self,msgq,destroy).
access_vector(allow,newrole_t,self,msgq,read).
access_vector(allow,newrole_t,self,msgq,write).
access_vector(allow,newrole_t,self,msgq,enqueue).
access_vector(allow,newrole_t,self,msgq,unix_read).
access_vector(allow,newrole_t,self,msgq,unix_write).
access_vector(allow,newrole_t,self,shm,associate).
access_vector(allow,newrole_t,self,shm,getattr).
access_vector(allow,newrole_t,self,shm,setattr).
access_vector(allow,newrole_t,self,shm,create).
access_vector(allow,newrole_t,self,shm,destroy).
access_vector(allow,newrole_t,self,shm,read).
access_vector(allow,newrole_t,self,shm,write).
access_vector(allow,newrole_t,self,shm,lock).
access_vector(allow,newrole_t,self,shm,unix_read).
access_vector(allow,newrole_t,self,shm,unix_write).
access_vector(allow,newrole_t,root_t,dir,read).
access_vector(allow,newrole_t,root_t,dir,getattr).
access_vector(allow,newrole_t,root_t,dir,lock).
access_vector(allow,newrole_t,root_t,dir,search).
access_vector(allow,newrole_t,root_t,dir,ioctl).
access_vector(allow,newrole_t,usr_t,dir,read).
access_vector(allow,newrole_t,usr_t,dir,getattr).
access_vector(allow,newrole_t,usr_t,dir,lock).
access_vector(allow,newrole_t,usr_t,dir,search).
access_vector(allow,newrole_t,usr_t,dir,ioctl).
access_vector(allow,newrole_t,lib_t,dir,read).
access_vector(allow,newrole_t,lib_t,dir,getattr).
access_vector(allow,newrole_t,lib_t,dir,lock).
access_vector(allow,newrole_t,lib_t,dir,search).
access_vector(allow,newrole_t,lib_t,dir,ioctl).
access_vector(allow,newrole_t,etc_t,dir,read).
access_vector(allow,newrole_t,etc_t,dir,getattr).
access_vector(allow,newrole_t,etc_t,dir,lock).
access_vector(allow,newrole_t,etc_t,dir,search).
access_vector(allow,newrole_t,etc_t,dir,ioctl).
access_vector(allow,newrole_t,lib_t,lnk_file,read).
access_vector(allow,newrole_t,lib_t,lnk_file,getattr).
access_vector(allow,newrole_t,lib_t,lnk_file,lock).
access_vector(allow,newrole_t,lib_t,lnk_file,ioctl).
access_vector(allow,newrole_t,ld_so_t,file,read).
access_vector(allow,newrole_t,ld_so_t,file,getattr).
access_vector(allow,newrole_t,ld_so_t,file,lock).
access_vector(allow,newrole_t,ld_so_t,file,execute).
access_vector(allow,newrole_t,ld_so_t,file,ioctl).
access_vector(allow,newrole_t,ld_so_t,file,execute_no_trans).
access_vector(allow,newrole_t,ld_so_t,lnk_file,read).
access_vector(allow,newrole_t,ld_so_t,lnk_file,getattr).
access_vector(allow,newrole_t,ld_so_t,lnk_file,lock).
access_vector(allow,newrole_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,newrole_t,shlib_t,file,read).
access_vector(allow,newrole_t,shlib_t,file,getattr).
access_vector(allow,newrole_t,shlib_t,file,lock).
access_vector(allow,newrole_t,shlib_t,file,execute).
access_vector(allow,newrole_t,shlib_t,file,ioctl).
access_vector(allow,newrole_t,shlib_t,lnk_file,read).
access_vector(allow,newrole_t,shlib_t,lnk_file,getattr).
access_vector(allow,newrole_t,shlib_t,lnk_file,lock).
access_vector(allow,newrole_t,shlib_t,lnk_file,ioctl).
access_vector(allow,newrole_t,ld_so_cache_t,file,read).
access_vector(allow,newrole_t,ld_so_cache_t,file,getattr).
access_vector(allow,newrole_t,ld_so_cache_t,file,lock).
access_vector(allow,newrole_t,ld_so_cache_t,file,ioctl).
access_vector(allow,newrole_t,device_t,dir,search).
access_vector(allow,newrole_t,null_device_t,chr_file,ioctl).
access_vector(allow,newrole_t,null_device_t,chr_file,read).
access_vector(allow,newrole_t,null_device_t,chr_file,getattr).
access_vector(allow,newrole_t,null_device_t,chr_file,lock).
access_vector(allow,newrole_t,null_device_t,chr_file,write).
access_vector(allow,newrole_t,null_device_t,chr_file,append).
access_vector(allow,newrole_t,etc_t,lnk_file,read).
access_vector(allow,newrole_t,locale_t,dir,read).
access_vector(allow,newrole_t,locale_t,dir,getattr).
access_vector(allow,newrole_t,locale_t,dir,lock).
access_vector(allow,newrole_t,locale_t,dir,search).
access_vector(allow,newrole_t,locale_t,dir,ioctl).
access_vector(allow,newrole_t,locale_t,file,read).
access_vector(allow,newrole_t,locale_t,file,getattr).
access_vector(allow,newrole_t,locale_t,file,lock).
access_vector(allow,newrole_t,locale_t,file,ioctl).
access_vector(allow,newrole_t,locale_t,lnk_file,read).
access_vector(allow,newrole_t,locale_t,lnk_file,getattr).
access_vector(allow,newrole_t,locale_t,lnk_file,lock).
access_vector(allow,newrole_t,locale_t,lnk_file,ioctl).
type_decl(newrole_exec_t,[],[file_type,exec_type,sysadmfile]).
access_vector(allow,userdomain,newrole_t,process,transition).
access_vector(dontaudit,userdomain,newrole_t,process,noatsecure).
access_vector(allow,userdomain,newrole_exec_t,file,read).
access_vector(allow,userdomain,newrole_exec_t,file,getattr).
access_vector(allow,userdomain,newrole_exec_t,file,execute).
access_vector(allow,newrole_t,userdomain,process,sigchld).
access_vector(allow,newrole_t,userdomain,fd,use).
access_vector(allow,userdomain,newrole_t,fd,use).
access_vector(allow,newrole_t,userdomain,fifo_file,ioctl).
access_vector(allow,newrole_t,userdomain,fifo_file,read).
access_vector(allow,newrole_t,userdomain,fifo_file,getattr).
access_vector(allow,newrole_t,userdomain,fifo_file,lock).
access_vector(allow,newrole_t,userdomain,fifo_file,write).
access_vector(allow,newrole_t,userdomain,fifo_file,append).
access_vector(allow,newrole_t,newrole_exec_t,file,read).
access_vector(allow,newrole_t,newrole_exec_t,file,getattr).
access_vector(allow,newrole_t,newrole_exec_t,file,lock).
access_vector(allow,newrole_t,newrole_exec_t,file,execute).
access_vector(allow,newrole_t,newrole_exec_t,file,ioctl).
access_vector(allow,newrole_t,newrole_exec_t,file,entrypoint).
type_trans(userdomain,newrole_exec_t,process,newrole_t).
access_vector(allow,newrole_t,shadow_t,file,read).
access_vector(allow,newrole_t,shadow_t,file,getattr).
access_vector(allow,newrole_t,privfd,fd,use).
access_vector(allow,newrole_t,sbin_t,dir,read).
access_vector(allow,newrole_t,sbin_t,dir,getattr).
access_vector(allow,newrole_t,sbin_t,dir,lock).
access_vector(allow,newrole_t,sbin_t,dir,search).
access_vector(allow,newrole_t,sbin_t,dir,ioctl).
access_vector(allow,newrole_t,chkpwd_exec_t,file,read).
access_vector(allow,newrole_t,chkpwd_exec_t,file,getattr).
access_vector(allow,newrole_t,chkpwd_exec_t,file,lock).
access_vector(allow,newrole_t,chkpwd_exec_t,file,execute).
access_vector(allow,newrole_t,chkpwd_exec_t,file,ioctl).
access_vector(allow,newrole_t,chkpwd_exec_t,file,execute_no_trans).
access_vector(allow,newrole_t,bin_t,dir,read).
access_vector(allow,newrole_t,bin_t,dir,getattr).
access_vector(allow,newrole_t,bin_t,dir,lock).
access_vector(allow,newrole_t,bin_t,dir,search).
access_vector(allow,newrole_t,bin_t,dir,ioctl).
access_vector(allow,newrole_t,bin_t,lnk_file,read).
access_vector(allow,newrole_t,shell_exec_t,file,read).
access_vector(allow,newrole_t,shell_exec_t,file,getattr).
access_vector(allow,newrole_t,shell_exec_t,file,lock).
access_vector(allow,newrole_t,shell_exec_t,file,ioctl).
access_vector(allow,newrole_t,userdomain,process,transition).
access_vector(dontaudit,newrole_t,userdomain,process,noatsecure).
access_vector(allow,newrole_t,shell_exec_t,file,read).
access_vector(allow,newrole_t,shell_exec_t,file,getattr).
access_vector(allow,newrole_t,shell_exec_t,file,execute).
access_vector(allow,userdomain,newrole_t,process,sigchld).
access_vector(allow,userdomain,newrole_t,fd,use).
access_vector(allow,newrole_t,userdomain,fd,use).
access_vector(allow,userdomain,newrole_t,fifo_file,ioctl).
access_vector(allow,userdomain,newrole_t,fifo_file,read).
access_vector(allow,userdomain,newrole_t,fifo_file,getattr).
access_vector(allow,userdomain,newrole_t,fifo_file,lock).
access_vector(allow,userdomain,newrole_t,fifo_file,write).
access_vector(allow,userdomain,newrole_t,fifo_file,append).
access_vector(allow,userdomain,shell_exec_t,file,entrypoint).
access_vector(allow,newrole_t,self,process,setexec).
access_vector(allow,newrole_t,proc_t,dir,search).
access_vector(allow,newrole_t,proc_t,lnk_file,read).
access_vector(allow,newrole_t,self,dir,search).
access_vector(allow,newrole_t,self,file,read).
access_vector(allow,newrole_t,self,file,write).
access_vector(allow,newrole_t,self,capability,setuid).
access_vector(allow,newrole_t,self,capability,setgid).
access_vector(allow,newrole_t,self,capability,net_bind_service).
access_vector(allow,newrole_t,self,capability,dac_override).
access_vector(allow,newrole_t,var_run_t,dir,read).
access_vector(allow,newrole_t,var_run_t,dir,getattr).
access_vector(allow,newrole_t,var_run_t,dir,lock).
access_vector(allow,newrole_t,var_run_t,dir,search).
access_vector(allow,newrole_t,var_run_t,dir,ioctl).
access_vector(allow,newrole_t,initrc_var_run_t,file,ioctl).
access_vector(allow,newrole_t,initrc_var_run_t,file,read).
access_vector(allow,newrole_t,initrc_var_run_t,file,getattr).
access_vector(allow,newrole_t,initrc_var_run_t,file,lock).
access_vector(allow,newrole_t,initrc_var_run_t,file,write).
access_vector(allow,newrole_t,initrc_var_run_t,file,append).
access_vector(allow,newrole_t,devpts_t,dir,read).
access_vector(allow,newrole_t,devpts_t,dir,getattr).
access_vector(allow,newrole_t,devpts_t,dir,lock).
access_vector(allow,newrole_t,devpts_t,dir,search).
access_vector(allow,newrole_t,devpts_t,dir,ioctl).
access_vector(allow,newrole_t,etc_t,file,read).
access_vector(allow,newrole_t,etc_t,file,getattr).
access_vector(allow,newrole_t,etc_t,file,lock).
access_vector(allow,newrole_t,etc_t,file,ioctl).
access_vector(allow,newrole_t,var_t,dir,read).
access_vector(allow,newrole_t,var_t,dir,getattr).
access_vector(allow,newrole_t,var_t,dir,lock).
access_vector(allow,newrole_t,var_t,dir,search).
access_vector(allow,newrole_t,var_t,dir,ioctl).
access_vector(allow,newrole_t,var_t,file,read).
access_vector(allow,newrole_t,var_t,file,getattr).
access_vector(allow,newrole_t,var_t,file,lock).
access_vector(allow,newrole_t,var_t,file,ioctl).
access_vector(allow,newrole_t,var_t,lnk_file,read).
access_vector(allow,newrole_t,var_t,lnk_file,getattr).
access_vector(allow,newrole_t,var_t,lnk_file,lock).
access_vector(allow,newrole_t,var_t,lnk_file,ioctl).
access_vector(allow,newrole_t,var_t,sock_file,read).
access_vector(allow,newrole_t,var_t,sock_file,getattr).
access_vector(allow,newrole_t,var_t,sock_file,lock).
access_vector(allow,newrole_t,var_t,sock_file,ioctl).
access_vector(allow,newrole_t,var_t,fifo_file,read).
access_vector(allow,newrole_t,var_t,fifo_file,getattr).
access_vector(allow,newrole_t,var_t,fifo_file,lock).
access_vector(allow,newrole_t,var_t,fifo_file,ioctl).
access_vector(allow,newrole_t,device_t,dir,read).
access_vector(allow,newrole_t,device_t,dir,getattr).
access_vector(allow,newrole_t,device_t,dir,lock).
access_vector(allow,newrole_t,device_t,dir,search).
access_vector(allow,newrole_t,device_t,dir,ioctl).
access_vector(allow,newrole_t,ttyfile,chr_file,relabelfrom).
access_vector(allow,newrole_t,ttyfile,chr_file,relabelto).
access_vector(allow,newrole_t,ptyfile,chr_file,relabelfrom).
access_vector(allow,newrole_t,ptyfile,chr_file,relabelto).
access_vector(allow,newrole_t,ttyfile,chr_file,ioctl).
access_vector(allow,newrole_t,ttyfile,chr_file,read).
access_vector(allow,newrole_t,ttyfile,chr_file,getattr).
access_vector(allow,newrole_t,ttyfile,chr_file,lock).
access_vector(allow,newrole_t,ttyfile,chr_file,write).
access_vector(allow,newrole_t,ttyfile,chr_file,append).
access_vector(allow,newrole_t,ptyfile,chr_file,ioctl).
access_vector(allow,newrole_t,ptyfile,chr_file,read).
access_vector(allow,newrole_t,ptyfile,chr_file,getattr).
access_vector(allow,newrole_t,ptyfile,chr_file,lock).
access_vector(allow,newrole_t,ptyfile,chr_file,write).
access_vector(allow,newrole_t,ptyfile,chr_file,append).
access_vector(allow,newrole_t,devtty_t,chr_file,ioctl).
access_vector(allow,newrole_t,devtty_t,chr_file,read).
access_vector(allow,newrole_t,devtty_t,chr_file,getattr).
access_vector(allow,newrole_t,devtty_t,chr_file,lock).
access_vector(allow,newrole_t,devtty_t,chr_file,write).
access_vector(allow,newrole_t,devtty_t,chr_file,append).
access_vector(allow,newrole_t,etc_t,lnk_file,read).
access_vector(allow,newrole_t,security_t,dir,read).
access_vector(allow,newrole_t,security_t,dir,search).
access_vector(allow,newrole_t,security_t,dir,getattr).
access_vector(allow,newrole_t,security_t,file,getattr).
access_vector(allow,newrole_t,security_t,file,read).
access_vector(allow,newrole_t,security_t,file,write).
access_vector(allow,newrole_t,security_t,security,check_context).
access_vector(allow,newrole_t,security_t,security,compute_av).
access_vector(allow,newrole_t,security_t,security,compute_create).
access_vector(allow,newrole_t,security_t,security,compute_relabel).
access_vector(allow,newrole_t,security_t,security,compute_user).
access_vector(allow,newrole_t,fs_t,filesystem,getattr).
access_vector(dontaudit,newrole_t,home_root_t,dir,search).
access_vector(dontaudit,newrole_t,home_type,dir,search).
access_vector(dontaudit,newrole_t,proc_t,dir,search).
access_vector(dontaudit,unpriv_userdomain,newrole_t,process,signal).
type_decl(passwd_t,[],[domain,privlog,auth,privowner]).
access_vector(allow,passwd_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,passwd_t,self,dir,read).
access_vector(allow,passwd_t,self,dir,getattr).
access_vector(allow,passwd_t,self,dir,lock).
access_vector(allow,passwd_t,self,dir,search).
access_vector(allow,passwd_t,self,dir,ioctl).
access_vector(allow,passwd_t,self,file,read).
access_vector(allow,passwd_t,self,file,getattr).
access_vector(allow,passwd_t,self,file,lock).
access_vector(allow,passwd_t,self,file,ioctl).
access_vector(allow,passwd_t,self,lnk_file,read).
access_vector(allow,passwd_t,self,lnk_file,getattr).
access_vector(allow,passwd_t,self,lnk_file,lock).
access_vector(allow,passwd_t,self,lnk_file,ioctl).
access_vector(allow,passwd_t,self,sock_file,read).
access_vector(allow,passwd_t,self,sock_file,getattr).
access_vector(allow,passwd_t,self,sock_file,lock).
access_vector(allow,passwd_t,self,sock_file,ioctl).
access_vector(allow,passwd_t,self,fifo_file,read).
access_vector(allow,passwd_t,self,fifo_file,getattr).
access_vector(allow,passwd_t,self,fifo_file,lock).
access_vector(allow,passwd_t,self,fifo_file,ioctl).
access_vector(allow,passwd_t,self,fd,_).
access_vector(allow,passwd_t,self,fifo_file,ioctl).
access_vector(allow,passwd_t,self,fifo_file,read).
access_vector(allow,passwd_t,self,fifo_file,getattr).
access_vector(allow,passwd_t,self,fifo_file,lock).
access_vector(allow,passwd_t,self,fifo_file,write).
access_vector(allow,passwd_t,self,fifo_file,append).
access_vector(allow,passwd_t,self,unix_dgram_socket,create).
access_vector(allow,passwd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,passwd_t,self,unix_dgram_socket,read).
access_vector(allow,passwd_t,self,unix_dgram_socket,getattr).
access_vector(allow,passwd_t,self,unix_dgram_socket,write).
access_vector(allow,passwd_t,self,unix_dgram_socket,setattr).
access_vector(allow,passwd_t,self,unix_dgram_socket,append).
access_vector(allow,passwd_t,self,unix_dgram_socket,bind).
access_vector(allow,passwd_t,self,unix_dgram_socket,connect).
access_vector(allow,passwd_t,self,unix_dgram_socket,getopt).
access_vector(allow,passwd_t,self,unix_dgram_socket,setopt).
access_vector(allow,passwd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,passwd_t,self,unix_stream_socket,create).
access_vector(allow,passwd_t,self,unix_stream_socket,ioctl).
access_vector(allow,passwd_t,self,unix_stream_socket,read).
access_vector(allow,passwd_t,self,unix_stream_socket,getattr).
access_vector(allow,passwd_t,self,unix_stream_socket,write).
access_vector(allow,passwd_t,self,unix_stream_socket,setattr).
access_vector(allow,passwd_t,self,unix_stream_socket,append).
access_vector(allow,passwd_t,self,unix_stream_socket,bind).
access_vector(allow,passwd_t,self,unix_stream_socket,connect).
access_vector(allow,passwd_t,self,unix_stream_socket,getopt).
access_vector(allow,passwd_t,self,unix_stream_socket,setopt).
access_vector(allow,passwd_t,self,unix_stream_socket,shutdown).
access_vector(allow,passwd_t,self,unix_stream_socket,listen).
access_vector(allow,passwd_t,self,unix_stream_socket,accept).
access_vector(allow,passwd_t,self,unix_dgram_socket,sendto).
access_vector(allow,passwd_t,self,unix_stream_socket,connectto).
access_vector(allow,passwd_t,self,sem,associate).
access_vector(allow,passwd_t,self,sem,getattr).
access_vector(allow,passwd_t,self,sem,setattr).
access_vector(allow,passwd_t,self,sem,create).
access_vector(allow,passwd_t,self,sem,destroy).
access_vector(allow,passwd_t,self,sem,read).
access_vector(allow,passwd_t,self,sem,write).
access_vector(allow,passwd_t,self,sem,unix_read).
access_vector(allow,passwd_t,self,sem,unix_write).
access_vector(allow,passwd_t,self,msg,send).
access_vector(allow,passwd_t,self,msg,receive).
access_vector(allow,passwd_t,self,msgq,associate).
access_vector(allow,passwd_t,self,msgq,getattr).
access_vector(allow,passwd_t,self,msgq,setattr).
access_vector(allow,passwd_t,self,msgq,create).
access_vector(allow,passwd_t,self,msgq,destroy).
access_vector(allow,passwd_t,self,msgq,read).
access_vector(allow,passwd_t,self,msgq,write).
access_vector(allow,passwd_t,self,msgq,enqueue).
access_vector(allow,passwd_t,self,msgq,unix_read).
access_vector(allow,passwd_t,self,msgq,unix_write).
access_vector(allow,passwd_t,self,shm,associate).
access_vector(allow,passwd_t,self,shm,getattr).
access_vector(allow,passwd_t,self,shm,setattr).
access_vector(allow,passwd_t,self,shm,create).
access_vector(allow,passwd_t,self,shm,destroy).
access_vector(allow,passwd_t,self,shm,read).
access_vector(allow,passwd_t,self,shm,write).
access_vector(allow,passwd_t,self,shm,lock).
access_vector(allow,passwd_t,self,shm,unix_read).
access_vector(allow,passwd_t,self,shm,unix_write).
access_vector(allow,passwd_t,root_t,dir,read).
access_vector(allow,passwd_t,root_t,dir,getattr).
access_vector(allow,passwd_t,root_t,dir,lock).
access_vector(allow,passwd_t,root_t,dir,search).
access_vector(allow,passwd_t,root_t,dir,ioctl).
access_vector(allow,passwd_t,usr_t,dir,read).
access_vector(allow,passwd_t,usr_t,dir,getattr).
access_vector(allow,passwd_t,usr_t,dir,lock).
access_vector(allow,passwd_t,usr_t,dir,search).
access_vector(allow,passwd_t,usr_t,dir,ioctl).
access_vector(allow,passwd_t,lib_t,dir,read).
access_vector(allow,passwd_t,lib_t,dir,getattr).
access_vector(allow,passwd_t,lib_t,dir,lock).
access_vector(allow,passwd_t,lib_t,dir,search).
access_vector(allow,passwd_t,lib_t,dir,ioctl).
access_vector(allow,passwd_t,etc_t,dir,read).
access_vector(allow,passwd_t,etc_t,dir,getattr).
access_vector(allow,passwd_t,etc_t,dir,lock).
access_vector(allow,passwd_t,etc_t,dir,search).
access_vector(allow,passwd_t,etc_t,dir,ioctl).
access_vector(allow,passwd_t,lib_t,lnk_file,read).
access_vector(allow,passwd_t,lib_t,lnk_file,getattr).
access_vector(allow,passwd_t,lib_t,lnk_file,lock).
access_vector(allow,passwd_t,lib_t,lnk_file,ioctl).
access_vector(allow,passwd_t,ld_so_t,file,read).
access_vector(allow,passwd_t,ld_so_t,file,getattr).
access_vector(allow,passwd_t,ld_so_t,file,lock).
access_vector(allow,passwd_t,ld_so_t,file,execute).
access_vector(allow,passwd_t,ld_so_t,file,ioctl).
access_vector(allow,passwd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,passwd_t,ld_so_t,lnk_file,read).
access_vector(allow,passwd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,passwd_t,ld_so_t,lnk_file,lock).
access_vector(allow,passwd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,passwd_t,shlib_t,file,read).
access_vector(allow,passwd_t,shlib_t,file,getattr).
access_vector(allow,passwd_t,shlib_t,file,lock).
access_vector(allow,passwd_t,shlib_t,file,execute).
access_vector(allow,passwd_t,shlib_t,file,ioctl).
access_vector(allow,passwd_t,shlib_t,lnk_file,read).
access_vector(allow,passwd_t,shlib_t,lnk_file,getattr).
access_vector(allow,passwd_t,shlib_t,lnk_file,lock).
access_vector(allow,passwd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,passwd_t,ld_so_cache_t,file,read).
access_vector(allow,passwd_t,ld_so_cache_t,file,getattr).
access_vector(allow,passwd_t,ld_so_cache_t,file,lock).
access_vector(allow,passwd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,passwd_t,device_t,dir,search).
access_vector(allow,passwd_t,null_device_t,chr_file,ioctl).
access_vector(allow,passwd_t,null_device_t,chr_file,read).
access_vector(allow,passwd_t,null_device_t,chr_file,getattr).
access_vector(allow,passwd_t,null_device_t,chr_file,lock).
access_vector(allow,passwd_t,null_device_t,chr_file,write).
access_vector(allow,passwd_t,null_device_t,chr_file,append).
access_vector(allow,passwd_t,privfd,fd,use).
access_vector(allow,passwd_t,etc_t,lnk_file,read).
access_vector(allow,passwd_t,locale_t,dir,read).
access_vector(allow,passwd_t,locale_t,dir,getattr).
access_vector(allow,passwd_t,locale_t,dir,lock).
access_vector(allow,passwd_t,locale_t,dir,search).
access_vector(allow,passwd_t,locale_t,dir,ioctl).
access_vector(allow,passwd_t,locale_t,file,read).
access_vector(allow,passwd_t,locale_t,file,getattr).
access_vector(allow,passwd_t,locale_t,file,lock).
access_vector(allow,passwd_t,locale_t,file,ioctl).
access_vector(allow,passwd_t,locale_t,lnk_file,read).
access_vector(allow,passwd_t,locale_t,lnk_file,getattr).
access_vector(allow,passwd_t,locale_t,lnk_file,lock).
access_vector(allow,passwd_t,locale_t,lnk_file,ioctl).
access_vector(allow,passwd_t,fs_t,filesystem,getattr).
access_vector(allow,passwd_t,shell_exec_t,file,execute).
access_vector(allow,passwd_t,security_t,dir,read).
access_vector(allow,passwd_t,security_t,dir,search).
access_vector(allow,passwd_t,security_t,dir,getattr).
access_vector(allow,passwd_t,security_t,file,getattr).
access_vector(allow,passwd_t,security_t,file,read).
access_vector(allow,passwd_t,security_t,file,write).
access_vector(allow,passwd_t,security_t,security,check_context).
access_vector(allow,passwd_t,security_t,security,compute_av).
access_vector(allow,passwd_t,security_t,security,compute_create).
access_vector(allow,passwd_t,security_t,security,compute_relabel).
access_vector(allow,passwd_t,security_t,security,compute_user).
access_vector(allow,passwd_t,etc_t,dir,read).
access_vector(allow,passwd_t,etc_t,dir,getattr).
access_vector(allow,passwd_t,etc_t,dir,lock).
access_vector(allow,passwd_t,etc_t,dir,search).
access_vector(allow,passwd_t,etc_t,dir,ioctl).
access_vector(allow,passwd_t,etc_t,dir,add_name).
access_vector(allow,passwd_t,etc_t,dir,remove_name).
access_vector(allow,passwd_t,etc_t,dir,write).
access_vector(allow,passwd_t,shadow_t,file,create).
access_vector(allow,passwd_t,shadow_t,file,ioctl).
access_vector(allow,passwd_t,shadow_t,file,read).
access_vector(allow,passwd_t,shadow_t,file,getattr).
access_vector(allow,passwd_t,shadow_t,file,lock).
access_vector(allow,passwd_t,shadow_t,file,write).
access_vector(allow,passwd_t,shadow_t,file,setattr).
access_vector(allow,passwd_t,shadow_t,file,append).
access_vector(allow,passwd_t,shadow_t,file,link).
access_vector(allow,passwd_t,shadow_t,file,unlink).
access_vector(allow,passwd_t,shadow_t,file,rename).
type_trans(passwd_t,etc_t,file,shadow_t).
access_vector(allow,passwd_t,etc_t,file,create).
access_vector(allow,passwd_t,etc_t,file,ioctl).
access_vector(allow,passwd_t,etc_t,file,read).
access_vector(allow,passwd_t,etc_t,file,getattr).
access_vector(allow,passwd_t,etc_t,file,lock).
access_vector(allow,passwd_t,etc_t,file,write).
access_vector(allow,passwd_t,etc_t,file,setattr).
access_vector(allow,passwd_t,etc_t,file,append).
access_vector(allow,passwd_t,etc_t,file,link).
access_vector(allow,passwd_t,etc_t,file,unlink).
access_vector(allow,passwd_t,etc_t,file,rename).
access_vector(allow,passwd_t,etc_t,file,relabelfrom).
access_vector(allow,passwd_t,etc_t,file,relabelto).
access_vector(allow,passwd_t,shadow_t,file,relabelfrom).
access_vector(allow,passwd_t,shadow_t,file,relabelto).
access_vector(allow,passwd_t,self,process,setfscreate).
access_vector(allow,passwd_t,proc_t,dir,search).
access_vector(allow,passwd_t,proc_t,lnk_file,read).
access_vector(allow,passwd_t,self,dir,search).
access_vector(allow,passwd_t,self,file,read).
access_vector(allow,passwd_t,self,file,write).
access_vector(allow,passwd_t,etc_t,lnk_file,read).
access_vector(allow,passwd_t,self,capability,chown).
access_vector(allow,passwd_t,self,capability,dac_override).
access_vector(allow,passwd_t,self,capability,fsetid).
access_vector(allow,passwd_t,self,capability,setuid).
access_vector(allow,passwd_t,self,capability,sys_resource).
access_vector(allow,passwd_t,ttyfile,chr_file,ioctl).
access_vector(allow,passwd_t,ttyfile,chr_file,read).
access_vector(allow,passwd_t,ttyfile,chr_file,getattr).
access_vector(allow,passwd_t,ttyfile,chr_file,lock).
access_vector(allow,passwd_t,ttyfile,chr_file,write).
access_vector(allow,passwd_t,ttyfile,chr_file,append).
access_vector(allow,passwd_t,ptyfile,chr_file,ioctl).
access_vector(allow,passwd_t,ptyfile,chr_file,read).
access_vector(allow,passwd_t,ptyfile,chr_file,getattr).
access_vector(allow,passwd_t,ptyfile,chr_file,lock).
access_vector(allow,passwd_t,ptyfile,chr_file,write).
access_vector(allow,passwd_t,ptyfile,chr_file,append).
access_vector(allow,passwd_t,devtty_t,chr_file,ioctl).
access_vector(allow,passwd_t,devtty_t,chr_file,read).
access_vector(allow,passwd_t,devtty_t,chr_file,getattr).
access_vector(allow,passwd_t,devtty_t,chr_file,lock).
access_vector(allow,passwd_t,devtty_t,chr_file,write).
access_vector(allow,passwd_t,devtty_t,chr_file,append).
access_vector(dontaudit,passwd_t,devpts_t,dir,getattr).
access_vector(dontaudit,passwd_t,initrc_var_run_t,file,read).
access_vector(dontaudit,passwd_t,initrc_var_run_t,file,write).
access_vector(dontaudit,passwd_t,user_home_dir_type,dir,search).
access_vector(dontaudit,passwd_t,user_home_type,dir,search).
access_vector(dontaudit,passwd_t,proc_t,dir,search).
access_vector(dontaudit,passwd_t,proc_t,dir,read).
access_vector(dontaudit,passwd_t,device_t,dir,search).
access_vector(dontaudit,passwd_t,device_t,dir,read).
access_vector(allow,passwd_t,device_t,dir,getattr).
type_decl(sysadm_passwd_t,[],[domain,privlog,auth,privowner]).
access_vector(allow,sysadm_passwd_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,sysadm_passwd_t,self,dir,read).
access_vector(allow,sysadm_passwd_t,self,dir,getattr).
access_vector(allow,sysadm_passwd_t,self,dir,lock).
access_vector(allow,sysadm_passwd_t,self,dir,search).
access_vector(allow,sysadm_passwd_t,self,dir,ioctl).
access_vector(allow,sysadm_passwd_t,self,file,read).
access_vector(allow,sysadm_passwd_t,self,file,getattr).
access_vector(allow,sysadm_passwd_t,self,file,lock).
access_vector(allow,sysadm_passwd_t,self,file,ioctl).
access_vector(allow,sysadm_passwd_t,self,lnk_file,read).
access_vector(allow,sysadm_passwd_t,self,lnk_file,getattr).
access_vector(allow,sysadm_passwd_t,self,lnk_file,lock).
access_vector(allow,sysadm_passwd_t,self,lnk_file,ioctl).
access_vector(allow,sysadm_passwd_t,self,sock_file,read).
access_vector(allow,sysadm_passwd_t,self,sock_file,getattr).
access_vector(allow,sysadm_passwd_t,self,sock_file,lock).
access_vector(allow,sysadm_passwd_t,self,sock_file,ioctl).
access_vector(allow,sysadm_passwd_t,self,fifo_file,read).
access_vector(allow,sysadm_passwd_t,self,fifo_file,getattr).
access_vector(allow,sysadm_passwd_t,self,fifo_file,lock).
access_vector(allow,sysadm_passwd_t,self,fifo_file,ioctl).
access_vector(allow,sysadm_passwd_t,self,fd,_).
access_vector(allow,sysadm_passwd_t,self,fifo_file,ioctl).
access_vector(allow,sysadm_passwd_t,self,fifo_file,read).
access_vector(allow,sysadm_passwd_t,self,fifo_file,getattr).
access_vector(allow,sysadm_passwd_t,self,fifo_file,lock).
access_vector(allow,sysadm_passwd_t,self,fifo_file,write).
access_vector(allow,sysadm_passwd_t,self,fifo_file,append).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,create).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,read).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,getattr).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,write).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,setattr).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,append).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,bind).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,connect).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,getopt).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,setopt).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,create).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,ioctl).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,read).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,getattr).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,write).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,setattr).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,append).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,bind).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,connect).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,getopt).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,setopt).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,shutdown).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,listen).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,accept).
access_vector(allow,sysadm_passwd_t,self,unix_dgram_socket,sendto).
access_vector(allow,sysadm_passwd_t,self,unix_stream_socket,connectto).
access_vector(allow,sysadm_passwd_t,self,sem,associate).
access_vector(allow,sysadm_passwd_t,self,sem,getattr).
access_vector(allow,sysadm_passwd_t,self,sem,setattr).
access_vector(allow,sysadm_passwd_t,self,sem,create).
access_vector(allow,sysadm_passwd_t,self,sem,destroy).
access_vector(allow,sysadm_passwd_t,self,sem,read).
access_vector(allow,sysadm_passwd_t,self,sem,write).
access_vector(allow,sysadm_passwd_t,self,sem,unix_read).
access_vector(allow,sysadm_passwd_t,self,sem,unix_write).
access_vector(allow,sysadm_passwd_t,self,msg,send).
access_vector(allow,sysadm_passwd_t,self,msg,receive).
access_vector(allow,sysadm_passwd_t,self,msgq,associate).
access_vector(allow,sysadm_passwd_t,self,msgq,getattr).
access_vector(allow,sysadm_passwd_t,self,msgq,setattr).
access_vector(allow,sysadm_passwd_t,self,msgq,create).
access_vector(allow,sysadm_passwd_t,self,msgq,destroy).
access_vector(allow,sysadm_passwd_t,self,msgq,read).
access_vector(allow,sysadm_passwd_t,self,msgq,write).
access_vector(allow,sysadm_passwd_t,self,msgq,enqueue).
access_vector(allow,sysadm_passwd_t,self,msgq,unix_read).
access_vector(allow,sysadm_passwd_t,self,msgq,unix_write).
access_vector(allow,sysadm_passwd_t,self,shm,associate).
access_vector(allow,sysadm_passwd_t,self,shm,getattr).
access_vector(allow,sysadm_passwd_t,self,shm,setattr).
access_vector(allow,sysadm_passwd_t,self,shm,create).
access_vector(allow,sysadm_passwd_t,self,shm,destroy).
access_vector(allow,sysadm_passwd_t,self,shm,read).
access_vector(allow,sysadm_passwd_t,self,shm,write).
access_vector(allow,sysadm_passwd_t,self,shm,lock).
access_vector(allow,sysadm_passwd_t,self,shm,unix_read).
access_vector(allow,sysadm_passwd_t,self,shm,unix_write).
access_vector(allow,sysadm_passwd_t,root_t,dir,read).
access_vector(allow,sysadm_passwd_t,root_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,root_t,dir,lock).
access_vector(allow,sysadm_passwd_t,root_t,dir,search).
access_vector(allow,sysadm_passwd_t,root_t,dir,ioctl).
access_vector(allow,sysadm_passwd_t,usr_t,dir,read).
access_vector(allow,sysadm_passwd_t,usr_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,usr_t,dir,lock).
access_vector(allow,sysadm_passwd_t,usr_t,dir,search).
access_vector(allow,sysadm_passwd_t,usr_t,dir,ioctl).
access_vector(allow,sysadm_passwd_t,lib_t,dir,read).
access_vector(allow,sysadm_passwd_t,lib_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,lib_t,dir,lock).
access_vector(allow,sysadm_passwd_t,lib_t,dir,search).
access_vector(allow,sysadm_passwd_t,lib_t,dir,ioctl).
access_vector(allow,sysadm_passwd_t,etc_t,dir,read).
access_vector(allow,sysadm_passwd_t,etc_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,etc_t,dir,lock).
access_vector(allow,sysadm_passwd_t,etc_t,dir,search).
access_vector(allow,sysadm_passwd_t,etc_t,dir,ioctl).
access_vector(allow,sysadm_passwd_t,lib_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,lib_t,lnk_file,getattr).
access_vector(allow,sysadm_passwd_t,lib_t,lnk_file,lock).
access_vector(allow,sysadm_passwd_t,lib_t,lnk_file,ioctl).
access_vector(allow,sysadm_passwd_t,ld_so_t,file,read).
access_vector(allow,sysadm_passwd_t,ld_so_t,file,getattr).
access_vector(allow,sysadm_passwd_t,ld_so_t,file,lock).
access_vector(allow,sysadm_passwd_t,ld_so_t,file,execute).
access_vector(allow,sysadm_passwd_t,ld_so_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sysadm_passwd_t,ld_so_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sysadm_passwd_t,ld_so_t,lnk_file,lock).
access_vector(allow,sysadm_passwd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sysadm_passwd_t,shlib_t,file,read).
access_vector(allow,sysadm_passwd_t,shlib_t,file,getattr).
access_vector(allow,sysadm_passwd_t,shlib_t,file,lock).
access_vector(allow,sysadm_passwd_t,shlib_t,file,execute).
access_vector(allow,sysadm_passwd_t,shlib_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,shlib_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,shlib_t,lnk_file,getattr).
access_vector(allow,sysadm_passwd_t,shlib_t,lnk_file,lock).
access_vector(allow,sysadm_passwd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sysadm_passwd_t,ld_so_cache_t,file,read).
access_vector(allow,sysadm_passwd_t,ld_so_cache_t,file,getattr).
access_vector(allow,sysadm_passwd_t,ld_so_cache_t,file,lock).
access_vector(allow,sysadm_passwd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,device_t,dir,search).
access_vector(allow,sysadm_passwd_t,null_device_t,chr_file,ioctl).
access_vector(allow,sysadm_passwd_t,null_device_t,chr_file,read).
access_vector(allow,sysadm_passwd_t,null_device_t,chr_file,getattr).
access_vector(allow,sysadm_passwd_t,null_device_t,chr_file,lock).
access_vector(allow,sysadm_passwd_t,null_device_t,chr_file,write).
access_vector(allow,sysadm_passwd_t,null_device_t,chr_file,append).
access_vector(allow,sysadm_passwd_t,privfd,fd,use).
access_vector(allow,sysadm_passwd_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,locale_t,dir,read).
access_vector(allow,sysadm_passwd_t,locale_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,locale_t,dir,lock).
access_vector(allow,sysadm_passwd_t,locale_t,dir,search).
access_vector(allow,sysadm_passwd_t,locale_t,dir,ioctl).
access_vector(allow,sysadm_passwd_t,locale_t,file,read).
access_vector(allow,sysadm_passwd_t,locale_t,file,getattr).
access_vector(allow,sysadm_passwd_t,locale_t,file,lock).
access_vector(allow,sysadm_passwd_t,locale_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,locale_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,locale_t,lnk_file,getattr).
access_vector(allow,sysadm_passwd_t,locale_t,lnk_file,lock).
access_vector(allow,sysadm_passwd_t,locale_t,lnk_file,ioctl).
access_vector(allow,sysadm_passwd_t,fs_t,filesystem,getattr).
access_vector(allow,sysadm_passwd_t,shell_exec_t,file,execute).
access_vector(allow,sysadm_passwd_t,security_t,dir,read).
access_vector(allow,sysadm_passwd_t,security_t,dir,search).
access_vector(allow,sysadm_passwd_t,security_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,security_t,file,getattr).
access_vector(allow,sysadm_passwd_t,security_t,file,read).
access_vector(allow,sysadm_passwd_t,security_t,file,write).
access_vector(allow,sysadm_passwd_t,security_t,security,check_context).
access_vector(allow,sysadm_passwd_t,security_t,security,compute_av).
access_vector(allow,sysadm_passwd_t,security_t,security,compute_create).
access_vector(allow,sysadm_passwd_t,security_t,security,compute_relabel).
access_vector(allow,sysadm_passwd_t,security_t,security,compute_user).
access_vector(allow,sysadm_passwd_t,etc_t,dir,read).
access_vector(allow,sysadm_passwd_t,etc_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,etc_t,dir,lock).
access_vector(allow,sysadm_passwd_t,etc_t,dir,search).
access_vector(allow,sysadm_passwd_t,etc_t,dir,ioctl).
access_vector(allow,sysadm_passwd_t,etc_t,dir,add_name).
access_vector(allow,sysadm_passwd_t,etc_t,dir,remove_name).
access_vector(allow,sysadm_passwd_t,etc_t,dir,write).
access_vector(allow,sysadm_passwd_t,shadow_t,file,create).
access_vector(allow,sysadm_passwd_t,shadow_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,shadow_t,file,read).
access_vector(allow,sysadm_passwd_t,shadow_t,file,getattr).
access_vector(allow,sysadm_passwd_t,shadow_t,file,lock).
access_vector(allow,sysadm_passwd_t,shadow_t,file,write).
access_vector(allow,sysadm_passwd_t,shadow_t,file,setattr).
access_vector(allow,sysadm_passwd_t,shadow_t,file,append).
access_vector(allow,sysadm_passwd_t,shadow_t,file,link).
access_vector(allow,sysadm_passwd_t,shadow_t,file,unlink).
access_vector(allow,sysadm_passwd_t,shadow_t,file,rename).
type_trans(sysadm_passwd_t,etc_t,file,shadow_t).
access_vector(allow,sysadm_passwd_t,etc_t,file,create).
access_vector(allow,sysadm_passwd_t,etc_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,etc_t,file,read).
access_vector(allow,sysadm_passwd_t,etc_t,file,getattr).
access_vector(allow,sysadm_passwd_t,etc_t,file,lock).
access_vector(allow,sysadm_passwd_t,etc_t,file,write).
access_vector(allow,sysadm_passwd_t,etc_t,file,setattr).
access_vector(allow,sysadm_passwd_t,etc_t,file,append).
access_vector(allow,sysadm_passwd_t,etc_t,file,link).
access_vector(allow,sysadm_passwd_t,etc_t,file,unlink).
access_vector(allow,sysadm_passwd_t,etc_t,file,rename).
access_vector(allow,sysadm_passwd_t,etc_t,file,relabelfrom).
access_vector(allow,sysadm_passwd_t,etc_t,file,relabelto).
access_vector(allow,sysadm_passwd_t,shadow_t,file,relabelfrom).
access_vector(allow,sysadm_passwd_t,shadow_t,file,relabelto).
access_vector(allow,sysadm_passwd_t,self,process,setfscreate).
access_vector(allow,sysadm_passwd_t,proc_t,dir,search).
access_vector(allow,sysadm_passwd_t,proc_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,self,dir,search).
access_vector(allow,sysadm_passwd_t,self,file,read).
access_vector(allow,sysadm_passwd_t,self,file,write).
access_vector(allow,sysadm_passwd_t,etc_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,self,capability,chown).
access_vector(allow,sysadm_passwd_t,self,capability,dac_override).
access_vector(allow,sysadm_passwd_t,self,capability,fsetid).
access_vector(allow,sysadm_passwd_t,self,capability,setuid).
access_vector(allow,sysadm_passwd_t,self,capability,sys_resource).
access_vector(allow,sysadm_passwd_t,ttyfile,chr_file,ioctl).
access_vector(allow,sysadm_passwd_t,ttyfile,chr_file,read).
access_vector(allow,sysadm_passwd_t,ttyfile,chr_file,getattr).
access_vector(allow,sysadm_passwd_t,ttyfile,chr_file,lock).
access_vector(allow,sysadm_passwd_t,ttyfile,chr_file,write).
access_vector(allow,sysadm_passwd_t,ttyfile,chr_file,append).
access_vector(allow,sysadm_passwd_t,ptyfile,chr_file,ioctl).
access_vector(allow,sysadm_passwd_t,ptyfile,chr_file,read).
access_vector(allow,sysadm_passwd_t,ptyfile,chr_file,getattr).
access_vector(allow,sysadm_passwd_t,ptyfile,chr_file,lock).
access_vector(allow,sysadm_passwd_t,ptyfile,chr_file,write).
access_vector(allow,sysadm_passwd_t,ptyfile,chr_file,append).
access_vector(allow,sysadm_passwd_t,devtty_t,chr_file,ioctl).
access_vector(allow,sysadm_passwd_t,devtty_t,chr_file,read).
access_vector(allow,sysadm_passwd_t,devtty_t,chr_file,getattr).
access_vector(allow,sysadm_passwd_t,devtty_t,chr_file,lock).
access_vector(allow,sysadm_passwd_t,devtty_t,chr_file,write).
access_vector(allow,sysadm_passwd_t,devtty_t,chr_file,append).
access_vector(dontaudit,sysadm_passwd_t,devpts_t,dir,getattr).
access_vector(dontaudit,sysadm_passwd_t,initrc_var_run_t,file,read).
access_vector(dontaudit,sysadm_passwd_t,initrc_var_run_t,file,write).
access_vector(dontaudit,sysadm_passwd_t,user_home_dir_type,dir,search).
access_vector(dontaudit,sysadm_passwd_t,user_home_type,dir,search).
access_vector(dontaudit,sysadm_passwd_t,proc_t,dir,search).
access_vector(dontaudit,sysadm_passwd_t,proc_t,dir,read).
access_vector(dontaudit,sysadm_passwd_t,device_t,dir,search).
access_vector(dontaudit,sysadm_passwd_t,device_t,dir,read).
access_vector(allow,sysadm_passwd_t,device_t,dir,getattr).
role_decl(user_r,passwd_t).
role_decl(staff_r,passwd_t).
role_decl(sysadm_r,passwd_t).
role_decl(sysadm_r,sysadm_passwd_t).
type_decl(admin_passwd_exec_t,[],[file_type,sysadmfile]).
type_decl(passwd_exec_t,[],[file_type,sysadmfile,exec_type]).
access_vector(allow,userdomain,passwd_t,process,transition).
access_vector(dontaudit,userdomain,passwd_t,process,noatsecure).
access_vector(allow,userdomain,passwd_exec_t,file,read).
access_vector(allow,userdomain,passwd_exec_t,file,getattr).
access_vector(allow,userdomain,passwd_exec_t,file,execute).
access_vector(allow,passwd_t,userdomain,process,sigchld).
access_vector(allow,passwd_t,userdomain,fd,use).
access_vector(allow,userdomain,passwd_t,fd,use).
access_vector(allow,passwd_t,userdomain,fifo_file,ioctl).
access_vector(allow,passwd_t,userdomain,fifo_file,read).
access_vector(allow,passwd_t,userdomain,fifo_file,getattr).
access_vector(allow,passwd_t,userdomain,fifo_file,lock).
access_vector(allow,passwd_t,userdomain,fifo_file,write).
access_vector(allow,passwd_t,userdomain,fifo_file,append).
access_vector(allow,passwd_t,passwd_exec_t,file,read).
access_vector(allow,passwd_t,passwd_exec_t,file,getattr).
access_vector(allow,passwd_t,passwd_exec_t,file,lock).
access_vector(allow,passwd_t,passwd_exec_t,file,execute).
access_vector(allow,passwd_t,passwd_exec_t,file,ioctl).
access_vector(allow,passwd_t,passwd_exec_t,file,entrypoint).
type_trans(userdomain,passwd_exec_t,process,passwd_t).
access_vector(allow,sysadm_t,sysadm_passwd_t,process,transition).
access_vector(dontaudit,sysadm_t,sysadm_passwd_t,process,noatsecure).
access_vector(allow,sysadm_t,admin_passwd_exec_t,file,read).
access_vector(allow,sysadm_t,admin_passwd_exec_t,file,getattr).
access_vector(allow,sysadm_t,admin_passwd_exec_t,file,execute).
access_vector(allow,sysadm_passwd_t,sysadm_t,process,sigchld).
access_vector(allow,sysadm_passwd_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,sysadm_passwd_t,fd,use).
access_vector(allow,sysadm_passwd_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,sysadm_passwd_t,sysadm_t,fifo_file,read).
access_vector(allow,sysadm_passwd_t,sysadm_t,fifo_file,getattr).
access_vector(allow,sysadm_passwd_t,sysadm_t,fifo_file,lock).
access_vector(allow,sysadm_passwd_t,sysadm_t,fifo_file,write).
access_vector(allow,sysadm_passwd_t,sysadm_t,fifo_file,append).
access_vector(allow,sysadm_passwd_t,admin_passwd_exec_t,file,read).
access_vector(allow,sysadm_passwd_t,admin_passwd_exec_t,file,getattr).
access_vector(allow,sysadm_passwd_t,admin_passwd_exec_t,file,lock).
access_vector(allow,sysadm_passwd_t,admin_passwd_exec_t,file,execute).
access_vector(allow,sysadm_passwd_t,admin_passwd_exec_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,admin_passwd_exec_t,file,entrypoint).
type_trans(sysadm_t,admin_passwd_exec_t,process,sysadm_passwd_t).
access_vector(dontaudit,passwd_t,var_t,dir,search).
access_vector(allow,sysadm_passwd_t,root_t,dir,search).
access_vector(allow,sysadm_passwd_t,usr_t,dir,search).
access_vector(allow,sysadm_passwd_t,bin_t,dir,search).
access_vector(allow,sysadm_passwd_t,bin_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,bin_t,file,read).
access_vector(allow,sysadm_passwd_t,bin_t,file,getattr).
access_vector(allow,sysadm_passwd_t,bin_t,file,lock).
access_vector(allow,sysadm_passwd_t,bin_t,file,execute).
access_vector(allow,sysadm_passwd_t,bin_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,bin_t,file,execute_no_trans).
access_vector(allow,sysadm_passwd_t,var_t,dir,search).
type_decl(sysadm_passwd_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,sysadm_passwd_t,tmp_t,dir,read).
access_vector(allow,sysadm_passwd_t,tmp_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,tmp_t,dir,lock).
access_vector(allow,sysadm_passwd_t,tmp_t,dir,search).
access_vector(allow,sysadm_passwd_t,tmp_t,dir,ioctl).
access_vector(allow,sysadm_passwd_t,tmp_t,dir,add_name).
access_vector(allow,sysadm_passwd_t,tmp_t,dir,remove_name).
access_vector(allow,sysadm_passwd_t,tmp_t,dir,write).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,create).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,ioctl).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,read).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,getattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,lock).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,write).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,setattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,append).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,link).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,unlink).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,file,rename).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,create).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,ioctl).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,read).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,getattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,lock).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,write).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,setattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,append).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,link).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,unlink).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,lnk_file,rename).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,create).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,ioctl).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,read).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,getattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,lock).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,write).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,setattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,append).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,link).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,unlink).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,sock_file,rename).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,create).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,ioctl).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,read).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,getattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,lock).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,write).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,setattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,append).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,link).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,unlink).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,fifo_file,rename).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,create).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,read).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,getattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,lock).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,setattr).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,link).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,unlink).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,rename).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,search).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,add_name).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,remove_name).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,reparent).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,write).
access_vector(allow,sysadm_passwd_t,sysadm_passwd_tmp_t,dir,rmdir).
type_trans(sysadm_passwd_t,tmp_t,dir,sysadm_passwd_tmp_t).
type_trans(sysadm_passwd_t,tmp_t,[file,lnk_file,sock_file,fifo_file],sysadm_passwd_tmp_t).
access_vector(dontaudit,sysadm_passwd_t,sysadm_home_dir_t,dir,getattr).
access_vector(dontaudit,sysadm_passwd_t,sysadm_home_dir_t,dir,search).
access_vector(allow,sysadm_passwd_t,etc_t,lnk_file,read).
access_vector(dontaudit,sysadm_passwd_t,var_run_t,dir,search).
access_vector(allow,passwd_t,user_t,dir,search).
access_vector(allow,passwd_t,user_t,file,read).
access_vector(allow,passwd_t,user_t,process,getattr).
type_decl(setfiles_t,[],[domain,privlog,privowner]).
type_decl(setfiles_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(system_r,setfiles_t).
role_decl(sysadm_r,setfiles_t).
access_vector(allow,setfiles_t,initrc_devpts_t,chr_file,read).
access_vector(allow,setfiles_t,initrc_devpts_t,chr_file,write).
access_vector(allow,setfiles_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,setfiles_t,sysadm_tty_device_t,chr_file,read).
access_vector(allow,setfiles_t,sysadm_tty_device_t,chr_file,write).
access_vector(allow,setfiles_t,sysadm_tty_device_t,chr_file,ioctl).
access_vector(allow,setfiles_t,sysadm_devpts_t,chr_file,read).
access_vector(allow,setfiles_t,sysadm_devpts_t,chr_file,write).
access_vector(allow,setfiles_t,sysadm_devpts_t,chr_file,ioctl).
access_vector(allow,initrc_t,setfiles_t,process,transition).
access_vector(allow,sysadm_t,setfiles_t,process,transition).
access_vector(dontaudit,initrc_t,setfiles_t,process,noatsecure).
access_vector(dontaudit,sysadm_t,setfiles_t,process,noatsecure).
access_vector(allow,initrc_t,setfiles_exec_t,file,read).
access_vector(allow,initrc_t,setfiles_exec_t,file,getattr).
access_vector(allow,initrc_t,setfiles_exec_t,file,execute).
access_vector(allow,sysadm_t,setfiles_exec_t,file,read).
access_vector(allow,sysadm_t,setfiles_exec_t,file,getattr).
access_vector(allow,sysadm_t,setfiles_exec_t,file,execute).
access_vector(allow,setfiles_t,initrc_t,process,sigchld).
access_vector(allow,setfiles_t,sysadm_t,process,sigchld).
access_vector(allow,setfiles_t,initrc_t,fd,use).
access_vector(allow,setfiles_t,sysadm_t,fd,use).
access_vector(allow,initrc_t,setfiles_t,fd,use).
access_vector(allow,sysadm_t,setfiles_t,fd,use).
access_vector(allow,setfiles_t,initrc_t,fifo_file,ioctl).
access_vector(allow,setfiles_t,initrc_t,fifo_file,read).
access_vector(allow,setfiles_t,initrc_t,fifo_file,getattr).
access_vector(allow,setfiles_t,initrc_t,fifo_file,lock).
access_vector(allow,setfiles_t,initrc_t,fifo_file,write).
access_vector(allow,setfiles_t,initrc_t,fifo_file,append).
access_vector(allow,setfiles_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,setfiles_t,sysadm_t,fifo_file,read).
access_vector(allow,setfiles_t,sysadm_t,fifo_file,getattr).
access_vector(allow,setfiles_t,sysadm_t,fifo_file,lock).
access_vector(allow,setfiles_t,sysadm_t,fifo_file,write).
access_vector(allow,setfiles_t,sysadm_t,fifo_file,append).
access_vector(allow,setfiles_t,setfiles_exec_t,file,entrypoint).
type_trans([initrc_t,sysadm_t],setfiles_exec_t,process,setfiles_t).
access_vector(allow,setfiles_t,init_t,fd,use).
access_vector(allow,setfiles_t,privfd,fd,use).
access_vector(allow,setfiles_t,root_t,dir,read).
access_vector(allow,setfiles_t,root_t,dir,getattr).
access_vector(allow,setfiles_t,root_t,dir,lock).
access_vector(allow,setfiles_t,root_t,dir,search).
access_vector(allow,setfiles_t,root_t,dir,ioctl).
access_vector(allow,setfiles_t,usr_t,dir,read).
access_vector(allow,setfiles_t,usr_t,dir,getattr).
access_vector(allow,setfiles_t,usr_t,dir,lock).
access_vector(allow,setfiles_t,usr_t,dir,search).
access_vector(allow,setfiles_t,usr_t,dir,ioctl).
access_vector(allow,setfiles_t,lib_t,dir,read).
access_vector(allow,setfiles_t,lib_t,dir,getattr).
access_vector(allow,setfiles_t,lib_t,dir,lock).
access_vector(allow,setfiles_t,lib_t,dir,search).
access_vector(allow,setfiles_t,lib_t,dir,ioctl).
access_vector(allow,setfiles_t,etc_t,dir,read).
access_vector(allow,setfiles_t,etc_t,dir,getattr).
access_vector(allow,setfiles_t,etc_t,dir,lock).
access_vector(allow,setfiles_t,etc_t,dir,search).
access_vector(allow,setfiles_t,etc_t,dir,ioctl).
access_vector(allow,setfiles_t,lib_t,lnk_file,read).
access_vector(allow,setfiles_t,lib_t,lnk_file,getattr).
access_vector(allow,setfiles_t,lib_t,lnk_file,lock).
access_vector(allow,setfiles_t,lib_t,lnk_file,ioctl).
access_vector(allow,setfiles_t,ld_so_t,file,read).
access_vector(allow,setfiles_t,ld_so_t,file,getattr).
access_vector(allow,setfiles_t,ld_so_t,file,lock).
access_vector(allow,setfiles_t,ld_so_t,file,execute).
access_vector(allow,setfiles_t,ld_so_t,file,ioctl).
access_vector(allow,setfiles_t,ld_so_t,file,execute_no_trans).
access_vector(allow,setfiles_t,ld_so_t,lnk_file,read).
access_vector(allow,setfiles_t,ld_so_t,lnk_file,getattr).
access_vector(allow,setfiles_t,ld_so_t,lnk_file,lock).
access_vector(allow,setfiles_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,setfiles_t,shlib_t,file,read).
access_vector(allow,setfiles_t,shlib_t,file,getattr).
access_vector(allow,setfiles_t,shlib_t,file,lock).
access_vector(allow,setfiles_t,shlib_t,file,execute).
access_vector(allow,setfiles_t,shlib_t,file,ioctl).
access_vector(allow,setfiles_t,shlib_t,lnk_file,read).
access_vector(allow,setfiles_t,shlib_t,lnk_file,getattr).
access_vector(allow,setfiles_t,shlib_t,lnk_file,lock).
access_vector(allow,setfiles_t,shlib_t,lnk_file,ioctl).
access_vector(allow,setfiles_t,ld_so_cache_t,file,read).
access_vector(allow,setfiles_t,ld_so_cache_t,file,getattr).
access_vector(allow,setfiles_t,ld_so_cache_t,file,lock).
access_vector(allow,setfiles_t,ld_so_cache_t,file,ioctl).
access_vector(allow,setfiles_t,device_t,dir,search).
access_vector(allow,setfiles_t,null_device_t,chr_file,ioctl).
access_vector(allow,setfiles_t,null_device_t,chr_file,read).
access_vector(allow,setfiles_t,null_device_t,chr_file,getattr).
access_vector(allow,setfiles_t,null_device_t,chr_file,lock).
access_vector(allow,setfiles_t,null_device_t,chr_file,write).
access_vector(allow,setfiles_t,null_device_t,chr_file,append).
access_vector(allow,setfiles_t,self,capability,dac_override).
access_vector(allow,setfiles_t,self,capability,dac_read_search).
access_vector(allow,setfiles_t,lib_t,file,execute).
access_vector(allow,setfiles_t,security_t,dir,read).
access_vector(allow,setfiles_t,security_t,dir,search).
access_vector(allow,setfiles_t,security_t,dir,getattr).
access_vector(allow,setfiles_t,security_t,file,getattr).
access_vector(allow,setfiles_t,security_t,file,read).
access_vector(allow,setfiles_t,security_t,file,write).
access_vector(allow,setfiles_t,security_t,security,check_context).
access_vector(allow,setfiles_t,security_t,security,compute_av).
access_vector(allow,setfiles_t,security_t,security,compute_create).
access_vector(allow,setfiles_t,security_t,security,compute_relabel).
access_vector(allow,setfiles_t,security_t,security,compute_user).
access_vector(allow,setfiles_t,policy_src_t,file,read).
access_vector(allow,setfiles_t,policy_src_t,file,getattr).
access_vector(allow,setfiles_t,policy_src_t,file,lock).
access_vector(allow,setfiles_t,policy_src_t,file,ioctl).
access_vector(allow,setfiles_t,file_type,dir,read).
access_vector(allow,setfiles_t,file_type,dir,getattr).
access_vector(allow,setfiles_t,file_type,dir,lock).
access_vector(allow,setfiles_t,file_type,dir,search).
access_vector(allow,setfiles_t,file_type,dir,ioctl).
access_vector(allow,setfiles_t,file_type,lnk_file,read).
access_vector(allow,setfiles_t,file_type,lnk_file,getattr).
access_vector(allow,setfiles_t,file_type,lnk_file,lock).
access_vector(allow,setfiles_t,file_type,lnk_file,ioctl).
access_vector(allow,setfiles_t,file_type,dir,getattr).
access_vector(allow,setfiles_t,file_type,dir,relabelfrom).
access_vector(allow,setfiles_t,file_type,dir,relabelto).
access_vector(allow,setfiles_t,file_type,file,getattr).
access_vector(allow,setfiles_t,file_type,file,relabelfrom).
access_vector(allow,setfiles_t,file_type,file,relabelto).
access_vector(allow,setfiles_t,file_type,lnk_file,getattr).
access_vector(allow,setfiles_t,file_type,lnk_file,relabelfrom).
access_vector(allow,setfiles_t,file_type,lnk_file,relabelto).
access_vector(allow,setfiles_t,file_type,sock_file,getattr).
access_vector(allow,setfiles_t,file_type,sock_file,relabelfrom).
access_vector(allow,setfiles_t,file_type,sock_file,relabelto).
access_vector(allow,setfiles_t,file_type,fifo_file,getattr).
access_vector(allow,setfiles_t,file_type,fifo_file,relabelfrom).
access_vector(allow,setfiles_t,file_type,fifo_file,relabelto).
access_vector(allow,setfiles_t,file_type,chr_file,getattr).
access_vector(allow,setfiles_t,file_type,chr_file,relabelfrom).
access_vector(allow,setfiles_t,file_type,chr_file,relabelto).
access_vector(allow,setfiles_t,file_type,blk_file,getattr).
access_vector(allow,setfiles_t,file_type,blk_file,relabelfrom).
access_vector(allow,setfiles_t,file_type,blk_file,relabelto).
access_vector(allow,setfiles_t,file_labels_t,dir,read).
access_vector(allow,setfiles_t,file_labels_t,dir,getattr).
access_vector(allow,setfiles_t,file_labels_t,dir,lock).
access_vector(allow,setfiles_t,file_labels_t,dir,search).
access_vector(allow,setfiles_t,file_labels_t,dir,ioctl).
access_vector(allow,setfiles_t,file_labels_t,dir,add_name).
access_vector(allow,setfiles_t,file_labels_t,dir,remove_name).
access_vector(allow,setfiles_t,file_labels_t,dir,write).
access_vector(allow,setfiles_t,file_labels_t,file,create).
access_vector(allow,setfiles_t,file_labels_t,file,ioctl).
access_vector(allow,setfiles_t,file_labels_t,file,read).
access_vector(allow,setfiles_t,file_labels_t,file,getattr).
access_vector(allow,setfiles_t,file_labels_t,file,lock).
access_vector(allow,setfiles_t,file_labels_t,file,write).
access_vector(allow,setfiles_t,file_labels_t,file,setattr).
access_vector(allow,setfiles_t,file_labels_t,file,append).
access_vector(allow,setfiles_t,file_labels_t,file,link).
access_vector(allow,setfiles_t,file_labels_t,file,unlink).
access_vector(allow,setfiles_t,file_labels_t,file,rename).
access_vector(allow,setfiles_t,fs_t,filesystem,getattr).
access_vector(allow,setfiles_t,fs_type,dir,read).
access_vector(allow,setfiles_t,fs_type,dir,getattr).
access_vector(allow,setfiles_t,fs_type,dir,lock).
access_vector(allow,setfiles_t,fs_type,dir,search).
access_vector(allow,setfiles_t,fs_type,dir,ioctl).
access_vector(allow,setfiles_t,etc_runtime_t,file,read).
access_vector(allow,setfiles_t,etc_t,file,read).
access_vector(allow,setfiles_t,proc_t,file,getattr).
access_vector(allow,setfiles_t,proc_t,file,read).
access_vector(allow,setfiles_t,home_type,file,read).
access_vector(allow,setfiles_t,home_type,file,getattr).
access_vector(allow,setfiles_t,home_type,file,lock).
access_vector(allow,setfiles_t,home_type,file,ioctl).
type_decl(ssh_port_t,[],[port_type]).
type_decl(sshd_t,[],[domain,privuser,privrole,privlog,privowner,privfd,auth]).
role_decl(system_r,sshd_t).
access_vector(allow,sshd_t,root_t,dir,read).
access_vector(allow,sshd_t,root_t,dir,getattr).
access_vector(allow,sshd_t,root_t,dir,lock).
access_vector(allow,sshd_t,root_t,dir,search).
access_vector(allow,sshd_t,root_t,dir,ioctl).
access_vector(allow,sshd_t,usr_t,dir,read).
access_vector(allow,sshd_t,usr_t,dir,getattr).
access_vector(allow,sshd_t,usr_t,dir,lock).
access_vector(allow,sshd_t,usr_t,dir,search).
access_vector(allow,sshd_t,usr_t,dir,ioctl).
access_vector(allow,sshd_t,lib_t,dir,read).
access_vector(allow,sshd_t,lib_t,dir,getattr).
access_vector(allow,sshd_t,lib_t,dir,lock).
access_vector(allow,sshd_t,lib_t,dir,search).
access_vector(allow,sshd_t,lib_t,dir,ioctl).
access_vector(allow,sshd_t,etc_t,dir,read).
access_vector(allow,sshd_t,etc_t,dir,getattr).
access_vector(allow,sshd_t,etc_t,dir,lock).
access_vector(allow,sshd_t,etc_t,dir,search).
access_vector(allow,sshd_t,etc_t,dir,ioctl).
access_vector(allow,sshd_t,lib_t,lnk_file,read).
access_vector(allow,sshd_t,lib_t,lnk_file,getattr).
access_vector(allow,sshd_t,lib_t,lnk_file,lock).
access_vector(allow,sshd_t,lib_t,lnk_file,ioctl).
access_vector(allow,sshd_t,ld_so_t,file,read).
access_vector(allow,sshd_t,ld_so_t,file,getattr).
access_vector(allow,sshd_t,ld_so_t,file,lock).
access_vector(allow,sshd_t,ld_so_t,file,execute).
access_vector(allow,sshd_t,ld_so_t,file,ioctl).
access_vector(allow,sshd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sshd_t,ld_so_t,lnk_file,read).
access_vector(allow,sshd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sshd_t,ld_so_t,lnk_file,lock).
access_vector(allow,sshd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sshd_t,shlib_t,file,read).
access_vector(allow,sshd_t,shlib_t,file,getattr).
access_vector(allow,sshd_t,shlib_t,file,lock).
access_vector(allow,sshd_t,shlib_t,file,execute).
access_vector(allow,sshd_t,shlib_t,file,ioctl).
access_vector(allow,sshd_t,shlib_t,lnk_file,read).
access_vector(allow,sshd_t,shlib_t,lnk_file,getattr).
access_vector(allow,sshd_t,shlib_t,lnk_file,lock).
access_vector(allow,sshd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sshd_t,ld_so_cache_t,file,read).
access_vector(allow,sshd_t,ld_so_cache_t,file,getattr).
access_vector(allow,sshd_t,ld_so_cache_t,file,lock).
access_vector(allow,sshd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sshd_t,device_t,dir,search).
access_vector(allow,sshd_t,null_device_t,chr_file,ioctl).
access_vector(allow,sshd_t,null_device_t,chr_file,read).
access_vector(allow,sshd_t,null_device_t,chr_file,getattr).
access_vector(allow,sshd_t,null_device_t,chr_file,lock).
access_vector(allow,sshd_t,null_device_t,chr_file,write).
access_vector(allow,sshd_t,null_device_t,chr_file,append).
access_vector(allow,sshd_t,self,unix_dgram_socket,create).
access_vector(allow,sshd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,sshd_t,self,unix_dgram_socket,read).
access_vector(allow,sshd_t,self,unix_dgram_socket,getattr).
access_vector(allow,sshd_t,self,unix_dgram_socket,write).
access_vector(allow,sshd_t,self,unix_dgram_socket,setattr).
access_vector(allow,sshd_t,self,unix_dgram_socket,append).
access_vector(allow,sshd_t,self,unix_dgram_socket,bind).
access_vector(allow,sshd_t,self,unix_dgram_socket,connect).
access_vector(allow,sshd_t,self,unix_dgram_socket,getopt).
access_vector(allow,sshd_t,self,unix_dgram_socket,setopt).
access_vector(allow,sshd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,sshd_t,self,unix_stream_socket,create).
access_vector(allow,sshd_t,self,unix_stream_socket,ioctl).
access_vector(allow,sshd_t,self,unix_stream_socket,read).
access_vector(allow,sshd_t,self,unix_stream_socket,getattr).
access_vector(allow,sshd_t,self,unix_stream_socket,write).
access_vector(allow,sshd_t,self,unix_stream_socket,setattr).
access_vector(allow,sshd_t,self,unix_stream_socket,append).
access_vector(allow,sshd_t,self,unix_stream_socket,bind).
access_vector(allow,sshd_t,self,unix_stream_socket,connect).
access_vector(allow,sshd_t,self,unix_stream_socket,getopt).
access_vector(allow,sshd_t,self,unix_stream_socket,setopt).
access_vector(allow,sshd_t,self,unix_stream_socket,shutdown).
access_vector(allow,sshd_t,self,unix_stream_socket,listen).
access_vector(allow,sshd_t,self,unix_stream_socket,accept).
access_vector(allow,sshd_t,self,fifo_file,ioctl).
access_vector(allow,sshd_t,self,fifo_file,read).
access_vector(allow,sshd_t,self,fifo_file,getattr).
access_vector(allow,sshd_t,self,fifo_file,lock).
access_vector(allow,sshd_t,self,fifo_file,write).
access_vector(allow,sshd_t,self,fifo_file,append).
access_vector(allow,sshd_t,self,process,fork).
access_vector(allow,sshd_t,self,process,sigchld).
access_vector(allow,sshd_t,self,process,setsched).
access_vector(allow,sshd_t,proc_t,dir,read).
access_vector(allow,sshd_t,proc_t,dir,getattr).
access_vector(allow,sshd_t,proc_t,dir,lock).
access_vector(allow,sshd_t,proc_t,dir,search).
access_vector(allow,sshd_t,proc_t,dir,ioctl).
access_vector(allow,sshd_t,proc_t,file,read).
access_vector(allow,sshd_t,proc_t,file,getattr).
access_vector(allow,sshd_t,proc_t,file,lock).
access_vector(allow,sshd_t,proc_t,file,ioctl).
access_vector(allow,sshd_t,proc_t,lnk_file,read).
access_vector(allow,sshd_t,proc_t,lnk_file,getattr).
access_vector(allow,sshd_t,proc_t,lnk_file,lock).
access_vector(allow,sshd_t,proc_t,lnk_file,ioctl).
access_vector(allow,sshd_t,proc_t,sock_file,read).
access_vector(allow,sshd_t,proc_t,sock_file,getattr).
access_vector(allow,sshd_t,proc_t,sock_file,lock).
access_vector(allow,sshd_t,proc_t,sock_file,ioctl).
access_vector(allow,sshd_t,proc_t,fifo_file,read).
access_vector(allow,sshd_t,proc_t,fifo_file,getattr).
access_vector(allow,sshd_t,proc_t,fifo_file,lock).
access_vector(allow,sshd_t,proc_t,fifo_file,ioctl).
access_vector(allow,sshd_t,self,dir,search).
access_vector(allow,sshd_t,self,lnk_file,read).
access_vector(allow,sshd_t,fs_type,filesystem,getattr).
access_vector(allow,sshd_t,root_t,file,read).
access_vector(allow,sshd_t,root_t,file,getattr).
access_vector(allow,sshd_t,root_t,file,lock).
access_vector(allow,sshd_t,root_t,file,ioctl).
access_vector(allow,sshd_t,root_t,lnk_file,read).
access_vector(allow,sshd_t,root_t,lnk_file,getattr).
access_vector(allow,sshd_t,root_t,lnk_file,lock).
access_vector(allow,sshd_t,root_t,lnk_file,ioctl).
access_vector(allow,sshd_t,root_t,sock_file,read).
access_vector(allow,sshd_t,root_t,sock_file,getattr).
access_vector(allow,sshd_t,root_t,sock_file,lock).
access_vector(allow,sshd_t,root_t,sock_file,ioctl).
access_vector(allow,sshd_t,root_t,fifo_file,read).
access_vector(allow,sshd_t,root_t,fifo_file,getattr).
access_vector(allow,sshd_t,root_t,fifo_file,lock).
access_vector(allow,sshd_t,root_t,fifo_file,ioctl).
access_vector(allow,sshd_t,home_root_t,dir,read).
access_vector(allow,sshd_t,home_root_t,dir,getattr).
access_vector(allow,sshd_t,home_root_t,dir,lock).
access_vector(allow,sshd_t,home_root_t,dir,search).
access_vector(allow,sshd_t,home_root_t,dir,ioctl).
access_vector(allow,sshd_t,usr_t,file,read).
access_vector(allow,sshd_t,usr_t,file,getattr).
access_vector(allow,sshd_t,usr_t,file,lock).
access_vector(allow,sshd_t,usr_t,file,ioctl).
access_vector(allow,sshd_t,usr_t,lnk_file,read).
access_vector(allow,sshd_t,usr_t,lnk_file,getattr).
access_vector(allow,sshd_t,usr_t,lnk_file,lock).
access_vector(allow,sshd_t,usr_t,lnk_file,ioctl).
access_vector(allow,sshd_t,usr_t,sock_file,read).
access_vector(allow,sshd_t,usr_t,sock_file,getattr).
access_vector(allow,sshd_t,usr_t,sock_file,lock).
access_vector(allow,sshd_t,usr_t,sock_file,ioctl).
access_vector(allow,sshd_t,usr_t,fifo_file,read).
access_vector(allow,sshd_t,usr_t,fifo_file,getattr).
access_vector(allow,sshd_t,usr_t,fifo_file,lock).
access_vector(allow,sshd_t,usr_t,fifo_file,ioctl).
access_vector(allow,sshd_t,bin_t,dir,read).
access_vector(allow,sshd_t,bin_t,dir,getattr).
access_vector(allow,sshd_t,bin_t,dir,lock).
access_vector(allow,sshd_t,bin_t,dir,search).
access_vector(allow,sshd_t,bin_t,dir,ioctl).
access_vector(allow,sshd_t,bin_t,file,read).
access_vector(allow,sshd_t,bin_t,file,getattr).
access_vector(allow,sshd_t,bin_t,file,lock).
access_vector(allow,sshd_t,bin_t,file,ioctl).
access_vector(allow,sshd_t,bin_t,lnk_file,read).
access_vector(allow,sshd_t,bin_t,lnk_file,getattr).
access_vector(allow,sshd_t,bin_t,lnk_file,lock).
access_vector(allow,sshd_t,bin_t,lnk_file,ioctl).
access_vector(allow,sshd_t,bin_t,sock_file,read).
access_vector(allow,sshd_t,bin_t,sock_file,getattr).
access_vector(allow,sshd_t,bin_t,sock_file,lock).
access_vector(allow,sshd_t,bin_t,sock_file,ioctl).
access_vector(allow,sshd_t,bin_t,fifo_file,read).
access_vector(allow,sshd_t,bin_t,fifo_file,getattr).
access_vector(allow,sshd_t,bin_t,fifo_file,lock).
access_vector(allow,sshd_t,bin_t,fifo_file,ioctl).
access_vector(allow,sshd_t,sbin_t,dir,read).
access_vector(allow,sshd_t,sbin_t,dir,getattr).
access_vector(allow,sshd_t,sbin_t,dir,lock).
access_vector(allow,sshd_t,sbin_t,dir,search).
access_vector(allow,sshd_t,sbin_t,dir,ioctl).
access_vector(allow,sshd_t,sbin_t,file,read).
access_vector(allow,sshd_t,sbin_t,file,getattr).
access_vector(allow,sshd_t,sbin_t,file,lock).
access_vector(allow,sshd_t,sbin_t,file,ioctl).
access_vector(allow,sshd_t,sbin_t,lnk_file,read).
access_vector(allow,sshd_t,sbin_t,lnk_file,getattr).
access_vector(allow,sshd_t,sbin_t,lnk_file,lock).
access_vector(allow,sshd_t,sbin_t,lnk_file,ioctl).
access_vector(allow,sshd_t,sbin_t,sock_file,read).
access_vector(allow,sshd_t,sbin_t,sock_file,getattr).
access_vector(allow,sshd_t,sbin_t,sock_file,lock).
access_vector(allow,sshd_t,sbin_t,sock_file,ioctl).
access_vector(allow,sshd_t,sbin_t,fifo_file,read).
access_vector(allow,sshd_t,sbin_t,fifo_file,getattr).
access_vector(allow,sshd_t,sbin_t,fifo_file,lock).
access_vector(allow,sshd_t,sbin_t,fifo_file,ioctl).
access_vector(allow,sshd_t,var_t,dir,search).
access_vector(allow,sshd_t,var_log_t,dir,search).
access_vector(allow,sshd_t,etc_t,file,read).
access_vector(allow,sshd_t,etc_t,file,getattr).
access_vector(allow,sshd_t,etc_t,file,lock).
access_vector(allow,sshd_t,etc_t,file,ioctl).
access_vector(allow,sshd_t,etc_t,lnk_file,read).
access_vector(allow,sshd_t,etc_t,lnk_file,getattr).
access_vector(allow,sshd_t,etc_t,lnk_file,lock).
access_vector(allow,sshd_t,etc_t,lnk_file,ioctl).
access_vector(allow,sshd_t,etc_t,sock_file,read).
access_vector(allow,sshd_t,etc_t,sock_file,getattr).
access_vector(allow,sshd_t,etc_t,sock_file,lock).
access_vector(allow,sshd_t,etc_t,sock_file,ioctl).
access_vector(allow,sshd_t,etc_t,fifo_file,read).
access_vector(allow,sshd_t,etc_t,fifo_file,getattr).
access_vector(allow,sshd_t,etc_t,fifo_file,lock).
access_vector(allow,sshd_t,etc_t,fifo_file,ioctl).
access_vector(allow,sshd_t,etc_runtime_t,file,read).
access_vector(allow,sshd_t,etc_runtime_t,file,getattr).
access_vector(allow,sshd_t,etc_runtime_t,file,lock).
access_vector(allow,sshd_t,etc_runtime_t,file,ioctl).
access_vector(allow,sshd_t,etc_runtime_t,lnk_file,read).
access_vector(allow,sshd_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,sshd_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,sshd_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,sshd_t,resolv_conf_t,file,read).
access_vector(allow,sshd_t,resolv_conf_t,file,getattr).
access_vector(allow,sshd_t,resolv_conf_t,file,lock).
access_vector(allow,sshd_t,resolv_conf_t,file,ioctl).
access_vector(allow,sshd_t,resolv_conf_t,lnk_file,read).
access_vector(allow,sshd_t,resolv_conf_t,lnk_file,getattr).
access_vector(allow,sshd_t,resolv_conf_t,lnk_file,lock).
access_vector(allow,sshd_t,resolv_conf_t,lnk_file,ioctl).
access_vector(allow,sshd_t,ld_so_t,file,read).
access_vector(allow,sshd_t,ld_so_t,file,getattr).
access_vector(allow,sshd_t,ld_so_t,file,lock).
access_vector(allow,sshd_t,shlib_t,file,read).
access_vector(allow,sshd_t,shlib_t,file,getattr).
access_vector(allow,sshd_t,shlib_t,file,lock).
access_vector(allow,sshd_t,exec_type,file,read).
access_vector(allow,sshd_t,exec_type,file,getattr).
access_vector(allow,sshd_t,exec_type,file,lock).
access_vector(allow,sshd_t,exec_type,file,ioctl).
access_vector(allow,sshd_t,exec_type,lnk_file,read).
access_vector(allow,sshd_t,exec_type,lnk_file,getattr).
access_vector(allow,sshd_t,exec_type,lnk_file,lock).
access_vector(allow,sshd_t,exec_type,lnk_file,ioctl).
access_vector(allow,sshd_t,devtty_t,chr_file,ioctl).
access_vector(allow,sshd_t,devtty_t,chr_file,read).
access_vector(allow,sshd_t,devtty_t,chr_file,getattr).
access_vector(allow,sshd_t,devtty_t,chr_file,lock).
access_vector(allow,sshd_t,devtty_t,chr_file,write).
access_vector(allow,sshd_t,devtty_t,chr_file,append).
access_vector(allow,sshd_t,zero_device_t,chr_file,ioctl).
access_vector(allow,sshd_t,zero_device_t,chr_file,read).
access_vector(allow,sshd_t,zero_device_t,chr_file,getattr).
access_vector(allow,sshd_t,zero_device_t,chr_file,lock).
access_vector(allow,sshd_t,zero_device_t,chr_file,write).
access_vector(allow,sshd_t,zero_device_t,chr_file,append).
access_vector(allow,sshd_t,random_device_t,chr_file,read).
access_vector(allow,sshd_t,random_device_t,chr_file,getattr).
access_vector(allow,sshd_t,random_device_t,chr_file,lock).
access_vector(allow,sshd_t,random_device_t,chr_file,ioctl).
access_vector(allow,sshd_t,self,udp_socket,create).
access_vector(allow,sshd_t,self,udp_socket,ioctl).
access_vector(allow,sshd_t,self,udp_socket,read).
access_vector(allow,sshd_t,self,udp_socket,getattr).
access_vector(allow,sshd_t,self,udp_socket,write).
access_vector(allow,sshd_t,self,udp_socket,setattr).
access_vector(allow,sshd_t,self,udp_socket,append).
access_vector(allow,sshd_t,self,udp_socket,bind).
access_vector(allow,sshd_t,self,udp_socket,connect).
access_vector(allow,sshd_t,self,udp_socket,getopt).
access_vector(allow,sshd_t,self,udp_socket,setopt).
access_vector(allow,sshd_t,self,udp_socket,shutdown).
access_vector(allow,sshd_t,self,tcp_socket,create).
access_vector(allow,sshd_t,self,tcp_socket,ioctl).
access_vector(allow,sshd_t,self,tcp_socket,read).
access_vector(allow,sshd_t,self,tcp_socket,getattr).
access_vector(allow,sshd_t,self,tcp_socket,write).
access_vector(allow,sshd_t,self,tcp_socket,setattr).
access_vector(allow,sshd_t,self,tcp_socket,append).
access_vector(allow,sshd_t,self,tcp_socket,bind).
access_vector(allow,sshd_t,self,tcp_socket,connect).
access_vector(allow,sshd_t,self,tcp_socket,getopt).
access_vector(allow,sshd_t,self,tcp_socket,setopt).
access_vector(allow,sshd_t,self,tcp_socket,shutdown).
access_vector(allow,sshd_t,self,tcp_socket,listen).
access_vector(allow,sshd_t,self,tcp_socket,accept).
access_vector(allow,sshd_t,any_socket_t,udp_socket,sendto).
access_vector(allow,sshd_t,netif_type,netif,tcp_send).
access_vector(allow,sshd_t,netif_type,netif,udp_send).
access_vector(allow,sshd_t,netif_type,netif,rawip_send).
access_vector(allow,sshd_t,netif_type,netif,tcp_recv).
access_vector(allow,sshd_t,netif_type,netif,udp_recv).
access_vector(allow,sshd_t,netif_type,netif,rawip_recv).
access_vector(allow,sshd_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,sshd_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,sshd_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,sshd_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,sshd_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,sshd_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,sshd_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,sshd_t,node_type,node,tcp_send).
access_vector(allow,sshd_t,node_type,node,udp_send).
access_vector(allow,sshd_t,node_type,node,rawip_send).
access_vector(allow,sshd_t,node_type,node,tcp_recv).
access_vector(allow,sshd_t,node_type,node,udp_recv).
access_vector(allow,sshd_t,node_type,node,rawip_recv).
access_vector(allow,sshd_t,mount_t,udp_socket,ioctl).
access_vector(allow,sshd_t,mount_t,udp_socket,read).
access_vector(allow,sshd_t,mount_t,udp_socket,getattr).
access_vector(allow,sshd_t,mount_t,udp_socket,write).
access_vector(allow,sshd_t,mount_t,udp_socket,setattr).
access_vector(allow,sshd_t,mount_t,udp_socket,append).
access_vector(allow,sshd_t,mount_t,udp_socket,bind).
access_vector(allow,sshd_t,mount_t,udp_socket,connect).
access_vector(allow,sshd_t,mount_t,udp_socket,getopt).
access_vector(allow,sshd_t,mount_t,udp_socket,setopt).
access_vector(allow,sshd_t,mount_t,udp_socket,shutdown).
access_vector(allow,sshd_t,port_t,udp_socket,name_bind).
access_vector(allow,sshd_t,port_t,tcp_socket,name_bind).
access_vector(allow,sshd_t,self,capability,chown).
access_vector(allow,sshd_t,self,capability,dac_override).
access_vector(allow,sshd_t,self,capability,fowner).
access_vector(allow,sshd_t,self,capability,fsetid).
access_vector(allow,sshd_t,self,capability,setgid).
access_vector(allow,sshd_t,self,capability,setuid).
access_vector(allow,sshd_t,self,capability,net_bind_service).
access_vector(allow,sshd_t,self,capability,sys_tty_config).
access_vector(allow,sshd_t,shadow_t,file,read).
access_vector(allow,sshd_t,shadow_t,file,getattr).
access_vector(allow,sshd_t,home_root_t,dir,search).
access_vector(allow,sshd_t,home_root_t,dir,getattr).
access_vector(allow,sshd_t,user_home_dir_type,dir,search).
access_vector(allow,sshd_t,user_home_dir_type,dir,getattr).
access_vector(allow,sshd_t,sysadm_home_dir_t,dir,search).
access_vector(allow,sshd_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,sshd_t,user_t,process,transition).
access_vector(dontaudit,sshd_t,user_t,process,noatsecure).
access_vector(allow,sshd_t,shell_exec_t,file,read).
access_vector(allow,sshd_t,shell_exec_t,file,getattr).
access_vector(allow,sshd_t,shell_exec_t,file,execute).
access_vector(allow,user_t,sshd_t,process,sigchld).
access_vector(allow,user_t,sshd_t,fd,use).
access_vector(allow,sshd_t,user_t,fd,use).
access_vector(allow,user_t,sshd_t,fifo_file,ioctl).
access_vector(allow,user_t,sshd_t,fifo_file,read).
access_vector(allow,user_t,sshd_t,fifo_file,getattr).
access_vector(allow,user_t,sshd_t,fifo_file,lock).
access_vector(allow,user_t,sshd_t,fifo_file,write).
access_vector(allow,user_t,sshd_t,fifo_file,append).
access_vector(allow,user_t,shell_exec_t,file,entrypoint).
type_trans(sshd_t,shell_exec_t,process,user_t).
access_vector(allow,sshd_t,unpriv_userdomain,process,transition).
access_vector(dontaudit,sshd_t,unpriv_userdomain,process,noatsecure).
access_vector(allow,unpriv_userdomain,sshd_t,process,sigchld).
access_vector(allow,unpriv_userdomain,sshd_t,fd,use).
access_vector(allow,sshd_t,unpriv_userdomain,fd,use).
access_vector(allow,unpriv_userdomain,sshd_t,fifo_file,ioctl).
access_vector(allow,unpriv_userdomain,sshd_t,fifo_file,read).
access_vector(allow,unpriv_userdomain,sshd_t,fifo_file,getattr).
access_vector(allow,unpriv_userdomain,sshd_t,fifo_file,lock).
access_vector(allow,unpriv_userdomain,sshd_t,fifo_file,write).
access_vector(allow,unpriv_userdomain,sshd_t,fifo_file,append).
access_vector(allow,unpriv_userdomain,shell_exec_t,file,entrypoint).
access_vector(allow,sshd_t,self,process,setexec).
access_vector(allow,sshd_t,proc_t,dir,search).
access_vector(allow,sshd_t,proc_t,lnk_file,read).
access_vector(allow,sshd_t,self,dir,search).
access_vector(allow,sshd_t,self,file,read).
access_vector(allow,sshd_t,self,file,write).
access_vector(allow,sshd_t,initrc_var_run_t,file,ioctl).
access_vector(allow,sshd_t,initrc_var_run_t,file,read).
access_vector(allow,sshd_t,initrc_var_run_t,file,getattr).
access_vector(allow,sshd_t,initrc_var_run_t,file,lock).
access_vector(allow,sshd_t,initrc_var_run_t,file,write).
access_vector(allow,sshd_t,initrc_var_run_t,file,append).
access_vector(allow,sshd_t,wtmp_t,file,ioctl).
access_vector(allow,sshd_t,wtmp_t,file,read).
access_vector(allow,sshd_t,wtmp_t,file,getattr).
access_vector(allow,sshd_t,wtmp_t,file,lock).
access_vector(allow,sshd_t,wtmp_t,file,write).
access_vector(allow,sshd_t,wtmp_t,file,append).
access_vector(allow,sshd_t,security_t,dir,read).
access_vector(allow,sshd_t,security_t,dir,search).
access_vector(allow,sshd_t,security_t,dir,getattr).
access_vector(allow,sshd_t,security_t,file,getattr).
access_vector(allow,sshd_t,security_t,file,read).
access_vector(allow,sshd_t,security_t,file,write).
access_vector(allow,sshd_t,security_t,security,check_context).
access_vector(allow,sshd_t,security_t,security,compute_av).
access_vector(allow,sshd_t,security_t,security,compute_create).
access_vector(allow,sshd_t,security_t,security,compute_relabel).
access_vector(allow,sshd_t,security_t,security,compute_user).
access_vector(allow,sshd_t,default_context_t,file,read).
access_vector(allow,sshd_t,default_context_t,file,getattr).
access_vector(allow,sshd_t,default_context_t,file,lock).
access_vector(allow,sshd_t,default_context_t,file,ioctl).
type_decl(sshd_exec_t,[],[file_type,exec_type,sysadmfile]).
access_vector(allow,initrc_t,sshd_t,process,transition).
access_vector(dontaudit,initrc_t,sshd_t,process,noatsecure).
access_vector(allow,initrc_t,sshd_exec_t,file,read).
access_vector(allow,initrc_t,sshd_exec_t,file,getattr).
access_vector(allow,initrc_t,sshd_exec_t,file,execute).
access_vector(allow,sshd_t,initrc_t,process,sigchld).
access_vector(allow,sshd_t,initrc_t,fd,use).
access_vector(allow,initrc_t,sshd_t,fd,use).
access_vector(allow,sshd_t,initrc_t,fifo_file,ioctl).
access_vector(allow,sshd_t,initrc_t,fifo_file,read).
access_vector(allow,sshd_t,initrc_t,fifo_file,getattr).
access_vector(allow,sshd_t,initrc_t,fifo_file,lock).
access_vector(allow,sshd_t,initrc_t,fifo_file,write).
access_vector(allow,sshd_t,initrc_t,fifo_file,append).
access_vector(allow,sshd_t,sshd_exec_t,file,read).
access_vector(allow,sshd_t,sshd_exec_t,file,getattr).
access_vector(allow,sshd_t,sshd_exec_t,file,lock).
access_vector(allow,sshd_t,sshd_exec_t,file,execute).
access_vector(allow,sshd_t,sshd_exec_t,file,ioctl).
access_vector(allow,sshd_t,sshd_exec_t,file,entrypoint).
type_trans(initrc_t,sshd_exec_t,process,sshd_t).
access_vector(allow,sshd_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,sshd_t,initrc_devpts_t,chr_file,read).
access_vector(allow,sshd_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,sshd_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,sshd_t,initrc_devpts_t,chr_file,write).
access_vector(allow,sshd_t,initrc_devpts_t,chr_file,append).
access_vector(allow,sshd_t,ssh_port_t,tcp_socket,name_bind).
access_vector(allow,initrc_t,sshd_t,process,transition).
access_vector(dontaudit,initrc_t,sshd_t,process,noatsecure).
access_vector(allow,sshd_t,initrc_t,process,sigchld).
access_vector(allow,sshd_t,initrc_t,fd,use).
access_vector(allow,initrc_t,sshd_t,fd,use).
access_vector(allow,sshd_t,sshd_exec_t,file,entrypoint).
type_trans(initrc_t,sshd_exec_t,process,sshd_t).
type_decl(sshd_login_t,[],[domain,privuser,privrole,privlog,privowner,privfd,auth]).
role_decl(system_r,sshd_login_t).
access_vector(allow,sshd_login_t,root_t,dir,read).
access_vector(allow,sshd_login_t,root_t,dir,getattr).
access_vector(allow,sshd_login_t,root_t,dir,lock).
access_vector(allow,sshd_login_t,root_t,dir,search).
access_vector(allow,sshd_login_t,root_t,dir,ioctl).
access_vector(allow,sshd_login_t,usr_t,dir,read).
access_vector(allow,sshd_login_t,usr_t,dir,getattr).
access_vector(allow,sshd_login_t,usr_t,dir,lock).
access_vector(allow,sshd_login_t,usr_t,dir,search).
access_vector(allow,sshd_login_t,usr_t,dir,ioctl).
access_vector(allow,sshd_login_t,lib_t,dir,read).
access_vector(allow,sshd_login_t,lib_t,dir,getattr).
access_vector(allow,sshd_login_t,lib_t,dir,lock).
access_vector(allow,sshd_login_t,lib_t,dir,search).
access_vector(allow,sshd_login_t,lib_t,dir,ioctl).
access_vector(allow,sshd_login_t,etc_t,dir,read).
access_vector(allow,sshd_login_t,etc_t,dir,getattr).
access_vector(allow,sshd_login_t,etc_t,dir,lock).
access_vector(allow,sshd_login_t,etc_t,dir,search).
access_vector(allow,sshd_login_t,etc_t,dir,ioctl).
access_vector(allow,sshd_login_t,lib_t,lnk_file,read).
access_vector(allow,sshd_login_t,lib_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,lib_t,lnk_file,lock).
access_vector(allow,sshd_login_t,lib_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,ld_so_t,file,read).
access_vector(allow,sshd_login_t,ld_so_t,file,getattr).
access_vector(allow,sshd_login_t,ld_so_t,file,lock).
access_vector(allow,sshd_login_t,ld_so_t,file,execute).
access_vector(allow,sshd_login_t,ld_so_t,file,ioctl).
access_vector(allow,sshd_login_t,ld_so_t,file,execute_no_trans).
access_vector(allow,sshd_login_t,ld_so_t,lnk_file,read).
access_vector(allow,sshd_login_t,ld_so_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,ld_so_t,lnk_file,lock).
access_vector(allow,sshd_login_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,shlib_t,file,read).
access_vector(allow,sshd_login_t,shlib_t,file,getattr).
access_vector(allow,sshd_login_t,shlib_t,file,lock).
access_vector(allow,sshd_login_t,shlib_t,file,execute).
access_vector(allow,sshd_login_t,shlib_t,file,ioctl).
access_vector(allow,sshd_login_t,shlib_t,lnk_file,read).
access_vector(allow,sshd_login_t,shlib_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,shlib_t,lnk_file,lock).
access_vector(allow,sshd_login_t,shlib_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,ld_so_cache_t,file,read).
access_vector(allow,sshd_login_t,ld_so_cache_t,file,getattr).
access_vector(allow,sshd_login_t,ld_so_cache_t,file,lock).
access_vector(allow,sshd_login_t,ld_so_cache_t,file,ioctl).
access_vector(allow,sshd_login_t,device_t,dir,search).
access_vector(allow,sshd_login_t,null_device_t,chr_file,ioctl).
access_vector(allow,sshd_login_t,null_device_t,chr_file,read).
access_vector(allow,sshd_login_t,null_device_t,chr_file,getattr).
access_vector(allow,sshd_login_t,null_device_t,chr_file,lock).
access_vector(allow,sshd_login_t,null_device_t,chr_file,write).
access_vector(allow,sshd_login_t,null_device_t,chr_file,append).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,create).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,ioctl).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,read).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,getattr).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,write).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,setattr).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,append).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,bind).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,connect).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,getopt).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,setopt).
access_vector(allow,sshd_login_t,self,unix_dgram_socket,shutdown).
access_vector(allow,sshd_login_t,self,unix_stream_socket,create).
access_vector(allow,sshd_login_t,self,unix_stream_socket,ioctl).
access_vector(allow,sshd_login_t,self,unix_stream_socket,read).
access_vector(allow,sshd_login_t,self,unix_stream_socket,getattr).
access_vector(allow,sshd_login_t,self,unix_stream_socket,write).
access_vector(allow,sshd_login_t,self,unix_stream_socket,setattr).
access_vector(allow,sshd_login_t,self,unix_stream_socket,append).
access_vector(allow,sshd_login_t,self,unix_stream_socket,bind).
access_vector(allow,sshd_login_t,self,unix_stream_socket,connect).
access_vector(allow,sshd_login_t,self,unix_stream_socket,getopt).
access_vector(allow,sshd_login_t,self,unix_stream_socket,setopt).
access_vector(allow,sshd_login_t,self,unix_stream_socket,shutdown).
access_vector(allow,sshd_login_t,self,unix_stream_socket,listen).
access_vector(allow,sshd_login_t,self,unix_stream_socket,accept).
access_vector(allow,sshd_login_t,self,fifo_file,ioctl).
access_vector(allow,sshd_login_t,self,fifo_file,read).
access_vector(allow,sshd_login_t,self,fifo_file,getattr).
access_vector(allow,sshd_login_t,self,fifo_file,lock).
access_vector(allow,sshd_login_t,self,fifo_file,write).
access_vector(allow,sshd_login_t,self,fifo_file,append).
access_vector(allow,sshd_login_t,self,process,fork).
access_vector(allow,sshd_login_t,self,process,sigchld).
access_vector(allow,sshd_login_t,self,process,setsched).
access_vector(allow,sshd_login_t,proc_t,dir,read).
access_vector(allow,sshd_login_t,proc_t,dir,getattr).
access_vector(allow,sshd_login_t,proc_t,dir,lock).
access_vector(allow,sshd_login_t,proc_t,dir,search).
access_vector(allow,sshd_login_t,proc_t,dir,ioctl).
access_vector(allow,sshd_login_t,proc_t,file,read).
access_vector(allow,sshd_login_t,proc_t,file,getattr).
access_vector(allow,sshd_login_t,proc_t,file,lock).
access_vector(allow,sshd_login_t,proc_t,file,ioctl).
access_vector(allow,sshd_login_t,proc_t,lnk_file,read).
access_vector(allow,sshd_login_t,proc_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,proc_t,lnk_file,lock).
access_vector(allow,sshd_login_t,proc_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,proc_t,sock_file,read).
access_vector(allow,sshd_login_t,proc_t,sock_file,getattr).
access_vector(allow,sshd_login_t,proc_t,sock_file,lock).
access_vector(allow,sshd_login_t,proc_t,sock_file,ioctl).
access_vector(allow,sshd_login_t,proc_t,fifo_file,read).
access_vector(allow,sshd_login_t,proc_t,fifo_file,getattr).
access_vector(allow,sshd_login_t,proc_t,fifo_file,lock).
access_vector(allow,sshd_login_t,proc_t,fifo_file,ioctl).
access_vector(allow,sshd_login_t,self,dir,search).
access_vector(allow,sshd_login_t,self,lnk_file,read).
access_vector(allow,sshd_login_t,fs_type,filesystem,getattr).
access_vector(allow,sshd_login_t,root_t,file,read).
access_vector(allow,sshd_login_t,root_t,file,getattr).
access_vector(allow,sshd_login_t,root_t,file,lock).
access_vector(allow,sshd_login_t,root_t,file,ioctl).
access_vector(allow,sshd_login_t,root_t,lnk_file,read).
access_vector(allow,sshd_login_t,root_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,root_t,lnk_file,lock).
access_vector(allow,sshd_login_t,root_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,root_t,sock_file,read).
access_vector(allow,sshd_login_t,root_t,sock_file,getattr).
access_vector(allow,sshd_login_t,root_t,sock_file,lock).
access_vector(allow,sshd_login_t,root_t,sock_file,ioctl).
access_vector(allow,sshd_login_t,root_t,fifo_file,read).
access_vector(allow,sshd_login_t,root_t,fifo_file,getattr).
access_vector(allow,sshd_login_t,root_t,fifo_file,lock).
access_vector(allow,sshd_login_t,root_t,fifo_file,ioctl).
access_vector(allow,sshd_login_t,home_root_t,dir,read).
access_vector(allow,sshd_login_t,home_root_t,dir,getattr).
access_vector(allow,sshd_login_t,home_root_t,dir,lock).
access_vector(allow,sshd_login_t,home_root_t,dir,search).
access_vector(allow,sshd_login_t,home_root_t,dir,ioctl).
access_vector(allow,sshd_login_t,usr_t,file,read).
access_vector(allow,sshd_login_t,usr_t,file,getattr).
access_vector(allow,sshd_login_t,usr_t,file,lock).
access_vector(allow,sshd_login_t,usr_t,file,ioctl).
access_vector(allow,sshd_login_t,usr_t,lnk_file,read).
access_vector(allow,sshd_login_t,usr_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,usr_t,lnk_file,lock).
access_vector(allow,sshd_login_t,usr_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,usr_t,sock_file,read).
access_vector(allow,sshd_login_t,usr_t,sock_file,getattr).
access_vector(allow,sshd_login_t,usr_t,sock_file,lock).
access_vector(allow,sshd_login_t,usr_t,sock_file,ioctl).
access_vector(allow,sshd_login_t,usr_t,fifo_file,read).
access_vector(allow,sshd_login_t,usr_t,fifo_file,getattr).
access_vector(allow,sshd_login_t,usr_t,fifo_file,lock).
access_vector(allow,sshd_login_t,usr_t,fifo_file,ioctl).
access_vector(allow,sshd_login_t,bin_t,dir,read).
access_vector(allow,sshd_login_t,bin_t,dir,getattr).
access_vector(allow,sshd_login_t,bin_t,dir,lock).
access_vector(allow,sshd_login_t,bin_t,dir,search).
access_vector(allow,sshd_login_t,bin_t,dir,ioctl).
access_vector(allow,sshd_login_t,bin_t,file,read).
access_vector(allow,sshd_login_t,bin_t,file,getattr).
access_vector(allow,sshd_login_t,bin_t,file,lock).
access_vector(allow,sshd_login_t,bin_t,file,ioctl).
access_vector(allow,sshd_login_t,bin_t,lnk_file,read).
access_vector(allow,sshd_login_t,bin_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,bin_t,lnk_file,lock).
access_vector(allow,sshd_login_t,bin_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,bin_t,sock_file,read).
access_vector(allow,sshd_login_t,bin_t,sock_file,getattr).
access_vector(allow,sshd_login_t,bin_t,sock_file,lock).
access_vector(allow,sshd_login_t,bin_t,sock_file,ioctl).
access_vector(allow,sshd_login_t,bin_t,fifo_file,read).
access_vector(allow,sshd_login_t,bin_t,fifo_file,getattr).
access_vector(allow,sshd_login_t,bin_t,fifo_file,lock).
access_vector(allow,sshd_login_t,bin_t,fifo_file,ioctl).
access_vector(allow,sshd_login_t,sbin_t,dir,read).
access_vector(allow,sshd_login_t,sbin_t,dir,getattr).
access_vector(allow,sshd_login_t,sbin_t,dir,lock).
access_vector(allow,sshd_login_t,sbin_t,dir,search).
access_vector(allow,sshd_login_t,sbin_t,dir,ioctl).
access_vector(allow,sshd_login_t,sbin_t,file,read).
access_vector(allow,sshd_login_t,sbin_t,file,getattr).
access_vector(allow,sshd_login_t,sbin_t,file,lock).
access_vector(allow,sshd_login_t,sbin_t,file,ioctl).
access_vector(allow,sshd_login_t,sbin_t,lnk_file,read).
access_vector(allow,sshd_login_t,sbin_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,sbin_t,lnk_file,lock).
access_vector(allow,sshd_login_t,sbin_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,sbin_t,sock_file,read).
access_vector(allow,sshd_login_t,sbin_t,sock_file,getattr).
access_vector(allow,sshd_login_t,sbin_t,sock_file,lock).
access_vector(allow,sshd_login_t,sbin_t,sock_file,ioctl).
access_vector(allow,sshd_login_t,sbin_t,fifo_file,read).
access_vector(allow,sshd_login_t,sbin_t,fifo_file,getattr).
access_vector(allow,sshd_login_t,sbin_t,fifo_file,lock).
access_vector(allow,sshd_login_t,sbin_t,fifo_file,ioctl).
access_vector(allow,sshd_login_t,var_t,dir,search).
access_vector(allow,sshd_login_t,var_log_t,dir,search).
access_vector(allow,sshd_login_t,etc_t,file,read).
access_vector(allow,sshd_login_t,etc_t,file,getattr).
access_vector(allow,sshd_login_t,etc_t,file,lock).
access_vector(allow,sshd_login_t,etc_t,file,ioctl).
access_vector(allow,sshd_login_t,etc_t,lnk_file,read).
access_vector(allow,sshd_login_t,etc_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,etc_t,lnk_file,lock).
access_vector(allow,sshd_login_t,etc_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,etc_t,sock_file,read).
access_vector(allow,sshd_login_t,etc_t,sock_file,getattr).
access_vector(allow,sshd_login_t,etc_t,sock_file,lock).
access_vector(allow,sshd_login_t,etc_t,sock_file,ioctl).
access_vector(allow,sshd_login_t,etc_t,fifo_file,read).
access_vector(allow,sshd_login_t,etc_t,fifo_file,getattr).
access_vector(allow,sshd_login_t,etc_t,fifo_file,lock).
access_vector(allow,sshd_login_t,etc_t,fifo_file,ioctl).
access_vector(allow,sshd_login_t,etc_runtime_t,file,read).
access_vector(allow,sshd_login_t,etc_runtime_t,file,getattr).
access_vector(allow,sshd_login_t,etc_runtime_t,file,lock).
access_vector(allow,sshd_login_t,etc_runtime_t,file,ioctl).
access_vector(allow,sshd_login_t,etc_runtime_t,lnk_file,read).
access_vector(allow,sshd_login_t,etc_runtime_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,etc_runtime_t,lnk_file,lock).
access_vector(allow,sshd_login_t,etc_runtime_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,resolv_conf_t,file,read).
access_vector(allow,sshd_login_t,resolv_conf_t,file,getattr).
access_vector(allow,sshd_login_t,resolv_conf_t,file,lock).
access_vector(allow,sshd_login_t,resolv_conf_t,file,ioctl).
access_vector(allow,sshd_login_t,resolv_conf_t,lnk_file,read).
access_vector(allow,sshd_login_t,resolv_conf_t,lnk_file,getattr).
access_vector(allow,sshd_login_t,resolv_conf_t,lnk_file,lock).
access_vector(allow,sshd_login_t,resolv_conf_t,lnk_file,ioctl).
access_vector(allow,sshd_login_t,ld_so_t,file,read).
access_vector(allow,sshd_login_t,ld_so_t,file,getattr).
access_vector(allow,sshd_login_t,ld_so_t,file,lock).
access_vector(allow,sshd_login_t,shlib_t,file,read).
access_vector(allow,sshd_login_t,shlib_t,file,getattr).
access_vector(allow,sshd_login_t,shlib_t,file,lock).
access_vector(allow,sshd_login_t,exec_type,file,read).
access_vector(allow,sshd_login_t,exec_type,file,getattr).
access_vector(allow,sshd_login_t,exec_type,file,lock).
access_vector(allow,sshd_login_t,exec_type,file,ioctl).
access_vector(allow,sshd_login_t,exec_type,lnk_file,read).
access_vector(allow,sshd_login_t,exec_type,lnk_file,getattr).
access_vector(allow,sshd_login_t,exec_type,lnk_file,lock).
access_vector(allow,sshd_login_t,exec_type,lnk_file,ioctl).
access_vector(allow,sshd_login_t,devtty_t,chr_file,ioctl).
access_vector(allow,sshd_login_t,devtty_t,chr_file,read).
access_vector(allow,sshd_login_t,devtty_t,chr_file,getattr).
access_vector(allow,sshd_login_t,devtty_t,chr_file,lock).
access_vector(allow,sshd_login_t,devtty_t,chr_file,write).
access_vector(allow,sshd_login_t,devtty_t,chr_file,append).
access_vector(allow,sshd_login_t,zero_device_t,chr_file,ioctl).
access_vector(allow,sshd_login_t,zero_device_t,chr_file,read).
access_vector(allow,sshd_login_t,zero_device_t,chr_file,getattr).
access_vector(allow,sshd_login_t,zero_device_t,chr_file,lock).
access_vector(allow,sshd_login_t,zero_device_t,chr_file,write).
access_vector(allow,sshd_login_t,zero_device_t,chr_file,append).
access_vector(allow,sshd_login_t,random_device_t,chr_file,read).
access_vector(allow,sshd_login_t,random_device_t,chr_file,getattr).
access_vector(allow,sshd_login_t,random_device_t,chr_file,lock).
access_vector(allow,sshd_login_t,random_device_t,chr_file,ioctl).
access_vector(allow,sshd_login_t,self,udp_socket,create).
access_vector(allow,sshd_login_t,self,udp_socket,ioctl).
access_vector(allow,sshd_login_t,self,udp_socket,read).
access_vector(allow,sshd_login_t,self,udp_socket,getattr).
access_vector(allow,sshd_login_t,self,udp_socket,write).
access_vector(allow,sshd_login_t,self,udp_socket,setattr).
access_vector(allow,sshd_login_t,self,udp_socket,append).
access_vector(allow,sshd_login_t,self,udp_socket,bind).
access_vector(allow,sshd_login_t,self,udp_socket,connect).
access_vector(allow,sshd_login_t,self,udp_socket,getopt).
access_vector(allow,sshd_login_t,self,udp_socket,setopt).
access_vector(allow,sshd_login_t,self,udp_socket,shutdown).
access_vector(allow,sshd_login_t,self,tcp_socket,create).
access_vector(allow,sshd_login_t,self,tcp_socket,ioctl).
access_vector(allow,sshd_login_t,self,tcp_socket,read).
access_vector(allow,sshd_login_t,self,tcp_socket,getattr).
access_vector(allow,sshd_login_t,self,tcp_socket,write).
access_vector(allow,sshd_login_t,self,tcp_socket,setattr).
access_vector(allow,sshd_login_t,self,tcp_socket,append).
access_vector(allow,sshd_login_t,self,tcp_socket,bind).
access_vector(allow,sshd_login_t,self,tcp_socket,connect).
access_vector(allow,sshd_login_t,self,tcp_socket,getopt).
access_vector(allow,sshd_login_t,self,tcp_socket,setopt).
access_vector(allow,sshd_login_t,self,tcp_socket,shutdown).
access_vector(allow,sshd_login_t,self,tcp_socket,listen).
access_vector(allow,sshd_login_t,self,tcp_socket,accept).
access_vector(allow,sshd_login_t,any_socket_t,udp_socket,sendto).
access_vector(allow,sshd_login_t,netif_type,netif,tcp_send).
access_vector(allow,sshd_login_t,netif_type,netif,udp_send).
access_vector(allow,sshd_login_t,netif_type,netif,rawip_send).
access_vector(allow,sshd_login_t,netif_type,netif,tcp_recv).
access_vector(allow,sshd_login_t,netif_type,netif,udp_recv).
access_vector(allow,sshd_login_t,netif_type,netif,rawip_recv).
access_vector(allow,sshd_login_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,sshd_login_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,sshd_login_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,sshd_login_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,sshd_login_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,sshd_login_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,sshd_login_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,sshd_login_t,node_type,node,tcp_send).
access_vector(allow,sshd_login_t,node_type,node,udp_send).
access_vector(allow,sshd_login_t,node_type,node,rawip_send).
access_vector(allow,sshd_login_t,node_type,node,tcp_recv).
access_vector(allow,sshd_login_t,node_type,node,udp_recv).
access_vector(allow,sshd_login_t,node_type,node,rawip_recv).
access_vector(allow,sshd_login_t,mount_t,udp_socket,ioctl).
access_vector(allow,sshd_login_t,mount_t,udp_socket,read).
access_vector(allow,sshd_login_t,mount_t,udp_socket,getattr).
access_vector(allow,sshd_login_t,mount_t,udp_socket,write).
access_vector(allow,sshd_login_t,mount_t,udp_socket,setattr).
access_vector(allow,sshd_login_t,mount_t,udp_socket,append).
access_vector(allow,sshd_login_t,mount_t,udp_socket,bind).
access_vector(allow,sshd_login_t,mount_t,udp_socket,connect).
access_vector(allow,sshd_login_t,mount_t,udp_socket,getopt).
access_vector(allow,sshd_login_t,mount_t,udp_socket,setopt).
access_vector(allow,sshd_login_t,mount_t,udp_socket,shutdown).
access_vector(allow,sshd_login_t,port_t,udp_socket,name_bind).
access_vector(allow,sshd_login_t,port_t,tcp_socket,name_bind).
access_vector(allow,sshd_login_t,self,capability,chown).
access_vector(allow,sshd_login_t,self,capability,dac_override).
access_vector(allow,sshd_login_t,self,capability,fowner).
access_vector(allow,sshd_login_t,self,capability,fsetid).
access_vector(allow,sshd_login_t,self,capability,setgid).
access_vector(allow,sshd_login_t,self,capability,setuid).
access_vector(allow,sshd_login_t,self,capability,net_bind_service).
access_vector(allow,sshd_login_t,self,capability,sys_tty_config).
access_vector(allow,sshd_login_t,shadow_t,file,read).
access_vector(allow,sshd_login_t,shadow_t,file,getattr).
access_vector(allow,sshd_login_t,home_root_t,dir,search).
access_vector(allow,sshd_login_t,home_root_t,dir,getattr).
access_vector(allow,sshd_login_t,user_home_dir_type,dir,search).
access_vector(allow,sshd_login_t,user_home_dir_type,dir,getattr).
access_vector(allow,sshd_login_t,sysadm_home_dir_t,dir,search).
access_vector(allow,sshd_login_t,sysadm_home_dir_t,dir,getattr).
access_vector(allow,sshd_login_t,user_t,process,transition).
access_vector(dontaudit,sshd_login_t,user_t,process,noatsecure).
access_vector(allow,sshd_login_t,shell_exec_t,file,read).
access_vector(allow,sshd_login_t,shell_exec_t,file,getattr).
access_vector(allow,sshd_login_t,shell_exec_t,file,execute).
access_vector(allow,user_t,sshd_login_t,process,sigchld).
access_vector(allow,user_t,sshd_login_t,fd,use).
access_vector(allow,sshd_login_t,user_t,fd,use).
access_vector(allow,user_t,sshd_login_t,fifo_file,ioctl).
access_vector(allow,user_t,sshd_login_t,fifo_file,read).
access_vector(allow,user_t,sshd_login_t,fifo_file,getattr).
access_vector(allow,user_t,sshd_login_t,fifo_file,lock).
access_vector(allow,user_t,sshd_login_t,fifo_file,write).
access_vector(allow,user_t,sshd_login_t,fifo_file,append).
access_vector(allow,user_t,shell_exec_t,file,entrypoint).
type_trans(sshd_login_t,shell_exec_t,process,user_t).
access_vector(allow,sshd_login_t,unpriv_userdomain,process,transition).
access_vector(dontaudit,sshd_login_t,unpriv_userdomain,process,noatsecure).
access_vector(allow,unpriv_userdomain,sshd_login_t,process,sigchld).
access_vector(allow,unpriv_userdomain,sshd_login_t,fd,use).
access_vector(allow,sshd_login_t,unpriv_userdomain,fd,use).
access_vector(allow,unpriv_userdomain,sshd_login_t,fifo_file,ioctl).
access_vector(allow,unpriv_userdomain,sshd_login_t,fifo_file,read).
access_vector(allow,unpriv_userdomain,sshd_login_t,fifo_file,getattr).
access_vector(allow,unpriv_userdomain,sshd_login_t,fifo_file,lock).
access_vector(allow,unpriv_userdomain,sshd_login_t,fifo_file,write).
access_vector(allow,unpriv_userdomain,sshd_login_t,fifo_file,append).
access_vector(allow,unpriv_userdomain,shell_exec_t,file,entrypoint).
access_vector(allow,sshd_login_t,self,process,setexec).
access_vector(allow,sshd_login_t,proc_t,dir,search).
access_vector(allow,sshd_login_t,proc_t,lnk_file,read).
access_vector(allow,sshd_login_t,self,dir,search).
access_vector(allow,sshd_login_t,self,file,read).
access_vector(allow,sshd_login_t,self,file,write).
access_vector(allow,sshd_login_t,initrc_var_run_t,file,ioctl).
access_vector(allow,sshd_login_t,initrc_var_run_t,file,read).
access_vector(allow,sshd_login_t,initrc_var_run_t,file,getattr).
access_vector(allow,sshd_login_t,initrc_var_run_t,file,lock).
access_vector(allow,sshd_login_t,initrc_var_run_t,file,write).
access_vector(allow,sshd_login_t,initrc_var_run_t,file,append).
access_vector(allow,sshd_login_t,wtmp_t,file,ioctl).
access_vector(allow,sshd_login_t,wtmp_t,file,read).
access_vector(allow,sshd_login_t,wtmp_t,file,getattr).
access_vector(allow,sshd_login_t,wtmp_t,file,lock).
access_vector(allow,sshd_login_t,wtmp_t,file,write).
access_vector(allow,sshd_login_t,wtmp_t,file,append).
access_vector(allow,sshd_login_t,security_t,dir,read).
access_vector(allow,sshd_login_t,security_t,dir,search).
access_vector(allow,sshd_login_t,security_t,dir,getattr).
access_vector(allow,sshd_login_t,security_t,file,getattr).
access_vector(allow,sshd_login_t,security_t,file,read).
access_vector(allow,sshd_login_t,security_t,file,write).
access_vector(allow,sshd_login_t,security_t,security,check_context).
access_vector(allow,sshd_login_t,security_t,security,compute_av).
access_vector(allow,sshd_login_t,security_t,security,compute_create).
access_vector(allow,sshd_login_t,security_t,security,compute_relabel).
access_vector(allow,sshd_login_t,security_t,security,compute_user).
access_vector(allow,sshd_login_t,default_context_t,file,read).
access_vector(allow,sshd_login_t,default_context_t,file,getattr).
access_vector(allow,sshd_login_t,default_context_t,file,lock).
access_vector(allow,sshd_login_t,default_context_t,file,ioctl).
type_decl(sshd_key_t,[],[file_type,sysadmfile]).
access_vector(allow,sshd_t,sshd_t,tcp_socket,connectto).
access_vector(allow,sshd_t,sshd_t,tcp_socket,recvfrom).
access_vector(allow,sshd_t,sshd_t,tcp_socket,acceptfrom).
type_decl(sshd_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,sshd_t,tmp_t,dir,read).
access_vector(allow,sshd_t,tmp_t,dir,getattr).
access_vector(allow,sshd_t,tmp_t,dir,lock).
access_vector(allow,sshd_t,tmp_t,dir,search).
access_vector(allow,sshd_t,tmp_t,dir,ioctl).
access_vector(allow,sshd_t,tmp_t,dir,add_name).
access_vector(allow,sshd_t,tmp_t,dir,remove_name).
access_vector(allow,sshd_t,tmp_t,dir,write).
access_vector(allow,sshd_t,sshd_tmp_t,file,create).
access_vector(allow,sshd_t,sshd_tmp_t,file,ioctl).
access_vector(allow,sshd_t,sshd_tmp_t,file,read).
access_vector(allow,sshd_t,sshd_tmp_t,file,getattr).
access_vector(allow,sshd_t,sshd_tmp_t,file,lock).
access_vector(allow,sshd_t,sshd_tmp_t,file,write).
access_vector(allow,sshd_t,sshd_tmp_t,file,setattr).
access_vector(allow,sshd_t,sshd_tmp_t,file,append).
access_vector(allow,sshd_t,sshd_tmp_t,file,link).
access_vector(allow,sshd_t,sshd_tmp_t,file,unlink).
access_vector(allow,sshd_t,sshd_tmp_t,file,rename).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,create).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,ioctl).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,read).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,getattr).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,lock).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,write).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,setattr).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,append).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,link).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,unlink).
access_vector(allow,sshd_t,sshd_tmp_t,lnk_file,rename).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,create).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,ioctl).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,read).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,getattr).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,lock).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,write).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,setattr).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,append).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,link).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,unlink).
access_vector(allow,sshd_t,sshd_tmp_t,sock_file,rename).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,create).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,ioctl).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,read).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,getattr).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,lock).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,write).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,setattr).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,append).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,link).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,unlink).
access_vector(allow,sshd_t,sshd_tmp_t,fifo_file,rename).
access_vector(allow,sshd_t,sshd_tmp_t,dir,create).
access_vector(allow,sshd_t,sshd_tmp_t,dir,read).
access_vector(allow,sshd_t,sshd_tmp_t,dir,getattr).
access_vector(allow,sshd_t,sshd_tmp_t,dir,lock).
access_vector(allow,sshd_t,sshd_tmp_t,dir,setattr).
access_vector(allow,sshd_t,sshd_tmp_t,dir,link).
access_vector(allow,sshd_t,sshd_tmp_t,dir,unlink).
access_vector(allow,sshd_t,sshd_tmp_t,dir,rename).
access_vector(allow,sshd_t,sshd_tmp_t,dir,search).
access_vector(allow,sshd_t,sshd_tmp_t,dir,add_name).
access_vector(allow,sshd_t,sshd_tmp_t,dir,remove_name).
access_vector(allow,sshd_t,sshd_tmp_t,dir,reparent).
access_vector(allow,sshd_t,sshd_tmp_t,dir,write).
access_vector(allow,sshd_t,sshd_tmp_t,dir,rmdir).
type_trans(sshd_t,tmp_t,dir,sshd_tmp_t).
type_trans(sshd_t,tmp_t,[file,lnk_file,sock_file,fifo_file],sshd_tmp_t).
access_vector(allow,sshd_t,init_t,fd,use).
access_vector(allow,sshd_t,ptmx_t,chr_file,ioctl).
access_vector(allow,sshd_t,ptmx_t,chr_file,read).
access_vector(allow,sshd_t,ptmx_t,chr_file,getattr).
access_vector(allow,sshd_t,ptmx_t,chr_file,lock).
access_vector(allow,sshd_t,ptmx_t,chr_file,write).
access_vector(allow,sshd_t,ptmx_t,chr_file,append).
access_vector(allow,sshd_t,devpts_t,filesystem,getattr).
access_vector(allow,sshd_t,devpts_t,dir,getattr).
access_vector(allow,sshd_t,devpts_t,dir,read).
access_vector(allow,sshd_t,devpts_t,dir,search).
type_decl(sshd_devpts_t,[],[file_type,sysadmfile,ptyfile]).
access_vector(allow,sshd_devpts_t,devpts_t,filesystem,associate).
type_trans(sshd_t,devpts_t,chr_file,sshd_devpts_t).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,setattr).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,ioctl).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,read).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,getattr).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,lock).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,write).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,append).
access_vector(allow,sshd_t,sshd_login_t,process,transition).
access_vector(dontaudit,sshd_t,sshd_login_t,process,noatsecure).
access_vector(allow,sshd_t,login_exec_t,file,read).
access_vector(allow,sshd_t,login_exec_t,file,getattr).
access_vector(allow,sshd_t,login_exec_t,file,execute).
access_vector(allow,sshd_login_t,sshd_t,process,sigchld).
access_vector(allow,sshd_login_t,sshd_t,fd,use).
access_vector(allow,sshd_t,sshd_login_t,fd,use).
access_vector(allow,sshd_login_t,sshd_t,fifo_file,ioctl).
access_vector(allow,sshd_login_t,sshd_t,fifo_file,read).
access_vector(allow,sshd_login_t,sshd_t,fifo_file,getattr).
access_vector(allow,sshd_login_t,sshd_t,fifo_file,lock).
access_vector(allow,sshd_login_t,sshd_t,fifo_file,write).
access_vector(allow,sshd_login_t,sshd_t,fifo_file,append).
access_vector(allow,sshd_login_t,login_exec_t,file,read).
access_vector(allow,sshd_login_t,login_exec_t,file,getattr).
access_vector(allow,sshd_login_t,login_exec_t,file,lock).
access_vector(allow,sshd_login_t,login_exec_t,file,execute).
access_vector(allow,sshd_login_t,login_exec_t,file,ioctl).
access_vector(allow,sshd_login_t,login_exec_t,file,entrypoint).
type_trans(sshd_t,login_exec_t,process,sshd_login_t).
access_vector(allow,sshd_t,self,capability,sys_chroot).
access_vector(allow,sshd_t,self,capability,sys_resource).
type_decl(sshd_var_run_t,var_run_sshd_t,[file_type,sysadmfile,pidfile]).
access_vector(allow,sshd_t,var_run_t,dir,read).
access_vector(allow,sshd_t,var_run_t,dir,getattr).
access_vector(allow,sshd_t,var_run_t,dir,lock).
access_vector(allow,sshd_t,var_run_t,dir,search).
access_vector(allow,sshd_t,var_run_t,dir,ioctl).
access_vector(allow,sshd_t,var_run_t,dir,add_name).
access_vector(allow,sshd_t,var_run_t,dir,remove_name).
access_vector(allow,sshd_t,var_run_t,dir,write).
access_vector(allow,sshd_t,sshd_var_run_t,file,create).
access_vector(allow,sshd_t,sshd_var_run_t,file,ioctl).
access_vector(allow,sshd_t,sshd_var_run_t,file,read).
access_vector(allow,sshd_t,sshd_var_run_t,file,getattr).
access_vector(allow,sshd_t,sshd_var_run_t,file,lock).
access_vector(allow,sshd_t,sshd_var_run_t,file,write).
access_vector(allow,sshd_t,sshd_var_run_t,file,setattr).
access_vector(allow,sshd_t,sshd_var_run_t,file,append).
access_vector(allow,sshd_t,sshd_var_run_t,file,link).
access_vector(allow,sshd_t,sshd_var_run_t,file,unlink).
access_vector(allow,sshd_t,sshd_var_run_t,file,rename).
type_trans(sshd_t,var_run_t,file,sshd_var_run_t).
access_vector(allow,sshd_t,sshd_var_run_t,dir,read).
access_vector(allow,sshd_t,sshd_var_run_t,dir,getattr).
access_vector(allow,sshd_t,sshd_var_run_t,dir,lock).
access_vector(allow,sshd_t,sshd_var_run_t,dir,search).
access_vector(allow,sshd_t,sshd_var_run_t,dir,ioctl).
access_vector(allow,sshd_t,sshd_var_run_t,dir,add_name).
access_vector(allow,sshd_t,sshd_var_run_t,dir,remove_name).
access_vector(allow,sshd_t,sshd_var_run_t,dir,write).
access_vector(allow,sshd_t,sshd_key_t,file,getattr).
access_vector(allow,sshd_t,sshd_key_t,file,read).
access_vector(allow,sshd_t,lastlog_t,file,ioctl).
access_vector(allow,sshd_t,lastlog_t,file,read).
access_vector(allow,sshd_t,lastlog_t,file,getattr).
access_vector(allow,sshd_t,lastlog_t,file,lock).
access_vector(allow,sshd_t,lastlog_t,file,write).
access_vector(allow,sshd_t,lastlog_t,file,append).
access_vector(allow,sshd_t,unpriv_userdomain,process,signal).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,setattr).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,getattr).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,relabelfrom).
access_vector(allow,sshd_t,sshd_devpts_t,chr_file,relabelto).
access_vector(allow,sshd_t,userpty_type,chr_file,setattr).
access_vector(allow,sshd_t,userpty_type,chr_file,relabelto).
access_vector(allow,sshd_t,userpty_type,chr_file,ioctl).
access_vector(allow,sshd_t,userpty_type,chr_file,read).
access_vector(allow,sshd_t,userpty_type,chr_file,getattr).
access_vector(allow,sshd_t,userpty_type,chr_file,lock).
access_vector(allow,sshd_t,userpty_type,chr_file,write).
access_vector(allow,sshd_t,userpty_type,chr_file,append).
access_vector(dontaudit,sshd_t,sysadm_devpts_t,chr_file,setattr).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,setattr).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,ioctl).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,read).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,getattr).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,lock).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,write).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,append).
access_vector(allow,sshd_login_t,lastlog_t,file,ioctl).
access_vector(allow,sshd_login_t,lastlog_t,file,read).
access_vector(allow,sshd_login_t,lastlog_t,file,getattr).
access_vector(allow,sshd_login_t,lastlog_t,file,lock).
access_vector(allow,sshd_login_t,lastlog_t,file,write).
access_vector(allow,sshd_login_t,lastlog_t,file,append).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,relabelfrom).
access_vector(allow,sshd_login_t,sshd_devpts_t,chr_file,relabelto).
access_vector(allow,sshd_login_t,userpty_type,chr_file,getattr).
access_vector(allow,sshd_login_t,userpty_type,chr_file,relabelfrom).
access_vector(allow,sshd_login_t,userpty_type,chr_file,relabelto).
access_vector(allow,sshd_t,etc_t,lnk_file,read).
access_vector(allow,sshd_t,locale_t,dir,read).
access_vector(allow,sshd_t,locale_t,dir,getattr).
access_vector(allow,sshd_t,locale_t,dir,lock).
access_vector(allow,sshd_t,locale_t,dir,search).
access_vector(allow,sshd_t,locale_t,dir,ioctl).
access_vector(allow,sshd_t,locale_t,file,read).
access_vector(allow,sshd_t,locale_t,file,getattr).
access_vector(allow,sshd_t,locale_t,file,lock).
access_vector(allow,sshd_t,locale_t,file,ioctl).
access_vector(allow,sshd_t,locale_t,lnk_file,read).
access_vector(allow,sshd_t,locale_t,lnk_file,getattr).
access_vector(allow,sshd_t,locale_t,lnk_file,lock).
access_vector(allow,sshd_t,locale_t,lnk_file,ioctl).
access_vector(allow,sshd_t,var_spool_t,dir,search).
access_vector(allow,sshd_t,mail_spool_t,dir,search).
access_vector(allow,sshd_t,mail_spool_t,lnk_file,read).
access_vector(allow,sshd_t,mail_spool_t,file,getattr).
type_decl(ssh_exec_t,[],[file_type,exec_type,sysadmfile]).
access_vector(allow,sysadm_ssh_t,user_home_dir_type,dir,search).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,read).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,lock).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,search).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,dir,ioctl).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,read).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,lock).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,file,ioctl).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,read).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,getattr).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,lock).
access_vector(allow,sysadm_ssh_t,user_home_ssh_t,lnk_file,ioctl).
type_decl(su_exec_t,[],[file_type,sysadmfile,exec_type]).
access_vector(allow,sysadm_su_t,user_home_dir_type,dir,search).
type_decl(syslogd_t,[],[domain,privlog]).
type_decl(syslogd_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(system_r,syslogd_t).
access_vector(allow,initrc_t,syslogd_t,process,transition).
access_vector(dontaudit,initrc_t,syslogd_t,process,noatsecure).
access_vector(allow,initrc_t,syslogd_exec_t,file,read).
access_vector(allow,initrc_t,syslogd_exec_t,file,getattr).
access_vector(allow,initrc_t,syslogd_exec_t,file,execute).
access_vector(allow,syslogd_t,initrc_t,process,sigchld).
access_vector(allow,syslogd_t,initrc_t,fd,use).
access_vector(allow,initrc_t,syslogd_t,fd,use).
access_vector(allow,syslogd_t,initrc_t,fifo_file,ioctl).
access_vector(allow,syslogd_t,initrc_t,fifo_file,read).
access_vector(allow,syslogd_t,initrc_t,fifo_file,getattr).
access_vector(allow,syslogd_t,initrc_t,fifo_file,lock).
access_vector(allow,syslogd_t,initrc_t,fifo_file,write).
access_vector(allow,syslogd_t,initrc_t,fifo_file,append).
access_vector(allow,syslogd_t,syslogd_exec_t,file,entrypoint).
type_trans(initrc_t,syslogd_exec_t,process,syslogd_t).
access_vector(allow,syslogd_t,init_t,fd,use).
access_vector(allow,syslogd_t,init_t,process,sigchld).
access_vector(allow,syslogd_t,privfd,fd,use).
access_vector(allow,syslogd_t,newrole_t,process,sigchld).
access_vector(allow,syslogd_t,self,process,sigchld).
access_vector(allow,syslogd_t,self,process,sigkill).
access_vector(allow,syslogd_t,self,process,sigstop).
access_vector(allow,syslogd_t,self,process,signull).
access_vector(allow,syslogd_t,self,process,signal).
access_vector(allow,syslogd_t,self,process,fork).
access_vector(allow,syslogd_t,root_t,dir,read).
access_vector(allow,syslogd_t,root_t,dir,getattr).
access_vector(allow,syslogd_t,root_t,dir,lock).
access_vector(allow,syslogd_t,root_t,dir,search).
access_vector(allow,syslogd_t,root_t,dir,ioctl).
access_vector(allow,syslogd_t,usr_t,dir,read).
access_vector(allow,syslogd_t,usr_t,dir,getattr).
access_vector(allow,syslogd_t,usr_t,dir,lock).
access_vector(allow,syslogd_t,usr_t,dir,search).
access_vector(allow,syslogd_t,usr_t,dir,ioctl).
access_vector(allow,syslogd_t,lib_t,dir,read).
access_vector(allow,syslogd_t,lib_t,dir,getattr).
access_vector(allow,syslogd_t,lib_t,dir,lock).
access_vector(allow,syslogd_t,lib_t,dir,search).
access_vector(allow,syslogd_t,lib_t,dir,ioctl).
access_vector(allow,syslogd_t,etc_t,dir,read).
access_vector(allow,syslogd_t,etc_t,dir,getattr).
access_vector(allow,syslogd_t,etc_t,dir,lock).
access_vector(allow,syslogd_t,etc_t,dir,search).
access_vector(allow,syslogd_t,etc_t,dir,ioctl).
access_vector(allow,syslogd_t,lib_t,lnk_file,read).
access_vector(allow,syslogd_t,lib_t,lnk_file,getattr).
access_vector(allow,syslogd_t,lib_t,lnk_file,lock).
access_vector(allow,syslogd_t,lib_t,lnk_file,ioctl).
access_vector(allow,syslogd_t,ld_so_t,file,read).
access_vector(allow,syslogd_t,ld_so_t,file,getattr).
access_vector(allow,syslogd_t,ld_so_t,file,lock).
access_vector(allow,syslogd_t,ld_so_t,file,execute).
access_vector(allow,syslogd_t,ld_so_t,file,ioctl).
access_vector(allow,syslogd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,syslogd_t,ld_so_t,lnk_file,read).
access_vector(allow,syslogd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,syslogd_t,ld_so_t,lnk_file,lock).
access_vector(allow,syslogd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,syslogd_t,shlib_t,file,read).
access_vector(allow,syslogd_t,shlib_t,file,getattr).
access_vector(allow,syslogd_t,shlib_t,file,lock).
access_vector(allow,syslogd_t,shlib_t,file,execute).
access_vector(allow,syslogd_t,shlib_t,file,ioctl).
access_vector(allow,syslogd_t,shlib_t,lnk_file,read).
access_vector(allow,syslogd_t,shlib_t,lnk_file,getattr).
access_vector(allow,syslogd_t,shlib_t,lnk_file,lock).
access_vector(allow,syslogd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,syslogd_t,ld_so_cache_t,file,read).
access_vector(allow,syslogd_t,ld_so_cache_t,file,getattr).
access_vector(allow,syslogd_t,ld_so_cache_t,file,lock).
access_vector(allow,syslogd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,syslogd_t,device_t,dir,search).
access_vector(allow,syslogd_t,null_device_t,chr_file,ioctl).
access_vector(allow,syslogd_t,null_device_t,chr_file,read).
access_vector(allow,syslogd_t,null_device_t,chr_file,getattr).
access_vector(allow,syslogd_t,null_device_t,chr_file,lock).
access_vector(allow,syslogd_t,null_device_t,chr_file,write).
access_vector(allow,syslogd_t,null_device_t,chr_file,append).
access_vector(allow,syslogd_t,self,dir,read).
access_vector(allow,syslogd_t,self,dir,getattr).
access_vector(allow,syslogd_t,self,dir,lock).
access_vector(allow,syslogd_t,self,dir,search).
access_vector(allow,syslogd_t,self,dir,ioctl).
access_vector(allow,syslogd_t,proc_t,dir,read).
access_vector(allow,syslogd_t,proc_t,dir,getattr).
access_vector(allow,syslogd_t,proc_t,dir,lock).
access_vector(allow,syslogd_t,proc_t,dir,search).
access_vector(allow,syslogd_t,proc_t,dir,ioctl).
access_vector(allow,syslogd_t,self,lnk_file,read).
access_vector(allow,syslogd_t,proc_t,lnk_file,read).
access_vector(allow,syslogd_t,device_t,dir,getattr).
access_vector(allow,syslogd_t,device_t,dir,search).
access_vector(allow,syslogd_t,console_device_t,chr_file,ioctl).
access_vector(allow,syslogd_t,console_device_t,chr_file,read).
access_vector(allow,syslogd_t,console_device_t,chr_file,getattr).
access_vector(allow,syslogd_t,console_device_t,chr_file,lock).
access_vector(allow,syslogd_t,console_device_t,chr_file,write).
access_vector(allow,syslogd_t,console_device_t,chr_file,append).
access_vector(allow,syslogd_t,initrc_devpts_t,chr_file,ioctl).
access_vector(allow,syslogd_t,initrc_devpts_t,chr_file,read).
access_vector(allow,syslogd_t,initrc_devpts_t,chr_file,getattr).
access_vector(allow,syslogd_t,initrc_devpts_t,chr_file,lock).
access_vector(allow,syslogd_t,initrc_devpts_t,chr_file,write).
access_vector(allow,syslogd_t,initrc_devpts_t,chr_file,append).
access_vector(allow,syslogd_t,var_t,dir,getattr).
access_vector(allow,syslogd_t,var_t,dir,search).
type_decl(syslogd_var_run_t,var_run_syslogd_t,[file_type,sysadmfile,pidfile]).
access_vector(allow,syslogd_t,var_run_t,dir,read).
access_vector(allow,syslogd_t,var_run_t,dir,getattr).
access_vector(allow,syslogd_t,var_run_t,dir,lock).
access_vector(allow,syslogd_t,var_run_t,dir,search).
access_vector(allow,syslogd_t,var_run_t,dir,ioctl).
access_vector(allow,syslogd_t,var_run_t,dir,add_name).
access_vector(allow,syslogd_t,var_run_t,dir,remove_name).
access_vector(allow,syslogd_t,var_run_t,dir,write).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,create).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,ioctl).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,read).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,getattr).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,lock).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,write).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,setattr).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,append).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,link).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,unlink).
access_vector(allow,syslogd_t,syslogd_var_run_t,file,rename).
type_trans(syslogd_t,var_run_t,file,syslogd_var_run_t).
access_vector(allow,syslogd_t,syslogd_var_run_t,dir,read).
access_vector(allow,syslogd_t,syslogd_var_run_t,dir,getattr).
access_vector(allow,syslogd_t,syslogd_var_run_t,dir,lock).
access_vector(allow,syslogd_t,syslogd_var_run_t,dir,search).
access_vector(allow,syslogd_t,syslogd_var_run_t,dir,ioctl).
access_vector(allow,syslogd_t,syslogd_var_run_t,dir,add_name).
access_vector(allow,syslogd_t,syslogd_var_run_t,dir,remove_name).
access_vector(allow,syslogd_t,syslogd_var_run_t,dir,write).
access_vector(allow,syslogd_t,devtty_t,chr_file,ioctl).
access_vector(allow,syslogd_t,devtty_t,chr_file,read).
access_vector(allow,syslogd_t,devtty_t,chr_file,getattr).
access_vector(allow,syslogd_t,devtty_t,chr_file,lock).
access_vector(allow,syslogd_t,devtty_t,chr_file,write).
access_vector(allow,syslogd_t,devtty_t,chr_file,append).
access_vector(dontaudit,syslogd_t,sysadm_home_dir_t,dir,search).
access_vector(allow,syslogd_t,fs_type,filesystem,getattr).
access_vector(allow,syslogd_t,etc_t,lnk_file,read).
access_vector(allow,syslogd_t,locale_t,dir,read).
access_vector(allow,syslogd_t,locale_t,dir,getattr).
access_vector(allow,syslogd_t,locale_t,dir,lock).
access_vector(allow,syslogd_t,locale_t,dir,search).
access_vector(allow,syslogd_t,locale_t,dir,ioctl).
access_vector(allow,syslogd_t,locale_t,file,read).
access_vector(allow,syslogd_t,locale_t,file,getattr).
access_vector(allow,syslogd_t,locale_t,file,lock).
access_vector(allow,syslogd_t,locale_t,file,ioctl).
access_vector(allow,syslogd_t,locale_t,lnk_file,read).
access_vector(allow,syslogd_t,locale_t,lnk_file,getattr).
access_vector(allow,syslogd_t,locale_t,lnk_file,lock).
access_vector(allow,syslogd_t,locale_t,lnk_file,ioctl).
access_vector(allow,syslogd_t,self,udp_socket,create).
access_vector(allow,syslogd_t,self,udp_socket,ioctl).
access_vector(allow,syslogd_t,self,udp_socket,read).
access_vector(allow,syslogd_t,self,udp_socket,getattr).
access_vector(allow,syslogd_t,self,udp_socket,write).
access_vector(allow,syslogd_t,self,udp_socket,setattr).
access_vector(allow,syslogd_t,self,udp_socket,append).
access_vector(allow,syslogd_t,self,udp_socket,bind).
access_vector(allow,syslogd_t,self,udp_socket,connect).
access_vector(allow,syslogd_t,self,udp_socket,getopt).
access_vector(allow,syslogd_t,self,udp_socket,setopt).
access_vector(allow,syslogd_t,self,udp_socket,shutdown).
access_vector(allow,syslogd_t,self,tcp_socket,create).
access_vector(allow,syslogd_t,self,tcp_socket,ioctl).
access_vector(allow,syslogd_t,self,tcp_socket,read).
access_vector(allow,syslogd_t,self,tcp_socket,getattr).
access_vector(allow,syslogd_t,self,tcp_socket,write).
access_vector(allow,syslogd_t,self,tcp_socket,setattr).
access_vector(allow,syslogd_t,self,tcp_socket,append).
access_vector(allow,syslogd_t,self,tcp_socket,bind).
access_vector(allow,syslogd_t,self,tcp_socket,connect).
access_vector(allow,syslogd_t,self,tcp_socket,getopt).
access_vector(allow,syslogd_t,self,tcp_socket,setopt).
access_vector(allow,syslogd_t,self,tcp_socket,shutdown).
access_vector(allow,syslogd_t,self,tcp_socket,listen).
access_vector(allow,syslogd_t,self,tcp_socket,accept).
access_vector(allow,syslogd_t,any_socket_t,udp_socket,sendto).
access_vector(allow,syslogd_t,netif_type,netif,tcp_send).
access_vector(allow,syslogd_t,netif_type,netif,udp_send).
access_vector(allow,syslogd_t,netif_type,netif,rawip_send).
access_vector(allow,syslogd_t,netif_type,netif,tcp_recv).
access_vector(allow,syslogd_t,netif_type,netif,udp_recv).
access_vector(allow,syslogd_t,netif_type,netif,rawip_recv).
access_vector(allow,syslogd_t,netmsg_type,udp_socket,recvfrom).
access_vector(allow,syslogd_t,netmsg_type,tcp_socket,recvfrom).
access_vector(allow,syslogd_t,netmsg_type,rawip_socket,recvfrom).
access_vector(allow,syslogd_t,netmsg_type,tcp_socket,connectto).
access_vector(allow,syslogd_t,netmsg_type,tcp_socket,acceptfrom).
access_vector(allow,syslogd_t,tcp_socket_t,tcp_socket,recvfrom).
access_vector(dontaudit,syslogd_t,tcp_socket_t,tcp_socket,connectto).
access_vector(allow,syslogd_t,node_type,node,tcp_send).
access_vector(allow,syslogd_t,node_type,node,udp_send).
access_vector(allow,syslogd_t,node_type,node,rawip_send).
access_vector(allow,syslogd_t,node_type,node,tcp_recv).
access_vector(allow,syslogd_t,node_type,node,udp_recv).
access_vector(allow,syslogd_t,node_type,node,rawip_recv).
access_vector(allow,syslogd_t,mount_t,udp_socket,ioctl).
access_vector(allow,syslogd_t,mount_t,udp_socket,read).
access_vector(allow,syslogd_t,mount_t,udp_socket,getattr).
access_vector(allow,syslogd_t,mount_t,udp_socket,write).
access_vector(allow,syslogd_t,mount_t,udp_socket,setattr).
access_vector(allow,syslogd_t,mount_t,udp_socket,append).
access_vector(allow,syslogd_t,mount_t,udp_socket,bind).
access_vector(allow,syslogd_t,mount_t,udp_socket,connect).
access_vector(allow,syslogd_t,mount_t,udp_socket,getopt).
access_vector(allow,syslogd_t,mount_t,udp_socket,setopt).
access_vector(allow,syslogd_t,mount_t,udp_socket,shutdown).
access_vector(allow,syslogd_t,port_t,udp_socket,name_bind).
access_vector(allow,syslogd_t,port_t,tcp_socket,name_bind).
type_decl(devlog_t,[],[file_type,sysadmfile]).
access_vector(allow,privlog,console_device_t,chr_file,ioctl).
access_vector(allow,privlog,console_device_t,chr_file,read).
access_vector(allow,privlog,console_device_t,chr_file,write).
access_vector(allow,privlog,console_device_t,chr_file,getattr).
type_decl(syslogd_tmp_t,[],[file_type,sysadmfile,tmpfile]).
access_vector(allow,syslogd_t,tmp_t,dir,read).
access_vector(allow,syslogd_t,tmp_t,dir,getattr).
access_vector(allow,syslogd_t,tmp_t,dir,lock).
access_vector(allow,syslogd_t,tmp_t,dir,search).
access_vector(allow,syslogd_t,tmp_t,dir,ioctl).
access_vector(allow,syslogd_t,tmp_t,dir,add_name).
access_vector(allow,syslogd_t,tmp_t,dir,remove_name).
access_vector(allow,syslogd_t,tmp_t,dir,write).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,create).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,ioctl).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,read).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,getattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,lock).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,write).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,setattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,append).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,link).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,unlink).
access_vector(allow,syslogd_t,syslogd_tmp_t,file,rename).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,create).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,ioctl).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,read).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,getattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,lock).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,write).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,setattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,append).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,link).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,unlink).
access_vector(allow,syslogd_t,syslogd_tmp_t,lnk_file,rename).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,create).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,ioctl).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,read).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,getattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,lock).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,write).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,setattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,append).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,link).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,unlink).
access_vector(allow,syslogd_t,syslogd_tmp_t,sock_file,rename).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,create).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,ioctl).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,read).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,getattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,lock).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,write).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,setattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,append).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,link).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,unlink).
access_vector(allow,syslogd_t,syslogd_tmp_t,fifo_file,rename).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,create).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,read).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,getattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,lock).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,setattr).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,link).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,unlink).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,rename).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,search).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,add_name).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,remove_name).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,reparent).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,write).
access_vector(allow,syslogd_t,syslogd_tmp_t,dir,rmdir).
type_trans(syslogd_t,tmp_t,dir,syslogd_tmp_t).
type_trans(syslogd_t,tmp_t,[file,lnk_file,sock_file,fifo_file],syslogd_tmp_t).
access_vector(allow,syslogd_t,etc_t,file,read).
access_vector(allow,syslogd_t,etc_t,file,getattr).
access_vector(allow,syslogd_t,etc_t,file,lock).
access_vector(allow,syslogd_t,etc_t,file,ioctl).
access_vector(allow,syslogd_t,resolv_conf_t,file,read).
access_vector(allow,syslogd_t,resolv_conf_t,file,getattr).
access_vector(allow,syslogd_t,resolv_conf_t,file,lock).
access_vector(allow,syslogd_t,resolv_conf_t,file,ioctl).
access_vector(allow,syslogd_t,resolv_conf_t,lnk_file,read).
access_vector(allow,syslogd_t,resolv_conf_t,lnk_file,getattr).
access_vector(allow,syslogd_t,resolv_conf_t,lnk_file,lock).
access_vector(allow,syslogd_t,resolv_conf_t,lnk_file,ioctl).
access_vector(allow,syslogd_t,syslogd_t,capability,net_bind_service).
access_vector(allow,syslogd_t,syslogd_t,capability,dac_override).
access_vector(allow,syslogd_t,init_t,fd,use).
access_vector(allow,syslogd_t,initrc_devpts_t,chr_file,read).
access_vector(allow,syslogd_t,initrc_devpts_t,chr_file,write).
access_vector(allow,syslogd_t,console_device_t,chr_file,read).
access_vector(allow,syslogd_t,console_device_t,chr_file,write).
access_vector(allow,syslogd_t,var_log_t,dir,read).
access_vector(allow,syslogd_t,var_log_t,dir,getattr).
access_vector(allow,syslogd_t,var_log_t,dir,search).
access_vector(allow,syslogd_t,var_log_t,dir,add_name).
access_vector(allow,syslogd_t,var_log_t,dir,write).
access_vector(allow,syslogd_t,var_log_t,file,create).
access_vector(allow,syslogd_t,var_log_t,file,ioctl).
access_vector(allow,syslogd_t,var_log_t,file,getattr).
access_vector(allow,syslogd_t,var_log_t,file,setattr).
access_vector(allow,syslogd_t,var_log_t,file,append).
access_vector(allow,syslogd_t,var_log_t,file,link).
access_vector(allow,syslogd_t,device_t,dir,read).
access_vector(allow,syslogd_t,device_t,dir,getattr).
access_vector(allow,syslogd_t,device_t,dir,lock).
access_vector(allow,syslogd_t,device_t,dir,search).
access_vector(allow,syslogd_t,device_t,dir,ioctl).
access_vector(allow,syslogd_t,device_t,dir,add_name).
access_vector(allow,syslogd_t,device_t,dir,remove_name).
access_vector(allow,syslogd_t,device_t,dir,write).
access_vector(allow,syslogd_t,devlog_t,sock_file,create).
access_vector(allow,syslogd_t,devlog_t,sock_file,ioctl).
access_vector(allow,syslogd_t,devlog_t,sock_file,read).
access_vector(allow,syslogd_t,devlog_t,sock_file,getattr).
access_vector(allow,syslogd_t,devlog_t,sock_file,lock).
access_vector(allow,syslogd_t,devlog_t,sock_file,write).
access_vector(allow,syslogd_t,devlog_t,sock_file,setattr).
access_vector(allow,syslogd_t,devlog_t,sock_file,append).
access_vector(allow,syslogd_t,devlog_t,sock_file,link).
access_vector(allow,syslogd_t,devlog_t,sock_file,unlink).
access_vector(allow,syslogd_t,devlog_t,sock_file,rename).
type_trans(syslogd_t,[device_t,var_run_t],sock_file,devlog_t).
access_vector(allow,syslogd_t,self,unix_dgram_socket,create).
access_vector(allow,syslogd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,syslogd_t,self,unix_dgram_socket,read).
access_vector(allow,syslogd_t,self,unix_dgram_socket,getattr).
access_vector(allow,syslogd_t,self,unix_dgram_socket,write).
access_vector(allow,syslogd_t,self,unix_dgram_socket,setattr).
access_vector(allow,syslogd_t,self,unix_dgram_socket,append).
access_vector(allow,syslogd_t,self,unix_dgram_socket,bind).
access_vector(allow,syslogd_t,self,unix_dgram_socket,connect).
access_vector(allow,syslogd_t,self,unix_dgram_socket,getopt).
access_vector(allow,syslogd_t,self,unix_dgram_socket,setopt).
access_vector(allow,syslogd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,syslogd_t,self,unix_dgram_socket,sendto).
access_vector(allow,syslogd_t,self,unix_stream_socket,create).
access_vector(allow,syslogd_t,self,unix_stream_socket,ioctl).
access_vector(allow,syslogd_t,self,unix_stream_socket,read).
access_vector(allow,syslogd_t,self,unix_stream_socket,getattr).
access_vector(allow,syslogd_t,self,unix_stream_socket,write).
access_vector(allow,syslogd_t,self,unix_stream_socket,setattr).
access_vector(allow,syslogd_t,self,unix_stream_socket,append).
access_vector(allow,syslogd_t,self,unix_stream_socket,bind).
access_vector(allow,syslogd_t,self,unix_stream_socket,connect).
access_vector(allow,syslogd_t,self,unix_stream_socket,getopt).
access_vector(allow,syslogd_t,self,unix_stream_socket,setopt).
access_vector(allow,syslogd_t,self,unix_stream_socket,shutdown).
access_vector(allow,syslogd_t,self,unix_stream_socket,listen).
access_vector(allow,syslogd_t,self,unix_stream_socket,accept).
access_vector(allow,syslogd_t,devlog_t,unix_stream_socket,name_bind).
access_vector(allow,syslogd_t,devlog_t,unix_dgram_socket,name_bind).
access_vector(allow,privlog,devlog_t,sock_file,ioctl).
access_vector(allow,privlog,devlog_t,sock_file,read).
access_vector(allow,privlog,devlog_t,sock_file,getattr).
access_vector(allow,privlog,devlog_t,sock_file,lock).
access_vector(allow,privlog,devlog_t,sock_file,write).
access_vector(allow,privlog,devlog_t,sock_file,append).
access_vector(allow,privlog,syslogd_t,unix_dgram_socket,sendto).
access_vector(allow,privlog,syslogd_t,unix_stream_socket,connectto).
access_vector(allow,privlog,devlog_t,lnk_file,read).
access_vector(allow,syslogd_t,cron_log_t,file,ioctl).
access_vector(allow,syslogd_t,cron_log_t,file,read).
access_vector(allow,syslogd_t,cron_log_t,file,getattr).
access_vector(allow,syslogd_t,cron_log_t,file,lock).
access_vector(allow,syslogd_t,cron_log_t,file,write).
access_vector(allow,syslogd_t,cron_log_t,file,append).
access_vector(allow,logrotate_t,syslogd_exec_t,file,read).
access_vector(allow,logrotate_t,syslogd_exec_t,file,getattr).
access_vector(allow,logrotate_t,syslogd_exec_t,file,lock).
access_vector(allow,logrotate_t,syslogd_exec_t,file,ioctl).
type_decl(tmpreaper_t,[],[domain,privlog]).
type_decl(tmpreaper_exec_t,[],[file_type,sysadmfile,exec_type]).
role_decl(system_r,tmpreaper_t).
access_vector(allow,system_crond_t,tmpreaper_t,process,transition).
access_vector(dontaudit,system_crond_t,tmpreaper_t,process,noatsecure).
access_vector(allow,system_crond_t,tmpreaper_exec_t,file,read).
access_vector(allow,system_crond_t,tmpreaper_exec_t,file,getattr).
access_vector(allow,system_crond_t,tmpreaper_exec_t,file,execute).
access_vector(allow,tmpreaper_t,system_crond_t,process,sigchld).
access_vector(allow,tmpreaper_t,system_crond_t,fd,use).
access_vector(allow,system_crond_t,tmpreaper_t,fd,use).
access_vector(allow,tmpreaper_t,system_crond_t,fifo_file,ioctl).
access_vector(allow,tmpreaper_t,system_crond_t,fifo_file,read).
access_vector(allow,tmpreaper_t,system_crond_t,fifo_file,getattr).
access_vector(allow,tmpreaper_t,system_crond_t,fifo_file,lock).
access_vector(allow,tmpreaper_t,system_crond_t,fifo_file,write).
access_vector(allow,tmpreaper_t,system_crond_t,fifo_file,append).
access_vector(allow,tmpreaper_t,tmpreaper_exec_t,file,read).
access_vector(allow,tmpreaper_t,tmpreaper_exec_t,file,getattr).
access_vector(allow,tmpreaper_t,tmpreaper_exec_t,file,lock).
access_vector(allow,tmpreaper_t,tmpreaper_exec_t,file,execute).
access_vector(allow,tmpreaper_t,tmpreaper_exec_t,file,ioctl).
access_vector(allow,tmpreaper_t,tmpreaper_exec_t,file,entrypoint).
type_trans(system_crond_t,tmpreaper_exec_t,process,tmpreaper_t).
access_vector(allow,tmpreaper_t,crond_t,fifo_file,getattr).
access_vector(allow,tmpreaper_t,crond_t,fifo_file,read).
access_vector(allow,tmpreaper_t,crond_t,fifo_file,write).
access_vector(allow,tmpreaper_t,crond_t,fifo_file,ioctl).
access_vector(allow,tmpreaper_t,crond_t,fd,use).
access_vector(allow,tmpreaper_t,crond_t,process,sigchld).
access_vector(allow,tmpreaper_t,root_t,dir,read).
access_vector(allow,tmpreaper_t,root_t,dir,getattr).
access_vector(allow,tmpreaper_t,root_t,dir,lock).
access_vector(allow,tmpreaper_t,root_t,dir,search).
access_vector(allow,tmpreaper_t,root_t,dir,ioctl).
access_vector(allow,tmpreaper_t,usr_t,dir,read).
access_vector(allow,tmpreaper_t,usr_t,dir,getattr).
access_vector(allow,tmpreaper_t,usr_t,dir,lock).
access_vector(allow,tmpreaper_t,usr_t,dir,search).
access_vector(allow,tmpreaper_t,usr_t,dir,ioctl).
access_vector(allow,tmpreaper_t,lib_t,dir,read).
access_vector(allow,tmpreaper_t,lib_t,dir,getattr).
access_vector(allow,tmpreaper_t,lib_t,dir,lock).
access_vector(allow,tmpreaper_t,lib_t,dir,search).
access_vector(allow,tmpreaper_t,lib_t,dir,ioctl).
access_vector(allow,tmpreaper_t,etc_t,dir,read).
access_vector(allow,tmpreaper_t,etc_t,dir,getattr).
access_vector(allow,tmpreaper_t,etc_t,dir,lock).
access_vector(allow,tmpreaper_t,etc_t,dir,search).
access_vector(allow,tmpreaper_t,etc_t,dir,ioctl).
access_vector(allow,tmpreaper_t,lib_t,lnk_file,read).
access_vector(allow,tmpreaper_t,lib_t,lnk_file,getattr).
access_vector(allow,tmpreaper_t,lib_t,lnk_file,lock).
access_vector(allow,tmpreaper_t,lib_t,lnk_file,ioctl).
access_vector(allow,tmpreaper_t,ld_so_t,file,read).
access_vector(allow,tmpreaper_t,ld_so_t,file,getattr).
access_vector(allow,tmpreaper_t,ld_so_t,file,lock).
access_vector(allow,tmpreaper_t,ld_so_t,file,execute).
access_vector(allow,tmpreaper_t,ld_so_t,file,ioctl).
access_vector(allow,tmpreaper_t,ld_so_t,file,execute_no_trans).
access_vector(allow,tmpreaper_t,ld_so_t,lnk_file,read).
access_vector(allow,tmpreaper_t,ld_so_t,lnk_file,getattr).
access_vector(allow,tmpreaper_t,ld_so_t,lnk_file,lock).
access_vector(allow,tmpreaper_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,tmpreaper_t,shlib_t,file,read).
access_vector(allow,tmpreaper_t,shlib_t,file,getattr).
access_vector(allow,tmpreaper_t,shlib_t,file,lock).
access_vector(allow,tmpreaper_t,shlib_t,file,execute).
access_vector(allow,tmpreaper_t,shlib_t,file,ioctl).
access_vector(allow,tmpreaper_t,shlib_t,lnk_file,read).
access_vector(allow,tmpreaper_t,shlib_t,lnk_file,getattr).
access_vector(allow,tmpreaper_t,shlib_t,lnk_file,lock).
access_vector(allow,tmpreaper_t,shlib_t,lnk_file,ioctl).
access_vector(allow,tmpreaper_t,ld_so_cache_t,file,read).
access_vector(allow,tmpreaper_t,ld_so_cache_t,file,getattr).
access_vector(allow,tmpreaper_t,ld_so_cache_t,file,lock).
access_vector(allow,tmpreaper_t,ld_so_cache_t,file,ioctl).
access_vector(allow,tmpreaper_t,device_t,dir,search).
access_vector(allow,tmpreaper_t,null_device_t,chr_file,ioctl).
access_vector(allow,tmpreaper_t,null_device_t,chr_file,read).
access_vector(allow,tmpreaper_t,null_device_t,chr_file,getattr).
access_vector(allow,tmpreaper_t,null_device_t,chr_file,lock).
access_vector(allow,tmpreaper_t,null_device_t,chr_file,write).
access_vector(allow,tmpreaper_t,null_device_t,chr_file,append).
access_vector(allow,tmpreaper_t,tmpfile,dir,read).
access_vector(allow,tmpreaper_t,tmpfile,dir,getattr).
access_vector(allow,tmpreaper_t,tmpfile,dir,lock).
access_vector(allow,tmpreaper_t,tmpfile,dir,search).
access_vector(allow,tmpreaper_t,tmpfile,dir,ioctl).
access_vector(allow,tmpreaper_t,tmpfile,dir,add_name).
access_vector(allow,tmpreaper_t,tmpfile,dir,remove_name).
access_vector(allow,tmpreaper_t,tmpfile,dir,write).
access_vector(allow,tmpreaper_t,tmpfile,dir,rmdir).
access_vector(allow,tmpreaper_t,tmpfile,file,getattr).
access_vector(allow,tmpreaper_t,tmpfile,file,unlink).
access_vector(allow,tmpreaper_t,tmpfile,lnk_file,getattr).
access_vector(allow,tmpreaper_t,tmpfile,lnk_file,unlink).
access_vector(allow,tmpreaper_t,tmpfile,sock_file,getattr).
access_vector(allow,tmpreaper_t,tmpfile,sock_file,unlink).
access_vector(allow,tmpreaper_t,tmpfile,fifo_file,getattr).
access_vector(allow,tmpreaper_t,tmpfile,fifo_file,unlink).
access_vector(allow,tmpreaper_t,home_type,file,getattr).
access_vector(allow,tmpreaper_t,home_type,file,unlink).
access_vector(allow,tmpreaper_t,home_type,lnk_file,getattr).
access_vector(allow,tmpreaper_t,home_type,lnk_file,unlink).
access_vector(allow,tmpreaper_t,home_type,sock_file,getattr).
access_vector(allow,tmpreaper_t,home_type,sock_file,unlink).
access_vector(allow,tmpreaper_t,home_type,fifo_file,getattr).
access_vector(allow,tmpreaper_t,home_type,fifo_file,unlink).
access_vector(allow,tmpreaper_t,self,process,fork).
access_vector(allow,tmpreaper_t,self,process,sigchld).
access_vector(allow,tmpreaper_t,self,capability,dac_override).
access_vector(allow,tmpreaper_t,self,capability,dac_read_search).
access_vector(allow,tmpreaper_t,self,capability,fowner).
access_vector(allow,tmpreaper_t,fs_t,filesystem,getattr).
access_vector(allow,tmpreaper_t,etc_t,file,read).
access_vector(allow,tmpreaper_t,etc_t,file,getattr).
access_vector(allow,tmpreaper_t,etc_t,file,lock).
access_vector(allow,tmpreaper_t,etc_t,file,ioctl).
access_vector(allow,tmpreaper_t,etc_t,lnk_file,read).
access_vector(allow,tmpreaper_t,etc_t,lnk_file,getattr).
access_vector(allow,tmpreaper_t,etc_t,lnk_file,lock).
access_vector(allow,tmpreaper_t,etc_t,lnk_file,ioctl).
access_vector(allow,tmpreaper_t,var_t,dir,getattr).
access_vector(allow,tmpreaper_t,var_t,dir,search).
access_vector(allow,tmpreaper_t,var_lib_t,dir,read).
access_vector(allow,tmpreaper_t,var_lib_t,dir,getattr).
access_vector(allow,tmpreaper_t,var_lib_t,dir,lock).
access_vector(allow,tmpreaper_t,var_lib_t,dir,search).
access_vector(allow,tmpreaper_t,var_lib_t,dir,ioctl).
access_vector(allow,tmpreaper_t,var_lib_t,file,read).
access_vector(allow,tmpreaper_t,var_lib_t,file,getattr).
access_vector(allow,tmpreaper_t,var_lib_t,file,lock).
access_vector(allow,tmpreaper_t,var_lib_t,file,ioctl).
access_vector(allow,tmpreaper_t,var_lib_t,lnk_file,read).
access_vector(allow,tmpreaper_t,var_lib_t,lnk_file,getattr).
access_vector(allow,tmpreaper_t,var_lib_t,lnk_file,lock).
access_vector(allow,tmpreaper_t,var_lib_t,lnk_file,ioctl).
access_vector(allow,tmpreaper_t,device_t,dir,getattr).
access_vector(allow,tmpreaper_t,device_t,dir,search).
access_vector(allow,tmpreaper_t,random_device_t,chr_file,getattr).
access_vector(allow,tmpreaper_t,random_device_t,chr_file,read).
type_decl(useradd_t,[],[domain,privlog,auth,privowner]).
role_decl(sysadm_r,useradd_t).
access_vector(allow,useradd_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,useradd_t,self,dir,read).
access_vector(allow,useradd_t,self,dir,getattr).
access_vector(allow,useradd_t,self,dir,lock).
access_vector(allow,useradd_t,self,dir,search).
access_vector(allow,useradd_t,self,dir,ioctl).
access_vector(allow,useradd_t,self,file,read).
access_vector(allow,useradd_t,self,file,getattr).
access_vector(allow,useradd_t,self,file,lock).
access_vector(allow,useradd_t,self,file,ioctl).
access_vector(allow,useradd_t,self,lnk_file,read).
access_vector(allow,useradd_t,self,lnk_file,getattr).
access_vector(allow,useradd_t,self,lnk_file,lock).
access_vector(allow,useradd_t,self,lnk_file,ioctl).
access_vector(allow,useradd_t,self,sock_file,read).
access_vector(allow,useradd_t,self,sock_file,getattr).
access_vector(allow,useradd_t,self,sock_file,lock).
access_vector(allow,useradd_t,self,sock_file,ioctl).
access_vector(allow,useradd_t,self,fifo_file,read).
access_vector(allow,useradd_t,self,fifo_file,getattr).
access_vector(allow,useradd_t,self,fifo_file,lock).
access_vector(allow,useradd_t,self,fifo_file,ioctl).
access_vector(allow,useradd_t,self,fd,_).
access_vector(allow,useradd_t,self,fifo_file,ioctl).
access_vector(allow,useradd_t,self,fifo_file,read).
access_vector(allow,useradd_t,self,fifo_file,getattr).
access_vector(allow,useradd_t,self,fifo_file,lock).
access_vector(allow,useradd_t,self,fifo_file,write).
access_vector(allow,useradd_t,self,fifo_file,append).
access_vector(allow,useradd_t,self,unix_dgram_socket,create).
access_vector(allow,useradd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,useradd_t,self,unix_dgram_socket,read).
access_vector(allow,useradd_t,self,unix_dgram_socket,getattr).
access_vector(allow,useradd_t,self,unix_dgram_socket,write).
access_vector(allow,useradd_t,self,unix_dgram_socket,setattr).
access_vector(allow,useradd_t,self,unix_dgram_socket,append).
access_vector(allow,useradd_t,self,unix_dgram_socket,bind).
access_vector(allow,useradd_t,self,unix_dgram_socket,connect).
access_vector(allow,useradd_t,self,unix_dgram_socket,getopt).
access_vector(allow,useradd_t,self,unix_dgram_socket,setopt).
access_vector(allow,useradd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,useradd_t,self,unix_stream_socket,create).
access_vector(allow,useradd_t,self,unix_stream_socket,ioctl).
access_vector(allow,useradd_t,self,unix_stream_socket,read).
access_vector(allow,useradd_t,self,unix_stream_socket,getattr).
access_vector(allow,useradd_t,self,unix_stream_socket,write).
access_vector(allow,useradd_t,self,unix_stream_socket,setattr).
access_vector(allow,useradd_t,self,unix_stream_socket,append).
access_vector(allow,useradd_t,self,unix_stream_socket,bind).
access_vector(allow,useradd_t,self,unix_stream_socket,connect).
access_vector(allow,useradd_t,self,unix_stream_socket,getopt).
access_vector(allow,useradd_t,self,unix_stream_socket,setopt).
access_vector(allow,useradd_t,self,unix_stream_socket,shutdown).
access_vector(allow,useradd_t,self,unix_stream_socket,listen).
access_vector(allow,useradd_t,self,unix_stream_socket,accept).
access_vector(allow,useradd_t,self,unix_dgram_socket,sendto).
access_vector(allow,useradd_t,self,unix_stream_socket,connectto).
access_vector(allow,useradd_t,self,sem,associate).
access_vector(allow,useradd_t,self,sem,getattr).
access_vector(allow,useradd_t,self,sem,setattr).
access_vector(allow,useradd_t,self,sem,create).
access_vector(allow,useradd_t,self,sem,destroy).
access_vector(allow,useradd_t,self,sem,read).
access_vector(allow,useradd_t,self,sem,write).
access_vector(allow,useradd_t,self,sem,unix_read).
access_vector(allow,useradd_t,self,sem,unix_write).
access_vector(allow,useradd_t,self,msg,send).
access_vector(allow,useradd_t,self,msg,receive).
access_vector(allow,useradd_t,self,msgq,associate).
access_vector(allow,useradd_t,self,msgq,getattr).
access_vector(allow,useradd_t,self,msgq,setattr).
access_vector(allow,useradd_t,self,msgq,create).
access_vector(allow,useradd_t,self,msgq,destroy).
access_vector(allow,useradd_t,self,msgq,read).
access_vector(allow,useradd_t,self,msgq,write).
access_vector(allow,useradd_t,self,msgq,enqueue).
access_vector(allow,useradd_t,self,msgq,unix_read).
access_vector(allow,useradd_t,self,msgq,unix_write).
access_vector(allow,useradd_t,self,shm,associate).
access_vector(allow,useradd_t,self,shm,getattr).
access_vector(allow,useradd_t,self,shm,setattr).
access_vector(allow,useradd_t,self,shm,create).
access_vector(allow,useradd_t,self,shm,destroy).
access_vector(allow,useradd_t,self,shm,read).
access_vector(allow,useradd_t,self,shm,write).
access_vector(allow,useradd_t,self,shm,lock).
access_vector(allow,useradd_t,self,shm,unix_read).
access_vector(allow,useradd_t,self,shm,unix_write).
access_vector(allow,useradd_t,root_t,dir,read).
access_vector(allow,useradd_t,root_t,dir,getattr).
access_vector(allow,useradd_t,root_t,dir,lock).
access_vector(allow,useradd_t,root_t,dir,search).
access_vector(allow,useradd_t,root_t,dir,ioctl).
access_vector(allow,useradd_t,usr_t,dir,read).
access_vector(allow,useradd_t,usr_t,dir,getattr).
access_vector(allow,useradd_t,usr_t,dir,lock).
access_vector(allow,useradd_t,usr_t,dir,search).
access_vector(allow,useradd_t,usr_t,dir,ioctl).
access_vector(allow,useradd_t,lib_t,dir,read).
access_vector(allow,useradd_t,lib_t,dir,getattr).
access_vector(allow,useradd_t,lib_t,dir,lock).
access_vector(allow,useradd_t,lib_t,dir,search).
access_vector(allow,useradd_t,lib_t,dir,ioctl).
access_vector(allow,useradd_t,etc_t,dir,read).
access_vector(allow,useradd_t,etc_t,dir,getattr).
access_vector(allow,useradd_t,etc_t,dir,lock).
access_vector(allow,useradd_t,etc_t,dir,search).
access_vector(allow,useradd_t,etc_t,dir,ioctl).
access_vector(allow,useradd_t,lib_t,lnk_file,read).
access_vector(allow,useradd_t,lib_t,lnk_file,getattr).
access_vector(allow,useradd_t,lib_t,lnk_file,lock).
access_vector(allow,useradd_t,lib_t,lnk_file,ioctl).
access_vector(allow,useradd_t,ld_so_t,file,read).
access_vector(allow,useradd_t,ld_so_t,file,getattr).
access_vector(allow,useradd_t,ld_so_t,file,lock).
access_vector(allow,useradd_t,ld_so_t,file,execute).
access_vector(allow,useradd_t,ld_so_t,file,ioctl).
access_vector(allow,useradd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,useradd_t,ld_so_t,lnk_file,read).
access_vector(allow,useradd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,useradd_t,ld_so_t,lnk_file,lock).
access_vector(allow,useradd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,useradd_t,shlib_t,file,read).
access_vector(allow,useradd_t,shlib_t,file,getattr).
access_vector(allow,useradd_t,shlib_t,file,lock).
access_vector(allow,useradd_t,shlib_t,file,execute).
access_vector(allow,useradd_t,shlib_t,file,ioctl).
access_vector(allow,useradd_t,shlib_t,lnk_file,read).
access_vector(allow,useradd_t,shlib_t,lnk_file,getattr).
access_vector(allow,useradd_t,shlib_t,lnk_file,lock).
access_vector(allow,useradd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,useradd_t,ld_so_cache_t,file,read).
access_vector(allow,useradd_t,ld_so_cache_t,file,getattr).
access_vector(allow,useradd_t,ld_so_cache_t,file,lock).
access_vector(allow,useradd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,useradd_t,device_t,dir,search).
access_vector(allow,useradd_t,null_device_t,chr_file,ioctl).
access_vector(allow,useradd_t,null_device_t,chr_file,read).
access_vector(allow,useradd_t,null_device_t,chr_file,getattr).
access_vector(allow,useradd_t,null_device_t,chr_file,lock).
access_vector(allow,useradd_t,null_device_t,chr_file,write).
access_vector(allow,useradd_t,null_device_t,chr_file,append).
type_decl(useradd_exec_t,[],[file_type,sysadmfile,exec_type]).
access_vector(allow,sysadm_t,useradd_t,process,transition).
access_vector(dontaudit,sysadm_t,useradd_t,process,noatsecure).
access_vector(allow,sysadm_t,useradd_exec_t,file,read).
access_vector(allow,sysadm_t,useradd_exec_t,file,getattr).
access_vector(allow,sysadm_t,useradd_exec_t,file,execute).
access_vector(allow,useradd_t,sysadm_t,process,sigchld).
access_vector(allow,useradd_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,useradd_t,fd,use).
access_vector(allow,useradd_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,useradd_t,sysadm_t,fifo_file,read).
access_vector(allow,useradd_t,sysadm_t,fifo_file,getattr).
access_vector(allow,useradd_t,sysadm_t,fifo_file,lock).
access_vector(allow,useradd_t,sysadm_t,fifo_file,write).
access_vector(allow,useradd_t,sysadm_t,fifo_file,append).
access_vector(allow,useradd_t,useradd_exec_t,file,read).
access_vector(allow,useradd_t,useradd_exec_t,file,getattr).
access_vector(allow,useradd_t,useradd_exec_t,file,lock).
access_vector(allow,useradd_t,useradd_exec_t,file,execute).
access_vector(allow,useradd_t,useradd_exec_t,file,ioctl).
access_vector(allow,useradd_t,useradd_exec_t,file,entrypoint).
type_trans(sysadm_t,useradd_exec_t,process,useradd_t).
access_vector(allow,useradd_t,self,capability,dac_override).
access_vector(allow,useradd_t,self,capability,chown).
access_vector(allow,useradd_t,security_t,dir,read).
access_vector(allow,useradd_t,security_t,dir,search).
access_vector(allow,useradd_t,security_t,dir,getattr).
access_vector(allow,useradd_t,security_t,file,getattr).
access_vector(allow,useradd_t,security_t,file,read).
access_vector(allow,useradd_t,security_t,file,write).
access_vector(allow,useradd_t,security_t,security,check_context).
access_vector(allow,useradd_t,security_t,security,compute_av).
access_vector(allow,useradd_t,security_t,security,compute_create).
access_vector(allow,useradd_t,security_t,security,compute_relabel).
access_vector(allow,useradd_t,security_t,security,compute_user).
access_vector(allow,useradd_t,privfd,fd,use).
access_vector(allow,useradd_t,etc_t,dir,read).
access_vector(allow,useradd_t,etc_t,dir,getattr).
access_vector(allow,useradd_t,etc_t,dir,lock).
access_vector(allow,useradd_t,etc_t,dir,search).
access_vector(allow,useradd_t,etc_t,dir,ioctl).
access_vector(allow,useradd_t,etc_t,dir,add_name).
access_vector(allow,useradd_t,etc_t,dir,remove_name).
access_vector(allow,useradd_t,etc_t,dir,write).
access_vector(allow,useradd_t,shadow_t,file,create).
access_vector(allow,useradd_t,shadow_t,file,ioctl).
access_vector(allow,useradd_t,shadow_t,file,read).
access_vector(allow,useradd_t,shadow_t,file,getattr).
access_vector(allow,useradd_t,shadow_t,file,lock).
access_vector(allow,useradd_t,shadow_t,file,write).
access_vector(allow,useradd_t,shadow_t,file,setattr).
access_vector(allow,useradd_t,shadow_t,file,append).
access_vector(allow,useradd_t,shadow_t,file,link).
access_vector(allow,useradd_t,shadow_t,file,unlink).
access_vector(allow,useradd_t,shadow_t,file,rename).
type_trans(useradd_t,etc_t,file,shadow_t).
access_vector(allow,useradd_t,etc_t,file,create).
access_vector(allow,useradd_t,etc_t,file,ioctl).
access_vector(allow,useradd_t,etc_t,file,read).
access_vector(allow,useradd_t,etc_t,file,getattr).
access_vector(allow,useradd_t,etc_t,file,lock).
access_vector(allow,useradd_t,etc_t,file,write).
access_vector(allow,useradd_t,etc_t,file,setattr).
access_vector(allow,useradd_t,etc_t,file,append).
access_vector(allow,useradd_t,etc_t,file,link).
access_vector(allow,useradd_t,etc_t,file,unlink).
access_vector(allow,useradd_t,etc_t,file,rename).
access_vector(allow,useradd_t,self,process,setfscreate).
access_vector(allow,useradd_t,proc_t,dir,search).
access_vector(allow,useradd_t,proc_t,lnk_file,read).
access_vector(allow,useradd_t,self,dir,search).
access_vector(allow,useradd_t,self,file,read).
access_vector(allow,useradd_t,self,file,write).
access_vector(allow,useradd_t,etc_t,file,relabelfrom).
access_vector(allow,useradd_t,etc_t,file,relabelto).
access_vector(allow,useradd_t,shadow_t,file,relabelfrom).
access_vector(allow,useradd_t,shadow_t,file,relabelto).
access_vector(allow,useradd_t,etc_t,lnk_file,read).
access_vector(allow,useradd_t,locale_t,dir,read).
access_vector(allow,useradd_t,locale_t,dir,getattr).
access_vector(allow,useradd_t,locale_t,dir,lock).
access_vector(allow,useradd_t,locale_t,dir,search).
access_vector(allow,useradd_t,locale_t,dir,ioctl).
access_vector(allow,useradd_t,locale_t,file,read).
access_vector(allow,useradd_t,locale_t,file,getattr).
access_vector(allow,useradd_t,locale_t,file,lock).
access_vector(allow,useradd_t,locale_t,file,ioctl).
access_vector(allow,useradd_t,locale_t,lnk_file,read).
access_vector(allow,useradd_t,locale_t,lnk_file,getattr).
access_vector(allow,useradd_t,locale_t,lnk_file,lock).
access_vector(allow,useradd_t,locale_t,lnk_file,ioctl).
access_vector(dontaudit,useradd_t,device_t,dir,search).
access_vector(dontaudit,useradd_t,var_t,dir,search).
access_vector(dontaudit,useradd_t,var_log_t,dir,search).
access_vector(allow,useradd_t,fs_t,filesystem,getattr).
access_vector(allow,useradd_t,ttyfile,chr_file,ioctl).
access_vector(allow,useradd_t,ttyfile,chr_file,read).
access_vector(allow,useradd_t,ttyfile,chr_file,getattr).
access_vector(allow,useradd_t,ttyfile,chr_file,lock).
access_vector(allow,useradd_t,ttyfile,chr_file,write).
access_vector(allow,useradd_t,ttyfile,chr_file,append).
access_vector(allow,useradd_t,ptyfile,chr_file,ioctl).
access_vector(allow,useradd_t,ptyfile,chr_file,read).
access_vector(allow,useradd_t,ptyfile,chr_file,getattr).
access_vector(allow,useradd_t,ptyfile,chr_file,lock).
access_vector(allow,useradd_t,ptyfile,chr_file,write).
access_vector(allow,useradd_t,ptyfile,chr_file,append).
access_vector(dontaudit,useradd_t,sysadm_home_dir_t,dir,search).
access_vector(allow,useradd_t,home_root_t,dir,read).
access_vector(allow,useradd_t,home_root_t,dir,getattr).
access_vector(allow,useradd_t,home_root_t,dir,lock).
access_vector(allow,useradd_t,home_root_t,dir,search).
access_vector(allow,useradd_t,home_root_t,dir,ioctl).
access_vector(allow,useradd_t,home_root_t,dir,add_name).
access_vector(allow,useradd_t,home_root_t,dir,remove_name).
access_vector(allow,useradd_t,home_root_t,dir,write).
access_vector(allow,useradd_t,user_home_dir_t,dir,create).
access_vector(allow,useradd_t,user_home_dir_t,dir,read).
access_vector(allow,useradd_t,user_home_dir_t,dir,getattr).
access_vector(allow,useradd_t,user_home_dir_t,dir,lock).
access_vector(allow,useradd_t,user_home_dir_t,dir,setattr).
access_vector(allow,useradd_t,user_home_dir_t,dir,link).
access_vector(allow,useradd_t,user_home_dir_t,dir,unlink).
access_vector(allow,useradd_t,user_home_dir_t,dir,rename).
access_vector(allow,useradd_t,user_home_dir_t,dir,search).
access_vector(allow,useradd_t,user_home_dir_t,dir,add_name).
access_vector(allow,useradd_t,user_home_dir_t,dir,remove_name).
access_vector(allow,useradd_t,user_home_dir_t,dir,reparent).
access_vector(allow,useradd_t,user_home_dir_t,dir,write).
access_vector(allow,useradd_t,user_home_dir_t,dir,rmdir).
type_trans(useradd_t,home_root_t,dir,user_home_dir_t).
access_vector(allow,useradd_t,user_home_dir_t,dir,read).
access_vector(allow,useradd_t,user_home_dir_t,dir,getattr).
access_vector(allow,useradd_t,user_home_dir_t,dir,lock).
access_vector(allow,useradd_t,user_home_dir_t,dir,search).
access_vector(allow,useradd_t,user_home_dir_t,dir,ioctl).
access_vector(allow,useradd_t,user_home_dir_t,dir,add_name).
access_vector(allow,useradd_t,user_home_dir_t,dir,remove_name).
access_vector(allow,useradd_t,user_home_dir_t,dir,write).
access_vector(allow,useradd_t,user_home_t,file,create).
access_vector(allow,useradd_t,user_home_t,file,ioctl).
access_vector(allow,useradd_t,user_home_t,file,read).
access_vector(allow,useradd_t,user_home_t,file,getattr).
access_vector(allow,useradd_t,user_home_t,file,lock).
access_vector(allow,useradd_t,user_home_t,file,write).
access_vector(allow,useradd_t,user_home_t,file,setattr).
access_vector(allow,useradd_t,user_home_t,file,append).
access_vector(allow,useradd_t,user_home_t,file,link).
access_vector(allow,useradd_t,user_home_t,file,unlink).
access_vector(allow,useradd_t,user_home_t,file,rename).
access_vector(allow,useradd_t,user_home_t,lnk_file,create).
access_vector(allow,useradd_t,user_home_t,lnk_file,ioctl).
access_vector(allow,useradd_t,user_home_t,lnk_file,read).
access_vector(allow,useradd_t,user_home_t,lnk_file,getattr).
access_vector(allow,useradd_t,user_home_t,lnk_file,lock).
access_vector(allow,useradd_t,user_home_t,lnk_file,write).
access_vector(allow,useradd_t,user_home_t,lnk_file,setattr).
access_vector(allow,useradd_t,user_home_t,lnk_file,append).
access_vector(allow,useradd_t,user_home_t,lnk_file,link).
access_vector(allow,useradd_t,user_home_t,lnk_file,unlink).
access_vector(allow,useradd_t,user_home_t,lnk_file,rename).
access_vector(allow,useradd_t,user_home_t,sock_file,create).
access_vector(allow,useradd_t,user_home_t,sock_file,ioctl).
access_vector(allow,useradd_t,user_home_t,sock_file,read).
access_vector(allow,useradd_t,user_home_t,sock_file,getattr).
access_vector(allow,useradd_t,user_home_t,sock_file,lock).
access_vector(allow,useradd_t,user_home_t,sock_file,write).
access_vector(allow,useradd_t,user_home_t,sock_file,setattr).
access_vector(allow,useradd_t,user_home_t,sock_file,append).
access_vector(allow,useradd_t,user_home_t,sock_file,link).
access_vector(allow,useradd_t,user_home_t,sock_file,unlink).
access_vector(allow,useradd_t,user_home_t,sock_file,rename).
access_vector(allow,useradd_t,user_home_t,fifo_file,create).
access_vector(allow,useradd_t,user_home_t,fifo_file,ioctl).
access_vector(allow,useradd_t,user_home_t,fifo_file,read).
access_vector(allow,useradd_t,user_home_t,fifo_file,getattr).
access_vector(allow,useradd_t,user_home_t,fifo_file,lock).
access_vector(allow,useradd_t,user_home_t,fifo_file,write).
access_vector(allow,useradd_t,user_home_t,fifo_file,setattr).
access_vector(allow,useradd_t,user_home_t,fifo_file,append).
access_vector(allow,useradd_t,user_home_t,fifo_file,link).
access_vector(allow,useradd_t,user_home_t,fifo_file,unlink).
access_vector(allow,useradd_t,user_home_t,fifo_file,rename).
access_vector(allow,useradd_t,user_home_t,dir,create).
access_vector(allow,useradd_t,user_home_t,dir,read).
access_vector(allow,useradd_t,user_home_t,dir,getattr).
access_vector(allow,useradd_t,user_home_t,dir,lock).
access_vector(allow,useradd_t,user_home_t,dir,setattr).
access_vector(allow,useradd_t,user_home_t,dir,link).
access_vector(allow,useradd_t,user_home_t,dir,unlink).
access_vector(allow,useradd_t,user_home_t,dir,rename).
access_vector(allow,useradd_t,user_home_t,dir,search).
access_vector(allow,useradd_t,user_home_t,dir,add_name).
access_vector(allow,useradd_t,user_home_t,dir,remove_name).
access_vector(allow,useradd_t,user_home_t,dir,reparent).
access_vector(allow,useradd_t,user_home_t,dir,write).
access_vector(allow,useradd_t,user_home_t,dir,rmdir).
type_trans(useradd_t,user_home_dir_t,dir,user_home_t).
type_trans(useradd_t,user_home_dir_t,[file,lnk_file,sock_file,fifo_file],user_home_t).
access_vector(allow,useradd_t,var_spool_t,dir,search).
access_vector(allow,useradd_t,mail_spool_t,dir,search).
access_vector(allow,useradd_t,mail_spool_t,dir,write).
access_vector(allow,useradd_t,mail_spool_t,dir,add_name).
access_vector(allow,useradd_t,mail_spool_t,dir,remove_name).
access_vector(allow,useradd_t,mail_spool_t,file,create).
access_vector(allow,useradd_t,mail_spool_t,file,setattr).
access_vector(allow,useradd_t,mail_spool_t,file,getattr).
access_vector(allow,useradd_t,mail_spool_t,file,unlink).
access_vector(allow,useradd_t,mail_spool_t,lnk_file,read).
access_vector(allow,useradd_t,self,capability,fowner).
access_vector(allow,useradd_t,self,capability,fsetid).
access_vector(allow,useradd_t,self,capability,setuid).
access_vector(allow,useradd_t,self,capability,sys_resource).
access_vector(allow,useradd_t,shell_exec_t,file,read).
access_vector(allow,useradd_t,shell_exec_t,file,getattr).
access_vector(allow,useradd_t,shell_exec_t,file,lock).
access_vector(allow,useradd_t,shell_exec_t,file,execute).
access_vector(allow,useradd_t,shell_exec_t,file,ioctl).
access_vector(allow,useradd_t,shell_exec_t,file,execute_no_trans).
access_vector(allow,useradd_t,initrc_var_run_t,file,read).
access_vector(allow,useradd_t,initrc_var_run_t,file,write).
access_vector(allow,useradd_t,initrc_var_run_t,file,lock).
type_decl(groupadd_t,[],[domain,privlog,auth,privowner]).
role_decl(sysadm_r,groupadd_t).
access_vector(allow,groupadd_t,self,process,except([ptrace,setexec,setfscreate])).
access_vector(allow,groupadd_t,self,dir,read).
access_vector(allow,groupadd_t,self,dir,getattr).
access_vector(allow,groupadd_t,self,dir,lock).
access_vector(allow,groupadd_t,self,dir,search).
access_vector(allow,groupadd_t,self,dir,ioctl).
access_vector(allow,groupadd_t,self,file,read).
access_vector(allow,groupadd_t,self,file,getattr).
access_vector(allow,groupadd_t,self,file,lock).
access_vector(allow,groupadd_t,self,file,ioctl).
access_vector(allow,groupadd_t,self,lnk_file,read).
access_vector(allow,groupadd_t,self,lnk_file,getattr).
access_vector(allow,groupadd_t,self,lnk_file,lock).
access_vector(allow,groupadd_t,self,lnk_file,ioctl).
access_vector(allow,groupadd_t,self,sock_file,read).
access_vector(allow,groupadd_t,self,sock_file,getattr).
access_vector(allow,groupadd_t,self,sock_file,lock).
access_vector(allow,groupadd_t,self,sock_file,ioctl).
access_vector(allow,groupadd_t,self,fifo_file,read).
access_vector(allow,groupadd_t,self,fifo_file,getattr).
access_vector(allow,groupadd_t,self,fifo_file,lock).
access_vector(allow,groupadd_t,self,fifo_file,ioctl).
access_vector(allow,groupadd_t,self,fd,_).
access_vector(allow,groupadd_t,self,fifo_file,ioctl).
access_vector(allow,groupadd_t,self,fifo_file,read).
access_vector(allow,groupadd_t,self,fifo_file,getattr).
access_vector(allow,groupadd_t,self,fifo_file,lock).
access_vector(allow,groupadd_t,self,fifo_file,write).
access_vector(allow,groupadd_t,self,fifo_file,append).
access_vector(allow,groupadd_t,self,unix_dgram_socket,create).
access_vector(allow,groupadd_t,self,unix_dgram_socket,ioctl).
access_vector(allow,groupadd_t,self,unix_dgram_socket,read).
access_vector(allow,groupadd_t,self,unix_dgram_socket,getattr).
access_vector(allow,groupadd_t,self,unix_dgram_socket,write).
access_vector(allow,groupadd_t,self,unix_dgram_socket,setattr).
access_vector(allow,groupadd_t,self,unix_dgram_socket,append).
access_vector(allow,groupadd_t,self,unix_dgram_socket,bind).
access_vector(allow,groupadd_t,self,unix_dgram_socket,connect).
access_vector(allow,groupadd_t,self,unix_dgram_socket,getopt).
access_vector(allow,groupadd_t,self,unix_dgram_socket,setopt).
access_vector(allow,groupadd_t,self,unix_dgram_socket,shutdown).
access_vector(allow,groupadd_t,self,unix_stream_socket,create).
access_vector(allow,groupadd_t,self,unix_stream_socket,ioctl).
access_vector(allow,groupadd_t,self,unix_stream_socket,read).
access_vector(allow,groupadd_t,self,unix_stream_socket,getattr).
access_vector(allow,groupadd_t,self,unix_stream_socket,write).
access_vector(allow,groupadd_t,self,unix_stream_socket,setattr).
access_vector(allow,groupadd_t,self,unix_stream_socket,append).
access_vector(allow,groupadd_t,self,unix_stream_socket,bind).
access_vector(allow,groupadd_t,self,unix_stream_socket,connect).
access_vector(allow,groupadd_t,self,unix_stream_socket,getopt).
access_vector(allow,groupadd_t,self,unix_stream_socket,setopt).
access_vector(allow,groupadd_t,self,unix_stream_socket,shutdown).
access_vector(allow,groupadd_t,self,unix_stream_socket,listen).
access_vector(allow,groupadd_t,self,unix_stream_socket,accept).
access_vector(allow,groupadd_t,self,unix_dgram_socket,sendto).
access_vector(allow,groupadd_t,self,unix_stream_socket,connectto).
access_vector(allow,groupadd_t,self,sem,associate).
access_vector(allow,groupadd_t,self,sem,getattr).
access_vector(allow,groupadd_t,self,sem,setattr).
access_vector(allow,groupadd_t,self,sem,create).
access_vector(allow,groupadd_t,self,sem,destroy).
access_vector(allow,groupadd_t,self,sem,read).
access_vector(allow,groupadd_t,self,sem,write).
access_vector(allow,groupadd_t,self,sem,unix_read).
access_vector(allow,groupadd_t,self,sem,unix_write).
access_vector(allow,groupadd_t,self,msg,send).
access_vector(allow,groupadd_t,self,msg,receive).
access_vector(allow,groupadd_t,self,msgq,associate).
access_vector(allow,groupadd_t,self,msgq,getattr).
access_vector(allow,groupadd_t,self,msgq,setattr).
access_vector(allow,groupadd_t,self,msgq,create).
access_vector(allow,groupadd_t,self,msgq,destroy).
access_vector(allow,groupadd_t,self,msgq,read).
access_vector(allow,groupadd_t,self,msgq,write).
access_vector(allow,groupadd_t,self,msgq,enqueue).
access_vector(allow,groupadd_t,self,msgq,unix_read).
access_vector(allow,groupadd_t,self,msgq,unix_write).
access_vector(allow,groupadd_t,self,shm,associate).
access_vector(allow,groupadd_t,self,shm,getattr).
access_vector(allow,groupadd_t,self,shm,setattr).
access_vector(allow,groupadd_t,self,shm,create).
access_vector(allow,groupadd_t,self,shm,destroy).
access_vector(allow,groupadd_t,self,shm,read).
access_vector(allow,groupadd_t,self,shm,write).
access_vector(allow,groupadd_t,self,shm,lock).
access_vector(allow,groupadd_t,self,shm,unix_read).
access_vector(allow,groupadd_t,self,shm,unix_write).
access_vector(allow,groupadd_t,root_t,dir,read).
access_vector(allow,groupadd_t,root_t,dir,getattr).
access_vector(allow,groupadd_t,root_t,dir,lock).
access_vector(allow,groupadd_t,root_t,dir,search).
access_vector(allow,groupadd_t,root_t,dir,ioctl).
access_vector(allow,groupadd_t,usr_t,dir,read).
access_vector(allow,groupadd_t,usr_t,dir,getattr).
access_vector(allow,groupadd_t,usr_t,dir,lock).
access_vector(allow,groupadd_t,usr_t,dir,search).
access_vector(allow,groupadd_t,usr_t,dir,ioctl).
access_vector(allow,groupadd_t,lib_t,dir,read).
access_vector(allow,groupadd_t,lib_t,dir,getattr).
access_vector(allow,groupadd_t,lib_t,dir,lock).
access_vector(allow,groupadd_t,lib_t,dir,search).
access_vector(allow,groupadd_t,lib_t,dir,ioctl).
access_vector(allow,groupadd_t,etc_t,dir,read).
access_vector(allow,groupadd_t,etc_t,dir,getattr).
access_vector(allow,groupadd_t,etc_t,dir,lock).
access_vector(allow,groupadd_t,etc_t,dir,search).
access_vector(allow,groupadd_t,etc_t,dir,ioctl).
access_vector(allow,groupadd_t,lib_t,lnk_file,read).
access_vector(allow,groupadd_t,lib_t,lnk_file,getattr).
access_vector(allow,groupadd_t,lib_t,lnk_file,lock).
access_vector(allow,groupadd_t,lib_t,lnk_file,ioctl).
access_vector(allow,groupadd_t,ld_so_t,file,read).
access_vector(allow,groupadd_t,ld_so_t,file,getattr).
access_vector(allow,groupadd_t,ld_so_t,file,lock).
access_vector(allow,groupadd_t,ld_so_t,file,execute).
access_vector(allow,groupadd_t,ld_so_t,file,ioctl).
access_vector(allow,groupadd_t,ld_so_t,file,execute_no_trans).
access_vector(allow,groupadd_t,ld_so_t,lnk_file,read).
access_vector(allow,groupadd_t,ld_so_t,lnk_file,getattr).
access_vector(allow,groupadd_t,ld_so_t,lnk_file,lock).
access_vector(allow,groupadd_t,ld_so_t,lnk_file,ioctl).
access_vector(allow,groupadd_t,shlib_t,file,read).
access_vector(allow,groupadd_t,shlib_t,file,getattr).
access_vector(allow,groupadd_t,shlib_t,file,lock).
access_vector(allow,groupadd_t,shlib_t,file,execute).
access_vector(allow,groupadd_t,shlib_t,file,ioctl).
access_vector(allow,groupadd_t,shlib_t,lnk_file,read).
access_vector(allow,groupadd_t,shlib_t,lnk_file,getattr).
access_vector(allow,groupadd_t,shlib_t,lnk_file,lock).
access_vector(allow,groupadd_t,shlib_t,lnk_file,ioctl).
access_vector(allow,groupadd_t,ld_so_cache_t,file,read).
access_vector(allow,groupadd_t,ld_so_cache_t,file,getattr).
access_vector(allow,groupadd_t,ld_so_cache_t,file,lock).
access_vector(allow,groupadd_t,ld_so_cache_t,file,ioctl).
access_vector(allow,groupadd_t,device_t,dir,search).
access_vector(allow,groupadd_t,null_device_t,chr_file,ioctl).
access_vector(allow,groupadd_t,null_device_t,chr_file,read).
access_vector(allow,groupadd_t,null_device_t,chr_file,getattr).
access_vector(allow,groupadd_t,null_device_t,chr_file,lock).
access_vector(allow,groupadd_t,null_device_t,chr_file,write).
access_vector(allow,groupadd_t,null_device_t,chr_file,append).
type_decl(groupadd_exec_t,[],[file_type,sysadmfile,exec_type]).
access_vector(allow,sysadm_t,groupadd_t,process,transition).
access_vector(dontaudit,sysadm_t,groupadd_t,process,noatsecure).
access_vector(allow,sysadm_t,groupadd_exec_t,file,read).
access_vector(allow,sysadm_t,groupadd_exec_t,file,getattr).
access_vector(allow,sysadm_t,groupadd_exec_t,file,execute).
access_vector(allow,groupadd_t,sysadm_t,process,sigchld).
access_vector(allow,groupadd_t,sysadm_t,fd,use).
access_vector(allow,sysadm_t,groupadd_t,fd,use).
access_vector(allow,groupadd_t,sysadm_t,fifo_file,ioctl).
access_vector(allow,groupadd_t,sysadm_t,fifo_file,read).
access_vector(allow,groupadd_t,sysadm_t,fifo_file,getattr).
access_vector(allow,groupadd_t,sysadm_t,fifo_file,lock).
access_vector(allow,groupadd_t,sysadm_t,fifo_file,write).
access_vector(allow,groupadd_t,sysadm_t,fifo_file,append).
access_vector(allow,groupadd_t,groupadd_exec_t,file,read).
access_vector(allow,groupadd_t,groupadd_exec_t,file,getattr).
access_vector(allow,groupadd_t,groupadd_exec_t,file,lock).
access_vector(allow,groupadd_t,groupadd_exec_t,file,execute).
access_vector(allow,groupadd_t,groupadd_exec_t,file,ioctl).
access_vector(allow,groupadd_t,groupadd_exec_t,file,entrypoint).
type_trans(sysadm_t,groupadd_exec_t,process,groupadd_t).
access_vector(allow,groupadd_t,self,capability,dac_override).
access_vector(allow,groupadd_t,self,capability,chown).
access_vector(allow,groupadd_t,security_t,dir,read).
access_vector(allow,groupadd_t,security_t,dir,search).
access_vector(allow,groupadd_t,security_t,dir,getattr).
access_vector(allow,groupadd_t,security_t,file,getattr).
access_vector(allow,groupadd_t,security_t,file,read).
access_vector(allow,groupadd_t,security_t,file,write).
access_vector(allow,groupadd_t,security_t,security,check_context).
access_vector(allow,groupadd_t,security_t,security,compute_av).
access_vector(allow,groupadd_t,security_t,security,compute_create).
access_vector(allow,groupadd_t,security_t,security,compute_relabel).
access_vector(allow,groupadd_t,security_t,security,compute_user).
access_vector(allow,groupadd_t,privfd,fd,use).
access_vector(allow,groupadd_t,etc_t,dir,read).
access_vector(allow,groupadd_t,etc_t,dir,getattr).
access_vector(allow,groupadd_t,etc_t,dir,lock).
access_vector(allow,groupadd_t,etc_t,dir,search).
access_vector(allow,groupadd_t,etc_t,dir,ioctl).
access_vector(allow,groupadd_t,etc_t,dir,add_name).
access_vector(allow,groupadd_t,etc_t,dir,remove_name).
access_vector(allow,groupadd_t,etc_t,dir,write).
access_vector(allow,groupadd_t,shadow_t,file,create).
access_vector(allow,groupadd_t,shadow_t,file,ioctl).
access_vector(allow,groupadd_t,shadow_t,file,read).
access_vector(allow,groupadd_t,shadow_t,file,getattr).
access_vector(allow,groupadd_t,shadow_t,file,lock).
access_vector(allow,groupadd_t,shadow_t,file,write).
access_vector(allow,groupadd_t,shadow_t,file,setattr).
access_vector(allow,groupadd_t,shadow_t,file,append).
access_vector(allow,groupadd_t,shadow_t,file,link).
access_vector(allow,groupadd_t,shadow_t,file,unlink).
access_vector(allow,groupadd_t,shadow_t,file,rename).
type_trans(groupadd_t,etc_t,file,shadow_t).
access_vector(allow,groupadd_t,etc_t,file,create).
access_vector(allow,groupadd_t,etc_t,file,ioctl).
access_vector(allow,groupadd_t,etc_t,file,read).
access_vector(allow,groupadd_t,etc_t,file,getattr).
access_vector(allow,groupadd_t,etc_t,file,lock).
access_vector(allow,groupadd_t,etc_t,file,write).
access_vector(allow,groupadd_t,etc_t,file,setattr).
access_vector(allow,groupadd_t,etc_t,file,append).
access_vector(allow,groupadd_t,etc_t,file,link).
access_vector(allow,groupadd_t,etc_t,file,unlink).
access_vector(allow,groupadd_t,etc_t,file,rename).
access_vector(allow,groupadd_t,self,process,setfscreate).
access_vector(allow,groupadd_t,proc_t,dir,search).
access_vector(allow,groupadd_t,proc_t,lnk_file,read).
access_vector(allow,groupadd_t,self,dir,search).
access_vector(allow,groupadd_t,self,file,read).
access_vector(allow,groupadd_t,self,file,write).
access_vector(allow,groupadd_t,etc_t,file,relabelfrom).
access_vector(allow,groupadd_t,etc_t,file,relabelto).
access_vector(allow,groupadd_t,shadow_t,file,relabelfrom).
access_vector(allow,groupadd_t,shadow_t,file,relabelto).
access_vector(allow,groupadd_t,etc_t,lnk_file,read).
access_vector(allow,groupadd_t,locale_t,dir,read).
access_vector(allow,groupadd_t,locale_t,dir,getattr).
access_vector(allow,groupadd_t,locale_t,dir,lock).
access_vector(allow,groupadd_t,locale_t,dir,search).
access_vector(allow,groupadd_t,locale_t,dir,ioctl).
access_vector(allow,groupadd_t,locale_t,file,read).
access_vector(allow,groupadd_t,locale_t,file,getattr).
access_vector(allow,groupadd_t,locale_t,file,lock).
access_vector(allow,groupadd_t,locale_t,file,ioctl).
access_vector(allow,groupadd_t,locale_t,lnk_file,read).
access_vector(allow,groupadd_t,locale_t,lnk_file,getattr).
access_vector(allow,groupadd_t,locale_t,lnk_file,lock).
access_vector(allow,groupadd_t,locale_t,lnk_file,ioctl).
access_vector(dontaudit,groupadd_t,device_t,dir,search).
access_vector(dontaudit,groupadd_t,var_t,dir,search).
access_vector(dontaudit,groupadd_t,var_log_t,dir,search).
access_vector(allow,groupadd_t,fs_t,filesystem,getattr).
access_vector(allow,groupadd_t,ttyfile,chr_file,ioctl).
access_vector(allow,groupadd_t,ttyfile,chr_file,read).
access_vector(allow,groupadd_t,ttyfile,chr_file,getattr).
access_vector(allow,groupadd_t,ttyfile,chr_file,lock).
access_vector(allow,groupadd_t,ttyfile,chr_file,write).
access_vector(allow,groupadd_t,ttyfile,chr_file,append).
access_vector(allow,groupadd_t,ptyfile,chr_file,ioctl).
access_vector(allow,groupadd_t,ptyfile,chr_file,read).
access_vector(allow,groupadd_t,ptyfile,chr_file,getattr).
access_vector(allow,groupadd_t,ptyfile,chr_file,lock).
access_vector(allow,groupadd_t,ptyfile,chr_file,write).
access_vector(allow,groupadd_t,ptyfile,chr_file,append).
access_vector(dontaudit,groupadd_t,sysadm_home_dir_t,dir,search).
access_vector(dontaudit,groupadd_t,initrc_var_run_t,file,write).
access_vector(dontaudit,groupadd_t,var_run_t,dir,search).
access_vector(dontaudit,groupadd_t,self,capability,fsetid).
neverallow(domain,except(domain),process,transition).
neverallow(except([insmod_t,ifconfig_t,kernel_t]),self,capability,sys_module).
neverallow(except([ldconfig_t,admin]),[exec_type,ld_so_t,shlib_t],file,[write,append,unlink,rename]).
neverallow(except([ldconfig_t,admin]),[lib_t,bin_t,sbin_t],dir,[add_name,remove_name,rename]).
neverallow(except(admin),[lib_t,bin_t,sbin_t],file,[write,append,unlink,rename]).
neverallow(except([fsadm_t,mount_t]),fixed_disk_device_t,[chr_file,blk_file],[read,write,append]).
neverallow(except(privmem),memory_device_t,[chr_file,blk_file],[read,write,append]).
neverallow(except(klogd_t),proc_kmsg_t,file,except([getattr])).
neverallow(_,proc_kcore_t,file,except([getattr])).
neverallow(except([initrc_t,admin,kernel_t,insmod_t]),sysctl_t,file,[write,append]).
neverallow(except([initrc_t,admin]),sysctl_fs_t,file,[write,append]).
neverallow(except([init_t,initrc_t,admin,kernel_t,insmod_t]),sysctl_kernel_t,file,[write,append]).
neverallow(except([initrc_t,admin]),sysctl_net_t,file,[write,append]).
neverallow(except([initrc_t,admin]),sysctl_net_unix_t,file,[write,append]).
neverallow(except([initrc_t,admin]),sysctl_vm_t,file,[write,append]).
neverallow(except([initrc_t,admin]),sysctl_dev_t,file,[write,append]).
neverallow(except([initrc_t,admin]),sysctl_modprobe_t,file,[write,append]).
neverallow(getty_t,except(getty_exec_t),file,entrypoint).
neverallow(getty_t,except([getty_exec_t,ld_so_t]),file,execute_no_trans).
neverallow(klogd_t,except(klogd_exec_t),file,entrypoint).
neverallow(klogd_t,except([klogd_exec_t,ld_so_t]),file,execute_no_trans).
neverallow(syslogd_t,except(syslogd_exec_t),file,entrypoint).
neverallow(syslogd_t,except([syslogd_exec_t,ld_so_t]),file,execute_no_trans).
neverallow([local_login_t,remote_login_t],except(login_exec_t),file,entrypoint).
neverallow([local_login_t,remote_login_t],except(ld_so_t),file,execute_no_trans).
neverallow(passwd_t,except([admin_passwd_exec_t,passwd_exec_t]),file,entrypoint).
neverallow(passwd_t,except([ld_so_t]),file,execute_no_trans).
neverallow(except([admin,initrc_t]),security_t,security,setenforce).
neverallow(except([kernel_t,load_policy_t]),security_t,security,load_policy).
role_allow(system_r,sysadm_r).
role_allow(sysadm_r,system_r).
user(system_u,system_r).
user(user_u,user_r).
user(root,staff_r).
user(root,sysadm_r).
user(jadmin,staff_r).
user(jadmin,sysadm_r).
user(jdoe,user_r).
init_sid_context(kernel,(system_u,system_r,kernel_t)).
init_sid_context(security,(system_u,object_r,security_t)).
init_sid_context(unlabeled,(system_u,object_r,unlabeled_t)).
init_sid_context(fs,(system_u,object_r,fs_t)).
init_sid_context(file,(system_u,object_r,file_t)).
init_sid_context(file_labels,(system_u,object_r,file_labels_t)).
init_sid_context(init,(system_u,system_r,init_t)).
init_sid_context(any_socket,(system_u,system_r,any_socket_t)).
init_sid_context(port,(system_u,object_r,port_t)).
init_sid_context(netif,(system_u,object_r,netif_t)).
init_sid_context(netmsg,(system_u,object_r,netmsg_t)).
init_sid_context(node,(system_u,object_r,node_t)).
init_sid_context(igmp_packet,(system_u,system_r,igmp_packet_t)).
init_sid_context(icmp_socket,(system_u,system_r,icmp_socket_t)).
init_sid_context(tcp_socket,(system_u,system_r,tcp_socket_t)).
init_sid_context(sysctl_modprobe,(system_u,object_r,sysctl_modprobe_t)).
init_sid_context(sysctl,(system_u,object_r,sysctl_t)).
init_sid_context(sysctl_fs,(system_u,object_r,sysctl_fs_t)).
init_sid_context(sysctl_kernel,(system_u,object_r,sysctl_kernel_t)).
init_sid_context(sysctl_net,(system_u,object_r,sysctl_net_t)).
init_sid_context(sysctl_net_unix,(system_u,object_r,sysctl_net_unix_t)).
init_sid_context(sysctl_vm,(system_u,object_r,sysctl_vm_t)).
init_sid_context(sysctl_dev,(system_u,object_r,sysctl_dev_t)).
init_sid_context(kmod,(system_u,system_r,kernel_t)).
init_sid_context(policy,(system_u,object_r,policy_config_t)).
init_sid_context(scmp_packet,(system_u,system_r,scmp_packet_t)).
fs_use(xattr,ext2,(system_u,object_r,fs_t)).
fs_use(xattr,ext3,(system_u,object_r,fs_t)).
fs_use(task,pipefs,(system_u,object_r,fs_t)).
fs_use(task,sockfs,(system_u,object_r,fs_t)).
fs_use(trans,devpts,(system_u,object_r,devpts_t)).
fs_use(trans,tmpfs,(system_u,object_r,tmpfs_t)).
fs_use(trans,shm,(system_u,object_r,tmpfs_t)).
genfscon(proc,'/',(system_u,object_r,proc_t)).
genfscon(proc,'/kmsg',(system_u,object_r,proc_kmsg_t)).
genfscon(proc,'/kcore',(system_u,object_r,proc_kcore_t)).
genfscon(proc,'/sysvipc',(system_u,object_r,proc_t)).
genfscon(proc,'/sys',(system_u,object_r,sysctl_t)).
genfscon(proc,'/sys/kernel',(system_u,object_r,sysctl_kernel_t)).
genfscon(proc,'/sys/kernel/modprobe',(system_u,object_r,sysctl_modprobe_t)).
genfscon(proc,'/sys/net',(system_u,object_r,sysctl_net_t)).
genfscon(proc,'/sys/net/unix',(system_u,object_r,sysctl_net_unix_t)).
genfscon(proc,'/sys/vm',(system_u,object_r,sysctl_vm_t)).
genfscon(proc,'/sys/dev',(system_u,object_r,sysctl_dev_t)).
genfscon(rootfs,'/',(system_u,object_r,root_t)).
genfscon(sysfs,'/',(system_u,object_r,sysfs_t)).
genfscon(selinuxfs,'/',(system_u,object_r,security_t)).
genfscon(iso9660,'/',(system_u,object_r,iso9660_t)).
genfscon(vfat,'/',(system_u,object_r,dosfs_t)).
genfscon(msdos,'/',(system_u,object_r,dosfs_t)).
genfscon(nfs,'/',(system_u,object_r,nfs_t)).
portcon(tcp,22,(system_u,object_r,ssh_port_t)).
netifcon(lo,(system_u,object_r,netif_lo_t),(system_u,object_r,netmsg_lo_t)).
netifcon(eth0,(system_u,object_r,netif_eth0_t),(system_u,object_r,netmsg_eth0_t)).
netifcon(eth1,(system_u,object_r,netif_eth1_t),(system_u,object_r,netmsg_eth1_t)).
netifcon(eth2,(system_u,object_r,netif_eth2_t),(system_u,object_r,netmsg_eth2_t)).
netifcon(ippp0,(system_u,object_r,netif_ippp0_t),(system_u,object_r,netmsg_ippp0_t)).
netifcon(ipsec0,(system_u,object_r,netif_ipsec0_t),(system_u,object_r,netmsg_ipsec0_t)).
netifcon(ipsec1,(system_u,object_r,netif_ipsec1_t),(system_u,object_r,netmsg_ipsec1_t)).
netifcon(ipsec2,(system_u,object_r,netif_ipsec2_t),(system_u,object_r,netmsg_ipsec2_t)).
nodecon('127.0.0.1','255.255.255.255',(system_u,object_r,node_lo_t)).

:- import member/2 from basics.

constraint(C,P, T1,R1,U1, T2,R2,U2) :- 
      (equiv_class(C,process),
       equiv_perm(C,P,transition)
       -> (U1 == U2 ; type_eq(T1,privuser) ; type_eq(T1,crond_t), type_eq(T1,user_crond_domain))
        ; true),
      (equiv_class(C,process),
       equiv_perm(C,P,transition)
       -> (R1 == R2 ; type_eq(T1,privrole))
        ; true),
      (equiv_class(C,[dir,file,lnk_file,sock_file,fifo_file,chr_file,blk_file]),
       equiv_perm(C,P,[create,relabelto,relabelfrom])
       -> (U1 == U2 ; type_eq(T1,privowner))
        ; true),
      (equiv_class(C,[tcp_socket,udp_socket,rawip_socket,netlink_socket,packet_socket,unix_stream_socket,unix_dgram_socket]),
       equiv_perm(C,P,[create,relabelto,relabelfrom])
       -> (U1 == U2 ; type_eq(T1,privowner))
        ; true).


