
access(filesystem,[mount,remount,unmount,getattr,relabelfrom,relabelto,transition,associate,quotamod,quotaget]).

inherits(dir,file).
access(dir,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,unlink,link,rename,execute,swapon,quotaon,mounton,add_name,remove_name,reparent,search,rmdir]).

inherits(file,file).
access(file,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,unlink,link,rename,execute,swapon,quotaon,mounton,execute_no_trans,entrypoint]).

inherits(lnk_file,file).
access(lnk_file,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,unlink,link,rename,execute,swapon,quotaon,mounton]).

inherits(chr_file,file).
access(chr_file,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,unlink,link,rename,execute,swapon,quotaon,mounton]).

inherits(blk_file,file).
access(blk_file,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,unlink,link,rename,execute,swapon,quotaon,mounton]).

inherits(sock_file,file).
access(sock_file,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,unlink,link,rename,execute,swapon,quotaon,mounton]).

inherits(fifo_file,file).
access(fifo_file,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,unlink,link,rename,execute,swapon,quotaon,mounton]).

access(fd,[use]).

inherits(socket,socket).
access(socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind]).

inherits(tcp_socket,socket).
access(tcp_socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind,connectto,newconn,acceptfrom]).

inherits(udp_socket,socket).
access(udp_socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind]).

inherits(rawip_socket,socket).
access(rawip_socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind]).

access(node,[tcp_recv,tcp_send,udp_recv,udp_send,rawip_recv,rawip_send,enforce_dest]).

access(netif,[tcp_recv,tcp_send,udp_recv,udp_send,rawip_recv,rawip_send]).

inherits(netlink_socket,socket).
access(netlink_socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind]).

inherits(packet_socket,socket).
access(packet_socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind]).

inherits(key_socket,socket).
access(key_socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind]).

inherits(unix_stream_socket,socket).
access(unix_stream_socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind,connectto,newconn,acceptfrom]).

inherits(unix_dgram_socket,socket).
access(unix_dgram_socket,[ioctl,read,write,create,getattr,setattr,lock,relabelfrom,relabelto,append,bind,connect,listen,accept,getopt,setopt,shutdown,recvfrom,sendto,recv_msg,send_msg,name_bind]).

access(process,[fork,transition,sigchld,sigkill,sigstop,signull,signal,ptrace,getsched,setsched,getsession,getpgid,setpgid,getcap,setcap,share,getattr,setexec,setfscreate,noatsecure]).

inherits(ipc,ipc).
access(ipc,[create,destroy,getattr,setattr,read,write,associate,unix_read,unix_write]).

inherits(sem,ipc).
access(sem,[create,destroy,getattr,setattr,read,write,associate,unix_read,unix_write]).

inherits(msgq,ipc).
access(msgq,[create,destroy,getattr,setattr,read,write,associate,unix_read,unix_write,enqueue]).

access(msg,[send,receive]).

inherits(shm,ipc).
access(shm,[create,destroy,getattr,setattr,read,write,associate,unix_read,unix_write,lock]).

access(security,[compute_av,compute_create,compute_member,check_context,load_policy,compute_relabel,compute_user,setenforce]).

access(system,[ipc_info,syslog_read,syslog_mod,syslog_console]).

access(capability,[chown,dac_override,dac_read_search,fowner,fsetid,kill,setgid,setuid,setpcap,linux_immutable,net_bind_service,net_broadcast,net_admin,net_raw,ipc_lock,ipc_owner,sys_module,sys_rawio,sys_chroot,sys_ptrace,sys_pacct,sys_admin,sys_boot,sys_nice,sys_resource,sys_time,sys_tty_config,mknod,lease]).

access(passwd,[passwd,chfn,chsh]).

initial_sid(kernel).
initial_sid(security).
initial_sid(unlabeled).
initial_sid(fs).
initial_sid(file).
initial_sid(file_labels).
initial_sid(init).
initial_sid(any_socket).
initial_sid(port).
initial_sid(netif).
initial_sid(netmsg).
initial_sid(node).
initial_sid(igmp_packet).
initial_sid(icmp_socket).
initial_sid(tcp_socket).
initial_sid(sysctl_modprobe).
initial_sid(sysctl).
initial_sid(sysctl_fs).
initial_sid(sysctl_kernel).
initial_sid(sysctl_net).
initial_sid(sysctl_net_unix).
initial_sid(sysctl_vm).
initial_sid(sysctl_dev).
initial_sid(kmod).
initial_sid(policy).
initial_sid(scmp_packet).


security_class(security).
security_class(process).
security_class(system).
security_class(capability).
security_class(filesystem).
security_class(file).
security_class(dir).
security_class(fd).
security_class(lnk_file).
security_class(chr_file).
security_class(blk_file).
security_class(sock_file).
security_class(fifo_file).
security_class(socket).
security_class(tcp_socket).
security_class(udp_socket).
security_class(rawip_socket).
security_class(node).
security_class(netif).
security_class(netlink_socket).
security_class(packet_socket).
security_class(key_socket).
security_class(unix_stream_socket).
security_class(unix_dgram_socket).
security_class(sem).
security_class(msg).
security_class(msgq).
security_class(shm).
security_class(ipc).
security_class(passwd).


perm_map(common,file,ioctl,[none]).
perm_map(common,file,read,[read]).
perm_map(common,file,write,[write]).
perm_map(common,file,create,[write]).
perm_map(common,file,getattr,[read]).
perm_map(common,file,setattr,[write]).
perm_map(common,file,lock,[none]).
perm_map(common,file,relabelfrom,[read,write]).
perm_map(common,file,relabelto,[write]).
perm_map(common,file,append,[write]).
perm_map(common,file,unlink,[write]).
perm_map(common,file,link,[write]).
perm_map(common,file,rename,[write]).
perm_map(common,file,execute,[read]).
perm_map(common,file,swapon,[read,write]).
perm_map(common,file,quotaon,[read,write]).
perm_map(common,file,mounton,[read,write]).
perm_map(common,socket,ioctl,[none]).
perm_map(common,socket,read,[read]).
perm_map(common,socket,write,[write]).
perm_map(common,socket,create,[write]).
perm_map(common,socket,getattr,[read]).
perm_map(common,socket,setattr,[write]).
perm_map(common,socket,lock,[none]).
perm_map(common,socket,relabelfrom,[read,write]).
perm_map(common,socket,relabelto,[write]).
perm_map(common,socket,append,[write]).
perm_map(common,socket,bind,[write]).
perm_map(common,socket,connect,[write]).
perm_map(common,socket,listen,[read]).
perm_map(common,socket,accept,[read]).
perm_map(common,socket,getopt,[read]).
perm_map(common,socket,setopt,[write]).
perm_map(common,socket,shutdown,[write]).
perm_map(common,socket,recvfrom,[read]).
perm_map(common,socket,sendto,[write]).
perm_map(common,socket,recv_msg,[read]).
perm_map(common,socket,send_msg,[write]).
perm_map(common,socket,name_bind,[none]).
perm_map(common,ipc,create,[write]).
perm_map(common,ipc,destroy,[write]).
perm_map(common,ipc,getattr,[read]).
perm_map(common,ipc,setattr,[write]).
perm_map(common,ipc,read,[read]).
perm_map(common,ipc,write,[write]).
perm_map(common,ipc,associate,[none]).
perm_map(common,ipc,unix_read,[read]).
perm_map(common,ipc,unix_write,[write]).
perm_map(class,filesystem,mount,[write]).
perm_map(class,filesystem,remount,[write]).
perm_map(class,filesystem,unmount,[write]).
perm_map(class,filesystem,getattr,[read]).
perm_map(class,filesystem,relabelfrom,[read,write]).
perm_map(class,filesystem,relabelto,[write]).
perm_map(class,filesystem,transition,[write]).
perm_map(class,filesystem,associate,[none]).
perm_map(class,filesystem,quotamod,[write]).
perm_map(class,filesystem,quotaget,[read]).
perm_map(class,dir,add_name,[write]).
perm_map(class,dir,remove_name,[write]).
perm_map(class,dir,reparent,[write]).
perm_map(class,dir,search,[read]).
perm_map(class,dir,rmdir,[read,write]).
perm_map(class,file,execute_no_trans,[read]).
perm_map(class,file,entrypoint,[read]).
perm_map(class,fd,use,[read,write]).
perm_map(class,tcp_socket,connectto,[write]).
perm_map(class,tcp_socket,newconn,[write]).
perm_map(class,tcp_socket,acceptfrom,[read]).
perm_map(class,node,tcp_recv,[read]).
perm_map(class,node,tcp_send,[write]).
perm_map(class,node,udp_recv,[read]).
perm_map(class,node,udp_send,[write]).
perm_map(class,node,rawip_recv,[read]).
perm_map(class,node,rawip_send,[write]).
perm_map(class,node,enforce_dest,[none]).
perm_map(class,netif,tcp_recv,[read]).
perm_map(class,netif,tcp_send,[write]).
perm_map(class,netif,udp_recv,[read]).
perm_map(class,netif,udp_send,[write]).
perm_map(class,netif,rawip_recv,[read]).
perm_map(class,netif,rawip_send,[write]).
perm_map(class,unix_stream_socket,connectto,[write]).
perm_map(class,unix_stream_socket,newconn,[write]).
perm_map(class,unix_stream_socket,acceptfrom,[read]).
perm_map(class,process,fork,[none]).
perm_map(class,process,transition,[write]).
perm_map(class,process,sigchld,[write]).
perm_map(class,process,sigkill,[write]).
perm_map(class,process,sigstop,[write]).
perm_map(class,process,signull,[none]).
perm_map(class,process,signal,[write]).
perm_map(class,process,ptrace,[read,write]).
perm_map(class,process,getsched,[read]).
perm_map(class,process,setsched,[write]).
perm_map(class,process,getsession,[read]).
perm_map(class,process,getpgid,[read]).
perm_map(class,process,setpgid,[write]).
perm_map(class,process,getcap,[read]).
perm_map(class,process,setcap,[write]).
perm_map(class,process,share,[read,write]).
perm_map(class,msgq,enqueue,[write]).
perm_map(class,msg,send,[write]).
perm_map(class,msg,receive,[read]).
perm_map(class,shm,lock,[write]).
perm_map(class,security,compute_av,[none]).
perm_map(class,security,transition_sid,[none]).
perm_map(class,security,member_sid,[none]).
perm_map(class,security,sid_to_context,[none]).
perm_map(class,security,context_to_sid,[none]).
perm_map(class,security,load_policy,[none]).
perm_map(class,security,get_sids,[none]).
perm_map(class,security,change_sid,[none]).
perm_map(class,security,get_user_sids,[none]).
perm_map(class,system,ipc_info,[none]).
perm_map(class,system,avc_toggle,[none]).
perm_map(class,system,nfsd_control,[none]).
perm_map(class,system,bdflush,[none]).
perm_map(class,system,syslog_read,[none]).
perm_map(class,system,syslog_mod,[none]).
perm_map(class,system,syslog_console,[none]).
perm_map(class,system,ichsid,[none]).
perm_map(class,capability,chown,[none]).
perm_map(class,capability,dac_override,[none]).
perm_map(class,capability,dac_read_search,[none]).
perm_map(class,capability,fowner,[none]).
perm_map(class,capability,fsetid,[none]).
perm_map(class,capability,kill,[none]).
perm_map(class,capability,setgid,[none]).
perm_map(class,capability,setuid,[none]).
perm_map(class,capability,setpcap,[none]).
perm_map(class,capability,linux_immutable,[none]).
perm_map(class,capability,net_bind_service,[none]).
perm_map(class,capability,net_broadcast,[none]).
perm_map(class,capability,net_admin,[none]).
perm_map(class,capability,net_raw,[none]).
perm_map(class,capability,ipc_lock,[none]).
perm_map(class,capability,ipc_owner,[none]).
perm_map(class,capability,sys_module,[none]).
perm_map(class,capability,sys_rawio,[none]).
perm_map(class,capability,sys_chroot,[none]).
perm_map(class,capability,sys_ptrace,[none]).
perm_map(class,capability,sys_pacct,[none]).
perm_map(class,capability,sys_admin,[none]).
perm_map(class,capability,sys_boot,[none]).
perm_map(class,capability,sys_nice,[none]).
perm_map(class,capability,sys_resource,[none]).
perm_map(class,capability,sys_time,[none]).
perm_map(class,capability,sys_tty_config,[none]).
perm_map(class,capability,mknod,[none]).
perm_map(class,capability,lease,[none]).


attr(mlstrustedreader).

attr(mlstrustedwriter).

attr(mlstrustedobject).

attr(domain).

attr(privuser).

attr(privrole).

attr(privowner).

attr(privlog).

attr(privmem).

attr(privfd).

attr(privhome).

attr(auth).

attr(admin).

attr(userdomain).

attr(userpty_type).

attr(user_crond_domain).

attr(unpriv_userdomain).

attr(user_home_dir_type).

attr(gphdomain).

attr(file_type).

attr(sysadmfile).

attr(fs_type).

attr(root_dir_type).

attr(exec_type).

attr(tmpfile).

attr(user_tmpfile).

attr(xserver_tmpfile).

attr(tmpfsfile).

attr(home_type).

attr(home_dir_type).

attr(ttyfile).

attr(ptyfile).

attr(pidfile).

attr(socket_type).

attr(port_type).

attr(netif_type).

attr(netmsg_type).

attr(node_type).

attr(logfile).

attr(lockfile).

attr(login_contexts).

attr(user_mail_domain).

attr(privmail).

attr(user_home_type).

attr(mta_user_agent).

attr(mta_delivery_agent).

attr(web_client_domain).

attr(mail_server_domain).

define(checkpolicy.te).

define(chkpwd.te).

define(crond.te).

define(crontab.te).

define(fsadm.te).

define(getty.te).

define(ifconfig.te).

define(initrc.te).

define(init.te).

define(klogd.te).

define(ldconfig.te).

define(load_policy.te).

define(login.te).

define(logrotate.te).

define(modutil.te).

define(mount.te).

define(netutils.te).

define(newrole.te).

define(passwd.te).

define(setfiles.te).

define(ssh.te).

define(su.te).

define(syslogd.te).

define(tmpreaper.te).

define(useradd.te).

define(kernel.te).

user_domain(Arg1) :- 
      admin_domain(Arg1).

access_vector(allow,[Arg1_t],[kernel_t],[system],[syslog_read]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[self],[capability],[except([sys_module])]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_getsecurity(Arg1_t) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[kernel_t],[system],[_]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[self],[passwd],[passwd,chfn,chsh]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_sysctl(Arg1_t) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[sysadmfile],[notdevfile_class_set],[create_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[sysadmfile],[dir],[create_dir_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_setfscreate(Arg1_t) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[removable_device_t],[devfile_class_set],[rw_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[initctl_t],[fifo_file],[rw_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[domain],[dir],[r_dir_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[domain],[notdevfile_class_set],[r_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[domain],[process],[getattr]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[domain,unlabeled_t],[process],[signal_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[tty_device_t],[chr_file],[rw_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[ttyfile],[chr_file],[rw_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[ptyfile],[chr_file],[rw_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[tun_tap_device_t],[chr_file],[rw_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_exec(Arg1_t,init_exec_t) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_exec(Arg1_t,user_home_type) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_exec(Arg1_t,src_t) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[policy_src_t],[notdevfile_class_set],[create_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[policy_src_t],[dir],[create_dir_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[policy_config_t],[file],[unlink]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[file_type],[dir],[getattr,read,search,relabelfrom,relabelto]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[file_type],[file_class_set],[getattr,relabelfrom,relabelto]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

file_type_auto_trans(Arg1_t,user_tmpfile,Arg1_tmp_t,sock_file) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

access_vector(allow,[Arg1_t],[fs_type],[filesystem],[quotamod]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[console_device_t],[chr_file],[rw_file_perms]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[domain],[socket_class_set],[getattr]) :- 
      admin_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

admin_domain(x).

set_macro(dir_file_class_set,[dir,file,lnk_file,sock_file,fifo_file,chr_file,blk_file]).

set_macro(file_class_set,[file,lnk_file,sock_file,fifo_file,chr_file,blk_file]).

set_macro(notdevfile_class_set,[file,lnk_file,sock_file,fifo_file]).

set_macro(devfile_class_set,[chr_file,blk_file]).

set_macro(socket_class_set,[tcp_socket,udp_socket,rawip_socket,netlink_socket,packet_socket,unix_stream_socket,unix_dgram_socket]).

set_macro(dgram_socket_class_set,[udp_socket,unix_dgram_socket]).

set_macro(stream_socket_class_set,[tcp_socket,unix_stream_socket]).

set_macro(unpriv_socket_class_set,[tcp_socket,udp_socket,unix_stream_socket,unix_dgram_socket]).

set_macro(stat_file_perms,[getattr]).

set_macro(x_file_perms,[getattr,execute]).

set_macro(r_file_perms,[read,getattr,lock,ioctl]).

set_macro(rx_file_perms,[read,getattr,lock,execute,ioctl]).

set_macro(rw_file_perms,[ioctl,read,getattr,lock,write,append]).

set_macro(ra_file_perms,[ioctl,read,getattr,lock,append]).

set_macro(link_file_perms,[getattr,link,unlink,rename]).

set_macro(create_file_perms,[create,ioctl,read,getattr,lock,write,setattr,append,link,unlink,rename]).

set_macro(r_dir_perms,[read,getattr,lock,search,ioctl]).

set_macro(rw_dir_perms,[read,getattr,lock,search,ioctl,add_name,remove_name,write]).

set_macro(ra_dir_perms,[read,getattr,lock,search,ioctl,add_name,write]).

set_macro(create_dir_perms,[create,read,getattr,lock,setattr,link,unlink,rename,search,add_name,remove_name,reparent,write,rmdir]).

set_macro(mount_fs_perms,[mount,remount,unmount,getattr]).

set_macro(rw_socket_perms,[ioctl,read,getattr,write,setattr,append,bind,connect,getopt,setopt,shutdown]).

set_macro(create_socket_perms,[create,ioctl,read,getattr,write,setattr,append,bind,connect,getopt,setopt,shutdown]).

set_macro(rw_stream_socket_perms,[ioctl,read,getattr,write,setattr,append,bind,connect,getopt,setopt,shutdown,listen,accept]).

set_macro(create_stream_socket_perms,[create,ioctl,read,getattr,write,setattr,append,bind,connect,getopt,setopt,shutdown,listen,accept]).

set_macro(signal_perms,[sigchld,sigkill,sigstop,signull,signal]).

set_macro(packet_perms,[tcp_recv,tcp_send,udp_recv,udp_send,rawip_recv,rawip_send]).

set_macro(r_sem_perms,[associate,getattr,read,unix_read]).

set_macro(rw_sem_perms,[associate,getattr,read,write,unix_read,unix_write]).

set_macro(create_sem_perms,[associate,getattr,setattr,create,destroy,read,write,unix_read,unix_write]).

set_macro(r_msgq_perms,[associate,getattr,read,unix_read]).

set_macro(rw_msgq_perms,[associate,getattr,read,write,enqueue,unix_read,unix_write]).

set_macro(create_msgq_perms,[associate,getattr,setattr,create,destroy,read,write,enqueue,unix_read,unix_write]).

set_macro(r_shm_perms,[associate,getattr,read,unix_read]).

set_macro(rw_shm_perms,[associate,getattr,read,write,lock,unix_read,unix_write]).

set_macro(create_shm_perms,[associate,getattr,setattr,create,destroy,read,write,lock,unix_read,unix_write]).

access_vector(allow,[Arg1],[Arg2],[dir],[r_dir_perms]) :- 
      r_dir_file(Arg1,Arg2).

access_vector(allow,[Arg1],[Arg2],[file,lnk_file],[r_file_perms]) :- 
      r_dir_file(Arg1,Arg2).

r_dir_file(x,x).

access_vector(allow,[Arg1],[Arg2],[dir],[rw_dir_perms]) :- 
      rw_dir_file(Arg1,Arg2).

access_vector(allow,[Arg1],[Arg2],[file,lnk_file],[rw_file_perms]) :- 
      rw_dir_file(Arg1,Arg2).

rw_dir_file(x,x).

access_vector(allow,[Arg1],[Arg2],[dir],[ra_dir_perms]) :- 
      ra_dir_file(Arg1,Arg2).

access_vector(allow,[Arg1],[Arg2],[file,lnk_file],[ra_file_perms]) :- 
      ra_dir_file(Arg1,Arg2).

ra_dir_file(x,x).

access_vector(allow,[Arg1],[Arg2],[dir],[rw_dir_perms]) :- 
      rw_dir_create_file(Arg1,Arg2).

access_vector(allow,[Arg1],[Arg2],[file,lnk_file],[create_file_perms]) :- 
      rw_dir_create_file(Arg1,Arg2).

rw_dir_create_file(x,x).

access_vector(allow,[Arg1],[Arg2],[dir],[create_dir_perms]) :- 
      create_dir_file(Arg1,Arg2).

access_vector(allow,[Arg1],[Arg2],[file,lnk_file],[create_file_perms]) :- 
      create_dir_file(Arg1,Arg2).

create_dir_file(x,x).

access_vector(allow,[Arg1],[Arg2],[dir],[create_dir_perms]) :- 
      create_dir_notdevfile(Arg1,Arg2).

access_vector(allow,[Arg1],[Arg2],[notdevfile_class_set],[create_file_perms]) :- 
      create_dir_notdevfile(Arg1,Arg2).

create_dir_notdevfile(x,x).

access_vector(allow,[Arg1],[Arg2],[dir],[read,getattr,search,add_name,write]) :- 
      create_append_log_file(Arg1,Arg2).

access_vector(allow,[Arg1],[Arg2],[file],[create,ioctl,getattr,setattr,append,link]) :- 
      create_append_log_file(Arg1,Arg2).

create_append_log_file(x,x).

access_vector(allow,[Arg1],[security_t],[dir],[read,search,getattr]) :- 
      can_getsecurity(Arg1).

access_vector(allow,[Arg1],[security_t],[file],[getattr,read,write]) :- 
      can_getsecurity(Arg1).

access_vector(allow,[Arg1],[security_t],[security],[check_context,compute_av,compute_create,compute_relabel,compute_user]) :- 
      can_getsecurity(Arg1).

can_getsecurity(x).

access_vector(allow,[Arg1],[security_t],[dir],[read,search,getattr]) :- 
      can_setenforce(Arg1).

access_vector(allow,[Arg1],[security_t],[file],[getattr,read,write]) :- 
      can_setenforce(Arg1).

access_vector(allow,[Arg1],[security_t],[security],[setenforce]) :- 
      can_setenforce(Arg1).

access_vector(auditallow,[Arg1],[security_t],[security],[setenforce]) :- 
      can_setenforce(Arg1).

can_setenforce(x).

access_vector(allow,[Arg1],[security_t],[dir],[read,search,getattr]) :- 
      can_loadpol(Arg1).

access_vector(allow,[Arg1],[security_t],[file],[getattr,read,write]) :- 
      can_loadpol(Arg1).

access_vector(allow,[Arg1],[security_t],[security],[load_policy]) :- 
      can_loadpol(Arg1).

access_vector(auditallow,[Arg1],[security_t],[security],[load_policy]) :- 
      can_loadpol(Arg1).

can_loadpol(x).

access_vector(allow,[Arg1],[Arg3],[process],[transition]) :- 
      domain_trans(Arg1,Arg2,Arg3).

access_vector(dontaudit,[Arg1],[Arg3],[process],[noatsecure]) :- 
      domain_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg1],[Arg2],[file],[read,x_file_perms]) :- 
      domain_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg3],[Arg1],[process],[sigchld]) :- 
      domain_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg3],[Arg1],[fd],[use]) :- 
      domain_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg1],[Arg3],[fd],[use]) :- 
      domain_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg3],[Arg1],[fifo_file],[rw_file_perms]) :- 
      domain_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg3],[Arg2],[file],[rx_file_perms]) :- 
      domain_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg3],[Arg2],[file],[entrypoint]) :- 
      domain_trans(Arg1,Arg2,Arg3).

domain_trans(x,x,x).

domain_trans(Arg1,Arg2,Arg3) :- 
      domain_auto_trans(Arg1,Arg2,Arg3).

type_trans([Arg1],[Arg2],[process],Arg3) :- 
      domain_auto_trans(Arg1,Arg2,Arg3).

domain_auto_trans(x,x,x).

access_vector(allow,[Arg1],[self],[process],[setexec]) :- 
      can_setexec(Arg1).

access_vector(allow,[Arg1],[proc_t],[dir],[search]) :- 
      can_setexec(Arg1).

access_vector(allow,[Arg1],[proc_t],[lnk_file],[read]) :- 
      can_setexec(Arg1).

access_vector(allow,[Arg1],[self],[dir],[search]) :- 
      can_setexec(Arg1).

access_vector(allow,[Arg1],[self],[file],[read,write]) :- 
      can_setexec(Arg1).

can_setexec(x).

access_vector(allow,[Arg1],[self],[process],[setfscreate]) :- 
      can_setfscreate(Arg1).

access_vector(allow,[Arg1],[proc_t],[dir],[search]) :- 
      can_setfscreate(Arg1).

access_vector(allow,[Arg1],[proc_t],[lnk_file],[read]) :- 
      can_setfscreate(Arg1).

access_vector(allow,[Arg1],[self],[dir],[search]) :- 
      can_setfscreate(Arg1).

access_vector(allow,[Arg1],[self],[file],[read,write]) :- 
      can_setfscreate(Arg1).

can_setfscreate(x).

access_vector(allow,[Arg1],[root_t,usr_t,lib_t,etc_t],[dir],[r_dir_perms]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[lib_t],[lnk_file],[r_file_perms]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[ld_so_t],[file],[rx_file_perms]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[ld_so_t],[file],[execute_no_trans]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[ld_so_t],[lnk_file],[r_file_perms]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[shlib_t],[file],[rx_file_perms]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[shlib_t],[lnk_file],[r_file_perms]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[ld_so_cache_t],[file],[r_file_perms]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[device_t],[dir],[search]) :- 
      uses_shlib(Arg1).

access_vector(allow,[Arg1],[null_device_t],[chr_file],[rw_file_perms]) :- 
      uses_shlib(Arg1).

uses_shlib(x).

access_vector(allow,[Arg1],[Arg2],[process],[ptrace]) :- 
      can_ptrace(Arg1,Arg2).

can_ptrace(x,x).

access_vector(allow,[Arg1],[Arg2],[file],[rx_file_perms,execute_no_trans]) :- 
      can_exec(Arg1,Arg2).

can_exec(x,x).

access_vector(allow,[Arg1],[bin_t,sbin_t,lib_t,etc_t],[dir],[r_dir_perms]) :- 
      can_exec_any(Arg1).

access_vector(allow,[Arg1],[bin_t,sbin_t,etc_t],[lnk_file],[getattr,read]) :- 
      can_exec_any(Arg1).

uses_shlib(Arg1) :- 
      can_exec_any(Arg1).

can_exec(Arg1,etc_t) :- 
      can_exec_any(Arg1).

can_exec(Arg1,lib_t) :- 
      can_exec_any(Arg1).

can_exec(Arg1,bin_t) :- 
      can_exec_any(Arg1).

can_exec(Arg1,sbin_t) :- 
      can_exec_any(Arg1).

can_exec(Arg1,exec_type) :- 
      can_exec_any(Arg1).

can_exec_any(x).

access_vector(allow,[Arg1],[Arg2],[dir],[rw_dir_perms]) :- 
      file_type_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg1],[Arg3],[notdevfile_class_set],[create_file_perms]) :- 
      file_type_trans(Arg1,Arg2,Arg3).

access_vector(allow,[Arg1],[Arg3],[dir],[create_dir_perms]) :- 
      file_type_trans(Arg1,Arg2,Arg3).

file_type_trans(x,x,x).

file_type_trans(Arg1,Arg2,Arg3) :- 
      file_type_auto_trans(Arg1,Arg2,Arg3).

type_trans([Arg1],[Arg2],[dir],Arg3) :- 
      file_type_auto_trans(Arg1,Arg2,Arg3).

type_trans([Arg1],[Arg2],[notdevfile_class_set],Arg3) :- 
      file_type_auto_trans(Arg1,Arg2,Arg3).

file_type_auto_trans(x,x,x).

access_vector(allow,[Arg1],[self],[udp_socket],[create_socket_perms]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[self],[tcp_socket],[create_stream_socket_perms]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[any_socket_t],[udp_socket],[sendto]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[netif_type],[netif],[tcp_send,udp_send,rawip_send]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[netif_type],[netif],[tcp_recv,udp_recv,rawip_recv]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[netmsg_type],[udp_socket,tcp_socket,rawip_socket],[recvfrom]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[netmsg_type],[tcp_socket],[connectto,acceptfrom]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[tcp_socket_t],[tcp_socket],[recvfrom]) :- 
      can_network(Arg1).

access_vector(dontaudit,[Arg1],[tcp_socket_t],[tcp_socket],[connectto]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[node_type],[node],[tcp_send,udp_send,rawip_send]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[node_type],[node],[tcp_recv,udp_recv,rawip_recv]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[mount_t],[udp_socket],[rw_socket_perms]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[port_t],[udp_socket],[name_bind]) :- 
      can_network(Arg1).

access_vector(allow,[Arg1],[port_t],[tcp_socket],[name_bind]) :- 
      can_network(Arg1).

can_network(x).

access_vector(allow,[Arg1],[Arg2],[unix_stream_socket],[connectto]) :- 
      can_unix_connect(Arg1,Arg2).

can_unix_connect(x,x).

access_vector(allow,[Arg1],[Arg2],[unix_dgram_socket],[sendto]) :- 
      can_unix_send(Arg1,Arg2).

can_unix_send(x,x).

access_vector(allow,[Arg1],[Arg2],[tcp_socket],[connectto,recvfrom]) :- 
      can_tcp_connect(Arg1,Arg2).

access_vector(allow,[Arg2],[Arg1],[tcp_socket],[acceptfrom,recvfrom]) :- 
      can_tcp_connect(Arg1,Arg2).

access_vector(allow,[Arg2],[tcp_socket_t],[tcp_socket],[recvfrom]) :- 
      can_tcp_connect(Arg1,Arg2).

access_vector(allow,[Arg1],[tcp_socket_t],[tcp_socket],[recvfrom]) :- 
      can_tcp_connect(Arg1,Arg2).

can_tcp_connect(x,x).

access_vector(allow,[Arg1],[Arg2],[udp_socket],[sendto]) :- 
      can_udp_send(Arg1,Arg2).

access_vector(allow,[Arg2],[Arg1],[udp_socket],[recvfrom]) :- 
      can_udp_send(Arg1,Arg2).

can_udp_send(x,x).

access_vector(allow,[Arg1],[sysctl_t],[dir],[r_dir_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_t],[file],[setattr,rw_file_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_fs_t],[dir],[r_dir_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_fs_t],[file],[setattr,rw_file_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_kernel_t],[dir],[r_dir_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_kernel_t],[file],[setattr,rw_file_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_net_t],[dir],[r_dir_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_net_t],[file],[setattr,rw_file_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_net_unix_t],[dir],[r_dir_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_net_unix_t],[file],[setattr,rw_file_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_vm_t],[dir],[r_dir_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_vm_t],[file],[setattr,rw_file_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_dev_t],[dir],[r_dir_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_dev_t],[file],[setattr,rw_file_perms]) :- 
      can_sysctl(Arg1).

access_vector(allow,[Arg1],[sysctl_modprobe_t],[file],[setattr,rw_file_perms]) :- 
      can_sysctl(Arg1).

can_sysctl(x).

access_vector(allow,[Arg1_t],[ptmx_t],[chr_file],[rw_file_perms]) :- 
      base_pty_perms(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[devpts_t],[filesystem],[getattr]) :- 
      base_pty_perms(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[devpts_t],[dir],[getattr,read,search]) :- 
      base_pty_perms(Arg1),
      compose_id(Arg1,t,Arg1_t).

base_pty_perms(x).

base_pty_perms(Arg1) :- 
      can_create_pty(Arg1,Arg2).

type_decl(Arg1_devpts_t,[],[file_type,sysadmfile,ptyfile],[Arg2]) :- 
      can_create_pty(Arg1,Arg2),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

access_vector(allow,[Arg1_devpts_t],[devpts_t],[filesystem],[associate]) :- 
      can_create_pty(Arg1,Arg2),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

type_trans([Arg1_t],[devpts_t],[chr_file],Arg1_devpts_t) :- 
      can_create_pty(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

access_vector(allow,[Arg1_t],[Arg1_devpts_t],[chr_file],[setattr,rw_file_perms]) :- 
      can_create_pty(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

can_create_pty(x,[x]).

base_pty_perms(Arg1) :- 
      can_create_other_pty(Arg1,Arg2).

type_trans([Arg1_t],[devpts_t],[chr_file],Arg2_devpts_t) :- 
      can_create_other_pty(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg2,devpts_t,Arg2_devpts_t).

access_vector(allow,[Arg1_t],[Arg2_devpts_t],[chr_file],[setattr,rw_file_perms]) :- 
      can_create_other_pty(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg2,devpts_t,Arg2_devpts_t).

can_create_other_pty(x,x).

access_vector(allow,[Arg1],[etc_t],[lnk_file],[read]) :- 
      read_locale(Arg1).

r_dir_file(Arg1,locale_t) :- 
      read_locale(Arg1).

read_locale(x).

access_vector(allow,[Arg1],[self],[process],[except([ptrace,setexec,setfscreate])]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[dir],[r_dir_perms]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[notdevfile_class_set],[r_file_perms]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[fd],[_]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[fifo_file],[rw_file_perms]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[unix_dgram_socket],[create_socket_perms]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[unix_stream_socket],[create_stream_socket_perms]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[unix_dgram_socket],[sendto]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[unix_stream_socket],[connectto]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[sem],[create_sem_perms]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[msg],[send,receive]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[msgq],[create_msgq_perms]) :- 
      general_domain_access(Arg1).

access_vector(allow,[Arg1],[self],[shm],[create_shm_perms]) :- 
      general_domain_access(Arg1).

general_domain_access(x).

access_vector(allow,[Arg1],[proc_t],[dir],[r_dir_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[proc_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[proc_kmsg_t],[file],[stat_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[proc_kcore_t],[file],[stat_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_modprobe_t],[file],[r_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_t],[file],[r_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_t],[dir],[r_dir_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_fs_t],[file],[r_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_fs_t],[dir],[r_dir_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_kernel_t],[file],[r_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_kernel_t],[dir],[r_dir_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_net_t],[file],[r_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_net_t],[dir],[r_dir_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_vm_t],[file],[r_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_vm_t],[dir],[r_dir_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_dev_t],[file],[r_file_perms]) :- 
      general_proc_read_access(Arg1).

access_vector(allow,[Arg1],[sysctl_dev_t],[dir],[r_dir_perms]) :- 
      general_proc_read_access(Arg1).

general_proc_read_access(x).

access_vector(allow,[Arg1],[root_t],[dir],[r_dir_perms]) :- 
      base_file_read_access(Arg1).

access_vector(allow,[Arg1],[root_t],[notdevfile_class_set],[r_file_perms]) :- 
      base_file_read_access(Arg1).

access_vector(allow,[Arg1],[home_root_t],[dir],[r_dir_perms]) :- 
      base_file_read_access(Arg1).

access_vector(allow,[Arg1],[usr_t],[dir],[r_dir_perms]) :- 
      base_file_read_access(Arg1).

access_vector(allow,[Arg1],[usr_t],[notdevfile_class_set],[r_file_perms]) :- 
      base_file_read_access(Arg1).

access_vector(allow,[Arg1],[bin_t],[dir],[r_dir_perms]) :- 
      base_file_read_access(Arg1).

access_vector(allow,[Arg1],[bin_t],[notdevfile_class_set],[r_file_perms]) :- 
      base_file_read_access(Arg1).

access_vector(allow,[Arg1],[sbin_t],[dir],[r_dir_perms]) :- 
      base_file_read_access(Arg1).

access_vector(allow,[Arg1],[sbin_t],[notdevfile_class_set],[r_file_perms]) :- 
      base_file_read_access(Arg1).

base_file_read_access(x).

errprint('Warning : general_file_read_access is deprecated.') :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[fs_type],[filesystem],[getattr]) :- 
      general_file_read_access(Arg1).

base_file_read_access(Arg1) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[readable_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[readable_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[file_labels_t],[dir],[getattr]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[lost_found_t],[dir],[getattr]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[devpts_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[tmp_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[tmp_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[catman_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[catman_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_lib_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_lib_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_lib_nfs_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_lib_nfs_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

r_dir_file(Arg1,tetex_data_t) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_yp_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_yp_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_spool_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_spool_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_run_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_run_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_log_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_log_sa_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_log_sa_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_log_ksyms_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_lock_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[var_lock_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[initrc_var_run_t],[file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[wtmp_t],[file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[boot_t],[dir],[search,getattr]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[boot_t],[file],[getattr]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[system_map_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[boot_t],[lnk_file],[read]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[etc_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[etc_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[etc_runtime_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[etc_aliases_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[etc_mail_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[etc_mail_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[resolv_conf_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[ld_so_cache_t],[file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[lib_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[lib_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[ld_so_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[shlib_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[exec_type],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[man_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[man_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[src_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[src_t],[notdevfile_class_set],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[modules_object_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[modules_object_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[modules_dep_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[modules_conf_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[device_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[device_t],[lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[random_device_t],[chr_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[zero_device_t],[chr_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[tmpfs_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[tmpfs_t],[lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[device_t],[lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[usbdevfs_t],[dir],[r_dir_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[usbdevfs_t],[file,lnk_file],[r_file_perms]) :- 
      general_file_read_access(Arg1).

access_vector(allow,[Arg1],[usbdevfs_device_t],[file],[getattr]) :- 
      general_file_read_access(Arg1).

general_file_read_access(x).

errprint('Warning : general_file_write_access is deprecated.') :- 
      general_file_write_access(Arg1).

access_vector(allow,[Arg1],[devtty_t],[chr_file],[rw_file_perms]) :- 
      general_file_write_access(Arg1).

access_vector(allow,[Arg1],[null_device_t,zero_device_t],[chr_file],[rw_file_perms]) :- 
      general_file_write_access(Arg1).

access_vector(dontaudit,[Arg1],[ld_so_cache_t],[file],[write]) :- 
      general_file_write_access(Arg1).

general_file_write_access(x).

general_domain_access(Arg1) :- 
      every_test_domain(Arg1).

general_proc_read_access(Arg1) :- 
      every_test_domain(Arg1).

general_file_read_access(Arg1) :- 
      every_test_domain(Arg1).

general_file_write_access(Arg1) :- 
      every_test_domain(Arg1).

uses_shlib(Arg1) :- 
      every_test_domain(Arg1).

access_vector(allow,[Arg1],[locale_t],[dir],[r_dir_perms]) :- 
      every_test_domain(Arg1).

access_vector(allow,[Arg1],[locale_t],[file,lnk_file],[r_file_perms]) :- 
      every_test_domain(Arg1).

every_test_domain(x).

errprint('Warning : every_domain is deprecated.') :- 
      every_domain(Arg1).

every_test_domain(Arg1) :- 
      every_domain(Arg1).

can_network(Arg1) :- 
      every_domain(Arg1).

every_domain(x).

type_decl(Arg1_t,[],[domain,privlog],[Arg2]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

type_decl(Arg1_exec_t,[],[file_type,sysadmfile,exec_type],[]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(exec,t,exec_t),
      compose_id(Arg1,exec_t,Arg1_exec_t).

role_decl(system_r,[Arg1_t]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

domain_auto_trans(initrc_t,Arg1_exec_t,Arg1_t) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(exec,t,exec_t),
      compose_id(Arg1,exec_t,Arg1_exec_t),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[init_t],[fd],[use]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[init_t],[process],[sigchld]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[privfd],[fd],[use]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[self],[process],[signal_perms,fork]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

uses_shlib(Arg1_t) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[self,proc_t],[dir],[r_dir_perms]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[self,proc_t],[lnk_file],[read]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[device_t],[dir],[getattr,search]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[null_device_t],[chr_file],[rw_file_perms]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[console_device_t],[chr_file],[rw_file_perms]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[initrc_devpts_t],[chr_file],[rw_file_perms]) :- 
      daemon_base_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

daemon_base_domain(x,[x]).

type_decl(Arg1_var_run_t,[Id_var_run_Arg1_t],[file_type,sysadmfile,pidfile],[]) :- 
      var_run_domain(Arg1),
      compose_id(run,t,run_t),
      compose_id(var,run_t,var_run_t),
      compose_id(Arg1,var_run_t,Arg1_var_run_t),
      compose_id(Arg1,t,Arg1_t),
      compose_id(var_run,Arg1_t,Id_var_run_Arg1_t).

file_type_auto_trans(Arg1_t,var_run_t,Arg1_var_run_t,file) :- 
      var_run_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(run,t,run_t),
      compose_id(var,run_t,var_run_t),
      compose_id(Arg1,var_run_t,Arg1_var_run_t).

access_vector(allow,[Arg1_t],[Arg1_var_run_t],[dir],[rw_dir_perms]) :- 
      var_run_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(run,t,run_t),
      compose_id(var,run_t,var_run_t),
      compose_id(Arg1,var_run_t,Arg1_var_run_t).

var_run_domain(x).

daemon_base_domain(Arg1,Arg2) :- 
      daemon_domain(Arg1,Arg2).

access_vector(allow,[Arg1_t],[var_t],[dir],[getattr,search]) :- 
      daemon_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

var_run_domain(Arg1) :- 
      daemon_domain(Arg1,Arg2).

access_vector(allow,[Arg1_t],[devtty_t],[chr_file],[rw_file_perms]) :- 
      daemon_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[sysadm_home_dir_t],[dir],[search]) :- 
      daemon_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[fs_type],[filesystem],[getattr]) :- 
      daemon_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

read_locale(Arg1_t) :- 
      daemon_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

daemon_domain(x,[x]).

domain_auto_trans(Arg1,authbind_exec_t,authbind_t) :- 
      uses_authbind(Arg1).

access_vector(allow,[authbind_t],[Arg1],[process],[sigchld]) :- 
      uses_authbind(Arg1).

access_vector(allow,[authbind_t],[Arg1],[fd],[use]) :- 
      uses_authbind(Arg1).

access_vector(allow,[authbind_t],[Arg1],[tcp_socket,udp_socket],[rw_socket_perms]) :- 
      uses_authbind(Arg1).

uses_authbind(x).

type_decl(Arg2_t,[],[domain,privlog],[Arg3]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

type_decl(Arg2_exec_t,[],[file_type,sysadmfile,exec_type],[]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(exec,t,exec_t),
      compose_id(Arg2,exec_t,Arg2_exec_t).

role_decl(system_r,[Arg2_t]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

domain_auto_trans(Arg1,Arg2_exec_t,Arg2_t) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(exec,t,exec_t),
      compose_id(Arg2,exec_t,Arg2_exec_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[Arg1],[fd],[use]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[Arg1],[process],[sigchld]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[self],[process],[signal_perms]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

uses_shlib(Arg2_t) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[self,proc_t],[dir],[r_dir_perms]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[self,proc_t],[lnk_file],[read]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[device_t],[dir],[getattr]) :- 
      daemon_sub_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t).

daemon_sub_domain(x,x,[x]).

type_decl(Arg1_tmp_t,[],[file_type,sysadmfile,tmpfile],[Arg2]) :- 
      tmp_domain(Arg1,Arg2),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

file_type_auto_trans(Arg1_t,tmp_t,Arg1_tmp_t) :- 
      tmp_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

tmp_domain(x,[x]).

type_decl(Arg1_tmpfs_t,[],[file_type,sysadmfile,tmpfsfile],[]) :- 
      tmpfs_domain(Arg1),
      compose_id(tmpfs,t,tmpfs_t),
      compose_id(Arg1,tmpfs_t,Arg1_tmpfs_t).

file_type_auto_trans(Arg1_t,tmpfs_t,Arg1_tmpfs_t) :- 
      tmpfs_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(tmpfs,t,tmpfs_t),
      compose_id(Arg1,tmpfs_t,Arg1_tmpfs_t).

access_vector(allow,[Arg1_tmpfs_t],[tmpfs_t],[filesystem],[associate]) :- 
      tmpfs_domain(Arg1),
      compose_id(tmpfs,t,tmpfs_t),
      compose_id(Arg1,tmpfs_t,Arg1_tmpfs_t).

tmpfs_domain(x).

type_decl(Arg1_var_lib_t,[Id_var_lib_Arg1_t],[file_type,sysadmfile],[]) :- 
      var_lib_domain(Arg1),
      compose_id(lib,t,lib_t),
      compose_id(var,lib_t,var_lib_t),
      compose_id(Arg1,var_lib_t,Arg1_var_lib_t),
      compose_id(Arg1,t,Arg1_t),
      compose_id(var_lib,Arg1_t,Id_var_lib_Arg1_t).

file_type_auto_trans(Arg1_t,var_lib_t,Arg1_var_lib_t) :- 
      var_lib_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(lib,t,lib_t),
      compose_id(var,lib_t,var_lib_t),
      compose_id(Arg1,var_lib_t,Arg1_var_lib_t).

var_lib_domain(x).

type_decl(Arg1_log_t,[],[file_type,sysadmfile,logfile],[]) :- 
      log_domain(Arg1),
      compose_id(log,t,log_t),
      compose_id(Arg1,log_t,Arg1_log_t).

file_type_auto_trans(Arg1_t,var_log_t,Arg1_log_t) :- 
      log_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(log,t,log_t),
      compose_id(Arg1,log_t,Arg1_log_t).

log_domain(x).

type_decl(Arg1_lock_t,[],[file_type,sysadmfile,lockfile],[]) :- 
      lock_domain(Arg1),
      compose_id(lock,t,lock_t),
      compose_id(Arg1,lock_t,Arg1_lock_t).

file_type_auto_trans(Arg1_t,var_lock_t,Arg1_lock_t,file) :- 
      lock_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(lock,t,lock_t),
      compose_id(Arg1,lock_t,Arg1_lock_t).

lock_domain(x).

type_decl(Arg1_t,[],[domain,privlog],[]) :- 
      application_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

type_decl(Arg1_exec_t,[],[file_type,sysadmfile,exec_type],[]) :- 
      application_domain(Arg1),
      compose_id(exec,t,exec_t),
      compose_id(Arg1,exec_t,Arg1_exec_t).

role_decl(sysadm_r,[Arg1_t]) :- 
      application_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

domain_auto_trans(sysadm_t,Arg1_exec_t,Arg1_t) :- 
      application_domain(Arg1),
      compose_id(exec,t,exec_t),
      compose_id(Arg1,exec_t,Arg1_exec_t),
      compose_id(Arg1,t,Arg1_t).

uses_shlib(Arg1_t) :- 
      application_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

application_domain(x).

application_domain(Arg1) :- 
      user_application_domain(Arg1).

in_user_role(Arg1_t) :- 
      user_application_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

domain_auto_trans(userdomain,Arg1_exec_t,Arg1_t) :- 
      user_application_domain(Arg1),
      compose_id(exec,t,exec_t),
      compose_id(Arg1,exec_t,Arg1_exec_t),
      compose_id(Arg1,t,Arg1_t).

user_application_domain(x).

type_decl(Arg1_t,[],[domain,privlog],[Arg2]) :- 
      system_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

type_decl(Arg1_exec_t,[],[file_type,sysadmfile,exec_type],[]) :- 
      system_domain(Arg1,Arg2),
      compose_id(exec,t,exec_t),
      compose_id(Arg1,exec_t,Arg1_exec_t).

role_decl(system_r,[Arg1_t]) :- 
      system_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

uses_shlib(Arg1_t) :- 
      system_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_t],[dir],[r_dir_perms]) :- 
      system_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t).

system_domain(x,[x]).

access_vector(allow,[Arg1_t],[self],[capability],[setgid,chown,fowner]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[self],[capability],[sys_nice,fsetid]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

type_decl(Arg1_home_dir_t,[],[file_type,sysadmfile,home_dir_type,user_home_dir_type,home_type,user_home_type],[]) :- 
      user_domain(Arg1),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t).

type_decl(Arg1_home_t,[],[file_type,sysadmfile,home_type,user_home_type],[]) :- 
      user_domain(Arg1),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

file_type_auto_trans(privhome,Arg1_home_dir_t,Arg1_home_t) :- 
      user_domain(Arg1),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

tmp_domain(Arg1,[user_tmpfile]) :- 
      user_domain(Arg1).

file_type_auto_trans(Arg1_t,Arg1_home_dir_t,Arg1_home_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(allow,[Arg1_t],[Arg1_home_t],[dir_file_class_set],[relabelfrom,relabelto]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(allow,[Arg1_t],[Arg1_tmp_t],[unix_stream_socket],[name_bind]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

type_decl(Arg1_tty_device_t,[],[file_type,sysadmfile,ttyfile],[]) :- 
      user_domain(Arg1),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_t],[privfd],[fd],[use]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[Arg1_tty_device_t],[chr_file],[setattr,rw_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

type_change([Arg1_t],[tty_device_t],[chr_file],Arg1_tty_device_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_t],[locale_t],[dir],[r_dir_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[locale_t],[file,lnk_file],[r_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

r_dir_file(Arg1_t,tetex_data_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_exec(Arg1_t,tetex_data_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_create_pty(Arg1,userpty_type) :- 
      user_domain(Arg1).

access_vector(allow,[Arg1_t],[boot_t],[dir],[getattr,search]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[boot_t],[dir],[read]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[boot_t],[lnk_file],[getattr]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[boot_t],[file],[getattr,read]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[system_map_t],[file],[getattr,read]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

tmpfs_domain(Arg1) :- 
      user_domain(Arg1).

access_vector(allow,[Arg1_t],[catman_t],[dir],[rw_dir_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[catman_t],[notdevfile_class_set],[create_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[mail_spool_t],[dir],[r_dir_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[mail_spool_t],[file],[rw_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[mail_spool_t],[lnk_file],[read]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[fs_type],[filesystem],[quotaget]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_exec_any(Arg1_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_exec(Arg1_t,Arg1_home_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

can_exec(Arg1_t,Arg1_tmp_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

access_vector(allow,[Arg1_t],[mouse_device_t],[chr_file],[r_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[misc_device_t],[file_class_set],[rw_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_network(Arg1_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[resolv_conf_t],[file],[getattr,read]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[resolv_conf_t],[file],[ioctl]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[node_lo_t],[node],[enforce_dest]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_udp_send(Arg1_t,Arg1_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_tcp_connect(Arg1_t,Arg1_t) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[kernel_t],[system],[syslog_read]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[kernel_t],[system],[ipc_info]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[domain],[dir],[r_dir_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[domain],[notdevfile_class_set],[r_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[initrc_var_run_t],[file],[getattr,read,write]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[tmpfile],[dir_file_class_set],[getattr]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[removable_device_t,fixed_disk_device_t],[blk_file],[getattr]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[sound_device_t],[chr_file],[getattr,read,write,ioctl]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[fs_type],[filesystem],[getattr]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[devtty_t],[chr_file],[rw_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[null_device_t],[chr_file],[rw_file_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[zero_device_t],[chr_file],[rw_file_perms,execute]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[random_device_t],[chr_file],[getattr,read]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[devpts_t],[dir],[r_dir_perms]) :- 
      user_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

user_domain(x).

type_decl(Arg1_t,[],[domain,userdomain,unpriv_userdomain,web_client_domain],[]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

role_decl(Arg1_r,[Arg1_t]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(Arg1,t,Arg1_t).

role_decl([system_r],[Arg1_r]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,r,Arg1_r).

general_domain_access(Arg1_t) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[proc_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[proc_t],[file,lnk_file],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

base_file_read_access(Arg1_t) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[readable_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[readable_t],[notdevfile_class_set],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[file_labels_t],[dir],[getattr]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[lost_found_t],[dir],[getattr]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[tmp_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[tmp_t],[file,lnk_file],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[var_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[var_t],[notdevfile_class_set],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[var_spool_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[var_spool_t],[notdevfile_class_set],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[var_run_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[var_run_t],[file,lnk_file],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[sysctl_kernel_t],[dir],[search]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[sysctl_kernel_t],[file],[getattr,read]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_t],[notdevfile_class_set],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_runtime_t],[file,lnk_file],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[modules_conf_t],[file],[getattr,read]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[man_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[man_t],[notdevfile_class_set],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[device_t],[dir],[r_dir_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[device_t],[lnk_file],[r_file_perms]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[ld_so_cache_t],[file],[write]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

uses_shlib(Arg1_t) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

user_domain(Arg1) :- 
      full_user_role(Arg1).

access_vector(dontaudit,[Arg1_t],[sysadm_home_t],[dir],[read,search,getattr]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[sysadm_home_t],[file],[read,getattr,append]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[file_t],[dir,file,lnk_file],[getattr]) :- 
      full_user_role(Arg1),
      compose_id(Arg1,t,Arg1_t).

full_user_role(x).

role_decl(user_r,[Arg1]) :- 
      in_user_role(Arg1).

role_decl(staff_r,[Arg1]) :- 
      in_user_role(Arg1).

in_user_role(x).

chkpwd_domain.

set_macro(chroot_role,[Arg1_r]) :- 
      chroot(Arg1,Arg2).

set_macro(chroot_tty_device,[Arg1_devpts_t,Arg1_tty_device_t]) :- 
      chroot(Arg1,Arg2).

set_macro(chroot_fd_use,[privfd]) :- 
      chroot(Arg1,Arg2).

mount_domain(Arg1,Arg1_mount) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,mount,Arg1_mount).

role_decl(chroot_role,[Arg1_mount_t]) :- 
      chroot(Arg1,Arg2),
      compose_id(mount,t,mount_t),
      compose_id(Arg1,mount_t,Arg1_mount_t).

set_macro(chroot_mount_domain,[Arg1_mount_t]) :- 
      chroot(Arg1,Arg2).

type_decl(Arg2_ro_t,[],[file_type,sysadmfile,home_type,user_home_type],[]) :- 
      chroot(Arg1,Arg2),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t).

type_decl(Arg2_rw_t,[],[file_type,sysadmfile,home_type,user_home_type],[]) :- 
      chroot(Arg1,Arg2),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t).

type_decl(Arg2_dropdown_t,[],[file_type,sysadmfile,home_type,user_home_type],[]) :- 
      chroot(Arg1,Arg2),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t).

access_vector(allow,[chroot_mount_domain],[Arg2_rw_t,Arg2_ro_t],[dir],[getattr,search,mounton]) :- 
      chroot(Arg1,Arg2),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t).

access_vector(allow,[chroot_mount_domain],[Arg2_rw_t,Arg2_ro_t],[file],[getattr,mounton]) :- 
      chroot(Arg1,Arg2),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t).

type_decl(Arg2_super_entry_t,[],[file_type,sysadmfile,home_type,user_home_type],[]) :- 
      chroot(Arg1,Arg2),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t).

type_decl(Arg2_t,[],[domain,userdomain,unpriv_userdomain],[]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

type_decl(Arg2_super_t,[],[domain,userdomain,unpriv_userdomain],[]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

access_vector(allow,[Arg2_super_t],[chroot_tty_device],[chr_file],[rw_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

define(Arg1_chroot_def) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,def,chroot_def),
      compose_id(Arg1,chroot_def,Arg1_chroot_def).

access_vector(allow,[chroot_mount_domain],[proc_t,device_t,fs_t],[filesystem],[mount,unmount]) :- 
      chroot(Arg1,Arg2).

type_decl(Arg1_chroot_t,[],[domain],[]) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

access_vector(allow,[Arg1_chroot_t],[chroot_tty_device],[chr_file],[rw_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

access_vector(allow,[Arg1_chroot_t],[chroot_fd_use],[fd],[use]) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

access_vector(allow,[Arg1_chroot_t,Arg2_t,Arg2_super_t],[Arg1_t],[fd],[use]) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t),
      compose_id(Arg2,t,Arg2_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg1,t,Arg1_t).

role_decl(chroot_role,[Arg1_chroot_t]) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

uses_shlib(Arg1_chroot_t) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

access_vector(allow,[Arg1_chroot_t],[self],[capability],[sys_chroot]) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

access_vector(allow,[Arg1_t],[Arg1_chroot_t],[dir],[search,getattr,read]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

access_vector(allow,[Arg1_t],[Arg1_chroot_t],[file,lnk_file],[read,getattr]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

domain_auto_trans(Arg1_t,chroot_exec_t,Arg1_chroot_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

access_vector(allow,[Arg1_chroot_t],[fs_t],[filesystem],[getattr]) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t).

role_decl(chroot_role,[Arg2_t,Arg2_super_t]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

access_vector(allow,[Arg1_t],[Arg2_super_t,Arg2_t],[dir],[search,getattr,read]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg1_t],[Arg2_super_t,Arg2_t],[file,lnk_file],[read,getattr]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg1_t],[Arg2_super_t,Arg2_t],[process],[signal_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t],[Arg2_t],[dir],[search,getattr,read]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t],[Arg2_t],[file,lnk_file],[read,getattr]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg1_t,Arg2_super_t],[Arg2_t],[process],[signal_perms,ptrace]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg1_t],[Arg2_super_t],[process],[signal_perms,ptrace]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

access_vector(allow,[sysadm_t],[Arg2_super_t,Arg2_t],[process],[signal_perms,ptrace]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t,Arg2_t],[fs_t,device_t],[filesystem],[getattr]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t,Arg2_t],[device_t],[dir],[search,getattr]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t,Arg2_t],[devtty_t],[chr_file],[rw_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t,Arg2_t],[random_device_t],[chr_file],[r_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t,Arg2_t],[self],[capability],[fowner,chown,fsetid,setgid,setuid,net_bind_service,sys_tty_config]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t],[self],[capability],[sys_ptrace]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

can_tcp_connect(Arg2_super_t,Arg2_t) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_super_t,Arg2_t],[Arg2_rw_t],[sock_file],[create_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t).

access_vector(dontaudit,[Arg2_super_t,Arg2_t],[domain],[dir],[search,getattr]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[chroot_tty_device],[chr_file],[read,write]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

r_dir_file(Arg1_chroot_t,Arg2_ro_t,Arg2_rw_t,Arg2_super_entry_t,Arg2_dropdown_t) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t).

can_exec(Arg2_t,Arg2_ro_t,Arg2_rw_t,Arg2_super_entry_t,Arg2_dropdown_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t).

can_exec(Arg2_super_t,Arg2_ro_t,Arg2_super_entry_t) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t).

create_dir_notdevfile(Arg2_super_t,Arg2_ro_t,Arg2_rw_t,Arg2_super_entry_t,Arg2_dropdown_t) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t).

domain_auto_trans(Arg2_super_t,Arg2_rw_t,Arg2_dropdown_t,Arg2_t) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg1_chroot_t],[Arg2_ro_t,Arg2_rw_t],[lnk_file],[read]) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t).

r_dir_file(Arg2_t,Arg2_ro_t,Arg2_super_entry_t,Arg2_dropdown_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t).

create_dir_notdevfile(Arg2_t,Arg2_rw_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t).

access_vector(allow,[Arg2_t],[Arg2_rw_t],[fifo_file],[create_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t).

access_vector(allow,[Arg2_t],[Arg2_ro_t],[fifo_file],[rw_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t).

access_vector(allow,[Arg1_t,Arg2_super_t],[Arg2_rw_t,Arg2_ro_t],[fifo_file],[create_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t).

create_dir_notdevfile(Arg1_t,Arg2_ro_t,Arg2_rw_t,Arg2_super_entry_t,Arg2_dropdown_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t).

can_exec(Arg1_t,Arg2_ro_t,Arg2_dropdown_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t).

domain_auto_trans(Arg1_chroot_t,Arg2_ro_t,Arg2_rw_t,Arg2_dropdown_t,Arg2_t) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t),
      compose_id(Arg2,t,Arg2_t).

domain_auto_trans(Arg1_chroot_t,Arg2_super_entry_t,Arg2_super_t) :- 
      chroot(Arg1,Arg2),
      compose_id(chroot,t,chroot_t),
      compose_id(Arg1,chroot_t,Arg1_chroot_t),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

access_vector(allow,[Arg1_t,Arg2_super_t],[Arg2_ro_t,Arg2_rw_t,Arg2_super_entry_t,Arg2_dropdown_t],[dir,notdevfile_class_set],[relabelfrom,relabelto]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(entry,t,entry_t),
      compose_id(super,entry_t,super_entry_t),
      compose_id(Arg2,super_entry_t,Arg2_super_entry_t),
      compose_id(dropdown,t,dropdown_t),
      compose_id(Arg2,dropdown_t,Arg2_dropdown_t).

general_proc_read_access(Arg2_t,Arg2_super_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

general_domain_access(Arg2_t,Arg2_super_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

can_create_pty(Arg2) :- 
      chroot(Arg1,Arg2).

can_create_pty(Arg2_super) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,super,Arg2_super).

can_network(Arg2_t,Arg2_super_t) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

access_vector(allow,[Arg2_t,Arg2_super_t],[null_device_t],[chr_file],[rw_file_perms]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

access_vector(allow,[Arg2_super_t],[Arg2_rw_t,Arg2_ro_t],[dir,file],[mounton]) :- 
      chroot(Arg1,Arg2),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t).

access_vector(allow,[Arg2_t,Arg2_super_t],[self],[capability],[dac_override,kill]) :- 
      chroot(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(super,t,super_t),
      compose_id(Arg2,super_t,Arg2_super_t).

chroot(x,x).

type_decl(Arg1_clamscan_t,[],[domain,privlog],[]) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

uses_shlib(Arg1_clamscan_t) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

access_vector(allow,[Arg1_clamscan_t],[fs_t],[filesystem],[getattr]) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

r_dir_file(Arg1_clamscan_t,etc_t) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

read_locale(Arg1_clamscan_t) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

access_vector(allow,[Arg1_clamscan_t],[var_lib_t],[dir],[search]) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

r_dir_file(Arg1_clamscan_t,clamav_var_lib_t) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

tmp_domain(Arg1_clamscan,[]) :- 
      clamscan_domain(Arg1),
      compose_id(Arg1,clamscan,Arg1_clamscan).

access_vector(allow,[Arg1_clamscan_t],[proc_t],[dir],[r_dir_perms]) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

access_vector(allow,[Arg1_clamscan_t],[proc_t],[file],[r_file_perms]) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

access_vector(allow,[Arg1_clamscan_t],[sysctl_kernel_t],[dir],[r_dir_perms]) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

access_vector(allow,[Arg1_clamscan_t],[sysctl_kernel_t],[file],[r_file_perms]) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

access_vector(allow,[Arg1_clamscan_t],[self],[unix_stream_socket],[connect,create,read,write]) :- 
      clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

clamscan_domain(x).

clamscan_domain(Arg1) :- 
      user_clamscan_domain(Arg1).

role_decl(Arg1_r,[Arg1_clamscan_t]) :- 
      user_clamscan_domain(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

domain_auto_trans(Arg1_t,clamscan_exec_t,Arg1_clamscan_t) :- 
      user_clamscan_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

access_vector(allow,[Arg1_clamscan_t],[Arg1_tty_device_t],[chr_file],[rw_file_perms]) :- 
      user_clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_clamscan_t],[Arg1_devpts_t],[chr_file],[rw_file_perms]) :- 
      user_clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

r_dir_file(Arg1_clamscan_t,Arg1_home_t) :- 
      user_clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

r_dir_file(Arg1_clamscan_t,Arg1_home_dir_t) :- 
      user_clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t).

access_vector(allow,[Arg1_clamscan_t],[Arg1_home_t],[file],[r_file_perms]) :- 
      user_clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(allow,[Arg1_clamscan_t],[privfd],[fd],[use]) :- 
      user_clamscan_domain(Arg1),
      compose_id(clamscan,t,clamscan_t),
      compose_id(Arg1,clamscan_t,Arg1_clamscan_t).

user_clamscan_domain(x).

type_decl(Arg1_freshclam_t,[],[domain,privlog],[]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

uses_shlib(Arg1_freshclam_t) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

read_locale(Arg1_freshclam_t) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

r_dir_file(Arg1_freshclam_t,etc_t) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[resolv_conf_t],[file],[read,getattr]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[var_lib_t],[dir],[search]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

rw_dir_create_file(Arg1_freshclam_t,clamav_var_lib_t) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[Arg1_freshclam_t],[capability],[setgid,setuid]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

can_network(Arg1_freshclam_t) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[var_log_t],[dir],[search]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[var_log_freshclam_t],[file],[rw_file_perms]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[proc_t],[dir],[r_dir_perms]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[proc_t],[file],[r_file_perms]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[sysctl_kernel_t],[dir],[r_dir_perms]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[sysctl_kernel_t],[file],[r_file_perms]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[self],[unix_stream_socket],[connect,create,read,write]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[random_device_t],[chr_file],[getattr,read]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(dontaudit,[Arg1_freshclam_t],[random_device_t],[chr_file],[ioctl]) :- 
      freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

freshclam_domain(x).

freshclam_domain(Arg1) :- 
      user_freshclam_domain(Arg1).

role_decl(Arg1_r,[Arg1_freshclam_t]) :- 
      user_freshclam_domain(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

domain_auto_trans(Arg1_t,freshclam_exec_t,Arg1_freshclam_t) :- 
      user_freshclam_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

access_vector(allow,[Arg1_freshclam_t],[Arg1_tty_device_t],[chr_file],[rw_file_perms]) :- 
      user_freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_freshclam_t],[Arg1_devpts_t],[chr_file],[rw_file_perms]) :- 
      user_freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

access_vector(allow,[Arg1_freshclam_t],[privfd],[fd],[use]) :- 
      user_freshclam_domain(Arg1),
      compose_id(freshclam,t,freshclam_t),
      compose_id(Arg1,freshclam_t,Arg1_freshclam_t).

user_freshclam_domain(x).

type_decl(Arg1_crond_t,[],[domain,user_crond_domain],[]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

domain_trans(crond_t,shell_exec_t,Arg1_crond_t) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

role_decl(Arg1_r,[Arg1_crond_t]) :- 
      crond_domain(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

can_network(Arg1_crond_t) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[resolv_conf_t],[file],[getattr,read]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

uses_shlib(Arg1_crond_t) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

r_dir_file(Arg1_crond_t,self) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[self],[fifo_file],[rw_file_perms]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[self],[unix_stream_socket],[create_socket_perms]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[self],[unix_dgram_socket],[create_socket_perms]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[etc_runtime_t],[file],[getattr,read]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[self],[process],[fork,signal_perms]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[proc_t],[dir],[getattr,search,read]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[proc_t],[file],[getattr,read]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

read_locale(Arg1_crond_t) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[sysctl_kernel_t],[dir],[search]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[sysctl_kernel_t],[file],[getattr,read]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[var_spool_t],[dir],[search]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[fs_t],[filesystem],[getattr]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[devtty_t],[chr_file],[read,write]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[Arg1_crond_t],[capability],[dac_override]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[initrc_t],[fd],[use]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(allow,[Arg1_crond_t],[Arg1_cron_spool_t],[file],[entrypoint]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t),
      compose_id(spool,t,spool_t),
      compose_id(cron,spool_t,cron_spool_t),
      compose_id(Arg1,cron_spool_t,Arg1_cron_spool_t).

access_vector(allow,[Arg1_crond_t],[home_root_t],[dir],[search]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

file_type_auto_trans(Arg1_crond_t,Arg1_home_dir_t,Arg1_home_t) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

file_type_auto_trans(Arg1_crond_t,tmp_t,Arg1_tmp_t) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

can_exec_any(Arg1_crond_t) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

can_exec(Arg1_crond_t,Arg1_home_t) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(dontaudit,[Arg1_crond_t],[boot_t],[dir],[search]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

access_vector(dontaudit,[Arg1_crond_t],[domain],[dir],[getattr]) :- 
      crond_domain(Arg1),
      compose_id(crond,t,crond_t),
      compose_id(Arg1,crond_t,Arg1_crond_t).

crond_domain(x).

domain_auto_trans(system_crond_t,Arg1,Arg2) :- 
      system_crond_entry(Arg1,Arg2).

access_vector(allow,[Arg2],[crond_t],[fifo_file],[getattr,read,write,ioctl]) :- 
      system_crond_entry(Arg1,Arg2).

access_vector(allow,[Arg2],[crond_t],[fd],[use]) :- 
      system_crond_entry(Arg1,Arg2).

access_vector(allow,[Arg2],[crond_t],[process],[sigchld]) :- 
      system_crond_entry(Arg1,Arg2).

system_crond_entry(x,x).

type_decl(Arg1_crontab_t,[],[domain,privlog],[]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

domain_auto_trans(Arg1_t,crontab_exec_t,Arg1_crontab_t) :- 
      crontab_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

role_decl(Arg1_r,[Arg1_crontab_t]) :- 
      crontab_domain(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

uses_shlib(Arg1_crontab_t) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[etc_t],[file],[getattr,read]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[self],[unix_stream_socket],[create_socket_perms]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[self],[unix_dgram_socket],[create_socket_perms]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

read_locale(Arg1_crontab_t) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[Arg1_crontab_t],[capability],[setuid,setgid,chown]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

file_type_auto_trans(Arg1_crontab_t,tmp_t,Arg1_tmp_t) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

type_decl(Arg1_cron_spool_t,[],[file_type,sysadmfile],[]) :- 
      crontab_domain(Arg1),
      compose_id(spool,t,spool_t),
      compose_id(cron,spool_t,cron_spool_t),
      compose_id(Arg1,cron_spool_t,Arg1_cron_spool_t).

access_vector(allow,[sysadm_crontab_t],[Arg1_cron_spool_t],[file],[getattr,read]) :- 
      crontab_domain(Arg1),
      compose_id(spool,t,spool_t),
      compose_id(cron,spool_t,cron_spool_t),
      compose_id(Arg1,cron_spool_t,Arg1_cron_spool_t).

access_vector(allow,[Arg1_crontab_t],[var_t,var_spool_t],[dir],[search]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

file_type_auto_trans(Arg1_crontab_t,cron_spool_t,Arg1_cron_spool_t) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t),
      compose_id(spool,t,spool_t),
      compose_id(cron,spool_t,cron_spool_t),
      compose_id(Arg1,cron_spool_t,Arg1_cron_spool_t).

access_vector(allow,[Arg1_crontab_t],[self],[process],[fork,signal_perms]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[cron_spool_t],[dir],[setattr]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[crond_t],[Arg1_cron_spool_t],[file],[r_file_perms]) :- 
      crontab_domain(Arg1),
      compose_id(spool,t,spool_t),
      compose_id(cron,spool_t,cron_spool_t),
      compose_id(Arg1,cron_spool_t,Arg1_cron_spool_t).

access_vector(allow,[Arg1_crontab_t],[bin_t,sbin_t],[dir],[search]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[bin_t],[lnk_file],[read]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

domain_auto_trans(Arg1_crontab_t,bin_t,sbin_t,shell_exec_t,Arg1_t) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_crontab_t],[Arg1_home_t,Arg1_home_dir_t],[dir],[r_dir_perms]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t).

access_vector(allow,[Arg1_crontab_t],[Arg1_home_t],[file],[r_file_perms]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(dontaudit,[Arg1_crontab_t],[Arg1_home_dir_t],[dir],[write]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t).

access_vector(allow,[Arg1_crontab_t],[cron_log_t],[file],[r_file_perms]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[cron_log_t],[file],[append]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[device_t],[dir],[search]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

access_vector(allow,[Arg1_crontab_t],[Arg1_tty_device_t],[chr_file],[rw_file_perms]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_crontab_t],[Arg1_devpts_t],[chr_file],[rw_file_perms]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

access_vector(allow,[Arg1_crontab_t],[privfd],[fd],[use]) :- 
      crontab_domain(Arg1),
      compose_id(crontab,t,crontab_t),
      compose_id(Arg1,crontab_t,Arg1_crontab_t).

crontab_domain(x).

type_decl(Arg1_home_fingerlog_t,[],[file_type,sysadmfile],[]) :- 
      fingerd_macro(Arg1),
      compose_id(fingerlog,t,fingerlog_t),
      compose_id(home,fingerlog_t,home_fingerlog_t),
      compose_id(Arg1,home_fingerlog_t,Arg1_home_fingerlog_t).

file_type_auto_trans(fingerd_t,Arg1_home_dir_t,Arg1_home_fingerlog_t) :- 
      fingerd_macro(Arg1),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(fingerlog,t,fingerlog_t),
      compose_id(home,fingerlog_t,home_fingerlog_t),
      compose_id(Arg1,home_fingerlog_t,Arg1_home_fingerlog_t).

fingerd_macro(x).

type_decl(Arg1_gpg_t,[],[domain,privlog],[]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

domain_auto_trans(Arg1_t,gpg_exec_t,Arg1_gpg_t) :- 
      gpg_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

can_network(Arg1_gpg_t) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(dontaudit,[Arg1_gpg_t],[Arg1_t],[unix_stream_socket],[read,write]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(Arg1,t,Arg1_t).

role_decl(Arg1_r,[Arg1_gpg_t]) :- 
      gpg_domain(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

type_decl(Arg1_gpg_secret_t,[],[file_type,sysadmfile],[]) :- 
      gpg_domain(Arg1),
      compose_id(secret,t,secret_t),
      compose_id(gpg,secret_t,gpg_secret_t),
      compose_id(Arg1,gpg_secret_t,Arg1_gpg_secret_t).

access_vector(allow,[Arg1_t],[Arg1_gpg_secret_t],[file],[getattr]) :- 
      gpg_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(secret,t,secret_t),
      compose_id(gpg,secret_t,gpg_secret_t),
      compose_id(Arg1,gpg_secret_t,Arg1_gpg_secret_t).

access_vector(allow,[Arg1_gpg_t],[device_t],[dir],[r_dir_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[random_device_t],[chr_file],[r_file_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[etc_t,resolv_conf_t],[file],[r_file_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[self],[unix_stream_socket],[create_stream_socket_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[self],[tcp_socket],[create_stream_socket_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[Arg1_devpts_t,Arg1_tty_device_t],[chr_file],[rw_file_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_gpg_t],[privfd],[fd],[use]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[Arg1_t],[fd],[use]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_gpg_t],[Arg1_t],[process],[sigchld]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t,Arg1_gpg_t],[Arg1_gpg_t],[process],[signal]) :- 
      gpg_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_t],[Arg1_gpg_t],[dir],[search,getattr,read]) :- 
      gpg_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_t],[Arg1_gpg_t],[file,lnk_file],[read,getattr]) :- 
      gpg_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

uses_shlib(Arg1_gpg_t) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[home_root_t],[dir],[read,search]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

file_type_auto_trans(Arg1_gpg_t,Arg1_home_dir_t,Arg1_gpg_secret_t,dir) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(secret,t,secret_t),
      compose_id(gpg,secret_t,gpg_secret_t),
      compose_id(Arg1,gpg_secret_t,Arg1_gpg_secret_t).

rw_dir_create_file(Arg1_gpg_t,Arg1_gpg_secret_t) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(secret,t,secret_t),
      compose_id(gpg,secret_t,gpg_secret_t),
      compose_id(Arg1,gpg_secret_t,Arg1_gpg_secret_t).

file_type_auto_trans(Arg1_gpg_t,Arg1_home_dir_t,Arg1_home_t,file) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

create_dir_file(Arg1_gpg_t,Arg1_home_t) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

file_type_auto_trans(Arg1_gpg_t,tmp_t,Arg1_tmp_t) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

access_vector(allow,[Arg1_gpg_t],[self],[capability],[ipc_lock,setuid]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[devtty_t],[chr_file],[rw_file_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[etc_t,usr_t],[dir],[r_dir_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[fs_t],[filesystem],[getattr]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_gpg_t],[usr_t],[file],[r_file_perms]) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

read_locale(Arg1_gpg_t) :- 
      gpg_domain(Arg1),
      compose_id(gpg,t,gpg_t),
      compose_id(Arg1,gpg_t,Arg1_gpg_t).

access_vector(allow,[Arg1_t],[Arg1_gpg_secret_t],[dir],[rw_dir_perms]) :- 
      gpg_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(secret,t,secret_t),
      compose_id(gpg,secret_t,gpg_secret_t),
      compose_id(Arg1,gpg_secret_t,Arg1_gpg_secret_t).

gpg_domain(x).

type_decl(Arg1_gph_t,[],[domain,gphdomain],[]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

domain_auto_trans(Arg1_t,gph_exec_t,Arg1_gph_t) :- 
      gph_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

role_decl(Arg1_r,[Arg1_gph_t]) :- 
      gph_domain(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

uses_shlib(Arg1_gph_t) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

access_vector(allow,[Arg1_gph_t],[Arg1_gph_t],[capability],[setuid,setgid,fsetid]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

can_create_other_pty(Arg1_gph,Arg1) :- 
      gph_domain(Arg1),
      compose_id(Arg1,gph,Arg1_gph).

access_vector(allow,[Arg1_gph_t],[initrc_var_run_t],[file],[rw_file_perms]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

access_vector(allow,[Arg1_gph_t],[wtmp_t],[file],[rw_file_perms]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

access_vector(allow,[Arg1_gph_t],[Arg1_t],[unix_stream_socket],[rw_stream_socket_perms]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_gph_t],[Arg1_tty_device_t],[chr_file],[rw_file_perms]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_t],[Arg1_gph_t],[fd],[use]) :- 
      gph_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

can_network(Arg1_gph_t) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

access_vector(allow,[Arg1_gph_t],[lastlog_t],[file],[rw_file_perms]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

access_vector(allow,[Arg1_gph_t],[home_root_t],[dir],[search]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t).

access_vector(allow,[Arg1_gph_t],[Arg1_home_t],[dir],[search,add_name]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(allow,[Arg1_gph_t],[Arg1_home_t],[file],[create,write]) :- 
      gph_domain(Arg1),
      compose_id(gph,t,gph_t),
      compose_id(Arg1,gph_t,Arg1_gph_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

gph_domain(x).

irc_domain.

type_decl(Arg1_lpr_t,[],[domain,privlog],[]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

domain_auto_trans(Arg1_t,lpr_exec_t,Arg1_lpr_t) :- 
      lpr_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

access_vector(allow,[Arg1_t],[Arg1_lpr_t],[process],[signull]) :- 
      lpr_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

uses_shlib(Arg1_lpr_t) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

read_locale(Arg1_lpr_t) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

role_decl(Arg1_r,[Arg1_lpr_t]) :- 
      lpr_domain(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

can_network(Arg1_lpr_t) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

access_vector(allow,[Arg1_lpr_t],[resolv_conf_t],[file],[getattr,read]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

access_vector(allow,[Arg1_lpr_t],[Arg1_lpr_t],[capability],[setuid,dac_override,net_bind_service,chown]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

access_vector(allow,[Arg1_lpr_t],[self],[unix_stream_socket],[create_stream_socket_perms]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

r_dir_file(Arg1_lpr_t,etc_t) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

type_decl(Arg1_lpr_tmp_t,[],[file_type,sysadmfile,tmpfile],[]) :- 
      lpr_domain(Arg1),
      compose_id(tmp,t,tmp_t),
      compose_id(lpr,tmp_t,lpr_tmp_t),
      compose_id(Arg1,lpr_tmp_t,Arg1_lpr_tmp_t).

file_type_auto_trans(Arg1_lpr_t,tmp_t,Arg1_lpr_tmp_t) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t),
      compose_id(tmp,t,tmp_t),
      compose_id(lpr,tmp_t,lpr_tmp_t),
      compose_id(Arg1,lpr_tmp_t,Arg1_lpr_tmp_t).

r_dir_file(Arg1_lpr_t,Arg1_tmp_t) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

type_decl(Arg1_print_spool_t,[],[file_type,sysadmfile],[]) :- 
      lpr_domain(Arg1),
      compose_id(spool,t,spool_t),
      compose_id(print,spool_t,print_spool_t),
      compose_id(Arg1,print_spool_t,Arg1_print_spool_t).

file_type_auto_trans(Arg1_lpr_t,print_spool_t,Arg1_print_spool_t) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t),
      compose_id(spool,t,spool_t),
      compose_id(print,spool_t,print_spool_t),
      compose_id(Arg1,print_spool_t,Arg1_print_spool_t).

access_vector(allow,[Arg1_lpr_t],[device_t],[dir],[search]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

access_vector(allow,[Arg1_lpr_t],[Arg1_tty_device_t],[chr_file],[rw_file_perms]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_lpr_t],[Arg1_devpts_t],[chr_file],[rw_file_perms]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

access_vector(allow,[Arg1_lpr_t],[privfd],[fd],[use]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

access_vector(allow,[Arg1_lpr_t],[home_root_t,Arg1_home_t,Arg1_home_dir_t],[dir],[search]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t).

access_vector(allow,[Arg1_lpr_t],[Arg1_home_t],[file,lnk_file],[r_file_perms]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(allow,[Arg1_lpr_t],[print_spool_t],[notdevfile_class_set],[rw_file_perms]) :- 
      lpr_domain(Arg1),
      compose_id(lpr,t,lpr_t),
      compose_id(Arg1,lpr_t,Arg1_lpr_t).

lpr_domain(x).

%$2_def :- 
%      mount_domain(Arg1,Arg2).

type_decl(Arg2_t,[],[domain,privlog],[]) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

uses_shlib(Arg2_t) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

domain_auto_trans(Arg1_t,mount_exec_t,Arg2_t) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg1,t,Arg1_t),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[proc_t],[dir],[search]) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

tmp_domain(_,Arg2) :- 
      mount_domain(Arg1,Arg2).

access_vector(allow,[Arg2_t],[self],[capability],[net_bind_service,sys_rawio,sys_admin]) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

file_type_auto_trans(Arg2_t,etc_t,etc_runtime_t,file) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[etc_t],[file],[getattr,read]) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

read_locale(Arg2_t) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t).

access_vector(allow,[Arg2_t],[Arg1_tty_device_t],[chr_file],[getattr,read,write,ioctl]) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg2_t],[Arg1_devpts_t],[chr_file],[getattr,read,write]) :- 
      mount_domain(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

mount_domain(x,x).

type_decl(Arg1_mail_t,[],[domain,privlog,user_mail_domain],[]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

can_tcp_connect(Arg1_t,mail_server_domain) :- 
      mail_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

domain_auto_trans(Arg1_t,sendmail_exec_t,Arg1_mail_t) :- 
      mail_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

can_exec(Arg1_mail_t,sendmail_exec_t) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

role_decl(Arg1_r,[Arg1_mail_t]) :- 
      mail_domain(Arg1),
      compose_id(Arg1,r,Arg1_r),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

uses_shlib(Arg1_mail_t) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

can_network(Arg1_mail_t) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[self],[unix_dgram_socket],[create_socket_perms]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[self],[unix_stream_socket],[create_socket_perms]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

read_locale(Arg1_mail_t) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[device_t],[dir],[search]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[var_t,var_spool_t],[dir],[search]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[self],[process],[fork,signal_perms]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[sbin_t],[dir],[search]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(dontaudit,[Arg1_mail_t],[var_run_t],[dir],[search]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[self],[capability],[setuid,setgid,chown]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

can_exec(Arg1_mail_t,bin_t) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[Arg1_tmp_t],[file],[read,getattr]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

access_vector(dontaudit,[Arg1_mail_t],[Arg1_tmp_t],[file],[append]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

access_vector(allow,[mta_user_agent],[Arg1_tmp_t],[file],[read,getattr]) :- 
      mail_domain(Arg1),
      compose_id(tmp,t,tmp_t),
      compose_id(Arg1,tmp_t,Arg1_tmp_t).

access_vector(allow,[mta_user_agent],[Arg1_devpts_t,Arg1_tty_device_t],[chr_file],[getattr,read,write]) :- 
      mail_domain(Arg1),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_mail_t],[Arg1_tty_device_t,Arg1_devpts_t,devtty_t],[chr_file],[rw_file_perms]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

access_vector(allow,[Arg1_mail_t],[privfd],[fd],[use]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

file_type_auto_trans(Arg1_mail_t,Arg1_home_dir_t,Arg1_home_t,file) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

file_type_auto_trans(mta_delivery_agent,Arg1_home_dir_t,Arg1_home_t) :- 
      mail_domain(Arg1),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(allow,[Arg1_mail_t],[etc_t],[file],[getattr,read]) :- 
      mail_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

mail_domain(x).

x_client_domain(Arg1,netscape,web_client_domain,privlog) :- 
      netscape_domain(Arg1).

access_vector(allow,[Arg1_netscape_t],[var_lib_t],[file],[getattr,read]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(allow,[Arg1_netscape_t],[random_device_t],[chr_file],[getattr,ioctl,read]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(allow,[Arg1_netscape_t],[self],[socket],[create]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(allow,[Arg1_t],[Arg1_netscape_rw_t],[sock_file],[create_file_perms]) :- 
      netscape_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(rw,t,rw_t),
      compose_id(netscape,rw_t,netscape_rw_t),
      compose_id(Arg1,netscape_rw_t,Arg1_netscape_rw_t).

can_unix_connect(Arg1_t,Arg1_netscape_t) :- 
      netscape_domain(Arg1),
      compose_id(Arg1,t,Arg1_t),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(allow,[Arg1_netscape_t],[device_t],[dir],[getattr,read]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(allow,[Arg1_netscape_t],[devpts_t],[dir],[getattr,read]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(allow,[Arg1_netscape_t],[proc_t],[file],[getattr,read]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(dontaudit,[Arg1_netscape_t],[tty_device_t],[chr_file],[getattr]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(dontaudit,[Arg1_netscape_t],[proc_t],[dir],[read]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(allow,[Arg1_netscape_t],[var_t,var_lib_t],[dir],[search]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(dontaudit,[Arg1_netscape_t],[var_run_t],[dir],[search]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

can_exec(Arg1_netscape_t,Arg1_netscape_rw_t) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t),
      compose_id(rw,t,rw_t),
      compose_id(netscape,rw_t,netscape_rw_t),
      compose_id(Arg1,netscape_rw_t,Arg1_netscape_rw_t).

access_vector(dontaudit,[Arg1_netscape_t],[Arg1_home_t],[dir],[rw_dir_perms]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(dontaudit,[Arg1_netscape_t],[Arg1_home_t],[file],[rw_file_perms]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t),
      compose_id(home,t,home_t),
      compose_id(Arg1,home_t,Arg1_home_t).

access_vector(dontaudit,[Arg1_netscape_t],[tmpfile],[dir],[getattr,search]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

access_vector(dontaudit,[Arg1_netscape_t],[tmpfile],[file],[getattr]) :- 
      netscape_domain(Arg1),
      compose_id(netscape,t,netscape_t),
      compose_id(Arg1,netscape_t,Arg1_netscape_t).

netscape_domain(x).

type_decl(Id_run_Arg3_exec_t,[],[file_type,exec_type,sysadmfile],[]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(exec,t,exec_t),
      compose_id(Arg3,exec_t,Arg3_exec_t),
      compose_id(run,Arg3_exec_t,Id_run_Arg3_exec_t).

type_decl(Id_run_Arg3_t,[],[domain,privrole,privuser,privlog,auth],[]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

domain_auto_trans(Arg1,Id_run_Arg3_exec_t,Id_run_Arg3_t) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(exec,t,exec_t),
      compose_id(Arg3,exec_t,Arg3_exec_t),
      compose_id(run,Arg3_exec_t,Id_run_Arg3_exec_t),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

role_decl(Arg2,[Id_run_Arg3_t]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(allow,[Id_run_Arg3_t],[initrc_var_run_t],[file],[rw_file_perms]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(allow,[Id_run_Arg3_t],[admin_tty_type],[chr_file],[rw_file_perms]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(dontaudit,[Id_run_Arg3_t],[devpts_t],[dir],[getattr,read]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(dontaudit,[Id_run_Arg3_t],[device_t],[dir],[read]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(dontaudit,[Id_run_Arg3_t],[file_type],[dir],[search]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(dontaudit,[Id_run_Arg3_t],[self],[capability],[dac_override,dac_read_search]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

can_exec(Id_run_Arg3_t,bin_t,chkpwd_exec_t,shell_exec_t) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

domain_trans(Id_run_Arg3_t,Arg4,Arg5) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

can_setexec(Id_run_Arg3_t) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(allow,[Id_run_Arg3_t],[privfd],[fd],[use]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

uses_shlib(Id_run_Arg3_t) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

can_getsecurity(Id_run_Arg3_t) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(allow,[Id_run_Arg3_t],[self],[unix_stream_socket],[create_socket_perms]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(allow,[Id_run_Arg3_t],[self],[unix_dgram_socket],[create_socket_perms]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(allow,[Id_run_Arg3_t],[etc_t],[file],[getattr,read]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

read_locale(Id_run_Arg3_t) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(allow,[Id_run_Arg3_t],[fs_t],[filesystem],[getattr]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(allow,[Id_run_Arg3_t],[bin_t,sbin_t],[dir],[search]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

access_vector(dontaudit,[Id_run_Arg3_t],[proc_t,device_t],[dir],[getattr,search]) :- 
      run_program(Arg1,Arg2,Arg4,Arg5),
      compose_id(Arg3,t,Arg3_t),
      compose_id(run,Arg3_t,Id_run_Arg3_t).

run_program(x,x,x,x).

screen_domain.

access_vector(allow,[Arg1_mail_t],[self],[capability],[net_bind_service]) :- 
      sendmail_user_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

type_decl(Arg1_mail_tmp_t,[],[file_type,sysadmfile,tmpfile],[]) :- 
      sendmail_user_domain(Arg1),
      compose_id(tmp,t,tmp_t),
      compose_id(mail,tmp_t,mail_tmp_t),
      compose_id(Arg1,mail_tmp_t,Arg1_mail_tmp_t).

file_type_auto_trans(Arg1_mail_t,tmp_t,Arg1_mail_tmp_t) :- 
      sendmail_user_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t),
      compose_id(tmp,t,tmp_t),
      compose_id(mail,tmp_t,mail_tmp_t),
      compose_id(Arg1,mail_tmp_t,Arg1_mail_tmp_t).

access_vector(allow,[Arg1_mail_t],[mail_spool_t],[dir],[rw_dir_perms]) :- 
      sendmail_user_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[mail_spool_t],[file],[create_file_perms]) :- 
      sendmail_user_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[mqueue_spool_t],[dir],[rw_dir_perms]) :- 
      sendmail_user_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

access_vector(allow,[Arg1_mail_t],[mqueue_spool_t],[file],[create_file_perms]) :- 
      sendmail_user_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

file_type_auto_trans(Arg1_mail_t,var_log_t,sendmail_log_t) :- 
      sendmail_user_domain(Arg1),
      compose_id(mail,t,mail_t),
      compose_id(Arg1,mail_t,Arg1_mail_t).

sendmail_user_domain(x).

ssh_domain.

su_domain.

xauth_domain.

type_decl(Arg1_Arg2_t,[],[domain],[Arg3]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

domain_auto_trans(Arg1_t,Arg2_exec_t,Arg1_Arg2_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(exec,t,exec_t),
      compose_id(Arg2,exec_t,Arg2_exec_t),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

role_decl(Arg1_r,[Arg1_Arg2_t]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,r,Arg1_r),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

can_network(Arg1_Arg2_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[resolv_conf_t],[file],[getattr,read]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[self],[process],[fork,signal_perms,getsched]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[self],[unix_dgram_socket],[create_socket_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[self],[unix_stream_socket],[connectto,create_stream_socket_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[self],[fifo_file],[rw_file_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[etc_runtime_t],[file],[getattr,read]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[etc_t],[lnk_file],[read]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[fs_t],[filesystem],[getattr]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

read_locale(Arg1_Arg2_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

r_dir_file(Arg1_Arg2_t,readable_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[devtty_t],[chr_file],[read,write]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[proc_t],[dir],[search]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[proc_t],[lnk_file],[read]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[self],[dir],[search]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[sysctl_kernel_t],[dir],[search]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[sysctl_kernel_t],[file],[getattr,read]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

type_decl(Arg1_Arg2_rw_t,[],[file_type,sysadmfile,tmpfile],[]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(Arg1,Arg2_rw_t,Arg1_Arg2_rw_t).

file_type_auto_trans(Arg1_Arg2_t,tmp_t,Arg1_Arg2_rw_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(Arg1,Arg2_rw_t,Arg1_Arg2_rw_t).

access_vector(allow,[Arg1_t],[Arg1_Arg2_rw_t],[dir,file,lnk_file],[relabelfrom,relabelto]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(Arg1,Arg2_rw_t,Arg1_Arg2_rw_t).

access_vector(allow,[Arg1_t],[Arg1_Arg2_rw_t],[dir],[create_dir_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(Arg1,Arg2_rw_t,Arg1_Arg2_rw_t).

access_vector(allow,[Arg1_t],[Arg1_Arg2_rw_t],[file,lnk_file],[create_file_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(Arg1,Arg2_rw_t,Arg1_Arg2_rw_t).

type_decl(Arg1_Arg2_ro_t,[],[file_type,sysadmfile],[]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(Arg1,Arg2_ro_t,Arg1_Arg2_ro_t).

r_dir_file(Arg1_Arg2_t,Arg1_Arg2_ro_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(Arg1,Arg2_ro_t,Arg1_Arg2_ro_t).

access_vector(allow,[Arg1_Arg2_t],[Arg1_Arg2_ro_t],[fifo_file],[read,write]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(Arg1,Arg2_ro_t,Arg1_Arg2_ro_t).

create_dir_file(Arg1_t,Arg1_Arg2_ro_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(Arg1,Arg2_ro_t,Arg1_Arg2_ro_t).

access_vector(allow,[Arg1_t],[Arg1_Arg2_ro_t],[fifo_file],[create_file_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(Arg1,Arg2_ro_t,Arg1_Arg2_ro_t).

access_vector(allow,[Arg1_t],[Arg1_Arg2_ro_t],[dir,file,lnk_file],[relabelto,relabelfrom]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(ro,t,ro_t),
      compose_id(Arg2,ro_t,Arg2_ro_t),
      compose_id(Arg1,Arg2_ro_t,Arg1_Arg2_ro_t).

access_vector(allow,[Arg1_t],[Arg1_Arg2_t],[process],[signal_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_t],[Arg1_Arg2_t],[dir],[r_dir_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_t],[Arg1_Arg2_t],[notdevfile_class_set],[r_file_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,t,Arg1_t),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[device_t],[dir],[search]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[zero_device_t],[chr_file],[rw_file_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[zero_device_t],[chr_file],[x_file_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

can_exec_any(Arg1_Arg2_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[privfd],[fd],[use]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

access_vector(allow,[Arg1_Arg2_t],[Arg1_tty_device_t],[chr_file],[rw_file_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t).

access_vector(allow,[Arg1_Arg2_t],[Arg1_devpts_t],[chr_file],[rw_file_perms]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t).

access_vector(allow,[Arg1_Arg2_t],[home_root_t],[dir],[search,getattr]) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t).

file_type_auto_trans(Arg1_Arg2_t,Arg1_home_dir_t,Arg1_Arg2_rw_t) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg2,t,Arg2_t),
      compose_id(Arg1,Arg2_t,Arg1_Arg2_t),
      compose_id(dir,t,dir_t),
      compose_id(home,dir_t,home_dir_t),
      compose_id(Arg1,home_dir_t,Arg1_home_dir_t),
      compose_id(rw,t,rw_t),
      compose_id(Arg2,rw_t,Arg2_rw_t),
      compose_id(Arg1,Arg2_rw_t,Arg1_Arg2_rw_t).

tmpfs_domain(Arg1_Arg2) :- 
      x_client_domain(Arg1,Arg2,Arg3),
      compose_id(Arg1,Arg2,Arg1_Arg2).

x_client_domain(x,x,x).

xserver_domain.

type_decl(device_t,[],[file_type],[]).

type_decl(null_device_t,[],[file_type,mlstrustedobject],[]).

type_decl(zero_device_t,[],[file_type,mlstrustedobject],[]).

type_decl(console_device_t,[],[file_type],[]).

type_decl(memory_device_t,[],[file_type],[]).

type_decl(random_device_t,[],[file_type],[]).

type_decl(devtty_t,[],[file_type,mlstrustedobject],[]).

type_decl(tty_device_t,[],[file_type],[]).

type_decl(fixed_disk_device_t,[],[file_type],[]).

type_decl(removable_device_t,[],[file_type],[]).

type_decl(clock_device_t,[],[file_type],[]).

type_decl(tun_tap_device_t,[],[file_type],[]).

type_decl(misc_device_t,[],[file_type],[]).

type_decl(psaux_t,[],[file_type],[]).

type_decl(mouse_device_t,[],[file_type],[]).

type_decl(agp_device_t,[],[file_type],[]).

type_decl(dri_device_t,[],[file_type],[]).

type_decl(sound_device_t,[],[file_type],[]).

type_decl(ppp_device_t,[],[file_type],[]).

type_decl(framebuf_device_t,[],[file_type],[]).

type_decl(devfs_control_t,[],[file_type],[]).

type_decl(mtrr_device_t,[],[file_type],[]).

type_decl(apm_bios_t,[],[file_type],[]).

type_decl(v4l_device_t,[],[file_type],[]).

type_decl(ptmx_t,[],[file_type,sysadmfile],[]).

type_decl(devpts_t,[],[fs_type,root_dir_type],[]).

type_decl(unlabeled_t,[],[fs_type,file_type,root_dir_type,sysadmfile],[]).

type_decl(fs_t,[],[fs_type],[]).

type_decl(file_t,[],[file_type,root_dir_type,sysadmfile],[]).

type_decl(root_t,[],[file_type,sysadmfile],[]).

type_decl(home_root_t,[],[file_type,sysadmfile],[]).

type_decl(lost_found_t,[],[file_type,sysadmfile],[]).

type_decl(boot_t,[],[file_type,root_dir_type,sysadmfile],[]).

type_decl(system_map_t,[],[file_type,sysadmfile],[]).

type_decl(boot_runtime_t,[],[file_type,sysadmfile],[]).

type_decl(tmp_t,[],[file_type,sysadmfile,tmpfile],[]).

type_decl(etc_t,[],[file_type,sysadmfile],[]).

type_decl(shadow_t,[],[file_type],[]).

access_vector(allow,[auth],[shadow_t],[file],[getattr,read]).

type_decl(ld_so_cache_t,[],[file_type,sysadmfile],[]).

type_decl(etc_runtime_t,[],[file_type,sysadmfile],[]).

type_decl(etc_aliases_t,[],[file_type,sysadmfile],[]).

type_decl(etc_mail_t,[],[file_type,sysadmfile],[]).

type_decl(resolv_conf_t,[],[file_type,sysadmfile],[]).

type_decl(lib_t,[],[file_type,sysadmfile],[]).

type_decl(shlib_t,[],[file_type,sysadmfile],[]).

type_decl(ld_so_t,[],[file_type,sysadmfile],[]).

type_decl(bin_t,[],[file_type,sysadmfile],[]).

type_decl(ls_exec_t,[],[file_type,exec_type,sysadmfile],[]).

type_decl(shell_exec_t,[],[file_type,exec_type,sysadmfile],[]).

type_decl(sbin_t,[],[file_type,sysadmfile],[]).

type_decl(usr_t,[],[file_type,root_dir_type,sysadmfile],[]).

type_decl(src_t,[],[file_type,sysadmfile],[]).

type_decl(var_t,[],[file_type,root_dir_type,sysadmfile],[]).

type_decl(var_run_t,[],[file_type,sysadmfile],[]).

type_decl(var_log_t,[],[file_type,sysadmfile,logfile],[]).

type_decl(faillog_t,[],[file_type,sysadmfile,logfile],[]).

type_decl(var_lock_t,[],[file_type,sysadmfile,lockfile],[]).

type_decl(var_lib_t,[],[file_type,sysadmfile],[]).

type_decl(tetex_data_t,[],[file_type,sysadmfile,tmpfile],[]).

type_decl(var_spool_t,[],[file_type,sysadmfile],[]).

type_decl(var_yp_t,[],[file_type,sysadmfile],[]).

type_decl(var_log_sa_t,[],[file_type,sysadmfile,logfile],[]).

type_decl(var_log_ksyms_t,[],[file_type,sysadmfile,logfile],[]).

type_decl(lastlog_t,[],[file_type,sysadmfile,logfile],[]).

type_decl(var_lib_nfs_t,[],[file_type,sysadmfile],[]).

type_decl(wtmp_t,[],[file_type,sysadmfile,logfile],[]).

type_decl(catman_t,[],[file_type,sysadmfile,tmpfile],[]).

type_decl(at_spool_t,[],[file_type,sysadmfile],[]).

type_decl(cron_spool_t,[],[file_type,sysadmfile],[]).

type_decl(print_spool_t,[],[file_type,sysadmfile],[]).

type_decl(mail_spool_t,[],[file_type,sysadmfile],[]).

type_decl(mqueue_spool_t,[],[file_type,sysadmfile],[]).

type_decl(man_t,[],[file_type,sysadmfile],[]).

type_decl(readable_t,[],[file_type,sysadmfile],[]).

type_decl(test_file_t,[],[file_type,sysadmfile],[]).

type_decl(poly_t,[],[file_type,sysadmfile],[]).

type_decl(swapfile_t,[],[file_type,sysadmfile],[]).

type_decl(locale_t,[],[file_type],[]).

access_vector(allow,[file_type],[fs_t],[filesystem],[associate]).

access_vector(allow,[devpts_t],[devpts_t],[filesystem],[associate]).

type_decl(tmpfs_t,[],[file_type,sysadmfile,fs_type,root_dir_type],[]).

access_vector(allow,[tmpfs_t,tmp_t],[tmpfs_t],[filesystem],[associate]).

type_decl(usbdevfs_t,[],[fs_type,root_dir_type,sysadmfile],[]).

access_vector(allow,[usbdevfs_t],[usbdevfs_t],[filesystem],[associate]).

type_decl(usbdevfs_device_t,[],[file_type,sysadmfile],[]).

access_vector(allow,[usbdevfs_device_t],[usbdevfs_t],[filesystem],[associate]).

type_decl(sysfs_t,[driverfs_t],[fs_type,root_dir_type,sysadmfile],[]).

access_vector(allow,[sysfs_t],[sysfs_t],[filesystem],[associate]).

type_decl(iso9660_t,[],[fs_type,root_dir_type,sysadmfile],[]).

access_vector(allow,[iso9660_t],[iso9660_t],[filesystem],[associate]).

type_decl(dosfs_t,[],[fs_type,root_dir_type,sysadmfile],[]).

access_vector(allow,[dosfs_t],[dosfs_t],[filesystem],[associate]).

type_decl(any_socket_t,[],[socket_type],[]).

role_decl(system_r,[any_socket_t]).

type_decl(igmp_packet_t,[],[],[]).

role_decl(system_r,[igmp_packet_t]).

type_decl(icmp_socket_t,[],[socket_type],[]).

role_decl(system_r,[icmp_socket_t]).

type_decl(tcp_socket_t,[],[socket_type],[]).

role_decl(system_r,[tcp_socket_t]).

type_decl(scmp_packet_t,[],[],[]).

role_decl(system_r,[scmp_packet_t]).

type_decl(port_t,[],[port_type],[]).

type_decl(netif_t,[],[netif_type],[]).

type_decl(netif_eth0_t,[],[netif_type],[]).

type_decl(netif_eth1_t,[],[netif_type],[]).

type_decl(netif_eth2_t,[],[netif_type],[]).

type_decl(netif_lo_t,[],[netif_type],[]).

type_decl(netif_ippp0_t,[],[netif_type],[]).

type_decl(netif_ipsec0_t,[],[netif_type],[]).

type_decl(netif_ipsec1_t,[],[netif_type],[]).

type_decl(netif_ipsec2_t,[],[netif_type],[]).

type_decl(netmsg_t,[],[netmsg_type],[]).

type_decl(netmsg_eth0_t,[],[netmsg_type],[]).

type_decl(netmsg_eth1_t,[],[netmsg_type],[]).

type_decl(netmsg_eth2_t,[],[netmsg_type],[]).

type_decl(netmsg_lo_t,[],[netmsg_type],[]).

type_decl(netmsg_ippp0_t,[],[netmsg_type],[]).

type_decl(netmsg_ipsec0_t,[],[netmsg_type],[]).

type_decl(netmsg_ipsec1_t,[],[netmsg_type],[]).

type_decl(netmsg_ipsec2_t,[],[netmsg_type],[]).

type_decl(node_t,[],[node_type],[]).

type_decl(node_lo_t,[],[node_type],[]).

type_decl(node_internal_t,[],[node_type],[]).

access_vector(allow,[igmp_packet_t],[netif_type],[netif],[rawip_send,rawip_recv]).

access_vector(allow,[igmp_packet_t],[node_type],[node],[rawip_send,rawip_recv]).

access_vector(allow,[icmp_socket_t],[netif_type],[netif],[rawip_send,rawip_recv]).

access_vector(allow,[icmp_socket_t],[node_type],[node],[rawip_send,rawip_recv]).

access_vector(allow,[icmp_socket_t],[netmsg_type],[rawip_socket],[recvfrom]).

access_vector(allow,[tcp_socket_t],[netif_type],[netif],[tcp_send,tcp_recv]).

access_vector(allow,[tcp_socket_t],[netmsg_type],[tcp_socket],[recvfrom]).

access_vector(allow,[tcp_socket_t],[node_type],[node],[tcp_send,tcp_recv]).

access_vector(allow,[netmsg_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_eth0_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_eth0_t],[netif_eth0_t],[netif],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_eth1_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_eth1_t],[netif_eth1_t],[netif],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_eth2_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_eth2_t],[netif_eth2_t],[netif],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_lo_t],[node_lo_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_lo_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_lo_t],[netif_lo_t],[netif],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_ippp0_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_ippp0_t],[netif_ippp0_t],[netif],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_ipsec0_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_ipsec0_t],[netif_ipsec0_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_ipsec1_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_ipsec1_t],[netif_ipsec1_t],[netif],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_ipsec2_t],[node_t],[node],[tcp_recv,udp_recv,rawip_recv]).

access_vector(allow,[netmsg_ipsec2_t],[netif_ipsec2_t],[netif],[tcp_recv,udp_recv,rawip_recv]).

type_decl(nfs_t,[],[fs_type,root_dir_type],[]).

access_vector(allow,[nfs_t],[nfs_t],[filesystem],[associate]).

type_decl(proc_t,[],[fs_type,root_dir_type],[]).

type_decl(proc_kmsg_t,[],[],[]).

type_decl(proc_kcore_t,[],[],[]).

type_decl(sysctl_t,[],[],[]).

type_decl(sysctl_fs_t,[],[],[]).

type_decl(sysctl_kernel_t,[],[],[]).

type_decl(sysctl_modprobe_t,[],[],[]).

type_decl(sysctl_net_t,[],[],[]).

type_decl(sysctl_net_unix_t,[],[],[]).

type_decl(sysctl_vm_t,[],[],[]).

type_decl(sysctl_dev_t,[],[],[]).

type_decl(security_t,[],[fs_type],[]).

type_decl(policy_config_t,[],[file_type],[]).

type_decl(policy_src_t,[],[file_type],[]).

type_decl(default_context_t,[],[file_type,sysadmfile,login_contexts],[]).

type_decl(file_labels_t,[],[file_type,sysadmfile],[]).

type_decl(no_access_t,[],[file_type,sysadmfile],[]).

type_decl(sysadm_t,[],[domain,privlog,privowner,admin,userdomain,web_client_domain,privhome],[]).

access_vector(allow,[privhome],[home_root_t],[dir],[search]).

role_decl(system_r,[sysadm_t]).

role_decl(sysadm_r,[sysadm_t]).

general_proc_read_access(sysadm_t).

general_domain_access(sysadm_t).

admin_domain(sysadm).

can_setenforce(admin).

set_macro(admin_tty_type,[sysadm_tty_device_t,sysadm_devpts_t]).

full_user_role(user).

full_user_role(staff).

access_vector(allow,[staff_t],[unpriv_userdomain],[process],[signal_perms]).

r_dir_file(staff_t,domain).

access_vector(allow,[staff_t],[ttyfile,ptyfile,tty_device_t],[chr_file],[getattr]).

access_vector(dontaudit,[unpriv_userdomain],[sysadm_home_dir_t],[dir],[getattr,search]).

role_decl(system_r,[user_t]).

role_decl([Arg1_r],[Arg2_r]) :- 
      role_tty_type_change(Arg1,Arg2),
      compose_id(Arg1,r,Arg1_r),
      compose_id(Arg2,r,Arg2_r).

type_change([Arg2_t],[Arg1_devpts_t],[chr_file],Arg2_devpts_t) :- 
      role_tty_type_change(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg1,devpts_t,Arg1_devpts_t),
      compose_id(devpts,t,devpts_t),
      compose_id(Arg2,devpts_t,Arg2_devpts_t).

type_change([Arg2_t],[Arg1_tty_device_t],[chr_file],Arg2_tty_device_t) :- 
      role_tty_type_change(Arg1,Arg2),
      compose_id(Arg2,t,Arg2_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg1,tty_device_t,Arg1_tty_device_t),
      compose_id(device,t,device_t),
      compose_id(tty,device_t,tty_device_t),
      compose_id(Arg2,tty_device_t,Arg2_tty_device_t).

role_tty_type_change(x,x).

access_vector(dontaudit,[unpriv_userdomain],[ptyfile],[chr_file],[getattr]).

type_decl(kernel_t,[],[domain],[]).

role_decl(system_r,[kernel_t]).

general_domain_access(kernel_t).

general_proc_read_access(kernel_t).

base_file_read_access(kernel_t).

uses_shlib(kernel_t).

access_vector(allow,[kernel_t],[self],[capability],[_]).

domain_auto_trans(kernel_t,init_exec_t,init_t).

access_vector(allow,[kernel_t],[init_t],[process],[share]).

access_vector(allow,[kernel_t],[fs_type],[filesystem],[mount_fs_perms]).

access_vector(allow,[kernel_t],[file_labels_t],[dir],[search]).

access_vector(allow,[kernel_t],[domain],[process],[signal]).

access_vector(allow,[kernel_t],[device_t],[dir],[search]).

access_vector(allow,[kernel_t],[console_device_t],[chr_file],[rw_file_perms]).

access_vector(allow,[kernel_t],[file_t],[chr_file],[rw_file_perms]).

can_exec(kernel_t,file_t).

access_vector(allow,[kernel_t],[self],[capability],[sys_chroot]).

access_vector(allow,[kernel_t],[unlabeled_t,root_t,file_t],[dir],[mounton]).

access_vector(allow,[kernel_t],[file_t],[dir],[rw_dir_perms]).

access_vector(allow,[kernel_t],[file_t],[blk_file],[create_file_perms]).

access_vector(allow,[kernel_t],[sysctl_t,sysctl_kernel_t],[file],[setattr,rw_file_perms]).

access_vector(allow,[kernel_t],[policy_config_t],[dir],[r_dir_perms]).

can_loadpol(kernel_t).

can_exec(kernel_t,bin_t).

type_decl(checkpolicy_t,[],[domain],[]).

role_decl(sysadm_r,[checkpolicy_t]).

type_decl(checkpolicy_exec_t,[],[file_type,exec_type,sysadmfile],[]).

domain_auto_trans(sysadm_t,checkpolicy_exec_t,checkpolicy_t).

access_vector(allow,[checkpolicy_t],[policy_config_t],[dir],[rw_dir_perms]).

access_vector(allow,[checkpolicy_t],[policy_config_t],[notdevfile_class_set],[create_file_perms]).

access_vector(allow,[checkpolicy_t],[policy_src_t],[dir],[r_dir_perms]).

access_vector(allow,[checkpolicy_t],[policy_src_t],[notdevfile_class_set],[r_file_perms]).

file_type_auto_trans(checkpolicy_t,policy_src_t,policy_config_t).

access_vector(allow,[checkpolicy_t],[root_t],[dir],[search]).

access_vector(allow,[checkpolicy_t],[etc_t],[dir],[search]).

access_vector(allow,[checkpolicy_t],[devpts_t],[dir],[r_dir_perms]).

access_vector(allow,[checkpolicy_t],[admin_tty_type],[chr_file],[read,write,ioctl,getattr]).

uses_shlib(checkpolicy_t).

access_vector(allow,[checkpolicy_t],[self],[capability],[dac_override]).

access_vector(allow,[checkpolicy_t],[sysadm_tmp_t],[file],[getattr,write]).

can_exec(user_t,checkpolicy_exec_t).

access_vector(allow,[checkpolicy_t],[privfd],[fd],[use]).

type_decl(chkpwd_exec_t,[],[file_type,sysadmfile,exec_type],[]).

daemon_domain(crond,[privrole,privmail,auth,privfd]).

general_domain_access(crond_t).

type_decl(anacron_exec_t,[],[file_type,sysadmfile,exec_type],[]).

tmp_domain(crond,[]).

type_decl(system_crond_t,[],[domain,privlog,privmail],[]).

access_vector(allow,[system_crond_t],[devtty_t],[chr_file],[rw_file_perms]).

access_vector(allow,[system_crond_t],[proc_t],[dir],[r_dir_perms]).

access_vector(allow,[system_crond_t],[proc_t],[file],[r_file_perms]).

access_vector(allow,[system_crond_t],[proc_t],[lnk_file],[read]).

access_vector(dontaudit,[system_crond_t],[domain],[dir],[search]).

access_vector(allow,[system_crond_t],[etc_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[system_crond_t],[etc_runtime_t],[file],[read]).

read_locale(crond_t,system_crond_t).

type_decl(cron_log_t,[],[file_type,sysadmfile,logfile],[]).

file_type_auto_trans(crond_t,var_log_t,cron_log_t).

access_vector(allow,[crond_t],[crond_t],[capability],[setgid,setuid,net_bind_service]).

can_getsecurity(crond_t).

access_vector(allow,[crond_t],[bin_t,sbin_t],[dir],[search]).

access_vector(allow,[crond_t],[bin_t],[lnk_file],[read]).

access_vector(allow,[crond_t],[var_lib_t],[dir],[search]).

access_vector(allow,[crond_t],[var_spool_t],[dir],[r_dir_perms]).

access_vector(allow,[crond_t],[cron_spool_t],[dir],[r_dir_perms]).

access_vector(allow,[crond_t],[cron_spool_t],[file],[r_file_perms]).

access_vector(allow,[crond_t],[system_crond_script_t],[file],[r_file_perms]).

access_vector(allow,[crond_t],[system_crond_script_t],[dir],[r_dir_perms]).

access_vector(allow,[crond_t],[default_context_t],[file],[r_file_perms]).

access_vector(allow,[crond_t],[etc_t],[file],[getattr,read]).

access_vector(allow,[crond_t],[etc_t],[lnk_file],[read]).

access_vector(allow,[crond_t],[sysadm_home_dir_t],[dir],[r_dir_perms]).

access_vector(allow,[crond_t],[home_root_t],[dir],[getattr,search]).

access_vector(allow,[crond_t],[user_home_dir_type],[dir],[r_dir_perms]).

can_exec(crond_t,shell_exec_t).

role_decl(system_r,[system_crond_t]).

uses_shlib(system_crond_t).

general_domain_access(system_crond_t).

access_vector(allow,[system_crond_t],[var_log_t],[file],[r_file_perms]).

type_decl(system_crond_script_t,[],[file_type,sysadmfile],[]).

domain_trans(crond_t,shell_exec_t,system_crond_t).

can_setexec(crond_t).

domain_auto_trans(initrc_t,anacron_exec_t,system_crond_t).

file_type_auto_trans(system_crond_t,var_log_t,cron_log_t).

access_vector(allow,[system_crond_t],[init_t],[fd],[use]).

access_vector(allow,[system_crond_t],[initrc_t],[fd],[use]).

access_vector(allow,[system_crond_t],[initrc_t],[udp_socket],[rw_socket_perms]).

access_vector(allow,[system_crond_t],[system_crond_t],[capability],[setgid,setuid,dac_override,fowner,net_bind_service,fsetid]).

access_vector(allow,[system_crond_t],[system_crond_script_t],[file],[r_file_perms]).

access_vector(allow,[system_crond_t],[system_crond_script_t],[file],[entrypoint]).

access_vector(allow,[system_crond_t],[bin_t,sbin_t],[dir],[r_dir_perms]).

access_vector(allow,[system_crond_t],[bin_t,sbin_t],[lnk_file],[read]).

can_exec(system_crond_t,bin_t,sbin_t,exec_type,etc_t).

access_vector(allow,[system_crond_t],[cron_spool_t],[dir],[r_dir_perms]).

access_vector(allow,[system_crond_t],[cron_spool_t],[file],[r_file_perms]).

access_vector(allow,[system_crond_t],[var_lib_t],[dir],[rw_dir_perms]).

access_vector(allow,[system_crond_t],[var_lib_t],[file],[create_file_perms]).

access_vector(allow,[system_crond_t],[catman_t],[dir],[create_dir_perms]).

access_vector(allow,[system_crond_t],[catman_t],[file],[create_file_perms]).

access_vector(allow,[system_crond_t],[man_t],[file],[r_file_perms]).

access_vector(allow,[system_crond_t],[man_t],[lnk_file],[read]).

lock_domain(system_crond).

access_vector(allow,[crond_t],[mail_spool_t],[lnk_file],[read]).

access_vector(allow,[system_crond_t],[file_type],[file_class_set],[getattr]).

access_vector(allow,[system_crond_t],[file_type],[dir],[read,search,getattr]).

type_decl(system_crond_tmp_t,[],[file_type,sysadmfile,tmpfile],[]).

file_type_auto_trans(system_crond_t,tmp_t,crond_tmp_t,system_crond_tmp_t).

access_vector(dontaudit,[system_crond_t],[initrc_var_run_t],[file],[read,write]).

access_vector(allow,[system_crond_t],[var_log_sa_t],[file],[create_file_perms]).

access_vector(allow,[system_crond_t],[var_log_sa_t],[dir],[rw_dir_perms]).

access_vector(allow,[system_crond_t],[fs_t],[filesystem],[getattr]).

access_vector(allow,[system_crond_t],[sysctl_t,sysctl_kernel_t],[dir],[search]).

access_vector(allow,[system_crond_t],[sysctl_kernel_t],[file],[getattr,read]).

access_vector(allow,[system_crond_t],[var_spool_t],[file],[create_file_perms]).

access_vector(allow,[system_crond_t],[var_spool_t],[dir],[rw_dir_perms]).

access_vector(dontaudit,[system_crond_t],[unlabeled_t],[dir],[r_dir_perms]).

access_vector(dontaudit,[system_crond_t],[unlabeled_t],[file],[r_file_perms]).

type_decl(crontab_exec_t,[],[file_type,sysadmfile,exec_type],[]).

type_decl(fsadm_t,[],[domain,privlog],[]).

role_decl(system_r,[fsadm_t]).

role_decl(sysadm_r,[fsadm_t]).

general_domain_access(fsadm_t).

access_vector(allow,[fsadm_t],[proc_t],[dir],[r_dir_perms]).

access_vector(allow,[fsadm_t],[proc_t],[notdevfile_class_set],[r_file_perms]).

access_vector(allow,[fsadm_t],[sysctl_kernel_t],[file],[r_file_perms]).

access_vector(allow,[fsadm_t],[sysctl_kernel_t],[dir],[r_dir_perms]).

base_file_read_access(fsadm_t).

access_vector(allow,[fsadm_t],[etc_t],[dir],[r_dir_perms]).

access_vector(allow,[fsadm_t],[etc_t],[notdevfile_class_set],[r_file_perms]).

access_vector(allow,[fsadm_t],[modules_conf_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[fsadm_t],[device_t],[dir],[r_dir_perms]).

access_vector(allow,[fsadm_t],[device_t],[lnk_file],[r_file_perms]).

uses_shlib(fsadm_t).

type_decl(fsadm_exec_t,[],[file_type,sysadmfile,exec_type],[]).

domain_auto_trans(initrc_t,fsadm_exec_t,fsadm_t).

domain_auto_trans(sysadm_t,fsadm_exec_t,fsadm_t).

type_decl(fsadm_tmp_t,[],[file_type,sysadmfile,tmpfile],[]).

file_type_auto_trans(fsadm_t,tmp_t,fsadm_tmp_t).

access_vector(allow,[fsadm_t],[fs_t],[filesystem],[remount]).

access_vector(allow,[fsadm_t],[proc_t],[filesystem],[getattr]).

access_vector(allow,[fsadm_t],[random_device_t],[chr_file],[getattr,read]).

access_vector(allow,[fsadm_t],[self],[capability],[ipc_lock,sys_rawio,sys_admin]).

file_type_auto_trans(fsadm_t,etc_t,etc_runtime_t,file).

access_vector(allow,[fsadm_t],[init_t],[fd],[use]).

can_exec(fsadm_t,fsadm_exec_t).

access_vector(allow,[fsadm_t],[fixed_disk_device_t],[devfile_class_set],[rw_file_perms]).

access_vector(allow,[fsadm_t],[removable_device_t],[devfile_class_set],[rw_file_perms]).

access_vector(allow,[fsadm_t],[lost_found_t],[dir],[create_dir_perms]).

access_vector(allow,[fsadm_t],[lost_found_t],[notdevfile_class_set],[create_file_perms]).

access_vector(allow,[fsadm_t],[file_t],[dir],[search,read,getattr,rmdir,create]).

access_vector(allow,[fsadm_t],[device_t],[dir],[rw_dir_perms]).

access_vector(allow,[fsadm_t],[device_t],[lnk_file],[unlink,create]).

access_vector(allow,[fsadm_t],[swapfile_t],[file],[getattr,swapon]).

access_vector(allow,[fsadm_t],[fixed_disk_device_t],[blk_file],[getattr,swapon]).

domain_auto_trans(fsadm_t,insmod_exec_t,insmod_t).

access_vector(allow,[fsadm_t],[kernel_t],[system],[syslog_console]).

access_vector(allow,[fsadm_t],[admin_tty_type],[chr_file],[rw_file_perms]).

access_vector(allow,[fsadm_t],[privfd],[fd],[use]).

read_locale(fsadm_t).

daemon_domain(getty,[mlstrustedwriter,privfd]).

type_decl(etc_getty_t,[],[file_type,sysadmfile],[]).

r_dir_file(getty_t,etc_getty_t).

access_vector(allow,[getty_t],[console_device_t],[chr_file],[setattr]).

tmp_domain(getty,[]).

log_domain(getty).

access_vector(allow,[getty_t],[etc_t,etc_runtime_t],[file],[getattr,read]).

access_vector(allow,[getty_t],[etc_t],[lnk_file],[read]).

access_vector(allow,[getty_t],[self],[process],[getpgid,getsession]).

access_vector(allow,[getty_t],[self],[unix_dgram_socket],[create_socket_perms]).

access_vector(allow,[getty_t],[self],[unix_stream_socket],[create_socket_perms]).

access_vector(allow,[getty_t],[resolv_conf_t],[file],[getattr,read]).

access_vector(allow,[getty_t],[getty_t],[capability],[dac_override,chown,sys_tty_config]).

access_vector(allow,[getty_t],[getty_t],[capability],[fsetid]).

domain_auto_trans(init_t,getty_exec_t,getty_t).

access_vector(allow,[getty_t],[init_t],[fd],[use]).

access_vector(allow,[getty_t],[bin_t],[dir],[search]).

domain_auto_trans(getty_t,login_exec_t,local_login_t).

access_vector(allow,[getty_t],[initrc_var_run_t],[file],[rw_file_perms]).

access_vector(allow,[getty_t],[wtmp_t],[file],[rw_file_perms]).

access_vector(allow,[getty_t],[tty_device_t],[chr_file],[setattr,rw_file_perms]).

access_vector(allow,[getty_t],[ttyfile],[chr_file],[setattr,rw_file_perms]).

rw_dir_create_file(getty_t,var_lock_t).

type_decl(ifconfig_t,[],[domain,privlog],[]).

type_decl(ifconfig_exec_t,[],[file_type,sysadmfile,exec_type],[]).

role_decl(system_r,[ifconfig_t]).

role_decl(sysadm_r,[ifconfig_t]).

uses_shlib(ifconfig_t).

general_domain_access(ifconfig_t).

domain_auto_trans(initrc_t,ifconfig_exec_t,ifconfig_t).

domain_auto_trans(sysadm_t,ifconfig_exec_t,ifconfig_t).

access_vector(allow,[ifconfig_t],[ifconfig_t],[capability],[sys_module,net_admin]).

access_vector(allow,[ifconfig_t],[init_t],[fd],[use]).

domain_auto_trans(ifconfig_t,insmod_exec_t,insmod_t).

access_vector(allow,[ifconfig_t],[proc_t],[dir],[r_dir_perms]).

access_vector(allow,[ifconfig_t],[proc_t],[file],[r_file_perms]).

access_vector(allow,[ifconfig_t],[privfd],[fd],[use]).

access_vector(allow,[ifconfig_t],[self],[udp_socket],[create_socket_perms]).

access_vector(allow,[ifconfig_t],[initrc_devpts_t,admin_tty_type],[chr_file],[rw_file_perms]).

access_vector(allow,[ifconfig_t],[tun_tap_device_t],[chr_file],[read,write]).

access_vector(dontaudit,[ifconfig_t],[sysctl_t,sysctl_net_t],[dir],[search]).

access_vector(allow,[ifconfig_t],[fs_t],[filesystem],[getattr]).

type_decl(initrc_t,[],[domain,privlog,privowner,privmail],[]).

role_decl(system_r,[initrc_t]).

uses_shlib(initrc_t).

type_decl(initrc_exec_t,[],[file_type,sysadmfile,exec_type],[]).

access_vector(allow,[initrc_t],[etc_t],[lnk_file],[r_file_perms]).

read_locale(initrc_t).

access_vector(allow,[initrc_t],[proc_t],[dir],[r_dir_perms]).

access_vector(allow,[initrc_t],[proc_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[initrc_t],[self],[unix_dgram_socket],[create_socket_perms]).

access_vector(allow,[initrc_t],[self],[unix_stream_socket],[create_socket_perms]).

access_vector(allow,[initrc_t],[self],[fifo_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[usbdevfs_t],[dir],[r_dir_perms]).

access_vector(allow,[initrc_t],[usbdevfs_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[initrc_t],[usbdevfs_device_t],[file],[getattr]).

access_vector(allow,[initrc_t],[self],[process],[fork,sigchld,setsched]).

can_create_pty(initrc,[]).

type_decl(initrc_tmp_t,[],[file_type,sysadmfile,tmpfile],[]).

file_type_auto_trans(initrc_t,tmp_t,initrc_tmp_t).

var_run_domain(initrc).

access_vector(allow,[initrc_t],[var_run_t],[file,sock_file,lnk_file],[unlink]).

access_vector(allow,[initrc_t],[framebuf_device_t],[chr_file],[r_file_perms]).

access_vector(allow,[initrc_t],[initrc_t],[capability],[except([sys_module])]).

access_vector(allow,[initrc_t],[kernel_t],[system],[_]).

can_setenforce(initrc_t).

can_sysctl(initrc_t).

access_vector(allow,[initrc_t],[bin_t,sbin_t],[dir],[r_dir_perms]).

access_vector(allow,[initrc_t],[bin_t,sbin_t],[lnk_file],[read]).

can_exec(initrc_t,etc_t).

can_exec(initrc_t,lib_t).

can_exec(initrc_t,bin_t).

can_exec(initrc_t,sbin_t).

can_exec(initrc_t,exec_type).

access_vector(allow,[initrc_t],[modules_conf_t],[file],[r_file_perms]).

can_exec(initrc_t,initrc_exec_t).

can_exec(initrc_t,init_exec_t).

access_vector(allow,[initrc_t],[initctl_t],[fifo_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[file_labels_t],[dir],[r_dir_perms]).

access_vector(allow,[initrc_t],[file_labels_t],[file],[stat_file_perms]).

access_vector(allow,[initrc_t],[domain],[notdevfile_class_set],[r_file_perms]).

access_vector(allow,[initrc_t],[domain],[dir],[r_dir_perms]).

access_vector(allow,[initrc_t],[fs_type],[filesystem],[mount_fs_perms]).

access_vector(allow,[initrc_t],[file_t],[dir],[read,search,getattr,mounton]).

file_type_auto_trans(initrc_t,etc_t,etc_runtime_t,file).

access_vector(allow,[initrc_t],[ld_so_cache_t],[file],[rw_file_perms]).

access_vector(allow,[initrc_t],[wtmp_t],[file],[setattr,rw_file_perms]).

access_vector(allow,[initrc_t],[var_log_t],[file],[setattr,rw_file_perms]).

access_vector(allow,[initrc_t],[lastlog_t],[file],[setattr,rw_file_perms]).

access_vector(allow,[initrc_t],[lockfile],[dir],[rw_dir_perms]).

access_vector(allow,[initrc_t],[lockfile],[file],[getattr,unlink]).

access_vector(allow,[initrc_t],[var_lib_t],[file],[rw_file_perms]).

access_vector(allow,[initrc_t],[var_lib_t],[file],[unlink]).

access_vector(allow,[initrc_t],[var_lock_t],[dir],[create_dir_perms]).

access_vector(allow,[initrc_t],[var_lock_t],[file],[create_file_perms]).

access_vector(allow,[initrc_t],[clock_device_t],[devfile_class_set],[rw_file_perms]).

access_vector(allow,[initrc_t],[domain],[process],[signal_perms]).

access_vector(allow,[initrc_t],[pidfile],[file],[getattr,read,unlink]).

access_vector(allow,[initrc_t],[random_device_t],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[psaux_t],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[framebuf_device_t],[lnk_file],[read]).

access_vector(allow,[initrc_t],[framebuf_device_t],[devfile_class_set],[setattr]).

access_vector(allow,[initrc_t],[misc_device_t],[devfile_class_set],[setattr]).

access_vector(allow,[initrc_t],[device_t],[devfile_class_set],[setattr]).

access_vector(allow,[initrc_t],[fixed_disk_device_t],[devfile_class_set],[setattr]).

access_vector(allow,[initrc_t],[removable_device_t],[devfile_class_set],[setattr]).

access_vector(allow,[initrc_t],[file_type],[file_class_set],[getattr]).

access_vector(allow,[initrc_t],[file_type],[dir],[search,getattr]).

access_vector(allow,[initrc_t],[devtty_t],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[console_device_t],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[tty_device_t],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[ttyfile],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[ptyfile],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[ttyfile],[chr_file],[relabelfrom]).

access_vector(allow,[initrc_t],[tty_device_t],[chr_file],[relabelto]).

access_vector(allow,[initrc_t],[system_map_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[initrc_t],[root_t],[dir],[search,write,remove_name]).

access_vector(allow,[initrc_t],[root_t],[file],[unlink,write]).

access_vector(allow,[initrc_t],[var_spool_t],[file],[rw_file_perms]).

access_vector(allow,[initrc_t],[fs_type],[filesystem],[quotamod,quotaget]).

access_vector(allow,[initrc_t],[mouse_device_t],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[admin_tty_type],[chr_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[sound_device_t],[chr_file],[setattr,ioctl,read,write]).

file_type_auto_trans(initrc_t,var_log_t,var_log_ksyms_t).

access_vector(allow,[initrc_t],[removable_device_t],[blk_file],[rw_file_perms]).

access_vector(allow,[initrc_t],[root_t],[dir],[search,write,add_name]).

access_vector(allow,[initrc_t],[root_t],[file],[create,setattr,unlink,getattr]).

access_vector(allow,[initrc_t],[file_t],[file],[unlink,getattr]).

access_vector(allow,[initrc_t],[home_root_t,home_type],[dir],[r_dir_perms]).

access_vector(allow,[initrc_t],[home_type],[file],[r_file_perms]).

access_vector(allow,[initrc_t],[pidfile],[dir],[rw_dir_perms]).

access_vector(allow,[initrc_t],[pidfile],[sock_file],[unlink]).

access_vector(allow,[initrc_t],[tmpfile],[sock_file],[unlink]).

rw_dir_create_file(initrc_t,var_lib_t).

access_vector(allow,[initrc_t],[tmpfile],[dir],[rw_dir_perms,rmdir]).

access_vector(allow,[initrc_t],[tmpfile],[notdevfile_class_set],[getattr,unlink]).

run_program(sysadm_t,sysadm_r,init,initrc_exec_t,initrc_t).

access_vector(allow,[initrc_t],[privfd],[fd],[use]).

type_decl(init_t,[],[domain,privlog,mlstrustedreader,mlstrustedwriter],[]).

role_decl(system_r,[init_t]).

uses_shlib(init_t).

type_decl(init_exec_t,[],[file_type,sysadmfile,exec_type],[]).

type_decl(initctl_t,[],[file_type,sysadmfile],[]).

type_decl(sulogin_exec_t,[],[file_type,exec_type,sysadmfile],[]).

access_vector(allow,[init_t],[file_t],[dir],[search]).

access_vector(allow,[init_t],[init_t],[capability],[except([sys_module])]).

domain_auto_trans(init_t,initrc_exec_t,initrc_t).

domain_auto_trans(init_t,shell_exec_t,sysadm_t).

domain_auto_trans(init_t,sulogin_exec_t,sysadm_t).

can_exec(init_t,sbin_t).

can_exec(init_t,init_exec_t).

file_type_auto_trans(init_t,device_t,initctl_t,fifo_file).

file_type_auto_trans(init_t,etc_t,etc_runtime_t,file).

access_vector(allow,[init_t],[ld_so_cache_t],[file],[rw_file_perms]).

access_vector(allow,[init_t],[var_t],[dir],[search]).

access_vector(allow,[init_t],[var_log_t],[dir],[search]).

read_locale(init_t).

access_vector(allow,[init_t],[self],[unix_dgram_socket],[create_socket_perms]).

access_vector(allow,[init_t],[self],[unix_stream_socket],[create_socket_perms]).

access_vector(allow,[init_t],[self],[fifo_file],[rw_file_perms]).

access_vector(allow,[init_t],[bin_t],[dir],[read,getattr,lock,search,ioctl]).

access_vector(allow,[init_t],[bin_t],[file,lnk_file,sock_file,fifo_file],[read,getattr,lock,ioctl]).

access_vector(allow,[init_t],[exec_type],[file,lnk_file],[read,getattr,lock,ioctl]).

access_vector(allow,[init_t],[sbin_t],[dir],[read,getattr,lock,search,ioctl]).

access_vector(allow,[init_t],[sbin_t],[file,lnk_file,sock_file,fifo_file],[read,getattr,lock,ioctl]).

access_vector(allow,[init_t],[self],[process],[fork,sigchld]).

access_vector(allow,[init_t],[var_run_t],[file],[rw_file_perms]).

access_vector(allow,[init_t],[initrc_var_run_t],[file],[setattr,rw_file_perms]).

var_run_domain(init).

access_vector(allow,[init_t],[proc_t],[dir],[r_dir_perms]).

access_vector(allow,[init_t],[proc_t],[lnk_file],[r_file_perms]).

access_vector(allow,[init_t],[self],[dir],[r_dir_perms]).

access_vector(allow,[init_t],[self],[lnk_file],[r_file_perms]).

access_vector(allow,[init_t],[devpts_t],[dir],[r_file_perms]).

access_vector(allow,[init_t],[wtmp_t],[file],[rw_file_perms]).

access_vector(allow,[init_t],[domain],[process],[signal_perms]).

access_vector(allow,[domain],[init_t],[process],[sigchld,signull]).

access_vector(allow,[unlabeled_t],[init_t],[process],[sigchld]).

access_vector(allow,[init_t],[console_device_t],[chr_file],[rw_file_perms]).

access_vector(allow,[init_t],[tty_device_t],[chr_file],[rw_file_perms]).

access_vector(allow,[init_t],[ttyfile],[chr_file],[rw_file_perms]).

access_vector(allow,[init_t],[ptyfile],[chr_file],[rw_file_perms]).

can_exec(init_t,bin_t).

can_exec(init_t,etc_t).

access_vector(dontaudit,[init_t],[file_labels_t],[dir],[search]).

daemon_domain(klogd,[privmem]).

tmp_domain(klogd,[]).

access_vector(allow,[klogd_t],[proc_t],[dir],[r_dir_perms]).

access_vector(allow,[klogd_t],[proc_t],[lnk_file],[r_file_perms]).

access_vector(allow,[klogd_t],[proc_t],[file],[getattr,read]).

access_vector(allow,[klogd_t],[self],[dir],[r_dir_perms]).

access_vector(allow,[klogd_t],[self],[lnk_file],[r_file_perms]).

access_vector(allow,[klogd_t],[etc_t],[lnk_file],[read]).

access_vector(allow,[klogd_t],[etc_t],[file],[r_file_perms]).

read_locale(klogd_t).

access_vector(allow,[klogd_t],[etc_runtime_t],[file],[getattr,read]).

access_vector(allow,[klogd_t],[self],[unix_dgram_socket],[create_socket_perms]).

access_vector(allow,[klogd_t],[klogd_t],[capability],[sys_admin,sys_rawio]).

access_vector(allow,[klogd_t],[proc_kmsg_t],[file],[r_file_perms]).

access_vector(allow,[klogd_t],[memory_device_t],[chr_file],[r_file_perms]).

access_vector(allow,[klogd_t],[kernel_t],[system],[syslog_mod,syslog_console]).

access_vector(allow,[klogd_t],[system_map_t],[file],[r_file_perms]).

access_vector(allow,[klogd_t],[boot_t],[dir],[r_dir_perms]).

type_decl(ldconfig_t,[],[domain,privlog],[]).

type_decl(ldconfig_exec_t,[],[file_type,sysadmfile,exec_type],[]).

role_decl(sysadm_r,[ldconfig_t]).

role_decl(system_r,[ldconfig_t]).

domain_auto_trans(sysadm_t,initrc_t,ldconfig_exec_t,ldconfig_t).

access_vector(dontaudit,[ldconfig_t],[device_t],[dir],[search]).

access_vector(allow,[ldconfig_t],[initrc_devpts_t,admin_tty_type],[chr_file],[rw_file_perms]).

access_vector(allow,[ldconfig_t],[privfd],[fd],[use]).

uses_shlib(ldconfig_t).

file_type_auto_trans(ldconfig_t,etc_t,ld_so_cache_t).

file_type_auto_trans(ldconfig_t,lib_t,shlib_t).

access_vector(allow,[ldconfig_t],[lib_t],[lnk_file],[unlink]).

access_vector(allow,[ldconfig_t],[userdomain],[fd],[use]).

access_vector(allow,[ldconfig_t],[etc_t],[file],[getattr,read]).

access_vector(allow,[ldconfig_t],[etc_t],[lnk_file],[read]).

access_vector(allow,[ldconfig_t],[fs_t],[filesystem],[getattr]).

type_decl(load_policy_t,[],[domain],[]).

role_decl(sysadm_r,[load_policy_t]).

type_decl(load_policy_exec_t,[],[file_type,exec_type,sysadmfile],[]).

domain_auto_trans(sysadm_t,load_policy_exec_t,load_policy_t).

can_loadpol(load_policy_t).

access_vector(allow,[load_policy_t],[policy_config_t],[dir],[r_dir_perms]).

access_vector(allow,[load_policy_t],[policy_config_t],[notdevfile_class_set],[r_file_perms]).

access_vector(allow,[load_policy_t],[root_t],[dir],[search]).

access_vector(allow,[load_policy_t],[etc_t],[dir],[search]).

access_vector(allow,[load_policy_t],[devpts_t],[dir],[r_dir_perms]).

access_vector(allow,[load_policy_t],[initrc_devpts_t,admin_tty_type],[chr_file],[read,write,ioctl,getattr]).

uses_shlib(load_policy_t).

access_vector(allow,[load_policy_t],[self],[capability],[dac_override]).

access_vector(allow,[load_policy_t],[initrc_t,privfd],[fd],[use]).

access_vector(allow,[load_policy_t],[fs_t],[filesystem],[getattr]).

access_vector(allow,[load_policy_t],[sysadm_tmp_t],[file],[getattr,write]).

type_decl(Arg1_login_t,[],[domain,privuser,privrole,privlog,auth,privowner,mlstrustedreader,mlstrustedwriter,mlstrustedobject,privfd],[]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

role_decl(system_r,[Arg1_login_t]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

general_domain_access(Arg1_login_t) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[proc_t],[dir],[r_dir_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[proc_t],[notdevfile_class_set],[r_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

base_file_read_access(Arg1_login_t) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[readable_t],[dir],[r_dir_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[readable_t],[notdevfile_class_set],[r_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[var_t],[dir],[search]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[var_spool_t],[dir],[search]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[etc_t],[dir],[r_dir_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[etc_t],[notdevfile_class_set],[r_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[etc_runtime_t],[file,lnk_file],[r_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

read_locale(Arg1_login_t) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[exec_type],[file,lnk_file],[r_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[device_t],[dir],[r_dir_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[device_t],[lnk_file],[r_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

uses_shlib(Arg1_login_t) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

tmp_domain(Arg1_login,[]) :- 
      login_domain(Arg1),
      compose_id(Arg1,login,Arg1_login).

access_vector(allow,[Arg1_login_t],[self],[capability],[setuid,setgid,chown,fowner,fsetid,net_bind_service,sys_tty_config,dac_override,sys_nice,sys_resource]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

domain_auto_trans(Arg1_login_t,shell_exec_t,user_t) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

can_setexec(Arg1_login_t) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[home_root_t],[dir],[search]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[home_dir_type],[dir],[search]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[var_run_t],[dir],[search]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[initrc_var_run_t],[file],[rw_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[var_log_t],[dir],[search]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[wtmp_t],[file],[rw_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[lastlog_t],[file],[rw_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[faillog_t],[file],[append,read,write]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[mail_spool_t],[dir],[r_dir_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[mail_spool_t],[file],[getattr]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[mail_spool_t],[lnk_file],[read]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

can_getsecurity(Arg1_login_t) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

access_vector(allow,[Arg1_login_t],[default_context_t],[file],[r_file_perms]) :- 
      login_domain(Arg1),
      compose_id(login,t,login_t),
      compose_id(Arg1,login_t,Arg1_login_t).

%login_domain(x).

type_decl(login_exec_t,[],[file_type,sysadmfile,exec_type],[]).

login_domain(local).

domain_trans(local_login_t,shell_exec_t,userdomain).

access_vector(dontaudit,[local_login_t],[fixed_disk_device_t],[blk_file],[getattr,setattr]).

access_vector(dontaudit,[local_login_t],[removable_device_t],[blk_file],[getattr,setattr]).

access_vector(dontaudit,[local_login_t],[device_t],[chr_file,blk_file,lnk_file],[getattr,setattr]).

access_vector(dontaudit,[local_login_t],[misc_device_t],[chr_file,blk_file,lnk_file],[getattr,setattr]).

access_vector(dontaudit,[local_login_t],[framebuf_device_t],[chr_file,blk_file,lnk_file],[getattr,setattr,read]).

access_vector(dontaudit,[local_login_t],[apm_bios_t],[chr_file],[getattr,setattr]).

access_vector(dontaudit,[local_login_t],[v4l_device_t],[chr_file,blk_file,lnk_file],[getattr,setattr,read]).

access_vector(dontaudit,[local_login_t],[v4l_device_t],[dir],[read,search,getattr]).

access_vector(dontaudit,[local_login_t],[file_t],[dir],[r_dir_perms]).

access_vector(allow,[local_login_t],[var_lock_t],[dir],[rw_dir_perms]).

access_vector(allow,[local_login_t],[var_lock_t],[file],[create_file_perms]).

access_vector(allow,[local_login_t],[tty_device_t],[chr_file],[setattr,rw_file_perms]).

access_vector(allow,[local_login_t],[ttyfile],[chr_file],[setattr,rw_file_perms]).

access_vector(allow,[local_login_t],[tty_device_t],[chr_file],[getattr,relabelfrom,relabelto]).

access_vector(allow,[local_login_t],[ttyfile],[chr_file],[getattr,relabelfrom,relabelto]).

access_vector(allow,[local_login_t],[sound_device_t],[chr_file],[getattr,setattr]).

access_vector(allow,[local_login_t],[var_run_t],[dir],[rw_dir_perms]).

access_vector(allow,[local_login_t],[var_run_t],[file],[create_file_perms]).

login_domain(remote).

domain_trans(remote_login_t,shell_exec_t,unpriv_userdomain).

access_vector(allow,[remote_login_t],[devpts_t],[dir],[search]).

access_vector(allow,[remote_login_t],[ptyfile],[chr_file],[getattr,relabelfrom,relabelto]).

type_decl(logrotate_t,[],[domain,privowner,privmail],[]).

role_decl(system_r,[logrotate_t]).

role_decl(sysadm_r,[logrotate_t]).

uses_shlib(logrotate_t).

general_domain_access(logrotate_t).

type_decl(logrotate_exec_t,[],[file_type,sysadmfile,exec_type],[]).

system_crond_entry(logrotate_exec_t,logrotate_t).

domain_auto_trans(sysadm_t,logrotate_exec_t,logrotate_t).

access_vector(allow,[logrotate_t],[self],[unix_stream_socket],[create_socket_perms]).

access_vector(allow,[logrotate_t],[devtty_t],[chr_file],[rw_file_perms]).

access_vector(allow,[logrotate_t],[etc_t],[file],[getattr,read]).

access_vector(allow,[logrotate_t],[etc_t],[lnk_file],[read]).

access_vector(allow,[logrotate_t],[etc_runtime_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[logrotate_t],[sysadm_home_dir_t],[dir],[read,getattr,search]).

rw_dir_create_file(logrotate_t,var_lock_t).

tmp_domain(logrotate,[]).

access_vector(allow,[logrotate_t],[bin_t,sbin_t],[dir],[r_dir_perms]).

access_vector(allow,[logrotate_t],[bin_t,sbin_t],[lnk_file],[read]).

can_exec(logrotate_t,bin_t,sbin_t,shell_exec_t,etc_t,ls_exec_t).

access_vector(allow,[logrotate_t],[pidfile],[file],[r_file_perms]).

access_vector(allow,[logrotate_t],[proc_t],[dir],[r_dir_perms]).

access_vector(allow,[logrotate_t],[proc_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[logrotate_t],[sysctl_t,sysctl_kernel_t],[dir],[search]).

access_vector(allow,[logrotate_t],[sysctl_kernel_t],[file],[getattr,read]).

access_vector(allow,[logrotate_t],[domain],[notdevfile_class_set],[r_file_perms]).

access_vector(allow,[logrotate_t],[domain],[dir],[r_dir_perms]).

access_vector(allow,[logrotate_t],[exec_type],[file],[getattr]).

access_vector(allow,[logrotate_t],[device_t],[dir],[r_dir_perms]).

access_vector(allow,[logrotate_t],[device_t],[lnk_file],[r_file_perms]).

access_vector(allow,[logrotate_t],[domain],[process],[signal]).

access_vector(allow,[logrotate_t],[var_t],[dir],[r_dir_perms]).

access_vector(allow,[logrotate_t],[logfile],[dir],[rw_dir_perms]).

access_vector(allow,[logrotate_t],[logfile],[lnk_file],[read]).

access_vector(allow,[logrotate_t],[logfile],[file],[create_file_perms]).

access_vector(allow,[logrotate_t],[wtmp_t],[file],[create_file_perms]).

can_setfscreate(logrotate_t).

access_vector(allow,[logrotate_t],[self],[capability],[chown,dac_override,kill,fsetid,fowner]).

access_vector(dontaudit,[logrotate_t],[self],[capability],[setuid,setgid]).

access_vector(allow,[logrotate_t],[var_run_t],[dir],[r_dir_perms]).

var_lib_domain(logrotate).

access_vector(allow,[logrotate_t],[var_spool_t],[dir],[search,write,add_name,remove_name]).

access_vector(allow,[logrotate_t],[var_spool_t],[file],[rename,create,setattr,unlink]).

access_vector(allow,[logrotate_t],[admin_tty_type],[chr_file],[rw_file_perms]).

read_locale(logrotate_t).

access_vector(allow,[logrotate_t],[fs_t],[filesystem],[getattr]).

can_exec(logrotate_t,shell_exec_t).

type_decl(modules_dep_t,[],[file_type,sysadmfile],[]).

type_decl(modules_conf_t,[],[file_type,sysadmfile],[]).

type_decl(modules_object_t,[],[file_type,sysadmfile],[]).

type_decl(depmod_t,[],[domain],[]).

role_decl(system_r,[depmod_t]).

role_decl(sysadm_r,[depmod_t]).

uses_shlib(depmod_t).

type_decl(depmod_exec_t,[],[file_type,exec_type,sysadmfile],[]).

domain_auto_trans(initrc_t,depmod_exec_t,depmod_t).

access_vector(allow,[depmod_t],[bin_t,sbin_t],[dir],[search]).

can_exec(depmod_t,depmod_exec_t).

domain_auto_trans(sysadm_t,depmod_exec_t,depmod_t).

access_vector(allow,[depmod_t],[init_t,privfd],[fd],[use]).

access_vector(allow,[depmod_t],[etc_t,etc_runtime_t],[file],[getattr,read]).

access_vector(allow,[depmod_t],[device_t,proc_t],[dir],[search]).

access_vector(allow,[depmod_t],[proc_t],[file],[getattr,read]).

access_vector(allow,[depmod_t],[fs_t],[filesystem],[getattr]).

access_vector(allow,[depmod_t],[boot_t],[dir],[search]).

access_vector(allow,[depmod_t],[system_map_t],[file],[getattr,read]).

access_vector(allow,[depmod_t],[modules_conf_t],[file],[r_file_perms]).

file_type_auto_trans(depmod_t,modules_object_t,modules_dep_t).

access_vector(allow,[depmod_t],[modules_object_t],[dir],[r_dir_perms]).

access_vector(allow,[depmod_t],[modules_object_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[depmod_t],[console_device_t,initrc_devpts_t,admin_tty_type],[chr_file],[rw_file_perms]).

access_vector(allow,[depmod_t],[home_root_t,user_home_dir_type,sysadm_home_dir_t],[dir],[r_dir_perms]).

r_dir_file(depmod_t,user_home_type,sysadm_home_t).

type_decl(insmod_t,[],[domain,privlog],[]).

role_decl(system_r,[insmod_t]).

role_decl(sysadm_r,[insmod_t]).

uses_shlib(insmod_t).

read_locale(insmod_t).

access_vector(allow,[insmod_t],[self],[udp_socket],[create_socket_perms]).

type_decl(insmod_exec_t,[],[file_type,exec_type,sysadmfile],[]).

domain_auto_trans(initrc_t,kernel_t,insmod_exec_t,insmod_t).

access_vector(allow,[initrc_t],[insmod_exec_t],[lnk_file],[read]).

can_exec(insmod_t,insmod_exec_t).

access_vector(allow,[insmod_t],[bin_t,sbin_t],[dir],[search]).

access_vector(allow,[insmod_t],[sbin_t],[lnk_file],[read]).

access_vector(allow,[insmod_t],[init_t],[fd],[use]).

domain_auto_trans(sysadm_t,insmod_exec_t,insmod_t).

access_vector(allow,[insmod_t],[fs_t],[filesystem],[getattr]).

access_vector(allow,[insmod_t],[modules_conf_t,modules_dep_t],[file],[getattr,read]).

access_vector(allow,[insmod_t],[modules_object_t],[dir],[r_dir_perms]).

access_vector(allow,[insmod_t],[modules_object_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[insmod_t],[self],[unix_dgram_socket],[create_socket_perms]).

access_vector(allow,[insmod_t],[self],[capability],[sys_module,kill]).

access_vector(allow,[insmod_t],[self],[capability],[net_raw]).

access_vector(allow,[insmod_t],[privfd],[fd],[use]).

access_vector(allow,[insmod_t],[domain],[process],[signal]).

access_vector(allow,[insmod_t],[proc_t,sysctl_t,sysctl_kernel_t],[dir],[search]).

access_vector(allow,[insmod_t],[sysctl_kernel_t],[file],[setattr,rw_file_perms]).

access_vector(allow,[insmod_t],[sysctl_t],[file],[write]).

access_vector(allow,[insmod_t],[proc_t],[file],[getattr,read]).

access_vector(allow,[insmod_t],[var_t],[dir],[r_dir_perms]).

access_vector(allow,[insmod_t],[var_log_t],[dir],[r_dir_perms]).

access_vector(allow,[insmod_t],[var_log_ksyms_t],[file],[create_file_perms]).

access_vector(allow,[insmod_t],[var_log_ksyms_t],[dir],[create_dir_perms]).

access_vector(allow,[insmod_t],[device_t],[dir],[search]).

access_vector(allow,[insmod_t],[etc_runtime_t],[file],[getattr,read]).

access_vector(allow,[insmod_t],[self],[process],[fork,signal_perms]).

access_vector(allow,[insmod_t],[initrc_devpts_t,admin_tty_type],[chr_file],[rw_file_perms]).

access_vector(dontaudit,[insmod_t],[file_t],[dir],[search]).

type_decl(update_modules_t,[],[domain,privlog],[]).

type_decl(update_modules_exec_t,[],[file_type,exec_type,sysadmfile],[]).

role_decl(system_r,[update_modules_t]).

role_decl(sysadm_r,[update_modules_t]).

domain_auto_trans(initrc_t,sysadm_t,update_modules_exec_t,update_modules_t).

access_vector(allow,[update_modules_t],[privfd],[fd],[use]).

access_vector(allow,[update_modules_t],[init_t],[fd],[use]).

access_vector(allow,[update_modules_t],[device_t],[dir],[getattr,search]).

access_vector(allow,[update_modules_t],[console_device_t,devtty_t],[chr_file],[rw_file_perms]).

access_vector(allow,[update_modules_t],[initrc_devpts_t,admin_tty_type],[chr_file],[rw_file_perms]).

access_vector(dontaudit,[update_modules_t],[sysadm_home_dir_t],[dir],[search]).

uses_shlib(update_modules_t).

access_vector(allow,[update_modules_t],[self],[process],[fork,sigchld]).

access_vector(allow,[update_modules_t],[self],[fifo_file],[rw_file_perms]).

access_vector(allow,[update_modules_t],[modules_dep_t],[file],[rw_file_perms]).

file_type_auto_trans(update_modules_t,modules_object_t,modules_conf_t).

domain_auto_trans(update_modules_t,depmod_exec_t,depmod_t).

can_exec(update_modules_t,shell_exec_t,bin_t,sbin_t,update_modules_exec_t,etc_t).

access_vector(allow,[update_modules_t],[bin_t],[lnk_file],[read]).

access_vector(allow,[update_modules_t],[sbin_t,bin_t],[dir],[search]).

access_vector(allow,[update_modules_t],[etc_t,etc_runtime_t],[file],[r_file_perms]).

access_vector(allow,[update_modules_t],[etc_t],[lnk_file],[read]).

access_vector(allow,[update_modules_t],[fs_t],[filesystem],[getattr]).

access_vector(allow,[update_modules_t],[proc_t],[dir],[search]).

access_vector(allow,[update_modules_t],[proc_t],[file],[r_file_perms]).

access_vector(allow,[update_modules_t],[self,proc_t],[lnk_file],[read]).

access_vector(allow,[update_modules_t],[sysctl_t,sysctl_kernel_t],[dir],[search]).

access_vector(allow,[update_modules_t],[sysctl_kernel_t],[file],[getattr,read]).

access_vector(allow,[update_modules_t],[self],[dir],[search]).

access_vector(allow,[update_modules_t],[self],[unix_stream_socket],[create_socket_perms]).

file_type_auto_trans(update_modules_t,etc_t,modules_conf_t).

access_vector(allow,[update_modules_t],[etc_t],[file],[unlink]).

tmp_domain(update_modules,[]).

type_decl(mount_exec_t,[],[file_type,sysadmfile,exec_type],[]).

mount_domain(sysadm,mount).

role_decl(sysadm_r,[mount_t]).

role_decl(system_r,[mount_t]).

domain_auto_trans(initrc_t,mount_exec_t,mount_t).

access_vector(allow,[mount_t],[init_t],[fd],[use]).

access_vector(allow,[mount_t],[privfd],[fd],[use]).

access_vector(allow,[mount_t],[self],[capability],[ipc_lock,dac_override]).

access_vector(allow,[mount_t],[self],[process],[fork,signal_perms]).

access_vector(allow,[mount_t],[file_type],[dir],[search]).

access_vector(allow,[mount_t],[fixed_disk_device_t],[devfile_class_set],[rw_file_perms]).

access_vector(allow,[mount_t],[removable_device_t],[devfile_class_set],[rw_file_perms]).

access_vector(allow,[mount_t],[fs_type],[filesystem],[mount_fs_perms]).

access_vector(allow,[mount_t],[file_t],[dir],[mounton]).

access_vector(allow,[mount_t],[usr_t],[dir],[mounton]).

access_vector(allow,[mount_t],[proc_t],[dir],[mounton]).

access_vector(allow,[mount_t],[root_t],[dir],[mounton]).

access_vector(allow,[mount_t],[home_root_t],[dir],[mounton]).

access_vector(allow,[mount_t],[boot_t],[dir],[mounton]).

access_vector(allow,[mount_t],[device_t],[dir],[mounton]).

access_vector(allow,[mount_t],[root_t],[filesystem],[unmount]).

type_decl(netutils_t,[],[domain,privlog],[]).

type_decl(netutils_exec_t,[],[file_type,sysadmfile,exec_type],[]).

role_decl(system_r,[netutils_t]).

role_decl(sysadm_r,[netutils_t]).

uses_shlib(netutils_t).

can_network(netutils_t).

domain_auto_trans(initrc_t,netutils_exec_t,netutils_t).

domain_auto_trans(sysadm_t,netutils_exec_t,netutils_t).

access_vector(allow,[netutils_t],[init_t],[fd],[use]).

access_vector(allow,[netutils_t],[self],[process],[fork,signal_perms]).

access_vector(allow,[netutils_t],[self],[capability],[net_admin,net_raw,setuid,setgid]).

access_vector(allow,[netutils_t],[self],[netlink_socket],[create_socket_perms]).

access_vector(allow,[netutils_t],[self],[packet_socket],[create_socket_perms]).

access_vector(allow,[netutils_t],[self],[udp_socket],[create_socket_perms]).

access_vector(allow,[netutils_t],[self],[tcp_socket],[create_socket_perms]).

access_vector(allow,[netutils_t],[self],[unix_stream_socket],[create_socket_perms]).

access_vector(allow,[netutils_t],[etc_t],[file],[r_file_perms]).

access_vector(allow,[netutils_t],[resolv_conf_t],[file],[r_file_perms]).

read_locale(netutils_t).

access_vector(allow,[netutils_t],[fs_t],[filesystem],[getattr]).

access_vector(allow,[netutils_t],[privfd],[fd],[use]).

access_vector(allow,[netutils_t],[admin_tty_type],[chr_file],[rw_file_perms]).

type_decl(newrole_t,[],[domain,privrole,privowner,privlog,auth,privfd],[]).

in_user_role(newrole_t).

role_decl(sysadm_r,[newrole_t]).

general_domain_access(newrole_t).

uses_shlib(newrole_t).

read_locale(newrole_t).

type_decl(newrole_exec_t,[],[file_type,exec_type,sysadmfile],[]).

domain_auto_trans(userdomain,newrole_exec_t,newrole_t).

access_vector(allow,[newrole_t],[shadow_t],[file],[read,getattr]).

access_vector(allow,[newrole_t],[privfd],[fd],[use]).

access_vector(allow,[newrole_t],[sbin_t],[dir],[r_dir_perms]).

can_exec(newrole_t,chkpwd_exec_t).

access_vector(allow,[newrole_t],[bin_t],[dir],[r_dir_perms]).

access_vector(allow,[newrole_t],[bin_t],[lnk_file],[read]).

access_vector(allow,[newrole_t],[shell_exec_t],[file],[r_file_perms]).

domain_trans(newrole_t,shell_exec_t,userdomain).

can_setexec(newrole_t).

access_vector(allow,[newrole_t],[self],[capability],[setuid,setgid,net_bind_service,dac_override]).

access_vector(allow,[newrole_t],[var_run_t],[dir],[r_dir_perms]).

access_vector(allow,[newrole_t],[initrc_var_run_t],[file],[rw_file_perms]).

access_vector(allow,[newrole_t],[devpts_t],[dir],[r_dir_perms]).

access_vector(allow,[newrole_t],[etc_t],[file],[r_file_perms]).

access_vector(allow,[newrole_t],[var_t],[dir],[r_dir_perms]).

access_vector(allow,[newrole_t],[var_t],[notdevfile_class_set],[r_file_perms]).

access_vector(allow,[newrole_t],[device_t],[dir],[r_dir_perms]).

access_vector(allow,[newrole_t],[ttyfile,ptyfile],[chr_file],[relabelfrom,relabelto]).

access_vector(allow,[newrole_t],[ttyfile,ptyfile,devtty_t],[chr_file],[rw_file_perms]).

can_getsecurity(newrole_t).

access_vector(allow,[newrole_t],[fs_t],[filesystem],[getattr]).

access_vector(dontaudit,[newrole_t],[home_root_t,home_type],[dir],[search]).

access_vector(dontaudit,[newrole_t],[proc_t],[dir],[search]).

access_vector(dontaudit,[unpriv_userdomain],[newrole_t],[process],[signal]).

type_decl(Arg1_t,[],[domain,privlog,auth,privowner],[]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

general_domain_access(Arg1_t) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

uses_shlib(Arg1_t) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[privfd],[fd],[use]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

read_locale(Arg1_t) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[fs_t],[filesystem],[getattr]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[shell_exec_t],[file],[execute]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_getsecurity(Arg1_t) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

file_type_auto_trans(Arg1_t,etc_t,shadow_t,file) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_t],[file],[create_file_perms]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_t,shadow_t],[file],[relabelfrom,relabelto]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_setfscreate(Arg1_t) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_t],[lnk_file],[read]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[self],[capability],[chown,dac_override,fsetid,setuid,sys_resource]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[ttyfile,ptyfile],[chr_file],[rw_file_perms]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[devtty_t],[chr_file],[rw_file_perms]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[devpts_t],[dir],[getattr]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[initrc_var_run_t],[file],[read,write]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[user_home_dir_type,user_home_type],[dir],[search]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[proc_t,device_t],[dir],[search,read]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[device_t],[dir],[getattr]) :- 
      passwd_domain(Arg1),
      compose_id(Arg1,t,Arg1_t).

%passwd_domain(x).

passwd_domain(passwd).

passwd_domain(sysadm_passwd).

in_user_role(passwd_t).

role_decl(sysadm_r,[passwd_t]).

role_decl(sysadm_r,[sysadm_passwd_t]).

type_decl(admin_passwd_exec_t,[],[file_type,sysadmfile],[]).

type_decl(passwd_exec_t,[],[file_type,sysadmfile,exec_type],[]).

domain_auto_trans(userdomain,passwd_exec_t,passwd_t).

domain_auto_trans(sysadm_t,admin_passwd_exec_t,sysadm_passwd_t).

access_vector(dontaudit,[passwd_t],[var_t],[dir],[search]).

access_vector(allow,[sysadm_passwd_t],[root_t,usr_t,bin_t],[dir],[search]).

access_vector(allow,[sysadm_passwd_t],[bin_t],[lnk_file],[read]).

can_exec(sysadm_passwd_t,bin_t).

access_vector(allow,[sysadm_passwd_t],[var_t],[dir],[search]).

tmp_domain(sysadm_passwd,[]).

access_vector(dontaudit,[sysadm_passwd_t],[sysadm_home_dir_t],[dir],[getattr,search]).

access_vector(allow,[sysadm_passwd_t],[etc_t],[lnk_file],[read]).

access_vector(dontaudit,[sysadm_passwd_t],[var_run_t],[dir],[search]).

access_vector(allow,[passwd_t],[user_t],[dir],[search]).

access_vector(allow,[passwd_t],[user_t],[file],[read]).

access_vector(allow,[passwd_t],[user_t],[process],[getattr]).

type_decl(setfiles_t,[],[domain,privlog,privowner],[]).

type_decl(setfiles_exec_t,[],[file_type,sysadmfile,exec_type],[]).

role_decl(system_r,[setfiles_t]).

role_decl(sysadm_r,[setfiles_t]).

access_vector(allow,[setfiles_t],[initrc_devpts_t],[chr_file],[read,write,ioctl]).

access_vector(allow,[setfiles_t],[admin_tty_type],[chr_file],[read,write,ioctl]).

domain_auto_trans(initrc_t,sysadm_t,setfiles_exec_t,setfiles_t).

access_vector(allow,[setfiles_t],[init_t],[fd],[use]).

access_vector(allow,[setfiles_t],[privfd],[fd],[use]).

uses_shlib(setfiles_t).

access_vector(allow,[setfiles_t],[self],[capability],[dac_override,dac_read_search]).

access_vector(allow,[setfiles_t],[lib_t],[file],[execute]).

can_getsecurity(setfiles_t).

access_vector(allow,[setfiles_t],[policy_src_t],[file],[r_file_perms]).

access_vector(allow,[setfiles_t],[file_type],[dir],[r_dir_perms]).

access_vector(allow,[setfiles_t],[file_type],[lnk_file],[r_file_perms]).

access_vector(allow,[setfiles_t],[file_type],[dir_file_class_set],[getattr,relabelfrom,relabelto]).

access_vector(allow,[setfiles_t],[file_labels_t],[dir],[rw_dir_perms]).

access_vector(allow,[setfiles_t],[file_labels_t],[file],[create_file_perms]).

access_vector(allow,[setfiles_t],[fs_t],[filesystem],[getattr]).

access_vector(allow,[setfiles_t],[fs_type],[dir],[r_dir_perms]).

access_vector(allow,[setfiles_t],[etc_runtime_t],[file],[read]).

access_vector(allow,[setfiles_t],[etc_t],[file],[read]).

access_vector(allow,[setfiles_t],[proc_t],[file],[getattr,read]).

access_vector(allow,[setfiles_t],[home_type],[file],[r_file_perms]).

type_decl(ssh_port_t,[],[port_type],[]).

type_decl(Arg1,[],[domain,privuser,privrole,privlog,privowner,privfd,auth],[]) :- 
      sshd_program_domain(Arg1).

role_decl(system_r,[Arg1]) :- 
      sshd_program_domain(Arg1).

uses_shlib(Arg1) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[self],[unix_dgram_socket],[create_socket_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[self],[unix_stream_socket],[create_stream_socket_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[self],[fifo_file],[rw_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[self],[process],[fork,sigchld,setsched]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[proc_t],[dir],[r_dir_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[proc_t],[notdevfile_class_set],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[self],[dir],[search]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[self],[lnk_file],[read]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[fs_type],[filesystem],[getattr]) :- 
      sshd_program_domain(Arg1).

base_file_read_access(Arg1) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[var_t],[dir],[search]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[var_log_t],[dir],[search]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[etc_t],[dir],[r_dir_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[etc_t],[notdevfile_class_set],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[etc_runtime_t],[file,lnk_file],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[resolv_conf_t],[file,lnk_file],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[ld_so_t],[file,lnk_file],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[shlib_t],[file,lnk_file],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[exec_type],[file,lnk_file],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[devtty_t],[chr_file],[rw_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[null_device_t,zero_device_t],[chr_file],[rw_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[random_device_t],[chr_file],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

can_network(Arg1) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[self],[capability],[chown,dac_override,fowner,fsetid,setgid,setuid,net_bind_service,sys_tty_config]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[shadow_t],[file],[read,getattr]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[home_root_t,user_home_dir_type,sysadm_home_dir_t],[dir],[search,getattr]) :- 
      sshd_program_domain(Arg1).

domain_auto_trans(Arg1,shell_exec_t,user_t) :- 
      sshd_program_domain(Arg1).

domain_trans(Arg1,shell_exec_t,unpriv_userdomain) :- 
      sshd_program_domain(Arg1).

can_setexec(Arg1) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[initrc_var_run_t],[file],[rw_file_perms]) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[wtmp_t],[file],[rw_file_perms]) :- 
      sshd_program_domain(Arg1).

can_getsecurity(Arg1) :- 
      sshd_program_domain(Arg1).

access_vector(allow,[Arg1],[default_context_t],[file],[r_file_perms]) :- 
      sshd_program_domain(Arg1).

%sshd_program_domain(x).

sshd_program_domain(sshd_t).

type_decl(sshd_exec_t,[],[file_type,exec_type,sysadmfile],[]).

domain_auto_trans(initrc_t,sshd_exec_t,sshd_t).

access_vector(allow,[sshd_t],[initrc_devpts_t],[chr_file],[rw_file_perms]).

access_vector(allow,[sshd_t],[ssh_port_t],[tcp_socket],[name_bind]).

sshd_program_domain(sshd_login_t).

type_decl(sshd_key_t,[],[file_type,sysadmfile],[]).

can_tcp_connect(sshd_t,sshd_t).

type_decl(sshd_tmp_t,[],[file_type,sysadmfile,tmpfile],[]).

file_type_auto_trans(sshd_t,tmp_t,sshd_tmp_t).

access_vector(allow,[sshd_t],[init_t],[fd],[use]).

can_create_pty(sshd,[]).

domain_auto_trans(sshd_t,login_exec_t,sshd_login_t).

access_vector(allow,[sshd_t],[self],[capability],[sys_chroot,sys_resource]).

var_run_domain(sshd).

access_vector(allow,[sshd_t],[sshd_key_t],[file],[getattr,read]).

access_vector(allow,[sshd_t],[lastlog_t],[file],[rw_file_perms]).

access_vector(allow,[sshd_t],[unpriv_userdomain],[process],[signal]).

access_vector(allow,[sshd_t],[sshd_devpts_t],[chr_file],[setattr,getattr,relabelfrom,relabelto]).

access_vector(allow,[sshd_t],[userpty_type],[chr_file],[setattr,relabelto,rw_file_perms]).

access_vector(dontaudit,[sshd_t],[sysadm_devpts_t],[chr_file],[setattr]).

access_vector(allow,[sshd_login_t],[sshd_devpts_t],[chr_file],[setattr,rw_file_perms]).

access_vector(allow,[sshd_login_t],[lastlog_t],[file],[rw_file_perms]).

access_vector(allow,[sshd_login_t],[sshd_devpts_t],[chr_file],[relabelfrom,relabelto]).

access_vector(allow,[sshd_login_t],[userpty_type],[chr_file],[getattr,relabelfrom,relabelto]).

read_locale(sshd_t).

access_vector(allow,[sshd_t],[var_spool_t,mail_spool_t],[dir],[search]).

access_vector(allow,[sshd_t],[mail_spool_t],[lnk_file],[read]).

access_vector(allow,[sshd_t],[mail_spool_t],[file],[getattr]).

type_decl(ssh_exec_t,[],[file_type,exec_type,sysadmfile],[]).

access_vector(allow,[sysadm_ssh_t],[user_home_dir_type],[dir],[search]).

r_dir_file(sysadm_ssh_t,user_home_ssh_t).

type_decl(su_exec_t,[],[file_type,sysadmfile,exec_type],[]).

access_vector(allow,[sysadm_su_t],[user_home_dir_type],[dir],[search]).

daemon_domain(syslogd,[]).

can_network(syslogd_t).

type_decl(devlog_t,[],[file_type,sysadmfile],[]).

access_vector(allow,[privlog],[console_device_t],[chr_file],[ioctl,read,write,getattr]).

tmp_domain(syslogd,[]).

access_vector(allow,[syslogd_t],[etc_t],[file],[r_file_perms]).

access_vector(allow,[syslogd_t],[resolv_conf_t],[file,lnk_file],[r_file_perms]).

access_vector(allow,[syslogd_t],[syslogd_t],[capability],[net_bind_service,dac_override]).

access_vector(allow,[syslogd_t],[init_t],[fd],[use]).

access_vector(allow,[syslogd_t],[initrc_devpts_t,console_device_t],[chr_file],[read,write]).

create_append_log_file(syslogd_t,var_log_t).

file_type_auto_trans(syslogd_t,device_t,var_run_t,devlog_t,sock_file).

access_vector(allow,[syslogd_t],[self],[unix_dgram_socket],[create_socket_perms]).

access_vector(allow,[syslogd_t],[self],[unix_dgram_socket],[sendto]).

access_vector(allow,[syslogd_t],[self],[unix_stream_socket],[create_socket_perms]).

access_vector(allow,[syslogd_t],[self],[unix_stream_socket],[listen,accept]).

access_vector(allow,[syslogd_t],[devlog_t],[unix_stream_socket],[name_bind]).

access_vector(allow,[syslogd_t],[devlog_t],[unix_dgram_socket],[name_bind]).

access_vector(allow,[privlog],[devlog_t],[sock_file],[rw_file_perms]).

can_unix_send(privlog,syslogd_t).

can_unix_connect(privlog,syslogd_t).

access_vector(allow,[privlog],[devlog_t],[lnk_file],[read]).

type_decl(tmpreaper_t,[],[domain,privlog],[]).

type_decl(tmpreaper_exec_t,[],[file_type,sysadmfile,exec_type],[]).

role_decl(system_r,[tmpreaper_t]).

system_crond_entry(tmpreaper_exec_t,tmpreaper_t).

uses_shlib(tmpreaper_t).

access_vector(allow,[tmpreaper_t],[tmpfile],[dir],[rw_dir_perms,rmdir]).

access_vector(allow,[tmpreaper_t],[tmpfile],[notdevfile_class_set],[getattr,unlink]).

access_vector(allow,[tmpreaper_t],[home_type],[notdevfile_class_set],[getattr,unlink]).

access_vector(allow,[tmpreaper_t],[self],[process],[fork,sigchld]).

access_vector(allow,[tmpreaper_t],[self],[capability],[dac_override,dac_read_search,fowner]).

access_vector(allow,[tmpreaper_t],[fs_t],[filesystem],[getattr]).

r_dir_file(tmpreaper_t,etc_t).

access_vector(allow,[tmpreaper_t],[var_t],[dir],[getattr,search]).

r_dir_file(tmpreaper_t,var_lib_t).

access_vector(allow,[tmpreaper_t],[device_t],[dir],[getattr,search]).

access_vector(allow,[tmpreaper_t],[random_device_t],[chr_file],[getattr,read]).

type_decl(Arg1_t,[],[domain,privlog,auth,privowner],[]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

role_decl(sysadm_r,[Arg1_t]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

general_domain_access(Arg1_t) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

uses_shlib(Arg1_t) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

type_decl(Arg1_exec_t,[],[file_type,sysadmfile,exec_type],[]) :- 
      user_group_add_program(Arg1),
      compose_id(exec,t,exec_t),
      compose_id(Arg1,exec_t,Arg1_exec_t).

domain_auto_trans(sysadm_t,Arg1_exec_t,Arg1_t) :- 
      user_group_add_program(Arg1),
      compose_id(exec,t,exec_t),
      compose_id(Arg1,exec_t,Arg1_exec_t),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[self],[capability],[dac_override,chown]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_getsecurity(Arg1_t) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[privfd],[fd],[use]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

file_type_auto_trans(Arg1_t,etc_t,shadow_t,file) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_t],[file],[create_file_perms]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

can_setfscreate(Arg1_t) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[etc_t,shadow_t],[file],[relabelfrom,relabelto]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

read_locale(Arg1_t) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[device_t,var_t,var_log_t],[dir],[search]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[fs_t],[filesystem],[getattr]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[ttyfile],[chr_file],[rw_file_perms]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(allow,[Arg1_t],[ptyfile],[chr_file],[rw_file_perms]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

access_vector(dontaudit,[Arg1_t],[sysadm_home_dir_t],[dir],[search]) :- 
      user_group_add_program(Arg1),
      compose_id(Arg1,t,Arg1_t).

%user_group_add_program(x).

user_group_add_program(useradd).

file_type_auto_trans(useradd_t,home_root_t,user_home_dir_t,dir).

file_type_auto_trans(useradd_t,user_home_dir_t,user_home_t).

access_vector(allow,[useradd_t],[var_spool_t],[dir],[search]).

access_vector(allow,[useradd_t],[mail_spool_t],[dir],[search,write,add_name,remove_name]).

access_vector(allow,[useradd_t],[mail_spool_t],[file],[create,setattr,getattr,unlink]).

access_vector(allow,[useradd_t],[mail_spool_t],[lnk_file],[read]).

access_vector(allow,[useradd_t],[self],[capability],[fowner,fsetid,setuid,sys_resource]).

can_exec(useradd_t,shell_exec_t).

access_vector(allow,[useradd_t],[initrc_var_run_t],[file],[read,write,lock]).

user_group_add_program(groupadd).

access_vector(dontaudit,[groupadd_t],[initrc_var_run_t],[file],[write]).

access_vector(dontaudit,[groupadd_t],[var_run_t],[dir],[search]).

access_vector(dontaudit,[groupadd_t],[self],[capability],[fsetid]).

neverallow([domain],[except([domain])],[process],[transition]).

neverallow([except([insmod_t,ifconfig_t,kernel_t])],[self],[capability],[sys_module]).

neverallow([except([ldconfig_t,admin])],[exec_type,ld_so_t,shlib_t],[file],[write,append,unlink,rename]).

neverallow([except([ldconfig_t,admin])],[lib_t,bin_t,sbin_t],[dir],[add_name,remove_name,rename]).

neverallow([except([admin])],[lib_t,bin_t,sbin_t],[file],[write,append,unlink,rename]).

neverallow([except([fsadm_t,mount_t])],[fixed_disk_device_t],[devfile_class_set],[read,write,append]).

neverallow([except([privmem])],[memory_device_t],[devfile_class_set],[read,write,append]).

neverallow([except([klogd_t])],[proc_kmsg_t],[file],[except([stat_file_perms])]).

neverallow([_],[proc_kcore_t],[file],[except([stat_file_perms])]).

neverallow([except([initrc_t,admin,kernel_t,insmod_t])],[sysctl_t],[file],[write,append]).

neverallow([except([initrc_t,admin])],[sysctl_fs_t],[file],[write,append]).

neverallow([except([init_t,initrc_t,admin,kernel_t,insmod_t])],[sysctl_kernel_t],[file],[write,append]).

neverallow([except([initrc_t,admin])],[sysctl_net_t],[file],[write,append]).

neverallow([except([initrc_t,admin])],[sysctl_net_unix_t],[file],[write,append]).

neverallow([except([initrc_t,admin])],[sysctl_vm_t],[file],[write,append]).

neverallow([except([initrc_t,admin])],[sysctl_dev_t],[file],[write,append]).

neverallow([except([initrc_t,admin])],[sysctl_modprobe_t],[file],[write,append]).

role_allow(system_r,sysadm_r).
role_allow(sysadm_r,system_r).


user(system_u,[s]).
user(user_u,[s]).
user(root,[staff_r,sysadm_r]).
user(jadmin,[staff_r,sysadm_r]).
user(jdoe,[user_r]).


:- import member/2 from basics.

constraint(C,P, T1,R1,U1, T2,R2,U2) :- 
      (macro_member(C, [process]),
       member(P, [transition])
       -> (U1 == U2 ; type_eq(T1,privuser))
        ; true),
      (macro_member(C, [process]),
       member(P, [transition])
       -> (R1 == R2 ; type_eq(T1,privrole))
        ; true),
      (macro_member(C, [dir_file_class_set]),
       member(P, [create,relabelto,relabelfrom])
       -> (U1 == U2 ; type_eq(T1,privowner))
        ; true),
      (macro_member(C, [socket_class_set]),
       member(P, [create,relabelto,relabelfrom])
       -> (U1 == U2 ; type_eq(T1,privowner))
        ; true).


sid_context(kernel,(system_u  ','  system_r  ','  kernel_t)).
sid_context(security,(system_u  ','  object_r  ','  security_t)).
sid_context(unlabeled,(system_u  ','  object_r  ','  unlabeled_t)).
sid_context(fs,(system_u  ','  object_r  ','  fs_t)).
sid_context(file,(system_u  ','  object_r  ','  file_t)).
sid_context(file_labels,(system_u  ','  object_r  ','  file_labels_t)).
sid_context(init,(system_u  ','  system_r  ','  init_t)).
sid_context(any_socket,(system_u  ','  system_r  ','  any_socket_t)).
sid_context(port,(system_u  ','  object_r  ','  port_t)).
sid_context(netif,(system_u  ','  object_r  ','  netif_t)).
sid_context(netmsg,(system_u  ','  object_r  ','  netmsg_t)).
sid_context(node,(system_u  ','  object_r  ','  node_t)).
sid_context(igmp_packet,(system_u  ','  system_r  ','  igmp_packet_t)).
sid_context(icmp_socket,(system_u  ','  system_r  ','  icmp_socket_t)).
sid_context(tcp_socket,(system_u  ','  system_r  ','  tcp_socket_t)).
sid_context(sysctl_modprobe,(system_u  ','  object_r  ','  sysctl_modprobe_t)).
sid_context(sysctl,(system_u  ','  object_r  ','  sysctl_t)).
sid_context(sysctl_fs,(system_u  ','  object_r  ','  sysctl_fs_t)).
sid_context(sysctl_kernel,(system_u  ','  object_r  ','  sysctl_kernel_t)).
sid_context(sysctl_net,(system_u  ','  object_r  ','  sysctl_net_t)).
sid_context(sysctl_net_unix,(system_u  ','  object_r  ','  sysctl_net_unix_t)).
sid_context(sysctl_vm,(system_u  ','  object_r  ','  sysctl_vm_t)).
sid_context(sysctl_dev,(system_u  ','  object_r  ','  sysctl_dev_t)).
sid_context(kmod,(system_u  ','  system_r  ','  kernel_t)).
sid_context(policy,(system_u  ','  object_r  ','  policy_config_t)).
sid_context(scmp_packet,(system_u  ','  system_r  ','  scmp_packet_t)).


fs_use(xattr,ext,(system_u  ','  object_r  ','  fs_t)).
fs_use(xattr,ext,(system_u  ','  object_r  ','  fs_t)).
fs_use(task,pipefs,(system_u  ','  object_r  ','  fs_t)).
fs_use(task,sockfs,(system_u  ','  object_r  ','  fs_t)).
fs_use(trans,devpts,(system_u  ','  object_r  ','  devpts_t)).
fs_use(trans,tmpfs,(system_u  ','  object_r  ','  tmpfs_t)).
fs_use(trans,shm,(system_u  ','  object_r  ','  tmpfs_t)).


genfscon(proc,'/',(system_u,object_r,proc_t)).

genfscon(proc,'/kmsg',(system_u,object_r,proc_kmsg_t)).

genfscon(proc,'/kcore',(system_u,object_r,proc_kcore_t)).

genfscon(proc,'/sysvipc',(system_u,object_r,proc_t)).

genfscon(proc,'/sys',(system_u,object_r,sysctl_t)).

genfscon(proc,'/sys/kernel',(system_u,object_r,sysctl_kernel_t)).

genfscon(proc,'/sys/kernel/modprobe',(system_u,object_r,sysctl_modprobe_t)).

genfscon(proc,'/sys/net',(system_u,object_r,sysctl_net_t)).

genfscon(proc,'/sys/net/unix',(system_u,object_r,sysctl_net_unix_t)).

genfscon(proc,'/sys/vm',(system_u,object_r,sysctl_vm_t)).

genfscon(proc,'/sys/dev',(system_u,object_r,sysctl_dev_t)).

genfscon(rootfs,'/',(system_u,object_r,root_t)).

genfscon(sysfs,'/',(system_u,object_r,sysfs_t)).

genfscon(selinuxfs,'/',(system_u,object_r,security_t)).

genfscon(iso,'/',(system_u,object_r,iso)).

genfscon(vfat,'/',(system_u,object_r,dosfs_t)).

genfscon(msdos,'/',(system_u,object_r,dosfs_t)).

genfscon(nfs,'/',(system_u,object_r,nfs_t)).




netifcon(lo,(system_u  ','  object_r  ','  netif_lo_t),(system_u  ','  object_r  ','  netmsg_lo_t)).
netifcon(eth,(system_u  ','  object_r  ','  netif_eth),(system_u  ','  object_r  ','  netmsg_eth)).
netifcon(eth,(system_u  ','  object_r  ','  netif_eth),(system_u  ','  object_r  ','  netmsg_eth)).
netifcon(eth,(system_u  ','  object_r  ','  netif_eth),(system_u  ','  object_r  ','  netmsg_eth)).
netifcon(ippp,(system_u  ','  object_r  ','  netif_ippp),(system_u  ','  object_r  ','  netmsg_ippp)).
netifcon(ipsec,(system_u  ','  object_r  ','  netif_ipsec),(system_u  ','  object_r  ','  netmsg_ipsec)).
netifcon(ipsec,(system_u  ','  object_r  ','  netif_ipsec),(system_u  ','  object_r  ','  netmsg_ipsec)).
netifcon(ipsec,(system_u  ','  object_r  ','  netif_ipsec),(system_u  ','  object_r  ','  netmsg_ipsec)).
nodecon([127,0,0,1],[255,255,255,255],(system_u  ','  object_r  ','  node_lo_t)).

